/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

#include "pal.h"

namespace GpuUtil
{
namespace MsaaImageCopy
{

struct PipelineBinary
{
    const void* pBuffer;
    size_t size;
};

// Msaa DS Copy compute shader binary
inline constexpr Util::uint8 MsaaDSCopy_Cs_0DCD1401[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x60, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x86, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x07, 0x03, 0x81, 0xbe, 0x01, 0x00, 0x46, 0xd7, 0x04, 0x06, 0x05, 0x04, 0x00, 0x01, 0x08, 0xf4, 0x40, 0x00,
    0x00, 0xfa, 0x00, 0x00, 0x46, 0xd7, 0x03, 0x06, 0x01, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0xf9, 0x00, 0x88, 0x7d, 0x06,
    0x82, 0x86, 0x06, 0x07, 0x02, 0x88, 0x7d, 0x02, 0x6a, 0x6a, 0x87, 0x6a, 0x3c, 0x82, 0xbe, 0xaa, 0x01, 0x88, 0xbf,
    0x00, 0x02, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xfa, 0x04, 0x00, 0x38, 0x4a, 0x05, 0x02, 0x3a, 0x4a, 0x7f, 0xc0, 0x8c,
    0xbf, 0x08, 0x00, 0x40, 0x4a, 0x09, 0x02, 0x42, 0x4a, 0x0a, 0x81, 0x00, 0xbf, 0x58, 0x00, 0x84, 0xbf, 0x00, 0x03,
    0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x0c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c,
    0x00, 0x03, 0x00, 0x1d, 0x06, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x82, 0x00, 0xbf,
    0x0d, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x70, 0x00, 0x8c,
    0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x89, 0x01, 0x82, 0xbf, 0x0b,
    0x84, 0x00, 0xbf, 0x16, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e,
    0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x71, 0x01, 0x82, 0xbf,
    0x0b, 0x88, 0x00, 0xbf, 0x6f, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e,
    0x7e, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c, 0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02,
    0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf,
    0x80, 0x00, 0x00, 0x7e, 0x49, 0x01, 0x82, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x5b, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x14, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f,
    0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x0a, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b,
    0x81, 0x00, 0xbf, 0x09, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00,
    0x7e, 0x32, 0x01, 0x82, 0xbf, 0x81, 0x02, 0x16, 0x7e, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04,
    0x03, 0x00, 0x1d, 0x0b, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x84, 0x00, 0xbf, 0x15,
    0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e, 0x83, 0x02, 0x1e, 0x7e,
    0x71, 0x00, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x70, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x1f,
    0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x14, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x12, 0x01, 0x84, 0xbf,
    0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e, 0x83, 0x02, 0x1e, 0x7e, 0x84, 0x02, 0x24,
    0x7e, 0x85, 0x02, 0x26, 0x7e, 0x86, 0x02, 0x2c, 0x7e, 0x87, 0x02, 0x2e, 0x7e, 0x71, 0x00, 0x8c, 0xbf, 0xe3, 0xff,
    0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x70, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xec, 0x00, 0x82, 0xbf,
    0x0a, 0x84, 0x00, 0xbf, 0x67, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x24,
    0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x12,
    0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x81, 0x00, 0xbf, 0x09, 0x00, 0x84, 0xbf, 0x00,
    0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x21, 0x12, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xd5, 0x00, 0x82, 0xbf, 0x81, 0x02, 0x26,
    0x7e, 0x82, 0x02, 0x2c, 0x7e, 0x83, 0x02, 0x2e, 0x7e, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04,
    0x03, 0x00, 0x1d, 0x13, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d, 0x16, 0x00, 0x00, 0x32,
    0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x17, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e,
    0x0b, 0x82, 0x00, 0xbf, 0x19, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x3f, 0x8c,
    0xbf, 0x08, 0x19, 0x22, 0x1e, 0x09, 0x1b, 0x10, 0x1e, 0x0a, 0x1d, 0x12, 0x1e, 0x0b, 0x1f, 0x14, 0x1e, 0x04, 0x00,
    0x51, 0xd5, 0x00, 0x09, 0x46, 0x04, 0x05, 0x00, 0x51, 0xd5, 0x01, 0x0b, 0x22, 0x04, 0x06, 0x00, 0x51, 0xd5, 0x02,
    0x0d, 0x26, 0x04, 0x07, 0x00, 0x51, 0xd5, 0x03, 0x0f, 0x2a, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13, 0x00,
    0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xab, 0x00, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0xa9, 0x00,
    0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x84, 0x02, 0x34, 0x7e, 0x85, 0x02, 0x36, 0x7e, 0x86,
    0x02, 0x3c, 0x7e, 0x87, 0x02, 0x3e, 0x7e, 0x73, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00,
    0x00, 0x72, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x71, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x08, 0x01, 0x00, 0x21, 0x1a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1b, 0x00, 0x00,
    0x70, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x1e, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x1f, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x83, 0x00,
    0x82, 0xbf, 0x0a, 0x88, 0x00, 0xbf, 0x81, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80,
    0x02, 0x44, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00,
    0x1d, 0x22, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x81, 0x00, 0xbf, 0x08, 0x00, 0x84,
    0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x6d, 0x00, 0x82, 0xbf, 0x81, 0x02, 0x46, 0x7e, 0x82,
    0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x2c, 0x7e, 0x86, 0x02, 0x34, 0x7e,
    0x87, 0x02, 0x3c, 0x7e, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x23, 0x00,
    0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d, 0x24, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c,
    0x03, 0x00, 0x1d, 0x25, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x32,
    0x0f, 0x00, 0xf0, 0x1c, 0x14, 0x03, 0x00, 0x1d, 0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x03, 0x00,
    0x1d, 0x1a, 0x00, 0x00, 0x30, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x03, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00,
    0x7e, 0x0b, 0x82, 0x00, 0xbf, 0x29, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x74, 0x3f,
    0x8c, 0xbf, 0x08, 0x19, 0x4a, 0x1e, 0x09, 0x1b, 0x10, 0x1e, 0x0a, 0x1d, 0x12, 0x1e, 0x0b, 0x1f, 0x14, 0x1e, 0x70,
    0x3f, 0x8c, 0xbf, 0x18, 0x39, 0x16, 0x1e, 0x04, 0x00, 0x51, 0xd5, 0x00, 0x09, 0x96, 0x04, 0x05, 0x00, 0x51, 0xd5,
    0x01, 0x0b, 0x22, 0x04, 0x06, 0x00, 0x51, 0xd5, 0x02, 0x0d, 0x26, 0x04, 0x07, 0x00, 0x51, 0xd5, 0x03, 0x0f, 0x2a,
    0x04, 0x09, 0x00, 0x51, 0xd5, 0x10, 0x29, 0x2e, 0x04, 0x1b, 0x3f, 0x10, 0x1e, 0x1a, 0x3d, 0x16, 0x1e, 0x19, 0x3b,
    0x14, 0x1e, 0x08, 0x00, 0x51, 0xd5, 0x13, 0x2f, 0x22, 0x04, 0x0b, 0x00, 0x51, 0xd5, 0x12, 0x2d, 0x2e, 0x04, 0x0a,
    0x00, 0x51, 0xd5, 0x11, 0x2b, 0x2a, 0x04, 0x04, 0x13, 0x08, 0x1e, 0x05, 0x15, 0x0a, 0x1e, 0x06, 0x17, 0x0c, 0x1e,
    0x07, 0x11, 0x0e, 0x1e, 0x7f, 0xc0, 0x8c, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x24, 0x00,
    0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x22, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x75,
    0x3f, 0x8c, 0xbf, 0x04, 0x11, 0x08, 0x1e, 0x05, 0x13, 0x0a, 0x1e, 0x06, 0x15, 0x0c, 0x1e, 0x07, 0x17, 0x0e, 0x1e,
    0x73, 0x3f, 0x8c, 0xbf, 0x0c, 0x21, 0x10, 0x1e, 0x0d, 0x23, 0x12, 0x1e, 0x0e, 0x25, 0x14, 0x1e, 0x0f, 0x27, 0x16,
    0x1e, 0x70, 0x3f, 0x8c, 0xbf, 0x0c, 0x00, 0x51, 0xd5, 0x14, 0x31, 0x72, 0x04, 0x0d, 0x00, 0x51, 0xd5, 0x15, 0x33,
    0x76, 0x04, 0x0e, 0x00, 0x51, 0xd5, 0x16, 0x35, 0x7a, 0x04, 0x0f, 0x00, 0x51, 0xd5, 0x17, 0x37, 0x7e, 0x04, 0x7f,
    0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x04, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x24, 0x00,
    0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x25, 0x00, 0x00, 0x00, 0x00, 0x81, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68,
    0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65,
    0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69,
    0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f,
    0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73,
    0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68,
    0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
    0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf4, 0x07, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00, 0x20, 0x00,
    0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e,
    0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73,
    0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc,
    0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68,
    0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c,
    0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f,
    0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f,
    0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xce, 0x5d, 0x09, 0x22, 0x94, 0x5b, 0x01, 0xec, 0xcf, 0xc9, 0x97, 0x6a, 0xb1,
    0x04, 0x86, 0xee, 0xd5, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70,
    0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75,
    0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64,
    0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b,
    0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f,
    0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e,
    0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63,
    0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73,
    0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00,
    0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69,
    0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75,
    0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61,
    0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e,
    0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65,
    0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x20, 0xb2,
    0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc,
    0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70,
    0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c,
    0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76,
    0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2,
    0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72,
    0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f,
    0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03,
    0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68,
    0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2,
    0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad,
    0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65,
    0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x97, 0x17, 0x8c, 0xaa, 0xaa, 0x2e, 0x72,
    0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65,
    0xaa, 0x4d, 0x73, 0x61, 0x61, 0x44, 0x53, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e,
    0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x66,
    0xa4, 0x89, 0x32, 0x30, 0x66, 0x15, 0x01, 0xcf, 0xd0, 0xa9, 0x3c, 0xcd, 0x1f, 0x6f, 0xef, 0x44, 0xb2, 0x2e, 0x63,
    0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e,
    0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67,
    0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e,
    0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73,
    0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c,
    0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf4, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7a,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xca, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf5, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x3d, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00,
};

// Msaa RT Copy compute shader binary
inline constexpr Util::uint8 MsaaRTCopy_Cs_0DCD1401[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x86, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x07, 0x03, 0x81, 0xbe, 0x01, 0x00, 0x46, 0xd7, 0x04, 0x06, 0x05, 0x04, 0x00, 0x01, 0x08, 0xf4, 0x40, 0x00,
    0x00, 0xfa, 0x00, 0x00, 0x46, 0xd7, 0x03, 0x06, 0x01, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0xf9, 0x00, 0x88, 0x7d, 0x06,
    0x82, 0x86, 0x06, 0x07, 0x02, 0x88, 0x7d, 0x02, 0x6a, 0x6a, 0x87, 0x6a, 0x3c, 0x82, 0xbe, 0x2e, 0x02, 0x88, 0xbf,
    0x00, 0x02, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xfa, 0x04, 0x00, 0x38, 0x4a, 0x05, 0x02, 0x3a, 0x4a, 0x7f, 0xc0, 0x8c,
    0xbf, 0x08, 0x00, 0x40, 0x4a, 0x09, 0x02, 0x42, 0x4a, 0x0a, 0x81, 0x00, 0xbf, 0x58, 0x00, 0x84, 0xbf, 0x00, 0x03,
    0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x0c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c,
    0x00, 0x03, 0x00, 0x1d, 0x06, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x82, 0x00, 0xbf,
    0x0d, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x70, 0x00, 0x8c,
    0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0d, 0x02, 0x82, 0xbf, 0x0b,
    0x84, 0x00, 0xbf, 0x16, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e,
    0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xf5, 0x01, 0x82, 0xbf,
    0x0b, 0x88, 0x00, 0xbf, 0xf3, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e,
    0x7e, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c, 0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02,
    0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf,
    0x80, 0x00, 0x00, 0x7e, 0xcd, 0x01, 0x82, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x62, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x14, 0x7e, 0x81, 0x02, 0x16, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff,
    0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x0a, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c,
    0x04, 0x03, 0x00, 0x1d, 0x0b, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x81, 0x00, 0xbf,
    0x12, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03,
    0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d,
    0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xa9, 0x01, 0x82, 0xbf,
    0x0b, 0x84, 0x00, 0xbf, 0x16, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c,
    0x7e, 0x83, 0x02, 0x1e, 0x7e, 0x71, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x70,
    0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x04, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x91, 0x01, 0x82,
    0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x8f, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02,
    0x1c, 0x7e, 0x83, 0x02, 0x1e, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x26, 0x7e, 0x86, 0x02, 0x2c, 0x7e, 0x87,
    0x02, 0x2e, 0x7e, 0x71, 0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f,
    0x00, 0x00, 0x70, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32,
    0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00,
    0x21, 0x16, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x1f, 0x0f, 0xa3,
    0xbf, 0x80, 0x00, 0x00, 0x7e, 0x69, 0x01, 0x82, 0xbf, 0x0a, 0x84, 0x00, 0xbf, 0x84, 0x00, 0x84, 0xbf, 0x00, 0x03,
    0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x24, 0x7e, 0x81, 0x02, 0x26, 0x7e, 0x82, 0x02, 0x2c, 0x7e, 0x83,
    0x02, 0x2e, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00,
    0x1d, 0x12, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x13, 0x00, 0x00, 0x32, 0x0f, 0x00,
    0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d, 0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x17,
    0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x81, 0x00, 0xbf, 0x23, 0x00, 0x84, 0xbf, 0x00,
    0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x72, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18,
    0x70, 0x3f, 0x8c, 0xbf, 0x11, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02,
    0x18, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x05, 0x00,
    0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x23, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03,
    0x0f, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18,
    0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x09, 0x02, 0x18, 0x7f, 0xc0, 0x8c,
    0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00,
    0x00, 0x7e, 0x2c, 0x01, 0x82, 0xbf, 0x0b, 0x82, 0x00, 0xbf, 0x1f, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xfa, 0x72, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b,
    0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x7f,
    0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00,
    0x7e, 0x0b, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x09, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00,
    0x00, 0xfa, 0x84, 0x02, 0x34, 0x7e, 0x85, 0x02, 0x36, 0x7e, 0x86, 0x02, 0x3c, 0x7e, 0x87, 0x02, 0x3e, 0x7e, 0x73,
    0x00, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x72, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x17,
    0x00, 0x00, 0x71, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1a, 0x00, 0x00, 0x32,
    0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1b, 0x00, 0x00, 0x70, 0x3f, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x0c, 0x01, 0x00, 0x21, 0x1e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x1f, 0x00,
    0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0xe3, 0x00, 0x82, 0xbf, 0x0a, 0x88, 0x00, 0xbf, 0xe1, 0x00,
    0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x44, 0x7e, 0x81, 0x02, 0x46, 0x7e, 0x82,
    0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x2c, 0x7e, 0x86, 0x02, 0x34, 0x7e,
    0x87, 0x02, 0x3c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03,
    0x00, 0x1d, 0x22, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x23, 0x00, 0x00, 0x32, 0x0f,
    0x00, 0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d, 0x24, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d,
    0x25, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0,
    0x1c, 0x14, 0x03, 0x00, 0x1d, 0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x03, 0x00, 0x1d, 0x1a, 0x00,
    0x00, 0x30, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x03, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x81,
    0x00, 0xbf, 0x43, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00,
    0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x74, 0x3f, 0x8c, 0xbf,
    0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x09, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02,
    0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x23, 0x00,
    0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x11,
    0x2b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18,
    0x05, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x04, 0x00, 0x03,
    0xd5, 0x04, 0x13, 0x02, 0x18, 0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f,
    0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x01,
    0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5,
    0x00, 0x47, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x05, 0x11, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x06, 0x19, 0x02,
    0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x15, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x07, 0x09, 0x02, 0x18, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03,
    0x09, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x1f, 0x0f, 0xa3, 0xbf,
    0x80, 0x00, 0x00, 0x7e, 0x77, 0x00, 0x82, 0xbf, 0x0b, 0x82, 0x00, 0xbf, 0x40, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00,
    0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x74, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5,
    0x03, 0x0f, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x01, 0x00, 0x03,
    0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b,
    0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x25,
    0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5,
    0x19, 0x3b, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x05, 0x0d, 0x02,
    0x18, 0x06, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x0b, 0x00,
    0x03, 0xd5, 0x07, 0x09, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00,
    0x4b, 0x02, 0x18, 0x0c, 0x00, 0x03, 0xd5, 0x08, 0x0d, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5, 0x09, 0x0f, 0x02, 0x18,
    0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x0a, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x00, 0x00,
    0x80, 0xbf, 0x35, 0x00, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x33, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x74, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b,
    0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x72,
    0x3f, 0x8c, 0xbf, 0x08, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18,
    0x0a, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x0b, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x70, 0x3f, 0x8c,
    0xbf, 0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x0e, 0x00,
    0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x0f, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3,
    0xff, 0xa3, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00,
    0x21, 0x23, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x24, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x25, 0x00, 0x00, 0x00, 0x00, 0x81, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xbf, 0x04, 0x11,
    0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64,
    0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65,
    0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72,
    0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c,
    0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69,
    0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69,
    0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12,
    0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d,
    0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73,
    0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c,
    0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65,
    0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb,
    0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd,
    0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74,
    0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
    0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68,
    0x92, 0xcf, 0x1b, 0x55, 0x2d, 0x65, 0xcc, 0x7d, 0x3c, 0x07, 0xcf, 0xce, 0x39, 0xf0, 0x44, 0xc6, 0x87, 0xbb, 0x36,
    0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91,
    0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70,
    0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65,
    0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e,
    0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72,
    0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74,
    0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74,
    0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72,
    0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3,
    0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac,
    0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73,
    0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77,
    0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x20, 0xb2, 0x2e, 0x75, 0x73, 0x65,
    0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d,
    0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f,
    0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c,
    0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67,
    0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65,
    0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73,
    0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78,
    0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2,
    0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68,
    0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76,
    0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75,
    0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0xdf, 0x96, 0x5a, 0x10, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73,
    0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61,
    0x61, 0x52, 0x54, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa7, 0xc3, 0x18, 0x28, 0xcb,
    0xff, 0x9e, 0x1d, 0xcf, 0x4e, 0x52, 0x14, 0xb1, 0x04, 0xe5, 0xcf, 0xfd, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75,
    0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69,
    0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78,
    0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74,
    0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f,
    0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01,
    0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7a, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8a, 0x0a, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xda, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4d, 0x0b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa DS Copy compute shader binary
inline constexpr Util::uint8 MsaaDSCopy_Cs_857A9C8A[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xdc, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x86, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x07, 0x03, 0x81, 0xbe, 0x01, 0x00, 0x46, 0xd7, 0x04, 0x06, 0x05, 0x04, 0x00, 0x01, 0x08, 0xf4, 0x40, 0x00,
    0x00, 0xfa, 0x00, 0x00, 0x46, 0xd7, 0x03, 0x06, 0x01, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0xf9, 0x00, 0x88, 0x7d, 0x06,
    0x82, 0x86, 0x06, 0x07, 0x02, 0x88, 0x7d, 0x02, 0x6a, 0x6a, 0x87, 0x6a, 0x3c, 0x82, 0xbe, 0x89, 0x01, 0x88, 0xbf,
    0x00, 0x02, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xfa, 0x04, 0x00, 0x38, 0x4a, 0x05, 0x02, 0x3a, 0x4a, 0x7f, 0xc0, 0x8c,
    0xbf, 0x08, 0x00, 0x40, 0x4a, 0x09, 0x02, 0x42, 0x4a, 0x0a, 0x81, 0x00, 0xbf, 0x53, 0x00, 0x84, 0xbf, 0x00, 0x03,
    0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x0c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a, 0x00,
    0x00, 0x10, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x06, 0x00, 0x00, 0x0b, 0x82, 0x00, 0xbf,
    0x0c, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x70, 0x00, 0x8c,
    0xbf, 0x01, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x69, 0x01, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x14,
    0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x82, 0x02, 0x14, 0x7e,
    0x83, 0x02, 0x16, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x03, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x0b, 0x00, 0x00, 0x53, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x51, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4,
    0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c,
    0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02, 0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x07, 0x00,
    0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x13, 0x00, 0x00, 0x2d, 0x01, 0x82, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x50, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4,
    0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x14, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a, 0x00, 0x00, 0x10,
    0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x0a, 0x00, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x07, 0x00,
    0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x19, 0x01, 0x82, 0xbf, 0x81, 0x02, 0x16, 0x7e, 0x32, 0x0f, 0x00, 0xf0,
    0x1c, 0x04, 0x03, 0x00, 0x1d, 0x0b, 0x00, 0x00, 0x0b, 0x84, 0x00, 0xbf, 0x13, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e, 0x83, 0x02, 0x1e, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x03, 0x00,
    0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00,
    0xbf, 0xfe, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e, 0x83, 0x02,
    0x1e, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x26, 0x7e, 0x86, 0x02, 0x2c, 0x7e, 0x87, 0x02, 0x2e, 0x7e, 0x70,
    0x00, 0x8c, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21,
    0x13, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0xdb, 0x00, 0x82, 0xbf, 0x0a, 0x84, 0x00, 0xbf, 0x5c, 0x00, 0x84,
    0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x24, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff,
    0x12, 0x8a, 0x00, 0x00, 0x10, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x0b,
    0x81, 0x00, 0xbf, 0x07, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0xc7, 0x00, 0x82, 0xbf, 0x81, 0x02, 0x26,
    0x7e, 0x82, 0x02, 0x2c, 0x7e, 0x83, 0x02, 0x2e, 0x7e, 0x02, 0x00, 0xa1, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04,
    0x03, 0x00, 0x1d, 0x13, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d, 0x16, 0x00, 0x00, 0x32,
    0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x17, 0x00, 0x00, 0x0b, 0x82, 0x00, 0xbf, 0x18, 0x00, 0x84, 0xbf,
    0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x3f, 0x8c, 0xbf, 0x08, 0x19, 0x22, 0x1e, 0x09, 0x1b, 0x10,
    0x1e, 0x0a, 0x1d, 0x12, 0x1e, 0x0b, 0x1f, 0x14, 0x1e, 0x04, 0x00, 0x51, 0xd5, 0x00, 0x09, 0x46, 0x04, 0x05, 0x00,
    0x51, 0xd5, 0x01, 0x0b, 0x22, 0x04, 0x06, 0x00, 0x51, 0xd5, 0x02, 0x0d, 0x26, 0x04, 0x07, 0x00, 0x51, 0xd5, 0x03,
    0x0f, 0x2a, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0x01, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0xa0, 0x00, 0x82,
    0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x9e, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x84, 0x02,
    0x34, 0x7e, 0x85, 0x02, 0x36, 0x7e, 0x86, 0x02, 0x3c, 0x7e, 0x87, 0x02, 0x3e, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x07,
    0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00,
    0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08,
    0x01, 0x00, 0x21, 0x1a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1b, 0x00, 0x00, 0x32,
    0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x1e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00,
    0x21, 0x1f, 0x00, 0x00, 0x7d, 0x00, 0x82, 0xbf, 0x0a, 0x88, 0x00, 0xbf, 0x7b, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x44, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a, 0x00, 0x00,
    0x10, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x22, 0x00, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x06,
    0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x00, 0x8c, 0xbf, 0x30, 0x3f, 0x20, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x6a, 0x00, 0x82, 0xbf, 0x81, 0x02, 0x46, 0x7e, 0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a,
    0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x2c, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02, 0x3c, 0x7e, 0x06, 0x00,
    0xa1, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x23, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c,
    0x08, 0x03, 0x00, 0x1d, 0x24, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x25, 0x00, 0x00,
    0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x14, 0x03,
    0x00, 0x1d, 0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x03, 0x00, 0x1d, 0x1a, 0x00, 0x00, 0x30, 0x0f,
    0x00, 0xf0, 0x1c, 0x1c, 0x03, 0x00, 0x0b, 0x82, 0x00, 0xbf, 0x28, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xfa, 0x74, 0x3f, 0x8c, 0xbf, 0x08, 0x19, 0x4a, 0x1e, 0x09, 0x1b, 0x10, 0x1e, 0x0a, 0x1d, 0x12, 0x1e,
    0x0b, 0x1f, 0x14, 0x1e, 0x70, 0x3f, 0x8c, 0xbf, 0x18, 0x39, 0x16, 0x1e, 0x04, 0x00, 0x51, 0xd5, 0x00, 0x09, 0x96,
    0x04, 0x05, 0x00, 0x51, 0xd5, 0x01, 0x0b, 0x22, 0x04, 0x06, 0x00, 0x51, 0xd5, 0x02, 0x0d, 0x26, 0x04, 0x07, 0x00,
    0x51, 0xd5, 0x03, 0x0f, 0x2a, 0x04, 0x09, 0x00, 0x51, 0xd5, 0x10, 0x29, 0x2e, 0x04, 0x1b, 0x3f, 0x10, 0x1e, 0x1a,
    0x3d, 0x16, 0x1e, 0x19, 0x3b, 0x14, 0x1e, 0x04, 0x13, 0x08, 0x1e, 0x08, 0x00, 0x51, 0xd5, 0x13, 0x2f, 0x22, 0x04,
    0x0b, 0x00, 0x51, 0xd5, 0x12, 0x2d, 0x2e, 0x04, 0x0a, 0x00, 0x51, 0xd5, 0x11, 0x2b, 0x2a, 0x04, 0x07, 0x11, 0x0e,
    0x1e, 0x06, 0x17, 0x0c, 0x1e, 0x05, 0x15, 0x0a, 0x1e, 0x7f, 0xc0, 0x8c, 0xbf, 0x01, 0x00, 0xa1, 0xbf, 0x30, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x24,
    0x00, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x22, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa,
    0x75, 0x3f, 0x8c, 0xbf, 0x04, 0x11, 0x08, 0x1e, 0x05, 0x13, 0x0a, 0x1e, 0x06, 0x15, 0x0c, 0x1e, 0x07, 0x17, 0x0e,
    0x1e, 0x73, 0x3f, 0x8c, 0xbf, 0x0c, 0x21, 0x10, 0x1e, 0x0d, 0x23, 0x12, 0x1e, 0x0e, 0x25, 0x14, 0x1e, 0x0f, 0x27,
    0x16, 0x1e, 0x70, 0x3f, 0x8c, 0xbf, 0x0c, 0x00, 0x51, 0xd5, 0x14, 0x31, 0x72, 0x04, 0x0d, 0x00, 0x51, 0xd5, 0x15,
    0x33, 0x76, 0x04, 0x0e, 0x00, 0x51, 0xd5, 0x16, 0x35, 0x7a, 0x04, 0x0f, 0x00, 0x51, 0xd5, 0x17, 0x37, 0x7e, 0x04,
    0x7f, 0xc0, 0x8c, 0xbf, 0x03, 0x00, 0xa1, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x24,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x25, 0x00, 0x00, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74,
    0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44,
    0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72,
    0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43,
    0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63,
    0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73,
    0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00, 0x20,
    0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c,
    0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e,
    0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43,
    0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff,
    0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73,
    0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f,
    0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63,
    0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xce, 0x5d, 0x09, 0x22, 0x94, 0x5b, 0x01, 0xec, 0xcf, 0xc9, 0x97, 0x6a,
    0xb1, 0x04, 0x86, 0xee, 0xd5, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70,
    0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73,
    0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00,
    0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62,
    0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab,
    0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e,
    0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73,
    0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62,
    0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4,
    0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d,
    0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x20,
    0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70,
    0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75,
    0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e, 0x66,
    0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f,
    0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65,
    0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f,
    0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72,
    0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73,
    0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63,
    0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74,
    0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00,
    0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68,
    0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x97, 0x17, 0x8c, 0xaa, 0xaa, 0x2e,
    0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d,
    0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x44, 0x53, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72,
    0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf,
    0x66, 0xa4, 0x89, 0x32, 0x30, 0x66, 0x15, 0x01, 0xcf, 0x55, 0xee, 0x01, 0xec, 0xe2, 0x74, 0x9f, 0x9c, 0xb2, 0x2e,
    0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf,
    0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74,
    0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65,
    0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42,
    0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf6, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x71, 0x08, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb9, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
};

// Msaa RT Copy compute shader binary
inline constexpr Util::uint8 MsaaRTCopy_Cs_857A9C8A[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x04, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x86, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x07, 0x03, 0x81, 0xbe, 0x01, 0x00, 0x46, 0xd7, 0x04, 0x06, 0x05, 0x04, 0x00, 0x01, 0x08, 0xf4, 0x40, 0x00,
    0x00, 0xfa, 0x00, 0x00, 0x46, 0xd7, 0x03, 0x06, 0x01, 0x04, 0x7f, 0xc0, 0x8c, 0xbf, 0xf9, 0x00, 0x88, 0x7d, 0x06,
    0x82, 0x86, 0x06, 0x07, 0x02, 0x88, 0x7d, 0x02, 0x6a, 0x6a, 0x87, 0x6a, 0x3c, 0x82, 0xbe, 0x13, 0x02, 0x88, 0xbf,
    0x00, 0x02, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xfa, 0x04, 0x00, 0x38, 0x4a, 0x05, 0x02, 0x3a, 0x4a, 0x7f, 0xc0, 0x8c,
    0xbf, 0x08, 0x00, 0x40, 0x4a, 0x09, 0x02, 0x42, 0x4a, 0x0a, 0x81, 0x00, 0xbf, 0x53, 0x00, 0x84, 0xbf, 0x00, 0x03,
    0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x0c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a, 0x00,
    0x00, 0x10, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x06, 0x00, 0x00, 0x0b, 0x82, 0x00, 0xbf,
    0x0c, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x70, 0x00, 0x8c,
    0xbf, 0x01, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0xf3, 0x01, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x14,
    0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x82, 0x02, 0x14, 0x7e,
    0x83, 0x02, 0x16, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x03, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x0b, 0x00, 0x00, 0xdd, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0xdb, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4,
    0x00, 0x00, 0x00, 0xfa, 0x81, 0x02, 0x0e, 0x7e, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c,
    0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02, 0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x07, 0x00,
    0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x06, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x07, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21,
    0x13, 0x00, 0x00, 0xb7, 0x01, 0x82, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x5a, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4,
    0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x14, 0x7e, 0x81, 0x02, 0x16, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12,
    0x8a, 0x00, 0x00, 0x10, 0x00, 0x01, 0x00, 0xa1, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x0a,
    0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x0b, 0x00, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x10,
    0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x70, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5,
    0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02,
    0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x95, 0x01, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x13, 0x00, 0x84, 0xbf, 0x00,
    0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e, 0x83, 0x02, 0x1e, 0x7e, 0x70, 0x00, 0x8c, 0xbf,
    0x03, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0e,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00, 0x80, 0x01, 0x82, 0xbf, 0x0b,
    0x88, 0x00, 0xbf, 0x7e, 0x01, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x82, 0x02, 0x1c, 0x7e,
    0x83, 0x02, 0x1e, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85, 0x02, 0x26, 0x7e, 0x86, 0x02, 0x2c, 0x7e, 0x87, 0x02, 0x2e,
    0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0a,
    0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x21, 0x0e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x0f, 0x00, 0x00,
    0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01,
    0x00, 0x21, 0x13, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x5b, 0x01, 0x82, 0xbf, 0x0a, 0x84, 0x00, 0xbf, 0x7b,
    0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02, 0x24, 0x7e, 0x81, 0x02, 0x26, 0x7e,
    0x82, 0x02, 0x2c, 0x7e, 0x83, 0x02, 0x2e, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a, 0x00, 0x00, 0x10,
    0x00, 0x03, 0x00, 0xa1, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x32, 0x0f,
    0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x13, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x03, 0x00, 0x1d,
    0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x17, 0x00, 0x00, 0x0b, 0x81, 0x00, 0xbf,
    0x21, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x72, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03,
    0xd5, 0x00, 0x09, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x11, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00,
    0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02,
    0x0d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x23, 0x02, 0x18,
    0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03,
    0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x09,
    0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x20,
    0x01, 0x82, 0xbf, 0x0b, 0x82, 0x00, 0xbf, 0x1d, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa,
    0x72, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02,
    0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x70, 0x3f,
    0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x06,
    0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf,
    0x01, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x13, 0x00, 0x00, 0x01, 0x01, 0x82, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0xff, 0x00,
    0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x84, 0x02, 0x34, 0x7e, 0x85, 0x02, 0x36, 0x7e, 0x86,
    0x02, 0x3c, 0x7e, 0x87, 0x02, 0x3e, 0x7e, 0x70, 0x00, 0x8c, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x21, 0x12, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x21, 0x13, 0x00,
    0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x16, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x21, 0x17, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1a, 0x00, 0x00, 0x32,
    0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21, 0x1b, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00,
    0x21, 0x1e, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x1f, 0x00, 0x00, 0xde, 0x00, 0x82,
    0xbf, 0x0a, 0x88, 0x00, 0xbf, 0xdc, 0x00, 0x84, 0xbf, 0x00, 0x03, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x80, 0x02,
    0x44, 0x7e, 0x81, 0x02, 0x46, 0x7e, 0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x24, 0x7e, 0x85,
    0x02, 0x2c, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02, 0x3c, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x12, 0xff, 0x12, 0x8a,
    0x00, 0x00, 0x10, 0x00, 0x07, 0x00, 0xa1, 0xbf, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x03, 0x00, 0x1d, 0x22, 0x00,
    0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x03, 0x00, 0x1d, 0x23, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x08,
    0x03, 0x00, 0x1d, 0x24, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x03, 0x00, 0x1d, 0x25, 0x00, 0x00, 0x32,
    0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x03, 0x00, 0x1d, 0x12, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x14, 0x03, 0x00,
    0x1d, 0x16, 0x00, 0x00, 0x32, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x03, 0x00, 0x1d, 0x1a, 0x00, 0x00, 0x30, 0x0f, 0x00,
    0xf0, 0x1c, 0x1c, 0x03, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x41, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00,
    0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01,
    0x0b, 0x02, 0x18, 0x74, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf,
    0x09, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x05, 0x00, 0x03,
    0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x23, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09,
    0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5,
    0x1a, 0x3d, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x04, 0x13, 0x02, 0x18, 0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02,
    0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x07, 0x00,
    0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x1b,
    0x3f, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x47, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x05, 0x11, 0x02, 0x18,
    0x06, 0x00, 0x03, 0xd5, 0x06, 0x19, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x15, 0x02, 0x18, 0x04, 0x00, 0x03,
    0xd5, 0x07, 0x09, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x0d,
    0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x09, 0x02, 0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x74, 0x00, 0x82, 0xbf, 0x0b, 0x82, 0x00, 0xbf, 0x3d, 0x00, 0x84, 0xbf, 0x00, 0x01, 0x0c, 0xf4,
    0x00, 0x00, 0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03,
    0xd5, 0x01, 0x0b, 0x02, 0x18, 0x74, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03,
    0x0f, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0b, 0x02,
    0x18, 0x05, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x25, 0x00,
    0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x19,
    0x3b, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x05, 0x0d, 0x02, 0x18,
    0x06, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x0b, 0x00, 0x03,
    0xd5, 0x07, 0x09, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x4b,
    0x02, 0x18, 0x0c, 0x00, 0x03, 0xd5, 0x08, 0x0d, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5, 0x09, 0x0f, 0x02, 0x18, 0x7f,
    0xc0, 0x8c, 0xbf, 0x01, 0x00, 0xa1, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f, 0x20, 0xf0,
    0x20, 0x0a, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x35, 0x00, 0x82, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x33, 0x00, 0x84,
    0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x76, 0x3f, 0x8c, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09,
    0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03,
    0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x74, 0x3f, 0x8c, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18,
    0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x07, 0x00, 0x03,
    0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x72, 0x3f, 0x8c, 0xbf, 0x08, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x09, 0x00,
    0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x0b, 0x00, 0x03, 0xd5, 0x13,
    0x2f, 0x02, 0x18, 0x70, 0x3f, 0x8c, 0xbf, 0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5,
    0x19, 0x3b, 0x02, 0x18, 0x0e, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x0f, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02,
    0x18, 0x7f, 0xc0, 0x8c, 0xbf, 0x03, 0x00, 0xa1, 0xbf, 0x30, 0x3f, 0x20, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x32, 0x3f,
    0x20, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x21, 0x23, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x21,
    0x24, 0x00, 0x00, 0x32, 0x3f, 0x20, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x21, 0x25, 0x00, 0x00, 0x00, 0x00, 0x81, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20,
    0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20,
    0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70,
    0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20,
    0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f,
    0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f,
    0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x98, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00,
    0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61,
    0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c,
    0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2,
    0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2,
    0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65,
    0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61,
    0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e,
    0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65,
    0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x1b, 0x55, 0x2d, 0x65, 0xcc, 0x7d, 0x3c, 0x07, 0xcf, 0xce, 0x39,
    0xf0, 0x44, 0xc6, 0x87, 0xbb, 0x36, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61,
    0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f,
    0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61,
    0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde,
    0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d,
    0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72,
    0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4,
    0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a,
    0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63,
    0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f,
    0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3,
    0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75,
    0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x20, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61,
    0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f,
    0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e,
    0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f,
    0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64,
    0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f,
    0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70,
    0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72,
    0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74,
    0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e,
    0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74,
    0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63,
    0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0xdf, 0x96, 0x5a, 0x10, 0xaa,
    0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61,
    0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x52, 0x54, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65,
    0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92,
    0xcf, 0xa7, 0xc3, 0x18, 0x28, 0xcb, 0xff, 0x9e, 0x1d, 0xcf, 0x4c, 0x59, 0x2b, 0x15, 0x96, 0x45, 0x3e, 0x9f, 0xb2,
    0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85,
    0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e,
    0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f,
    0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63,
    0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x98, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x0a, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x1e, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x99, 0x0a, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00,
    0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe1, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa DS Copy compute shader binary
inline constexpr Util::uint8 MsaaDSCopy_Cs_F3CDD6F8[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x08, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x86, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x07, 0x00, 0x81, 0xbe, 0x00, 0x02, 0x08, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15, 0x29, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x01, 0x00, 0x46, 0xd6, 0x03,
    0x06, 0x05, 0x04, 0x00, 0x00, 0x46, 0xd6, 0x04, 0x06, 0x01, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x12, 0x01, 0x87, 0xbf,
    0x02, 0x00, 0x4c, 0xd4, 0x0a, 0x02, 0x02, 0x00, 0x0b, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00, 0x87,
    0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x8b, 0x01, 0xa5, 0xbf, 0x00, 0x01, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x08, 0x02,
    0x38, 0x4a, 0x09, 0x00, 0x3c, 0x4a, 0x07, 0xfc, 0x89, 0xbf, 0x04, 0x02, 0x40, 0x4a, 0x05, 0x00, 0x44, 0x4a, 0x06,
    0x81, 0x00, 0xbf, 0x51, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08, 0x7e,
    0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x04, 0x00, 0x00, 0x07, 0x82, 0x00,
    0xbf, 0x0c, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x07, 0x00,
    0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x6d, 0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf,
    0x14, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e,
    0x7e, 0x83, 0x02, 0x14, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x0a, 0x00, 0x00, 0x57, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x55, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02,
    0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e, 0x87, 0x02, 0x24, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07,
    0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x12, 0x00, 0x00, 0x31, 0x01, 0xa0, 0xbf, 0x06, 0x82, 0x00, 0xbf, 0x4e, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x10, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00,
    0x02, 0x00, 0x1e, 0x08, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x07, 0x00, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00,
    0x1f, 0x01, 0xa0, 0xbf, 0x81, 0x02, 0x14, 0x7e, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x0a, 0x00,
    0x00, 0x07, 0x84, 0x00, 0xbf, 0x13, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02,
    0x16, 0x7e, 0x83, 0x02, 0x1c, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01,
    0x00, 0x22, 0x0e, 0x00, 0x00, 0x06, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x04, 0x01, 0xa1, 0xbf, 0x00, 0x01,
    0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x16, 0x7e, 0x83, 0x02, 0x1c, 0x7e, 0x84, 0x02, 0x1e, 0x7e, 0x85,
    0x02, 0x24, 0x7e, 0x86, 0x02, 0x26, 0x7e, 0x87, 0x02, 0x2c, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f,
    0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22,
    0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x04, 0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x16, 0x00,
    0x00, 0xe1, 0x00, 0xa0, 0xbf, 0x06, 0x84, 0x00, 0xbf, 0x5c, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00,
    0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e,
    0x10, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x07, 0x00, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0xcf, 0x00, 0xa0,
    0xbf, 0x81, 0x02, 0x24, 0x7e, 0x82, 0x02, 0x22, 0x7e, 0x83, 0x02, 0x26, 0x7e, 0x02, 0x00, 0x85, 0xbf, 0x19, 0x0f,
    0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x12, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e,
    0x11, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x13, 0x00, 0x00, 0x07, 0x82, 0x00, 0xbf,
    0x1a, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x03, 0x89, 0xbf, 0x08, 0x19, 0x26,
    0x1e, 0x09, 0x1b, 0x2c, 0x1e, 0x0a, 0x1d, 0x10, 0x1e, 0x0b, 0x1f, 0x12, 0x1e, 0x94, 0x01, 0x87, 0xbf, 0x04, 0x00,
    0x19, 0xd6, 0x00, 0x09, 0x4e, 0x04, 0x06, 0x00, 0x19, 0xd6, 0x02, 0x0d, 0x22, 0x04, 0x03, 0x00, 0x87, 0xbf, 0x07,
    0x00, 0x19, 0xd6, 0x03, 0x0f, 0x26, 0x04, 0x05, 0x00, 0x19, 0xd6, 0x01, 0x0b, 0x5a, 0x04, 0x07, 0xfc, 0x89, 0xbf,
    0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0xa6, 0x00, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0xa4, 0x00,
    0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86,
    0x02, 0x34, 0x7e, 0x87, 0x02, 0x36, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x12, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x11, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x16, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x17, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00,
    0x22, 0x1a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1b, 0x00, 0x00, 0x83, 0x00, 0xa0,
    0xbf, 0x06, 0x88, 0x00, 0xbf, 0x81, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02,
    0x42, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x21, 0x00, 0x00, 0x07,
    0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x00, 0x89, 0xbf,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x71, 0x00, 0xa0, 0xbf, 0x81, 0x02, 0x46,
    0x7e, 0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02, 0x28, 0x7e, 0x86, 0x02,
    0x30, 0x7e, 0x87, 0x02, 0x3a, 0x7e, 0x06, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e,
    0x23, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e, 0x24, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0,
    0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x25, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x02, 0x00, 0x1e, 0x10, 0x00,
    0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x14, 0x02, 0x00, 0x1e, 0x14, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x18,
    0x02, 0x00, 0x1e, 0x18, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x02, 0x00, 0x1e, 0x1d, 0x00, 0x00, 0x07,
    0x82, 0x00, 0xbf, 0x2d, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x13, 0x89, 0xbf,
    0x08, 0x19, 0x10, 0x1e, 0x0a, 0x1d, 0x18, 0x1e, 0xf7, 0x03, 0x89, 0xbf, 0x18, 0x39, 0x14, 0x1e, 0x09, 0x1b, 0x12,
    0x1e, 0x0b, 0x1f, 0x1a, 0x1e, 0x04, 0x00, 0x19, 0xd6, 0x00, 0x09, 0x22, 0x04, 0x14, 0x02, 0x87, 0xbf, 0x0a, 0x00,
    0x19, 0xd6, 0x10, 0x29, 0x2a, 0x04, 0x05, 0x00, 0x19, 0xd6, 0x01, 0x0b, 0x26, 0x04, 0x1a, 0x3d, 0x10, 0x1e, 0x53,
    0x02, 0x87, 0xbf, 0x04, 0x15, 0x08, 0x1e, 0x19, 0x3b, 0x14, 0x1e, 0x1b, 0x3f, 0x12, 0x1e, 0x06, 0x00, 0x19, 0xd6,
    0x02, 0x0d, 0x32, 0x04, 0x07, 0x00, 0x19, 0xd6, 0x03, 0x0f, 0x36, 0x04, 0x0a, 0x00, 0x19, 0xd6, 0x11, 0x2b, 0x2a,
    0x04, 0xa4, 0x01, 0x87, 0xbf, 0x09, 0x00, 0x19, 0xd6, 0x13, 0x2f, 0x26, 0x04, 0x08, 0x00, 0x19, 0xd6, 0x12, 0x2d,
    0x22, 0x04, 0x05, 0x15, 0x0a, 0x1e, 0x93, 0x01, 0x87, 0xbf, 0x07, 0x13, 0x0e, 0x1e, 0x06, 0x11, 0x0c, 0x1e, 0x07,
    0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x25, 0x00, 0xa0, 0xbf, 0x07, 0x84, 0x00,
    0xbf, 0x23, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x17, 0x89, 0xbf, 0x04, 0x11,
    0x08, 0x1e, 0x05, 0x13, 0x0a, 0x1e, 0x06, 0x15, 0x0c, 0x1e, 0x07, 0x17, 0x0e, 0x1e, 0xf7, 0x0f, 0x89, 0xbf, 0x0c,
    0x21, 0x10, 0x1e, 0x0d, 0x23, 0x12, 0x1e, 0x0e, 0x25, 0x14, 0x1e, 0x0f, 0x27, 0x16, 0x1e, 0xf7, 0x03, 0x89, 0xbf,
    0x0c, 0x00, 0x19, 0xd6, 0x14, 0x31, 0x72, 0x04, 0x0d, 0x00, 0x19, 0xd6, 0x15, 0x33, 0x76, 0x04, 0x0e, 0x00, 0x19,
    0xd6, 0x16, 0x35, 0x7a, 0x04, 0x0f, 0x00, 0x19, 0xd6, 0x17, 0x37, 0x7e, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00,
    0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x24, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x25, 0x00, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6,
    0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65,
    0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d,
    0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c,
    0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68,
    0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x9c, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00,
    0x00, 0x0c, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae,
    0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61,
    0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e,
    0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68,
    0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c,
    0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65,
    0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f,
    0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xce, 0x5d, 0x09, 0x22, 0x94, 0x5b,
    0x01, 0xec, 0xcf, 0xc9, 0x97, 0x6a, 0xb1, 0x04, 0x86, 0xee, 0xd5, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61,
    0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68,
    0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77,
    0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81,
    0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e,
    0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73,
    0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xab,
    0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73,
    0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72,
    0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73,
    0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64,
    0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e,
    0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f,
    0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f,
    0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72,
    0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0x00, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65,
    0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93,
    0x08, 0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e,
    0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65,
    0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac,
    0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77,
    0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e,
    0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70,
    0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70,
    0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73,
    0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce,
    0x97, 0x17, 0x8c, 0xaa, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42,
    0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x44, 0x53, 0x43, 0x6f, 0x70, 0x79, 0xb7,
    0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f,
    0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x66, 0xa4, 0x89, 0x32, 0x30, 0x66, 0x15, 0x01, 0xcf, 0x10, 0xff, 0xc9, 0x98,
    0x3b, 0x75, 0x2a, 0xaf, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73,
    0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63,
    0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67,
    0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e,
    0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69,
    0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
    0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x9c, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x72, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00,
    0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x9d, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe5, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa RT Copy compute shader binary
inline constexpr Util::uint8 MsaaRTCopy_Cs_F3CDD6F8[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x86, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x07, 0x00, 0x81, 0xbe, 0x00, 0x02, 0x08, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15, 0x29, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x01, 0x00, 0x46, 0xd6, 0x03,
    0x06, 0x05, 0x04, 0x00, 0x00, 0x46, 0xd6, 0x04, 0x06, 0x01, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x12, 0x01, 0x87, 0xbf,
    0x02, 0x00, 0x4c, 0xd4, 0x0a, 0x02, 0x02, 0x00, 0x0b, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00, 0x87,
    0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x1d, 0x02, 0xa5, 0xbf, 0x00, 0x01, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x08, 0x02,
    0x38, 0x4a, 0x09, 0x00, 0x3c, 0x4a, 0x07, 0xfc, 0x89, 0xbf, 0x04, 0x02, 0x40, 0x4a, 0x05, 0x00, 0x44, 0x4a, 0x06,
    0x81, 0x00, 0xbf, 0x51, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08, 0x7e,
    0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x04, 0x00, 0x00, 0x07, 0x82, 0x00,
    0xbf, 0x0c, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x07, 0x00,
    0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0xff, 0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf,
    0x14, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e,
    0x7e, 0x83, 0x02, 0x14, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x0a, 0x00, 0x00, 0xe9, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0xe7, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02,
    0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e, 0x87, 0x02, 0x24, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07,
    0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x12, 0x00, 0x00, 0xc3, 0x01, 0xa0, 0xbf, 0x06, 0x82, 0x00, 0xbf, 0x58, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x10, 0x7e, 0x81, 0x02, 0x12, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00,
    0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x08, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c,
    0x04, 0x02, 0x00, 0x1e, 0x09, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x10, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4,
    0x00, 0x00, 0x00, 0xf8, 0xf7, 0x03, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03,
    0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f,
    0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0xa3,
    0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf, 0x13, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x09,
    0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x04, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x8e, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x8c, 0x01, 0xa1, 0xbf,
    0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c,
    0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02, 0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00,
    0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x22, 0x09, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01,
    0x00, 0x22, 0x0e, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f,
    0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22,
    0x13, 0x00, 0x00, 0x69, 0x01, 0xa0, 0xbf, 0x06, 0x84, 0x00, 0xbf, 0x7b, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4,
    0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x81, 0x02, 0x22, 0x7e, 0x82, 0x02, 0x24, 0x7e, 0x83, 0x02, 0x26,
    0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x10,
    0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x11, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c,
    0x08, 0x02, 0x00, 0x1e, 0x12, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x13, 0x00, 0x00,
    0x07, 0x81, 0x00, 0xbf, 0x23, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x0b, 0x89,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x12, 0x00, 0x03, 0xd5, 0x08, 0x19,
    0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x13, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x25, 0x02, 0x18,
    0x04, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x27, 0x02, 0x18, 0x03, 0x00, 0x03,
    0xd5, 0x03, 0x0f, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x14, 0x01, 0x87, 0xbf, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x2e, 0x01, 0xa0, 0xbf, 0x07, 0x82, 0x00, 0xbf,
    0x1d, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x0b, 0x89, 0xbf, 0x00, 0x00, 0x03,
    0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d,
    0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08,
    0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18,
    0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x11,
    0x00, 0x00, 0x0f, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x0d, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02, 0x36, 0x7e,
    0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x11, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x16, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00,
    0x22, 0x17, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1a, 0x00, 0x00, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1b, 0x00, 0x00, 0xec, 0x00, 0xa0, 0xbf, 0x06, 0x88, 0x00, 0xbf, 0xea, 0x00,
    0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x42, 0x7e, 0x81, 0x02, 0x46, 0x7e, 0x82,
    0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02, 0x28, 0x7e, 0x86, 0x02, 0x30, 0x7e,
    0x87, 0x02, 0x3a, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02,
    0x00, 0x1e, 0x21, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x23, 0x00, 0x00, 0x19, 0x0f,
    0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e, 0x24, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e,
    0x25, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x02, 0x00, 0x1e, 0x10, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0,
    0x1c, 0x14, 0x02, 0x00, 0x1e, 0x14, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x02, 0x00, 0x1e, 0x18, 0x00,
    0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x02, 0x00, 0x1e, 0x1d, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x49, 0x00,
    0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00,
    0x09, 0x02, 0x18, 0xf7, 0x13, 0x89, 0xbf, 0x23, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x0b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02,
    0x18, 0x34, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x47, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf, 0x05, 0x00,
    0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x11,
    0x2b, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x23, 0x00, 0x03, 0xd5,
    0x18, 0x39, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x14, 0x02, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x05, 0x47,
    0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x11, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x12,
    0x2d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0d, 0x02, 0x18, 0x54, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5,
    0x00, 0x0f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02,
    0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x04, 0x00,
    0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x94, 0x01, 0x87, 0xbf, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05,
    0x00, 0x03, 0xd5, 0x07, 0x11, 0x02, 0x18, 0x13, 0x01, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x09, 0x02, 0x18,
    0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x22, 0x21, 0x00, 0x00, 0x7b, 0x00, 0xa0, 0xbf, 0x07, 0x82, 0x00, 0xbf, 0x43, 0x00, 0xa1, 0xbf, 0x00, 0x01,
    0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0xf7,
    0x13, 0x89, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18,
    0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x24, 0x02, 0x87,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00,
    0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b,
    0x1f, 0x02, 0x18, 0x54, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf,
    0x04, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02,
    0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x07, 0x00,
    0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x34, 0x02, 0x87, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x06,
    0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5,
    0x05, 0x0f, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02,
    0x18, 0x14, 0x01, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x06, 0x11, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x07, 0x13,
    0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22,
    0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x36, 0x00, 0xa0, 0xbf,
    0x07, 0x84, 0x00, 0xbf, 0x34, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0xf7, 0x13, 0x89, 0xbf, 0x07,
    0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5,
    0x09, 0x1b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf, 0x0b, 0x00, 0x03,
    0xd5, 0x13, 0x2f, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x11, 0x2b,
    0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x0f, 0x00, 0x03, 0xd5, 0x1b,
    0x3f, 0x02, 0x18, 0x0e, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18,
    0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23,
    0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x24, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x0c, 0x01, 0x00, 0x22, 0x25, 0x00, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20,
    0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20,
    0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70,
    0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20,
    0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f,
    0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f,
    0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00,
    0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61,
    0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c,
    0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2,
    0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2,
    0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65,
    0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61,
    0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e,
    0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65,
    0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x1b, 0x55, 0x2d, 0x65, 0xcc, 0x7d, 0x3c, 0x07, 0xcf, 0xce, 0x39,
    0xf0, 0x44, 0xc6, 0x87, 0xbb, 0x36, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61,
    0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f,
    0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61,
    0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde,
    0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d,
    0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72,
    0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4,
    0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a,
    0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63,
    0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f,
    0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3,
    0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75,
    0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61,
    0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f,
    0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e,
    0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f,
    0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64,
    0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f,
    0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70,
    0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72,
    0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74,
    0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e,
    0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74,
    0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63,
    0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0xdf, 0x96, 0x5a, 0x10, 0xaa,
    0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61,
    0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x52, 0x54, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65,
    0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92,
    0xcf, 0xa7, 0xc3, 0x18, 0x28, 0xcb, 0xff, 0x9e, 0x1d, 0xcf, 0x1d, 0x49, 0x8c, 0x2b, 0xe3, 0xad, 0x3f, 0x20, 0xb2,
    0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85,
    0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e,
    0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f,
    0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63,
    0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5a, 0x0a, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x6a, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xba, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe5, 0x0a, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00,
    0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x2d, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa DS Copy compute shader binary
inline constexpr Util::uint8 MsaaDSCopy_Cs_519251A5[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf4, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x86, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x07, 0x00, 0x81, 0xbe, 0x00, 0x02, 0x08, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15, 0x29, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x01, 0x00, 0x46, 0xd6, 0x03,
    0x06, 0x05, 0x04, 0x00, 0x00, 0x46, 0xd6, 0x04, 0x06, 0x01, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x12, 0x01, 0x87, 0xbf,
    0x02, 0x00, 0x4c, 0xd4, 0x0a, 0x02, 0x02, 0x00, 0x0b, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00, 0x87,
    0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x8b, 0x01, 0xa5, 0xbf, 0x00, 0x01, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x08, 0x02,
    0x38, 0x4a, 0x09, 0x00, 0x3c, 0x4a, 0x07, 0xfc, 0x89, 0xbf, 0x04, 0x02, 0x40, 0x4a, 0x05, 0x00, 0x44, 0x4a, 0x06,
    0x81, 0x00, 0xbf, 0x51, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08, 0x7e,
    0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x04, 0x00, 0x00, 0x07, 0x82, 0x00,
    0xbf, 0x0c, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x07, 0x00,
    0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x6d, 0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf,
    0x14, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e,
    0x7e, 0x83, 0x02, 0x14, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x0a, 0x00, 0x00, 0x57, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x55, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02,
    0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e, 0x87, 0x02, 0x24, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07,
    0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x12, 0x00, 0x00, 0x31, 0x01, 0xa0, 0xbf, 0x06, 0x82, 0x00, 0xbf, 0x4e, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x10, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00,
    0x02, 0x00, 0x1e, 0x08, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x07, 0x00, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00,
    0x1f, 0x01, 0xa0, 0xbf, 0x81, 0x02, 0x14, 0x7e, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x0a, 0x00,
    0x00, 0x07, 0x84, 0x00, 0xbf, 0x13, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02,
    0x16, 0x7e, 0x83, 0x02, 0x1c, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01,
    0x00, 0x22, 0x0e, 0x00, 0x00, 0x06, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x04, 0x01, 0xa1, 0xbf, 0x00, 0x01,
    0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x16, 0x7e, 0x83, 0x02, 0x1c, 0x7e, 0x84, 0x02, 0x1e, 0x7e, 0x85,
    0x02, 0x24, 0x7e, 0x86, 0x02, 0x26, 0x7e, 0x87, 0x02, 0x2c, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f,
    0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22,
    0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x04, 0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x16, 0x00,
    0x00, 0xe1, 0x00, 0xa0, 0xbf, 0x06, 0x84, 0x00, 0xbf, 0x5c, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00,
    0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e,
    0x10, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x07, 0x00, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0xcf, 0x00, 0xa0,
    0xbf, 0x81, 0x02, 0x24, 0x7e, 0x82, 0x02, 0x22, 0x7e, 0x83, 0x02, 0x26, 0x7e, 0x02, 0x00, 0x85, 0xbf, 0x19, 0x0f,
    0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x12, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e,
    0x11, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x13, 0x00, 0x00, 0x07, 0x82, 0x00, 0xbf,
    0x1a, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x03, 0x89, 0xbf, 0x08, 0x19, 0x26,
    0x1e, 0x09, 0x1b, 0x2c, 0x1e, 0x0a, 0x1d, 0x10, 0x1e, 0x0b, 0x1f, 0x12, 0x1e, 0x94, 0x01, 0x87, 0xbf, 0x04, 0x00,
    0x19, 0xd6, 0x00, 0x09, 0x4e, 0x04, 0x06, 0x00, 0x19, 0xd6, 0x02, 0x0d, 0x22, 0x04, 0x03, 0x00, 0x87, 0xbf, 0x07,
    0x00, 0x19, 0xd6, 0x03, 0x0f, 0x26, 0x04, 0x05, 0x00, 0x19, 0xd6, 0x01, 0x0b, 0x5a, 0x04, 0x07, 0xfc, 0x89, 0xbf,
    0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0xa6, 0x00, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0xa4, 0x00,
    0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86,
    0x02, 0x34, 0x7e, 0x87, 0x02, 0x36, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x12, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x11, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x16, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x17, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00,
    0x22, 0x1a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1b, 0x00, 0x00, 0x83, 0x00, 0xa0,
    0xbf, 0x06, 0x88, 0x00, 0xbf, 0x81, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02,
    0x42, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x21, 0x00, 0x00, 0x07,
    0x81, 0x00, 0xbf, 0x07, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x00, 0x89, 0xbf,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x71, 0x00, 0xa0, 0xbf, 0x81, 0x02, 0x46,
    0x7e, 0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02, 0x28, 0x7e, 0x86, 0x02,
    0x30, 0x7e, 0x87, 0x02, 0x3a, 0x7e, 0x06, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e,
    0x23, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e, 0x24, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0,
    0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x25, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x02, 0x00, 0x1e, 0x10, 0x00,
    0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x14, 0x02, 0x00, 0x1e, 0x14, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x18,
    0x02, 0x00, 0x1e, 0x18, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x02, 0x00, 0x1e, 0x1d, 0x00, 0x00, 0x07,
    0x82, 0x00, 0xbf, 0x2d, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x13, 0x89, 0xbf,
    0x08, 0x19, 0x10, 0x1e, 0x0a, 0x1d, 0x18, 0x1e, 0xf7, 0x03, 0x89, 0xbf, 0x18, 0x39, 0x14, 0x1e, 0x09, 0x1b, 0x12,
    0x1e, 0x0b, 0x1f, 0x1a, 0x1e, 0x04, 0x00, 0x19, 0xd6, 0x00, 0x09, 0x22, 0x04, 0x14, 0x02, 0x87, 0xbf, 0x0a, 0x00,
    0x19, 0xd6, 0x10, 0x29, 0x2a, 0x04, 0x05, 0x00, 0x19, 0xd6, 0x01, 0x0b, 0x26, 0x04, 0x1a, 0x3d, 0x10, 0x1e, 0x53,
    0x02, 0x87, 0xbf, 0x04, 0x15, 0x08, 0x1e, 0x19, 0x3b, 0x14, 0x1e, 0x1b, 0x3f, 0x12, 0x1e, 0x06, 0x00, 0x19, 0xd6,
    0x02, 0x0d, 0x32, 0x04, 0x07, 0x00, 0x19, 0xd6, 0x03, 0x0f, 0x36, 0x04, 0x0a, 0x00, 0x19, 0xd6, 0x11, 0x2b, 0x2a,
    0x04, 0xa4, 0x01, 0x87, 0xbf, 0x09, 0x00, 0x19, 0xd6, 0x13, 0x2f, 0x26, 0x04, 0x08, 0x00, 0x19, 0xd6, 0x12, 0x2d,
    0x22, 0x04, 0x05, 0x15, 0x0a, 0x1e, 0x93, 0x01, 0x87, 0xbf, 0x07, 0x13, 0x0e, 0x1e, 0x06, 0x11, 0x0c, 0x1e, 0x07,
    0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x25, 0x00, 0xa0, 0xbf, 0x07, 0x84, 0x00,
    0xbf, 0x23, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x17, 0x89, 0xbf, 0x04, 0x11,
    0x08, 0x1e, 0x05, 0x13, 0x0a, 0x1e, 0x06, 0x15, 0x0c, 0x1e, 0x07, 0x17, 0x0e, 0x1e, 0xf7, 0x0f, 0x89, 0xbf, 0x0c,
    0x21, 0x10, 0x1e, 0x0d, 0x23, 0x12, 0x1e, 0x0e, 0x25, 0x14, 0x1e, 0x0f, 0x27, 0x16, 0x1e, 0xf7, 0x03, 0x89, 0xbf,
    0x0c, 0x00, 0x19, 0xd6, 0x14, 0x31, 0x72, 0x04, 0x0d, 0x00, 0x19, 0xd6, 0x15, 0x33, 0x76, 0x04, 0x0e, 0x00, 0x19,
    0xd6, 0x16, 0x35, 0x7a, 0x04, 0x0f, 0x00, 0x19, 0xd6, 0x17, 0x37, 0x7e, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00,
    0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x24, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x25, 0x00, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6,
    0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65,
    0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d,
    0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c,
    0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68,
    0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x9c, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00,
    0x00, 0xf7, 0x03, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae,
    0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61,
    0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e,
    0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68,
    0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c,
    0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65,
    0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f,
    0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xce, 0x5d, 0x09, 0x22, 0x94, 0x5b,
    0x01, 0xec, 0xcf, 0xc9, 0x97, 0x6a, 0xb1, 0x04, 0x86, 0xee, 0xd5, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61,
    0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68,
    0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77,
    0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81,
    0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1a, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e,
    0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73,
    0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xab,
    0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73,
    0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72,
    0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73,
    0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64,
    0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e,
    0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f,
    0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f,
    0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72,
    0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0x00, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65,
    0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93,
    0x08, 0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e,
    0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65,
    0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac,
    0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77,
    0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e,
    0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70,
    0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70,
    0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73,
    0x65, 0x00, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5,
    0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x44, 0x53, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69,
    0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61,
    0x73, 0x68, 0x92, 0xcf, 0x66, 0xa4, 0x89, 0x32, 0x30, 0x66, 0x15, 0x01, 0xcf, 0x6f, 0xcd, 0x84, 0xe0, 0x71, 0x4f,
    0x4a, 0xd6, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65,
    0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74,
    0x01, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64,
    0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab,
    0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73,
    0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9c,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x72, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x9d, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe5, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa RT Copy compute shader binary
inline constexpr Util::uint8 MsaaRTCopy_Cs_519251A5[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x3c, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x86, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x07, 0x00, 0x81, 0xbe, 0x00, 0x02, 0x08, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15, 0x29, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x01, 0x00, 0x46, 0xd6, 0x03,
    0x06, 0x05, 0x04, 0x00, 0x00, 0x46, 0xd6, 0x04, 0x06, 0x01, 0x04, 0x07, 0xfc, 0x89, 0xbf, 0x12, 0x01, 0x87, 0xbf,
    0x02, 0x00, 0x4c, 0xd4, 0x0a, 0x02, 0x02, 0x00, 0x0b, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00, 0x87,
    0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x1d, 0x02, 0xa5, 0xbf, 0x00, 0x01, 0x08, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x08, 0x02,
    0x38, 0x4a, 0x09, 0x00, 0x3c, 0x4a, 0x07, 0xfc, 0x89, 0xbf, 0x04, 0x02, 0x40, 0x4a, 0x05, 0x00, 0x44, 0x4a, 0x06,
    0x81, 0x00, 0xbf, 0x51, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08, 0x7e,
    0x07, 0xfc, 0x89, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x04, 0x00, 0x00, 0x07, 0x82, 0x00,
    0xbf, 0x0c, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x07, 0x00,
    0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0xff, 0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf,
    0x14, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e,
    0x7e, 0x83, 0x02, 0x14, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x0a, 0x00, 0x00, 0xe9, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0xe7, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c,
    0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02,
    0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e, 0x87, 0x02, 0x24, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07,
    0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x04, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0,
    0x20, 0x00, 0x01, 0x00, 0x22, 0x06, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x07, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00,
    0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0e, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00,
    0x22, 0x12, 0x00, 0x00, 0xc3, 0x01, 0xa0, 0xbf, 0x06, 0x82, 0x00, 0xbf, 0x58, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c,
    0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x10, 0x7e, 0x81, 0x02, 0x12, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00,
    0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x08, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c,
    0x04, 0x02, 0x00, 0x1e, 0x09, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x10, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4,
    0x00, 0x00, 0x00, 0xf8, 0xf7, 0x03, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03,
    0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f,
    0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0xa3,
    0x01, 0xa0, 0xbf, 0x07, 0x84, 0x00, 0xbf, 0x13, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x09,
    0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x04, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x8e, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x8c, 0x01, 0xa1, 0xbf,
    0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c,
    0x7e, 0x85, 0x02, 0x1e, 0x7e, 0x86, 0x02, 0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x07, 0x00, 0x89, 0xbf, 0x07, 0x00,
    0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x08, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x00, 0x01, 0x00, 0x22, 0x09, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0a, 0x00, 0x00,
    0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x0b, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01,
    0x00, 0x22, 0x0e, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x0f, 0x00, 0x00, 0x99, 0x4f,
    0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22,
    0x13, 0x00, 0x00, 0x69, 0x01, 0xa0, 0xbf, 0x06, 0x84, 0x00, 0xbf, 0x7b, 0x00, 0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4,
    0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x81, 0x02, 0x22, 0x7e, 0x82, 0x02, 0x24, 0x7e, 0x83, 0x02, 0x26,
    0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02, 0x00, 0x1e, 0x10,
    0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x11, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c,
    0x08, 0x02, 0x00, 0x1e, 0x12, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e, 0x13, 0x00, 0x00,
    0x07, 0x81, 0x00, 0xbf, 0x23, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x0b, 0x89,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x12, 0x00, 0x03, 0xd5, 0x08, 0x19,
    0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x13, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x25, 0x02, 0x18,
    0x04, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x27, 0x02, 0x18, 0x03, 0x00, 0x03,
    0xd5, 0x03, 0x0f, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x14, 0x01, 0x87, 0xbf, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x2e, 0x01, 0xa0, 0xbf, 0x07, 0x82, 0x00, 0xbf,
    0x1d, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x0b, 0x89, 0xbf, 0x00, 0x00, 0x03,
    0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d,
    0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08,
    0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18,
    0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x11,
    0x00, 0x00, 0x0f, 0x01, 0xa0, 0xbf, 0x07, 0x88, 0x00, 0xbf, 0x0d, 0x01, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02, 0x36, 0x7e,
    0x07, 0x00, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x10, 0x00,
    0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x11, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04,
    0x01, 0x00, 0x22, 0x12, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x13, 0x00, 0x00, 0x99,
    0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x16, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00,
    0x22, 0x17, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1a, 0x00, 0x00, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x0c, 0x01, 0x00, 0x22, 0x1b, 0x00, 0x00, 0xec, 0x00, 0xa0, 0xbf, 0x06, 0x88, 0x00, 0xbf, 0xea, 0x00,
    0xa1, 0xbf, 0x00, 0x02, 0x0c, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x42, 0x7e, 0x81, 0x02, 0x46, 0x7e, 0x82,
    0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02, 0x28, 0x7e, 0x86, 0x02, 0x30, 0x7e,
    0x87, 0x02, 0x3a, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x00, 0x02,
    0x00, 0x1e, 0x21, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x04, 0x02, 0x00, 0x1e, 0x23, 0x00, 0x00, 0x19, 0x0f,
    0x00, 0xf0, 0x1c, 0x08, 0x02, 0x00, 0x1e, 0x24, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x0c, 0x02, 0x00, 0x1e,
    0x25, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x10, 0x02, 0x00, 0x1e, 0x10, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0,
    0x1c, 0x14, 0x02, 0x00, 0x1e, 0x14, 0x00, 0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x18, 0x02, 0x00, 0x1e, 0x18, 0x00,
    0x00, 0x19, 0x0f, 0x00, 0xf0, 0x1c, 0x1c, 0x02, 0x00, 0x1e, 0x1d, 0x00, 0x00, 0x07, 0x81, 0x00, 0xbf, 0x49, 0x00,
    0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00,
    0x09, 0x02, 0x18, 0xf7, 0x13, 0x89, 0xbf, 0x23, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x0b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02,
    0x18, 0x34, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x47, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf, 0x05, 0x00,
    0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x11,
    0x2b, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x23, 0x00, 0x03, 0xd5,
    0x18, 0x39, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x14, 0x02, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x05, 0x47,
    0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x11, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x12,
    0x2d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0d, 0x02, 0x18, 0x54, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5,
    0x00, 0x0f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02,
    0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x04, 0x00,
    0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x94, 0x01, 0x87, 0xbf, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05,
    0x00, 0x03, 0xd5, 0x07, 0x11, 0x02, 0x18, 0x13, 0x01, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x09, 0x02, 0x18,
    0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01,
    0x00, 0x22, 0x21, 0x00, 0x00, 0x7b, 0x00, 0xa0, 0xbf, 0x07, 0x82, 0x00, 0xbf, 0x43, 0x00, 0xa1, 0xbf, 0x00, 0x01,
    0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0xf7,
    0x13, 0x89, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18,
    0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x24, 0x02, 0x87,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00,
    0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b,
    0x1f, 0x02, 0x18, 0x54, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf,
    0x04, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02,
    0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x07, 0x00,
    0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x34, 0x02, 0x87, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x06,
    0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5,
    0x05, 0x0f, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02,
    0x18, 0x14, 0x01, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x06, 0x11, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x07, 0x13,
    0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x00, 0x01, 0x00, 0x22,
    0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23, 0x00, 0x00, 0x36, 0x00, 0xa0, 0xbf,
    0x07, 0x84, 0x00, 0xbf, 0x34, 0x00, 0xa1, 0xbf, 0x00, 0x01, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0xf7, 0x1b, 0x89,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0xf7, 0x13, 0x89, 0xbf, 0x07,
    0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5,
    0x09, 0x1b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0xf7, 0x0b, 0x89, 0xbf, 0x0b, 0x00, 0x03,
    0xd5, 0x13, 0x2f, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x09, 0x00, 0x03, 0xd5, 0x11, 0x2b,
    0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0xf7, 0x03, 0x89, 0xbf, 0x0f, 0x00, 0x03, 0xd5, 0x1b,
    0x3f, 0x02, 0x18, 0x0e, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x0d, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18,
    0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x07, 0xfc, 0x89, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x99, 0x4f, 0x18,
    0xf0, 0x20, 0x00, 0x01, 0x00, 0x22, 0x21, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x04, 0x01, 0x00, 0x22, 0x23,
    0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20, 0x08, 0x01, 0x00, 0x22, 0x24, 0x00, 0x00, 0x99, 0x4f, 0x18, 0xf0, 0x20,
    0x0c, 0x01, 0x00, 0x22, 0x25, 0x00, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20,
    0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20,
    0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70,
    0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20,
    0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f,
    0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f,
    0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0xf7, 0x03, 0x00, 0x00,
    0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61,
    0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c,
    0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2,
    0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2,
    0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65,
    0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61,
    0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e,
    0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65,
    0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x1b, 0x55, 0x2d, 0x65, 0xcc, 0x7d, 0x3c, 0x07, 0xcf, 0xce, 0x39,
    0xf0, 0x44, 0xc6, 0x87, 0xbb, 0x36, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61,
    0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f,
    0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61,
    0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde,
    0x00, 0x1a, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d,
    0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72,
    0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4,
    0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a,
    0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63,
    0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f,
    0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3,
    0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75,
    0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61,
    0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f,
    0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08, 0x08, 0x01, 0xab, 0x2e,
    0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f,
    0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64,
    0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f,
    0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70,
    0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72,
    0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74,
    0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e,
    0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74,
    0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaa, 0x2e, 0x72,
    0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65,
    0xaa, 0x4d, 0x73, 0x61, 0x61, 0x52, 0x54, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e,
    0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa7,
    0xc3, 0x18, 0x28, 0xcb, 0xff, 0x9e, 0x1d, 0xcf, 0xe9, 0x87, 0x6c, 0x05, 0x01, 0xc5, 0x90, 0xff, 0xb2, 0x2e, 0x63,
    0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e,
    0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67,
    0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e,
    0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73,
    0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c,
    0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x09, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5a, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x6a, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xba, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe5, 0x0a, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x2d, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
};

#if (PAL_BUILD_GFX12&& 0) || (PAL_BUILD_GFX12&& PAL_BUILD_NAVI48) || (PAL_BUILD_GFX12&& (PAL_BUILD_NAVI48&& 0)) || (PAL_BUILD_GFX12&& (0 && 0))
// Msaa DS Copy compute shader binary
inline constexpr Util::uint8 MsaaDSCopy_Cs_4AC1E1C2[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xe8, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x09, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x84, 0xbe, 0x09, 0x00, 0x87, 0xbf, 0x05, 0x0f, 0x81,
    0xbe, 0x02, 0x00, 0x80, 0xbe, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03, 0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15,
    0x29, 0x02, 0x00, 0x41, 0x00, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0x73, 0xff, 0x02, 0x8b, 0xff, 0xff, 0x00, 0x00, 0x00,
    0xa0, 0x04, 0xf4, 0x41, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x90, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4,
    0x54, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xdf, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x76, 0x00, 0x00,
    0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x3b, 0x01, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xa0, 0x00, 0x00, 0xf8, 0x01, 0x00,
    0x0b, 0xd6, 0x75, 0x10, 0x05, 0x04, 0x00, 0x00, 0x0b, 0xd6, 0x02, 0x10, 0x01, 0x04, 0x00, 0xa0, 0x04, 0xf4, 0xbf,
    0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xfa, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x1b, 0x01, 0x00, 0xf8,
    0x00, 0xa0, 0x04, 0xf4, 0x79, 0x01, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x9c, 0x01, 0x00, 0xf8, 0x00, 0x00, 0xc7,
    0xbf, 0x02, 0x00, 0x4c, 0xd4, 0x06, 0x02, 0x02, 0x00, 0x07, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00,
    0x87, 0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x94, 0x01, 0xa5, 0xbf, 0x00, 0x42, 0x00, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x04,
    0x02, 0x38, 0x4a, 0x05, 0x00, 0x3c, 0x4a, 0x00, 0x00, 0xc7, 0xbf, 0x08, 0x02, 0x40, 0x4a, 0x09, 0x00, 0x44, 0x4a,
    0x0a, 0x81, 0x00, 0xbf, 0x54, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08,
    0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x04, 0x00, 0x0b, 0x82,
    0x00, 0xbf, 0x0d, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x00,
    0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00,
    0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x06, 0x00, 0x75, 0x01, 0xa0,
    0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x15, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02,
    0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x03,
    0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3,
    0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x06, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x07,
    0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0x5e, 0x01, 0xa0, 0xbf, 0x0b, 0x88,
    0x00, 0xbf, 0x5c, 0x01, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82,
    0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02, 0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e,
    0x87, 0x02, 0x24, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1,
    0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x06, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x07, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0b, 0x00,
    0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0e, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08,
    0x00, 0x20, 0x22, 0x0f, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00, 0x37, 0x01,
    0xa0, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x51, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80,
    0x02, 0x10, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x08, 0x00,
    0x0b, 0x81, 0x00, 0xbf, 0x08, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0xc7,
    0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0x24, 0x01,
    0xa0, 0xbf, 0x81, 0x02, 0x14, 0x7e, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x0a, 0x00, 0x0b,
    0x84, 0x00, 0xbf, 0x14, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x16, 0x7e,
    0x83, 0x02, 0x1c, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1,
    0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0b, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x0e, 0x00, 0x0a, 0x01, 0xa0, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x08, 0x01, 0xa1, 0xbf,
    0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x16, 0x7e, 0x83, 0x02, 0x1c, 0x7e, 0x84, 0x02, 0x1e,
    0x7e, 0x85, 0x02, 0x24, 0x7e, 0x86, 0x02, 0x26, 0x7e, 0x87, 0x02, 0x2c, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00,
    0xc0, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0x06,
    0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00,
    0x20, 0x22, 0x0b, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0e, 0x00, 0x06, 0x80, 0xc1,
    0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0f, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x12, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x13, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x16, 0x00, 0xe4, 0x00, 0xa0, 0xbf, 0x0a, 0x84, 0x00, 0xbf, 0x5e, 0x00, 0xa1, 0xbf,
    0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x06, 0x00, 0xc0,
    0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x10, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x08, 0x00, 0xa1, 0xbf, 0x00, 0x61,
    0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x10, 0x00, 0xd1, 0x00, 0xa0, 0xbf, 0x81, 0x02, 0x24, 0x7e, 0x82, 0x02, 0x22, 0x7e,
    0x83, 0x02, 0x26, 0x7e, 0x02, 0x00, 0x85, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x12,
    0x00, 0x06, 0x00, 0xc0, 0xd3, 0x08, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x11, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x0c, 0x18,
    0x00, 0x00, 0x1c, 0x1e, 0x13, 0x00, 0x0b, 0x82, 0x00, 0xbf, 0x1a, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x00, 0x00, 0xc0, 0xbf, 0x08, 0x19, 0x26, 0x2a, 0x09, 0x1b, 0x2c, 0x2a, 0x0a, 0x1d, 0x10, 0x2a,
    0x0b, 0x1f, 0x12, 0x2a, 0x94, 0x01, 0x87, 0xbf, 0x04, 0x00, 0x29, 0xd6, 0x00, 0x09, 0x4e, 0x04, 0x06, 0x00, 0x29,
    0xd6, 0x02, 0x0d, 0x22, 0x04, 0x03, 0x00, 0x87, 0xbf, 0x07, 0x00, 0x29, 0xd6, 0x03, 0x0f, 0x26, 0x04, 0x05, 0x00,
    0x29, 0xd6, 0x01, 0x0b, 0x5a, 0x04, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x10, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00,
    0xa8, 0x00, 0xa0, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0xa6, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00,
    0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02, 0x36, 0x7e, 0x00, 0x00,
    0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20,
    0x22, 0x10, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00, 0x06, 0x80, 0xc1, 0xd3,
    0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x11, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x13,
    0x00, 0x06, 0x80, 0xc1, 0xd3, 0x08, 0x08, 0x08, 0x00, 0x20, 0x22, 0x16, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x08, 0x08,
    0x08, 0x00, 0x20, 0x22, 0x17, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20, 0x22, 0x1a, 0x00, 0x06,
    0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20, 0x22, 0x1b, 0x00, 0x84, 0x00, 0xa0, 0xbf, 0x0a, 0x88, 0x00, 0xbf,
    0x82, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x42, 0x7e, 0x00, 0x00, 0xc7,
    0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x21, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x08, 0x00,
    0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x06,
    0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x71, 0x00, 0xa0, 0xbf, 0x81, 0x02, 0x46, 0x7e,
    0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02, 0x28, 0x7e, 0x86, 0x02, 0x30,
    0x7e, 0x87, 0x02, 0x3a, 0x7e, 0x06, 0x00, 0x85, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00, 0x1c, 0x1e,
    0x23, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x08, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x24, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x0c,
    0x18, 0x00, 0x00, 0x1c, 0x1e, 0x25, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x10, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x10, 0x00,
    0x06, 0x00, 0xc0, 0xd3, 0x14, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x14, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x18, 0x18, 0x00,
    0x00, 0x1c, 0x1e, 0x18, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x1c, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x1d, 0x00, 0x0b, 0x82,
    0x00, 0xbf, 0x2d, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x04, 0x00, 0xc0, 0xbf, 0x08,
    0x19, 0x10, 0x2a, 0x0a, 0x1d, 0x18, 0x2a, 0x00, 0x00, 0xc0, 0xbf, 0x18, 0x39, 0x14, 0x2a, 0x09, 0x1b, 0x12, 0x2a,
    0x0b, 0x1f, 0x1a, 0x2a, 0x04, 0x00, 0x29, 0xd6, 0x00, 0x09, 0x22, 0x04, 0x14, 0x02, 0x87, 0xbf, 0x0a, 0x00, 0x29,
    0xd6, 0x10, 0x29, 0x2a, 0x04, 0x05, 0x00, 0x29, 0xd6, 0x01, 0x0b, 0x26, 0x04, 0x1a, 0x3d, 0x10, 0x2a, 0x53, 0x02,
    0x87, 0xbf, 0x04, 0x15, 0x08, 0x2a, 0x19, 0x3b, 0x14, 0x2a, 0x1b, 0x3f, 0x12, 0x2a, 0x06, 0x00, 0x29, 0xd6, 0x02,
    0x0d, 0x32, 0x04, 0x07, 0x00, 0x29, 0xd6, 0x03, 0x0f, 0x36, 0x04, 0x0a, 0x00, 0x29, 0xd6, 0x11, 0x2b, 0x2a, 0x04,
    0xa4, 0x01, 0x87, 0xbf, 0x09, 0x00, 0x29, 0xd6, 0x13, 0x2f, 0x26, 0x04, 0x08, 0x00, 0x29, 0xd6, 0x12, 0x2d, 0x22,
    0x04, 0x05, 0x15, 0x0a, 0x2a, 0x93, 0x01, 0x87, 0xbf, 0x07, 0x13, 0x0e, 0x2a, 0x06, 0x11, 0x0c, 0x2a, 0x00, 0x00,
    0xc7, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x06,
    0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x23, 0x00, 0x25, 0x00, 0xa0, 0xbf, 0x0b, 0x84, 0x00, 0xbf,
    0x23, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x05, 0x00, 0xc0, 0xbf, 0x04, 0x11, 0x08,
    0x2a, 0x05, 0x13, 0x0a, 0x2a, 0x06, 0x15, 0x0c, 0x2a, 0x07, 0x17, 0x0e, 0x2a, 0x03, 0x00, 0xc0, 0xbf, 0x0c, 0x21,
    0x10, 0x2a, 0x0d, 0x23, 0x12, 0x2a, 0x0e, 0x25, 0x14, 0x2a, 0x0f, 0x27, 0x16, 0x2a, 0x00, 0x00, 0xc0, 0xbf, 0x0c,
    0x00, 0x29, 0xd6, 0x14, 0x31, 0x72, 0x04, 0x0d, 0x00, 0x29, 0xd6, 0x15, 0x33, 0x76, 0x04, 0x0e, 0x00, 0x29, 0xd6,
    0x16, 0x35, 0x7a, 0x04, 0x0f, 0x00, 0x29, 0xd6, 0x17, 0x37, 0x7e, 0x04, 0x00, 0x00, 0xc7, 0xbf, 0x03, 0x00, 0x85,
    0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08,
    0x08, 0x00, 0x20, 0x22, 0x23, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x08, 0x08, 0x08, 0x00, 0x20, 0x22, 0x24, 0x00, 0x06,
    0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20, 0x22, 0x25, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf,
    0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64,
    0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69,
    0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20,
    0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61,
    0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64,
    0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75,
    0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x20, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00,
    0x68, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61,
    0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d,
    0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74,
    0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61,
    0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xce, 0x5d, 0x09, 0x22, 0x94, 0x5b, 0x01,
    0xec, 0xcf, 0xc9, 0x97, 0x6a, 0xb1, 0x04, 0x86, 0xee, 0xd5, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61,
    0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e,
    0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3,
    0x2e, 0x63, 0x73, 0xde, 0x00, 0x1d, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74,
    0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f,
    0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14, 0xab, 0x2e,
    0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69,
    0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74,
    0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f,
    0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64,
    0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63,
    0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65,
    0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61,
    0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x08,
    0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66,
    0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65,
    0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xb9, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76, 0x67, 0x70,
    0x72, 0x5f, 0x73, 0x61, 0x76, 0x65, 0x64, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x00, 0xa9, 0x2e, 0x77, 0x67, 0x70,
    0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64,
    0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73,
    0xc2, 0xaf, 0x2e, 0x77, 0x67, 0x5f, 0x72, 0x6f, 0x75, 0x6e, 0x64, 0x5f, 0x72, 0x6f, 0x62, 0x69, 0x6e, 0xc2, 0xab,
    0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f,
    0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74,
    0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65,
    0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f,
    0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76,
    0x61, 0x6c, 0x75, 0x65, 0xce, 0x97, 0x17, 0x8c, 0xaa, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72,
    0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61, 0x44, 0x53,
    0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65,
    0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x66, 0xa4, 0x89, 0x32, 0x30, 0x66, 0x15, 0x01,
    0xcf, 0x5b, 0x14, 0xc9, 0xc8, 0xf7, 0x67, 0x56, 0xdf, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f,
    0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63,
    0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e,
    0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64,
    0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2,
    0xb0, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x65, 0x6e, 0xc2, 0xad,
    0x2e, 0x78, 0x5f, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xad, 0x2e, 0x79, 0x5f, 0x69,
    0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70,
    0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x08, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x96, 0x08, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xa6, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf6, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x21, 0x09, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
    0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x69, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Msaa RT Copy compute shader binary
inline constexpr Util::uint8 MsaaRTCopy_Cs_4AC1E1C2[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x24, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x09, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x84, 0xbe, 0x09, 0x00, 0x87, 0xbf, 0x05, 0x0f, 0x81,
    0xbe, 0x02, 0x00, 0x80, 0xbe, 0xff, 0x00, 0x02, 0x36, 0xff, 0x03, 0x00, 0x00, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x15,
    0x29, 0x02, 0x00, 0x41, 0x00, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0x73, 0xff, 0x02, 0x8b, 0xff, 0xff, 0x00, 0x00, 0x00,
    0xa0, 0x04, 0xf4, 0x41, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x56, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4,
    0x9b, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x78, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xad, 0x00, 0x00,
    0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xd0, 0x00, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x0a, 0x01, 0x00, 0xf8, 0x01, 0x00,
    0x0b, 0xd6, 0x75, 0x10, 0x05, 0x04, 0x00, 0x00, 0x0b, 0xd6, 0x02, 0x10, 0x01, 0x04, 0x00, 0xa0, 0x04, 0xf4, 0x23,
    0x01, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x44, 0x01, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0xb4, 0x01, 0x00, 0xf8,
    0x00, 0xa0, 0x04, 0xf4, 0xf7, 0x01, 0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x2b, 0x02, 0x00, 0xf8, 0x00, 0x00, 0xc7,
    0xbf, 0x02, 0x00, 0x4c, 0xd4, 0x06, 0x02, 0x02, 0x00, 0x07, 0x00, 0x98, 0x7c, 0x02, 0x6a, 0xea, 0x8b, 0x09, 0x00,
    0x87, 0xbf, 0x6a, 0x21, 0x82, 0xbe, 0x23, 0x02, 0xa5, 0xbf, 0x00, 0x42, 0x00, 0xf4, 0x50, 0x00, 0x00, 0xf8, 0x04,
    0x02, 0x38, 0x4a, 0x05, 0x00, 0x3c, 0x4a, 0x00, 0x00, 0xc7, 0xbf, 0x08, 0x02, 0x40, 0x4a, 0x09, 0x00, 0x44, 0x4a,
    0x0a, 0x81, 0x00, 0xbf, 0x54, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x08,
    0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x04, 0x00, 0x0b, 0x82,
    0x00, 0xbf, 0x0d, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x00,
    0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00,
    0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x06, 0x00, 0x04, 0x02, 0xa0,
    0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x15, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02,
    0x0c, 0x7e, 0x82, 0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x03,
    0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3,
    0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x06, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x07,
    0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0xed, 0x01, 0xa0, 0xbf, 0x0b, 0x88,
    0x00, 0xbf, 0xeb, 0x01, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x81, 0x02, 0x0c, 0x7e, 0x82,
    0x02, 0x0e, 0x7e, 0x83, 0x02, 0x14, 0x7e, 0x84, 0x02, 0x16, 0x7e, 0x85, 0x02, 0x1c, 0x7e, 0x86, 0x02, 0x1e, 0x7e,
    0x87, 0x02, 0x24, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1,
    0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x04, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x06, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x07, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0b, 0x00,
    0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0e, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08,
    0x00, 0x20, 0x22, 0x0f, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00, 0xc6, 0x01,
    0xa0, 0xbf, 0x0a, 0x82, 0x00, 0xbf, 0x5a, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80,
    0x02, 0x10, 0x7e, 0x81, 0x02, 0x12, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x00, 0xc0, 0xd3,
    0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x08, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x09,
    0x00, 0x0b, 0x81, 0x00, 0xbf, 0x10, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00,
    0xc0, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x00, 0x00, 0xc7, 0xbf,
    0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0xa6, 0x01, 0xa0, 0xbf, 0x0b, 0x84, 0x00,
    0xbf, 0x14, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02,
    0x16, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x09, 0x00,
    0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08,
    0x00, 0x20, 0x22, 0x0b, 0x00, 0x90, 0x01, 0xa0, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x8e, 0x01, 0xa1, 0xbf, 0x00, 0x61,
    0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x82, 0x02, 0x14, 0x7e, 0x83, 0x02, 0x16, 0x7e, 0x84, 0x02, 0x1c, 0x7e, 0x85,
    0x02, 0x1e, 0x7e, 0x86, 0x02, 0x24, 0x7e, 0x87, 0x02, 0x26, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf,
    0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x08, 0x00, 0x06, 0x80, 0xc1,
    0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x09, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x0a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0b, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x0e, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x0f, 0x00,
    0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08,
    0x00, 0x20, 0x22, 0x13, 0x00, 0x6a, 0x01, 0xa0, 0xbf, 0x0a, 0x84, 0x00, 0xbf, 0x7c, 0x00, 0xa1, 0xbf, 0x00, 0x63,
    0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x20, 0x7e, 0x81, 0x02, 0x22, 0x7e, 0x82, 0x02, 0x24, 0x7e, 0x83,
    0x02, 0x26, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x03, 0x00, 0x85, 0xbf, 0x06, 0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00,
    0x1c, 0x1e, 0x10, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x11, 0x00, 0x06, 0x00, 0xc0,
    0xd3, 0x08, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x12, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x0c, 0x18, 0x00, 0x00, 0x1c, 0x1e,
    0x13, 0x00, 0x0b, 0x81, 0x00, 0xbf, 0x23, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x02,
    0x00, 0xc0, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x00, 0x00, 0xc0, 0xbf, 0x12, 0x00, 0x03, 0xd5,
    0x08, 0x19, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x13, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02,
    0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x25,
    0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x27, 0x02, 0x18, 0x03,
    0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x14, 0x01, 0x87, 0xbf,
    0x02, 0x00, 0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x00, 0x00, 0xc7,
    0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x10, 0x00, 0x2f, 0x01, 0xa0, 0xbf, 0x0b, 0x82,
    0x00, 0xbf, 0x1d, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x02, 0x00, 0xc0, 0xbf, 0x00,
    0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5,
    0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x00, 0x00, 0xc0, 0xbf, 0x04, 0x00, 0x03,
    0xd5, 0x08, 0x19, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d,
    0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06,
    0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x10, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00,
    0x20, 0x22, 0x11, 0x00, 0x10, 0x01, 0xa0, 0xbf, 0x0b, 0x88, 0x00, 0xbf, 0x0e, 0x01, 0xa1, 0xbf, 0x00, 0x61, 0x00,
    0xf4, 0x00, 0x00, 0x00, 0xf8, 0x84, 0x02, 0x2c, 0x7e, 0x85, 0x02, 0x2e, 0x7e, 0x86, 0x02, 0x34, 0x7e, 0x87, 0x02,
    0x36, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x00, 0xc0, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00,
    0x08, 0x08, 0x00, 0x20, 0x22, 0x10, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x11, 0x00,
    0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x12, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08,
    0x00, 0x20, 0x22, 0x13, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x08, 0x08, 0x08, 0x00, 0x20, 0x22, 0x16, 0x00, 0x06, 0x80,
    0xc1, 0xd3, 0x08, 0x08, 0x08, 0x00, 0x20, 0x22, 0x17, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20,
    0x22, 0x1a, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20, 0x22, 0x1b, 0x00, 0xec, 0x00, 0xa0, 0xbf,
    0x0a, 0x88, 0x00, 0xbf, 0xea, 0x00, 0xa1, 0xbf, 0x00, 0x63, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x80, 0x02, 0x42,
    0x7e, 0x81, 0x02, 0x46, 0x7e, 0x82, 0x02, 0x48, 0x7e, 0x83, 0x02, 0x4a, 0x7e, 0x84, 0x02, 0x20, 0x7e, 0x85, 0x02,
    0x28, 0x7e, 0x86, 0x02, 0x30, 0x7e, 0x87, 0x02, 0x3a, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x07, 0x00, 0x85, 0xbf, 0x06,
    0x00, 0xc0, 0xd3, 0x00, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x21, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x04, 0x18, 0x00, 0x00,
    0x1c, 0x1e, 0x23, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x08, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x24, 0x00, 0x06, 0x00, 0xc0,
    0xd3, 0x0c, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x25, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x10, 0x18, 0x00, 0x00, 0x1c, 0x1e,
    0x10, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x14, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x14, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x18,
    0x18, 0x00, 0x00, 0x1c, 0x1e, 0x18, 0x00, 0x06, 0x00, 0xc0, 0xd3, 0x1c, 0x18, 0x00, 0x00, 0x1c, 0x1e, 0x1d, 0x00,
    0x0b, 0x81, 0x00, 0xbf, 0x49, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x06, 0x00, 0xc0,
    0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x04, 0x00, 0xc0, 0xbf, 0x23, 0x00, 0x03, 0xd5, 0x08, 0x19,
    0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02,
    0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x34, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x47, 0x02, 0x18,
    0x02, 0x00, 0xc0, 0xbf, 0x05, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x09, 0x02,
    0x18, 0x04, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x00, 0x00, 0xc0, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x19, 0x3b,
    0x02, 0x18, 0x23, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x0a, 0x1d, 0x02, 0x18, 0x03,
    0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02, 0x18, 0x14, 0x02, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18,
    0x07, 0x00, 0x03, 0xd5, 0x05, 0x47, 0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x11, 0x02,
    0x18, 0x04, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0d, 0x02, 0x18, 0x54, 0x02,
    0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x0f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x05,
    0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5,
    0x1b, 0x3f, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x04, 0x0d, 0x02, 0x18, 0x94, 0x01, 0x87, 0xbf, 0x03, 0x00, 0x03,
    0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x07, 0x11, 0x02, 0x18, 0x13, 0x01, 0x87, 0xbf, 0x02, 0x00,
    0x03, 0xd5, 0x02, 0x09, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x00, 0x00, 0xc7, 0xbf, 0x06,
    0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x7b, 0x00, 0xa0, 0xbf, 0x0b, 0x82, 0x00, 0xbf,
    0x43, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x06, 0x00, 0xc0, 0xbf, 0x00, 0x00, 0x03,
    0xd5, 0x00, 0x09, 0x02, 0x18, 0x04, 0x00, 0xc0, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x01, 0x00,
    0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02,
    0x0d, 0x02, 0x18, 0x24, 0x02, 0x87, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5,
    0x0a, 0x1d, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5, 0x01, 0x0b, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x05, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x54, 0x02, 0x87, 0xbf, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x09,
    0x02, 0x18, 0x02, 0x00, 0xc0, 0xbf, 0x04, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x00, 0x00, 0xc0, 0xbf, 0x06,
    0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0b, 0x02, 0x18, 0x05, 0x00, 0x03, 0xd5,
    0x11, 0x2b, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x34, 0x02, 0x87, 0xbf, 0x04, 0x00, 0x03,
    0xd5, 0x04, 0x0d, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x1a, 0x3d,
    0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x05, 0x0f, 0x02, 0x18, 0x07, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x09,
    0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x14, 0x01, 0x87, 0xbf, 0x06, 0x00, 0x03, 0xd5, 0x06, 0x11, 0x02, 0x18,
    0x07, 0x00, 0x03, 0xd5, 0x07, 0x13, 0x02, 0x18, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1,
    0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x04, 0x08, 0x08, 0x00, 0x20, 0x22,
    0x23, 0x00, 0x36, 0x00, 0xa0, 0xbf, 0x0b, 0x84, 0x00, 0xbf, 0x34, 0x00, 0xa1, 0xbf, 0x00, 0x61, 0x00, 0xf4, 0x00,
    0x00, 0x00, 0xf8, 0x06, 0x00, 0xc0, 0xbf, 0x00, 0x00, 0x03, 0xd5, 0x00, 0x09, 0x02, 0x18, 0x01, 0x00, 0x03, 0xd5,
    0x01, 0x0b, 0x02, 0x18, 0x02, 0x00, 0x03, 0xd5, 0x02, 0x0d, 0x02, 0x18, 0x03, 0x00, 0x03, 0xd5, 0x03, 0x0f, 0x02,
    0x18, 0x04, 0x00, 0xc0, 0xbf, 0x07, 0x00, 0x03, 0xd5, 0x0b, 0x1f, 0x02, 0x18, 0x06, 0x00, 0x03, 0xd5, 0x0a, 0x1d,
    0x02, 0x18, 0x05, 0x00, 0x03, 0xd5, 0x09, 0x1b, 0x02, 0x18, 0x04, 0x00, 0x03, 0xd5, 0x08, 0x19, 0x02, 0x18, 0x02,
    0x00, 0xc0, 0xbf, 0x0b, 0x00, 0x03, 0xd5, 0x13, 0x2f, 0x02, 0x18, 0x0a, 0x00, 0x03, 0xd5, 0x12, 0x2d, 0x02, 0x18,
    0x09, 0x00, 0x03, 0xd5, 0x11, 0x2b, 0x02, 0x18, 0x08, 0x00, 0x03, 0xd5, 0x10, 0x29, 0x02, 0x18, 0x00, 0x00, 0xc0,
    0xbf, 0x0f, 0x00, 0x03, 0xd5, 0x1b, 0x3f, 0x02, 0x18, 0x0e, 0x00, 0x03, 0xd5, 0x1a, 0x3d, 0x02, 0x18, 0x0d, 0x00,
    0x03, 0xd5, 0x19, 0x3b, 0x02, 0x18, 0x0c, 0x00, 0x03, 0xd5, 0x18, 0x39, 0x02, 0x18, 0x00, 0x00, 0xc7, 0xbf, 0x03,
    0x00, 0x85, 0xbf, 0x06, 0x80, 0xc1, 0xd3, 0x00, 0x08, 0x08, 0x00, 0x20, 0x22, 0x21, 0x00, 0x06, 0x80, 0xc1, 0xd3,
    0x04, 0x08, 0x08, 0x00, 0x20, 0x22, 0x23, 0x00, 0x06, 0x80, 0xc1, 0xd3, 0x08, 0x08, 0x08, 0x00, 0x20, 0x22, 0x24,
    0x00, 0x06, 0x80, 0xc1, 0xd3, 0x0c, 0x08, 0x08, 0x00, 0x20, 0x22, 0x25, 0x00, 0x00, 0x00, 0x80, 0xbf, 0x03, 0x00,
    0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74,
    0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20,
    0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e,
    0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67,
    0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62,
    0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x5c, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00,
    0x00, 0x00, 0x68, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82,
    0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0,
    0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5,
    0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f,
    0x68, 0x61, 0x73, 0x68, 0xcf, 0xb2, 0xff, 0xbc, 0x20, 0x01, 0x70, 0xcb, 0x1f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c,
    0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65,
    0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x01, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64,
    0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69,
    0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x1b, 0x55, 0x2d, 0x65, 0xcc,
    0x7d, 0x3c, 0x07, 0xcf, 0xce, 0x39, 0xf0, 0x44, 0xc6, 0x87, 0xbb, 0x36, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77,
    0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f,
    0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73,
    0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1d, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69,
    0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63,
    0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x14,
    0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x26, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f,
    0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f,
    0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e,
    0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa,
    0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73,
    0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64,
    0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e,
    0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f,
    0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0x00, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72,
    0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73,
    0x93, 0x08, 0x08, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae,
    0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65,
    0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xb9, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76,
    0x67, 0x70, 0x72, 0x5f, 0x73, 0x61, 0x76, 0x65, 0x64, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x00, 0xa9, 0x2e, 0x77,
    0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72,
    0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65,
    0x73, 0x73, 0xc2, 0xaf, 0x2e, 0x77, 0x67, 0x5f, 0x72, 0x6f, 0x75, 0x6e, 0x64, 0x5f, 0x72, 0x6f, 0x62, 0x69, 0x6e,
    0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x03, 0xa8, 0x2e, 0x65, 0x78, 0x63,
    0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad,
    0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61,
    0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65,
    0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d,
    0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0xdf, 0x96, 0x5a, 0x10, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74,
    0x65, 0x72, 0x73, 0x81, 0xcd, 0x2e, 0x42, 0x00, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xaa, 0x4d, 0x73, 0x61, 0x61,
    0x52, 0x54, 0x43, 0x6f, 0x70, 0x79, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69,
    0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa7, 0xc3, 0x18, 0x28, 0xcb, 0xff,
    0x9e, 0x1d, 0xcf, 0x6b, 0xf7, 0xb7, 0xd0, 0xb6, 0x40, 0xfc, 0xc2, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
    0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67,
    0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x01, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f,
    0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67,
    0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65,
    0x6e, 0xc2, 0xb0, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x65, 0x6e,
    0xc2, 0xad, 0x2e, 0x78, 0x5f, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xad, 0x2e, 0x79,
    0x5f, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73,
    0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c, 0x0a,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x0a, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe2, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x32, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5d,
    0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa5, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x04, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

// Table of compute pipeline binaries for 10_1_0
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable10_1_0[] =
{
    {MsaaDSCopy_Cs_0DCD1401,  sizeof(MsaaDSCopy_Cs_0DCD1401)},
    {MsaaRTCopy_Cs_0DCD1401,  sizeof(MsaaRTCopy_Cs_0DCD1401)},
};

// Table of compute pipeline binaries for 10_3_0
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable10_3_0[] =
{
    {MsaaDSCopy_Cs_857A9C8A,  sizeof(MsaaDSCopy_Cs_857A9C8A)},
    {MsaaRTCopy_Cs_857A9C8A,  sizeof(MsaaRTCopy_Cs_857A9C8A)},
};

// Table of compute pipeline binaries for 11_0_0
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable11_0_0[] =
{
    {MsaaDSCopy_Cs_F3CDD6F8,  sizeof(MsaaDSCopy_Cs_F3CDD6F8)},
    {MsaaRTCopy_Cs_F3CDD6F8,  sizeof(MsaaRTCopy_Cs_F3CDD6F8)},
};

// Table of compute pipeline binaries for 11_0_3
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable11_0_3[] =
{
    {MsaaDSCopy_Cs_519251A5,  sizeof(MsaaDSCopy_Cs_519251A5)},
    {MsaaRTCopy_Cs_519251A5,  sizeof(MsaaRTCopy_Cs_519251A5)},
};

#if  PAL_BUILD_STRIX_HALO
// Table of compute pipeline binaries for 11_5_1
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable11_5_1[] =
{
    {MsaaDSCopy_Cs_F3CDD6F8,  sizeof(MsaaDSCopy_Cs_F3CDD6F8)},
    {MsaaRTCopy_Cs_F3CDD6F8,  sizeof(MsaaRTCopy_Cs_F3CDD6F8)},
};
#endif

#if PAL_BUILD_GFX12 && PAL_BUILD_NAVI48
// Table of compute pipeline binaries for 12_0_1
inline constexpr PipelineBinary msaaImageCopyComputeBinaryTable12_0_1[] =
{
    {MsaaDSCopy_Cs_4AC1E1C2,  sizeof(MsaaDSCopy_Cs_4AC1E1C2)},
    {MsaaRTCopy_Cs_4AC1E1C2,  sizeof(MsaaRTCopy_Cs_4AC1E1C2)},
};
#endif

} // MsaaImageCopy
} // GpuUtil
