/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

#include "pal.h"

namespace GpuUtil
{
namespace TimeGraphDraw
{

struct PipelineBinary
{
    const void* pBuffer;
    size_t size;
};

// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_0DCD1401[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb4, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x8c, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x03, 0x03, 0x81, 0xbe, 0x04, 0x03, 0x82, 0xbe, 0x05, 0x03, 0x83, 0xbe, 0x04, 0x00, 0x46, 0xd7, 0x0a, 0x0c,
    0x01, 0x04, 0xc1, 0x09, 0x04, 0x80, 0x04, 0x08, 0x88, 0x7d, 0x6a, 0x3c, 0x84, 0xbe, 0xc4, 0x00, 0x88, 0xbf, 0x00,
    0x20, 0x30, 0xe0, 0x04, 0x06, 0x00, 0x80, 0x06, 0x03, 0x8a, 0xbe, 0x0d, 0x03, 0x8b, 0xbe, 0x0f, 0x00, 0x46, 0xd7,
    0x04, 0x05, 0x11, 0x04, 0x70, 0x3f, 0x8c, 0xbf, 0x80, 0x0c, 0x06, 0x7d, 0x6a, 0x3c, 0x85, 0xbe, 0x22, 0x00, 0x88,
    0xbf, 0x80, 0x0c, 0x00, 0x4c, 0x06, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x07, 0x1e, 0x0e, 0x4a, 0x01, 0x00,
    0xa1, 0xbf, 0x05, 0x03, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x05, 0x04, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x6a,
    0x3c, 0x86, 0xbe, 0x0a, 0x00, 0x88, 0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e,
    0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x08, 0x0c, 0x10, 0x4c, 0x08, 0x3f, 0x20, 0xf0, 0x07, 0x00, 0x04,
    0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x06, 0x7e, 0x7e, 0x8a, 0x0b, 0x00, 0x88, 0xbf, 0x7f, 0xc0,
    0x8c, 0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x80,
    0x02, 0x10, 0x7e, 0xe3, 0xff, 0xa3, 0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x07, 0x00, 0x04, 0x00, 0x1f, 0x0f, 0xa3, 0xbf,
    0x80, 0x00, 0x00, 0x7e, 0x05, 0x03, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0xe3, 0xff, 0xa3, 0xbf, 0x00, 0x20, 0x30,
    0xe0, 0x00, 0x04, 0x00, 0x80, 0x85, 0x1e, 0x0e, 0x4a, 0x07, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0x00, 0x55,
    0x10, 0x7e, 0x70, 0x3f, 0x8c, 0xbf, 0x04, 0x0d, 0x02, 0x4c, 0x01, 0x0b, 0x12, 0x7e, 0x09, 0x11, 0x02, 0x10, 0x80,
    0x12, 0x08, 0x7c, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x08, 0x7c, 0x0b, 0x00, 0x01, 0xd5,
    0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x06, 0xd4, 0xf2, 0x02, 0x02, 0x00, 0x05, 0x00, 0x08, 0xf4, 0x20, 0x00, 0x00,
    0xfa, 0x7f, 0xc0, 0x8c, 0xbf, 0x05, 0x03, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x05, 0x6a, 0x7e, 0x87, 0x3d, 0x00,
    0x88, 0xbf, 0xf3, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x08, 0x7e, 0x7e, 0x03, 0x86, 0xbe, 0x7e, 0x03, 0x89, 0xbe, 0x00,
    0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x07, 0x1f, 0x04, 0x7d, 0x6a, 0x3c, 0x8a, 0xbe, 0x09, 0x7e, 0x09,
    0x8a, 0x2d, 0x00, 0x84, 0xbf, 0x0a, 0x09, 0x7e, 0x87, 0x0a, 0x0d, 0x06, 0x4a, 0x80, 0x0a, 0x06, 0x7c, 0x0b, 0x1f,
    0x1e, 0x4a, 0xf3, 0x0a, 0x00, 0x06, 0x06, 0x07, 0x0c, 0x02, 0x05, 0x01, 0x04, 0x02, 0x06, 0x1f, 0x00, 0x22, 0x05,
    0x03, 0x41, 0xd5, 0x09, 0x11, 0x0a, 0x04, 0x80, 0x00, 0x06, 0x7d, 0x6a, 0x3c, 0x8a, 0xbe, 0x1e, 0x00, 0x88, 0xbf,
    0x80, 0x0c, 0x00, 0x4c, 0x06, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x07, 0x1e, 0x1a, 0x4a, 0x6a, 0x3c, 0x8b,
    0xbe, 0x0b, 0x00, 0x88, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02,
    0x06, 0x7e, 0x08, 0x0c, 0x1c, 0x4c, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x0d,
    0x00, 0x03, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0b, 0x7e, 0x7e, 0x8a, 0x0b, 0x00, 0x88, 0xbf,
    0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x7f, 0xc0, 0x8c,
    0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x0a, 0x3f, 0x20, 0xf0, 0x0d, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x1f, 0x0f,
    0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0a, 0x03, 0xfe, 0xbe, 0xcf, 0xff, 0x82, 0xbf, 0x06, 0x03, 0xfe, 0xbe, 0x05,
    0x7e, 0x7e, 0x8a, 0x3d, 0x00, 0x88, 0xbf, 0xf3, 0x02, 0x12, 0x7e, 0x07, 0x01, 0xaa, 0xd5, 0x01, 0x01, 0x00, 0x00,
    0x80, 0x02, 0x10, 0x7e, 0x7e, 0x03, 0x86, 0xbe, 0x7e, 0x03, 0x89, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x06, 0x09,
    0x04, 0x7d, 0x6a, 0x3c, 0x8a, 0xbe, 0x09, 0x7e, 0x09, 0x8a, 0x2d, 0x00, 0x84, 0xbf, 0x0a, 0x09, 0x7e, 0x87, 0x0b,
    0x1f, 0x06, 0x4a, 0x80, 0x12, 0x06, 0x7c, 0xf3, 0x12, 0x0a, 0x06, 0x0a, 0x0d, 0x0c, 0x4a, 0x0f, 0x07, 0x1e, 0x02,
    0x09, 0x0b, 0x00, 0x02, 0x06, 0x1f, 0x02, 0x22, 0x07, 0x01, 0x12, 0x06, 0x80, 0x02, 0x06, 0x7d, 0x6a, 0x3c, 0x8a,
    0xbe, 0x1f, 0x00, 0x88, 0xbf, 0x80, 0x0c, 0x00, 0x4c, 0x06, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x07, 0x1e,
    0x1a, 0x4a, 0x6a, 0x3c, 0x8b, 0xbe, 0x0c, 0x00, 0x88, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02,
    0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x08, 0x0c, 0x18, 0x4c, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf,
    0x0a, 0x3f, 0x20, 0xf0, 0x0d, 0x00, 0x03, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00,
    0x7e, 0x0b, 0x7e, 0x7e, 0x8a, 0x0b, 0x00, 0x88, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02,
    0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xe3, 0xff, 0xa3, 0xbf, 0x0a, 0x3f, 0x20, 0xf0, 0x0d,
    0x00, 0x03, 0x00, 0x08, 0x00, 0x00, 0x00, 0x1f, 0x0f, 0xa3, 0xbf, 0x80, 0x00, 0x00, 0x7e, 0x0a, 0x03, 0xfe, 0xbe,
    0xcf, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72,
    0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65,
    0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e,
    0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55,
    0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00,
    0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f,
    0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x07, 0x00, 0x00, 0x00, 0x0b, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00,
    0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03,
    0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91,
    0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63,
    0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f, 0xb0, 0x2e, 0x73, 0x70,
    0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75,
    0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68,
    0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61,
    0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa9, 0x75, 0x50,
    0xc6, 0xc3, 0x40, 0xeb, 0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf,
    0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b,
    0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67,
    0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70,
    0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75,
    0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e,
    0x74, 0x18, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xa9, 0x2e, 0x6c, 0x64,
    0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65,
    0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e,
    0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b,
    0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65,
    0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65,
    0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74,
    0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65,
    0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72,
    0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x20, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74,
    0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75,
    0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xab, 0x2e, 0x66,
    0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f,
    0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65,
    0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f,
    0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72,
    0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73,
    0x0a, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63,
    0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74,
    0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00,
    0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68,
    0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x12, 0xb5, 0xb3, 0xdf, 0xaa, 0x2e,
    0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd,
    0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06,
    0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65, 0x47, 0x72, 0x61, 0x70,
    0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e,
    0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b, 0x28, 0x0b, 0xcf, 0x4e, 0x7e,
    0x47, 0xef, 0x7c, 0x7c, 0x52, 0xd1, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67,
    0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70,
    0x5f, 0x63, 0x6e, 0x74, 0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e,
    0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f,
    0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61,
    0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x48, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xbe, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xce, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x05, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28,
    0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x49, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_857A9C8A[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x64, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x04, 0x40, 0x80, 0xb0, 0x80, 0x1f, 0x8c, 0xbe, 0x03, 0x00, 0xa0, 0xbf, 0x02, 0x03, 0x80,
    0xbe, 0x03, 0x03, 0x81, 0xbe, 0x04, 0x03, 0x82, 0xbe, 0x05, 0x03, 0x83, 0xbe, 0x04, 0x00, 0x46, 0xd7, 0x0a, 0x0c,
    0x01, 0x04, 0xc1, 0x09, 0x04, 0x80, 0x7e, 0x03, 0x85, 0xbe, 0x7e, 0x00, 0xd4, 0xd4, 0x04, 0x08, 0x02, 0x00, 0xaf,
    0x00, 0x88, 0xbf, 0x00, 0x20, 0x30, 0xe0, 0x04, 0x06, 0x00, 0x80, 0x06, 0x03, 0x8a, 0xbe, 0x0d, 0x03, 0x8b, 0xbe,
    0x0f, 0x00, 0x46, 0xd7, 0x04, 0x05, 0x11, 0x04, 0x7e, 0x03, 0x84, 0xbe, 0x70, 0x3f, 0x8c, 0xbf, 0x7e, 0x00, 0x96,
    0xd4, 0x06, 0x01, 0x01, 0x00, 0x1c, 0x00, 0x88, 0xbf, 0x80, 0x0c, 0x00, 0x4c, 0x06, 0x01, 0x00, 0x24, 0x08, 0x00,
    0x08, 0x7d, 0x07, 0x1e, 0x0e, 0x4a, 0x05, 0x03, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x05, 0x04, 0x0c, 0xf4, 0x00,
    0x00, 0x00, 0xfa, 0x6a, 0x3c, 0x86, 0xbe, 0x08, 0x00, 0x88, 0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x0c, 0x02, 0x00, 0x7e,
    0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x08, 0x0c, 0x10, 0x4c, 0x08, 0x3f, 0x20,
    0xf0, 0x07, 0x00, 0x04, 0x00, 0x06, 0x7e, 0x7e, 0x8a, 0x08, 0x00, 0x88, 0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x0c, 0x02,
    0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0x08,
    0x3f, 0x20, 0xf0, 0x07, 0x00, 0x04, 0x00, 0x04, 0x03, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0x00, 0x20, 0x30, 0xe0,
    0x00, 0x04, 0x00, 0x80, 0x85, 0x1e, 0x0e, 0x4a, 0x07, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0x00, 0x55, 0x10,
    0x7e, 0x70, 0x3f, 0x8c, 0xbf, 0x04, 0x0d, 0x02, 0x4c, 0x01, 0x0b, 0x12, 0x7e, 0x09, 0x11, 0x02, 0x10, 0x80, 0x12,
    0x08, 0x7c, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x08, 0x7c, 0x0b, 0x00, 0x01, 0xd5, 0x81,
    0x82, 0xa9, 0x01, 0x6a, 0x02, 0x06, 0xd4, 0xf2, 0x02, 0x02, 0x00, 0x05, 0x00, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xfa,
    0x7f, 0xc0, 0x8c, 0xbf, 0x05, 0x03, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x04, 0x6a, 0x7e, 0x87, 0x36, 0x00, 0x88,
    0xbf, 0xf3, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x08, 0x7e, 0x7e, 0x03, 0x86, 0xbe, 0x7e, 0x03, 0x89, 0xbe, 0x00, 0x00,
    0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x03, 0x8a, 0xbe, 0x7e,
    0x00, 0x92, 0xd4, 0x07, 0x1f, 0x02, 0x00, 0x09, 0x7e, 0x09, 0x8a, 0x28, 0x00, 0x84, 0xbf, 0x0a, 0x09, 0x7e, 0x87,
    0x0a, 0x0d, 0x06, 0x4a, 0xf3, 0x0a, 0x00, 0x06, 0x80, 0x0a, 0x06, 0x7c, 0x0b, 0x1f, 0x1e, 0x4a, 0x06, 0x07, 0x0c,
    0x02, 0x05, 0x01, 0x04, 0x02, 0x06, 0x1f, 0x00, 0x22, 0x05, 0x03, 0x4b, 0xd5, 0x09, 0x11, 0x0a, 0x04, 0x7e, 0x03,
    0x8a, 0xbe, 0x7e, 0x00, 0x96, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x18, 0x00, 0x88, 0xbf, 0x80, 0x0c, 0x00, 0x4c, 0x06,
    0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x07, 0x1e, 0x1a, 0x4a, 0x6a, 0x3c, 0x8b, 0xbe, 0x08, 0x00, 0x88, 0xbf,
    0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x08, 0x0c, 0x1c,
    0x4c, 0x7f, 0xc0, 0x8c, 0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x0d, 0x00, 0x03, 0x00, 0x0b, 0x7e, 0x7e, 0x8a, 0x08, 0x00,
    0x88, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x7f,
    0xc0, 0x8c, 0xbf, 0x0a, 0x3f, 0x20, 0xf0, 0x0d, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x0a, 0x03, 0xfe, 0xbe,
    0xd3, 0xff, 0x82, 0xbf, 0x06, 0x03, 0xfe, 0xbe, 0x04, 0x7e, 0x7e, 0x8a, 0x35, 0x00, 0x88, 0xbf, 0xf3, 0x02, 0x12,
    0x7e, 0x07, 0x01, 0xaa, 0xd5, 0x01, 0x01, 0x00, 0x00, 0x80, 0x02, 0x10, 0x7e, 0x7e, 0x03, 0x86, 0xbe, 0x7e, 0x03,
    0x89, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x03, 0x8a, 0xbe, 0x7e, 0x00, 0x92, 0xd4, 0x06,
    0x09, 0x02, 0x00, 0x09, 0x7e, 0x09, 0x8a, 0x28, 0x00, 0x84, 0xbf, 0x0a, 0x09, 0x7e, 0x87, 0x0b, 0x1f, 0x06, 0x4a,
    0xf3, 0x12, 0x0a, 0x06, 0x80, 0x12, 0x06, 0x7c, 0x0a, 0x0d, 0x0c, 0x4a, 0x0f, 0x07, 0x1e, 0x02, 0x09, 0x0b, 0x00,
    0x02, 0x06, 0x1f, 0x02, 0x22, 0x07, 0x01, 0x12, 0x06, 0x7e, 0x03, 0x8a, 0xbe, 0x7e, 0x00, 0x96, 0xd4, 0x01, 0x01,
    0x01, 0x00, 0x19, 0x00, 0x88, 0xbf, 0x80, 0x0c, 0x00, 0x4c, 0x06, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x07,
    0x1e, 0x1a, 0x4a, 0x6a, 0x3c, 0x8b, 0xbe, 0x09, 0x00, 0x88, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e,
    0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x08, 0x0c, 0x18, 0x4c, 0x7f, 0xc0, 0x8c, 0xbf, 0x0a, 0x3f, 0x20,
    0xf0, 0x0d, 0x00, 0x03, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x0b, 0x7e, 0x7e, 0x8a, 0x08, 0x00, 0x88, 0xbf, 0x00, 0x02,
    0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x0a,
    0x3f, 0x20, 0xf0, 0x0d, 0x00, 0x03, 0x00, 0x08, 0x00, 0x00, 0x00, 0x0a, 0x03, 0xfe, 0xbe, 0xd3, 0xff, 0x82, 0xbf,
    0x00, 0x00, 0x81, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64,
    0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69,
    0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20,
    0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61,
    0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64,
    0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75,
    0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00,
    0x0b, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61,
    0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d,
    0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74,
    0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61,
    0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa9, 0x75, 0x50, 0xc6, 0xc3, 0x40, 0xeb,
    0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61,
    0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e,
    0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3,
    0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74,
    0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f,
    0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0xab, 0x2e,
    0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69,
    0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74,
    0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f,
    0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64,
    0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63,
    0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x20, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65,
    0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69,
    0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74,
    0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66,
    0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77,
    0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72,
    0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65,
    0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73, 0x67, 0x70, 0x72, 0x73, 0x0a, 0xa8, 0x2e, 0x65,
    0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e,
    0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73,
    0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61,
    0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73,
    0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x12, 0xb5, 0xb3, 0xdf, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd,
    0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07,
    0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69,
    0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61,
    0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b, 0x28, 0x0b, 0xcf, 0x41, 0x1c, 0x3f, 0xed, 0xf1, 0xa1,
    0x24, 0x92, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65,
    0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74,
    0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64,
    0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab,
    0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73,
    0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x04,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xce, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf9, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_F3CDD6F8[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb8, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x8c, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x03, 0x00, 0x81, 0xbe, 0x04, 0x00, 0x82, 0xbe, 0x05, 0x00, 0x83, 0xbe, 0xff, 0x00, 0x00, 0x36, 0xff, 0x03,
    0x00, 0x00, 0xc1, 0x09, 0x04, 0x80, 0xa1, 0x00, 0x87, 0xbf, 0x04, 0x00, 0x46, 0xd6, 0x0a, 0x0c, 0x01, 0x04, 0x7e,
    0x01, 0x8a, 0xbe, 0x7e, 0x00, 0xcc, 0xd4, 0x04, 0x08, 0x02, 0x00, 0xbf, 0x00, 0xa5, 0xbf, 0x00, 0x00, 0x50, 0xe0,
    0x04, 0x0e, 0x80, 0x80, 0x06, 0x00, 0x84, 0xbe, 0x0d, 0x00, 0x85, 0xbe, 0x0f, 0x00, 0x46, 0xd6, 0x04, 0x05, 0x11,
    0x04, 0x7e, 0x01, 0x8c, 0xbe, 0xf7, 0x03, 0x89, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x0e, 0x01, 0x01, 0x00, 0x1d, 0x00,
    0xa5, 0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07,
    0x1e, 0x0e, 0x4a, 0x02, 0x04, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x02, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02,
    0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x10, 0x4c, 0x84, 0x4f, 0x18, 0xf0, 0x07, 0x00,
    0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11,
    0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0x84, 0x4f, 0x18, 0xf0,
    0x07, 0x00, 0x05, 0x00, 0x0c, 0x01, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0x00, 0x00, 0x50, 0xe0, 0x00, 0x07, 0x80,
    0x80, 0x85, 0x1e, 0x08, 0x4a, 0x91, 0x00, 0x87, 0xbf, 0x04, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0xb1, 0x00,
    0x87, 0xbf, 0x00, 0x55, 0x04, 0x7e, 0xf7, 0x03, 0x89, 0xbf, 0x07, 0x1d, 0x02, 0x4c, 0x01, 0x0b, 0x02, 0x7e, 0x9f,
    0x0f, 0x88, 0xbf, 0x85, 0x00, 0x87, 0xbf, 0x01, 0x05, 0x10, 0x10, 0x80, 0x02, 0x28, 0x7c, 0x09, 0x00, 0x01, 0xd5,
    0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x28, 0x7c, 0x04, 0x00, 0x87, 0xbf, 0x00, 0x02, 0x16, 0xd4, 0xf2, 0x10, 0x02,
    0x00, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x07, 0xfc, 0x89, 0xbf, 0x02, 0x04, 0x08, 0xf4, 0x20, 0x00,
    0x00, 0xf8, 0x02, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x0c, 0x00, 0xfe, 0x8b, 0x39, 0x00, 0xa5, 0xbf, 0xf3,
    0x02, 0x0c, 0x7e, 0x80, 0x02, 0x0e, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x82, 0xbe, 0x00, 0x00, 0x80, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01, 0x84, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x04, 0x1f, 0x02,
    0x00, 0x02, 0x7e, 0x82, 0x91, 0x2c, 0x00, 0xa1, 0xbf, 0x04, 0x02, 0xfe, 0x8b, 0x09, 0x1d, 0x0a, 0x4a, 0xf3, 0x0c,
    0x04, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x0a, 0x1f, 0x1e, 0x4a, 0x14, 0x02, 0x87, 0xbf, 0x0e, 0x0b, 0x1c, 0x02, 0x06,
    0x05, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00, 0x22, 0x06, 0x01, 0x03, 0xd5, 0x08, 0x05, 0x02, 0x00,
    0x7e, 0x01, 0x84, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x19, 0x00, 0xa5,
    0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e,
    0x18, 0x4a, 0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11,
    0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a, 0x4c, 0x84, 0x4f, 0x18, 0xf0,
    0x0c, 0x00, 0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00,
    0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x85, 0x4f, 0x18, 0xf0, 0x0c, 0x00,
    0x05, 0x00, 0x07, 0x00, 0x00, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0xcf, 0xff, 0xa0, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x0c,
    0x7e, 0xfe, 0x91, 0x3c, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c, 0x7e, 0x04, 0x01, 0xaa, 0xd5, 0x08, 0x01, 0x00, 0x00,
    0x80, 0x02, 0x10, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x82, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01,
    0x84, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x0e, 0x0f, 0x02, 0x00, 0x02, 0x7e, 0x82, 0x91, 0x2b, 0x00, 0xa1, 0xbf, 0x04,
    0x02, 0xfe, 0x8b, 0x0a, 0x1f, 0x06, 0x4a, 0xf3, 0x0c, 0x00, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x23, 0x02, 0x87, 0xbf,
    0x0f, 0x07, 0x1e, 0x02, 0x09, 0x1d, 0x1c, 0x4a, 0x06, 0x01, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00,
    0x22, 0x04, 0x05, 0x0c, 0x06, 0x7e, 0x01, 0x84, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01,
    0x01, 0x00, 0x19, 0x00, 0xa5, 0xbf, 0x80, 0x1c, 0x00, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x01, 0x00, 0x24, 0x08,
    0x00, 0x88, 0x7c, 0x07, 0x1e, 0x18, 0x4a, 0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf,
    0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a,
    0x4c, 0x84, 0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc,
    0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x85,
    0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x05, 0x00, 0x08, 0x00, 0x00, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0xd0, 0xff, 0xa0, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47,
    0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76,
    0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73,
    0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79,
    0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65,
    0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e,
    0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00,
    0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
    0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0b, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44,
    0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69,
    0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69,
    0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73,
    0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f,
    0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff,
    0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08,
    0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65,
    0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92,
    0xcf, 0xa9, 0x75, 0x50, 0xc6, 0xc3, 0x40, 0xeb, 0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1,
    0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3,
    0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65,
    0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f,
    0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74,
    0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6f, 0x75, 0x6e, 0x74, 0x1c, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10,
    0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63,
    0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f,
    0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e,
    0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00,
    0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e,
    0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61,
    0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64,
    0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01,
    0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70,
    0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f,
    0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d,
    0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72,
    0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73,
    0x67, 0x70, 0x72, 0x73, 0x0a, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63,
    0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65,
    0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00,
    0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x12, 0xb5,
    0xb3, 0xdf, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00, 0xcd,
    0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05,
    0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65,
    0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70,
    0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b, 0x28,
    0x0b, 0xcf, 0x63, 0x90, 0x9a, 0x36, 0x64, 0x8a, 0x8a, 0x70, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65,
    0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f,
    0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65,
    0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67, 0x69,
    0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e,
    0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc2, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x22, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4d, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x95, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_519251A5[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xa4, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x8c, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x03, 0x00, 0x81, 0xbe, 0x04, 0x00, 0x82, 0xbe, 0x05, 0x00, 0x83, 0xbe, 0xff, 0x00, 0x00, 0x36, 0xff, 0x03,
    0x00, 0x00, 0xc1, 0x09, 0x04, 0x80, 0xa1, 0x00, 0x87, 0xbf, 0x04, 0x00, 0x46, 0xd6, 0x0a, 0x0c, 0x01, 0x04, 0x7e,
    0x01, 0x8a, 0xbe, 0x7e, 0x00, 0xcc, 0xd4, 0x04, 0x08, 0x02, 0x00, 0xbf, 0x00, 0xa5, 0xbf, 0x00, 0x00, 0x50, 0xe0,
    0x04, 0x0e, 0x80, 0x80, 0x06, 0x00, 0x84, 0xbe, 0x0d, 0x00, 0x85, 0xbe, 0x0f, 0x00, 0x46, 0xd6, 0x04, 0x05, 0x11,
    0x04, 0x7e, 0x01, 0x8c, 0xbe, 0xf7, 0x03, 0x89, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x0e, 0x01, 0x01, 0x00, 0x1d, 0x00,
    0xa5, 0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07,
    0x1e, 0x0e, 0x4a, 0x02, 0x04, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x02, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02,
    0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x10, 0x4c, 0x84, 0x4f, 0x18, 0xf0, 0x07, 0x00,
    0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11,
    0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0x84, 0x4f, 0x18, 0xf0,
    0x07, 0x00, 0x05, 0x00, 0x0c, 0x01, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0x00, 0x00, 0x50, 0xe0, 0x00, 0x07, 0x80,
    0x80, 0x85, 0x1e, 0x08, 0x4a, 0x91, 0x00, 0x87, 0xbf, 0x04, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0xb1, 0x00,
    0x87, 0xbf, 0x00, 0x55, 0x04, 0x7e, 0xf7, 0x03, 0x89, 0xbf, 0x07, 0x1d, 0x02, 0x4c, 0x01, 0x0b, 0x02, 0x7e, 0x9f,
    0x0f, 0x88, 0xbf, 0x85, 0x00, 0x87, 0xbf, 0x01, 0x05, 0x10, 0x10, 0x80, 0x02, 0x28, 0x7c, 0x09, 0x00, 0x01, 0xd5,
    0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x28, 0x7c, 0x04, 0x00, 0x87, 0xbf, 0x00, 0x02, 0x16, 0xd4, 0xf2, 0x10, 0x02,
    0x00, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x07, 0xfc, 0x89, 0xbf, 0x02, 0x04, 0x08, 0xf4, 0x20, 0x00,
    0x00, 0xf8, 0x02, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x0c, 0x00, 0xfe, 0x8b, 0x39, 0x00, 0xa5, 0xbf, 0xf3,
    0x02, 0x0c, 0x7e, 0x80, 0x02, 0x0e, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x82, 0xbe, 0x00, 0x00, 0x80, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01, 0x84, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x04, 0x1f, 0x02,
    0x00, 0x02, 0x7e, 0x82, 0x91, 0x2c, 0x00, 0xa1, 0xbf, 0x04, 0x02, 0xfe, 0x8b, 0x09, 0x1d, 0x0a, 0x4a, 0xf3, 0x0c,
    0x04, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x0a, 0x1f, 0x1e, 0x4a, 0x14, 0x02, 0x87, 0xbf, 0x0e, 0x0b, 0x1c, 0x02, 0x06,
    0x05, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00, 0x22, 0x06, 0x01, 0x03, 0xd5, 0x08, 0x05, 0x02, 0x00,
    0x7e, 0x01, 0x84, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x19, 0x00, 0xa5,
    0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e,
    0x18, 0x4a, 0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11,
    0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a, 0x4c, 0x84, 0x4f, 0x18, 0xf0,
    0x0c, 0x00, 0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00,
    0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x85, 0x4f, 0x18, 0xf0, 0x0c, 0x00,
    0x05, 0x00, 0x07, 0x00, 0x00, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0xcf, 0xff, 0xa0, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x0c,
    0x7e, 0xfe, 0x91, 0x3c, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c, 0x7e, 0x04, 0x01, 0xaa, 0xd5, 0x08, 0x01, 0x00, 0x00,
    0x80, 0x02, 0x10, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x82, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01,
    0x84, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x0e, 0x0f, 0x02, 0x00, 0x02, 0x7e, 0x82, 0x91, 0x2b, 0x00, 0xa1, 0xbf, 0x04,
    0x02, 0xfe, 0x8b, 0x0a, 0x1f, 0x06, 0x4a, 0xf3, 0x0c, 0x00, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x23, 0x02, 0x87, 0xbf,
    0x0f, 0x07, 0x1e, 0x02, 0x09, 0x1d, 0x1c, 0x4a, 0x06, 0x01, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00,
    0x22, 0x04, 0x05, 0x0c, 0x06, 0x7e, 0x01, 0x84, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01,
    0x01, 0x00, 0x19, 0x00, 0xa5, 0xbf, 0x80, 0x1c, 0x00, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x01, 0x00, 0x24, 0x08,
    0x00, 0x88, 0x7c, 0x07, 0x1e, 0x18, 0x4a, 0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf,
    0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a,
    0x4c, 0x84, 0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc,
    0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x85,
    0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x05, 0x00, 0x08, 0x00, 0x00, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0xd0, 0xff, 0xa0, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47,
    0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76,
    0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73,
    0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79,
    0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65,
    0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e,
    0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00,
    0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
    0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0xf6, 0x03, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44,
    0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69,
    0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69,
    0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73,
    0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f,
    0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff,
    0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08,
    0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65,
    0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92,
    0xcf, 0xa9, 0x75, 0x50, 0xc6, 0xc3, 0x40, 0xeb, 0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1,
    0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3,
    0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65,
    0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f,
    0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1a, 0xb3, 0x2e, 0x65, 0x6e, 0x74,
    0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6f, 0x75, 0x6e, 0x74, 0x1c, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10,
    0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63,
    0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f,
    0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e,
    0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00,
    0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e,
    0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61,
    0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64,
    0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01,
    0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70,
    0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f,
    0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d,
    0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72,
    0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73,
    0x67, 0x70, 0x72, 0x73, 0x0a, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63,
    0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65,
    0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00,
    0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43,
    0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e,
    0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65, 0x47, 0x72,
    0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c,
    0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b, 0x28, 0x0b, 0xcf,
    0x99, 0xc2, 0xfa, 0x41, 0x6e, 0x30, 0x00, 0x48, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x5f, 0x72,
    0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f, 0x63, 0x6f,
    0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65, 0x6e, 0xc3,
    0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f,
    0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e, 0xc2, 0xa4,
    0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xc2, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x22, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4d, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x95, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_20DE282F[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb8, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x43, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x06, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x8c, 0xbe, 0x03, 0x00, 0x84, 0xbf, 0x02, 0x00, 0x80,
    0xbe, 0x03, 0x00, 0x81, 0xbe, 0x04, 0x00, 0x82, 0xbe, 0x05, 0x00, 0x83, 0xbe, 0xff, 0x00, 0x00, 0x36, 0xff, 0x03,
    0x00, 0x00, 0xc1, 0x09, 0x04, 0x80, 0xa1, 0x00, 0x87, 0xbf, 0x04, 0x00, 0x46, 0xd6, 0x0a, 0x0c, 0x01, 0x04, 0x7e,
    0x01, 0x8a, 0xbe, 0x7e, 0x00, 0xcc, 0xd4, 0x04, 0x08, 0x02, 0x00, 0xbf, 0x00, 0xa5, 0xbf, 0x00, 0x00, 0x50, 0xe0,
    0x04, 0x0e, 0x80, 0x80, 0x06, 0x00, 0x84, 0xbe, 0x0d, 0x00, 0x85, 0xbe, 0x0f, 0x00, 0x46, 0xd6, 0x04, 0x05, 0x11,
    0x04, 0x7e, 0x01, 0x8c, 0xbe, 0xf7, 0x03, 0x89, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x0e, 0x01, 0x01, 0x00, 0x1d, 0x00,
    0xa5, 0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07,
    0x1e, 0x0e, 0x4a, 0x02, 0x04, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x02, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x6a, 0x21, 0x8e, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02,
    0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x10, 0x4c, 0x84, 0x4f, 0x18, 0xf0, 0x07, 0x00,
    0x05, 0x00, 0x0e, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x07, 0xfc, 0x89, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11,
    0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0x84, 0x4f, 0x18, 0xf0,
    0x07, 0x00, 0x05, 0x00, 0x0c, 0x01, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0x00, 0x00, 0x50, 0xe0, 0x00, 0x07, 0x80,
    0x80, 0x85, 0x1e, 0x08, 0x4a, 0x91, 0x00, 0x87, 0xbf, 0x04, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0xb1, 0x00,
    0x87, 0xbf, 0x00, 0x55, 0x04, 0x7e, 0xf7, 0x03, 0x89, 0xbf, 0x07, 0x1d, 0x02, 0x4c, 0x01, 0x0b, 0x02, 0x7e, 0x85,
    0x00, 0x87, 0xbf, 0x01, 0x05, 0x10, 0x10, 0x80, 0x02, 0x28, 0x7c, 0x09, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01,
    0x80, 0x00, 0x28, 0x7c, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x16, 0xd4, 0xf2, 0x10, 0x02,
    0x00, 0x02, 0x00, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x07, 0xfc, 0x89, 0xbf, 0x02, 0x04, 0x0c, 0xf4, 0x00, 0x00,
    0x00, 0xf8, 0x0c, 0x6a, 0xfe, 0x8b, 0x3b, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c, 0x7e, 0x80, 0x02, 0x0e, 0x7e, 0x7e,
    0x01, 0x84, 0xbe, 0x7e, 0x01, 0x8e, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01, 0x98, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x04, 0x1f, 0x02,
    0x00, 0x0e, 0x7e, 0x8e, 0x91, 0x2c, 0x00, 0xa1, 0xbf, 0x18, 0x0e, 0xfe, 0x8b, 0x09, 0x1d, 0x0a, 0x4a, 0xf3, 0x0c,
    0x04, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x0a, 0x1f, 0x1e, 0x4a, 0x14, 0x02, 0x87, 0xbf, 0x0e, 0x0b, 0x1c, 0x02, 0x06,
    0x05, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00, 0x22, 0x06, 0x01, 0x03, 0xd5, 0x08, 0x05, 0x02, 0x00,
    0x7e, 0x01, 0x98, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x19, 0x00, 0xa5,
    0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e,
    0x18, 0x4a, 0x6a, 0x21, 0x9a, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02,
    0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a, 0x4c, 0x07, 0xfc, 0x89, 0xbf, 0x84, 0x4f, 0x18, 0xf0,
    0x0c, 0x00, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x00, 0x02, 0x00, 0x7e, 0x01, 0x02, 0x02,
    0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x85, 0x4f, 0x18, 0xf0, 0x0c, 0x00,
    0x04, 0x00, 0x07, 0x00, 0x00, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xcf, 0xff, 0xa0, 0xbf, 0x04, 0x01, 0xfe, 0xbe, 0x0c,
    0x7e, 0xfe, 0x91, 0x3c, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c, 0x7e, 0x04, 0x01, 0xaa, 0xd5, 0x08, 0x01, 0x00, 0x00,
    0x80, 0x02, 0x10, 0x7e, 0x7e, 0x01, 0x84, 0xbe, 0x7e, 0x01, 0x8e, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x7e, 0x01,
    0x98, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x0e, 0x0f, 0x02, 0x00, 0x0e, 0x7e, 0x8e, 0x91, 0x2b, 0x00, 0xa1, 0xbf, 0x18,
    0x0e, 0xfe, 0x8b, 0x0a, 0x1f, 0x06, 0x4a, 0xf3, 0x0c, 0x00, 0x06, 0x80, 0x0c, 0x26, 0x7c, 0x09, 0x1d, 0x1c, 0x4a,
    0x14, 0x02, 0x87, 0xbf, 0x0f, 0x07, 0x1e, 0x02, 0x06, 0x01, 0x04, 0x02, 0x12, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00,
    0x22, 0x04, 0x05, 0x0c, 0x06, 0x7e, 0x01, 0x98, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01,
    0x01, 0x00, 0x19, 0x00, 0xa5, 0xbf, 0x80, 0x1c, 0x00, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x01, 0x00, 0x24, 0x08,
    0x00, 0x88, 0x7c, 0x07, 0x1e, 0x18, 0x4a, 0x6a, 0x21, 0x9a, 0xbe, 0x08, 0x00, 0xa5, 0xbf, 0x00, 0x02, 0x00, 0x7e,
    0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a, 0x4c, 0x07, 0xfc, 0x89,
    0xbf, 0x84, 0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x00, 0x02,
    0x00, 0x7e, 0x01, 0x02, 0x02, 0x7e, 0x02, 0x02, 0x04, 0x7e, 0x03, 0x02, 0x06, 0x7e, 0x07, 0xfc, 0x89, 0xbf, 0x85,
    0x4f, 0x18, 0xf0, 0x0c, 0x00, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd0, 0xff, 0xa0, 0xbf,
    0x00, 0x00, 0x80, 0xbf, 0x03, 0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47,
    0x65, 0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76,
    0x61, 0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73,
    0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79,
    0x20, 0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65,
    0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e,
    0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00,
    0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
    0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x0b, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44,
    0x47, 0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69,
    0x6f, 0x6e, 0x92, 0x03, 0x06, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69,
    0x6e, 0x65, 0x73, 0x91, 0x8b, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73,
    0x6f, 0x75, 0x72, 0x63, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f,
    0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff,
    0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08,
    0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65,
    0x83, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92,
    0xcf, 0xa9, 0x75, 0x50, 0xc6, 0xc3, 0x40, 0xeb, 0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1,
    0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3,
    0x2e, 0x63, 0x73, 0xaf, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65,
    0xa7, 0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f,
    0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1b, 0xb3, 0x2e, 0x65, 0x6e, 0x74,
    0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d,
    0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6f, 0x75, 0x6e, 0x74, 0x1c, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10,
    0xa9, 0x2e, 0x6c, 0x64, 0x73, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63,
    0x68, 0x5f, 0x6d, 0x65, 0x6d, 0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f,
    0x6e, 0x74, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e,
    0x62, 0x61, 0x63, 0x6b, 0x65, 0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00,
    0xb6, 0x2e, 0x70, 0x65, 0x72, 0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f,
    0x73, 0x69, 0x7a, 0x65, 0x00, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e,
    0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f,
    0x61, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61,
    0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72,
    0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64,
    0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01,
    0x01, 0xab, 0x2e, 0x66, 0x6c, 0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70,
    0x31, 0x36, 0x5f, 0x6f, 0x76, 0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f,
    0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2, 0xac, 0x2e, 0x6d,
    0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72, 0x77, 0x61, 0x72,
    0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x73,
    0x67, 0x70, 0x72, 0x73, 0x0a, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73, 0x63,
    0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72, 0x65,
    0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f,
    0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65, 0x00,
    0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x12, 0xb5,
    0xb3, 0xdf, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00, 0xcd,
    0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05,
    0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65,
    0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70,
    0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b, 0x28,
    0x0b, 0xcf, 0xd6, 0x8e, 0x62, 0xec, 0xa4, 0xb0, 0x52, 0x70, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65,
    0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x85, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67, 0x5f,
    0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f, 0x65,
    0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67, 0x69,
    0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65, 0x6e,
    0xc2, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73, 0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc2, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x22, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4d, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x95, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

#if (PAL_BUILD_GFX12&& 0) || (PAL_BUILD_GFX12&& PAL_BUILD_NAVI48) || (PAL_BUILD_GFX12&& (PAL_BUILD_NAVI48&& 0)) || (PAL_BUILD_GFX12&& (0 && 0))
// Time Graph compute shader binary
inline constexpr Util::uint8 TimeGraph_Cs_4AC1E1C2[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x48, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x09, 0x20, 0x80, 0xb0, 0x80, 0x47, 0x8c, 0xbe, 0x09, 0x00, 0x87, 0xbf, 0x0d, 0x0f, 0x81,
    0xbe, 0x02, 0x00, 0x8c, 0xbe, 0x03, 0x00, 0x8d, 0xbe, 0x04, 0x00, 0x8e, 0xbe, 0x05, 0x00, 0x8f, 0xbe, 0xff, 0x00,
    0x00, 0x36, 0xff, 0x03, 0x00, 0x00, 0xc1, 0x09, 0x00, 0x80, 0xa1, 0x00, 0x87, 0xbf, 0x04, 0x00, 0x0b, 0xd6, 0x75,
    0x80, 0x01, 0x04, 0x7e, 0x01, 0x82, 0xbe, 0x7e, 0x00, 0xcc, 0xd4, 0x00, 0x08, 0x02, 0x00, 0xcb, 0x00, 0xa5, 0xbf,
    0x7c, 0x00, 0x05, 0xc4, 0x0e, 0x18, 0x00, 0x80, 0x04, 0x00, 0x00, 0x00, 0x06, 0x00, 0x80, 0xbe, 0x0f, 0x00, 0x46,
    0xd6, 0x04, 0x05, 0x11, 0x04, 0x00, 0x00, 0xc0, 0xbf, 0x80, 0x1c, 0x86, 0x7c, 0x00, 0xa0, 0x04, 0xf4, 0x23, 0x00,
    0x00, 0xf8, 0x00, 0xa0, 0x04, 0xf4, 0x16, 0x00, 0x00, 0xf8, 0x6a, 0x21, 0x84, 0xbe, 0x1f, 0x00, 0xa5, 0xbf, 0x80,
    0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e, 0x0e, 0x4a,
    0x00, 0x44, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x00, 0x65, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8, 0x6a, 0x21, 0x8a,
    0xbe, 0x09, 0x00, 0xa5, 0xbf, 0x00, 0x00, 0xc7, 0xbf, 0x10, 0x02, 0x00, 0x7e, 0x11, 0x02, 0x02, 0x7e, 0x12, 0x02,
    0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x08, 0x1c, 0x10, 0x4c, 0x01, 0x80, 0xc1, 0xd3, 0x00, 0x28, 0x08, 0x00, 0x07,
    0x08, 0x00, 0x00, 0x0a, 0x7e, 0xfe, 0x91, 0x09, 0x00, 0xa5, 0xbf, 0x00, 0x00, 0xc7, 0xbf, 0x10, 0x02, 0x00, 0x7e,
    0x11, 0x02, 0x02, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x13, 0x02, 0x06, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0x01, 0x80, 0xc1,
    0xd3, 0x00, 0x28, 0x08, 0x00, 0x07, 0x08, 0x00, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0x81, 0x08, 0x00, 0x4a, 0x7c, 0x00,
    0x05, 0xc4, 0x07, 0x18, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x85, 0x1e, 0x08, 0x4a, 0x91, 0x00, 0x87, 0xbf, 0x04,
    0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0xb1, 0x00, 0x87, 0xbf, 0x00, 0x55, 0x04, 0x7e, 0x00, 0x00, 0xc0, 0xbf,
    0x07, 0x1d, 0x02, 0x4c, 0x01, 0x0b, 0x02, 0x7e, 0x85, 0x00, 0x87, 0xbf, 0x01, 0x05, 0x10, 0x10, 0x80, 0x02, 0x28,
    0x7c, 0x09, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x28, 0x7c, 0x04, 0x00, 0x87, 0xbf, 0x0a, 0x02,
    0x16, 0xd4, 0xf2, 0x10, 0x02, 0x00, 0x9d, 0xff, 0x88, 0xbf, 0x0a, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x00,
    0x43, 0x00, 0xf4, 0x20, 0x00, 0x00, 0xf8, 0x00, 0x00, 0xc7, 0xbf, 0x00, 0x64, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf8,
    0x00, 0xa0, 0x04, 0xf4, 0x40, 0x00, 0x00, 0xf8, 0x04, 0x0a, 0xfe, 0x8b, 0x3e, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c,
    0x7e, 0x80, 0x02, 0x0e, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00,
    0x80, 0xbf, 0x7e, 0x01, 0x98, 0xbe, 0x7e, 0x00, 0xc2, 0xd4, 0x04, 0x1f, 0x02, 0x00, 0x9e, 0xff, 0x88, 0xbf, 0x0a,
    0x7e, 0x8a, 0x91, 0x30, 0x00, 0xa1, 0xbf, 0x18, 0x0a, 0xfe, 0x8b, 0x00, 0xa0, 0x04, 0xf4, 0xf7, 0xff, 0xff, 0xf8,
    0x09, 0x1d, 0x0a, 0x4a, 0x80, 0x0c, 0x26, 0x7c, 0x0a, 0x1f, 0x1e, 0x4a, 0x9d, 0xff, 0x88, 0xbf, 0xa3, 0x00, 0x87,
    0xbf, 0x0e, 0x0b, 0x1c, 0x02, 0xf3, 0x0c, 0x04, 0x06, 0x06, 0x05, 0x04, 0x02, 0x13, 0x01, 0x87, 0xbf, 0x0e, 0x1f,
    0x00, 0x22, 0x06, 0x01, 0x03, 0xd5, 0x08, 0x05, 0x02, 0x00, 0x7e, 0x01, 0x98, 0xbe, 0x02, 0x00, 0x87, 0xbf, 0x7e,
    0x00, 0xc6, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x1a, 0x00, 0xa5, 0xbf, 0x80, 0x1c, 0x04, 0x4c, 0x91, 0x00, 0x87, 0xbf,
    0x0e, 0x05, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e, 0x18, 0x4a, 0x6a, 0x21, 0x9a, 0xbe, 0x09, 0x00, 0xa5,
    0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x08, 0x1c,
    0x1a, 0x4c, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x80, 0xc1, 0xd3, 0x00, 0x20, 0x08, 0x00, 0x0c, 0x0d, 0x00, 0x00, 0x1a,
    0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e,
    0x0f, 0x02, 0x06, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x80, 0xc1, 0xd3, 0x00, 0x20, 0x08, 0x00, 0x0c, 0x07, 0x00,
    0x00, 0x18, 0x01, 0xfe, 0xbe, 0xca, 0xff, 0xa0, 0xbf, 0x9e, 0xff, 0x88, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x04, 0x7e,
    0xfe, 0x91, 0x3b, 0x00, 0xa5, 0xbf, 0xf3, 0x02, 0x0c, 0x7e, 0x04, 0x01, 0xaa, 0xd5, 0x08, 0x01, 0x00, 0x00, 0x80,
    0x02, 0x10, 0x7e, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0x7e, 0x01, 0x98, 0xbe, 0x7e, 0x00, 0xc2, 0xd4,
    0x0e, 0x0f, 0x02, 0x00, 0x9e, 0xff, 0x88, 0xbf, 0x0a, 0x7e, 0x8a, 0x91, 0x2f, 0x00, 0xa1, 0xbf, 0x18, 0x0a, 0xfe,
    0x8b, 0x00, 0xa0, 0x04, 0xf4, 0xf7, 0xff, 0xff, 0xf8, 0x0a, 0x1f, 0x06, 0x4a, 0x80, 0x0c, 0x26, 0x7c, 0x9d, 0xff,
    0x88, 0xbf, 0xb2, 0x00, 0x87, 0xbf, 0x0f, 0x07, 0x1e, 0x02, 0x09, 0x1d, 0x1c, 0x4a, 0xf3, 0x0c, 0x00, 0x06, 0x06,
    0x01, 0x04, 0x02, 0x13, 0x01, 0x87, 0xbf, 0x0e, 0x1f, 0x00, 0x22, 0x04, 0x05, 0x0c, 0x06, 0x7e, 0x01, 0x98, 0xbe,
    0x02, 0x00, 0x87, 0xbf, 0x7e, 0x00, 0xc6, 0xd4, 0x00, 0x01, 0x01, 0x00, 0x1a, 0x00, 0xa5, 0xbf, 0x80, 0x1c, 0x00,
    0x4c, 0x91, 0x00, 0x87, 0xbf, 0x0e, 0x01, 0x00, 0x24, 0x08, 0x00, 0x88, 0x7c, 0x07, 0x1e, 0x18, 0x4a, 0x6a, 0x21,
    0x9a, 0xbe, 0x09, 0x00, 0xa5, 0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f,
    0x02, 0x06, 0x7e, 0x08, 0x1c, 0x1a, 0x4c, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x80, 0xc1, 0xd3, 0x00, 0x20, 0x08, 0x00,
    0x0c, 0x0d, 0x00, 0x00, 0x1a, 0x7e, 0xfe, 0x91, 0x08, 0x00, 0xa5, 0xbf, 0x0c, 0x02, 0x00, 0x7e, 0x0d, 0x02, 0x02,
    0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0f, 0x02, 0x06, 0x7e, 0x00, 0x00, 0xc7, 0xbf, 0x01, 0x80, 0xc1, 0xd3, 0x00, 0x20,
    0x08, 0x00, 0x0c, 0x08, 0x00, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xcb, 0xff, 0xa0, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x03,
    0x00, 0xb6, 0xbf, 0x00, 0x00, 0xb0, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xdf, 0x03, 0x10, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61,
    0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
    0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63,
    0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20,
    0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f,
    0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64,
    0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74,
    0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07,
    0x00, 0x00, 0x00, 0x67, 0x04, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00,
    0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x03, 0x06,
    0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x8b,
    0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xae, 0x2e, 0x72, 0x65, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65,
    0x5f, 0x68, 0x61, 0x73, 0x68, 0xcf, 0x2c, 0x01, 0xe0, 0x95, 0x2a, 0x4a, 0x6b, 0x9f, 0xb0, 0x2e, 0x73, 0x70, 0x69,
    0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73,
    0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61,
    0x64, 0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x83, 0xb0, 0x2e, 0x61, 0x70,
    0x69, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xa9, 0x75, 0x50, 0xc6,
    0xc3, 0x40, 0xeb, 0xc2, 0xcf, 0x9b, 0xa5, 0xba, 0xc0, 0xe3, 0x25, 0xb2, 0x1b, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64,
    0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xaf, 0x2e,
    0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x73, 0x75, 0x62, 0x74, 0x79, 0x70, 0x65, 0xa7, 0x55, 0x6e, 0x6b, 0x6e,
    0x6f, 0x77, 0x6e, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65,
    0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0xde, 0x00, 0x1d, 0xb3, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f,
    0x69, 0x6e, 0x74, 0x5f, 0x73, 0x79, 0x6d, 0x62, 0x6f, 0x6c, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f,
    0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74,
    0x1c, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xa9, 0x2e, 0x6c, 0x64, 0x73,
    0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x73, 0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x6d, 0x65, 0x6d,
    0x6f, 0x72, 0x79, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb4, 0x2e, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x64,
    0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb3, 0x2e, 0x62, 0x61, 0x63, 0x6b, 0x65,
    0x6e, 0x64, 0x5f, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00, 0xb6, 0x2e, 0x70, 0x65, 0x72,
    0x66, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x00,
    0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65,
    0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb4, 0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x61, 0x70, 0x70, 0x65, 0x6e,
    0x64, 0x5f, 0x63, 0x6f, 0x6e, 0x73, 0x75, 0x6d, 0x65, 0xc2, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f,
    0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x40, 0xb2, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74, 0x61,
    0x5f, 0x72, 0x65, 0x67, 0x5f, 0x6d, 0x61, 0x70, 0xdc, 0x00, 0x20, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff,
    0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff,
    0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce,
    0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff,
    0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xce, 0xff, 0xff, 0xff,
    0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70,
    0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xab, 0x2e, 0x66, 0x6c,
    0x6f, 0x61, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xcc, 0xc0, 0xae, 0x2e, 0x66, 0x70, 0x31, 0x36, 0x5f, 0x6f, 0x76,
    0x65, 0x72, 0x66, 0x6c, 0x6f, 0x77, 0xc2, 0xaa, 0x2e, 0x69, 0x65, 0x65, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2,
    0xb9, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x73, 0x61, 0x76, 0x65,
    0x64, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x00, 0xa9, 0x2e, 0x77, 0x67, 0x70, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0xc2,
    0xac, 0x2e, 0x6d, 0x65, 0x6d, 0x5f, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x65, 0x64, 0xc2, 0xb1, 0x2e, 0x66, 0x6f, 0x72,
    0x77, 0x61, 0x72, 0x64, 0x5f, 0x70, 0x72, 0x6f, 0x67, 0x72, 0x65, 0x73, 0x73, 0xc2, 0xaf, 0x2e, 0x77, 0x67, 0x5f,
    0x72, 0x6f, 0x75, 0x6e, 0x64, 0x5f, 0x72, 0x6f, 0x62, 0x69, 0x6e, 0xc2, 0xab, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x73, 0x67, 0x70, 0x72, 0x73, 0x0a, 0xa8, 0x2e, 0x65, 0x78, 0x63, 0x70, 0x5f, 0x65, 0x6e, 0x00, 0xab, 0x2e, 0x73,
    0x63, 0x72, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x6e, 0xc2, 0xad, 0x2e, 0x74, 0x72, 0x61, 0x70, 0x5f, 0x70, 0x72,
    0x65, 0x73, 0x65, 0x6e, 0x74, 0xc2, 0xb0, 0x2e, 0x73, 0x68, 0x61, 0x72, 0x65, 0x64, 0x5f, 0x76, 0x67, 0x70, 0x72,
    0x5f, 0x63, 0x6e, 0x74, 0x00, 0xad, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x73, 0x5f, 0x70, 0x65, 0x72, 0x5f, 0x73, 0x65,
    0x00, 0xaf, 0x2e, 0x63, 0x68, 0x65, 0x63, 0x6b, 0x73, 0x75, 0x6d, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0xce, 0x12,
    0xb5, 0xb3, 0xdf, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xcd, 0x2e, 0x42, 0x00,
    0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47,
    0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d,
    0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69,
    0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xe8, 0x6c, 0xf1, 0x6a, 0x54, 0x7b,
    0x28, 0x0b, 0xcf, 0xfd, 0x2d, 0x0e, 0xdb, 0xa1, 0x75, 0x1b, 0x9c, 0xb2, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
    0x65, 0x5f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x88, 0xaf, 0x2e, 0x74, 0x69, 0x64, 0x69, 0x67,
    0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x5f, 0x63, 0x6e, 0x74, 0x00, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x78, 0x5f,
    0x65, 0x6e, 0xc3, 0xaa, 0x2e, 0x74, 0x67, 0x69, 0x64, 0x5f, 0x79, 0x5f, 0x65, 0x6e, 0xc2, 0xaa, 0x2e, 0x74, 0x67,
    0x69, 0x64, 0x5f, 0x7a, 0x5f, 0x65, 0x6e, 0xc2, 0xab, 0x2e, 0x74, 0x67, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x5f, 0x65,
    0x6e, 0xc2, 0xb0, 0x2e, 0x64, 0x79, 0x6e, 0x61, 0x6d, 0x69, 0x63, 0x5f, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x65, 0x6e,
    0xc2, 0xad, 0x2e, 0x78, 0x5f, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xad, 0x2e, 0x79,
    0x5f, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6c, 0x65, 0x61, 0x76, 0x65, 0x00, 0xa4, 0x2e, 0x61, 0x70, 0x69, 0xa7, 0x73,
    0x63, 0x70, 0x63, 0x42, 0x6c, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf6, 0x04,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x81, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc9, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x04, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

// Table of compute pipeline binaries for 10_1_0
inline constexpr PipelineBinary timeGraphComputeBinaryTable10_1_0[] =
{
    {TimeGraph_Cs_0DCD1401,  sizeof(TimeGraph_Cs_0DCD1401)},
};

// Table of compute pipeline binaries for 10_3_0
inline constexpr PipelineBinary timeGraphComputeBinaryTable10_3_0[] =
{
    {TimeGraph_Cs_857A9C8A,  sizeof(TimeGraph_Cs_857A9C8A)},
};

// Table of compute pipeline binaries for 11_0_0
inline constexpr PipelineBinary timeGraphComputeBinaryTable11_0_0[] =
{
    {TimeGraph_Cs_F3CDD6F8,  sizeof(TimeGraph_Cs_F3CDD6F8)},
};

// Table of compute pipeline binaries for 11_0_3
inline constexpr PipelineBinary timeGraphComputeBinaryTable11_0_3[] =
{
    {TimeGraph_Cs_519251A5,  sizeof(TimeGraph_Cs_519251A5)},
};

// Table of compute pipeline binaries for 11_5_0
inline constexpr PipelineBinary timeGraphComputeBinaryTable11_5_0[] =
{
    {TimeGraph_Cs_20DE282F,  sizeof(TimeGraph_Cs_20DE282F)},
};

#if  PAL_BUILD_STRIX_HALO
// Table of compute pipeline binaries for 11_5_1
inline constexpr PipelineBinary timeGraphComputeBinaryTable11_5_1[] =
{
    {TimeGraph_Cs_20DE282F,  sizeof(TimeGraph_Cs_20DE282F)},
};
#endif

#if PAL_BUILD_GFX12 && PAL_BUILD_NAVI48
// Table of compute pipeline binaries for 12_0_1
inline constexpr PipelineBinary timeGraphComputeBinaryTable12_0_1[] =
{
    {TimeGraph_Cs_4AC1E1C2,  sizeof(TimeGraph_Cs_4AC1E1C2)},
};
#endif

} // TimeGraphDraw
} // GpuUtil
