/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx12
{
inline namespace Chip
{
constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0x0000;
constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_CACHE_EVICT_POINTS_DEFAULT                    = 0x400051A;
constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR0_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR0_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR1_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR1_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR2_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR2_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR3_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR3_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR4_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR4_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR5_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR5_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR6_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR6_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_COLOR7_FDCC_CONTROL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR7_VIEW2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0x0000;
constexpr unsigned int mmCB_FGCG_SRAM_OVERRIDE_DEFAULT                    = 0x0000;
constexpr unsigned int mmCB_HW_CONTROL_1_DEFAULT                          = 0x1000000;
constexpr unsigned int mmCB_HW_CONTROL_2_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_HW_CONTROL_3_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_HW_CONTROL_4_DEFAULT                          = 0x0002;
constexpr unsigned int mmCB_HW_CONTROL_DEFAULT                            = 0x400340;
constexpr unsigned int mmCB_HW_MEM_ARBITER_CTL_DEFAULT                    = 0x18800801;
constexpr unsigned int mmCB_MEM0_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM1_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM2_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM3_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM4_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM5_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM6_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_MEM7_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER2_SELECT_DEFAULT                   = 0x03FF;
constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER3_SELECT_DEFAULT                   = 0x03FF;
constexpr unsigned int mmCB_PERFCOUNTER_FILTER_DEFAULT                    = 0x0000;
constexpr unsigned int mmCB_READ_RESP_KEY_OVERRIDE_DEFAULT                = 0x0000;
constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0x0000;
constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCOHER_DEST_BASE_0_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_1_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_0_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x0000;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0_DEFAULT               = 0x0000;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1_DEFAULT               = 0x0000;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2_DEFAULT               = 0x0000;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3_DEFAULT               = 0x0000;
constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_ID_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_INTERLEAVE_DEFAULT              = 0x0040;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x0000;
constexpr unsigned int mmCOMPUTE_MISC_RESERVED_DEFAULT                    = 0x0008;
constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0x0000;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE_DEFAULT                 = 0x0000;
constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x0000;
constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0x0000;
constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_PIPELINESTAT_ENABLE_DEFAULT              = 0x0001;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_X_DEFAULT                  = 0x0000;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_Y_DEFAULT                  = 0x0000;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_Z_DEFAULT                  = 0x0000;
constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0x0000;
constexpr unsigned int mmCOMPUTE_REQ_CTRL_DEFAULT                         = 0x0000;
constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x0000;
constexpr unsigned int mmCOMPUTE_RESTART_X_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_RESTART_Y_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_RESTART_Z_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0x0000;
constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0x0000;
constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0x0000;
constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0x0000;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE0_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE1_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE2_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE3_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE4_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE5_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE6_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE7_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE8_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_THREADGROUP_ID_DEFAULT                   = 0x0000;
constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE_DEFAULT              = 0x0000;
constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_0_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x0000;
constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCPF_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPF_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCPG_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPG_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCP_DMA_CNTL_DEFAULT                              = 0x10100030;
constexpr unsigned int mmCP_DMA_ME_CMD_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_ME_CMD_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_ME_COMMAND_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_DMA_ME_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_DMA_ME_DST_ADDR_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_ME_DST_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_ME_SRC_ADDR_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_ME_SRC_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_CMD_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_CMD_ADDR_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_COMMAND_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_DST_ADDR_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_DST_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_SRC_ADDR_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_DMA_PFP_SRC_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_COMMAND_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_DST_ADDR_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_DST_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_SRC_ADDR_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_DMA_PIO_SRC_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_DMA_READ_TAGS_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH0_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH0_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH0_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH0_MASK_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH1_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH1_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH1_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH1_MASK_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH2_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH2_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH2_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH2_MASK_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH3_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH3_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH3_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH3_MASK_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH_STAT_ADDR_HI_DEFAULT                = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH_STAT_ADDR_LO_DEFAULT                = 0x0000;
constexpr unsigned int mmCP_DMA_WATCH_STAT_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_ADDR_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_ADDR_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_CNTX_ID_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_DATA_CNTL_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_DATA_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_DATA_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_EOP_DONE_EVENT_CNTL_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_EOP_LAST_FENCE_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_EOP_LAST_FENCE_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_CNTL0_DEFAULT           = 0x0010;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_CNTL1_DEFAULT           = 0x0010;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_CNTL0_DEFAULT           = 0x0011;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_CNTL1_DEFAULT           = 0x0011;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_CNTL0_DEFAULT           = 0x0012;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_CNTL1_DEFAULT           = 0x0012;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_CNTL0_DEFAULT           = 0x0013;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_CNTL1_DEFAULT           = 0x0013;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_CNTL0_DEFAULT           = 0x0014;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_CNTL1_DEFAULT           = 0x0014;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_CNTL0_DEFAULT           = 0x0015;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_CNTL1_DEFAULT           = 0x0015;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_CNTL0_DEFAULT           = 0x0016;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_CNTL1_DEFAULT           = 0x0016;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_CNTL0_DEFAULT           = 0x0017;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_CNTL1_DEFAULT           = 0x0017;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_CNTL0_DEFAULT           = 0x0018;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_CNTL1_DEFAULT           = 0x0018;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_BASE0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_BASE1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_CNTL0_DEFAULT           = 0x0019;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_CNTL1_DEFAULT           = 0x0019;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_MASK0_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_MASK1_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_CNTL0_DEFAULT          = 0x001A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_CNTL1_DEFAULT          = 0x001A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_CNTL0_DEFAULT          = 0x001B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_CNTL1_DEFAULT          = 0x001B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_CNTL0_DEFAULT          = 0x001C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_CNTL1_DEFAULT          = 0x001C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_CNTL0_DEFAULT          = 0x001D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_CNTL1_DEFAULT          = 0x001D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_CNTL0_DEFAULT          = 0x001E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_CNTL1_DEFAULT          = 0x001E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_BASE0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_BASE1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_CNTL0_DEFAULT          = 0x001F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_CNTL1_DEFAULT          = 0x001F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_MASK0_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_MASK1_DEFAULT          = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_PERFCOUNT_CNTL0_DEFAULT              = 0x0000;
constexpr unsigned int mmCP_GFX_RS64_PERFCOUNT_CNTL1_DEFAULT              = 0x0000;
constexpr unsigned int mmCP_HQD_ACTIVE_DEFAULT                            = 0x0000;
constexpr unsigned int mmCP_HQD_AQL_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_ATOMIC0_PREOP_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_ATOMIC0_PREOP_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_ATOMIC1_PREOP_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_ATOMIC1_PREOP_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_CNTL_STACK_OFFSET_DEFAULT                 = 0x0000;
constexpr unsigned int mmCP_HQD_CNTL_STACK_SIZE_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_HQD_CTX_SAVE_BASE_ADDR_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmCP_HQD_CTX_SAVE_BASE_ADDR_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmCP_HQD_CTX_SAVE_CONTROL_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_CTX_SAVE_SIZE_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_HQD_DDID_DELTA_RPT_COUNT_DEFAULT              = 0x0000;
constexpr unsigned int mmCP_HQD_DDID_INFLIGHT_COUNT_DEFAULT               = 0x0000;
constexpr unsigned int mmCP_HQD_DDID_RPTR_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_HQD_DDID_WPTR_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_HQD_DEQUEUE_REQUEST_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_HQD_DEQUEUE_STATUS_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_HQD_DMA_OFFLOAD_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_EOP_BASE_ADDR_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_HQD_EOP_BASE_ADDR_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_HQD_EOP_CONTROL_DEFAULT                       = 0x0006;
constexpr unsigned int mmCP_HQD_EOP_EVENTS_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_EOP_RPTR_DEFAULT                          = 0x40000000;
constexpr unsigned int mmCP_HQD_EOP_WPTR_DEFAULT                          = 0x7F8000;
constexpr unsigned int mmCP_HQD_EOP_WPTR_MEM_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_HQD_ERROR_DEFAULT                             = 0x0000;
constexpr unsigned int mmCP_HQD_GDS_RESOURCE_STATE_DEFAULT                = 0x0000;
constexpr unsigned int mmCP_HQD_GFX_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_GFX_STATUS_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_HQ_CONTROL0_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_HQ_CONTROL1_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_HQ_SCHEDULER0_DEFAULT                     = 0x40000000;
constexpr unsigned int mmCP_HQD_HQ_SCHEDULER1_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_HQD_HQ_STATUS0_DEFAULT                        = 0x40000000;
constexpr unsigned int mmCP_HQD_HQ_STATUS1_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_IB_BASE_ADDR_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_HQD_IB_BASE_ADDR_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_HQD_IB_CONTROL_DEFAULT                        = 0x300000;
constexpr unsigned int mmCP_HQD_IB_RPTR_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_IQ_RPTR_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_IQ_TIMER_DEFAULT                          = 0x0000;
constexpr unsigned int mmCP_HQD_MSG_TYPE_DEFAULT                          = 0x0000;
constexpr unsigned int mmCP_HQD_OFFLOAD_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_PERSISTENT_STATE_DEFAULT                  = 0xBE05501;
constexpr unsigned int mmCP_HQD_PIPE_PRIORITY_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_BASE_HI_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_CONTROL_DEFAULT                        = 0x308509;
constexpr unsigned int mmCP_HQD_PQ_DOORBELL_CONTROL_DEFAULT               = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_RPTR_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_RPTR_REPORT_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_RPTR_REPORT_ADDR_HI_DEFAULT            = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_WPTR_HI_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_WPTR_LO_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_WPTR_POLL_ADDR_DEFAULT                 = 0x0000;
constexpr unsigned int mmCP_HQD_PQ_WPTR_POLL_ADDR_HI_DEFAULT              = 0x0000;
constexpr unsigned int mmCP_HQD_QUANTUM_DEFAULT                           = 0x0000;
constexpr unsigned int mmCP_HQD_QUEUE_PRIORITY_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_HQD_SECURE_REQ0_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_HQD_SUSPEND_CNTL_STACK_DW_CNT_DEFAULT         = 0x0000;
constexpr unsigned int mmCP_HQD_SUSPEND_CNTL_STACK_OFFSET_DEFAULT         = 0x0000;
constexpr unsigned int mmCP_HQD_SUSPEND_WG_STATE_OFFSET_DEFAULT           = 0x0000;
constexpr unsigned int mmCP_HQD_VMID_DEFAULT                              = 0x0000;
constexpr unsigned int mmCP_HQD_WG_STATE_OFFSET_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_INT_CNTL_DEFAULT                              = 0x0000;
constexpr unsigned int mmCP_INT_CNTL_RING0_DEFAULT                        = 0x0000;
constexpr unsigned int mmCP_INT_STATUS_DEFAULT                            = 0x0000;
constexpr unsigned int mmCP_INT_STATUS_RING0_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_MEC_RS64_PERFCOUNT_CNTL_DEFAULT               = 0x0000;
constexpr unsigned int mmCP_MES_PERFCOUNT_CNTL_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_ME_COHER_BASE_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_BASE_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_ME_COHER_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_SIZE_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_ME_COHER_STATUS_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_MQD_BASE_ADDR_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_MQD_BASE_ADDR_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_MQD_CONTROL_DEFAULT                           = 0x0100;
constexpr unsigned int mmCP_PERFMON_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmCP_PERFMON_CNTX_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_PIPEID_DEFAULT                                = 0x0000;
constexpr unsigned int mmCP_PIPE_STATS_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_PIPE_STATS_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_PIPE_STATS_CONTROL_DEFAULT                    = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_STAT_DEFAULT                                  = 0x0000;
constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_ARB_CONFIG_DEFAULT                            = 0x0000;
constexpr unsigned int mmDB_CGTT_CLK_CTRL_0_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_CREDIT_LIMIT_DEFAULT                          = 0x0000;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_DEPTH_VIEW1_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0x0000;
constexpr unsigned int mmDB_DFD_INDIRECT_DAT_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_DFD_INDIRECT_SEL_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0x0000;
constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x8102000;
constexpr unsigned int mmDB_FGCG_INTERFACES_CLK_CTRL_DEFAULT              = 0x0000;
constexpr unsigned int mmDB_FGCG_SRAMS_CLK_CTRL_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH1_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH2_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH3_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH4_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FREE_CACHELINES_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_GL1_INTERFACE_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_MEM_ARB_WATERMARKS_DEFAULT                    = 0x4040404;
constexpr unsigned int mmDB_MEM_CONFIG_DEFAULT                            = 0x0035;
constexpr unsigned int mmDB_MEM_TEMPORAL_DEFAULT                          = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_RING_CONTROL_DEFAULT                          = 0x0001;
constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION_DEFAULT               = 0x0000;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x0000;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x0000;
constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x0000;
constexpr unsigned int mmDB_STENCIL_OPVAL_DEFAULT                         = 0x0000;
constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0x0000;
constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_STENCIL_READ_MASK_DEFAULT                     = 0x0000;
constexpr unsigned int mmDB_STENCIL_REF_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_STENCIL_WRITE_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmDB_SUMMARIZER_TIMEOUTS_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_VIEWPORT_CONTROL_DEFAULT                      = 0x0000;
constexpr unsigned int mmDB_WATERMARKS_DEFAULT                            = 0xA040A05;
constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x0000;
constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x0000;
constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0x0000;
constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi8_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi9_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi10_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi11_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi12_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi13_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi14_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi15_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo8_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo9_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo10_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo11_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo12_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo13_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo14_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo15_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi8_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi9_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi10_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi11_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi12_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi13_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi14_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi15_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo8_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo9_DEFAULT                 = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo10_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo11_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo12_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo13_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo14_DEFAULT                = 0x0000;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo15_DEFAULT                = 0x0000;
constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x8200545;
constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x8200545;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI_DEFAULT                = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO_DEFAULT                = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT         = 0x4000000;
constexpr unsigned int mmGCR_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGCR_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE_DEFAULT               = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE_DEFAULT               = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_SELECT1_DEFAULT          = 0xFFFFF;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_SELECT_DEFAULT           = 0xFFFFF;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_SELECT_DEFAULT           = 0x03FF;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_SELECT_DEFAULT             = 0x03FF;
constexpr unsigned int mmGE1_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1_DEFAULT              = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1_DEFAULT              = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1_DEFAULT              = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1_DEFAULT              = 0xFFFFF;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0x0000;
constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_1_DEFAULT               = 0x0000;
constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_DEFAULT                 = 0x0000;
constexpr unsigned int mmGE_GS_ORDERED_ID_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmGE_GS_THROTTLE_DEFAULT                           = 0x0000;
constexpr unsigned int mmGE_IA_ENHANCE_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0x0000;
constexpr unsigned int mmGE_MAX_OUTPUT_PER_SUBGROUP_DEFAULT               = 0x0000;
constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0x0000;
constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0x0000;
constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0000;
constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmGE_PA_IF_SAFE_REG_DEFAULT                        = 0xDC37;
constexpr unsigned int mmGE_POS_RING_BASE_DEFAULT                         = 0x0000;
constexpr unsigned int mmGE_POS_RING_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmGE_PRIM_RING_BASE_DEFAULT                        = 0x0000;
constexpr unsigned int mmGE_PRIM_RING_SIZE_DEFAULT                        = 0xC6E0000;
constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x01FE;
constexpr unsigned int mmGE_RATE_CNTL_1_DEFAULT                           = 0x10101010;
constexpr unsigned int mmGE_RATE_CNTL_2_DEFAULT                           = 0x0000;
constexpr unsigned int mmGE_SE_CNTL_STATUS_DEFAULT                        = 0x0000;
constexpr unsigned int mmGE_SE_ENHANCE_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_SPI_IF_SAFE_REG_DEFAULT                       = 0x18A69;
constexpr unsigned int mmGE_STATUS_DEFAULT                                = 0x0000;
constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmGE_USER_VGPR1_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_USER_VGPR2_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_USER_VGPR3_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0000;
constexpr unsigned int mmGE_VRS_RATE_DEFAULT                              = 0x0000;
constexpr unsigned int mmGE_WD_CNTL_STATUS_DEFAULT                        = 0x0000;
constexpr unsigned int mmGE_WD_ENHANCE_DEFAULT                            = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_CTRL2_DEFAULT                               = 0xC00006B;
constexpr unsigned int mmGL2C_CTRL3_DEFAULT                               = 0xC0C41183;
constexpr unsigned int mmGL2C_CTRL4_DEFAULT                               = 0xFEFF8002;
constexpr unsigned int mmGL2C_CTRL5_DEFAULT                               = 0xB035;
constexpr unsigned int mmGL2C_CTRL_DEFAULT                                = 0x306FF37F;
constexpr unsigned int mmGL2C_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_SELECT_DEFAULT                = 0x0000;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_SELECT_DEFAULT                = 0x0000;
constexpr unsigned int mmGRBMH_SYNC_DEFAULT                               = 0x0000;
constexpr unsigned int mmGRBM_GFX_INDEX_DEFAULT                           = 0xE0000000;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_DATA_DEFAULT                   = 0xE0000000;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_NOWHERE_2_DEFAULT                           = 0x0000;
constexpr unsigned int mmGRBM_NOWHERE_DEFAULT                             = 0xDEADBEEF;
constexpr unsigned int mmGRBM_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_HI_DEFAULT              = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_HI_DEFAULT              = 0x0000;
constexpr unsigned int mmIA_UTCL1_CNTL_DEFAULT                            = 0x0080;
constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x0000;
constexpr unsigned int mmIA_UTCL1_STATUS_DEFAULT                          = 0x0000;
constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_CL_ENHANCE_DEFAULT                            = 0x880007;
constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_CL_VRS_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_PH_ENHANCE_DEFAULT                            = 0x1000;
constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0028;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_RATE_CNTL_DEFAULT                             = 0x0000;
constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_ATM_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_CNTL_2_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE_DEFAULT               = 0x8000000;
constexpr unsigned int mmPA_SC_BINNER_DYNAMIC_BATCH_LIMIT_DEFAULT         = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0_DEFAULT                = 0x84224C02;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1_DEFAULT                = 0x82000008;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2_DEFAULT                = 0x1118AAB8;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3_DEFAULT                = 0xC2400024;
constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_CNTL_DEFAULT         = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER_DEFAULT      = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER_DEFAULT             = 0x0800;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_0_EXT_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_1_EXT_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_2_EXT_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_3_EXT_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0x0000;
constexpr unsigned int mmPA_SC_DSM_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_ENHANCE_1_DEFAULT                          = 0x40C2040;
constexpr unsigned int mmPA_SC_ENHANCE_2_DEFAULT                          = 0x0820;
constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SC_ENHANCE_DEFAULT                            = 0x8000409;
constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
constexpr unsigned int mmPA_SC_FIFO_SIZE_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS_DEFAULT                 = 0xFFFFFF;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_HISZ_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_HISZ_RENDER_OVERRIDE_DEFAULT               = 0x0000;
constexpr unsigned int mmPA_SC_HIS_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_HIS_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_HIS_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_HIS_SIZE_XY_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_HIS_SURFACE_CNTL_DEFAULT                   = 0x42000020;
constexpr unsigned int mmPA_SC_HIZ_BASE_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_HIZ_BASE_EXT_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_HIZ_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_HIZ_SIZE_XY_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_HIZ_SURFACE_CNTL_DEFAULT                   = 0x42000020;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_EN_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK_DEFAULT           = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_IF_FIFO_SIZE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_RESET_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_STATE_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_MODE_CNTL_1_DEFAULT                        = 0x6000000;
constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_EN_DEFAULT              = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_PACKER_WAVE_ID_CNTL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SC_RASTER_CONFIG_DEFAULT                      = 0x2A00126A;
constexpr unsigned int mmPA_SC_SAMPLE_PROPERTIES_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_SHADER_CONTROL_DEFAULT                     = 0x0000;
constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE_DEFAULT       = 0x0000;
constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_EN_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_0_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_0_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_1_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_1_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_2_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_2_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_3_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_3_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_4_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_4_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_5_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_5_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_6_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_6_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_7_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_7_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_8_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_8_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_9_BR_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_9_TL_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_10_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_10_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_11_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_11_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_12_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_12_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_13_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_13_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_14_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_14_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_15_BR_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_15_TL_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VRS_INFO_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_VRS_OVERRIDE_CNTL_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_BASE_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_BASE_EXT_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_EXT_DEFAULT         = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_SIZE_XY_DEFAULT          = 0x0000;
constexpr unsigned int mmPA_SC_VRS_RATE_SIZE_XY_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_1_DEFAULT                 = 0x55480708;
constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x42000000;
constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0x0000;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x0000;
constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0x0000;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0x0000;
constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER2_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER2_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmPC_PERFCOUNTER3_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmPC_PERFCOUNTER3_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmPerfMonCtl1_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl2_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl3_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl4_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl5_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl6_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl7_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl8_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl9_DEFAULT                              = 0x0000;
constexpr unsigned int mmPerfMonCtl10_DEFAULT                             = 0x0000;
constexpr unsigned int mmPerfMonCtl11_DEFAULT                             = 0x0000;
constexpr unsigned int mmPerfMonCtl12_DEFAULT                             = 0x0000;
constexpr unsigned int mmPerfMonCtlClk_DEFAULT                            = 0x30000000;
constexpr unsigned int mmPerfMonCtr1_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr1_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr2_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr2_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr3_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr3_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr4_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr4_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr5_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr5_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr6_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr6_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr7_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr7_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr8_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr8_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr9_Hi_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr9_Lo_DEFAULT                           = 0x0000;
constexpr unsigned int mmPerfMonCtr10_Hi_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtr10_Lo_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtr11_Hi_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtr11_Lo_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtr12_Hi_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtr12_Lo_DEFAULT                          = 0x0000;
constexpr unsigned int mmPerfMonCtrClk_Hi_DEFAULT                         = 0x0000;
constexpr unsigned int mmPerfMonCtrClk_Lo_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
constexpr unsigned int mmRLC_PERFMON_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET_DEFAULT        = 0x0008;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRL_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS_DEFAULT = 0xFFFF;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT_DEFAULT            = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x7E004;
constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED_DEFAULT          = 0x0001;
constexpr unsigned int mmRLC_SPM_ACCUM_STATUS_DEFAULT                     = 0x184800;
constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_ADDR_DEFAULT           = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_DATA_DEFAULT           = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD_DEFAULT                  = 0x0001;
constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_BLK_EN_MASK_IND_ADDR_DEFAULT      = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_BLK_EN_MASK_IND_DATA_DEFAULT      = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_ADDR_DEFAULT            = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_DATA_DEFAULT            = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_0_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_1_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_2_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_3_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GTS_TRIGGER_VALUE_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_GTS_TRIGGER_VALUE_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_INFO_1_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_INFO_2_DEFAULT                       = 0xCA0000;
constexpr unsigned int mmRLC_SPM_INT_STATUS_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_MC_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmRLC_SPM_MODE_DEFAULT                             = 0x0000;
constexpr unsigned int mmRLC_SPM_PAUSE_DEFAULT                            = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_RING_RDPTR_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_RING_WRPTR_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_CMD_ACK_DEFAULT                     = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_CMD_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA_DEFAULT                    = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_REQ_OP_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_RET_DATA_DEFAULT                    = 0x0000;
constexpr unsigned int mmRLC_SPM_RSPM_RET_OP_DEFAULT                      = 0x0000;
constexpr unsigned int mmRLC_SPM_SAMPLE_CNT_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_BLK_EN_MASK_IND_ADDR_DEFAULT          = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_BLK_EN_MASK_IND_DATA_DEFAULT          = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_ADDR_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_DATA_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA_DEFAULT                 = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_OP_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_DATA_DEFAULT                 = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_OP_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_0_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_1_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_2_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_3_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SPARE_DEFAULT                            = 0x0000;
constexpr unsigned int mmRLC_SPM_STATUS_DEFAULT                           = 0x0000;
constexpr unsigned int mmRLC_SPM_THREAD_TRACE_CTRL_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_UTCL1_CNTL_DEFAULT                       = 0x0080;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_2_DEFAULT                    = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmRMI_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmRMI_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmRMI_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmRMI_PERF_COUNTER_CNTL_DEFAULT                    = 0x80240;
constexpr unsigned int mmRPB_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER2_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER3_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
constexpr unsigned int mmRPB_PERF_COUNTER_CNTL_DEFAULT                    = 0x0010;
constexpr unsigned int mmSCRATCH_REG0_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG1_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG2_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG3_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG4_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG5_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG6_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REG7_DEFAULT                             = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER0_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER1_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER2_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER3_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER4_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER5_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER6_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REGISTER7_DEFAULT                        = 0x0000;
constexpr unsigned int mmSCRATCH_REG_ATOMIC_DEFAULT                       = 0x0000;
constexpr unsigned int mmSCRATCH_REG_CMPSWAP_ATOMIC_DEFAULT               = 0x0000;
constexpr unsigned int mmSC_MEM_SCOPE_DEFAULT                             = 0x0055;
constexpr unsigned int mmSC_MEM_SPEC_READ_DEFAULT                         = 0x0000;
constexpr unsigned int mmSC_MEM_TEMPORAL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSDMA0_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSPI_ARB_CNTL_0_DEFAULT                           = 0x0000;
constexpr unsigned int mmSPI_ARB_CYCLES_0_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_ARB_CYCLES_1_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_ARB_PRIORITY_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_ATTRIBUTE_RING_BASE_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_ATTRIBUTE_RING_SIZE_DEFAULT                  = 0x20000;
constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmSPI_BARYC_SSAA_CNTL_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_STATUS_DEFAULT           = 0x0000;
constexpr unsigned int mmSPI_COMPUTE_WGS_CONTROL_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x80070000;
constexpr unsigned int mmSPI_CONFIG_CNTL_2_DEFAULT                        = 0xF0011;
constexpr unsigned int mmSPI_CONFIG_CNTL_DEFAULT                          = 0xC062C688;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS0_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS1_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS2_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS3_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS4_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS5_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS6_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS7_DEFAULT                   = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_GFX0_DEFAULT                  = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_GFX1_DEFAULT                  = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_HP3D0_DEFAULT                 = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_HP3D1_DEFAULT                 = 0xFFFFFFFF;
constexpr unsigned int mmSPI_CONFIG_PS_CU_EN_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_CREST_MODE_DEFAULT                           = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_STATUS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_CS_CRAWLER_CONFIG_DEFAULT                    = 0x0000;
constexpr unsigned int mmSPI_DSM_CNTL2_DEFAULT                            = 0x0000;
constexpr unsigned int mmSPI_DSM_CNTL_DEFAULT                             = 0x0000;
constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0000;
constexpr unsigned int mmSPI_EXP_THROTTLE_CTRL_DEFAULT                    = 0x8782E2E;
constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x13E0;
constexpr unsigned int mmSPI_GDS_CREDITS_DEFAULT                          = 0x4040;
constexpr unsigned int mmSPI_GFX_CNTL_DEFAULT                             = 0x0000;
constexpr unsigned int mmSPI_GFX_CRAWLER_CONFIG_DEFAULT                   = 0x0000;
constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_GRP_LAUNCH_GUARANTEE_CTRL_DEFAULT            = 0x211103;
constexpr unsigned int mmSPI_GRP_LAUNCH_GUARANTEE_ENABLE_DEFAULT          = 0x8A4E;
constexpr unsigned int mmSPI_GS_THROTTLE_CNTL1_DEFAULT                    = 0x12355123;
constexpr unsigned int mmSPI_GS_THROTTLE_CNTL2_DEFAULT                    = 0x1544D;
constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_LB_CTR_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_CS_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_HSGS_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_PS_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_REG_DEFAULT                          = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_WAVES_DEFAULT                        = 0x0000;
constexpr unsigned int mmSPI_LB_WGP_MASK_DEFAULT                          = 0xFFFF;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_GPR_MIN_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_GPR_MIN_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER_BINS_DEFAULT                     = 0xFCB87430;
constexpr unsigned int mmSPI_PG_ENABLE_STATIC_WGP_MASK_DEFAULT            = 0xFFFF;
constexpr unsigned int mmSPI_PQEV_CTRL_DEFAULT                            = 0xFF1008;
constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0x0000;
constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000FF;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15_DEFAULT            = 0x0000;
constexpr unsigned int mmSPI_SAVE_RESTORE_STATUS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SCRATCH_ADDR_STATUS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0x0000;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_CTRL_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_DIM_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_EXP_ALLOC_DEFAULT          = 0x0000;
constexpr unsigned int mmSPI_SHADER_GS_OUT_CONFIG_PS_DEFAULT              = 0x0000;
constexpr unsigned int mmSPI_SHADER_GS_OUT_CONFIG_PS_GS_DEFAULT           = 0x0000;
constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0x0000;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS_DEFAULT                   = 0x0000;
constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_SQG_EVENT_CTL_DEFAULT                        = 0x0000;
constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x8000140;
constexpr unsigned int mmSPI_SX_SCOREBOARD_BUFFER_SIZES_DEFAULT           = 0x400040;
constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS0_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS1_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS2_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS3_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX_DEFAULT                 = 0x7C1F07F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_HP3D_DEFAULT                = 0x7C1F07F;
constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_GFX_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_HPG_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_0_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_2_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_3_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_0_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_2_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_4_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_6_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_7_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_9_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_11_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_13_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_14_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_15_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_16_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_17_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_18_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_19_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_20_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_21_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WGP_WORK_PENDING_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQG_CONFIG_DEFAULT                               = 0x0001;
constexpr unsigned int mmSQG_GL1X_CTRL_DEFAULT                            = 0x0031;
constexpr unsigned int mmSQG_GL1X_STATUS_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER0_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER1_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER2_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER3_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER4_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER4_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER4_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER5_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER5_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER5_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER6_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER6_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER6_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER7_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER7_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQG_PERFCOUNTER7_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQG_PERFCOUNTER_CTRL2_DEFAULT                    = 0x1FFFE;
constexpr unsigned int mmSQG_PERFCOUNTER_CTRL_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQG_PERF_SAMPLE_FINISH_DEFAULT                   = 0x0000;
constexpr unsigned int mmSQG_STATUS_DEFAULT                               = 0x0000;
constexpr unsigned int mmSQG_THREAD_TRACE_CONFIG_DEFAULT                  = 0x0000;
constexpr unsigned int mmSQ_ALU_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_ARB_CONFIG_DEFAULT                            = 0x0030;
constexpr unsigned int mmSQ_CLK_CTRL_DEFAULT                              = 0x0000;
constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0x0000;
constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180000;
constexpr unsigned int mmSQ_DSM_CNTL2_DEFAULT                             = 0x0000;
constexpr unsigned int mmSQ_DSM_CNTL_DEFAULT                              = 0x0000;
constexpr unsigned int mmSQ_DYN_VGPR_DEFAULT                              = 0x00FF;
constexpr unsigned int mmSQ_FIFO_SIZES_DEFAULT                            = 0xD001;
constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0x0000;
constexpr unsigned int mmSQ_IND_INDEX_DEFAULT                             = 0x0000;
constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK_DEFAULT                   = 0xFFFFFF;
constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL_DEFAULT                    = 0x0000;
constexpr unsigned int mmSQ_LDS_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT_DEFAULT                   = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT_DEFAULT                  = 0x01FF;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2_DEFAULT                     = 0x1FFFE;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL_DEFAULT                      = 0x0000;
constexpr unsigned int mmSQ_PERF_SNAPSHOT_CTRL_DEFAULT                    = 0x1FFFE;
constexpr unsigned int mmSQ_RANDOM_WAVE_PRI_DEFAULT                       = 0x007F;
constexpr unsigned int mmSQ_RUNTIME_CONFIG_DEFAULT                        = 0x0000;
constexpr unsigned int mmSQ_SHADER_TBA_HI_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TBA_LO_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TMA_HI_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TMA_LO_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_TEX_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_CTRL_DEFAULT                     = 0x400000;
constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR_DEFAULT            = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR_DEFAULT          = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_HALT_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR_DEFAULT           = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR_DEFAULT         = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_MASK_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_POWEROFF_RESTORE_1_DEFAULT       = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_STATUS2_DEFAULT                  = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_STATUS_DEFAULT                   = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_WPTR_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQ_WATCH0_ADDR_H_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH0_ADDR_L_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH0_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmSQ_WATCH1_ADDR_H_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH1_ADDR_L_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH1_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmSQ_WATCH2_ADDR_H_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH2_ADDR_L_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH2_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmSQ_WATCH3_ADDR_H_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH3_ADDR_L_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_WATCH3_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x0000;
constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0x0000;
constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmSX_PS_DOWNCONVERT_CONTROL_DEFAULT                = 0x0000;
constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0x0000;
constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0x0000;
constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_CNTL2_DEFAULT                                 = 0x0000;
constexpr unsigned int mmTA_CNTL_AUX_DEFAULT                              = 0x1030000;
constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xC0030000;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
constexpr unsigned int mmTA_SCRATCH_DEFAULT                               = 0x0000;
constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmTCP_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN_DEFAULT                = 0x0000;
constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
constexpr unsigned int mmUMCCH0_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl6_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl7_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl8_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl9_DEFAULT                       = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl10_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl11_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtl12_DEFAULT                      = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x30000000;
constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_SELECT_DEFAULT                = 0x03FF;
constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0x0000;
constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0x0000;
constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH_DEFAULT                  = 0x0200;
constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_DMA_REQ_FIFO_DEPTH_DEFAULT                   = 0x0020;
constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0x0000;
constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_DRAW_INIT_FIFO_DEPTH_DEFAULT                 = 0x0020;
constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0x0000;
constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x0000;
constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x0000;
constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x07FF;
constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0x0000;
constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0x0000;
constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x0000;
constexpr unsigned int mmVGT_INSTANCE_BASE_ID_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0x0000;
constexpr unsigned int mmVGT_MC_LAT_CNTL_DEFAULT                          = 0x0002;
constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0x0000;
constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0x0000;
constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0x0000;
constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_PRIMITIVEID_RESET_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0000;
constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0x0000;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0x0000;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x0000;
constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_TF_MEMORY_BASE_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x0000;
constexpr unsigned int mmVGT_TF_RING_SIZE_DEFAULT                         = 0x3000;
constexpr unsigned int mmWD_UTCL1_CNTL_DEFAULT                            = 0x0080;
constexpr unsigned int mmWD_UTCL1_STATUS_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_BUSY_HYSTERESIS_DEFAULT                      = 0x0808;
constexpr unsigned int mmWGS_BUSY_STAT2_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_BUSY_STAT_DEFAULT                            = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DDID_INDEX_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE0_DEFAULT           = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE1_DEFAULT           = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE2_DEFAULT           = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE3_DEFAULT           = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DIM_X_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DIM_Y_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DIM_Z_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_END_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_ID_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_INITIATOR_DEFAULT           = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_INTERLEAVE_DEFAULT          = 0x0040;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT         = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT         = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT     = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT     = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_TUNNEL_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_MISC_RESERVED_DEFAULT                = 0x0008;
constexpr unsigned int mmWGS_COMPUTE_NOWHERE_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_X_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_Y_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_Z_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PERFCOUNT_ENABLE_DEFAULT             = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PGM_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PGM_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC1_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC2_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC3_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PIPELINESTAT_ENABLE_DEFAULT          = 0x0001;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_X_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_Y_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_Z_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RELAUNCH2_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RELAUNCH_DEFAULT                     = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_REQ_CTRL_DEFAULT                     = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RESOURCE_LIMITS_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RESTART_X_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RESTART_Y_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_RESTART_Z_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_SHADER_CHKSUM_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_START_X_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_START_Y_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_START_Z_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE0_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE1_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE2_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE3_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE4_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE5_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE6_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE7_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE8_DEFAULT       = 0xFFFFFFFF;
constexpr unsigned int mmWGS_COMPUTE_THREADGROUP_ID_DEFAULT               = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_THREAD_TRACE_ENABLE_DEFAULT          = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_TMPRING_SIZE_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_0_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_1_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_2_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_3_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_0_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_1_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_2_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_3_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_4_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_5_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_6_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_7_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_8_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_9_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_10_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_11_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_12_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_13_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_14_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_15_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_VMID_DEFAULT                         = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT         = 0x0000;
constexpr unsigned int mmWGS_COMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT         = 0x0000;
constexpr unsigned int mmWGS_DATA1_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA2_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA3_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA4_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA5_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA6_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA7_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA8_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA9_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_DATA10_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA11_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA12_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA13_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA14_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA15_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DATA16_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE0_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE0_CNTL_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE0_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE1_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE1_CNTL_DEFAULT                    = 0x0001;
constexpr unsigned int mmWGS_DC_APERTURE1_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE2_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE2_CNTL_DEFAULT                    = 0x0002;
constexpr unsigned int mmWGS_DC_APERTURE2_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE3_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE3_CNTL_DEFAULT                    = 0x0003;
constexpr unsigned int mmWGS_DC_APERTURE3_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE4_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE4_CNTL_DEFAULT                    = 0x0004;
constexpr unsigned int mmWGS_DC_APERTURE4_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE5_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE5_CNTL_DEFAULT                    = 0x0005;
constexpr unsigned int mmWGS_DC_APERTURE5_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE6_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE6_CNTL_DEFAULT                    = 0x0006;
constexpr unsigned int mmWGS_DC_APERTURE6_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE7_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE7_CNTL_DEFAULT                    = 0x0007;
constexpr unsigned int mmWGS_DC_APERTURE7_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE8_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE8_CNTL_DEFAULT                    = 0x0008;
constexpr unsigned int mmWGS_DC_APERTURE8_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE9_BASE_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE9_CNTL_DEFAULT                    = 0x0009;
constexpr unsigned int mmWGS_DC_APERTURE9_MASK_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE10_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE10_CNTL_DEFAULT                   = 0x000A;
constexpr unsigned int mmWGS_DC_APERTURE10_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE11_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE11_CNTL_DEFAULT                   = 0x000B;
constexpr unsigned int mmWGS_DC_APERTURE11_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE12_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE12_CNTL_DEFAULT                   = 0x000C;
constexpr unsigned int mmWGS_DC_APERTURE12_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE13_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE13_CNTL_DEFAULT                   = 0x000D;
constexpr unsigned int mmWGS_DC_APERTURE13_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE14_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE14_CNTL_DEFAULT                   = 0x000E;
constexpr unsigned int mmWGS_DC_APERTURE14_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE15_BASE_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_APERTURE15_CNTL_DEFAULT                   = 0x000F;
constexpr unsigned int mmWGS_DC_APERTURE15_MASK_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_DC_BASE_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmWGS_DC_BASE_HI_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_DC_BASE_LO_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_DC_OP_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_DDID_BASE_ADDR_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DDID_BASE_ADDR_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmWGS_DDID_CNTL_DEFAULT                            = 0x0080;
constexpr unsigned int mmWGS_DM_INDEX_ADDR_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_DM_INDEX_DATA_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_ENDIAN_SWAP_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_ERROR_DEFAULT                                = 0x0000;
constexpr unsigned int mmWGS_GEN_BASE_HI_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_GEN_BASE_LO_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_GP0_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP0_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP1_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP1_LO_DEFAULT                               = 0x2001;
constexpr unsigned int mmWGS_GP2_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP2_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP3_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP3_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP4_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP4_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP5_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP5_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP6_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP6_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP7_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP7_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP8_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP8_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_GP9_HI_DEFAULT                               = 0x40000000;
constexpr unsigned int mmWGS_GP9_LO_DEFAULT                               = 0x40000000;
constexpr unsigned int mmWGS_HALT_HYST_COUNT_DEFAULT                      = 0x0002;
constexpr unsigned int mmWGS_IC_BASE_CNTL_DEFAULT                         = 0x0020;
constexpr unsigned int mmWGS_IC_BASE_HI_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_IC_BASE_LO_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_IC_OP_CNTL_DEFAULT                           = 0x000A;
constexpr unsigned int mmWGS_IH_FREE_COUNT_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_INT_CNTXID_HI_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_INT_CNTXID_LO_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_INT_INFO_DEFAULT                             = 0x0000;
constexpr unsigned int mmWGS_INT_STATUS_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_IQ_TIMER_DEFAULT                             = 0x0000;
constexpr unsigned int mmWGS_IQ_TIMER_MESSAGE_DEFAULT                     = 0x0009;
constexpr unsigned int mmWGS_IQ_WAIT_TIME1_DEFAULT                        = 0x40404040;
constexpr unsigned int mmWGS_IQ_WAIT_TIME2_DEFAULT                        = 0x40004040;
constexpr unsigned int mmWGS_IQ_WAIT_TIME3_DEFAULT                        = 0x0040;
constexpr unsigned int mmWGS_LATENCY_STATS_DATA_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_LATENCY_STATS_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmWGS_LOCAL_APERTURE_DEFAULT                       = 0x0007;
constexpr unsigned int mmWGS_LOCAL_BASE0_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmWGS_LOCAL_BASE0_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmWGS_LOCAL_INSTR_APERTURE_DEFAULT                 = 0x0007;
constexpr unsigned int mmWGS_LOCAL_INSTR_BASE_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_LOCAL_INSTR_BASE_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_LOCAL_INSTR_MASK_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_LOCAL_INSTR_MASK_LO_DEFAULT                  = 0xF0000;
constexpr unsigned int mmWGS_LOCAL_MASK0_HI_DEFAULT                       = 0xFFFF;
constexpr unsigned int mmWGS_LOCAL_MASK0_LO_DEFAULT                       = 0xFFFF0000;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_APERTURE_DEFAULT               = 0x0003;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_BASE_HI_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_BASE_LO_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_MDBASE_HI_DEFAULT                            = 0x0000;
constexpr unsigned int mmWGS_MDBASE_LO_DEFAULT                            = 0x0000;
constexpr unsigned int mmWGS_MDBOUND_HI_DEFAULT                           = 0xFFFF;
constexpr unsigned int mmWGS_MDBOUND_LO_DEFAULT                           = 0xFFFF;
constexpr unsigned int mmWGS_ME1_HEADER_DUMP_DEFAULT                      = 0xDEF0DEF0;
constexpr unsigned int mmWGS_ME1_PIPE0_PRIORITY_DEFAULT                   = 0x0002;
constexpr unsigned int mmWGS_ME1_PIPE1_PRIORITY_DEFAULT                   = 0x0002;
constexpr unsigned int mmWGS_ME1_PIPE2_PRIORITY_DEFAULT                   = 0x0002;
constexpr unsigned int mmWGS_ME1_PIPE3_PRIORITY_DEFAULT                   = 0x0002;
constexpr unsigned int mmWGS_ME1_PIPE_PRIORITY_CNTS_DEFAULT               = 0x8081020;
constexpr unsigned int mmWGS_METADATA_BASE_ADDR_HI_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_METADATA_BASE_ADDR_LO_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_METADATA_CNTL_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_MGCG_SYNC_CNTL_DEFAULT                       = 0x1020;
constexpr unsigned int mmWGS_MIBOUND_HI_DEFAULT                           = 0x0000;
constexpr unsigned int mmWGS_MIBOUND_LO_DEFAULT                           = 0x1FFFFFF;
constexpr unsigned int mmWGS_MIE_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_MIE_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_MIP_HI_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_MIP_LO_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_MTIMECMP_HI_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_MTIMECMP_LO_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_MTVEC_HI_DEFAULT                             = 0x0000;
constexpr unsigned int mmWGS_MTVEC_LO_DEFAULT                             = 0x0000;
constexpr unsigned int mmWGS_OS_PIPES_DEFAULT                             = 0x0000;
constexpr unsigned int mmWGS_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmWGS_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmWGS_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmWGS_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmWGS_PERFMON_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmWGS_RS64_CNTL_DEFAULT                            = 0x40000000;
constexpr unsigned int mmWGS_RS64_EXCEPTION_STATUS_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_RS64_INSTR_PNTR_DEFAULT                      = 0x0800;
constexpr unsigned int mmWGS_RS64_INTERRUPT_DEFAULT                       = 0x0000;
constexpr unsigned int mmWGS_RS64_PENDING_INTERRUPT_DEFAULT               = 0x0000;
constexpr unsigned int mmWGS_RS64_PERFCOUNT_CNTL_DEFAULT                  = 0x0000;
constexpr unsigned int mmWGS_RS64_PRGRM_CNTR_START_DEFAULT                = 0x0800;
constexpr unsigned int mmWGS_RS64_PRGRM_CNTR_START_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmWGS_RS64_PRIV_LEVEL_DEFAULT                      = 0x0001;
constexpr unsigned int mmWGS_RS64_PRIV_LEVEL_VIOLATION_STATUS_DEFAULT     = 0x0000;
constexpr unsigned int mmWGS_RS64_THREAD_CNTL_DEFAULT                     = 0x10000;
constexpr unsigned int mmWGS_SCRATCH_DATA_DEFAULT                         = 0x0000;
constexpr unsigned int mmWGS_SCRATCH_INDEX_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_SECURE_REG0_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_SECURE_REG1_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_SECURE_REG2_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_SECURE_REG3_DEFAULT                          = 0x0000;
constexpr unsigned int mmWGS_STALLED_STAT1_DEFAULT                        = 0x0000;
constexpr unsigned int mmWGS_STATUS_DEFAULT                               = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CNTL_STACK_OFFSET_DEFAULT            = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CNTL_STACK_SIZE_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_BASE_ADDR_HI_DEFAULT        = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_BASE_ADDR_LO_DEFAULT        = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_CONTROL_DEFAULT             = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_RESUME_REQ_DEFAULT                   = 0x0000;
constexpr unsigned int mmWGS_SUSPEND_WG_STATE_OFFSET_DEFAULT              = 0x0000;
constexpr unsigned int mmWGS_TC_PERF_COUNTER_WINDOW_SELECT_DEFAULT        = 0x0000;
constexpr unsigned int mmWGS_TMZ_CNTL_DEFAULT                             = 0x0000;

#if CHIP_HDR_NAVI48
namespace Nv48
{
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
} // namespace Nv48
#endif

} // inline namespace Chip
} // namespace Gfx12
} // namespace Pal
