/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx12
{
inline namespace Chip
{
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND0_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND0_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND0_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND1_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND1_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND1_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND2_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND2_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND2_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND3_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND3_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND3_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND4_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND4_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND4_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND5_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND5_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND5_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND6_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND6_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND6_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_COMB_FCN_MASK             = 0x00e00000;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_DESTBLEND_MASK            = 0x1f000000;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_SRCBLEND_MASK             = 0x001f0000;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_COMB_FCN_MASK             = 0x000000e0;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_DESTBLEND_MASK            = 0x00001f00;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_SRCBLEND_MASK             = 0x0000001f;
constexpr unsigned int CB_BLEND7_CONTROL__DISABLE_ROP3_MASK               = 0x80000000;
constexpr unsigned int CB_BLEND7_CONTROL__ENABLE_MASK                     = 0x40000000;
constexpr unsigned int CB_BLEND7_CONTROL__SEPARATE_ALPHA_BLEND_MASK       = 0x20000000;
constexpr unsigned int CB_BLEND_ALPHA__BLEND_ALPHA_MASK                   = 0xffffffff;
constexpr unsigned int CB_BLEND_BLUE__BLEND_BLUE_MASK                     = 0xffffffff;
constexpr unsigned int CB_BLEND_GREEN__BLEND_GREEN_MASK                   = 0xffffffff;
constexpr unsigned int CB_BLEND_RED__BLEND_RED_MASK                       = 0xffffffff;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_CACHE_EVICT_POINT_MASK   = 0xff000000;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_COLOR_EVICT_POINT_MASK   = 0x000000ff;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_FMASK_EVICT_POINT_MASK   = 0x0000ff00;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR0_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR0_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR0_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR0_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR0_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR0_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR0_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR0_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR0_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR0_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR0_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR0_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR0_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR0_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR0_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR0_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR1_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR1_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR1_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR1_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR1_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR1_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR1_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR1_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR1_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR1_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR1_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR1_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR1_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR1_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR1_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR1_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR2_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR2_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR2_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR2_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR2_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR2_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR2_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR2_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR2_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR2_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR2_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR2_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR2_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR2_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR2_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR2_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR3_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR3_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR3_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR3_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR3_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR3_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR3_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR3_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR3_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR3_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR3_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR3_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR3_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR3_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR3_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR3_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR4_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR4_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR4_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR4_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR4_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR4_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR4_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR4_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR4_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR4_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR4_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR4_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR4_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR4_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR4_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR4_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR5_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR5_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR5_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR5_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR5_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR5_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR5_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR5_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR5_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR5_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR5_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR5_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR5_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR5_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR5_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR5_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR6_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR6_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR6_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR6_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR6_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR6_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR6_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR6_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR6_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR6_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR6_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR6_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR6_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR6_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR6_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR6_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_HEIGHT_MASK                = 0x0000ffff;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_WIDTH_MASK                 = 0xffff0000;
constexpr unsigned int CB_COLOR7_ATTRIB3__COLOR_SW_MODE_MASK              = 0x00038000;
constexpr unsigned int CB_COLOR7_ATTRIB3__MAX_MIP_MASK                    = 0x00f80000;
constexpr unsigned int CB_COLOR7_ATTRIB3__MIP0_DEPTH_MASK                 = 0x00003fff;
constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_TYPE_MASK              = 0x03000000;
constexpr unsigned int CB_COLOR7_ATTRIB3__SPECULATIVE_READ_MASK           = 0x0c000000;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_DST_ALPHA_1_MASK           = 0x00000004;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX_MASK = 0x00000008;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_FRAGMENTS_MASK               = 0x00000003;
constexpr unsigned int CB_COLOR7_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int CB_COLOR7_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__COMPRESSION_MODE_MASK      = 0x0c000000;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE_MASK = 0x10000000;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE_MASK = 0x01000000;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_COMP_FRAGS_MASK        = 0x60000000;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x00000004;
constexpr unsigned int CB_COLOR7_INFO__BLEND_BYPASS_MASK                  = 0x00010000;
constexpr unsigned int CB_COLOR7_INFO__BLEND_CLAMP_MASK                   = 0x00008000;
constexpr unsigned int CB_COLOR7_INFO__COMP_SWAP_MASK                     = 0x00001800;
constexpr unsigned int CB_COLOR7_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL_MASK = 0x00080000;
constexpr unsigned int CB_COLOR7_INFO__FORMAT_MASK                        = 0x0000001f;
constexpr unsigned int CB_COLOR7_INFO__LINEAR_GENERAL_MASK                = 0x00000080;
constexpr unsigned int CB_COLOR7_INFO__NUMBER_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CB_COLOR7_INFO__ROUND_MODE_MASK                    = 0x00040000;
constexpr unsigned int CB_COLOR7_INFO__SIMPLE_FLOAT_MASK                  = 0x00020000;
constexpr unsigned int CB_COLOR7_VIEW2__MIP_LEVEL_MASK                    = 0x0000001f;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX_MASK                     = 0x0fffc000;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_START_MASK                   = 0x00003fff;
constexpr unsigned int CB_COLOR_CONTROL__DEGAMMA_ENABLE_MASK              = 0x00000008;
constexpr unsigned int CB_COLOR_CONTROL__DISABLE_DUAL_QUAD_MASK           = 0x00000001;
constexpr unsigned int CB_COLOR_CONTROL__MODE_MASK                        = 0x00000070;
constexpr unsigned int CB_COLOR_CONTROL__ROP3_MASK                        = 0x00ff0000;
constexpr unsigned int CB_FGCG_SRAM_OVERRIDE__DISABLE_FGCG_MASK           = 0x000007ff;
constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS_MASK            = 0x0000003f;
constexpr unsigned int CB_HW_CONTROL_1__COLOR_SCOPE_MASK                  = 0x03000000;
constexpr unsigned int CB_HW_CONTROL_1__DISABLE_RDLAT_FIFO_BYP_MASK       = 0x00400000;
constexpr unsigned int CB_HW_CONTROL_1__DISABLE_SRC_FIFO_BYP_MASK         = 0x00200000;
constexpr unsigned int CB_HW_CONTROL_1__ENABLE_COMPRESSION_ON_BYPASS_MASK = 0x00800000;
constexpr unsigned int CB_HW_CONTROL_1__GLX_NOFILL_MASK                   = 0x04000000;
constexpr unsigned int CB_HW_CONTROL_1__GLX_PERF_CNTR_EN_MASK             = 0x80000000;
constexpr unsigned int CB_HW_CONTROL_1__GLX_VQID_MASK                     = 0x78000000;
constexpr unsigned int CB_HW_CONTROL_2__RESERVED_MASK                     = 0x00000001;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_OPT_WA_AND_FULLY_COVERED_MASK = 0x00200000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_CLEAR_KEY_OVERRIDE_FROM_ILLEGAL_DECODE_MASK = 0x08000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_256B_CLEARS_BECOME_1FRAG_MASK = 0x20000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_INSERT_BUBBLES_B2B_MASK = 0x04000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_OVERRIDE_ROH_COMP_MASK = 0x02000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_WAIT_SECOND_64B_MASK = 0x10000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SHADER_BLEND_OPTS_MASK    = 0x00000080;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_GLX_REQ_CLKEN_HIGH_MASK     = 0x00000008;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_GLX_SRC_CLKEN_HIGH_MASK     = 0x00000010;
constexpr unsigned int CB_HW_CONTROL_3__SPLIT_ALL_FAST_MODE_TRANSFERS_MASK = 0x00000040;
constexpr unsigned int CB_HW_CONTROL_4__DISABLE_FRAGOP_MULTI_FRAGMENT_MASK = 0x00004000;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_COARSE_RAW_HAZARD_MASK = 0x00020000;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_DS_RAW_HAZARD_MASK = 0x00040000;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_RAW_HAZARD_MASK = 0x00010000;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_READ_RESIDENCY_TIMEOUT_CNTR_MASK = 0x00000001;
constexpr unsigned int CB_HW_CONTROL_4__THRESHOLD_READ_RESIDENCY_TIMEOUT_CNTR_MASK = 0x00000006;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_BYPASS_MASK       = 0x02000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DISCARD_PIXEL_MASK = 0x04000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DONT_RD_DST_MASK  = 0x01000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_RESULT_EQ_DEST_MASK = 0x00200000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_WHEN_DISABLED_SRCALPHA_IS_USED_MASK = 0x08000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_EVICT_ILLEGAL_KEY_OVERRIDE_MASK = 0x00008000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_FMASK_REREAD_OPT_MASK       = 0x40000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_GRBM_BUSY_CNTR_MASK         = 0x00000001;
constexpr unsigned int CB_HW_CONTROL__DISABLE_HOLE_COLLAPSE_MASK          = 0x20000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_MULTICYCLE_WRITES_MASK      = 0x10000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_POWER_OPT_HC_MASK           = 0x00800000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_USE_OF_SET_HASH_MASK        = 0x00100000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_VRS_FILLRATE_OPTIMIZATION_MASK = 0x00000002;
constexpr unsigned int CB_HW_CONTROL__ENABLE_SINGLE_KEY_WR_OPT_MASK       = 0x00400000;
constexpr unsigned int CB_HW_CONTROL__EN_KEY_OVERRIDE_MASK                = 0x80000000;
constexpr unsigned int CB_HW_CONTROL__FORCE_EVICT_ALL_VALID_MASK          = 0x00010000;
constexpr unsigned int CB_HW_CONTROL__FORCE_NEEDS_DST_MASK                = 0x00080000;
constexpr unsigned int CB_HW_CONTROL__FORCE_WAIT_EOP_DONE_FLUSH_MASK      = 0x00040000;
constexpr unsigned int CB_HW_CONTROL__GLX_CREDITS_MASK                    = 0x000003c0;
constexpr unsigned int CB_HW_CONTROL__NUM_CCC_SKID_FIFO_ENTRIES_MASK      = 0x00007000;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__ARB_MODE_MASK               = 0x00000001;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CREDIT_MODE_MASK       = 0x10000000;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CRED_CNT_MAX_MASK      = 0x00000f80;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CYC_WEIGHT_MASK        = 0x0000003e;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CREDIT_MODE_MASK      = 0x08000000;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CRED_CNT_MAX_MASK     = 0x00f80000;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CYC_WEIGHT_MASK       = 0x0003e000;
constexpr unsigned int CB_MEM0_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM0_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM1_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM1_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM2_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM2_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM3_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM3_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM4_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM4_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM5_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM5_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM6_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM6_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_MEM7_INFO__TEMPORAL_READ_MASK                   = 0x00000007;
constexpr unsigned int CB_MEM7_INFO__TEMPORAL_WRITE_MASK                  = 0x00000038;
constexpr unsigned int CB_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int CB_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int CB_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int CB_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_ENABLE_MASK    = 0x00000400;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_SEL_MASK       = 0x00000800;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_ENABLE_MASK   = 0x00000010;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_SEL_MASK      = 0x000003e0;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_ENABLE_MASK      = 0x00001000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_SEL_MASK         = 0x0000e000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_ENABLE_MASK = 0x00200000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_SEL_MASK = 0x00c00000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_ENABLE_MASK = 0x00020000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_SEL_MASK = 0x001c0000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_ENABLE_MASK       = 0x00000001;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_SEL_MASK          = 0x0000000e;
constexpr unsigned int CB_READ_RESP_KEY_OVERRIDE__KEY_IDX_MASK            = 0x000000ff;
constexpr unsigned int CB_READ_RESP_KEY_OVERRIDE__NEW_KEY_VALUE_MASK      = 0x0000ff00;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_L3_BYPASS_MASK     = 0x08000000;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_RD_POLICY_MASK     = 0x00c00000;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_WR_POLICY_MASK     = 0x0000000c;
constexpr unsigned int CB_SHADER_MASK__OUTPUT0_ENABLE_MASK                = 0x0000000f;
constexpr unsigned int CB_SHADER_MASK__OUTPUT1_ENABLE_MASK                = 0x000000f0;
constexpr unsigned int CB_SHADER_MASK__OUTPUT2_ENABLE_MASK                = 0x00000f00;
constexpr unsigned int CB_SHADER_MASK__OUTPUT3_ENABLE_MASK                = 0x0000f000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT4_ENABLE_MASK                = 0x000f0000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT5_ENABLE_MASK                = 0x00f00000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT6_ENABLE_MASK                = 0x0f000000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT7_ENABLE_MASK                = 0xf0000000;
constexpr unsigned int CB_TARGET_MASK__TARGET0_ENABLE_MASK                = 0x0000000f;
constexpr unsigned int CB_TARGET_MASK__TARGET1_ENABLE_MASK                = 0x000000f0;
constexpr unsigned int CB_TARGET_MASK__TARGET2_ENABLE_MASK                = 0x00000f00;
constexpr unsigned int CB_TARGET_MASK__TARGET3_ENABLE_MASK                = 0x0000f000;
constexpr unsigned int CB_TARGET_MASK__TARGET4_ENABLE_MASK                = 0x000f0000;
constexpr unsigned int CB_TARGET_MASK__TARGET5_ENABLE_MASK                = 0x00f00000;
constexpr unsigned int CB_TARGET_MASK__TARGET6_ENABLE_MASK                = 0x0f000000;
constexpr unsigned int CB_TARGET_MASK__TARGET7_ENABLE_MASK                = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK          = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK          = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int COHER_DEST_BASE_0__DEST_BASE_256B_MASK             = 0xffffffff;
constexpr unsigned int COHER_DEST_BASE_1__DEST_BASE_256B_MASK             = 0xffffffff;
constexpr unsigned int COHER_DEST_BASE_2__DEST_BASE_256B_MASK             = 0xffffffff;
constexpr unsigned int COHER_DEST_BASE_3__DEST_BASE_256B_MASK             = 0xffffffff;
constexpr unsigned int COHER_DEST_BASE_HI_0__DEST_BASE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int COHER_DEST_BASE_HI_1__DEST_BASE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int COHER_DEST_BASE_HI_2__DEST_BASE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int COHER_DEST_BASE_HI_3__DEST_BASE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int COMPUTE_DDID_INDEX__INDEX_MASK                     = 0x000007ff;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE0__CU_EN_MASK             = 0xffffffff;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE1__CU_EN_MASK             = 0xffffffff;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE2__CU_EN_MASK             = 0xffffffff;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE3__CU_EN_MASK             = 0xffffffff;
constexpr unsigned int COMPUTE_DIM_X__SIZE_MASK                           = 0xffffffff;
constexpr unsigned int COMPUTE_DIM_Y__SIZE_MASK                           = 0xffffffff;
constexpr unsigned int COMPUTE_DIM_Z__SIZE_MASK                           = 0xffffffff;
constexpr unsigned int COMPUTE_DISPATCH_END__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_DISPATCH_ID__DISPATCH_ID_MASK              = 0xffffffff;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__AMP_SHADER_EN_MASK     = 0x00010000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN_MASK = 0x00000001;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__CS_W32_EN_MASK         = 0x00008000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__DISABLE_DISP_PREMPT_EN_MASK = 0x00020000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000_MASK = 0x00000004;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__INTERLEAVE_2D_EN_MASK  = 0x00040000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL_MASK = 0x00000008;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE_MASK = 0x00000010;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDER_MODE_MASK        = 0x00000040;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN_MASK     = 0x00000002;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PING_PONG_EN_MASK      = 0x00001000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESTORE_MASK           = 0x00004000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL_MASK = 0x00000400;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TTRACE_QUEUE_ID_MASK   = 0xe0000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE_MASK     = 0x00002000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS_MASK = 0x00000020;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL_MASK = 0x00000800;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__WGS_DISPATCH_MASK      = 0x00080000;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_1D_MASK    = 0x000003ff;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_X_SIZE_MASK = 0x000f0000;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_Y_SIZE_MASK = 0x0f000000;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_HI__DATA_MASK            = 0x000000ff;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_LO__DATA_MASK            = 0xffffffff;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA_MASK        = 0x000000ff;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA_MASK        = 0xffffffff;
constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__OFF_DELAY_MASK            = 0x00001fff;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED4_MASK              = 0x00000010;
constexpr unsigned int COMPUTE_MISC_RESERVED__SEND_SEID_MASK              = 0x0000000f;
constexpr unsigned int COMPUTE_MISC_RESERVED__WAVE_ID_BASE_MASK           = 0x0001ffe0;
constexpr unsigned int COMPUTE_NOWHERE__DATA_MASK                         = 0xffffffff;
constexpr unsigned int COMPUTE_NUM_THREAD_X__INTERLEAVE_BITS_X_MASK       = 0x0000e000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL_MASK         = 0x00001fff;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL_MASK      = 0xffff0000;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__INTERLEAVE_BITS_Y_MASK       = 0x0000e000;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL_MASK         = 0x00001fff;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL_MASK      = 0xffff0000;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL_MASK         = 0x0000ffff;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL_MASK      = 0xffff0000;
constexpr unsigned int COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE_MASK    = 0x00000001;
constexpr unsigned int COMPUTE_PGM_HI__DATA_MASK                          = 0x000000ff;
constexpr unsigned int COMPUTE_PGM_LO__DATA_MASK                          = 0xffffffff;
constexpr unsigned int COMPUTE_PGM_RSRC1__BULKY_MASK                      = 0x01000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__CDBG_USER_MASK                  = 0x02000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__DEBUG_MODE_MASK                 = 0x00400000;
constexpr unsigned int COMPUTE_PGM_RSRC1__DISABLE_PERF_MASK               = 0x00800000;
constexpr unsigned int COMPUTE_PGM_RSRC1__FLOAT_MODE_MASK                 = 0x000ff000;
constexpr unsigned int COMPUTE_PGM_RSRC1__FP16_OVFL_MASK                  = 0x04000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__FWD_PROGRESS_MASK               = 0x80000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__MEM_ORDERED_MASK                = 0x40000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIORITY_MASK                   = 0x00000c00;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIV_MASK                       = 0x00100000;
constexpr unsigned int COMPUTE_PGM_RSRC1__SGPRS_MASK                      = 0x000003c0;
constexpr unsigned int COMPUTE_PGM_RSRC1__VGPRS_MASK                      = 0x0000003f;
constexpr unsigned int COMPUTE_PGM_RSRC1__WGP_MODE_MASK                   = 0x20000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__WG_RR_EN_MASK                   = 0x00200000;
constexpr unsigned int COMPUTE_PGM_RSRC2__DYNAMIC_VGPR_MASK               = 0x00000040;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MASK                    = 0x7f000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MSB_MASK                = 0x00006000;
constexpr unsigned int COMPUTE_PGM_RSRC2__LDS_SIZE_MASK                   = 0x00ff8000;
constexpr unsigned int COMPUTE_PGM_RSRC2__SCRATCH_EN_MASK                 = 0x00000001;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_X_EN_MASK                  = 0x00000080;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Y_EN_MASK                  = 0x00000100;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Z_EN_MASK                  = 0x00000200;
constexpr unsigned int COMPUTE_PGM_RSRC2__TG_SIZE_EN_MASK                 = 0x00000400;
constexpr unsigned int COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT_MASK             = 0x00001800;
constexpr unsigned int COMPUTE_PGM_RSRC2__USER_SGPR_MASK                  = 0x0000003e;
constexpr unsigned int COMPUTE_PGM_RSRC2__WGP_TAKEOVER_MASK               = 0x80000000;
constexpr unsigned int COMPUTE_PGM_RSRC3__GLG_EN_MASK                     = 0x00002000;
constexpr unsigned int COMPUTE_PGM_RSRC3__IMAGE_OP_MASK                   = 0x80000000;
constexpr unsigned int COMPUTE_PGM_RSRC3__INST_PREF_SIZE_MASK             = 0x00000ff0;
constexpr unsigned int COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT_MASK            = 0x0000000f;
constexpr unsigned int COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE_MASK = 0x00000001;
constexpr unsigned int COMPUTE_PRESCALED_DIM_X__SIZE_MASK                 = 0xffffffff;
constexpr unsigned int COMPUTE_PRESCALED_DIM_Y__SIZE_MASK                 = 0xffffffff;
constexpr unsigned int COMPUTE_PRESCALED_DIM_Z__SIZE_MASK                 = 0xffffffff;
constexpr unsigned int COMPUTE_RELAUNCH2__IS_EVENT_MASK                   = 0x40000000;
constexpr unsigned int COMPUTE_RELAUNCH2__IS_STATE_MASK                   = 0x80000000;
constexpr unsigned int COMPUTE_RELAUNCH2__PAYLOAD_MASK                    = 0x3fffffff;
constexpr unsigned int COMPUTE_RELAUNCH__IS_EVENT_MASK                    = 0x40000000;
constexpr unsigned int COMPUTE_RELAUNCH__IS_STATE_MASK                    = 0x80000000;
constexpr unsigned int COMPUTE_RELAUNCH__PAYLOAD_MASK                     = 0x3fffffff;
constexpr unsigned int COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000;
constexpr unsigned int COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT_MASK = 0x07f00000;
constexpr unsigned int COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN_MASK          = 0x00010000;
constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS_MASK        = 0x00000200;
constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD_MASK     = 0x00007c00;
constexpr unsigned int COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU_MASK   = 0x0000001e;
constexpr unsigned int COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT_MASK    = 0x00008000;
constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0;
constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_EN_MASK            = 0x00000001;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT_MASK       = 0x07000000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST_MASK      = 0x00800000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD_MASK       = 0x003f0000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL_MASK       = 0x00400000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__TG_PER_CU_MASK            = 0x0000f000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH_MASK         = 0x000003ff;
constexpr unsigned int COMPUTE_RESTART_X__RESTART_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_RESTART_Y__RESTART_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_RESTART_Z__RESTART_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_SHADER_CHKSUM__CHECKSUM_MASK               = 0xffffffff;
constexpr unsigned int COMPUTE_START_X__START_MASK                        = 0xffffffff;
constexpr unsigned int COMPUTE_START_Y__START_MASK                        = 0xffffffff;
constexpr unsigned int COMPUTE_START_Z__START_MASK                        = 0xffffffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE4__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE4__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE5__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE5__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE6__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE6__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE7__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE7__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE8__SA0_CU_EN_MASK     = 0x0000ffff;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE8__SA1_CU_EN_MASK     = 0xffff0000;
constexpr unsigned int COMPUTE_THREADGROUP_ID__THREADGROUP_ID_MASK        = 0xffffffff;
constexpr unsigned int COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE_MASK = 0x00000001;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVESIZE_MASK                = 0x3ffff000;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVES_MASK                   = 0x00000fff;
constexpr unsigned int COMPUTE_USER_ACCUM_0__CONTRIBUTION_MASK            = 0x0000007f;
constexpr unsigned int COMPUTE_USER_ACCUM_1__CONTRIBUTION_MASK            = 0x0000007f;
constexpr unsigned int COMPUTE_USER_ACCUM_2__CONTRIBUTION_MASK            = 0x0000007f;
constexpr unsigned int COMPUTE_USER_ACCUM_3__CONTRIBUTION_MASK            = 0x0000007f;
constexpr unsigned int COMPUTE_USER_DATA_0__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_1__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_2__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_3__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_4__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_5__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_6__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_7__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_8__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_9__DATA_MASK                     = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_10__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_11__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_12__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_13__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_14__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_USER_DATA_15__DATA_MASK                    = 0xffffffff;
constexpr unsigned int COMPUTE_VMID__DATA_MASK                            = 0x0000000f;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR_MASK            = 0x0000ffff;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR_MASK            = 0xffffffff;
constexpr unsigned int CPC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK          = 0xf0000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK          = 0x0f000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK           = 0xf0000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int CPC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0xf0000000;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CPF_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPF_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK          = 0xf0000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK          = 0x0f000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK           = 0xf0000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int CPF_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPF_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0xf0000000;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CPG_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPG_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK          = 0xf0000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK          = 0x0f000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK           = 0xf0000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK           = 0x0f000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int CPG_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int CPG_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0xf0000000;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int CP_DMA_CNTL__BUFFER_DEPTH_MASK                     = 0x01ff0000;
constexpr unsigned int CP_DMA_CNTL__MIN_AVAILSZ_MASK                      = 0x00000030;
constexpr unsigned int CP_DMA_CNTL__PIO_COUNT_MASK                        = 0xc0000000;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_EMPTY_MASK                   = 0x10000000;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_FULL_MASK                    = 0x20000000;
constexpr unsigned int CP_DMA_CNTL__SPECULATIVE_DATA_READ_MASK            = 0x000000c0;
constexpr unsigned int CP_DMA_CNTL__UTCL1_FAULT_CONTROL_MASK              = 0x00000001;
constexpr unsigned int CP_DMA_CNTL__WATCH_CONTROL_MASK                    = 0x00000002;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__ADDR_HI_MASK                = 0x0000ffff;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__RSVD_MASK                   = 0xffff0000;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__ADDR_LO_MASK                = 0xfffffffc;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__RSVD_MASK                   = 0x00000003;
constexpr unsigned int CP_DMA_ME_COMMAND__BYTE_COUNT_MASK                 = 0x03ffffff;
constexpr unsigned int CP_DMA_ME_COMMAND__DAIC_MASK                       = 0x20000000;
constexpr unsigned int CP_DMA_ME_COMMAND__DAS_MASK                        = 0x08000000;
constexpr unsigned int CP_DMA_ME_COMMAND__DIS_WC_MASK                     = 0x80000000;
constexpr unsigned int CP_DMA_ME_COMMAND__RAW_WAIT_MASK                   = 0x40000000;
constexpr unsigned int CP_DMA_ME_COMMAND__SAIC_MASK                       = 0x10000000;
constexpr unsigned int CP_DMA_ME_COMMAND__SAS_MASK                        = 0x04000000;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_CACHE_POLICY_MASK           = 0x06000000;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_SELECT_MASK                 = 0x00300000;
constexpr unsigned int CP_DMA_ME_CONTROL__MEMLOG_CLEAR_MASK               = 0x00000400;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_CACHE_POLICY_MASK           = 0x00006000;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_SELECT_MASK                 = 0x60000000;
constexpr unsigned int CP_DMA_ME_CONTROL__VMID_MASK                       = 0x0000000f;
constexpr unsigned int CP_DMA_ME_DST_ADDR_HI__DST_ADDR_HI_MASK            = 0x0000ffff;
constexpr unsigned int CP_DMA_ME_DST_ADDR__DST_ADDR_MASK                  = 0xffffffff;
constexpr unsigned int CP_DMA_ME_SRC_ADDR_HI__SRC_ADDR_HI_MASK            = 0x0000ffff;
constexpr unsigned int CP_DMA_ME_SRC_ADDR__SRC_ADDR_MASK                  = 0xffffffff;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__ADDR_HI_MASK               = 0x0000ffff;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__RSVD_MASK                  = 0xffff0000;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__ADDR_LO_MASK               = 0xfffffffc;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__RSVD_MASK                  = 0x00000003;
constexpr unsigned int CP_DMA_PFP_COMMAND__BYTE_COUNT_MASK                = 0x03ffffff;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAIC_MASK                      = 0x20000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAS_MASK                       = 0x08000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__DIS_WC_MASK                    = 0x80000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__RAW_WAIT_MASK                  = 0x40000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAIC_MASK                      = 0x10000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAS_MASK                       = 0x04000000;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_CACHE_POLICY_MASK          = 0x06000000;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_SELECT_MASK                = 0x00300000;
constexpr unsigned int CP_DMA_PFP_CONTROL__MEMLOG_CLEAR_MASK              = 0x00000400;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_CACHE_POLICY_MASK          = 0x00006000;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_SELECT_MASK                = 0x60000000;
constexpr unsigned int CP_DMA_PFP_CONTROL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_PFP_DST_ADDR_HI__DST_ADDR_HI_MASK           = 0x0000ffff;
constexpr unsigned int CP_DMA_PFP_DST_ADDR__DST_ADDR_MASK                 = 0xffffffff;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR_HI__SRC_ADDR_HI_MASK           = 0x0000ffff;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR__SRC_ADDR_MASK                 = 0xffffffff;
constexpr unsigned int CP_DMA_PIO_COMMAND__BYTE_COUNT_MASK                = 0x03ffffff;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAIC_MASK                      = 0x20000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAS_MASK                       = 0x08000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__DIS_WC_MASK                    = 0x80000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__RAW_WAIT_MASK                  = 0x40000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAIC_MASK                      = 0x10000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAS_MASK                       = 0x04000000;
constexpr unsigned int CP_DMA_PIO_CONTROL__DST_CACHE_POLICY_MASK          = 0x06000000;
constexpr unsigned int CP_DMA_PIO_CONTROL__DST_SELECT_MASK                = 0x00300000;
constexpr unsigned int CP_DMA_PIO_CONTROL__MEMLOG_CLEAR_MASK              = 0x00000400;
constexpr unsigned int CP_DMA_PIO_CONTROL__SRC_CACHE_POLICY_MASK          = 0x00006000;
constexpr unsigned int CP_DMA_PIO_CONTROL__SRC_SELECT_MASK                = 0x60000000;
constexpr unsigned int CP_DMA_PIO_CONTROL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_PIO_DST_ADDR_HI__DST_ADDR_HI_MASK           = 0x0000ffff;
constexpr unsigned int CP_DMA_PIO_DST_ADDR__DST_ADDR_MASK                 = 0xffffffff;
constexpr unsigned int CP_DMA_PIO_SRC_ADDR_HI__SRC_ADDR_HI_MASK           = 0x0000ffff;
constexpr unsigned int CP_DMA_PIO_SRC_ADDR__SRC_ADDR_MASK                 = 0xffffffff;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_MASK                = 0x03ffffff;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_VALID_MASK          = 0x10000000;
constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__ADDR_HI_MASK                = 0x0000ffff;
constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__RSVD_MASK                   = 0xffff0000;
constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__ADDR_LO_MASK                = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__RSVD_MASK                   = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH0_CNTL__ANY_VMID_MASK                  = 0x00000400;
constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD1_MASK                     = 0x000000f0;
constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD2_MASK                     = 0xfffff800;
constexpr unsigned int CP_DMA_WATCH0_CNTL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_READS_MASK               = 0x00000100;
constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_WRITES_MASK              = 0x00000200;
constexpr unsigned int CP_DMA_WATCH0_MASK__MASK_MASK                      = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH0_MASK__RSVD_MASK                      = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__ADDR_HI_MASK                = 0x0000ffff;
constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__RSVD_MASK                   = 0xffff0000;
constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__ADDR_LO_MASK                = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__RSVD_MASK                   = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH1_CNTL__ANY_VMID_MASK                  = 0x00000400;
constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD1_MASK                     = 0x000000f0;
constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD2_MASK                     = 0xfffff800;
constexpr unsigned int CP_DMA_WATCH1_CNTL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_READS_MASK               = 0x00000100;
constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_WRITES_MASK              = 0x00000200;
constexpr unsigned int CP_DMA_WATCH1_MASK__MASK_MASK                      = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH1_MASK__RSVD_MASK                      = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__ADDR_HI_MASK                = 0x0000ffff;
constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__RSVD_MASK                   = 0xffff0000;
constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__ADDR_LO_MASK                = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__RSVD_MASK                   = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH2_CNTL__ANY_VMID_MASK                  = 0x00000400;
constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD1_MASK                     = 0x000000f0;
constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD2_MASK                     = 0xfffff800;
constexpr unsigned int CP_DMA_WATCH2_CNTL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_READS_MASK               = 0x00000100;
constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_WRITES_MASK              = 0x00000200;
constexpr unsigned int CP_DMA_WATCH2_MASK__MASK_MASK                      = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH2_MASK__RSVD_MASK                      = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__ADDR_HI_MASK                = 0x0000ffff;
constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__RSVD_MASK                   = 0xffff0000;
constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__ADDR_LO_MASK                = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__RSVD_MASK                   = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH3_CNTL__ANY_VMID_MASK                  = 0x00000400;
constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD1_MASK                     = 0x000000f0;
constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD2_MASK                     = 0xfffff800;
constexpr unsigned int CP_DMA_WATCH3_CNTL__VMID_MASK                      = 0x0000000f;
constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_READS_MASK               = 0x00000100;
constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_WRITES_MASK              = 0x00000200;
constexpr unsigned int CP_DMA_WATCH3_MASK__MASK_MASK                      = 0xffffff00;
constexpr unsigned int CP_DMA_WATCH3_MASK__RSVD_MASK                      = 0x000000ff;
constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_HI__ADDR_HI_MASK            = 0x0000ffff;
constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_LO__ADDR_LO_MASK            = 0xfffffffc;
constexpr unsigned int CP_DMA_WATCH_STAT__CLIENT_ID_MASK                  = 0x00000700;
constexpr unsigned int CP_DMA_WATCH_STAT__PIPE_MASK                       = 0x00003000;
constexpr unsigned int CP_DMA_WATCH_STAT__QUEUE_ID_MASK                   = 0x00000070;
constexpr unsigned int CP_DMA_WATCH_STAT__RD_WR_MASK                      = 0x00100000;
constexpr unsigned int CP_DMA_WATCH_STAT__TRAP_FLAG_MASK                  = 0x80000000;
constexpr unsigned int CP_DMA_WATCH_STAT__VMID_MASK                       = 0x0000000f;
constexpr unsigned int CP_DMA_WATCH_STAT__WATCH_ID_MASK                   = 0x00030000;
constexpr unsigned int CP_EOP_DONE_ADDR_HI__ADDR_HI_MASK                  = 0x0000ffff;
constexpr unsigned int CP_EOP_DONE_ADDR_LO__ADDR_LO_MASK                  = 0xfffffffc;
constexpr unsigned int CP_EOP_DONE_CNTX_ID__CNTX_ID_MASK                  = 0xffffffff;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__ACTION_ID_MASK              = 0x00c00000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__ACTION_PIPE_ID_MASK         = 0x00300000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DATA_SEL_MASK               = 0xe0000000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DST_SEL_MASK                = 0x00030000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__INT_SEL_MASK                = 0x07000000;
constexpr unsigned int CP_EOP_DONE_DATA_HI__DATA_HI_MASK                  = 0xffffffff;
constexpr unsigned int CP_EOP_DONE_DATA_LO__DATA_LO_MASK                  = 0xffffffff;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__CACHE_POLICY_MASK          = 0x06000000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EXECUTE_MASK               = 0x10000000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GCR_CNTL_MASK              = 0x01fff000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GLK_INV_MASK               = 0x40000000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__PWS_ENABLE_MASK            = 0x80000000;
constexpr unsigned int CP_EOP_LAST_FENCE_HI__LAST_FENCE_HI_MASK           = 0xffffffff;
constexpr unsigned int CP_EOP_LAST_FENCE_LO__LAST_FENCE_LO_MASK           = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_BASE0__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_BASE1__BASE_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__BYPASS_MODE_MASK   = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__ENABLE_MASK        = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__SCOPE_MASK         = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__TEMPORAL_MASK      = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__VMID_MASK          = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_MASK0__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_MASK1__MASK_MASK          = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_BASE0__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_BASE1__BASE_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__BYPASS_MODE_MASK  = 0x00000010;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__ENABLE_MASK       = 0x00000020;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__SCOPE_MASK        = 0x000000c0;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__TEMPORAL_MASK     = 0x00000700;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__VMID_MASK         = 0x0000000f;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_MASK0__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_MASK1__MASK_MASK         = 0xffffffff;
constexpr unsigned int CP_GFX_RS64_PERFCOUNT_CNTL0__EVENT_SEL_MASK        = 0x0000001f;
constexpr unsigned int CP_GFX_RS64_PERFCOUNT_CNTL1__EVENT_SEL_MASK        = 0x0000001f;
constexpr unsigned int CP_HQD_ACTIVE__ACTIVE_MASK                         = 0x00000001;
constexpr unsigned int CP_HQD_ACTIVE__BUSY_GATE_MASK                      = 0x00000002;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_EN_MASK               = 0x00008000;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_MASK                  = 0x00007fff;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_EN_MASK               = 0x80000000;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_MASK                  = 0x7fff0000;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_HI__ATOMIC0_PREOP_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_LO__ATOMIC0_PREOP_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_HI__ATOMIC1_PREOP_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_LO__ATOMIC1_PREOP_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_HQD_CNTL_STACK_OFFSET__OFFSET_MASK              = 0x0000fffc;
constexpr unsigned int CP_HQD_CNTL_STACK_SIZE__SIZE_MASK                  = 0x0000f000;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_HI__ADDR_HI_MASK         = 0x0000ffff;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_LO__ADDR_MASK            = 0xfffff000;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__EXE_DISABLE_MASK          = 0x00800000;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__POLICY_MASK               = 0x00000018;
constexpr unsigned int CP_HQD_CTX_SAVE_SIZE__SIZE_MASK                    = 0x03fff000;
constexpr unsigned int CP_HQD_DDID_DELTA_RPT_COUNT__COUNT_MASK            = 0x000000ff;
constexpr unsigned int CP_HQD_DDID_INFLIGHT_COUNT__COUNT_MASK             = 0x0000ffff;
constexpr unsigned int CP_HQD_DDID_RPTR__RPTR_MASK                        = 0x000007ff;
constexpr unsigned int CP_HQD_DDID_WPTR__WPTR_MASK                        = 0x000007ff;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_INT_MASK           = 0x00000100;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN_MASK        = 0x00000400;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_MASK           = 0x0000000f;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN_MASK        = 0x00000200;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_MASK           = 0x00000010;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_EN_MASK        = 0x00000400;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_MASK           = 0x0000000f;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_EN_MASK    = 0x00000200;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_MASK       = 0x00000010;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__AQL_OFFLOAD_EN_MASK            = 0x00000008;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__AQL_OFFLOAD_MASK               = 0x00000004;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD_EN_MASK            = 0x00000002;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD_MASK               = 0x00000001;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__EOP_OFFLOAD_EN_MASK            = 0x00000020;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__EOP_OFFLOAD_MASK               = 0x00000010;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR_HI__BASE_ADDR_HI_MASK         = 0x000000ff;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR__BASE_ADDR_MASK               = 0xffffffff;
constexpr unsigned int CP_HQD_EOP_CONTROL__CACHE_POLICY_MASK              = 0x03000000;
constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_SIZE_MASK                  = 0x0000003f;
constexpr unsigned int CP_HQD_EOP_CONTROL__EXE_DISABLE_MASK               = 0x00800000;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_EN_MASK           = 0x00400000;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_MASK              = 0x00200000;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOPIB_MASK          = 0x00002000;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOP_MASK            = 0x00000100;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOPIB_EN_MASK          = 0x00004000;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOP_EN_MASK            = 0x00001000;
constexpr unsigned int CP_HQD_EOP_EVENTS__CS_PARTIAL_FLUSH_PEND_MASK      = 0x00010000;
constexpr unsigned int CP_HQD_EOP_EVENTS__EVENT_COUNT_MASK                = 0x00000fff;
constexpr unsigned int CP_HQD_EOP_RPTR__DEQUEUE_PEND_MASK                 = 0x20000000;
constexpr unsigned int CP_HQD_EOP_RPTR__INIT_FETCHER_MASK                 = 0x80000000;
constexpr unsigned int CP_HQD_EOP_RPTR__RESET_FETCHER_MASK                = 0x10000000;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_EQ_CSMD_WPTR_MASK            = 0x40000000;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_MASK                         = 0x00001fff;
constexpr unsigned int CP_HQD_EOP_WPTR_MEM__WPTR_MASK                     = 0x00001fff;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_AVAIL_MASK                    = 0x1fff0000;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_EMPTY_MASK                    = 0x00008000;
constexpr unsigned int CP_HQD_EOP_WPTR__WPTR_MASK                         = 0x00001fff;
constexpr unsigned int CP_HQD_ERROR__AQL_ERROR_MASK                       = 0x00000020;
constexpr unsigned int CP_HQD_ERROR__DMA_DST_UTCL1_ERROR_MASK             = 0x00010000;
constexpr unsigned int CP_HQD_ERROR__DMA_SRC_UTCL1_ERROR_MASK             = 0x00008000;
constexpr unsigned int CP_HQD_ERROR__EDC_ERROR_ID_MASK                    = 0x0000000f;
constexpr unsigned int CP_HQD_ERROR__EOP_UTCL1_ERROR_MASK                 = 0x00000400;
constexpr unsigned int CP_HQD_ERROR__IB_UTCL1_ERROR_MASK                  = 0x00000200;
constexpr unsigned int CP_HQD_ERROR__IQ_UTCL1_ERROR_MASK                  = 0x00000800;
constexpr unsigned int CP_HQD_ERROR__PQ_UTCL1_ERROR_MASK                  = 0x00000100;
constexpr unsigned int CP_HQD_ERROR__QU_UTCL1_ERROR_MASK                  = 0x00040000;
constexpr unsigned int CP_HQD_ERROR__RRPT_UTCL1_ERROR_MASK                = 0x00001000;
constexpr unsigned int CP_HQD_ERROR__SR_UTCL1_ERROR_MASK                  = 0x00020000;
constexpr unsigned int CP_HQD_ERROR__SUA_ERROR_MASK                       = 0x00000010;
constexpr unsigned int CP_HQD_ERROR__TC_UTCL1_ERROR_MASK                  = 0x00080000;
constexpr unsigned int CP_HQD_ERROR__WPP_UTCL1_ERROR_MASK                 = 0x00002000;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__GWS_PNTR_MASK           = 0x0003f000;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__GWS_SIZE_MASK           = 0x000003f0;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__OA_ACQUIRED_MASK        = 0x00000002;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__OA_REQUIRED_MASK        = 0x00000001;
constexpr unsigned int CP_HQD_GFX_CONTROL__DB_UPDATED_MSG_EN_MASK         = 0x00008000;
constexpr unsigned int CP_HQD_GFX_CONTROL__MESSAGE_MASK                   = 0x0000000f;
constexpr unsigned int CP_HQD_GFX_CONTROL__MISC_MASK                      = 0x00007ff0;
constexpr unsigned int CP_HQD_GFX_STATUS__STATUS_MASK                     = 0x0000ffff;
constexpr unsigned int CP_HQD_HQ_CONTROL0__CONTROL_MASK                   = 0xffffffff;
constexpr unsigned int CP_HQD_HQ_CONTROL1__CONTROL_MASK                   = 0xffffffff;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__CONCURRENT_PROCESS_COUNT_MASK = 0x0f000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__CWSR_MASK                    = 0x00000001;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_INHERIT_VMID_MASK          = 0x00000200;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_QUEUE_DEBUG_EN_MASK        = 0x00004000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_QUEUE_USE_GWS_MASK         = 0x00002000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__DB_UPDATED_MSG_EN_MASK       = 0x80000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__MES_INTERRUPT_ENABLED_MASK   = 0x00100000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__MES_INTERRUPT_PIPE_MASK      = 0x00600000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_IDLE_MASK              = 0x40000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_RUN_ONCE_MASK          = 0x00000040;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_SCHEDULER_TYPE_MASK    = 0x00001c00;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_SLOT_CONNECTED_MASK    = 0x00008000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__RSRV_MASK                    = 0x00000004;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SAVE_STATUS_MASK             = 0x00000002;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SCRATCH_RAM_INIT_MASK        = 0x00000080;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__STATIC_QUEUE_MASK            = 0x00000038;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__TCL2_DIRTY_MASK              = 0x00000100;
constexpr unsigned int CP_HQD_HQ_SCHEDULER1__SCHEDULER_MASK               = 0xffffffff;
constexpr unsigned int CP_HQD_HQ_STATUS0__CONCURRENT_PROCESS_COUNT_MASK   = 0x0f000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__CWSR_MASK                       = 0x00000001;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_INHERIT_VMID_MASK             = 0x00000200;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_QUEUE_DEBUG_EN_MASK           = 0x00004000;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_QUEUE_USE_GWS_MASK            = 0x00002000;
constexpr unsigned int CP_HQD_HQ_STATUS0__DB_UPDATED_MSG_EN_MASK          = 0x80000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__MES_INTERRUPT_ENABLED_MASK      = 0x00100000;
constexpr unsigned int CP_HQD_HQ_STATUS0__MES_INTERRUPT_PIPE_MASK         = 0x00600000;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_IDLE_MASK                 = 0x40000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_RUN_ONCE_MASK             = 0x00000040;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_SCHEDULER_TYPE_MASK       = 0x00001c00;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_SLOT_CONNECTED_MASK       = 0x00008000;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSRV_MASK                       = 0x00000004;
constexpr unsigned int CP_HQD_HQ_STATUS0__SAVE_STATUS_MASK                = 0x00000002;
constexpr unsigned int CP_HQD_HQ_STATUS0__SCRATCH_RAM_INIT_MASK           = 0x00000080;
constexpr unsigned int CP_HQD_HQ_STATUS0__STATIC_QUEUE_MASK               = 0x00000038;
constexpr unsigned int CP_HQD_HQ_STATUS0__TCL2_DIRTY_MASK                 = 0x00000100;
constexpr unsigned int CP_HQD_HQ_STATUS1__STATUS_MASK                     = 0xffffffff;
constexpr unsigned int CP_HQD_IB_BASE_ADDR_HI__IB_BASE_ADDR_HI_MASK       = 0x0000ffff;
constexpr unsigned int CP_HQD_IB_BASE_ADDR__IB_BASE_ADDR_MASK             = 0xfffffffc;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_CACHE_POLICY_MASK            = 0x03000000;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_EXE_DISABLE_MASK             = 0x00800000;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_PRIV_STATE_MASK              = 0x40000000;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_SIZE_MASK                    = 0x000fffff;
constexpr unsigned int CP_HQD_IB_CONTROL__MIN_IB_AVAIL_SIZE_MASK          = 0x00300000;
constexpr unsigned int CP_HQD_IB_CONTROL__PROCESSING_IB_MASK              = 0x80000000;
constexpr unsigned int CP_HQD_IB_RPTR__CONSUMED_OFFSET_MASK               = 0x000fffff;
constexpr unsigned int CP_HQD_IQ_RPTR__OFFSET_MASK                        = 0x0000003f;
constexpr unsigned int CP_HQD_IQ_TIMER__ACTIVE_MASK                       = 0x80000000;
constexpr unsigned int CP_HQD_IQ_TIMER__CACHE_POLICY_MASK                 = 0x03000000;
constexpr unsigned int CP_HQD_IQ_TIMER__CLOCK_COUNT_MASK                  = 0x0000c000;
constexpr unsigned int CP_HQD_IQ_TIMER__EXE_DISABLE_MASK                  = 0x00800000;
constexpr unsigned int CP_HQD_IQ_TIMER__IMMEDIATE_EXPIRE_MASK             = 0x00000800;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_SIZE_MASK               = 0x003f0000;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_TYPE_MASK               = 0x00003000;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESSING_IQ_MASK                = 0x40000000;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESS_IQ_EN_MASK                = 0x20000000;
constexpr unsigned int CP_HQD_IQ_TIMER__QUANTUM_TIMER_MASK                = 0x00400000;
constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE_MASK                   = 0x08000000;
constexpr unsigned int CP_HQD_IQ_TIMER__REARM_TIMER_MASK                  = 0x10000000;
constexpr unsigned int CP_HQD_IQ_TIMER__RETRY_TYPE_MASK                   = 0x00000700;
constexpr unsigned int CP_HQD_IQ_TIMER__WAIT_TIME_MASK                    = 0x000000ff;
constexpr unsigned int CP_HQD_MSG_TYPE__ACTION_MASK                       = 0x00000007;
constexpr unsigned int CP_HQD_MSG_TYPE__SAVE_STATE_MASK                   = 0x00000070;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_EN_MASK                = 0x00000008;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_MASK                   = 0x00000004;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_EN_MASK                = 0x00000002;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_MASK                   = 0x00000001;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_EN_MASK                = 0x00000020;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_MASK                   = 0x00000010;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__CACHE_FULL_PACKET_EN_MASK = 0x08000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__DISP_ACTIVE_MASK          = 0x80000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__EOP_SWITCH_QOS_EN_MASK    = 0x01000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IB_SWITCH_QOS_EN_MASK     = 0x00800000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IQ_SWITCH_QOS_EN_MASK     = 0x00400000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PQ_SWITCH_QOS_EN_MASK     = 0x02000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_REQ_MASK          = 0x00000001;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_SIZE_MASK         = 0x0003ff00;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__QSWITCH_MODE_MASK         = 0x40000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RELAUNCH_WAVES_MASK       = 0x20000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RESTORE_ACTIVE_MASK       = 0x10000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__SUSPEND_STATUS_MASK       = 0x00000080;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TC_OFFLOAD_QOS_EN_MASK    = 0x04000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_CONNECT_OVERRIDE_MASK = 0x00000002;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_MATCH_DIS_MASK        = 0x00080000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_SWITCH_EXEMPT_MASK    = 0x00040000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WGS_QUEUE_MASK            = 0x00000010;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_CLAMP_EN_MASK         = 0x00100000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_SWITCH_QOS_EN_MASK    = 0x00200000;
constexpr unsigned int CP_HQD_PIPE_PRIORITY__PIPE_PRIORITY_MASK           = 0x00000003;
constexpr unsigned int CP_HQD_PQ_BASE_HI__ADDR_HI_MASK                    = 0x000000ff;
constexpr unsigned int CP_HQD_PQ_BASE__ADDR_MASK                          = 0xffffffff;
constexpr unsigned int CP_HQD_PQ_CONTROL__CACHE_POLICY_MASK               = 0x03000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__EXE_DISABLE_MASK                = 0x00800000;
constexpr unsigned int CP_HQD_PQ_CONTROL__KMD_QUEUE_MASK                  = 0x80000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__MIN_AVAIL_SIZE_MASK             = 0x00300000;
constexpr unsigned int CP_HQD_PQ_CONTROL__NO_UPDATE_RPTR_MASK             = 0x08000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_EMPTY_MASK                   = 0x00008000;
constexpr unsigned int CP_HQD_PQ_CONTROL__PRIV_STATE_MASK                 = 0x40000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_FULL_EN_MASK              = 0x00004000;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_SIZE_MASK                 = 0x0000003f;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_BLOCK_SIZE_MASK            = 0x00003f00;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_CARRY_MASK                 = 0x00000080;
constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR_MASK            = 0x000c0000;
constexpr unsigned int CP_HQD_PQ_CONTROL__TUNNEL_DISPATCH_MASK            = 0x20000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__UNORD_DISPATCH_MASK             = 0x10000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__WPTR_CARRY_MASK                 = 0x00000040;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_BIF_DROP_MASK = 0x00000002;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_EN_MASK       = 0x40000000;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_HIT_MASK      = 0x80000000;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_MODE_MASK     = 0x00000001;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_OFFSET_MASK   = 0x0ffffffc;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SCHD_HIT_MASK = 0x20000000;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SOURCE_MASK   = 0x10000000;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR_HI__RPTR_REPORT_ADDR_HI_MASK = 0x0000ffff;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR__RPTR_REPORT_ADDR_MASK  = 0xfffffffc;
constexpr unsigned int CP_HQD_PQ_RPTR__CONSUMED_OFFSET_MASK               = 0xffffffff;
constexpr unsigned int CP_HQD_PQ_WPTR_HI__DATA_MASK                       = 0xffffffff;
constexpr unsigned int CP_HQD_PQ_WPTR_LO__OFFSET_MASK                     = 0xffffffff;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR_HI__WPTR_ADDR_HI_MASK     = 0x0000ffff;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR__WPTR_ADDR_MASK           = 0xfffffff8;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_ACTIVE_MASK                = 0x80000000;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_DURATION_MASK              = 0x00003f00;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_EN_MASK                    = 0x00000001;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_SCALE_MASK                 = 0x00000010;
constexpr unsigned int CP_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL_MASK         = 0x0000000f;
constexpr unsigned int CP_HQD_SECURE_REQ0__REQ_EN_MASK                    = 0x80000000;
constexpr unsigned int CP_HQD_SECURE_REQ0__REQ_TYPE_MASK                  = 0x000000ff;
constexpr unsigned int CP_HQD_SECURE_REQ0__RSP_EN_MASK                    = 0x40000000;
constexpr unsigned int CP_HQD_SECURE_REQ0__RSP_TYPE_MASK                  = 0x0000ff00;
constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_DW_CNT__CNT_MASK         = 0x00003fff;
constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_OFFSET__OFFSET_MASK      = 0x0000fffc;
constexpr unsigned int CP_HQD_SUSPEND_WG_STATE_OFFSET__OFFSET_MASK        = 0x03fffffc;
constexpr unsigned int CP_HQD_VMID__IB_VMID_MASK                          = 0x00000f00;
constexpr unsigned int CP_HQD_VMID__VMID_MASK                             = 0x0000000f;
constexpr unsigned int CP_HQD_VMID__VQID_MASK                             = 0x03ff0000;
constexpr unsigned int CP_HQD_WG_STATE_OFFSET__OFFSET_MASK                = 0x03fffffc;
constexpr unsigned int CP_INT_CNTL_RING0__CMP_BUSY_INT_ENABLE_MASK        = 0x00040000;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_BUSY_INT_ENABLE_MASK       = 0x00080000;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_EMPTY_INT_ENABLE_MASK      = 0x00100000;
constexpr unsigned int CP_INT_CNTL_RING0__CP_ECC_ERROR_INT_ENABLE_MASK    = 0x00004000;
constexpr unsigned int CP_INT_CNTL_RING0__CP_VM_DOORBELL_WR_INT_ENABLE_MASK = 0x00000800;
constexpr unsigned int CP_INT_CNTL_RING0__DMA_WATCH_INT_ENABLE_MASK       = 0x00000400;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC0_INT_ENABLE_MASK        = 0x80000000;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC1_INT_ENABLE_MASK        = 0x40000000;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC2_INT_ENABLE_MASK        = 0x20000000;
constexpr unsigned int CP_INT_CNTL_RING0__GFX_IDLE_INT_ENABLE_MASK        = 0x00200000;
constexpr unsigned int CP_INT_CNTL_RING0__GPF_INT_ENABLE_MASK             = 0x00010000;
constexpr unsigned int CP_INT_CNTL_RING0__OPCODE_ERROR_INT_ENABLE_MASK    = 0x01000000;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_INSTR_INT_ENABLE_MASK      = 0x00400000;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_REG_INT_ENABLE_MASK        = 0x00800000;
constexpr unsigned int CP_INT_CNTL_RING0__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000;
constexpr unsigned int CP_INT_CNTL_RING0__RESUME_INT_ENABLE_MASK          = 0x00000100;
constexpr unsigned int CP_INT_CNTL_RING0__SUSPEND_INT_ENABLE_MASK         = 0x00000200;
constexpr unsigned int CP_INT_CNTL_RING0__TIME_STAMP_INT_ENABLE_MASK      = 0x04000000;
constexpr unsigned int CP_INT_CNTL_RING0__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000;
constexpr unsigned int CP_INT_CNTL__CMP_BUSY_INT_ENABLE_MASK              = 0x00040000;
constexpr unsigned int CP_INT_CNTL__CNTX_BUSY_INT_ENABLE_MASK             = 0x00080000;
constexpr unsigned int CP_INT_CNTL__CNTX_EMPTY_INT_ENABLE_MASK            = 0x00100000;
constexpr unsigned int CP_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK          = 0x00004000;
constexpr unsigned int CP_INT_CNTL__CP_VM_DOORBELL_WR_INT_ENABLE_MASK     = 0x00000800;
constexpr unsigned int CP_INT_CNTL__DMA_WATCH_INT_ENABLE_MASK             = 0x00000400;
constexpr unsigned int CP_INT_CNTL__GENERIC0_INT_ENABLE_MASK              = 0x80000000;
constexpr unsigned int CP_INT_CNTL__GENERIC1_INT_ENABLE_MASK              = 0x40000000;
constexpr unsigned int CP_INT_CNTL__GENERIC2_INT_ENABLE_MASK              = 0x20000000;
constexpr unsigned int CP_INT_CNTL__GFX_IDLE_INT_ENABLE_MASK              = 0x00200000;
constexpr unsigned int CP_INT_CNTL__GPF_INT_ENABLE_MASK                   = 0x00010000;
constexpr unsigned int CP_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK          = 0x01000000;
constexpr unsigned int CP_INT_CNTL__PRIV_INSTR_INT_ENABLE_MASK            = 0x00400000;
constexpr unsigned int CP_INT_CNTL__PRIV_REG_INT_ENABLE_MASK              = 0x00800000;
constexpr unsigned int CP_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK    = 0x08000000;
constexpr unsigned int CP_INT_CNTL__RESUME_INT_ENABLE_MASK                = 0x00000100;
constexpr unsigned int CP_INT_CNTL__SUSPEND_INT_ENABLE_MASK               = 0x00000200;
constexpr unsigned int CP_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK            = 0x04000000;
constexpr unsigned int CP_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK      = 0x00020000;
constexpr unsigned int CP_INT_STATUS_RING0__CMP_BUSY_INT_STAT_MASK        = 0x00040000;
constexpr unsigned int CP_INT_STATUS_RING0__CNTX_EMPTY_INT_STAT_MASK      = 0x00100000;
constexpr unsigned int CP_INT_STATUS_RING0__CP_ECC_ERROR_INT_STAT_MASK    = 0x00004000;
constexpr unsigned int CP_INT_STATUS_RING0__CP_VM_DOORBELL_WR_INT_STAT_MASK = 0x00000800;
constexpr unsigned int CP_INT_STATUS_RING0__DMA_WATCH_INT_STAT_MASK       = 0x00000400;
constexpr unsigned int CP_INT_STATUS_RING0__GCNTX_BUSY_INT_STAT_MASK      = 0x00080000;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC0_INT_STAT_MASK        = 0x80000000;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC1_INT_STAT_MASK        = 0x40000000;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC2_INT_STAT_MASK        = 0x20000000;
constexpr unsigned int CP_INT_STATUS_RING0__GFX_IDLE_INT_STAT_MASK        = 0x00200000;
constexpr unsigned int CP_INT_STATUS_RING0__GPF_INT_STAT_MASK             = 0x00010000;
constexpr unsigned int CP_INT_STATUS_RING0__OPCODE_ERROR_INT_STAT_MASK    = 0x01000000;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_INSTR_INT_STAT_MASK      = 0x00400000;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_REG_INT_STAT_MASK        = 0x00800000;
constexpr unsigned int CP_INT_STATUS_RING0__RESERVED_BIT_ERROR_INT_STAT_MASK = 0x08000000;
constexpr unsigned int CP_INT_STATUS_RING0__RESUME_INT_STAT_MASK          = 0x00000100;
constexpr unsigned int CP_INT_STATUS_RING0__SUSPEND_INT_STAT_MASK         = 0x00000200;
constexpr unsigned int CP_INT_STATUS_RING0__TIME_STAMP_INT_STAT_MASK      = 0x04000000;
constexpr unsigned int CP_INT_STATUS_RING0__WRM_POLL_TIMEOUT_INT_STAT_MASK = 0x00020000;
constexpr unsigned int CP_INT_STATUS__CMP_BUSY_INT_STAT_MASK              = 0x00040000;
constexpr unsigned int CP_INT_STATUS__CNTX_BUSY_INT_STAT_MASK             = 0x00080000;
constexpr unsigned int CP_INT_STATUS__CNTX_EMPTY_INT_STAT_MASK            = 0x00100000;
constexpr unsigned int CP_INT_STATUS__CP_ECC_ERROR_INT_STAT_MASK          = 0x00004000;
constexpr unsigned int CP_INT_STATUS__CP_VM_DOORBELL_WR_INT_STAT_MASK     = 0x00000800;
constexpr unsigned int CP_INT_STATUS__DMA_WATCH_INT_STAT_MASK             = 0x00000400;
constexpr unsigned int CP_INT_STATUS__GENERIC0_INT_STAT_MASK              = 0x80000000;
constexpr unsigned int CP_INT_STATUS__GENERIC1_INT_STAT_MASK              = 0x40000000;
constexpr unsigned int CP_INT_STATUS__GENERIC2_INT_STAT_MASK              = 0x20000000;
constexpr unsigned int CP_INT_STATUS__GFX_IDLE_INT_STAT_MASK              = 0x00200000;
constexpr unsigned int CP_INT_STATUS__GPF_INT_STAT_MASK                   = 0x00010000;
constexpr unsigned int CP_INT_STATUS__OPCODE_ERROR_INT_STAT_MASK          = 0x01000000;
constexpr unsigned int CP_INT_STATUS__PRIV_INSTR_INT_STAT_MASK            = 0x00400000;
constexpr unsigned int CP_INT_STATUS__PRIV_REG_INT_STAT_MASK              = 0x00800000;
constexpr unsigned int CP_INT_STATUS__RESERVED_BIT_ERROR_INT_STAT_MASK    = 0x08000000;
constexpr unsigned int CP_INT_STATUS__RESUME_INT_STAT_MASK                = 0x00000100;
constexpr unsigned int CP_INT_STATUS__SUSPEND_INT_STAT_MASK               = 0x00000200;
constexpr unsigned int CP_INT_STATUS__TIME_STAMP_INT_STAT_MASK            = 0x04000000;
constexpr unsigned int CP_INT_STATUS__WRM_POLL_TIMEOUT_INT_STAT_MASK      = 0x00020000;
constexpr unsigned int CP_MEC_RS64_PERFCOUNT_CNTL__EVENT_SEL_MASK         = 0x0000001f;
constexpr unsigned int CP_MES_PERFCOUNT_CNTL__EVENT_SEL_MASK              = 0x0000001f;
constexpr unsigned int CP_ME_COHER_BASE_HI__COHER_BASE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int CP_ME_COHER_BASE__COHER_BASE_256B_MASK             = 0xffffffff;
constexpr unsigned int CP_ME_COHER_CNTL__CB0_DEST_BASE_ENA_MASK           = 0x00000040;
constexpr unsigned int CP_ME_COHER_CNTL__CB1_DEST_BASE_ENA_MASK           = 0x00000080;
constexpr unsigned int CP_ME_COHER_CNTL__CB2_DEST_BASE_ENA_MASK           = 0x00000100;
constexpr unsigned int CP_ME_COHER_CNTL__CB3_DEST_BASE_ENA_MASK           = 0x00000200;
constexpr unsigned int CP_ME_COHER_CNTL__CB4_DEST_BASE_ENA_MASK           = 0x00000400;
constexpr unsigned int CP_ME_COHER_CNTL__CB5_DEST_BASE_ENA_MASK           = 0x00000800;
constexpr unsigned int CP_ME_COHER_CNTL__CB6_DEST_BASE_ENA_MASK           = 0x00001000;
constexpr unsigned int CP_ME_COHER_CNTL__CB7_DEST_BASE_ENA_MASK           = 0x00002000;
constexpr unsigned int CP_ME_COHER_CNTL__DB_DEST_BASE_ENA_MASK            = 0x00004000;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_0_ENA_MASK             = 0x00000001;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_1_ENA_MASK             = 0x00000002;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_2_ENA_MASK             = 0x00080000;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_3_ENA_MASK             = 0x00200000;
constexpr unsigned int CP_ME_COHER_SIZE_HI__COHER_SIZE_HI_256B_MASK       = 0x000000ff;
constexpr unsigned int CP_ME_COHER_SIZE__COHER_SIZE_256B_MASK             = 0xffffffff;
constexpr unsigned int CP_ME_COHER_STATUS__MATCHING_GFX_CNTX_MASK         = 0x000000ff;
constexpr unsigned int CP_ME_COHER_STATUS__STATUS_MASK                    = 0x80000000;
constexpr unsigned int CP_MQD_BASE_ADDR_HI__BASE_ADDR_HI_MASK             = 0x0000ffff;
constexpr unsigned int CP_MQD_BASE_ADDR__BASE_ADDR_MASK                   = 0xfffffffc;
constexpr unsigned int CP_MQD_CONTROL__CACHE_POLICY_MASK                  = 0x03000000;
constexpr unsigned int CP_MQD_CONTROL__EXE_DISABLE_MASK                   = 0x00800000;
constexpr unsigned int CP_MQD_CONTROL__PRIV_STATE_MASK                    = 0x00000100;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_EN_MASK             = 0x00002000;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_MASK                = 0x00001000;
constexpr unsigned int CP_MQD_CONTROL__VMID_MASK                          = 0x0000000f;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_ENABLE_MODE_MASK          = 0x00000300;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE_MASK        = 0x00000400;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_STATE_MASK                = 0x0000000f;
constexpr unsigned int CP_PERFMON_CNTL__SPM_PERFMON_STATE_MASK            = 0x000000f0;
constexpr unsigned int CP_PERFMON_CNTX_CNTL__PERFMON_ENABLE_MASK          = 0x80000000;
constexpr unsigned int CP_PIPEID__PIPE_ID_MASK                            = 0x00000003;
constexpr unsigned int CP_PIPE_STATS_ADDR_HI__PIPE_STATS_ADDR_HI_MASK     = 0x0000ffff;
constexpr unsigned int CP_PIPE_STATS_ADDR_LO__PIPE_STATS_ADDR_LO_MASK     = 0xfffffffc;
constexpr unsigned int CP_PIPE_STATS_CONTROL__CACHE_POLICY_MASK           = 0x06000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_HI__PSINVOC_COUNT0_HI_MASK    = 0xffffffff;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_LO__PSINVOC_COUNT0_LO_MASK    = 0xffffffff;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_HI__OBSOLETE_MASK             = 0xffffffff;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_LO__OBSOLETE_MASK             = 0xffffffff;
constexpr unsigned int CP_STAT__CE_BUSY_MASK                              = 0x04000000;
constexpr unsigned int CP_STAT__CP_BUSY_MASK                              = 0x80000000;
constexpr unsigned int CP_STAT__DC_BUSY_MASK                              = 0x00002000;
constexpr unsigned int CP_STAT__DMA_BUSY_MASK                             = 0x00400000;
constexpr unsigned int CP_STAT__GCRIU_BUSY_MASK                           = 0x02000000;
constexpr unsigned int CP_STAT__INTERRUPT_BUSY_MASK                       = 0x00100000;
constexpr unsigned int CP_STAT__MEQ_BUSY_MASK                             = 0x00010000;
constexpr unsigned int CP_STAT__ME_BUSY_MASK                              = 0x00020000;
constexpr unsigned int CP_STAT__PFP_BUSY_MASK                             = 0x00008000;
constexpr unsigned int CP_STAT__QUERY_BUSY_MASK                           = 0x00040000;
constexpr unsigned int CP_STAT__RCIU_BUSY_MASK                            = 0x00800000;
constexpr unsigned int CP_STAT__ROQ_CE_DB_BUSY_MASK                       = 0x00000040;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT1_BUSY_MASK                = 0x20000000;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT2_BUSY_MASK                = 0x40000000;
constexpr unsigned int CP_STAT__ROQ_CE_RING_BUSY_MASK                     = 0x10000000;
constexpr unsigned int CP_STAT__ROQ_DB_BUSY_MASK                          = 0x00000020;
constexpr unsigned int CP_STAT__ROQ_INDIRECT1_BUSY_MASK                   = 0x00000400;
constexpr unsigned int CP_STAT__ROQ_INDIRECT2_BUSY_MASK                   = 0x00000800;
constexpr unsigned int CP_STAT__ROQ_RING_BUSY_MASK                        = 0x00000200;
constexpr unsigned int CP_STAT__ROQ_STATE_BUSY_MASK                       = 0x00001000;
constexpr unsigned int CP_STAT__SCRATCH_RAM_BUSY_MASK                     = 0x01000000;
constexpr unsigned int CP_STAT__SURFACE_SYNC_BUSY_MASK                    = 0x00200000;
constexpr unsigned int CP_STAT__TCIU_BUSY_MASK                            = 0x08000000;
constexpr unsigned int CP_STAT__UTCL2IU_BUSY_MASK                         = 0x00004000;
constexpr unsigned int CP_VGT_ASINVOC_COUNT_HI__ASINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_ASINVOC_COUNT_LO__ASINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_HI__CSINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_LO__CSINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_HI__DSINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_LO__DSINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_HI__GSINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_LO__GSINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_HI__GSPRIM_COUNT_HI_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_LO__GSPRIM_COUNT_LO_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_HI__HSINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_LO__HSINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_HI__IAPRIM_COUNT_HI_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_LO__IAPRIM_COUNT_LO_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_IAVERT_COUNT_HI__IAVERT_COUNT_HI_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_IAVERT_COUNT_LO__IAVERT_COUNT_LO_MASK       = 0xffffffff;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_HI__VSINVOC_COUNT_HI_MASK     = 0xffffffff;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_LO__VSINVOC_COUNT_LO_MASK     = 0xffffffff;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_ENABLE_MASK        = 0x00000001;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET0_MASK       = 0x00000300;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET1_MASK       = 0x00000c00;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET2_MASK       = 0x00003000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET3_MASK       = 0x0000c000;
constexpr unsigned int DB_ALPHA_TO_MASK__OFFSET_ROUND_MASK                = 0x00010000;
constexpr unsigned int DB_ARB_CONFIG__ARB_MODE_MASK                       = 0x00000003;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_MAX_RD_MASK                 = 0x0000007c;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_MAX_WR_MASK                 = 0x0001f000;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_WEIGHT_RD_MASK              = 0x00000f80;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_WEIGHT_WR_MASK              = 0x003e0000;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__RESERVED_MASK                  = 0xfffffc00;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE0_MASK            = 0x00000001;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE1_MASK            = 0x00000002;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE2_MASK            = 0x00000004;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE3_MASK            = 0x00000008;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE4_MASK            = 0x00000010;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE5_MASK            = 0x00000020;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE6_MASK            = 0x00000040;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE8_MASK            = 0x00000100;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE9_MASK            = 0x00000200;
constexpr unsigned int DB_COUNT_CONTROL__DBFAIL_ENABLE_MASK               = 0x00f00000;
constexpr unsigned int DB_COUNT_CONTROL__DISABLE_CONSERVATIVE_ZPASS_COUNTS_MASK = 0x00000004;
constexpr unsigned int DB_COUNT_CONTROL__ENHANCED_CONSERVATIVE_ZPASS_COUNTS_MASK = 0x00000008;
constexpr unsigned int DB_COUNT_CONTROL__PERFECT_ZPASS_COUNTS_MASK        = 0x00000002;
constexpr unsigned int DB_COUNT_CONTROL__SFAIL_ENABLE_MASK                = 0x000f0000;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_EVEN_ENABLE_MASK           = 0x0f000000;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_ODD_ENABLE_MASK            = 0xf0000000;
constexpr unsigned int DB_COUNT_CONTROL__ZFAIL_ENABLE_MASK                = 0x0000f000;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_ENABLE_MASK                = 0x00000f00;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_EXPORT_CREDITS_MASK         = 0x00001c00;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_FREE_WAVE_CREDITS_MASK      = 0x007c0000;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_QUAD_CREDITS_MASK           = 0x000003e0;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_UPDATE_CREDITS_MASK         = 0x0000001f;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_WAVE_CREDITS_MASK           = 0x0003e000;
constexpr unsigned int DB_DEPTH_BOUNDS_MAX__MAX_MASK                      = 0xffffffff;
constexpr unsigned int DB_DEPTH_BOUNDS_MIN__MIN_MASK                      = 0xffffffff;
constexpr unsigned int DB_DEPTH_CONTROL__BACKFACE_ENABLE_MASK             = 0x00000080;
constexpr unsigned int DB_DEPTH_CONTROL__DEPTH_BOUNDS_ENABLE_MASK         = 0x00000008;
constexpr unsigned int DB_DEPTH_CONTROL__RESERVED_FIELD_30_MASK           = 0x40000000;
constexpr unsigned int DB_DEPTH_CONTROL__RESERVED_FIELD_31_MASK           = 0x80000000;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_BF_MASK              = 0x00700000;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_MASK                 = 0x00000700;
constexpr unsigned int DB_DEPTH_CONTROL__STENCIL_ENABLE_MASK              = 0x00000001;
constexpr unsigned int DB_DEPTH_CONTROL__ZFUNC_MASK                       = 0x00000070;
constexpr unsigned int DB_DEPTH_CONTROL__Z_ENABLE_MASK                    = 0x00000002;
constexpr unsigned int DB_DEPTH_CONTROL__Z_WRITE_ENABLE_MASK              = 0x00000004;
constexpr unsigned int DB_DEPTH_SIZE_XY__X_MAX_MASK                       = 0x0000ffff;
constexpr unsigned int DB_DEPTH_SIZE_XY__Y_MAX_MASK                       = 0xffff0000;
constexpr unsigned int DB_DEPTH_VIEW1__MIPID_MASK                         = 0x7c000000;
constexpr unsigned int DB_DEPTH_VIEW1__STENCIL_READ_ONLY_MASK             = 0x02000000;
constexpr unsigned int DB_DEPTH_VIEW1__Z_READ_ONLY_MASK                   = 0x01000000;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX_MASK                      = 0x3fff0000;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_START_MASK                    = 0x00003fff;
constexpr unsigned int DB_DFD_INDIRECT_DAT__DFD_DATA_MASK                 = 0xffffffff;
constexpr unsigned int DB_DFD_INDIRECT_SEL__DFD_INDEX_MASK                = 0x000000ff;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_NUM_SAMPLES_MASK            = 0x00007000;
constexpr unsigned int DB_EQAA__ENABLE_POSTZ_OVERRASTERIZATION_MASK       = 0x08000000;
constexpr unsigned int DB_EQAA__HIGH_QUALITY_INTERSECTIONS_MASK           = 0x00010000;
constexpr unsigned int DB_EQAA__MASK_EXPORT_NUM_SAMPLES_MASK              = 0x00000700;
constexpr unsigned int DB_EQAA__OVERRASTERIZATION_AMOUNT_MASK             = 0x07000000;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_1_MASK                     = 0x00000007;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_17_MASK                    = 0x00020000;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_18_MASK                    = 0x00040000;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_19_MASK                    = 0x00080000;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_21_MASK                    = 0x00200000;
constexpr unsigned int DB_EQAA__STATIC_ANCHOR_ASSOCIATIONS_MASK           = 0x00100000;
constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_QUAD_MASK         = 0x00000008;
constexpr unsigned int DB_EXCEPTION_CONTROL__CAM_FREE_WATERMARK_MASK      = 0xff000000;
constexpr unsigned int DB_EXCEPTION_CONTROL__EARLY_Z_PANIC_DISABLE_MASK   = 0x00000001;
constexpr unsigned int DB_EXCEPTION_CONTROL__FORCE_SUMMARIZE_MASK         = 0x000000f0;
constexpr unsigned int DB_EXCEPTION_CONTROL__LATE_Z_PANIC_DISABLE_MASK    = 0x00000002;
constexpr unsigned int DB_EXCEPTION_CONTROL__LQUAD_FIFO_HI_WATERMARK_MASK = 0x00ff0000;
constexpr unsigned int DB_EXCEPTION_CONTROL__LQUAD_FIFO_LO_WATERMARK_MASK = 0x0000ff00;
constexpr unsigned int DB_EXCEPTION_CONTROL__RE_Z_PANIC_DISABLE_MASK      = 0x00000004;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_EXPORT_OVERRIDE_MASK = 0x00000004;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_RMIRET_OVERRIDE_MASK = 0x00000040;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_GL1_COMP_REQ_OVERRIDE_MASK = 0x00000008;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_GL1_SRC_OVERRIDE_MASK = 0x00000010;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_FREE_WAVE_OVERRIDE_MASK = 0x00000100;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_QUAD_OVERRIDE_MASK = 0x00000001;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_UPDATE_OVERRIDE_MASK = 0x00000020;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_WAVE_OVERRIDE_MASK = 0x00000080;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE0_MASK             = 0x00000001;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE1_MASK             = 0x00000002;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE2_MASK             = 0x00000004;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE3_MASK             = 0x00000008;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE4_MASK             = 0x00000010;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE5_MASK             = 0x00000020;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE6_MASK             = 0x00000040;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE7_MASK             = 0x00000080;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE8_MASK             = 0x00000100;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE9_MASK             = 0x00000200;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE10_MASK            = 0x00000400;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE11_MASK            = 0x00000800;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE12_MASK            = 0x00001000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE13_MASK            = 0x00002000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE14_MASK            = 0x00004000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE15_MASK            = 0x00008000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE16_MASK            = 0x00010000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE17_MASK            = 0x00020000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE18_MASK            = 0x00040000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE19_MASK            = 0x00080000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE20_MASK            = 0x00100000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE22_MASK            = 0x00400000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE23_MASK            = 0x00800000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE24_MASK            = 0x01000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE26_MASK            = 0x04000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE27_MASK            = 0x08000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE28_MASK            = 0x10000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE29_MASK            = 0x20000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE30_MASK            = 0x40000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE31_MASK            = 0x80000000;
constexpr unsigned int DB_FIFO_DEPTH1__MI_RDREQ_FIFO_DEPTH_MASK           = 0x000000ff;
constexpr unsigned int DB_FIFO_DEPTH1__MI_WRREQ_FIFO_DEPTH_MASK           = 0x0000ff00;
constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH_MASK                      = 0xff000000;
constexpr unsigned int DB_FIFO_DEPTH2__EQUAD_FIFO_DEPTH_MASK              = 0x000000ff;
constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH_MASK           = 0x0000ff00;
constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH_MASK              = 0x01ff0000;
constexpr unsigned int DB_FIFO_DEPTH2__LTILE_OP_FIFO_DEPTH_MASK           = 0xfe000000;
constexpr unsigned int DB_FIFO_DEPTH3__LTILE_PROBE_FIFO_DEPTH_MASK        = 0x000000ff;
constexpr unsigned int DB_FIFO_DEPTH3__OREO_WAVE_HIDE_DEPTH_MASK          = 0x00ff0000;
constexpr unsigned int DB_FIFO_DEPTH3__OSB_WAVE_TABLE_DEPTH_MASK          = 0x0000ff00;
constexpr unsigned int DB_FIFO_DEPTH3__QUAD_READ_REQS_MASK                = 0xff000000;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_EVENT_FIFO_DEPTH_MASK          = 0xff000000;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_SCORE_BOARD_DEPTH_MASK         = 0x00ff0000;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_SQUAD_TABLE_DEPTH_MASK         = 0x000000ff;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_TILE_TABLE_DEPTH_MASK          = 0x0000ff00;
constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH_MASK          = 0x000000ff;
constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH_MASK          = 0x0000ff00;
constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH_MASK              = 0x00ff0000;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__OCCLUSION_COMPRESSION_MODE_MASK = 0x00000300;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__STENCIL_COMPRESSION_MODE_MASK = 0x000000c0;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__STENCIL_SPECULATIVE_READ_MASK = 0x0000000c;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__Z_COMPRESSION_MODE_MASK  = 0x00000030;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__Z_SPECULATIVE_READ_MASK  = 0x00000003;
constexpr unsigned int DB_HTILE_SURFACE__DST_OUTSIDE_ZERO_TO_ONE_MASK     = 0x00010000;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_1_MASK            = 0x00000001;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_2_MASK            = 0x00000004;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_3_MASK            = 0x00000008;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_4_MASK            = 0x000003f0;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_5_MASK            = 0x0000fc00;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_6_MASK            = 0x00020000;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT0_WATERMARK_MASK      = 0x00000007;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT1_WATERMARK_MASK      = 0x00000700;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT2_WATERMARK_MASK      = 0x00070000;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT3_WATERMARK_MASK      = 0x07000000;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_OCCLUSION_MASK = 0x00000100;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_STENCIL_MASK = 0x00000080;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_Z_MASK    = 0x00000040;
constexpr unsigned int DB_MEM_CONFIG__FL_DISABLE_SINGLE_COMPRESS_MASK     = 0x00008000;
constexpr unsigned int DB_MEM_CONFIG__OCCLUSION_OVERRIDE_COMPRESSION_MODE_MASK = 0x00006000;
constexpr unsigned int DB_MEM_CONFIG__OCCLUSION_SCOPE_MASK                = 0x00000030;
constexpr unsigned int DB_MEM_CONFIG__STENCIL_OVERRIDE_COMPRESSION_MODE_MASK = 0x00001800;
constexpr unsigned int DB_MEM_CONFIG__STENCIL_SCOPE_MASK                  = 0x0000000c;
constexpr unsigned int DB_MEM_CONFIG__Z_OVERRIDE_COMPRESSION_MODE_MASK    = 0x00000600;
constexpr unsigned int DB_MEM_CONFIG__Z_SCOPE_MASK                        = 0x00000003;
constexpr unsigned int DB_MEM_TEMPORAL__OCCLUSION_TEMPORAL_WRITE_MASK     = 0x00007000;
constexpr unsigned int DB_MEM_TEMPORAL__STENCIL_TEMPORAL_READ_MASK        = 0x000001c0;
constexpr unsigned int DB_MEM_TEMPORAL__STENCIL_TEMPORAL_WRITE_MASK       = 0x00000e00;
constexpr unsigned int DB_MEM_TEMPORAL__Z_TEMPORAL_READ_MASK              = 0x00000007;
constexpr unsigned int DB_MEM_TEMPORAL__Z_TEMPORAL_WRITE_MASK             = 0x00000038;
constexpr unsigned int DB_OCCLUSION_COUNT0_HI__COUNT_HI_MASK              = 0x7fffffff;
constexpr unsigned int DB_OCCLUSION_COUNT0_LOW__COUNT_LOW_MASK            = 0xffffffff;
constexpr unsigned int DB_OCCLUSION_COUNT1_HI__COUNT_HI_MASK              = 0x7fffffff;
constexpr unsigned int DB_OCCLUSION_COUNT1_LOW__COUNT_LOW_MASK            = 0xffffffff;
constexpr unsigned int DB_OCCLUSION_COUNT2_HI__COUNT_HI_MASK              = 0x7fffffff;
constexpr unsigned int DB_OCCLUSION_COUNT2_LOW__COUNT_LOW_MASK            = 0xffffffff;
constexpr unsigned int DB_OCCLUSION_COUNT3_HI__COUNT_HI_MASK              = 0x7fffffff;
constexpr unsigned int DB_OCCLUSION_COUNT3_LOW__COUNT_LOW_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int DB_RENDER_CONTROL__COPY_CENTROID_MASK              = 0x00000080;
constexpr unsigned int DB_RENDER_CONTROL__COPY_SAMPLE_MASK                = 0x00000f00;
constexpr unsigned int DB_RENDER_CONTROL__DECOMPRESS_ENABLE_MASK          = 0x00001000;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COMPRESS_DISABLE_MASK     = 0x00000040;
constexpr unsigned int DB_RENDER_CONTROL__FORCE_EXPORT_ORDER_MASK         = 0x00080000;
constexpr unsigned int DB_RENDER_CONTROL__FORCE_OREO_MODE_MASK            = 0x00040000;
constexpr unsigned int DB_RENDER_CONTROL__MAX_ALLOWED_STILES_IN_WAVE_MASK = 0x00f00000;
constexpr unsigned int DB_RENDER_CONTROL__OREO_MODE_MASK                  = 0x00030000;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_1_MASK           = 0x00000004;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_2_MASK           = 0x00000008;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_4_MASK           = 0x00000010;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_CLEAR_ENABLE_MASK       = 0x00000002;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COMPRESS_DISABLE_MASK   = 0x00000020;
constexpr unsigned int DB_RENDER_OVERRIDE2__ALLOW_PARTIAL_RES_HIER_KILL_MASK = 0x02000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__CENTROID_COMPUTATION_MODE_MASK = 0x18000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__DECOMPRESS_Z_ON_FLUSH_MASK    = 0x00000100;
constexpr unsigned int DB_RENDER_OVERRIDE2__DEPTH_BOUNDS_HIER_DEPTH_DISABLE_MASK = 0x00000400;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_COLOR_ON_VALIDATION_MASK = 0x00000080;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_FAST_PASS_MASK        = 0x00800000;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_NOZ_MASK              = 0x20000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__FORCE_SUMM_STENCIL_RANGE_TO_MAX_MASK = 0x00001000;
constexpr unsigned int DB_RENDER_OVERRIDE2__FORCE_SUMM_Z_RANGE_TO_MAX_MASK = 0x00000800;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_CONTROL_MASK = 0x00000003;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_COUNTDOWN_MASK = 0x0000001c;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_ZRANGE_MASK          = 0x00200000;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_1_MASK         = 0x00000200;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_2_MASK         = 0x001fe000;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_5_MASK         = 0x00000020;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_6_MASK         = 0x00000040;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES_MASK   = 0x04000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_STENCIL_DISABLE_MASK      = 0x00000100;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_Z_DISABLE_MASK            = 0x00000080;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_COLOR_KILL_MASK          = 0x00000400;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE_MASK        = 0x00006000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE0_MASK         = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE1_MASK         = 0x00000030;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIZ_ENABLE_MASK          = 0x00000003;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_SHADER_Z_ORDER_MASK      = 0x00000040;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_DIRTY_MASK       = 0x10000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_READ_MASK        = 0x00001000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_VALID_MASK       = 0x40000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_ALLOC_MASK             = 0x00008000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_DIRTY_MASK             = 0x08000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_LIMIT_SUMM_MASK        = 0x00180000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_READ_MASK              = 0x00000800;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_VALID_MASK             = 0x20000000;
constexpr unsigned int DB_RENDER_OVERRIDE__MAX_TILES_IN_DTT_MASK          = 0x03e00000;
constexpr unsigned int DB_RENDER_OVERRIDE__NOOP_CULL_DISABLE_MASK         = 0x00000200;
constexpr unsigned int DB_RENDER_OVERRIDE__PRESERVE_COMPRESSION_MASK      = 0x80000000;
constexpr unsigned int DB_RING_CONTROL__COUNTER_CONTROL_MASK              = 0x00000003;
constexpr unsigned int DB_SHADER_CONTROL__ALPHA_TO_MASK_DISABLE_MASK      = 0x00000800;
constexpr unsigned int DB_SHADER_CONTROL__CONSERVATIVE_Z_EXPORT_MASK      = 0x00006000;
constexpr unsigned int DB_SHADER_CONTROL__COVERAGE_TO_MASK_ENABLE_MASK    = 0x00000080;
constexpr unsigned int DB_SHADER_CONTROL__DEPTH_BEFORE_SHADER_MASK        = 0x00001000;
constexpr unsigned int DB_SHADER_CONTROL__DUAL_QUAD_DISABLE_MASK          = 0x00008000;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_HIER_FAIL_MASK          = 0x00000200;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_NOOP_MASK               = 0x00000400;
constexpr unsigned int DB_SHADER_CONTROL__KILL_ENABLE_MASK                = 0x00000040;
constexpr unsigned int DB_SHADER_CONTROL__MASK_EXPORT_ENABLE_MASK         = 0x00000100;
constexpr unsigned int DB_SHADER_CONTROL__OREO_BLEND_ENABLE_MASK          = 0x01000000;
constexpr unsigned int DB_SHADER_CONTROL__OVERRIDE_INTRINSIC_RATE_ENABLE_MASK = 0x02000000;
constexpr unsigned int DB_SHADER_CONTROL__OVERRIDE_INTRINSIC_RATE_MASK    = 0x1c000000;
constexpr unsigned int DB_SHADER_CONTROL__PRE_SHADER_DEPTH_COVERAGE_ENABLE_MASK = 0x00800000;
constexpr unsigned int DB_SHADER_CONTROL__PRIMITIVE_ORDERED_PIXEL_SHADER_MASK = 0x00010000;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_OP_VAL_EXPORT_ENABLE_MASK = 0x00000004;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_TEST_VAL_EXPORT_ENABLE_MASK = 0x00000002;
constexpr unsigned int DB_SHADER_CONTROL__Z_EXPORT_ENABLE_MASK            = 0x00000001;
constexpr unsigned int DB_SHADER_CONTROL__Z_ORDER_MASK                    = 0x00000030;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_1X1_MASK = 0x0000000f;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_1X2_MASK = 0x000f0000;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_2X1_MASK = 0x00000f00;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_2X2_MASK = 0x0f000000;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_1X1_MASK = 0x000000f0;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_1X2_MASK = 0x00f00000;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_2X1_MASK = 0x0000f000;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_2X2_MASK = 0xf0000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREFUNC0_MASK      = 0x00000007;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREMASK0_MASK      = 0x000ff000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREVALUE0_MASK     = 0x00000ff0;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREFUNC1_MASK      = 0x00000007;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREMASK1_MASK      = 0x000ff000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREVALUE1_MASK     = 0x00000ff0;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_BF_MASK            = 0x0000f000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_MASK               = 0x0000000f;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_BF_MASK           = 0x00f00000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_MASK              = 0x00000f00;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_BF_MASK           = 0x000f0000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_MASK              = 0x000000f0;
constexpr unsigned int DB_STENCIL_INFO__FORMAT_MASK                       = 0x00000001;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_1_MASK             = 0x0000e000;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_2_MASK             = 0x00000600;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_11_MASK            = 0x00000800;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_12_MASK            = 0x00001000;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_20_MASK            = 0x00100000;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_27_MASK            = 0x08000000;
constexpr unsigned int DB_STENCIL_INFO__SW_MODE_MASK                      = 0x000001f0;
constexpr unsigned int DB_STENCIL_INFO__TILE_STENCIL_DISABLE_MASK         = 0x20000000;
constexpr unsigned int DB_STENCIL_OPVAL__OPVAL_BF_MASK                    = 0x0000ff00;
constexpr unsigned int DB_STENCIL_OPVAL__OPVAL_MASK                       = 0x000000ff;
constexpr unsigned int DB_STENCIL_READ_BASE_HI__BASE_HI_MASK              = 0x000000ff;
constexpr unsigned int DB_STENCIL_READ_BASE__BASE_256B_MASK               = 0xffffffff;
constexpr unsigned int DB_STENCIL_READ_MASK__TESTMASK_BF_MASK             = 0x0000ff00;
constexpr unsigned int DB_STENCIL_READ_MASK__TESTMASK_MASK                = 0x000000ff;
constexpr unsigned int DB_STENCIL_REF__TESTVAL_BF_MASK                    = 0x0000ff00;
constexpr unsigned int DB_STENCIL_REF__TESTVAL_MASK                       = 0x000000ff;
constexpr unsigned int DB_STENCIL_WRITE_BASE_HI__BASE_HI_MASK             = 0x000000ff;
constexpr unsigned int DB_STENCIL_WRITE_BASE__BASE_256B_MASK              = 0xffffffff;
constexpr unsigned int DB_STENCIL_WRITE_MASK__WRITEMASK_BF_MASK           = 0x0000ff00;
constexpr unsigned int DB_STENCIL_WRITE_MASK__WRITEMASK_MASK              = 0x000000ff;
constexpr unsigned int DB_SUMMARIZER_TIMEOUTS__SUMM_CNTL_EVICT_TIMEOUT_MASK = 0x00000fff;
constexpr unsigned int DB_SUMMARIZER_TIMEOUTS__SUMM_EVICT_TIMEOUT_MASK    = 0x0fff0000;
constexpr unsigned int DB_VIEWPORT_CONTROL__DISABLE_VIEWPORT_CLAMP_MASK   = 0x00000001;
constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE_MASK           = 0xff000000;
constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH_MASK                    = 0x0000ff00;
constexpr unsigned int DB_WATERMARKS__DEPTH_FREE_MASK                     = 0x000000ff;
constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE_MASK             = 0x00ff0000;
constexpr unsigned int DB_Z_INFO__DECOMPRESS_ON_N_ZPLANES_MASK            = 0x07800000;
constexpr unsigned int DB_Z_INFO__FORMAT_MASK                             = 0x00000003;
constexpr unsigned int DB_Z_INFO__MAXMIP_MASK                             = 0x000f8000;
constexpr unsigned int DB_Z_INFO__NUM_SAMPLES_MASK                        = 0x0000000c;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_1_MASK                   = 0x00006000;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_2_MASK                   = 0x00000600;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_11_MASK                  = 0x00000800;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_12_MASK                  = 0x00001000;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_20_MASK                  = 0x00100000;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_27_MASK                  = 0x08000000;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_28_MASK                  = 0x10000000;
constexpr unsigned int DB_Z_INFO__SW_MODE_MASK                            = 0x000001f0;
constexpr unsigned int DB_Z_INFO__TILE_SURFACE_ENABLE_MASK                = 0x20000000;
constexpr unsigned int DB_Z_READ_BASE_HI__BASE_HI_MASK                    = 0x000000ff;
constexpr unsigned int DB_Z_READ_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int DB_Z_WRITE_BASE_HI__BASE_HI_MASK                   = 0x000000ff;
constexpr unsigned int DB_Z_WRITE_BASE__BASE_256B_MASK                    = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi8__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi8__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi9__EventSelectHi_MASK       = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi9__Filter_MASK              = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi10__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi10__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi11__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi11__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi12__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi12__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi13__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi13__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi14__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi14__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi15__EventSelectHi_MASK      = 0x0000003f;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi15__Filter_MASK             = 0xffffff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__BypassEn_MASK            = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__DsmTrig_MASK             = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__En_MASK                  = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__EventSelectLo_MASK       = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__Mp1Int_MASK              = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__UnitMaskHi_MASK          = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__UnitMaskLo_MASK          = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__BypassEn_MASK           = 0x00200000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__DsmTrig_MASK            = 0x00080000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__En_MASK                 = 0x00400000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__EventSelectLo_MASK      = 0x000000ff;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__Mp1Int_MASK             = 0x00100000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__UnitMaskHi_MASK         = 0x0f000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__UnitMaskLo_MASK         = 0x0000ff00;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi0__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi1__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi2__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi3__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi4__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi5__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi6__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi7__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi8__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi9__CTR_47_32_MASK           = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi10__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi11__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi12__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi13__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi14__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi15__CTR_47_32_MASK          = 0x0000ffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo0__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo1__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo2__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo3__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo4__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo5__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo6__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo7__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo8__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo9__CTR_31_0_MASK            = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo10__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo11__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo12__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo13__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo14__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo15__CTR_31_0_MASK           = 0xffffffff;
constexpr unsigned int GB_ADDR_CONFIG_READ__MAX_COMPRESSED_FRAGS_MASK     = 0x000000c0;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PIPES_MASK                = 0x00000007;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PKRS_MASK                 = 0x00000700;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_RB_PER_SE_MASK            = 0x0c000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_SHADER_ENGINES_MASK       = 0x00780000;
constexpr unsigned int GB_ADDR_CONFIG_READ__PIPE_INTERLEAVE_SIZE_MASK     = 0x00000038;
constexpr unsigned int GB_ADDR_CONFIG__MAX_COMPRESSED_FRAGS_MASK          = 0x000000c0;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PIPES_MASK                     = 0x00000007;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PKRS_MASK                      = 0x00000700;
constexpr unsigned int GB_ADDR_CONFIG__NUM_RB_PER_SE_MASK                 = 0x0c000000;
constexpr unsigned int GB_ADDR_CONFIG__NUM_SHADER_ENGINES_MASK            = 0x00780000;
constexpr unsigned int GB_ADDR_CONFIG__PIPE_INTERLEAVE_SIZE_MASK          = 0x00000038;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__CLEAR_MASK            = 0x20000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__ENABLE_MASK           = 0x10000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE_MASK        = 0x0f000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END_MASK     = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_MASK         = 0x000000ff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE_MASK      = 0xffff0000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COUNTER_HI_MASK         = 0x0000ffff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_LO__COUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK   = 0x02000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK  = 0x01000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000f;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000;
constexpr unsigned int GCR_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GCR_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int GCR_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GCR_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE0_MASK     = 0x00000003;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE1_MASK     = 0x0000000c;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE2_MASK     = 0x00000030;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE3_MASK     = 0x000000c0;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE0_MASK    = 0x00000f00;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE1_MASK    = 0x0000f000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE2_MASK    = 0x000f0000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE3_MASK    = 0x00f00000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE_MASK       = 0xf0000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL_MASK        = 0x000003ff;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE0_MASK     = 0x00000003;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE1_MASK     = 0x0000000c;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE2_MASK     = 0x00000030;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE3_MASK     = 0x000000c0;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE0_MASK    = 0x00000f00;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE1_MASK    = 0x0000f000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE2_MASK    = 0x000f0000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE3_MASK    = 0x00f00000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE_MASK       = 0xf0000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL_MASK        = 0x000003ff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK    = 0xffffffff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK    = 0xffffffff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK   = 0xf0000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK   = 0x0f000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK    = 0x000003ff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK    = 0x000ffc00;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__CNTR_MODE_MASK     = 0x00f00000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_MODE1_MASK    = 0x0f000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_MODE_MASK     = 0xf0000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_SEL1_MASK     = 0x000ffc00;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_SEL_MASK      = 0x000003ff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK    = 0xffffffff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK    = 0xffffffff;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_SELECT__COUNTER_MODE_MASK  = 0xf0000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_SELECT__PERF_SEL_MASK      = 0x000003ff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_MODE_MASK       = 0xf0000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_SEL_MASK        = 0x000003ff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_SELECT__COUNTER_MODE_MASK    = 0xf0000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_SELECT__PERF_SEL_MASK        = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_MODE0_MASK           = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_SEL0_MASK            = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_MODE0_MASK           = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_SEL0_MASK            = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_MODE0_MASK           = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_SEL0_MASK            = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_MODE0_MASK           = 0xf0000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_SEL0_MASK            = 0x000003ff;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_MODE0_MASK      = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_SEL0_MASK       = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_MODE0_MASK      = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_SEL0_MASK       = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_MODE0_MASK      = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_SEL0_MASK       = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK     = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK     = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK      = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK      = 0x000ffc00;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__CNTR_MODE_MASK       = 0x00f00000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_MODE0_MASK      = 0xf0000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_MODE1_MASK      = 0x0f000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_SEL0_MASK       = 0x000003ff;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_SEL1_MASK       = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK       = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK       = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK        = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK        = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__CNTR_MODE_MASK         = 0x00f00000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_MODE0_MASK        = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_MODE1_MASK        = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_SEL0_MASK         = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_SEL1_MASK         = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK       = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK       = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK        = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK        = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__CNTR_MODE_MASK         = 0x00f00000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_MODE0_MASK        = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_MODE1_MASK        = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_SEL0_MASK         = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_SEL1_MASK         = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK       = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK       = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK        = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK        = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__CNTR_MODE_MASK         = 0x00f00000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_MODE0_MASK        = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_MODE1_MASK        = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_SEL0_MASK         = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_SEL1_MASK         = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK        = 0xffffffff;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK       = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK       = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK        = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK        = 0x000ffc00;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__CNTR_MODE_MASK         = 0x00f00000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_MODE0_MASK        = 0xf0000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_MODE1_MASK        = 0x0f000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_SEL0_MASK         = 0x000003ff;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_SEL1_MASK         = 0x000ffc00;
constexpr unsigned int GE_CNTL__BREAK_PRIMGRP_AT_EOI_MASK                 = 0x00100000;
constexpr unsigned int GE_CNTL__BREAK_SUBGRP_AT_EOI_MASK                  = 0x00040000;
constexpr unsigned int GE_CNTL__DIS_PG_SIZE_ADJUST_FOR_STRIP_MASK         = 0x80000000;
constexpr unsigned int GE_CNTL__GCR_DISABLE_MASK                          = 0x40000000;
constexpr unsigned int GE_CNTL__PACKET_TO_ONE_PA_MASK                     = 0x00080000;
constexpr unsigned int GE_CNTL__PRIMS_PER_SUBGRP_MASK                     = 0x000001ff;
constexpr unsigned int GE_CNTL__PRIM_GRP_SIZE_MASK                        = 0x3fe00000;
constexpr unsigned int GE_CNTL__VERTS_PER_SUBGRP_MASK                     = 0x0003fe00;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM_1__GS_FL_DIM_Z_MASK       = 0x0000ffff;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM__GS_FL_DIM_X_MASK         = 0x0000ffff;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM__GS_FL_DIM_Y_MASK         = 0xffff0000;
constexpr unsigned int GE_GS_ORDERED_ID_BASE__BASE_MASK                   = 0x00000fff;
constexpr unsigned int GE_GS_THROTTLE__ENABLE_THROTTLE_MASK               = 0x00400000;
constexpr unsigned int GE_GS_THROTTLE__FACTOR1_MASK                       = 0x00070000;
constexpr unsigned int GE_GS_THROTTLE__FACTOR2_MASK                       = 0x00380000;
constexpr unsigned int GE_GS_THROTTLE__NUM_INIT_GRPS_MASK                 = 0x7f800000;
constexpr unsigned int GE_GS_THROTTLE__STALL_CYCLES_MASK                  = 0x0000fe00;
constexpr unsigned int GE_GS_THROTTLE__T0_MASK                            = 0x00000007;
constexpr unsigned int GE_GS_THROTTLE__T1_MASK                            = 0x00000038;
constexpr unsigned int GE_GS_THROTTLE__T2_MASK                            = 0x000001c0;
constexpr unsigned int GE_IA_ENHANCE__MISC_MASK                           = 0xffffffff;
constexpr unsigned int GE_INDX_OFFSET__INDX_OFFSET_MASK                   = 0xffffffff;
constexpr unsigned int GE_MAX_OUTPUT_PER_SUBGROUP__MAX_VERTS_PER_SUBGROUP_MASK = 0x000003ff;
constexpr unsigned int GE_MAX_VTX_INDX__MAX_INDX_MASK                     = 0xffffffff;
constexpr unsigned int GE_MIN_VTX_INDX__MIN_INDX_MASK                     = 0xffffffff;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__DISABLE_FOR_AUTO_INDEX_MASK = 0x00000004;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS_MASK     = 0x00000002;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__RESET_EN_MASK           = 0x00000001;
constexpr unsigned int GE_NGG_SUBGRP_CNTL__PRIM_AMP_FACTOR_MASK           = 0x000001ff;
constexpr unsigned int GE_NGG_SUBGRP_CNTL__THDS_PER_SUBGRP_MASK           = 0x0003fe00;
constexpr unsigned int GE_PA_IF_SAFE_REG__GE_PA_CSB_MASK                  = 0x000003ff;
constexpr unsigned int GE_PA_IF_SAFE_REG__GE_PA_PAYLOAD_MASK              = 0x000ffc00;
constexpr unsigned int GE_POS_RING_BASE__BASE_MASK                        = 0xffffffff;
constexpr unsigned int GE_POS_RING_SIZE__MEM_SIZE_MASK                    = 0x00003fff;
constexpr unsigned int GE_PRIM_RING_BASE__BASE_MASK                       = 0xffffffff;
constexpr unsigned int GE_PRIM_RING_SIZE__FORCE_SE_SCOPE_MASK             = 0x04000000;
constexpr unsigned int GE_PRIM_RING_SIZE__MEM_SIZE_MASK                   = 0x000007ff;
constexpr unsigned int GE_PRIM_RING_SIZE__PAB_NOFILL_MASK                 = 0x08000000;
constexpr unsigned int GE_PRIM_RING_SIZE__PAB_TEMPORAL_MASK               = 0x00e00000;
constexpr unsigned int GE_PRIM_RING_SIZE__PAF_TEMPORAL_MASK               = 0x001c0000;
constexpr unsigned int GE_PRIM_RING_SIZE__SCOPE_MASK                      = 0x00030000;
constexpr unsigned int GE_PRIM_RING_SIZE__SPEC_DATA_READ_MASK             = 0x03000000;
constexpr unsigned int GE_PRIV_CONTROL__CLAMP_HS_OFFCHIP_PER_SE_OVERRIDE_MASK = 0x00010000;
constexpr unsigned int GE_PRIV_CONTROL__CLAMP_PRIMGRP_SIZE_MASK           = 0x000003fe;
constexpr unsigned int GE_PRIV_CONTROL__FGCG_OVERRIDE_MASK                = 0x00008000;
constexpr unsigned int GE_PRIV_CONTROL__MIN_ATTR_GRPS_MASK                = 0x003c0000;
constexpr unsigned int GE_PRIV_CONTROL__RESERVED_MASK                     = 0x00000001;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_ES_VERT_MASK            = 0x000f0000;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_GS_PRIM_MASK            = 0x0f000000;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_HS_VERT_MASK            = 0x00000f00;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_LS_VERT_MASK            = 0x0000000f;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_ES_VERT_MASK         = 0x00f00000;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_GS_PRIM_MASK         = 0xf0000000;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_HS_VERT_MASK         = 0x0000f000;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_LS_VERT_MASK         = 0x000000f0;
constexpr unsigned int GE_RATE_CNTL_2__ADD_X_CLKS_MERGED_HS_GS_MASK       = 0x000f0000;
constexpr unsigned int GE_RATE_CNTL_2__ADD_X_CLKS_MERGED_LS_ES_MASK       = 0x00f00000;
constexpr unsigned int GE_RATE_CNTL_2__ENABLE_RATE_CNTL_MASK              = 0x04000000;
constexpr unsigned int GE_RATE_CNTL_2__MERGED_HS_GS_MODE_MASK             = 0x01000000;
constexpr unsigned int GE_RATE_CNTL_2__MERGED_LS_ES_MODE_MASK             = 0x02000000;
constexpr unsigned int GE_RATE_CNTL_2__SWAP_PRIORITY_MASK                 = 0x08000000;
constexpr unsigned int GE_SE_CNTL_STATUS__HS_BUSY_MASK                    = 0x00000004;
constexpr unsigned int GE_SE_CNTL_STATUS__NGG_BUSY_MASK                   = 0x00000002;
constexpr unsigned int GE_SE_CNTL_STATUS__TE_BUSY_MASK                    = 0x00000001;
constexpr unsigned int GE_SE_ENHANCE__MISC_MASK                           = 0xffffffff;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_GRP_MASK                = 0x0003f000;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_HS_GS_DATA_MASK         = 0x00000fc0;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_LS_ES_DATA_MASK         = 0x0000003f;
constexpr unsigned int GE_STATUS__PERFCOUNTER_STATUS_MASK                 = 0x00000001;
constexpr unsigned int GE_STATUS__THREAD_TRACE_STATUS_MASK                = 0x00000002;
constexpr unsigned int GE_STEREO_CNTL__EN_STEREO_MASK                     = 0x00000100;
constexpr unsigned int GE_STEREO_CNTL__RT_SLICE_MASK                      = 0x00000007;
constexpr unsigned int GE_STEREO_CNTL__UNUSED_MASK                        = 0x00000080;
constexpr unsigned int GE_STEREO_CNTL__VIEWPORT_MASK                      = 0x00000078;
constexpr unsigned int GE_USER_VGPR1__DATA_MASK                           = 0xffffffff;
constexpr unsigned int GE_USER_VGPR2__DATA_MASK                           = 0xffffffff;
constexpr unsigned int GE_USER_VGPR3__DATA_MASK                           = 0xffffffff;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR1_MASK                = 0x00000001;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR2_MASK                = 0x00000002;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR3_MASK                = 0x00000004;
constexpr unsigned int GE_VRS_RATE__RATE_X_MASK                           = 0x00000003;
constexpr unsigned int GE_VRS_RATE__RATE_Y_MASK                           = 0x00000030;
constexpr unsigned int GE_WD_CNTL_STATUS__DIST_BE_BUSY_MASK               = 0x00000002;
constexpr unsigned int GE_WD_CNTL_STATUS__DIST_BUSY_MASK                  = 0x00000001;
constexpr unsigned int GE_WD_CNTL_STATUS__GE_UTCL1_BUSY_MASK              = 0x00000004;
constexpr unsigned int GE_WD_CNTL_STATUS__PC_MANAGER_BUSY_MASK            = 0x00000010;
constexpr unsigned int GE_WD_CNTL_STATUS__WD_TE11_BUSY_MASK               = 0x00000008;
constexpr unsigned int GE_WD_CNTL_STATUS__WLC_BUSY_MASK                   = 0x00000020;
constexpr unsigned int GE_WD_ENHANCE__MISC_MASK                           = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK        = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK        = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2C_CTRL2__ADDR_MATCH_DISABLE_MASK                = 0x00000010;
constexpr unsigned int GL2C_CTRL2__COMPRESSED_WRITE_SAFE_MODE_MASK        = 0x00020000;
constexpr unsigned int GL2C_CTRL2__DCC_CLEAR_ERRORS_MASK                  = 0x01000000;
constexpr unsigned int GL2C_CTRL2__DCC_COMPRESSION_DISABLE_MASK           = 0x00004000;
constexpr unsigned int GL2C_CTRL2__DCC_COMP_TO_CONSTANT_EN_MASK           = 0x08000000;
constexpr unsigned int GL2C_CTRL2__DCC_COMP_TO_SINGLE_EN_MASK             = 0x04000000;
constexpr unsigned int GL2C_CTRL2__DECOMPRESS_WRITE_COMPRESSION_DISABLE_MASK = 0x00400000;
constexpr unsigned int GL2C_CTRL2__DF_COMPRESSION_MODE_OVERRIDE_MASK      = 0x00018000;
constexpr unsigned int GL2C_CTRL2__DISABLE_CACHE_RAM_READ_FILTER_MASK     = 0x40000000;
constexpr unsigned int GL2C_CTRL2__DISABLE_HI_PRIORITY_MASK               = 0x10000000;
constexpr unsigned int GL2C_CTRL2__DISABLE_TAG_RAM_READ_FILTER_MASK       = 0x80000000;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_32_MASK                      = 0x00000003;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_64_MASK                      = 0x0000000c;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_128_MASK                     = 0x00000020;
constexpr unsigned int GL2C_CTRL2__FORCE_WRITE_DECOMPRESSION_MASK         = 0x00800000;
constexpr unsigned int GL2C_CTRL2__GCR_ALL_SET_MASK                       = 0x00002000;
constexpr unsigned int GL2C_CTRL2__GCR_ARB_CTRL_MASK                      = 0x00001c00;
constexpr unsigned int GL2C_CTRL2__HIT_UNDER_MISS_DISABLE_MASK            = 0x00000080;
constexpr unsigned int GL2C_CTRL2__MAX_MIN_CTRL_MASK                      = 0x00300000;
constexpr unsigned int GL2C_CTRL2__OC_OVERRIDE_UNCOMP_LOGICAL_SIZE_DISABLE_MASK = 0x20000000;
constexpr unsigned int GL2C_CTRL2__RO_DISABLE_MASK                        = 0x00000100;
constexpr unsigned int GL2C_CTRL2__SC_TO_HI_PRIORITY_MASK                 = 0x00000040;
constexpr unsigned int GL2C_CTRL2__UNCOMP_RET_LATENCY_MODE_MASK           = 0x00000200;
constexpr unsigned int GL2C_CTRL2__USE_EA_EARLYWRRET_ON_WRITEBACK_MASK    = 0x00040000;
constexpr unsigned int GL2C_CTRL2__WRITEBACK_ALL_WAIT_FOR_ALL_EA_WRITE_COMPLETE_MASK = 0x00080000;
constexpr unsigned int GL2C_CTRL3__BANK_LINEAR_HASH_ENABLE_MASK           = 0x00000800;
constexpr unsigned int GL2C_CTRL3__BANK_LINEAR_HASH_MODE_MASK             = 0x00000020;
constexpr unsigned int GL2C_CTRL3__COMP_STREAM_OVERRIDE_BYPASS_MASK       = 0x04000000;
constexpr unsigned int GL2C_CTRL3__COMP_STREAM_OVERRIDE_MASK              = 0x00000001;
constexpr unsigned int GL2C_CTRL3__DECOMP_NBC_IND64_DISABLE_MASK          = 0x00002000;
constexpr unsigned int GL2C_CTRL3__EA_GMI_DISABLE_MASK                    = 0x02000000;
constexpr unsigned int GL2C_CTRL3__EA_READ_SIZE_LIMIT_MASK                = 0x00080000;
constexpr unsigned int GL2C_CTRL3__EA_WRITE_SIZE_LIMIT_MASK               = 0x00100000;
constexpr unsigned int GL2C_CTRL3__ENABLE_64B_LAST_USE_MASK               = 0x00000040;
constexpr unsigned int GL2C_CTRL3__FGCG_OVERRIDE_MASK                     = 0x00008000;
constexpr unsigned int GL2C_CTRL3__FORCE_MTYPE_UC_MASK                    = 0x00010000;
constexpr unsigned int GL2C_CTRL3__FORCE_READ_ON_WRITE_OP_MASK            = 0x00004000;
constexpr unsigned int GL2C_CTRL3__FORCE_UNCOMP_READ_MASK                 = 0x0000000c;
constexpr unsigned int GL2C_CTRL3__HASH_256B_ENABLE_MASK                  = 0x00001000;
constexpr unsigned int GL2C_CTRL3__INF_NAN_CLAMP_MASK                     = 0x08000000;
constexpr unsigned int GL2C_CTRL3__IO_CHANNEL_ENABLE_MASK                 = 0x00000100;
constexpr unsigned int GL2C_CTRL3__LAST_USE_MODE_MASK                     = 0x00000002;
constexpr unsigned int GL2C_CTRL3__LAST_USE_SAFE_MODE_MASK                = 0x00000010;
constexpr unsigned int GL2C_CTRL3__SCRATCH_MASK                           = 0xf0000000;
constexpr unsigned int GL2C_CTRL3__SET_GROUP_LINEAR_HASH_ENABLE_MASK      = 0x01000000;
constexpr unsigned int GL2C_CTRL3__UNCACHED_TO_UC_QUEUE_MASK              = 0x00000080;
constexpr unsigned int GL2C_CTRL3__WB_OPT_BURST_MAX_COUNT_MASK            = 0x00c00000;
constexpr unsigned int GL2C_CTRL3__WB_OPT_ENABLE_MASK                     = 0x00200000;
constexpr unsigned int GL2C_CTRL3__WRITE_SET_SECTOR_FULLY_WRITTEN_MASK    = 0x00040000;
constexpr unsigned int GL2C_CTRL4__CORE_MGCG_MODE_MASK                    = 0x00000080;
constexpr unsigned int GL2C_CTRL4__DCC_CLEAR_128B_CONSTANT_ENCODE_EN_MASK = 0x00008000;
constexpr unsigned int GL2C_CTRL4__DCC_FORCE_BYPASS_MASK                  = 0x00004000;
constexpr unsigned int GL2C_CTRL4__EA_COMPRESSED_NACK_DISABLE_MASK        = 0x00002000;
constexpr unsigned int GL2C_CTRL4__EA_NACK_DISABLE_MASK                   = 0x00000200;
constexpr unsigned int GL2C_CTRL4__EXECUTE_MGCG_MODE_MASK                 = 0x00000100;
constexpr unsigned int GL2C_CTRL4__FED_SAFE_MODE_MASK                     = 0x00000400;
constexpr unsigned int GL2C_CTRL4__FLUSH_SET_COUNTER_MASK_DISABLE_MASK    = 0x00000800;
constexpr unsigned int GL2C_CTRL4__LFIFO_HASH_MODE_MASK                   = 0xffff0000;
constexpr unsigned int GL2C_CTRL4__LFIFO_VMISS_DISABLE_MASK               = 0x00001000;
constexpr unsigned int GL2C_CTRL4__OC_UNCOMP_128B_COMPRESS_EN_DISABLE_MASK = 0x00000010;
constexpr unsigned int GL2C_CTRL4__SPA_CHANNEL_ENABLE_MASK                = 0x00000002;
constexpr unsigned int GL2C_CTRL4__TAG_MGCG_MODE_MASK                     = 0x00000040;
constexpr unsigned int GL2C_CTRL4__WRITEBACK_FIFO_STALL_ENABLE_MASK       = 0x00000008;
constexpr unsigned int GL2C_CTRL5__CB_SUPPORTED_COMP_SCHEME_MASK          = 0x00000007;
constexpr unsigned int GL2C_CTRL5__CID_REMAP_ENABLE_MASK                  = 0x00008000;
constexpr unsigned int GL2C_CTRL5__COMP_BYPASS_READ_MODE_MASK             = 0x00020000;
constexpr unsigned int GL2C_CTRL5__CONCAT_GT_128B_DISABLE_MASK            = 0x00000100;
constexpr unsigned int GL2C_CTRL5__DB_SUPPORTED_COMP_SCHEME_MASK          = 0x00000070;
constexpr unsigned int GL2C_CTRL5__FORCE_UNCOMP_READ_ON_UNCOMPRESSED_CL_MASK = 0x00000200;
constexpr unsigned int GL2C_CTRL5__LAST_USE_SAFE_MODE_COMP_MASK           = 0x00080000;
constexpr unsigned int GL2C_CTRL5__PERF_CNTR_EN_OVERRIDE_MASK             = 0x00010000;
constexpr unsigned int GL2C_CTRL5__UNCACHED_COMP_WRITE_PASSTHROUGH_EN_MASK = 0x00040000;
constexpr unsigned int GL2C_CTRL5__UNCOMP_KEY_COMP_WRITE_EN_MASK          = 0x00100000;
constexpr unsigned int GL2C_CTRL5__VGT_GS_MAX_WAVE_ID_WIDTH_MASK          = 0x00007c00;
constexpr unsigned int GL2C_CTRL__CACHE_SIZE_MASK                         = 0x00000003;
constexpr unsigned int GL2C_CTRL__DCC_COMP_SKIP_LOW_COMP_RATIOS_MASK      = 0x00000800;
constexpr unsigned int GL2C_CTRL__DCC_COMP_TRANSFER_SIZE_ENABLE_MASK      = 0x00000700;
constexpr unsigned int GL2C_CTRL__FORCE_HIT_QUEUE_POP_MASK                = 0x00c00000;
constexpr unsigned int GL2C_CTRL__IGNORE_FULLY_WRITTEN_MASK               = 0x08000000;
constexpr unsigned int GL2C_CTRL__LATENCY_FIFO_SIZE_MASK                  = 0x000f0000;
constexpr unsigned int GL2C_CTRL__LINEAR_SET_HASH_MASK                    = 0x00200000;
constexpr unsigned int GL2C_CTRL__RATE_MASK                               = 0x0000000c;
constexpr unsigned int GL2C_CTRL__SINGLE_GL2_MASK                         = 0x10000000;
constexpr unsigned int GL2C_CTRL__SRC_FIFO_SIZE_MASK                      = 0x0000f000;
constexpr unsigned int GL2C_CTRL__UNSUPPORTED_DF_ATOMIC_OPS_MASK          = 0x20000000;
constexpr unsigned int GL2C_CTRL__WRITEBACK_MARGIN_MASK                   = 0x000000f0;
constexpr unsigned int GL2C_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK         = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK         = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK          = 0x000003ff;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK          = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__CNTR_MODE_MASK           = 0x00f00000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE1_MASK          = 0x0f000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE_MASK           = 0xf0000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL1_MASK           = 0x000ffc00;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL_MASK            = 0x000003ff;
constexpr unsigned int GRBMH_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GRBMH_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00001000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__EA_LINK_BUSY_USER_DEFINED_MASK_MASK = 0x00800000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1A_BUSY_USER_DEFINED_MASK_MASK = 0x01000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000040;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1XCC_BUSY_USER_DEFINED_MASK_MASK = 0x00000080;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL2A_BUSY_USER_DEFINED_MASK_MASK = 0x00080000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL2C_BUSY_USER_DEFINED_MASK_MASK = 0x00008000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PC_BUSY_USER_DEFINED_MASK_MASK = 0x00400000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x0000003f;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SC_CLEAN_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SQG_BUSY_USER_DEFINED_MASK_MASK = 0x00000100;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x20000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__WGS_BUSY_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBMH_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int GRBMH_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00001000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__EA_LINK_BUSY_USER_DEFINED_MASK_MASK = 0x00800000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1A_BUSY_USER_DEFINED_MASK_MASK = 0x01000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000040;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1XCC_BUSY_USER_DEFINED_MASK_MASK = 0x00000080;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL2A_BUSY_USER_DEFINED_MASK_MASK = 0x00080000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL2C_BUSY_USER_DEFINED_MASK_MASK = 0x00008000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PC_BUSY_USER_DEFINED_MASK_MASK = 0x00400000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x0000003f;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SC_CLEAN_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SQG_BUSY_USER_DEFINED_MASK_MASK = 0x00000100;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x20000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__WGS_BUSY_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBMH_SYNC__GFX_PIPE0_PERFMON_SYNC_MASK            = 0x00000001;
constexpr unsigned int GRBMH_SYNC__GFX_PIPE0_SYNC_MASK                    = 0x00010000;
constexpr unsigned int GRBMH_SYNC__GFX_SYNC_SET_CLR_MASK                  = 0x80000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_BROADCAST_WRITES_MASK = 0x40000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_INDEX_MASK        = 0x0000007f;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_BROADCAST_WRITES_MASK   = 0x20000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_INDEX_MASK              = 0x00000300;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_BROADCAST_WRITES_MASK   = 0x80000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_INDEX_MASK              = 0x000f0000;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__INDEX_MASK               = 0x00000007;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__VF_PF_MASK               = 0x80000000;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_BROADCAST_WRITES_MASK     = 0x40000000;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_INDEX_MASK                = 0x0000007f;
constexpr unsigned int GRBM_GFX_INDEX__SA_BROADCAST_WRITES_MASK           = 0x20000000;
constexpr unsigned int GRBM_GFX_INDEX__SA_INDEX_MASK                      = 0x00000300;
constexpr unsigned int GRBM_GFX_INDEX__SE_BROADCAST_WRITES_MASK           = 0x80000000;
constexpr unsigned int GRBM_GFX_INDEX__SE_INDEX_MASK                      = 0x000f0000;
constexpr unsigned int GRBM_NOWHERE_2__DATA_MASK                          = 0xffffffff;
constexpr unsigned int GRBM_NOWHERE__DATA_MASK                            = 0xffffffff;
constexpr unsigned int GRBM_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GRBM_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__CH_BUSY_USER_DEFINED_MASK_MASK = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__EA_STAT_LINK_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000100;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1XCC_BUSY_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000004;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PC_BUSY_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK_MASK = 0x00000040;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK_MASK = 0x00000008;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00000002;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__WGS_BUSY_USER_DEFINED_MASK_MASK = 0x00001000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CP_BUSY_USER_DEFINED_MASK_MASK = 0x00400000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GRBM_BUSY_USER_DEFINED_MASK_MASK = 0x00080000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PERF_SEL_MASK            = 0x0000003f;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_CLEAN_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__UTCL2_BUSY_USER_DEFINED_MASK_MASK = 0x20000000;
constexpr unsigned int GRBM_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK          = 0xffffffff;
constexpr unsigned int GRBM_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK          = 0xffffffff;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__CH_BUSY_USER_DEFINED_MASK_MASK = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__EA_STAT_LINK_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000100;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1XCC_BUSY_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000004;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PC_BUSY_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK_MASK = 0x00000040;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK_MASK = 0x00000008;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00000002;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__WGS_BUSY_USER_DEFINED_MASK_MASK = 0x00001000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CP_BUSY_USER_DEFINED_MASK_MASK = 0x00400000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GRBM_BUSY_USER_DEFINED_MASK_MASK = 0x00080000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PERF_SEL_MASK            = 0x0000003f;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_CLEAN_USER_DEFINED_MASK_MASK = 0x00000200;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__UTCL2_BUSY_USER_DEFINED_MASK_MASK = 0x20000000;
constexpr unsigned int IA_UTCL1_CNTL__BYPASS_MASK                         = 0x02000000;
constexpr unsigned int IA_UTCL1_CNTL__DROP_MODE_MASK                      = 0x01000000;
constexpr unsigned int IA_UTCL1_CNTL__FORCE_SNOOP_MASK                    = 0x10000000;
constexpr unsigned int IA_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK                = 0x08000000;
constexpr unsigned int IA_UTCL1_CNTL__INVALIDATE_MASK                     = 0x04000000;
constexpr unsigned int IA_UTCL1_CNTL__LLC_NOALLOC_OVERRIDE_MASK           = 0x40000000;
constexpr unsigned int IA_UTCL1_CNTL__MTYPE_OVERRIDE_MASK                 = 0x20000000;
constexpr unsigned int IA_UTCL1_CNTL__VMID_RESET_MODE_MASK                = 0x00800000;
constexpr unsigned int IA_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK           = 0x000fffff;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_DETECTED_MASK             = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_INSTANCEID_MASK           = 0x0000c000;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_UTCL1ID_MASK              = 0x00003f00;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_VMID_MASK                 = 0x000000f0;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_DETECTED_MASK               = 0x00000004;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_INSTANCEID_MASK             = 0xc0000000;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_UTCL1ID_MASK                = 0x3f000000;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_DETECTED_MASK             = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_INSTANCEID_MASK           = 0x00c00000;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_UTCL1ID_MASK              = 0x003f0000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_DETECTED_MASK               = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_INSTANCEID_MASK             = 0x0000c000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_UTCL1ID_MASK                = 0x00003f00;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_VMID_MASK                   = 0x000000f0;
constexpr unsigned int IA_UTCL1_STATUS__PRT_DETECTED_MASK                 = 0x00000004;
constexpr unsigned int IA_UTCL1_STATUS__PRT_INSTANCEID_MASK               = 0xc0000000;
constexpr unsigned int IA_UTCL1_STATUS__PRT_UTCL1ID_MASK                  = 0x3f000000;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_DETECTED_MASK               = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_INSTANCEID_MASK             = 0x00c00000;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_UTCL1ID_MASK                = 0x003f0000;
constexpr unsigned int MP1_SMN_FPS_CNT__COUNT_MASK                        = 0xffffffff;
constexpr unsigned int PA_CL_CLIP_CNTL__BOUNDARY_EDGE_FLAG_ENA_MASK       = 0x00040000;
constexpr unsigned int PA_CL_CLIP_CNTL__CLIP_DISABLE_MASK                 = 0x00010000;
constexpr unsigned int PA_CL_CLIP_CNTL__DIS_CLIP_ERR_DETECT_MASK          = 0x00100000;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_CLIP_SPACE_DEF_MASK            = 0x00080000;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_LINEAR_ATTR_CLIP_ENA_MASK      = 0x01000000;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_RASTERIZATION_KILL_MASK        = 0x00400000;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_MODE_MASK                  = 0x0000c000;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_Y_SCALE_NEG_MASK           = 0x00002000;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_CULL_ONLY_ENA_MASK            = 0x00020000;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_0_MASK                    = 0x00000001;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_1_MASK                    = 0x00000002;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_2_MASK                    = 0x00000004;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_3_MASK                    = 0x00000008;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_4_MASK                    = 0x00000010;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_5_MASK                    = 0x00000020;
constexpr unsigned int PA_CL_CLIP_CNTL__VTE_VPORT_PROVOKE_DISABLE_MASK    = 0x02000000;
constexpr unsigned int PA_CL_CLIP_CNTL__VTX_KILL_OR_MASK                  = 0x00200000;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_FAR_DISABLE_MASK            = 0x08000000;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_NEAR_DISABLE_MASK           = 0x04000000;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_PROG_NEAR_ENA_MASK          = 0x10000000;
constexpr unsigned int PA_CL_CNTL_STATUS__CL_BUSY_MASK                    = 0x80000000;
constexpr unsigned int PA_CL_ENHANCE__BROADCAST_PERP_ENDCAP_PRIMS_MASK    = 0x20000000;
constexpr unsigned int PA_CL_ENHANCE__BROADCAST_PMODE_PRIMS_MASK          = 0x10000000;
constexpr unsigned int PA_CL_ENHANCE__CLAMP_NEGATIVE_BB_TO_ZERO_MASK      = 0x00800000;
constexpr unsigned int PA_CL_ENHANCE__CLIPPED_PRIM_SEQ_STALL_MASK         = 0x00000008;
constexpr unsigned int PA_CL_ENHANCE__CLIP_VTX_REORDER_ENA_MASK           = 0x00000001;
constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_PH_INTF_FINE_CLOCK_GATE_MASK = 0x00100000;
constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_SX_REQ_INTF_FINE_CLOCK_GATE_MASK = 0x00200000;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE0_MASK                     = 0x80000000;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE1_MASK                     = 0x40000000;
constexpr unsigned int PA_CL_ENHANCE__ENABLE_PA_RATE_CNTL_MASK            = 0x00400000;
constexpr unsigned int PA_CL_ENHANCE__IGNORE_PIPELINE_RESET_MASK          = 0x00000040;
constexpr unsigned int PA_CL_ENHANCE__KILL_INNER_EDGE_FLAGS_MASK          = 0x00000080;
constexpr unsigned int PA_CL_ENHANCE__NGG_BYPASS_PRIM_FILTER_MASK         = 0x00000800;
constexpr unsigned int PA_CL_ENHANCE__NGG_PA_TO_ALL_SC_MASK               = 0x00000100;
constexpr unsigned int PA_CL_ENHANCE__NGG_PRIM_INDICES_FIFO_DEPTH_MASK    = 0x0001c000;
constexpr unsigned int PA_CL_ENHANCE__NGG_SIDEBAND_MEMORY_DEPTH_MASK      = 0x00003000;
constexpr unsigned int PA_CL_ENHANCE__NUM_CLIP_SEQ_MASK                   = 0x00000006;
constexpr unsigned int PA_CL_ENHANCE__PAF_GEWD_CSB_CLK_OVERRIDE_MASK      = 0x08000000;
constexpr unsigned int PA_CL_ENHANCE__PA_R_GL1X_REQ_CLK_OVERRIDE_MASK     = 0x04000000;
constexpr unsigned int PA_CL_ENHANCE__PA_W_GL1X_REQ_CLK_OVERRIDE_MASK     = 0x02000000;
constexpr unsigned int PA_CL_ENHANCE__PA_W_GL1X_SRC_CLK_OVERRIDE_MASK     = 0x01000000;
constexpr unsigned int PA_CL_ENHANCE__POLY_INNER_EDGE_FLAG_DISABLE_MASK   = 0x00040000;
constexpr unsigned int PA_CL_ENHANCE__PROG_NEAR_CLIP_PLANE_ENABLE_MASK    = 0x00020000;
constexpr unsigned int PA_CL_ENHANCE__TC_LATENCY_TIME_STAMP_RESOLUTION_MASK = 0x00000600;
constexpr unsigned int PA_CL_ENHANCE__TC_REQUEST_PERF_CNTR_ENABLE_MASK    = 0x00080000;
constexpr unsigned int PA_CL_ENHANCE__VE_NAN_PROC_DISABLE_MASK            = 0x00000010;
constexpr unsigned int PA_CL_ENHANCE__XTRA_DEBUG_REG_SEL_MASK             = 0x00000020;
constexpr unsigned int PA_CL_GB_HORZ_CLIP_ADJ__DATA_REGISTER_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_GB_HORZ_DISC_ADJ__DATA_REGISTER_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_GB_VERT_CLIP_ADJ__DATA_REGISTER_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_GB_VERT_DISC_ADJ__DATA_REGISTER_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_CLIP_DIST_INF_DISCARD_MASK   = 0x00004000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_INF_RETAIN_MASK            = 0x00002000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_NAN_TO_INF_MASK            = 0x00001000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_INF_RETAIN_MASK           = 0x00000200;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_NAN_TO_INF_MASK           = 0x00000100;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_INF_RETAIN_MASK            = 0x00000800;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_NAN_TO_INF_MASK            = 0x00000400;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_0XNANINF_IS_0_MASK          = 0x00000008;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_NO_OUTPUT_NEG_0_MASK        = 0x00100000;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_INF_DISCARD_MASK          = 0x00000004;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_NAN_RETAIN_MASK           = 0x00000040;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_RECIP_NAN_IS_0_MASK       = 0x00000080;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_INF_DISCARD_MASK         = 0x00000001;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_NAN_RETAIN_MASK          = 0x00000010;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_INF_DISCARD_MASK          = 0x00000002;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_NAN_RETAIN_MASK           = 0x00000020;
constexpr unsigned int PA_CL_NGG_CNTL__INDEX_BUF_EDGE_FLAG_ENA_MASK       = 0x00000002;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_DEPTH_MASK            = 0x000003fc;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_OFF_MASK              = 0x00000001;
constexpr unsigned int PA_CL_POINT_CULL_RAD__DATA_REGISTER_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_POINT_SIZE__DATA_REGISTER_MASK               = 0xffffffff;
constexpr unsigned int PA_CL_POINT_X_RAD__DATA_REGISTER_MASK              = 0xffffffff;
constexpr unsigned int PA_CL_POINT_Y_RAD__DATA_REGISTER_MASK              = 0xffffffff;
constexpr unsigned int PA_CL_PROG_NEAR_CLIP_Z__DATA_REGISTER_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_UCP_0_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_0_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_0_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_0_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_1_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_1_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_1_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_1_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_2_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_2_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_2_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_2_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_3_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_3_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_3_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_3_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_4_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_4_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_4_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_4_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_5_W__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_5_X__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_5_Y__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_UCP_5_Z__DATA_REGISTER_MASK                  = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_1__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_2__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_3__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_4__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_5__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_6__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_7__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_8__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_9__VPORT_XOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_10__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_11__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_12__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_13__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_14__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET_15__VPORT_XOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XOFFSET__VPORT_XOFFSET_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_1__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_2__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_3__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_4__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_5__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_6__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_7__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_8__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_9__VPORT_XSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_10__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_11__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_12__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_13__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_14__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE_15__VPORT_XSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_XSCALE__VPORT_XSCALE_MASK              = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_1__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_2__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_3__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_4__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_5__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_6__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_7__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_8__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_9__VPORT_YOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_10__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_11__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_12__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_13__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_14__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET_15__VPORT_YOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YOFFSET__VPORT_YOFFSET_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_1__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_2__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_3__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_4__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_5__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_6__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_7__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_8__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_9__VPORT_YSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_10__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_11__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_12__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_13__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_14__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE_15__VPORT_YSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_YSCALE__VPORT_YSCALE_MASK              = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_1__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_2__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_3__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_4__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_5__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_6__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_7__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_8__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_9__VPORT_ZOFFSET_MASK          = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_10__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_11__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_12__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_13__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_14__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_15__VPORT_ZOFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZOFFSET__VPORT_ZOFFSET_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_1__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_2__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_3__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_4__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_5__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_6__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_7__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_8__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_9__VPORT_ZSCALE_MASK            = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_10__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_11__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_12__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_13__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_14__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE_15__VPORT_ZSCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_CL_VPORT_ZSCALE__VPORT_ZSCALE_MASK              = 0xffffffff;
constexpr unsigned int PA_CL_VRS_CNTL__CMASK_RATE_HINT_FORCE_ZERO_MASK    = 0x00004000;
constexpr unsigned int PA_CL_VRS_CNTL__EXPOSE_VRS_PIXELS_MASK_MASK        = 0x00002000;
constexpr unsigned int PA_CL_VRS_CNTL__HTILE_RATE_COMBINER_MODE_MASK      = 0x000001c0;
constexpr unsigned int PA_CL_VRS_CNTL__PRIMITIVE_RATE_COMBINER_MODE_MASK  = 0x00000038;
constexpr unsigned int PA_CL_VRS_CNTL__SAMPLE_COVERAGE_ENCODING_MASK      = 0x00008000;
constexpr unsigned int PA_CL_VRS_CNTL__SAMPLE_ITER_COMBINER_MODE_MASK     = 0x00000e00;
constexpr unsigned int PA_CL_VRS_CNTL__VERTEX_RATE_COMBINER_MODE_MASK     = 0x00000007;
constexpr unsigned int PA_CL_VS_OUT_CNTL__BYPASS_PRIM_RATE_COMBINER_MASK  = 0x40000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__BYPASS_VTX_RATE_COMBINER_MASK   = 0x20000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_0_MASK            = 0x00000001;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_1_MASK            = 0x00000002;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_2_MASK            = 0x00000004;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_3_MASK            = 0x00000008;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_4_MASK            = 0x00000010;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_5_MASK            = 0x00000020;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_6_MASK            = 0x00000040;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_7_MASK            = 0x00000080;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_0_MASK            = 0x00000100;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_1_MASK            = 0x00000200;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_2_MASK            = 0x00000400;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_3_MASK            = 0x00000800;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_4_MASK            = 0x00001000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_5_MASK            = 0x00002000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_6_MASK            = 0x00004000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_7_MASK            = 0x00008000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_EDGE_FLAG_MASK          = 0x00020000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_KILL_FLAG_MASK          = 0x00100000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH_MASK         = 0x08000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_POINT_SIZE_MASK         = 0x00010000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_RENDER_TARGET_INDX_MASK = 0x00040000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VIEWPORT_INDX_MASK      = 0x00080000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VRS_RATE_MASK           = 0x10000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST0_VEC_ENA_MASK     = 0x00400000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST1_VEC_ENA_MASK     = 0x00800000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_SIDE_BUS_ENA_MASK   = 0x01000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_VEC_ENA_MASK        = 0x00200000;
constexpr unsigned int PA_CL_VTE_CNTL__PERFCOUNTER_REF_MASK               = 0x00000800;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_OFFSET_ENA_MASK            = 0x00000002;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_SCALE_ENA_MASK             = 0x00000001;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_OFFSET_ENA_MASK            = 0x00000008;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_SCALE_ENA_MASK             = 0x00000004;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_OFFSET_ENA_MASK            = 0x00000020;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_SCALE_ENA_MASK             = 0x00000010;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_W0_FMT_MASK                    = 0x00000400;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_XY_FMT_MASK                    = 0x00000100;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_Z_FMT_MASK                     = 0x00000200;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_MASK                  = 0x00000020;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_SCAN_POST_RESET_MASK  = 0x00000040;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_PERF_REG_FGCG_MASK       = 0x00000200;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_CLKEN_CLOCK_GATE_MASK = 0x00000080;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_FINE_CLOCK_GATE_MASK = 0x00000010;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_USE_LAST_PH_ARBITER_PERFCOUNTER_SAMPLE_EVENT_MASK = 0x00002000;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE0_MASK                     = 0x00000001;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE1_MASK                     = 0x00000002;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE2_MASK                     = 0x00000004;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE3_MASK                     = 0x00000008;
constexpr unsigned int PA_PH_ENHANCE__ENABLE_PH_INTF_CLKEN_STRETCH_MASK   = 0x00001c00;
constexpr unsigned int PA_PH_ENHANCE__FORCE_PH_PERFCOUNTER_SAMPLE_ENABLE_ON_MASK = 0x00008000;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_MODE_DISABLE_MASK = 0x00020000;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_MODE_MASK        = 0x00010000;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_PERFCOUNTER_COUNT_MODE_MASK = 0x00040000;
constexpr unsigned int PA_PH_ENHANCE__USE_PERFCOUNTER_START_STOP_EVENTS_MASK = 0x00004000;
constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PA_PH_IF_FIFO_SIZE_MASK = 0x000003ff;
constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PH_SC_IF_FIFO_SIZE_MASK = 0x003f0000;
constexpr unsigned int PA_PH_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER4_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER5_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER6_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_PH_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_PH_PERFCOUNTER7_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_RATE_CNTL__PRIM_RATE_MASK                       = 0x000000f0;
constexpr unsigned int PA_RATE_CNTL__VERTEX_RATE_MASK                     = 0x0000000f;
constexpr unsigned int PA_SC_AA_CONFIG__AA_MASK_CENTROID_DTMN_MASK        = 0x00000010;
constexpr unsigned int PA_SC_AA_CONFIG__DETAIL_TO_EXPOSED_MODE_MASK       = 0x03000000;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_EXPOSED_SAMPLES_MASK         = 0x00700000;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_NUM_SAMPLES_MASK             = 0x00000007;
constexpr unsigned int PA_SC_AA_CONFIG__PS_ITER_SAMPLES_MASK              = 0xc0000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X0Y0_MASK         = 0x0000ffff;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X1Y0_MASK         = 0xffff0000;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X0Y1_MASK         = 0x0000ffff;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X1Y1_MASK         = 0xffff0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_X_MASK      = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_Y_MASK      = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_X_MASK      = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_Y_MASK      = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_X_MASK      = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_Y_MASK      = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_X_MASK      = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_Y_MASK      = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_X_MASK      = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_Y_MASK      = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_X_MASK      = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_Y_MASK      = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_X_MASK       = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_Y_MASK       = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_X_MASK       = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_Y_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_X_MASK       = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_Y_MASK       = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_X_MASK       = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_Y_MASK       = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_X_MASK      = 0x0000000f;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_Y_MASK      = 0x000000f0;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_X_MASK      = 0x00000f00;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_Y_MASK      = 0x0000f000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_X_MASK      = 0x000f0000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_Y_MASK      = 0x00f00000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_X_MASK      = 0x0f000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_Y_MASK      = 0xf0000000;
constexpr unsigned int PA_SC_ATM_CNTL__DISABLE_MAX_ATTRIBUTES_MASK        = 0x00010000;
constexpr unsigned int PA_SC_ATM_CNTL__DISABLE_SC_PC_IF_FGCG_EN_MASK      = 0x00000080;
constexpr unsigned int PA_SC_ATM_CNTL__MAX_ATTRIBUTES_IN_WAVE_MASK        = 0x0000ff00;
constexpr unsigned int PA_SC_ATM_CNTL__SC_PC_IF_SIZE_MASK                 = 0x0000003f;
constexpr unsigned int PA_SC_ATM_CNTL__SELECT_MAX_ATTRIBUTES_MASK         = 0x00020000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BINNING_MODE_MASK             = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_MAPPING_MODE_MASK         = 0x60000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_EXTEND_MASK        = 0x00000070;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_MASK               = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_EXTEND_MASK        = 0x00000380;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_MASK               = 0x00000008;
constexpr unsigned int PA_SC_BINNER_CNTL_0__CONTEXT_STATES_PER_BIN_MASK   = 0x00001c00;
constexpr unsigned int PA_SC_BINNER_CNTL_0__DISABLE_START_OF_PRIM_MASK    = 0x00040000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FLUSH_ON_BINNING_TRANSITION_MASK = 0x10000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FPOVS_PER_BATCH_MASK          = 0x07f80000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__OPTIMAL_BIN_SELECTION_MASK    = 0x08000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__PERSISTENT_STATES_PER_BIN_MASK = 0x0003e000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__RESERVED_31_MASK              = 0x80000000;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_ALLOC_COUNT_MASK          = 0x0000ffff;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_PRIM_PER_BATCH_MASK       = 0xffff0000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__BIN_SIZE_X_MULT_BY_1P5X_MASK  = 0x00000001;
constexpr unsigned int PA_SC_BINNER_CNTL_2__BIN_SIZE_Y_MULT_BY_1P5X_MASK  = 0x00000002;
constexpr unsigned int PA_SC_BINNER_CNTL_2__CONTEXT_DONE_EVENTS_PER_BIN_MASK = 0x00000780;
constexpr unsigned int PA_SC_BINNER_CNTL_2__DISABLE_NOPCEXPORT_BREAKBATCH_CONDITION_MASK = 0x00200000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__DUAL_LIGHT_SHAFT_IN_DRAW_MASK = 0x00000008;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ENABLE_LIGHT_VOLUME_RENDERING_OPTIMIZATION_MASK = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ENABLE_PING_PONG_BIN_ORDER_MASK = 0x00800000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__LIGHT_SHAFT_DRAW_CALL_LIMIT_MASK = 0x7c000000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__PING_PONG_BIN_ORDER_FLIP_MASK = 0x03000000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__RESERVED_LIGHT_SHAFT_DRAW_CALL_LIMIT_MASK = 0x00000070;
constexpr unsigned int PA_SC_BINNER_CNTL_2__SBB_ENABLE_MASK               = 0x00400000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_AREA_THRESHOLD_MASK       = 0x001fe000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_ENABLED_MASK              = 0x00000800;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_OPTIMIZATION_ENABLED_MASK = 0x00001000;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__BINNING_MODE_MASK      = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__CONTEXT_STATES_PER_BIN_MASK = 0x00001c00;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__DIRECT_OVERRIDE_MODE_MASK = 0x08000000;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__FPOVS_PER_BATCH_MASK   = 0x07f80000;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__OVERRIDE_MASK          = 0xf0000000;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__PERSISTENT_STATES_PER_BIN_MASK = 0x0003e000;
constexpr unsigned int PA_SC_BINNER_DYNAMIC_BATCH_LIMIT__LIMIT_MASK       = 0x000007ff;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__BREAK_BATCH_MASK        = 0x30000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_MASK        = 0x00003000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_TS_MASK     = 0x00000300;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CONTEXT_DONE_MASK       = 0x00000c00;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CS_PARTIAL_FLUSH_MASK   = 0x0000c000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_IB_END_MASK = 0x03000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_INCR_DE_MASK = 0x00c00000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__EVENT_STATE_CHANGE_MASK = 0x000c0000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_0_MASK         = 0x00000003;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RST_PIX_CNT_MASK        = 0x0c000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS1_MASK = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS2_MASK = 0x00000030;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS3_MASK = 0x000000c0;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_RESET_MASK = 0x00300000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_SYNC_MASK = 0x00030000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VS_PARTIAL_FLUSH_MASK   = 0xc0000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__BIN_CONF_OVERRIDE_CHECK_MASK = 0x0c000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_EVENT_MASK = 0x00003000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_TS_EVENT_MASK = 0x00000300;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_DFSM_MASK         = 0x00000030;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_ES_OUTPUT_MASK    = 0x03000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_HS_OUTPUT_MASK    = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_SAMPLE_MASK = 0x00c00000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_START_MASK  = 0x0000c000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_STOP_MASK   = 0x00030000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_START_MASK = 0x000c0000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_STOP_MASK  = 0x00300000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PS_PARTIAL_FLUSH_MASK   = 0x00000003;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__RESET_TO_LOWEST_VGT_MASK = 0x000000c0;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SAMPLE_PIPELINESTAT_MASK = 0x30000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SO_VGTSTREAMOUT_FLUSH_MASK = 0xc0000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__WAIT_SYNC_MASK          = 0x00000c00;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BLOCK_CONTEXT_DONE_MASK = 0x00000030;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BOTTOM_OF_PIPE_TS_MASK  = 0x00030000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_DONE_MASK            = 0xc0000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__DB_CACHE_FLUSH_AND_INV_MASK = 0x00300000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_DATA_TS_MASK = 0x0c000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_META_MASK = 0x30000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_DATA_TS_MASK = 0x00c00000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_META_MASK = 0x03000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_35_MASK        = 0x000000c0;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_41_MASK        = 0x000c0000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESET_VTX_CNT_MASK      = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SAMPLE_STREAMOUTSTATS_MASK = 0x00000003;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SC_SEND_DB_VPZ_MASK     = 0x0000c000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SQ_NON_EVENT_MASK       = 0x00003000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__TGID_ROLLOVER_MASK      = 0x00000c00;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__VGT_FLUSH_MASK          = 0x00000300;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__CONTEXT_SUSPEND_MASK    = 0x00c00000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__DRAW_DONE_MASK          = 0xc0000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_NGG_PIPELINE_MASK = 0x0c000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_PIPELINE_NOT_USED_MASK = 0x30000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__FLUSH_AND_INV_CB_PIXEL_DATA_MASK = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__OFFCHIP_HS_DEALLOC_MASK = 0x03000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_CONTROL_MASK = 0x00030000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_DUMP_MASK = 0x000c0000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_RESET_MASK = 0x00300000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PS_DONE_MASK            = 0x00000003;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_50_MASK        = 0x00000030;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_DRAW_MASK  = 0x00003000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FINISH_MASK = 0x0000c000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_MARKER_MASK = 0x00000c00;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_START_MASK = 0x000000c0;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_STOP_MASK  = 0x00000300;
constexpr unsigned int PA_SC_BINNER_OUTPUT_TIMEOUT_CNTL__THRESHOLD_MASK   = 0x0000ffff;
constexpr unsigned int PA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER__THRESHOLD_MASK = 0xffffffff;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_CONTEXT_THRESHOLD_MASK = 0x03800000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_PRIMS_THRESHOLD_MASK = 0x000ffc00;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_CONTEXT_THRESHOLD_MASK = 0x00700000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_PRIMS_THRESHOLD_MASK = 0x000003ff;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_PERSISTENT_STATE_THRESHOLD_MASK = 0x000003e0;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_TRIV_REJECTED_PRIMS_THRESHOLD_MASK = 0x03fffc00;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BIN_HIST_NUM_PERSISTENT_STATE_THRESHOLD_MASK = 0x0000001f;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_COLUMNS_PER_ROW_THRESHOLD_MASK = 0x003ff800;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_ROWS_PER_PRIM_THRESHOLD_MASK = 0x000007ff;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_3__BATCH_HIST_NUM_PS_WAVE_BREAKS_THRESHOLD_MASK = 0xffffffff;
constexpr unsigned int PA_SC_BINNER_TIMEOUT_COUNTER__THRESHOLD_MASK       = 0xffffffff;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_0_MASK         = 0x0000000f;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_1_MASK         = 0x000000f0;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_2_MASK         = 0x00000f00;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_3_MASK         = 0x0000f000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_4_MASK         = 0x000f0000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_5_MASK         = 0x00f00000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_6_MASK         = 0x0f000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_7_MASK         = 0xf0000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_8_MASK         = 0x0000000f;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_9_MASK         = 0x000000f0;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_10_MASK        = 0x00000f00;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_11_MASK        = 0x0000f000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_12_MASK        = 0x000f0000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_13_MASK        = 0x00f00000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_14_MASK        = 0x0f000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_15_MASK        = 0xf0000000;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__BR_X_EXT_MASK                = 0x00000003;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__BR_Y_EXT_MASK                = 0x0000000c;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__TL_X_EXT_MASK                = 0x00000030;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__TL_Y_EXT_MASK                = 0x000000c0;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__BR_X_EXT_MASK                = 0x00000003;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__BR_Y_EXT_MASK                = 0x0000000c;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__TL_X_EXT_MASK                = 0x00000030;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__TL_Y_EXT_MASK                = 0x000000c0;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__BR_X_EXT_MASK                = 0x00000003;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__BR_Y_EXT_MASK                = 0x0000000c;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__TL_X_EXT_MASK                = 0x00000030;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__TL_Y_EXT_MASK                = 0x000000c0;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__BR_X_EXT_MASK                = 0x00000003;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__BR_Y_EXT_MASK                = 0x0000000c;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__TL_X_EXT_MASK                = 0x00000030;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__TL_Y_EXT_MASK                = 0x000000c0;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_X_MASK                     = 0x00007fff;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_Y_MASK                     = 0x7fff0000;
constexpr unsigned int PA_SC_CLIPRECT_RULE__CLIP_RULE_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__CENTROID_SAMPLE_OVERRIDE_MASK = 0x01000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__COVERAGE_AA_MASK_ENABLE_MASK = 0x00200000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE_MASK = 0x00008000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__INNER_UNCERTAINTY_EDGERULE_OVERRIDE_MASK = 0x00080000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__NULL_SQUAD_AA_MASK_ENABLE_MASK = 0x00100000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OUTER_UNCERTAINTY_EDGERULE_OVERRIDE_MASK = 0x00040000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_OVER_RAST_INNER_TO_NORMAL_MASK = 0x00002000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_UNDER_RAST_INNER_TO_NORMAL_MASK = 0x00004000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_ENABLE_MASK = 0x00000001;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_SAMPLE_SELECT_MASK = 0x0000001e;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PBB_UNCERTAINTY_REGION_ENABLE_MASK = 0x00000400;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__POSTZ_AA_MASK_ENABLE_MASK = 0x00800000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PREZ_AA_MASK_ENABLE_MASK = 0x00400000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MODE_MASK = 0x00030000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MULT_MASK = 0x06000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_PBB_MULT_MASK = 0x18000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_ENABLE_MASK = 0x00000020;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_SAMPLE_SELECT_MASK = 0x000003c0;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_EXTENT_MASK = 0x00000800;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_OFFSET_MASK = 0x00001000;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_0_MASK               = 0x00000001;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_1_MASK               = 0x00000002;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_BT_MASK                    = 0xf0000000;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_LR_MASK                    = 0x0003f000;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_RL_MASK                    = 0x00fc0000;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_TB_MASK                    = 0x0f000000;
constexpr unsigned int PA_SC_EDGERULE__ER_POINT_MASK                      = 0x000000f0;
constexpr unsigned int PA_SC_EDGERULE__ER_RECT_MASK                       = 0x00000f00;
constexpr unsigned int PA_SC_EDGERULE__ER_TRI_MASK                        = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE_1__BYPASS_PBB_MASK                   = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_COUNT_PIXELS_MASK = 0x00002000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_FORCE_SOP_ALL_EVENTS_MASK = 0x00080000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_INTF_CG_MASK              = 0x00800000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_NONBINNED_LIVE_PRIM_DG1_LS0_CL0_EOPKT_POKE_MASK = 0x00000020;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_ODC_ENHANCE_MASK   = 0x00010000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_BINNING_CLK_OPTIMIZATION_MASK = 0x00400000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_CLK_OPTIMIZATION_MASK = 0x00100000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_CLK_OPTIMIZATION_MASK = 0x00200000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_OPT_MASK      = 0x00000400;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_QUAD_PROC_FDCE_ENHANCE_MASK = 0x08000000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_BINNING_MASK           = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_DB_STILE_INTF_FINE_CLOCK_GATE_MASK = 0x00004000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PROCESS_RESET_PBB_MASK = 0x00000200;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_1_MASK = 0x20000000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_MASK = 0x10000000;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SHADER_PROFILING_FOR_POWER_MASK = 0x02000000;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE1_MASK                   = 0x00000040;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE2_MASK                   = 0x00000080;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE3_MASK                   = 0x00000100;
constexpr unsigned int PA_SC_ENHANCE_1__ENABLE_DFSM_FLUSH_EVENT_TO_FLUSH_POPS_CAM_MASK = 0x00000800;
constexpr unsigned int PA_SC_ENHANCE_1__FLUSH_ON_BINNING_TRANSITION_MASK  = 0x04000000;
constexpr unsigned int PA_SC_ENHANCE_1__IOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT_MASK = 0x01000000;
constexpr unsigned int PA_SC_ENHANCE_1__OPTIMAL_BIN_SELECTION_MASK        = 0x00040000;
constexpr unsigned int PA_SC_ENHANCE_1__PASS_VPZ_EVENT_TO_SPI_MASK        = 0x40000000;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_ENABLE_MASK = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_MASK      = 0x00000006;
constexpr unsigned int PA_SC_ENHANCE_1__RESERVED_31_MASK                  = 0x80000000;
constexpr unsigned int PA_SC_ENHANCE_2__BREAK_WHEN_ONE_NULL_PRIM_BATCH_MASK = 0x04000000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPELINE_RESET_MASK = 0x00040000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPE_SWITCH_MASK = 0x00000100;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_EXPOSED_GT_DETAIL_RATE_TILE_COV_ADJ_MASK = 0x00008000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_FULL_TILE_WAVE_BREAK_MASK = 0x00000200;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_MAX_DEALLOC_FORCE_EOV_RESET_N_WAVES_COUNT_MASK = 0x40000000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PACKER_GRAD_FDCE_ENHANCE_MASK = 0x00001000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_INTF_EARLY_WAKEUP_MASK = 0x00004000;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_PRIM_INTF_FINE_CLOCK_GATE_MASK = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_QUAD_INTF_FINE_CLOCK_GATE_MASK = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_SPI_INTF_EARLY_WAKEUP_MASK = 0x00002000;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_FPOV_WAVE_BREAK_MASK       = 0x00000020;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_LPOV_WAVE_BREAK_MASK       = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PRIM_PAYLOAD_MASK = 0x00000080;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_VPZ_INJECTION_BEFORE_NULL_PRIMS_MASK = 0x00000400;
constexpr unsigned int PA_SC_ENHANCE_2__NULL_PRIM_BREAK_BATCH_LIMIT_MASK  = 0x38000000;
constexpr unsigned int PA_SC_ENHANCE_2__PBB_MAIN_CLK_REG_BUSY_WAKEUP_MASK = 0x00020000;
constexpr unsigned int PA_SC_ENHANCE_2__PBB_TIMEOUT_THRESHOLD_MODE_MASK   = 0x00000800;
constexpr unsigned int PA_SC_ENHANCE_2__PROCESS_RESET_FORCE_STILE_MASK_TO_ZERO_MASK = 0x00800000;
constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_16_MASK                  = 0x00010000;
constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_22_MASK                  = 0x00400000;
constexpr unsigned int PA_SC_ENHANCE_2__RSVD_MASK                         = 0x80000000;
constexpr unsigned int PA_SC_ENHANCE_3__APPLY_AA_MASK_AT_EXPOSED_RATE_FOR_VRS_COURSE_QUADS_WITH_CR_MASK = 0x08000000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_CP_CONTEXT_DONE_PERFCOUNT_SAMPLE_EN_MASK = 0x00000020;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_EVENT_INCLUSION_IN_CONTEXT_STATES_PER_BIN_MASK = 0x00008000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_FAST_NULL_PRIM_OPTIMIZATION_MASK = 0x00000800;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_LIGHT_VOLUME_RENDERING_OPTIMIZATION_MASK = 0x00002000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PBB_EOP_OPTIMIZATION_WITH_SAME_CONTEXT_BATCHES_MASK = 0x00000400;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PIXEL_WAIT_SYNC_COUNTERS_MASK = 0x00010000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_BCI_QUAD_NEW_PRIM_DATA_LOAD_OPTIMIZATION_MASK = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_FORCE_EOV_MAX_CLK_CNT_FOR_SPI_BACKPRESSURE_ONLY_MASK = 0x00200000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_FORCE_EOV_MAX_REZ_CNT_FOR_SPI_BACKPRESSURE_ONLY_MASK = 0x00100000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PWS_PRE_DEPTH_WAIT_SYNC_VPZ_INSERTION_MASK = 0x00800000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_RB_MASK_COPY_FOR_NONP2_SA_PAIR_HARVEST_MASK = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_CPG_PSINVOC_SEDC_ISOLATION_ACCUM_MASK = 0x00020000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_GL1X_REQ_FINE_CLOCK_GATE_MASK = 0x80000000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_GL1X_SRC_FINE_CLOCK_GATE_MASK = 0x40000000;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SET_VPZ_DIRTY_EOPKT_LAST_PHASE_ONLY_MASK = 0x00000200;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_ZPRE_PASS_OPTIMIZATION_MASK = 0x00004000;
constexpr unsigned int PA_SC_ENHANCE_3__DO_NOT_INCLUDE_OREO_WAVEID_IN_FORCE_EOV_MAX_CNT_DISABLE_MASK = 0x00400000;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE0_MASK                   = 0x10000000;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE1_MASK                   = 0x20000000;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE2_MASK                   = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_FIRST_PHASE_FILTER_MASK = 0x00000040;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_LAST_PHASE_FILTER_FOR_PBB_BINNED_PRIMS_MASK = 0x00000100;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_LAST_PHASE_FILTER_MASK = 0x00000080;
constexpr unsigned int PA_SC_ENHANCE_3__FORCE_PBB_WORKLOAD_MODE_TO_ZERO_MASK = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_3__FORCE_USE_OF_SC_CENTROID_DATA_MASK = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_CNT_FORCE_EOV_AT_QS_EMPTY_ONLY_MASK = 0x01000000;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_S0_FORCE_EOV_STALL_MASK       = 0x02000000;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_S1_FORCE_EOV_STALL_MASK       = 0x04000000;
constexpr unsigned int PA_SC_ENHANCE_3__USE_PBB_PRIM_STORAGE_WHEN_STALLED_MASK = 0x00001000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_AA_MASK_FULL_FIX_MASK       = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_DUALGRAD_PERF_OPTIMIZATION_MASK = 0x00000080;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOP_LINE_STIPPLE_RESET_MASK = 0x04000000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS_MASK = 0x00001000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OOO_NO_EOPG_SKEW_DESIRED_FIFO_IS_CURRENT_FIFO_MASK = 0x00800000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING_MASK = 0x00080000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS_MASK = 0x00200000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST_MASK = 0x00010000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE_MASK = 0x00004000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING_MASK = 0x00100000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING_MASK = 0x00020000;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_PA_SC_GUIDANCE_MASK         = 0x00000800;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SCISSOR_FIX_MASK            = 0x00000020;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_DB_TILE_FIX_MASK         = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_PRIM_MASK  = 0x00000100;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_SUPERTILE_MASK = 0x00000200;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_TILE_MASK  = 0x00000400;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_VPZ_EOP_LINE_STIPPLE_RESET_MASK = 0x08000000;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOCATIONS_MASK = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOC_CENTROID_MASK = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_MULTICYCLE_BUBBLE_FREEZE_MASK = 0x00002000;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID_MASK = 0x00400000;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_POLY_MODE_MASK  = 0x00008000;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY_MASK = 0x00040000;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_PA_SC_OUT_OF_ORDER_MASK      = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__IOO_DISABLE_SCAN_UNSELECTED_FIFOS_FOR_DUAL_GFX_RING_CHANGE_MASK = 0x10000000;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOPG_SKEW_THRESHOLD_SWITCHING_MASK = 0x02000000;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT_MASK = 0x01000000;
constexpr unsigned int PA_SC_ENHANCE__OOO_USE_ABSOLUTE_FIFO_COUNT_IN_THRESHOLD_SWITCHING_MASK = 0x20000000;
constexpr unsigned int PA_SC_ENHANCE__SEND_UNLIT_STILES_TO_PACKER_MASK    = 0x00000040;
constexpr unsigned int PA_SC_FIFO_DEPTH_CNTL__DEPTH_MASK                  = 0x000003ff;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_BACKEND_PRIM_FIFO_SIZE_MASK    = 0x00007fc0;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_EARLYZ_TILE_FIFO_SIZE_MASK     = 0xffe00000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_FRONTEND_PRIM_FIFO_SIZE_MASK   = 0x0000003f;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_HIZ_TILE_FIFO_SIZE_MASK        = 0x001f8000;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_CLK_CNT_MASK = 0x0000ffff;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_REZ_CNT_MASK = 0xffff0000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_HISZ_CONTROL__CONSERVATIVE_Z_EXPORT_MASK     = 0x00000018;
constexpr unsigned int PA_SC_HISZ_CONTROL__ROUND_MASK                     = 0x00000007;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DEPTH_BOUNDS_HIER_DEPTH_DISABLE_MASK = 0x00000200;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_FAST_PASS_MASK = 0x00000800;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_SINGLE_STENCIL_MASK = 0x00001000;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES_MASK = 0x00000100;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FAST_STENCIL_DISABLE_MASK = 0x00000020;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FAST_Z_DISABLE_MASK    = 0x00000010;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE_MASK = 0x000000c0;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_HIS_ENABLE_MASK  = 0x0000000c;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_HIZ_ENABLE_MASK  = 0x00000003;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__PRESERVE_ZRANGE_MASK   = 0x00000400;
constexpr unsigned int PA_SC_HIS_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int PA_SC_HIS_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int PA_SC_HIS_INFO__SURFACE_ENABLE_MASK                = 0x00000001;
constexpr unsigned int PA_SC_HIS_INFO__SW_MODE_MASK                       = 0x0000000e;
constexpr unsigned int PA_SC_HIS_SIZE_XY__X_MAX_MASK                      = 0x00001fff;
constexpr unsigned int PA_SC_HIS_SIZE_XY__Y_MAX_MASK                      = 0x1fff0000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_CONTEXT_DONE_SYNC_DISABLE_MASK = 0x00000040;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_DB_CONTEXT_DONE_SYNC_DISABLE_MASK = 0x00000080;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_EOP_SYNC_DISABLE_MASK  = 0x00040000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_EVICT_POINT_MASK       = 0xfc000000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_FLUSH_EVENT_MASK_DISABLE_MASK = 0x00001f00;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_FLUSH_NO_INV_DISABLE_MASK = 0x00004000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_MAX_TAGS_MASK          = 0x03f80000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_NONSTALLING_FLUSH_DISABLE_MASK = 0x00008000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_OUTSTANDING_CONTEXT_FILTERING_DISABLE_MASK = 0x00000020;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_PARTIAL_FLUSH_DISABLE_MASK = 0x00010000;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_PREFETCH_DISABLE_MASK  = 0x00002000;
constexpr unsigned int PA_SC_HIZ_BASE_EXT__BASE_256B_MASK                 = 0x000000ff;
constexpr unsigned int PA_SC_HIZ_BASE__BASE_256B_MASK                     = 0xffffffff;
constexpr unsigned int PA_SC_HIZ_INFO__DST_OUTSIDE_ZERO_TO_ONE_MASK       = 0x02000000;
constexpr unsigned int PA_SC_HIZ_INFO__FORMAT_MASK                        = 0x00000002;
constexpr unsigned int PA_SC_HIZ_INFO__SURFACE_ENABLE_MASK                = 0x00000001;
constexpr unsigned int PA_SC_HIZ_INFO__SW_MODE_MASK                       = 0x0000001c;
constexpr unsigned int PA_SC_HIZ_SIZE_XY__X_MAX_MASK                      = 0x00001fff;
constexpr unsigned int PA_SC_HIZ_SIZE_XY__Y_MAX_MASK                      = 0x1fff0000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_CONTEXT_DONE_SYNC_DISABLE_MASK = 0x00000040;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_DB_CONTEXT_DONE_SYNC_DISABLE_MASK = 0x00000080;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_EOP_SYNC_DISABLE_MASK  = 0x00040000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_EVICT_POINT_MASK       = 0xfc000000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_FLUSH_EVENT_MASK_DISABLE_MASK = 0x00001f00;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_FLUSH_NO_INV_DISABLE_MASK = 0x00004000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_MAX_TAGS_MASK          = 0x03f80000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_NONSTALLING_FLUSH_DISABLE_MASK = 0x00008000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_OUTSTANDING_CONTEXT_FILTERING_DISABLE_MASK = 0x00000020;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_PARTIAL_FLUSH_DISABLE_MASK = 0x00010000;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_PREFETCH_DISABLE_MASK  = 0x00002000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_COUNT__COUNT_MASK           = 0x0000ffff;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_H__X_COORD_MASK             = 0x0000ffff;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE__COUNT_MASK      = 0x0000ffff;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_V__Y_COORD_MASK             = 0x0000ffff;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_BCI_IF_FIFO_SIZE_MASK       = 0x00fc0000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_QUAD_IF_FIFO_SIZE_MASK   = 0x00000fc0;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_TILE_IF_FIFO_SIZE_MASK   = 0x0000003f;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_SPI_IF_FIFO_SIZE_MASK       = 0x0003f000;
constexpr unsigned int PA_SC_LINE_CNTL__DX10_DIAMOND_TEST_ENA_MASK        = 0x00001000;
constexpr unsigned int PA_SC_LINE_CNTL__EXPAND_LINE_WIDTH_MASK            = 0x00000200;
constexpr unsigned int PA_SC_LINE_CNTL__EXTRA_DX_DY_PRECISION_MASK        = 0x00002000;
constexpr unsigned int PA_SC_LINE_CNTL__LAST_PIXEL_MASK                   = 0x00000400;
constexpr unsigned int PA_SC_LINE_CNTL__PERPENDICULAR_ENDCAP_ENA_MASK     = 0x00000800;
constexpr unsigned int PA_SC_LINE_STIPPLE_RESET__AUTO_RESET_CNTL_MASK     = 0x00000003;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_COUNT_MASK       = 0x0000ff00;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_PTR_MASK         = 0x0000000f;
constexpr unsigned int PA_SC_LINE_STIPPLE__LINE_PATTERN_MASK              = 0x0000ffff;
constexpr unsigned int PA_SC_LINE_STIPPLE__PATTERN_BIT_ORDER_MASK         = 0x10000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__REPEAT_COUNT_MASK              = 0x00ff0000;
constexpr unsigned int PA_SC_MODE_CNTL_0__ALTERNATE_RBS_PER_TILE_MASK     = 0x00000020;
constexpr unsigned int PA_SC_MODE_CNTL_0__COARSE_TILE_STARTS_ON_EVEN_RB_MASK = 0x00000040;
constexpr unsigned int PA_SC_MODE_CNTL_0__IMPLICIT_VPORT_SCISSOR_ENABLE_MASK = 0x00000080;
constexpr unsigned int PA_SC_MODE_CNTL_0__LINE_STIPPLE_ENABLE_MASK        = 0x00000004;
constexpr unsigned int PA_SC_MODE_CNTL_0__MSAA_ENABLE_MASK                = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_0__SEND_UNLIT_STILES_TO_PKR_MASK   = 0x00000008;
constexpr unsigned int PA_SC_MODE_CNTL_0__VPORT_SCISSOR_ENABLE_MASK       = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_1__DISABLE_4X_TILE_PICKING_MASK    = 0x80000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_CNTDWN_ENABLE_MASK    = 0x02000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_REZ_ENABLE_MASK       = 0x04000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_ENABLE_MASK     = 0x00080000;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_MASK            = 0x00f00000;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_DETAIL_MASK_MASK  = 0x00008000;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_HI_Z_MASK         = 0x00004000;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_PRIM_DISCARD_ENABLE_MASK = 0x01000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_SUPERTILE_ENABLE_MASK = 0x00040000;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE_MASK = 0x00020000;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_PRIMITIVE_ENABLE_MASK = 0x08000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_WATER_MARK_MASK    = 0x70000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__PS_ITER_SAMPLE_MASK             = 0x00010000;
constexpr unsigned int PA_SC_MODE_CNTL_1__SUPERTILE_WALK_ORDER_ENABLE_MASK = 0x00000080;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_DISABLE_MASK         = 0x00000200;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_NO_SCISSOR_MASK      = 0x00000400;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_WALK_ORDER_ENABLE_MASK     = 0x00000100;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGN8_PRIM_FITS_ST_MASK   = 0x00000004;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGNMENT_MASK             = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_ENABLE_MASK          = 0x00000008;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_SIZE_MASK            = 0x00000070;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_SIZE_MASK                  = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_EXTENT_MASK            = 0x00000800;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_OFFSET_MASK            = 0x00001000;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_RECT_EXTENT_MASK            = 0x00002000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_FPOG_AND_DEALLOC_CONFLICT_MASK = 0x00001000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_MAX_ATTRIBUTES_MASK   = 0x00004000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_MAX_DEALLOC_MASK      = 0x00002000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_ATTRIBUTES_IN_WAVE_MASK   = 0xff000000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_DEALLOCS_IN_WAVE_MASK     = 0x000007ff;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_FPOVS_IN_WAVE_MASK        = 0x00ff0000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_COUNT__COUNT_MASK            = 0x0000ffff;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_H__X_COORD_MASK              = 0x0000ffff;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_OCCURRENCE__COUNT_MASK       = 0x0000ffff;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_V__Y_COORD_MASK              = 0x0000ffff;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DEBUG_CONFLICT_QUAD_MASK = 0x0f000000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_OREO_CONFLICT_QUAD_MASK = 0x80000000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_SC_DB_WAVE_IF_FGCG_EN_MASK = 0x00010000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_SC_SPI_WAVE_IF_FGCG_EN_MASK = 0x00800000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__SC_DB_WAVE_IF_FIFO_SIZE_MASK = 0x0000fc00;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__SC_SPI_WAVE_IF_FIFO_SIZE_MASK = 0x007e0000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__WAVES_IN_FLIGHT_LIMIT_MASK = 0x000001ff;
constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__OVERRIDE_MASK             = 0x00000001;
constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__PIPE_ID_MASK              = 0x00000002;
constexpr unsigned int PA_SC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER4_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER5_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER6_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SC_PERFCOUNTER7_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SC_PKR_WAVE_TABLE_CNTL__SIZE_MASK               = 0x0000003f;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_MAP_MASK            = 0x00000003;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL_MASK           = 0x0000000c;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL_MASK           = 0x00000030;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_MAP_MASK                  = 0x00000300;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL2_MASK                = 0x0000c000;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL_MASK                 = 0x00000c00;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_YSEL_MASK                 = 0x00003000;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR0_MASK              = 0x00000003;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR1_MASK              = 0x0000000c;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL2_MASK                 = 0x00000030;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL_MASK                  = 0x00000040;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_YSEL_MASK                  = 0x00000080;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_MAP_MASK                   = 0x00030000;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_XSEL_MASK                  = 0x000c0000;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_YSEL_MASK                  = 0x00300000;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_MAP_MASK                   = 0x03000000;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL_MASK                  = 0x0c000000;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL_MASK                  = 0x30000000;
constexpr unsigned int PA_SC_SAMPLE_PROPERTIES__MAX_SAMPLE_DIST_MASK      = 0x0000000f;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_X_MASK                 = 0x0000ffff;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_Y_MASK                 = 0xffff0000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_X_MASK                 = 0x0000ffff;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_Y_MASK                 = 0xffff0000;
constexpr unsigned int PA_SC_SHADER_CONTROL__DISABLE_OREO_CONFLICT_QUAD_MASK = 0x00000080;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_COLLISION_WAVEID_MASK   = 0x00000004;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_INTRAWAVE_COLLISION_MASK = 0x00000008;
constexpr unsigned int PA_SC_SHADER_CONTROL__PS_ITER_SAMPLE_MASK          = 0x00000100;
constexpr unsigned int PA_SC_SHADER_CONTROL__REALIGN_DQUADS_AFTER_N_WAVES_MASK = 0x00000003;
constexpr unsigned int PA_SC_SHADER_CONTROL__WAVE_BREAK_REGION_SIZE_MASK  = 0x00000060;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__FORCE_TILE_STEERING_OVERRIDE_USE_MASK = 0x80000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__ONE_RB_MODE_ENABLE_MASK = 0x00000001;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__RB_SELECT_MASK = 0x00000060;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SA_SELECT_MASK = 0x00000700;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SE_SELECT_MASK = 0x00000006;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__ENABLE_MASK          = 0x00000001;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_PACKER_PER_SC_MASK = 0x00300000;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SC_MASK   = 0x00030000;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SC_MASK          = 0x00003000;
constexpr unsigned int PA_SC_TRAP_SCREEN_COUNT__COUNT_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_H__X_COORD_MASK                  = 0x0000ffff;
constexpr unsigned int PA_SC_TRAP_SCREEN_OCCURRENCE__COUNT_MASK           = 0x0000ffff;
constexpr unsigned int PA_SC_TRAP_SCREEN_V__Y_COORD_MASK                  = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_0_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_0_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_0_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_0_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_1_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_1_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_1_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_1_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_2_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_2_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_2_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_2_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_3_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_3_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_3_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_3_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_4_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_4_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_4_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_4_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_5_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_5_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_5_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_5_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_6_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_6_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_6_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_6_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_7_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_7_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_7_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_7_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_8_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_8_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_8_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_8_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_9_BR__BR_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_9_BR__BR_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_9_TL__TL_X_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_9_TL__TL_Y_MASK                        = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_10_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_10_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_10_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_10_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_11_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_11_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_11_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_11_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_12_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_12_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_12_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_12_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_13_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_13_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_13_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_13_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_14_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_14_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_14_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_14_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_15_BR__BR_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_15_BR__BR_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_15_TL__TL_X_MASK                       = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_15_TL__TL_Y_MASK                       = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_X_MASK                = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_Y_MASK                = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_X_MASK               = 0x0000ffff;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_Y_MASK               = 0xffff0000;
constexpr unsigned int PA_SC_VPORT_ZMAX_0__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_1__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_2__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_3__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_4__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_5__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_6__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_7__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_8__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_9__VPORT_ZMAX_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_10__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_11__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_12__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_13__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_14__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMAX_15__VPORT_ZMAX_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_0__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_1__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_2__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_3__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_4__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_5__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_6__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_7__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_8__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_9__VPORT_ZMIN_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_10__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_11__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_12__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_13__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_14__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VPORT_ZMIN_15__VPORT_ZMIN_MASK               = 0xffffffff;
constexpr unsigned int PA_SC_VRS_INFO__FEEDBACK_SW_MODE_MASK              = 0x00000038;
constexpr unsigned int PA_SC_VRS_INFO__RATE_SW_MODE_MASK                  = 0x00000007;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__RATE_HINT_WRITE_BACK_ENABLE_MASK = 0x00002000;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_FEEDBACK_RATE_OVERRIDE_MASK = 0x00004000;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_OVERRIDE_RATE_COMBINER_MODE_MASK = 0x00000007;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_RATE_MASK             = 0x000000f0;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_SURFACE_ENABLE_MASK   = 0x00001000;
constexpr unsigned int PA_SC_VRS_RATE_BASE_EXT__BASE_256B_MASK            = 0x000000ff;
constexpr unsigned int PA_SC_VRS_RATE_BASE_EXT__TB_SYNC_SIM_ID_MASK       = 0xf0000000;
constexpr unsigned int PA_SC_VRS_RATE_BASE__BASE_256B_MASK                = 0xffffffff;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_BASE_EXT__BASE_256B_MASK   = 0x000000ff;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_BASE__BASE_256B_MASK       = 0xffffffff;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_SIZE_XY__X_MAX_MASK        = 0x00001fff;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_SIZE_XY__Y_MAX_MASK        = 0x1fff0000;
constexpr unsigned int PA_SC_VRS_RATE_SIZE_XY__X_MAX_MASK                 = 0x00001fff;
constexpr unsigned int PA_SC_VRS_RATE_SIZE_XY__Y_MAX_MASK                 = 0x1fff0000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_CMASK_RATE_HINT_FORCE_ZERO_OVERRIDE_MASK = 0x00080000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_PS_ITER_RATE_COMBINER_PASSTHRU_OVERRIDE_MASK = 0x00008000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_SSAA_DETAIL_TO_EXPOSED_RATE_CLAMPING_MASK = 0x00100000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_SSAA_VRS_RATE_NORMALIZATION_MASK = 0x00001000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTERFACE_RATE_8XAA_MASK = 0x00000100;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTERFACE_RATE_16XAA_MASK = 0x00000008;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTRINSIC_RATE_GT_4XAA_MASK = 0x00000200;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_MASK = 0x00000001;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_MASK_OPS_ENABLE_MASK = 0x00000004;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_POPS_MASK = 0x00000080;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_POST_DEPTH_IMPORT_MASK = 0x00000040;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_PRE_SHADER_DEPTH_COVERAGE_ENABLED_MASK = 0x00000020;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_SHADER_KILL_ENABLE_MASK = 0x00000002;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_Z_OR_STENCIL_MASK = 0x00000010;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__USE_ONLY_VRS_RATE_FINE_CFG_MASK = 0x00000400;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_0_MASK     = 0x00200000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_1_MASK     = 0x00400000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_2_MASK     = 0x00800000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_3_MASK     = 0x01000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_4_MASK     = 0x02000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_5_MASK     = 0x04000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_6_MASK     = 0x08000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_7_MASK     = 0x10000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_8_MASK     = 0x20000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_9_MASK     = 0x40000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_10_MASK    = 0x80000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_CONTEXT_DONE_SYNC_DISABLE_MASK = 0x00000040;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_EOP_SYNC_DISABLE_MASK  = 0x00040000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_EVICT_POINT_MASK       = 0xfc000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_FLUSH_EVENT_MASK_DISABLE_MASK = 0x00001f00;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_FLUSH_NO_INV_DISABLE_MASK = 0x00004000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_MAX_TAGS_MASK          = 0x03f80000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_NONSTALLING_FLUSH_DISABLE_MASK = 0x00008000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_PARTIAL_FLUSH_DISABLE_MASK = 0x00010000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_PREFETCH_DISABLE_MASK  = 0x00002000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRS_FEEDBACK_RATE_OVERRIDE_MASK = 0x00000080;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_X_OFFSET_MASK          = 0x0000ffff;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_Y_OFFSET_MASK          = 0xffff0000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_X_MASK                 = 0x0000ffff;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_Y_MASK                 = 0xffff0000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_X_MASK                 = 0x0000ffff;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_Y_MASK                 = 0xffff0000;
constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET_MASK            = 0xffffffff;
constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE_MASK                 = 0x000000e0;
constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET_MASK               = 0x00000f00;
constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE_MASK                   = 0x0000001e;
constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE_MASK                    = 0x00070000;
constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET_MASK                  = 0x00780000;
constexpr unsigned int PA_SU_CNTL_STATUS__SU_BUSY_MASK                    = 0x80000000;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_X_MASK = 0x00000fff;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_Y_MASK = 0x0fff0000;
constexpr unsigned int PA_SU_LINE_CNTL__WIDTH_MASK                        = 0x0000ffff;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__EXPAND_FULL_LENGTH_MASK   = 0x00000004;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__FRACTIONAL_ACCUM_MASK     = 0x00000008;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__LINE_STIPPLE_RESET_MASK   = 0x00000003;
constexpr unsigned int PA_SU_LINE_STIPPLE_SCALE__LINE_STIPPLE_SCALE_MASK  = 0xffffffff;
constexpr unsigned int PA_SU_LINE_STIPPLE_VALUE__LINE_STIPPLE_VALUE_MASK  = 0x00ffffff;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_LINES_MASK = 0x00000002;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_POINTS_MASK = 0x00000004;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_RECTANGLES_MASK = 0x00000008;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_TRIANGLES_MASK = 0x00000001;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__USE_PROVOKING_ZW_MASK = 0x00000010;
constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int PA_SU_POINT_MINMAX__MAX_SIZE_MASK                  = 0xffff0000;
constexpr unsigned int PA_SU_POINT_MINMAX__MIN_SIZE_MASK                  = 0x0000ffff;
constexpr unsigned int PA_SU_POINT_SIZE__HEIGHT_MASK                      = 0x0000ffff;
constexpr unsigned int PA_SU_POINT_SIZE__WIDTH_MASK                       = 0xffff0000;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_OFFSET__OFFSET_MASK         = 0xffffffff;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_SCALE__SCALE_MASK           = 0xffffffff;
constexpr unsigned int PA_SU_POLY_OFFSET_CLAMP__CLAMP_MASK                = 0xffffffff;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_DB_IS_FLOAT_FMT_MASK = 0x00000100;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_NEG_NUM_DB_BITS_MASK = 0x000000ff;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_OFFSET__OFFSET_MASK        = 0xffffffff;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_SCALE__SCALE_MASK          = 0xffffffff;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_EXPAND_ENA_MASK       = 0x00000020;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE_MASK   = 0x00000002;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_EXPAND_ENA_MASK      = 0x00000040;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE_MASK  = 0x00000004;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__PRIM_EXPAND_CONSTANT_MASK  = 0x0000ff00;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_EXPAND_ENA_MASK  = 0x00000080;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE_MASK = 0x00000008;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_EXPAND_ENA_MASK   = 0x00000010;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE_MASK = 0x00000001;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__XMAX_RIGHT_EXCLUSION_MASK  = 0x40000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__YMAX_BOTTOM_EXCLUSION_MASK = 0x80000000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_BACK_MASK                 = 0x00000002;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_FRONT_MASK                = 0x00000001;
constexpr unsigned int PA_SU_SC_MODE_CNTL__FACE_MASK                      = 0x00000004;
constexpr unsigned int PA_SU_SC_MODE_CNTL__MULTI_PRIM_IB_ENA_MASK         = 0x00200000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__NEW_QUAD_DECOMPOSITION_MASK    = 0x00800000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PERSP_CORR_DIS_MASK            = 0x00100000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_BACK_PTYPE_MASK       = 0x00000700;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_FRONT_PTYPE_MASK      = 0x000000e0;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_MODE_MASK                 = 0x00000018;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_BACK_ENABLE_MASK   = 0x00001000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_FRONT_ENABLE_MASK  = 0x00000800;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_PARA_ENABLE_MASK   = 0x00002000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PROVOKING_VTX_LAST_MASK        = 0x00080000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF_MASK = 0x00400000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__VTX_WINDOW_OFFSET_ENABLE_MASK  = 0x00010000;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE_MASK = 0x00000004;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE_MASK = 0x00000008;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE_MASK = 0x00000010;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SC_1XMSAA_COMPATIBLE_DISABLE_MASK = 0x00000040;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SMALL_PRIM_FILTER_ENABLE_MASK = 0x00000001;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE_MASK = 0x00000002;
constexpr unsigned int PA_SU_VTX_CNTL__PIX_CENTER_MASK                    = 0x00000001;
constexpr unsigned int PA_SU_VTX_CNTL__QUANT_MODE_MASK                    = 0x00000038;
constexpr unsigned int PA_SU_VTX_CNTL__ROUND_MODE_MASK                    = 0x00000006;
constexpr unsigned int PC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int PerfMonCtl1__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl1__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl1__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl1__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl1__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl1__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl1__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl1__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl2__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl2__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl2__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl2__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl2__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl2__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl2__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl2__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl3__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl3__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl3__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl3__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl3__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl3__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl3__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl3__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl4__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl4__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl4__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl4__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl4__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl4__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl4__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl4__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl5__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl5__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl5__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl5__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl5__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl5__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl5__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl5__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl6__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl6__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl6__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl6__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl6__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl6__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl6__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl6__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl7__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl7__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl7__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl7__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl7__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl7__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl7__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl7__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl8__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl8__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl8__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl8__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl8__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl8__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl8__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl8__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl9__BankSel_MASK                          = 0x00ff0000;
constexpr unsigned int PerfMonCtl9__Enable_MASK                           = 0x80000000;
constexpr unsigned int PerfMonCtl9__EventSelect_MASK                      = 0x000000ff;
constexpr unsigned int PerfMonCtl9__PriorityMask_MASK                     = 0x00003c00;
constexpr unsigned int PerfMonCtl9__RdWrMask_MASK                         = 0x00000300;
constexpr unsigned int PerfMonCtl9__ReqSizeMask_MASK                      = 0x0000c000;
constexpr unsigned int PerfMonCtl9__SubChanMask_MASK                      = 0x60000000;
constexpr unsigned int PerfMonCtl9__VCSel_MASK                            = 0x1f000000;
constexpr unsigned int PerfMonCtl10__BankSel_MASK                         = 0x00ff0000;
constexpr unsigned int PerfMonCtl10__Enable_MASK                          = 0x80000000;
constexpr unsigned int PerfMonCtl10__EventSelect_MASK                     = 0x000000ff;
constexpr unsigned int PerfMonCtl10__PriorityMask_MASK                    = 0x00003c00;
constexpr unsigned int PerfMonCtl10__RdWrMask_MASK                        = 0x00000300;
constexpr unsigned int PerfMonCtl10__ReqSizeMask_MASK                     = 0x0000c000;
constexpr unsigned int PerfMonCtl10__SubChanMask_MASK                     = 0x60000000;
constexpr unsigned int PerfMonCtl10__VCSel_MASK                           = 0x1f000000;
constexpr unsigned int PerfMonCtl11__BankSel_MASK                         = 0x00ff0000;
constexpr unsigned int PerfMonCtl11__Enable_MASK                          = 0x80000000;
constexpr unsigned int PerfMonCtl11__EventSelect_MASK                     = 0x000000ff;
constexpr unsigned int PerfMonCtl11__PriorityMask_MASK                    = 0x00003c00;
constexpr unsigned int PerfMonCtl11__RdWrMask_MASK                        = 0x00000300;
constexpr unsigned int PerfMonCtl11__ReqSizeMask_MASK                     = 0x0000c000;
constexpr unsigned int PerfMonCtl11__SubChanMask_MASK                     = 0x60000000;
constexpr unsigned int PerfMonCtl11__VCSel_MASK                           = 0x1f000000;
constexpr unsigned int PerfMonCtl12__BankSel_MASK                         = 0x00ff0000;
constexpr unsigned int PerfMonCtl12__Enable_MASK                          = 0x80000000;
constexpr unsigned int PerfMonCtl12__EventSelect_MASK                     = 0x000000ff;
constexpr unsigned int PerfMonCtl12__PriorityMask_MASK                    = 0x00003c00;
constexpr unsigned int PerfMonCtl12__RdWrMask_MASK                        = 0x00000300;
constexpr unsigned int PerfMonCtl12__ReqSizeMask_MASK                     = 0x0000c000;
constexpr unsigned int PerfMonCtl12__SubChanMask_MASK                     = 0x60000000;
constexpr unsigned int PerfMonCtl12__VCSel_MASK                           = 0x1f000000;
constexpr unsigned int PerfMonCtlClk__ClkGate_MASK                        = 0x00400000;
constexpr unsigned int PerfMonCtlClk__CtrClkEn_MASK                       = 0x80000000;
constexpr unsigned int PerfMonCtlClk__GlblMonEn_MASK                      = 0x02000000;
constexpr unsigned int PerfMonCtlClk__GlblResetMsk_MASK                   = 0x00001fff;
constexpr unsigned int PerfMonCtlClk__GlblReset_MASK                      = 0x01000000;
constexpr unsigned int PerfMonCtlClk__NumCounters_MASK                    = 0x3c000000;
constexpr unsigned int PerfMonCtlClk__SpmEn_MASK                          = 0x00800000;
constexpr unsigned int PerfMonCtr1_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr1_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr1_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr1_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr1_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr2_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr2_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr2_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr2_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr2_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr3_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr3_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr3_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr3_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr3_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr4_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr4_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr4_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr4_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr4_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr5_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr5_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr5_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr5_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr5_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr6_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr6_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr6_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr6_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr6_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr7_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr7_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr7_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr7_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr7_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr8_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr8_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr8_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr8_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr8_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr9_Hi__Data_MASK                          = 0x0000ffff;
constexpr unsigned int PerfMonCtr9_Hi__Overflow_MASK                      = 0x00010000;
constexpr unsigned int PerfMonCtr9_Hi__ThreshCntEn_MASK                   = 0x000c0000;
constexpr unsigned int PerfMonCtr9_Hi__ThreshCnt_MASK                     = 0xfff00000;
constexpr unsigned int PerfMonCtr9_Lo__Data_MASK                          = 0xffffffff;
constexpr unsigned int PerfMonCtr10_Hi__Data_MASK                         = 0x0000ffff;
constexpr unsigned int PerfMonCtr10_Hi__Overflow_MASK                     = 0x00010000;
constexpr unsigned int PerfMonCtr10_Hi__ThreshCntEn_MASK                  = 0x000c0000;
constexpr unsigned int PerfMonCtr10_Hi__ThreshCnt_MASK                    = 0xfff00000;
constexpr unsigned int PerfMonCtr10_Lo__Data_MASK                         = 0xffffffff;
constexpr unsigned int PerfMonCtr11_Hi__Data_MASK                         = 0x0000ffff;
constexpr unsigned int PerfMonCtr11_Hi__Overflow_MASK                     = 0x00010000;
constexpr unsigned int PerfMonCtr11_Hi__ThreshCntEn_MASK                  = 0x000c0000;
constexpr unsigned int PerfMonCtr11_Hi__ThreshCnt_MASK                    = 0xfff00000;
constexpr unsigned int PerfMonCtr11_Lo__Data_MASK                         = 0xffffffff;
constexpr unsigned int PerfMonCtr12_Hi__Data_MASK                         = 0x0000ffff;
constexpr unsigned int PerfMonCtr12_Hi__Overflow_MASK                     = 0x00010000;
constexpr unsigned int PerfMonCtr12_Hi__ThreshCntEn_MASK                  = 0x000c0000;
constexpr unsigned int PerfMonCtr12_Hi__ThreshCnt_MASK                    = 0xfff00000;
constexpr unsigned int PerfMonCtr12_Lo__Data_MASK                         = 0xffffffff;
constexpr unsigned int PerfMonCtrClk_Hi__Data_MASK                        = 0x0000ffff;
constexpr unsigned int PerfMonCtrClk_Hi__Overflow_MASK                    = 0x00010000;
constexpr unsigned int PerfMonCtrClk_Lo__Data_MASK                        = 0xffffffff;
constexpr unsigned int RLC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RLC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RLC_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT_MASK   = 0x000000ff;
constexpr unsigned int RLC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RLC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RLC_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT_MASK   = 0x000000ff;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE_MASK       = 0x00000400;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_STATE_MASK               = 0x00000007;
constexpr unsigned int RLC_PERFMON_CNTL__RESERVED_9_3_MASK                = 0x000003f8;
constexpr unsigned int RLC_PERFMON_CNTL__RESERVED_MASK                    = 0xfffff800;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__global_offset_MASK = 0x000000ff;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__spmwithaccum_global_offset_MASK = 0x00ff0000;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__spmwithaccum_se_offset_MASK = 0x0000ff00;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__ADDR_MASK              = 0x000007ff;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__DATA_MASK              = 0x000000ff;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobePerfmonSampleWires_MASK  = 0x00000400;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmAccum_MASK          = 0x00000004;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmSwaAccum_MASK       = 0x00000100;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetPerfMonitors_MASK   = 0x00000001;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetSpmBlock_MASK       = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartAccumulation_MASK   = 0x00000002;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm_MASK            = 0x000000f0;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSwa_MASK            = 0x00000200;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS__spp_addr_region_MASK = 0x000000ff;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS__swa_addr_region_MASK = 0x0000ff00;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__ADDR_MASK              = 0x0000007f;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_DATA__DATA_MASK              = 0xffffffff;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__DataRamWrCount_MASK = 0x0007ffff;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn_MASK               = 0x00000020;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable_MASK   = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn_MASK                 = 0x00000080;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableAccum_MASK               = 0x00000001;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableSpmWithAccumMode_MASK    = 0x00000002;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableSPPMode_MASK             = 0x00000004;
constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride_MASK      = 0x00000200;
constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_SwaLoadOverride_MASK   = 0x00000400;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_4_MASK                = 0x00000010;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_20_19_MASK            = 0x00180000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_22_21_MASK            = 0x00600000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_24_23_MASK            = 0x01800000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_26_25_MASK            = 0x06000000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_31_27_MASK            = 0xf8000000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride_MASK          = 0x00000800;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_SwaLoadOverride_MASK       = 0x00001000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_LoadOverride_MASK          = 0x00002000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_SwaLoadOverride_MASK       = 0x00004000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE2_LoadOverride_MASK          = 0x00008000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE2_SwaLoadOverride_MASK       = 0x00010000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE3_LoadOverride_MASK          = 0x00020000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE3_SwaLoadOverride_MASK       = 0x00040000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SwaAutoAccumEn_MASK            = 0x00000040;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SwaAutoSpmEn_MASK              = 0x00000100;
constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__SamplesRequested_MASK = 0x000000ff;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumArmed_MASK              = 0x00000800;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumDone_MASK               = 0x00000100;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumOverflow_MASK           = 0x00000400;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllFifosEmpty_MASK           = 0x00004000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllSegsDone_MASK             = 0x00100000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__FinalSequenceInProgress_MASK = 0x00002000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__FSMIsIdle_MASK               = 0x00008000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__MultiSampleAborted_MASK      = 0x00800000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__NumbSamplesCompleted_MASK    = 0x000000ff;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__RearmSppPending_MASK         = 0x00400000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__RearmSwaPending_MASK         = 0x00200000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SequenceInProgress_MASK      = 0x00001000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SpmDone_MASK                 = 0x00000200;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumArmed_MASK           = 0x00080000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumDone_MASK            = 0x00010000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumOverflow_MASK        = 0x00040000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaSpmDone_MASK              = 0x00020000;
constexpr unsigned int RLC_SPM_ACCUM_SWA_DATARAM_ADDR__ADDR_MASK          = 0x0000007f;
constexpr unsigned int RLC_SPM_ACCUM_SWA_DATARAM_DATA__DATA_MASK          = 0xffffffff;
constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__Threshold_MASK            = 0x0000ffff;
constexpr unsigned int RLC_SPM_GFXCLOCK_HIGHCOUNT__GFXCLOCK_HIGHCOUNT_MASK = 0xffffffff;
constexpr unsigned int RLC_SPM_GFXCLOCK_LOWCOUNT__GFXCLOCK_LOWCOUNT_MASK  = 0xffffffff;
constexpr unsigned int RLC_SPM_GLOBAL_BLK_EN_MASK_IND_ADDR__ADDR_MASK     = 0x00000fff;
constexpr unsigned int RLC_SPM_GLOBAL_BLK_EN_MASK_IND_DATA__DATA_MASK     = 0xffffffff;
constexpr unsigned int RLC_SPM_GLOBAL_DELAY_IND_ADDR__ADDR_MASK           = 0x00000fff;
constexpr unsigned int RLC_SPM_GLOBAL_DELAY_IND_DATA__DATA_MASK           = 0x0000003f;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__ADDR_MASK              = 0x000003ff;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__SEL0_MASK              = 0x0000ffff;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__SEL1_MASK              = 0xffff0000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_0__HI_MASK                = 0xffff0000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_0__LO_MASK                = 0x0000ffff;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_1__HI_MASK                = 0xffff0000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_1__LO_MASK                = 0x0000ffff;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_2__HI_MASK                = 0xffff0000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_2__LO_MASK                = 0x0000ffff;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_3__HI_MASK                = 0xffff0000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_3__LO_MASK                = 0x0000ffff;
constexpr unsigned int RLC_SPM_GTS_TRIGGER_VALUE_HI__VALUE_HI_MASK        = 0x00ffffff;
constexpr unsigned int RLC_SPM_GTS_TRIGGER_VALUE_LO__VALUE_LO_MASK        = 0xffffffff;
constexpr unsigned int RLC_SPM_INT_CNTL__RESERVED_MASK                    = 0xfffffffe;
constexpr unsigned int RLC_SPM_INT_CNTL__RLC_SPM_INT_CNTL_MASK            = 0x00000001;
constexpr unsigned int RLC_SPM_INT_INFO_1__INTERRUPT_INFO_1_MASK          = 0xffffffff;
constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_ID_MASK              = 0x00ff0000;
constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_INFO_2_MASK          = 0x0000ffff;
constexpr unsigned int RLC_SPM_INT_INFO_2__RESERVED_MASK                  = 0xff000000;
constexpr unsigned int RLC_SPM_INT_STATUS__RESERVED_MASK                  = 0xfffffffe;
constexpr unsigned int RLC_SPM_INT_STATUS__RLC_SPM_INT_STATUS_MASK        = 0x00000001;
constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_MASK                     = 0xffff0000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_COMP_MASK                 = 0x00001800;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_COMP_OVER_MASK            = 0x00002000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED_MASK                  = 0x00000080;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_NOFILL_MASK               = 0x00008000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR_MASK            = 0x00000040;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_RO_MASK                   = 0x00004000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_SDR_MASK                  = 0x00000030;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_TEMPORAL_MASK             = 0x00000700;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VMID_MASK                 = 0x0000000f;
constexpr unsigned int RLC_SPM_MODE__MODE_MASK                            = 0x00000001;
constexpr unsigned int RLC_SPM_PAUSE__PAUSED_MASK                         = 0x00000002;
constexpr unsigned int RLC_SPM_PAUSE__PAUSE_MASK                          = 0x00000001;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_RING_MODE_MASK       = 0x00003000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_MASK = 0xffff0000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_START_MODE_MASK = 0x00004000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_TYPE_MASK = 0x00008000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED_MASK                = 0x00000fff;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RESERVED_MASK        = 0xffff0000;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RING_BASE_HI_MASK    = 0x0000ffff;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_LO__RING_BASE_LO_MASK    = 0xffffffff;
constexpr unsigned int RLC_SPM_PERFMON_RING_SIZE__RING_BASE_SIZE_MASK     = 0xffffffff;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__GLOBAL_NUM_SEGMENT_MASK = 0x00ff0000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE_NUM_SEGMENT_MASK  = 0xff000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__TOTAL_NUM_SEGMENT_MASK = 0x0000ffff;
constexpr unsigned int RLC_SPM_RING_RDPTR__PERFMON_RING_RDPTR_MASK        = 0xffffffff;
constexpr unsigned int RLC_SPM_RING_WRPTR__PERFMON_RING_WRPTR_MASK        = 0xffffffe0;
constexpr unsigned int RLC_SPM_RING_WRPTR__RESERVED_MASK                  = 0x0000001f;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE0_ACK_MASK                 = 0x00000001;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE1_ACK_MASK                 = 0x00000002;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE2_ACK_MASK                 = 0x00000004;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE3_ACK_MASK                 = 0x00000008;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE4_ACK_MASK                 = 0x00000010;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE5_ACK_MASK                 = 0x00000020;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE6_ACK_MASK                 = 0x00000040;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE7_ACK_MASK                 = 0x00000080;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SPM_ACK_MASK                 = 0x00000100;
constexpr unsigned int RLC_SPM_RSPM_CMD__CMD_MASK                         = 0x0000000f;
constexpr unsigned int RLC_SPM_RSPM_REQ_DATA__DATA_MASK                   = 0x0000000f;
constexpr unsigned int RLC_SPM_RSPM_REQ_OP__OP_MASK                       = 0x0000000f;
constexpr unsigned int RLC_SPM_RSPM_RET_DATA__DATA_MASK                   = 0xffffffff;
constexpr unsigned int RLC_SPM_RSPM_RET_OP__OP_MASK                       = 0x0000000f;
constexpr unsigned int RLC_SPM_RSPM_RET_OP__VALID_MASK                    = 0x00000100;
constexpr unsigned int RLC_SPM_SAMPLE_CNT__COUNT_MASK                     = 0xffffffff;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD_MASK = 0x000000ff;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__RESERVED_MASK           = 0xffffff00;
constexpr unsigned int RLC_SPM_SE_BLK_EN_MASK_IND_ADDR__ADDR_MASK         = 0x00000fff;
constexpr unsigned int RLC_SPM_SE_BLK_EN_MASK_IND_DATA__DATA_MASK         = 0xffffffff;
constexpr unsigned int RLC_SPM_SE_DELAY_IND_ADDR__ADDR_MASK               = 0x00000fff;
constexpr unsigned int RLC_SPM_SE_DELAY_IND_DATA__DATA_MASK               = 0x0000003f;
constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__ADDR_MASK                  = 0x000003ff;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__SEL0_MASK                  = 0x0000ffff;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__SEL1_MASK                  = 0xffff0000;
constexpr unsigned int RLC_SPM_SE_RSPM_REQ_DATA__DATA_MASK                = 0x0000000f;
constexpr unsigned int RLC_SPM_SE_RSPM_REQ_OP__OP_MASK                    = 0x0000000f;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_DATA__DATA_MASK                = 0xffffffff;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_OP__OP_MASK                    = 0x0000000f;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_OP__VALID_MASK                 = 0x00000100;
constexpr unsigned int RLC_SPM_SE_USER_DATA_0__HI_MASK                    = 0xffff0000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_0__LO_MASK                    = 0x0000ffff;
constexpr unsigned int RLC_SPM_SE_USER_DATA_1__HI_MASK                    = 0xffff0000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_1__LO_MASK                    = 0x0000ffff;
constexpr unsigned int RLC_SPM_SE_USER_DATA_2__HI_MASK                    = 0xffff0000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_2__LO_MASK                    = 0x0000ffff;
constexpr unsigned int RLC_SPM_SE_USER_DATA_3__HI_MASK                    = 0xffff0000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_3__LO_MASK                    = 0x0000ffff;
constexpr unsigned int RLC_SPM_SPARE__SPARE_MASK                          = 0xffffffff;
constexpr unsigned int RLC_SPM_STATUS__ACCUM_BUSY_MASK                    = 0x00008000;
constexpr unsigned int RLC_SPM_STATUS__CTL_BUSY_MASK                      = 0x00000001;
constexpr unsigned int RLC_SPM_STATUS__CTL_REQ_STATE_MASK                 = 0x03000000;
constexpr unsigned int RLC_SPM_STATUS__CTL_RET_STATE_MASK                 = 0x04000000;
constexpr unsigned int RLC_SPM_STATUS__FSM_MASTER_STATE_MASK              = 0x000f0000;
constexpr unsigned int RLC_SPM_STATUS__FSM_MEMORY_STATE_MASK              = 0x00f00000;
constexpr unsigned int RLC_SPM_STATUS__RSPM_REG_BUSY_MASK                 = 0x00000002;
constexpr unsigned int RLC_SPM_STATUS__SE_RSPM_IO_BUSY_MASK               = 0x00000ff0;
constexpr unsigned int RLC_SPM_STATUS__SPM_RSPM_BUSY_MASK                 = 0x00000004;
constexpr unsigned int RLC_SPM_STATUS__SPM_RSPM_IO_BUSY_MASK              = 0x00000008;
constexpr unsigned int RLC_SPM_THREAD_TRACE_CTRL__THREAD_TRACE_INT_EN_MASK = 0x00000001;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__BYPASS_MASK                    = 0x02000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__DROP_MODE_MASK                 = 0x01000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SNOOP_MASK               = 0x10000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK           = 0x08000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__INVALIDATE_MASK                = 0x04000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED_23_20_MASK            = 0x00f00000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED_MASK                  = 0xe0000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK      = 0x000fffff;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorAddr_MSB_MASK = 0x000003c0;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorVmid_MASK = 0x0000003c;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqError_MASK    = 0x00000003;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_2__Translated_ReqErrorAddr_LSB_MASK = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int RMI_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int RMI_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int RMI_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__EVENT_BASED_PERF_EN_SEL_MASK = 0x0000000c;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_CNTR_SPM_SEL_MASK      = 0x04000000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_BURST_LENGTH_THRESHOLD_MASK = 0x01f80000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_CID_MASK       = 0x00003c00;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_VMID_MASK      = 0x0007c000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK0_MASK = 0x000000c0;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1_MASK = 0x00000300;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_SOFT_RESET_MASK        = 0x02000000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TC_PERF_EN_SEL_MASK         = 0x00000030;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TRANS_BASED_PERF_EN_SEL_MASK = 0x00000003;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__CLEAR_MASK                   = 0x20000000;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__ENABLE_MASK                  = 0x10000000;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_MODE_MASK               = 0x0f000000;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_END_MASK            = 0x0000ff00;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_MASK                = 0x000000ff;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__CLEAR_MASK                   = 0x20000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__ENABLE_MASK                  = 0x10000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_MODE_MASK               = 0x0f000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_END_MASK            = 0x0000ff00;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_MASK                = 0x000000ff;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__CLEAR_MASK                   = 0x20000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__ENABLE_MASK                  = 0x10000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_MODE_MASK               = 0x0f000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_END_MASK            = 0x0000ff00;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_MASK                = 0x000000ff;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__CLEAR_MASK                   = 0x20000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__ENABLE_MASK                  = 0x10000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_MODE_MASK               = 0x0f000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_END_MASK            = 0x0000ff00;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_MASK                = 0x000000ff;
constexpr unsigned int RPB_PERFCOUNTER_HI__COMPARE_VALUE_MASK             = 0xffff0000;
constexpr unsigned int RPB_PERFCOUNTER_HI__COUNTER_HI_MASK                = 0x0000ffff;
constexpr unsigned int RPB_PERFCOUNTER_LO__COUNTER_LO_MASK                = 0xffffffff;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK          = 0x02000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK         = 0x01000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000f;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK      = 0x0000ff00;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK       = 0x00ff0000;
constexpr unsigned int RPB_PERF_COUNTER_CNTL__PERF_COUNTER_SELECT_MASK    = 0x00000003;
constexpr unsigned int SCRATCH_REG0__SCRATCH_REG0_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG1__SCRATCH_REG1_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG2__SCRATCH_REG2_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG3__SCRATCH_REG3_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG4__SCRATCH_REG4_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG5__SCRATCH_REG5_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG6__SCRATCH_REG6_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REG7__SCRATCH_REG7_MASK                    = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER0__ScratchPad0_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER1__ScratchPad1_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER2__ScratchPad2_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER3__ScratchPad3_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER4__ScratchPad4_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER5__ScratchPad5_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER6__ScratchPad6_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REGISTER7__ScratchPad7_MASK                = 0xffffffff;
constexpr unsigned int SCRATCH_REG_ATOMIC__ID_MASK                        = 0x07000000;
constexpr unsigned int SCRATCH_REG_ATOMIC__IMMED_MASK                     = 0x00ffffff;
constexpr unsigned int SCRATCH_REG_ATOMIC__OP_MASK                        = 0x70000000;
constexpr unsigned int SCRATCH_REG_ATOMIC__reserved27_MASK                = 0x08000000;
constexpr unsigned int SCRATCH_REG_ATOMIC__reserved31_MASK                = 0x80000000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__ID_MASK                = 0x07000000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__IMMED_COMPARE_MASK     = 0x00000fff;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__IMMED_REPLACE_MASK     = 0x00fff000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__OP_MASK                = 0x70000000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__reserved27_MASK        = 0x08000000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__reserved31_MASK        = 0x80000000;
constexpr unsigned int SC_MEM_SCOPE__HIS_SCOPE_MASK                       = 0x000000c0;
constexpr unsigned int SC_MEM_SCOPE__HIZ_SCOPE_MASK                       = 0x00000030;
constexpr unsigned int SC_MEM_SCOPE__VRS_FEEDBACK_SCOPE_MASK              = 0x0000000c;
constexpr unsigned int SC_MEM_SCOPE__VRS_RATE_SCOPE_MASK                  = 0x00000003;
constexpr unsigned int SC_MEM_SPEC_READ__HIS_SPECULATIVE_READ_MASK        = 0x00000030;
constexpr unsigned int SC_MEM_SPEC_READ__HIZ_SPECULATIVE_READ_MASK        = 0x0000000c;
constexpr unsigned int SC_MEM_SPEC_READ__VRS_SPECULATIVE_READ_MASK        = 0x00000003;
constexpr unsigned int SC_MEM_TEMPORAL__HIS_TEMPORAL_READ_MASK            = 0x00007000;
constexpr unsigned int SC_MEM_TEMPORAL__HIS_TEMPORAL_WRITE_MASK           = 0x00038000;
constexpr unsigned int SC_MEM_TEMPORAL__HIZ_TEMPORAL_READ_MASK            = 0x000001c0;
constexpr unsigned int SC_MEM_TEMPORAL__HIZ_TEMPORAL_WRITE_MASK           = 0x00000e00;
constexpr unsigned int SC_MEM_TEMPORAL__VRS_TEMPORAL_READ_MASK            = 0x00000007;
constexpr unsigned int SC_MEM_TEMPORAL__VRS_TEMPORAL_WRITE_MASK           = 0x00000038;
constexpr unsigned int SDMA0_PERFCNT_MISC_CNTL__CMD_OP_MASK               = 0x0000ffff;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__CLEAR_MASK         = 0x20000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__ENABLE_MASK        = 0x10000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_MODE_MASK     = 0x0f000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_END_MASK  = 0x0000ff00;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_MASK      = 0x000000ff;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__CLEAR_MASK         = 0x20000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__ENABLE_MASK        = 0x10000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_MODE_MASK     = 0x0f000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_END_MASK  = 0x0000ff00;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_MASK      = 0x000000ff;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_HI__COMPARE_VALUE_MASK   = 0xffff0000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_HI__COUNTER_HI_MASK      = 0x0000ffff;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_LO__COUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000f;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000;
constexpr unsigned int SDMA0_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int SDMA0_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int SDMA0_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int SDMA0_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int SDMA1_PERFCNT_MISC_CNTL__CMD_OP_MASK               = 0x0000ffff;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__CLEAR_MASK         = 0x20000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__ENABLE_MASK        = 0x10000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_MODE_MASK     = 0x0f000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_END_MASK  = 0x0000ff00;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_MASK      = 0x000000ff;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__CLEAR_MASK         = 0x20000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__ENABLE_MASK        = 0x10000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_MODE_MASK     = 0x0f000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_END_MASK  = 0x0000ff00;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_MASK      = 0x000000ff;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_HI__COMPARE_VALUE_MASK   = 0xffff0000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_HI__COUNTER_HI_MASK      = 0x0000ffff;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_LO__COUNTER_LO_MASK      = 0xffffffff;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000f;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000;
constexpr unsigned int SDMA1_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int SDMA1_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int SDMA1_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int SDMA1_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK        = 0xf0000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK        = 0x0f000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK         = 0x000003ff;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK         = 0x000ffc00;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__CNTR_MODE_MASK          = 0x00f00000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE1_MASK         = 0x0f000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE_MASK          = 0xf0000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL1_MASK          = 0x000ffc00;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_COL_WT_MASK                = 0x0000000f;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_GDS_WT_MASK                = 0x00000f00;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_POS_WT_MASK                = 0x000000f0;
constexpr unsigned int SPI_ARB_CYCLES_0__TS0_DURATION_MASK                = 0x0000ffff;
constexpr unsigned int SPI_ARB_CYCLES_0__TS1_DURATION_MASK                = 0xffff0000;
constexpr unsigned int SPI_ARB_CYCLES_1__TS2_DURATION_MASK                = 0x0000ffff;
constexpr unsigned int SPI_ARB_CYCLES_1__TS3_DURATION_MASK                = 0xffff0000;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS0_MASK              = 0x00000007;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS1_MASK              = 0x00000038;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS2_MASK              = 0x000001c0;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS3_MASK              = 0x00000e00;
constexpr unsigned int SPI_ARB_PRIORITY__TS0_DUR_MULT_MASK                = 0x00003000;
constexpr unsigned int SPI_ARB_PRIORITY__TS1_DUR_MULT_MASK                = 0x0000c000;
constexpr unsigned int SPI_ARB_PRIORITY__TS2_DUR_MULT_MASK                = 0x00030000;
constexpr unsigned int SPI_ARB_PRIORITY__TS3_DUR_MULT_MASK                = 0x000c0000;
constexpr unsigned int SPI_ATTRIBUTE_RING_BASE__BASE_MASK                 = 0xffffffff;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__BIG_PAGE_MASK             = 0x00010000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__GL1_PERF_COUNTER_DISABLE_MASK = 0x00400000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__L1_POLICY_MASK            = 0x00060000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__L2_POLICY_MASK            = 0x00180000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__LLC_NOALLOC_MASK          = 0x00200000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__MEM_SIZE_MASK             = 0x000000ff;
constexpr unsigned int SPI_BARYC_CNTL__FRONT_FACE_ALL_BITS_MASK           = 0x01000000;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTER_CNTL_MASK            = 0x00000100;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTROID_CNTL_MASK          = 0x00001000;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTER_CNTL_MASK             = 0x00000001;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTROID_CNTL_MASK           = 0x00000010;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_LOCATION_MASK            = 0x00030000;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_ULC_MASK                 = 0x00100000;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__CENTER_SSAA_MODE_MASK         = 0x00000001;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__CENTROID_SSAA_MODE_MASK       = 0x00000002;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__COVERED_CENTROID_IS_CENTER_MASK = 0x00000004;
constexpr unsigned int SPI_COMPUTE_QUEUE_RESET__RESET_MASK                = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE0_SAVE_BUSY_MASK = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE1_SAVE_BUSY_MASK = 0x00000002;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE2_SAVE_BUSY_MASK = 0x00000004;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE3_SAVE_BUSY_MASK = 0x00000008;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE4_SAVE_BUSY_MASK = 0x00000010;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE5_SAVE_BUSY_MASK = 0x00000020;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE6_SAVE_BUSY_MASK = 0x00000040;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE7_SAVE_BUSY_MASK = 0x00000080;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE0_SAVE_BUSY_MASK = 0x00000100;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE1_SAVE_BUSY_MASK = 0x00000200;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE2_SAVE_BUSY_MASK = 0x00000400;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE3_SAVE_BUSY_MASK = 0x00000800;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE4_SAVE_BUSY_MASK = 0x00001000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE5_SAVE_BUSY_MASK = 0x00002000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE6_SAVE_BUSY_MASK = 0x00004000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE7_SAVE_BUSY_MASK = 0x00008000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE0_SAVE_BUSY_MASK = 0x00010000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE1_SAVE_BUSY_MASK = 0x00020000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE2_SAVE_BUSY_MASK = 0x00040000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE3_SAVE_BUSY_MASK = 0x00080000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE4_SAVE_BUSY_MASK = 0x00100000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE5_SAVE_BUSY_MASK = 0x00200000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE6_SAVE_BUSY_MASK = 0x00400000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE7_SAVE_BUSY_MASK = 0x00800000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE0_SAVE_BUSY_MASK = 0x01000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE1_SAVE_BUSY_MASK = 0x02000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE2_SAVE_BUSY_MASK = 0x04000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE3_SAVE_BUSY_MASK = 0x08000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE4_SAVE_BUSY_MASK = 0x10000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE5_SAVE_BUSY_MASK = 0x20000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE6_SAVE_BUSY_MASK = 0x40000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE7_SAVE_BUSY_MASK = 0x80000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__DONE_INTERRUPT_EN_MASK    = 0x00000004;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__INITIATE_MASK             = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__SAVE_BUSY_MASK            = 0x80000000;
constexpr unsigned int SPI_COMPUTE_WGS_CONTROL__WGS_ENABLE_MASK           = 0x00000001;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSC_PWR_SAVE_DISABLE_MASK       = 0x00004000;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSG_PWR_SAVE_DISABLE_MASK       = 0x00008000;
constexpr unsigned int SPI_CONFIG_CNTL_1__EN_USER_ACCUM_MASK              = 0x00200000;
constexpr unsigned int SPI_CONFIG_CNTL_1__INTERP_ONE_PRIM_PER_ROW_MASK    = 0x00000010;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_CNT_MASK            = 0x00003c00;
constexpr unsigned int SPI_CONFIG_CNTL_1__MAX_VTX_SYNC_CNT_MASK           = 0x001f0000;
constexpr unsigned int SPI_CONFIG_CNTL_1__OREO_EXPALLOC_STALL_MASK        = 0x00000200;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE_MASK            = 0x00000060;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_STRICT_MASK            = 0x00000080;
constexpr unsigned int SPI_CONFIG_CNTL_1__PS_GROUP_TIMEOUT_MASK           = 0xff800000;
constexpr unsigned int SPI_CONFIG_CNTL_1__PS_GROUP_TIMEOUT_MODE_MASK      = 0x00000100;
constexpr unsigned int SPI_CONFIG_CNTL_1__SA_SCREEN_MAP_MASK              = 0x00400000;
constexpr unsigned int SPI_CONFIG_CNTL_1__VTX_DONE_DELAY_MASK             = 0x0000000f;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD_MASK = 0x000000f0;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD_MASK = 0x0000000f;
constexpr unsigned int SPI_CONFIG_CNTL_2__CSC_HALT_ACK_DELAY_MASK         = 0x0001f000;
constexpr unsigned int SPI_CONFIG_CNTL_2__PC_CONTEXT_DONE_SYNC_ENABLE_MASK = 0x00200000;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_CSG_WAIT_DISABLE_MASK       = 0x00000100;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_GS_WAIT_DISABLE_MASK        = 0x00000400;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_HS_WAIT_DISABLE_MASK        = 0x00000200;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_PS_WAIT_DISABLE_MASK        = 0x00000800;
constexpr unsigned int SPI_CONFIG_CNTL_2__SPP_TIMEOUT_CTR_MASK            = 0x001e0000;
constexpr unsigned int SPI_CONFIG_CNTL__ALLOC_ARB_LRU_ENA_MASK            = 0x10000000;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_BOP_EVENTS_MASK        = 0x02000000;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_TOP_EVENTS_MASK        = 0x01000000;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_ARB_LRU_ENA_MASK              = 0x20000000;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_PRIORITY_ORDER_MASK           = 0x00e00000;
constexpr unsigned int SPI_CONFIG_CNTL__GPR_WRITE_PRIORITY_MASK           = 0x001fffff;
constexpr unsigned int SPI_CONFIG_CNTL__PS_PKR_PRIORITY_CNTL_MASK         = 0xc0000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS0__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS0__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS1__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS1__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS2__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS2__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS3__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS3__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS4__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS4__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS5__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS5__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS6__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS6__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS7__CU_EN_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS7__CU_EN_SA1_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX0__GS_CU_EN_MASK             = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX0__HS_CU_EN_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX1__CSG_CU_EN_MASK            = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX1__PS_CU_EN_MASK             = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D0__GS_CU_EN_MASK            = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D0__HS_CU_EN_MASK            = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D1__CSG_CU_EN_MASK           = 0xffff0000;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D1__PS_CU_EN_MASK            = 0x0000ffff;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR2_OFFSET_MASK              = 0x000000f0;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR3_OFFSET_MASK              = 0x00000f00;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR_OFFSET_MASK               = 0x0000000f;
constexpr unsigned int SPI_CREST_MODE__ENABLE_CREST_MASK                  = 0x00000001;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__COUNT_MASK              = 0x000007ff;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__EVENTS_MASK             = 0x07ff0000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__COUNT_MASK              = 0x000007ff;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__EVENTS_MASK             = 0x07ff0000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__COUNT_MASK              = 0x000007ff;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__EVENTS_MASK             = 0x07ff0000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__COUNT_MASK              = 0x000007ff;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__EVENTS_MASK             = 0x07ff0000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_STATUS__ACTIVE_MASK              = 0xffffffff;
constexpr unsigned int SPI_CS_CRAWLER_CONFIG__CSC_DEPTH_MASK              = 0x00000fc0;
constexpr unsigned int SPI_CS_CRAWLER_CONFIG__CSG_DEPTH_MASK              = 0x0000003f;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_ENABLE_ERROR_INJECT_MASK = 0x00000003;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY_MASK        = 0x000001f8;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_SELECT_INJECT_DELAY_MASK = 0x00000004;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_DSM_IRRITATOR_DATA_MASK   = 0x00000003;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_ENABLE_SINGLE_WRITE_MASK  = 0x00000004;
constexpr unsigned int SPI_EDC_CNT__SPI_SR_MEM_SED_COUNT_MASK             = 0x00000003;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__DOWNSTEP_MASK               = 0x00001e00;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__ENABLE_MASK                 = 0x00000001;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__EXP_STALL_THRESHOLD_MASK    = 0x03f80000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__HIGH_STALL_MON_HIST_COUNT_MASK = 0x00070000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__LOW_STALL_MON_HIST_COUNT_MASK = 0x0000e000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__PERIOD_MASK                 = 0x0000001e;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__SKEW_COUNT_MASK             = 0x1c000000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__THROTTLE_RESET_MASK         = 0x20000000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__UPSTEP_MASK                 = 0x000001e0;
constexpr unsigned int SPI_FEATURE_CTRL__PS_THROTTLE_MAX_WAVE_LIMIT_MASK  = 0x000007e0;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_IGNORE_MASK             = 0x00000010;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_DISABLE_MASK       = 0x00004000;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_OOO_CTRL_MASK      = 0x00002000;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_WIF_CTRL_MASK      = 0x00001800;
constexpr unsigned int SPI_FEATURE_CTRL__TUNNELING_WAVE_LIMIT_MASK        = 0x0000000f;
constexpr unsigned int SPI_GDS_CREDITS__DS_CMD_CREDITS_MASK               = 0x0000ff00;
constexpr unsigned int SPI_GDS_CREDITS__DS_DATA_CREDITS_MASK              = 0x000000ff;
constexpr unsigned int SPI_GFX_CNTL__RESET_COUNTS_MASK                    = 0x00000001;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__GS_DEPTH_MASK              = 0x000007e0;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__HS_DEPTH_MASK              = 0x0001f800;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_ALLOC_DEPTH_MASK        = 0x003e0000;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_DEPTH_MASK              = 0x0000001f;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_LDS_DONE_CNTL_MASK      = 0x02000000;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_LDS_DONE_DEPTH_MASK     = 0x01c00000;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__RA_PSWAVE_CREDITS_MASK     = 0x1c000000;
constexpr unsigned int SPI_GFX_SCRATCH_BASE_HI__DATA_MASK                 = 0x000000ff;
constexpr unsigned int SPI_GFX_SCRATCH_BASE_LO__DATA_MASK                 = 0xffffffff;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__ALLOC_SUCCESS_THRESHOLD_MASK = 0x00003c00;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__CS_WAVE_THRESHOLD_HIGH_MASK = 0x00f80000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__CU_MASK_ROTATE_PERIODS_MASK = 0x03000000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__GFX_PENDING_THRESHOLD_MASK = 0x00000038;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__GFX_WAVE_THRESHOLD_HIGH_MASK = 0x0007c000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__NUM_MRT_THRESHOLD_MASK = 0x00000007;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__PRIORITY_LOST_THRESHOLD_MASK = 0x000003c0;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__CS_GLG_DISABLE_MASK = 0x00000010;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__CS_NUM_LOCK_WGP_MASK = 0x00000700;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__ENABLE_MASK       = 0x00000001;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__GFX_NUM_LOCK_WGP_MASK = 0x000000e0;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__GS_ASSIST_EN_MASK = 0x00000004;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__HS_ASSIST_EN_MASK = 0x00000002;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__LOCK_MAINT_COUNT_MASK = 0x00038000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__LOCK_PERIOD_MASK  = 0x00007800;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__MRT_ASSIST_EN_MASK = 0x00000008;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_POLL_INTERVAL_MASK       = 0x0000000f;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_THROTTLE_BASE_MASK       = 0x000000f0;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_THROTTLE_STEP_SIZE_MASK  = 0x00000f00;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_LDS_THRESHOLD_MASK      = 0x000f0000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_POLL_INTERVAL_MASK      = 0x00f00000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_THROTTLE_BASE_MASK      = 0x0f000000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_THROTTLE_STEP_SIZE_MASK = 0xf0000000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_VGPR_THRESHOLD_MASK     = 0x0000f000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_PENALTY1_MASK  = 0x00000700;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_PENALTY2_MASK  = 0x00003800;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_THRESHOLD_FACTOR_MASK = 0x000000c0;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_THRESHOLD_MASK = 0x0000003c;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__PH_MODE_MASK                = 0x00010000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__PS_STALL_THRESHOLD_MASK     = 0x0000c000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__RESERVED_MASK               = 0xfffe0000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__SPI_THROTTLE_MODE_MASK      = 0x00000003;
constexpr unsigned int SPI_INTERP_CONTROL_0__FLAT_SHADE_ENA_MASK          = 0x00000001;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_ENA_MASK          = 0x00000002;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_W_MASK       = 0x00003800;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_X_MASK       = 0x0000001c;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Y_MASK       = 0x000000e0;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Z_MASK       = 0x00000700;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_TOP_1_MASK        = 0x00004000;
constexpr unsigned int SPI_LB_CTR_CTRL__CLEAR_ON_READ_MASK                = 0x00000008;
constexpr unsigned int SPI_LB_CTR_CTRL__LOAD_MASK                         = 0x00000001;
constexpr unsigned int SPI_LB_CTR_CTRL__RESET_COUNTS_MASK                 = 0x00000010;
constexpr unsigned int SPI_LB_CTR_CTRL__WAVES_SELECT_MASK                 = 0x00000006;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_CS__ACTIVE_MASK            = 0x0000ffff;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_GS_MASK     = 0xffff0000;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_HS_MASK     = 0x0000ffff;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_PS__WGP_USED_PS_MASK       = 0x0000ffff;
constexpr unsigned int SPI_LB_DATA_REG__CNT_DATA_MASK                     = 0xffffffff;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT0_MASK                     = 0x0000ffff;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT1_MASK                     = 0xffff0000;
constexpr unsigned int SPI_LB_WGP_MASK__WGP_MASK_MASK                     = 0x0000ffff;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__SGPR_MIN_MASK          = 0x000003c0;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__VGPR_MIN_MASK          = 0x0000003f;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_HI__MEM_BASE_MASK          = 0x000000ff;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_LO__MEM_BASE_MASK          = 0xffffffff;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_HI__MEM_BASE_MASK          = 0x000000ff;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_LO__MEM_BASE_MASK          = 0xffffffff;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__SGPR_MIN_MASK          = 0x000003c0;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__VGPR_MIN_MASK          = 0x0000003f;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_HI__MEM_BASE_MASK          = 0x000000ff;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_LO__MEM_BASE_MASK          = 0xffffffff;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_HI__MEM_BASE_MASK          = 0x000000ff;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_LO__MEM_BASE_MASK          = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MAX_MASK                = 0x000000f0;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MIN_MASK                = 0x0000000f;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MAX_MASK                = 0x0000f000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MIN_MASK                = 0x00000f00;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MAX_MASK                = 0x00f00000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MIN_MASK                = 0x000f0000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MAX_MASK                = 0xf0000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MIN_MASK                = 0x0f000000;
constexpr unsigned int SPI_PG_ENABLE_STATIC_WGP_MASK__WGP_MASK_MASK       = 0x0000ffff;
constexpr unsigned int SPI_PQEV_CTRL__COMPUTE_PIPE_EN_MASK                = 0x00ff0000;
constexpr unsigned int SPI_PQEV_CTRL__QUEUE_DURATION_MASK                 = 0x0000fc00;
constexpr unsigned int SPI_PQEV_CTRL__SCAN_PERIOD_MASK                    = 0x000003ff;
constexpr unsigned int SPI_PS_INPUT_ADDR__ANCILLARY_ENA_MASK              = 0x00002000;
constexpr unsigned int SPI_PS_INPUT_ADDR__FRONT_FACE_ENA_MASK             = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTER_ENA_MASK          = 0x00000020;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTROID_ENA_MASK        = 0x00000040;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_SAMPLE_ENA_MASK          = 0x00000010;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINE_STIPPLE_TEX_ENA_MASK       = 0x00000080;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTER_ENA_MASK           = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTROID_ENA_MASK         = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_PULL_MODEL_ENA_MASK       = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_SAMPLE_ENA_MASK           = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_FIXED_PT_ENA_MASK           = 0x00008000;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_W_FLOAT_ENA_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_X_FLOAT_ENA_MASK            = 0x00000100;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Y_FLOAT_ENA_MASK            = 0x00000200;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Z_FLOAT_ENA_MASK            = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_ADDR__SAMPLE_COVERAGE_ENA_MASK        = 0x00004000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR0_VALID_MASK              = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR1_VALID_MASK              = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_ATTR1_MASK        = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_MASK              = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DUP_MASK                      = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FLAT_SHADE_MASK               = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FP16_INTERP_MODE_MASK         = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__OFFSET_MASK                   = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PRIM_ATTR_MASK                = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_ATTR1_MASK      = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_MASK            = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ROTATE_PC_PTR_MASK            = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__USE_DEFAULT_ATTR1_MASK        = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_ATTR1_MASK     = 0x00800000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_MASK           = 0x00020000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR0_VALID_MASK             = 0x01000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR1_VALID_MASK             = 0x02000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_ATTR1_MASK       = 0x00600000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_MASK             = 0x00000300;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DUP_MASK                     = 0x00040000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FLAT_SHADE_MASK              = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FP16_INTERP_MODE_MASK        = 0x00080000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__OFFSET_MASK                  = 0x0000003f;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__PRIM_ATTR_MASK               = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ROTATE_PC_PTR_MASK           = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__USE_DEFAULT_ATTR1_MASK       = 0x00100000;
constexpr unsigned int SPI_PS_INPUT_ENA__ANCILLARY_ENA_MASK               = 0x00002000;
constexpr unsigned int SPI_PS_INPUT_ENA__COVERAGE_TO_SHADER_SELECT_MASK   = 0x00030000;
constexpr unsigned int SPI_PS_INPUT_ENA__FRONT_FACE_ENA_MASK              = 0x00001000;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTER_ENA_MASK           = 0x00000020;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTROID_ENA_MASK         = 0x00000040;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_SAMPLE_ENA_MASK           = 0x00000010;
constexpr unsigned int SPI_PS_INPUT_ENA__LINE_STIPPLE_TEX_ENA_MASK        = 0x00000080;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTER_ENA_MASK            = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTROID_ENA_MASK          = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_PULL_MODEL_ENA_MASK        = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_SAMPLE_ENA_MASK            = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_FIXED_PT_ENA_MASK            = 0x00008000;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_W_FLOAT_ENA_MASK             = 0x00000800;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_X_FLOAT_ENA_MASK             = 0x00000100;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Y_FLOAT_ENA_MASK             = 0x00000200;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Z_FLOAT_ENA_MASK             = 0x00000400;
constexpr unsigned int SPI_PS_INPUT_ENA__SAMPLE_COVERAGE_ENA_MASK         = 0x00004000;
constexpr unsigned int SPI_PS_IN_CONTROL__BC_OPTIMIZE_DISABLE_MASK        = 0x00004000;
constexpr unsigned int SPI_PS_IN_CONTROL__PARAM_GEN_MASK                  = 0x00000040;
constexpr unsigned int SPI_PS_IN_CONTROL__PS_W32_EN_MASK                  = 0x00008000;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_COLLISION_WAVE_ID_MASK     = 0x03ff0000;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_WAVE_ID_MASK               = 0x00000fff;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS_MASK           = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS_MASK                = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR_MASK               = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR_MASK               = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES_MASK              = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS_MASK          = 0x00078000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS_MASK               = 0x00000f00;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR_MASK              = 0x000000f0;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR_MASK              = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES_MASK             = 0x00007000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN_MASK              = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK_MASK      = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK_MASK       = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN_MASK             = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK_MASK     = 0x00ff0000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK_MASK      = 0x0000fffe;
constexpr unsigned int SPI_SAVE_RESTORE_STATUS__PERFCOUNTER_EN_MASK       = 0x00000001;
constexpr unsigned int SPI_SAVE_RESTORE_STATUS__THREAD_TRACE_EN_MASK      = 0x00000002;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__ME_ID_MASK                = 0x0000000c;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__OVERFLOW_DETECTED_MASK    = 0x00000002;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__PIPE_ID_MASK              = 0x00000030;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__WRITE_DIS_MASK            = 0x00000001;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL0_EXPORT_FORMAT_MASK     = 0x0000000f;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL1_EXPORT_FORMAT_MASK     = 0x000000f0;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL2_EXPORT_FORMAT_MASK     = 0x00000f00;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL3_EXPORT_FORMAT_MASK     = 0x0000f000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL4_EXPORT_FORMAT_MASK     = 0x000f0000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL5_EXPORT_FORMAT_MASK     = 0x00f00000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL6_EXPORT_FORMAT_MASK     = 0x0f000000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL7_EXPORT_FORMAT_MASK     = 0xf0000000;
constexpr unsigned int SPI_SHADER_GS_MESHLET_CTRL__INTERLEAVE_BITS_X_MASK = 0x0000000f;
constexpr unsigned int SPI_SHADER_GS_MESHLET_CTRL__INTERLEAVE_BITS_Y_MASK = 0x000000f0;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_X_MASK = 0x000000ff;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_Y_MASK = 0x0000ff00;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_Z_MASK = 0x00ff0000;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_THREADGROUP_SIZE_MASK = 0xff000000;
constexpr unsigned int SPI_SHADER_GS_MESHLET_EXP_ALLOC__MAX_EXP_PRIMS_MASK = 0x0003fe00;
constexpr unsigned int SPI_SHADER_GS_MESHLET_EXP_ALLOC__MAX_EXP_VERTS_MASK = 0x000001ff;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NO_PC_EXPORT_MASK  = 0x00000400;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NUM_INTERP_MASK    = 0x0001f800;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NUM_PRIM_INTERP_MASK = 0x003e0000;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__PRIM_EXPORT_COUNT_MASK = 0x000003e0;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__VS_EXPORT_COUNT_MASK = 0x0000001f;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NO_PC_EXPORT_MASK     = 0x00000400;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NUM_INTERP_MASK       = 0x0001f800;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NUM_PRIM_INTERP_MASK  = 0x003e0000;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__PRIM_EXPORT_COUNT_MASK = 0x000003e0;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__VS_EXPORT_COUNT_MASK  = 0x0000001f;
constexpr unsigned int SPI_SHADER_IDX_FORMAT__IDX0_EXPORT_FORMAT_MASK     = 0x0000000f;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_GS__CHECKSUM_MASK            = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_HS__CHECKSUM_MASK            = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_PS__CHECKSUM_MASK            = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_HI_ES__MEM_BASE_MASK                = 0x000000ff;
constexpr unsigned int SPI_SHADER_PGM_HI_GS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_HI_HS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_HI_LS__MEM_BASE_MASK                = 0x000000ff;
constexpr unsigned int SPI_SHADER_PGM_HI_PS__MEM_BASE_MASK                = 0x000000ff;
constexpr unsigned int SPI_SHADER_PGM_LO_ES__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_LO_GS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_LO_HS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_LO_LS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_LO_PS__MEM_BASE_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CDBG_USER_MASK            = 0x10000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CU_GROUP_ENABLE_MASK      = 0x01000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DEBUG_MODE_MASK           = 0x00400000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DISABLE_PERF_MASK         = 0x00800000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FLOAT_MODE_MASK           = 0x000ff000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FP16_OVFL_MASK            = 0x80000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FWD_PROGRESS_MASK         = 0x04000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__GS_VGPR_COMP_CNT_MASK     = 0x60000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIORITY_MASK             = 0x00000c00;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIV_MASK                 = 0x00100000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__SGPRS_MASK                = 0x000003c0;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__VGPRS_MASK                = 0x0000003f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WGP_MODE_MASK             = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WG_RR_EN_MASK             = 0x00200000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__CDBG_USER_MASK            = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DEBUG_MODE_MASK           = 0x00400000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DISABLE_PERF_MASK         = 0x00800000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FLOAT_MODE_MASK           = 0x000ff000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FP16_OVFL_MASK            = 0x40000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FWD_PROGRESS_MASK         = 0x02000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__LS_VGPR_COMP_CNT_MASK     = 0x30000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIORITY_MASK             = 0x00000c00;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIV_MASK                 = 0x00100000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__SGPRS_MASK                = 0x000003c0;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__VGPRS_MASK                = 0x0000003f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WGP_MODE_MASK             = 0x04000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WG_RR_EN_MASK             = 0x00200000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CDBG_USER_MASK            = 0x10000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CU_GROUP_DISABLE_MASK     = 0x01000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DEBUG_MODE_MASK           = 0x00400000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DISABLE_PERF_MASK         = 0x00800000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FLOAT_MODE_MASK           = 0x000ff000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FP16_OVFL_MASK            = 0x20000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FWD_PROGRESS_MASK         = 0x04000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__LOAD_PROVOKING_VTX_MASK   = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIORITY_MASK             = 0x00000c00;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIV_MASK                 = 0x00100000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__SGPRS_MASK                = 0x000003c0;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__VGPRS_MASK                = 0x0000003f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__WG_RR_EN_MASK             = 0x00200000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__ES_VGPR_COMP_CNT_MASK     = 0x00030000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__EXCP_EN_MASK              = 0x0000ff80;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__LDS_SIZE_MASK             = 0x07f80000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__OC_LDS_EN_MASK            = 0x00040000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SCRATCH_EN_MASK           = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SHARED_VGPR_CNT_MASK      = 0xf0000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__TRAP_PRESENT_MASK         = 0x00000040;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MASK            = 0x0000003e;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB_MASK        = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN_MASK              = 0x0003fe00;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE_MASK             = 0x07fc0000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__OC_LDS_EN_MASK            = 0x00000080;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SCRATCH_EN_MASK           = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SHARED_VGPR_CNT_MASK      = 0xf0000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TG_SIZE_EN_MASK           = 0x00000100;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TRAP_PRESENT_MASK         = 0x00000040;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MASK            = 0x0000003e;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB_MASK        = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXCP_EN_MASK              = 0x01ff0000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXTRA_LDS_SIZE_MASK       = 0x0000ff00;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_COLLISION_WAVEID_MASK = 0x02000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_INTRAWAVE_COLLISION_MASK = 0x04000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SCRATCH_EN_MASK           = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SHARED_VGPR_CNT_MASK      = 0xf0000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__TRAP_PRESENT_MASK         = 0x00000040;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MASK            = 0x0000003e;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB_MASK        = 0x08000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__WAVE_CNT_EN_MASK          = 0x00000080;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__CU_EN_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__CU_EN_MASK                = 0xffffffff;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__CU_EN_MASK                = 0x0000ffff;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GLG_EN_OVERRIDE_MASK      = 0x00000400;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GLG_FORCE_DISABLE_MASK    = 0x00000800;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__IMAGE_OP_MASK             = 0x80000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__INST_PREF_SIZE_MASK       = 0x7f800000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__PH_THROTTLE_EN_MASK       = 0x00004000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS_MASK = 0x007f0000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_THROTTLE_EN_MASK      = 0x00008000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__WAVE_LIMIT_MASK           = 0x000003ff;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GLG_EN_OVERRIDE_MASK      = 0x00000400;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GLG_FORCE_DISABLE_MASK    = 0x00000800;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__IMAGE_OP_MASK             = 0x80000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__INST_PREF_SIZE_MASK       = 0x00ff0000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__WAVE_LIMIT_MASK           = 0x000003ff;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__IMAGE_OP_MASK             = 0x80000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__INST_PREF_SIZE_MASK       = 0x00ff0000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__LDS_GROUP_SIZE_MASK       = 0x00000c00;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__WAVE_LIMIT_MASK           = 0x000003ff;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS0_EXPORT_FORMAT_MASK     = 0x0000000f;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS1_EXPORT_FORMAT_MASK     = 0x000000f0;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS2_EXPORT_FORMAT_MASK     = 0x00000f00;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS3_EXPORT_FORMAT_MASK     = 0x0000f000;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS4_EXPORT_FORMAT_MASK     = 0x000f0000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__GLOBAL_SCANNING_EN_MASK  = 0x00010000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001e;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_EN_MASK    = 0x00000001;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__GLOBAL_SCANNING_EN_MASK  = 0x00010000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001e;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_EN_MASK    = 0x00000001;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__GLOBAL_SCANNING_EN_MASK    = 0x00010000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_HYSTERESIS_MASK  = 0x00000200;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001e;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_EN_MASK      = 0x00000001;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_HIERARCHY_LEVEL_MASK = 0x00080000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_MASK     = 0x0007e000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_HIERARCHY_LEVEL_MASK = 0x10000000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_MASK         = 0x0ff00000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__PERFORMANCE_LIMIT_ENABLE_MASK = 0x80000000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_PER_SIMD32_MASK   = 0x00000fe0;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_WRAP_DISABLE_MASK = 0x00001000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__WAVES_PER_SIMD32_MASK  = 0x0000001f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_0__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_1__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_2__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_3__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_0__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_1__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_2__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_3__CONTRIBUTION_MASK    = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_0__CONTRIBUTION_MASK      = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_1__CONTRIBUTION_MASK      = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_2__CONTRIBUTION_MASK      = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_3__CONTRIBUTION_MASK      = 0x0000007f;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_GS__MEM_BASE_MASK     = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_HS__MEM_BASE_MASK     = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_GS__MEM_BASE_MASK     = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_HS__MEM_BASE_MASK     = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_0__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_1__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_2__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_3__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_4__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_5__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_6__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_7__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_8__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_9__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_10__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_11__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_12__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_13__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_14__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_15__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_16__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_17__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_18__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_19__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_20__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_21__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_22__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_23__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_24__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_25__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_26__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_27__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_28__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_29__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_30__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_31__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_0__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_1__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_2__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_3__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_4__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_5__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_6__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_7__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_8__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_9__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_10__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_11__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_12__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_13__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_14__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_15__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_16__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_17__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_18__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_19__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_20__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_21__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_22__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_23__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_24__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_25__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_26__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_27__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_28__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_29__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_30__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_31__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_0__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_1__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_2__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_3__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_4__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_5__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_6__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_7__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_8__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_9__DATA_MASK               = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_10__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_11__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_12__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_13__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_14__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_15__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_16__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_17__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_18__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_19__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_20__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_21__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_22__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_23__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_24__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_25__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_26__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_27__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_28__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_29__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_30__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_31__DATA_MASK              = 0xffffffff;
constexpr unsigned int SPI_SHADER_Z_FORMAT__Z_EXPORT_FORMAT_MASK          = 0x0000000f;
constexpr unsigned int SPI_SQG_EVENT_CTL__ENABLE_SQG_BOP_EVENTS_MASK      = 0x00000002;
constexpr unsigned int SPI_SQG_EVENT_CTL__ENABLE_SQG_TOP_EVENTS_MASK      = 0x00000001;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__COLOR_BUFFER_SIZE_MASK = 0x0000ffff;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__POSITION_BUFFER_SIZE_MASK = 0xffff0000;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__COLOR_SCOREBOARD_SIZE_MASK = 0x0000ffff;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__POSITION_SCOREBOARD_SIZE_MASK = 0xffff0000;
constexpr unsigned int SPI_TMPRING_SIZE__WAVESIZE_MASK                    = 0x3ffff000;
constexpr unsigned int SPI_TMPRING_SIZE__WAVES_MASK                       = 0x00000fff;
constexpr unsigned int SPI_USER_ACCUM_VMID_CNTL__EN_USER_ACCUM_MASK       = 0x0000000f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS0__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS1__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS2__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS3__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__GS_GRP_VALUE_MASK        = 0x07c00000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__HS_GRP_VALUE_MASK        = 0x0001f000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__VALUE_MASK               = 0x0000007f;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__GS_GRP_VALUE_MASK       = 0x07c00000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__HS_GRP_VALUE_MASK       = 0x0001f000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__VALUE_MASK              = 0x0000007f;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_GFX__WF_ACTIVE_MASK            = 0x00ffff00;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_GFX__WF_ALLOCATED_MASK         = 0x000000ff;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_HPG__WF_ACTIVE_MASK            = 0x00ffff00;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_HPG__WF_ALLOCATED_MASK         = 0x000000ff;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__EN_MASK                      = 0x00000010;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__SAMPLE_PERIOD_MASK           = 0x0000000f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__EN_WARN_MASK              = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__MAX_CNT_MASK              = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__EN_WARN_MASK              = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__MAX_CNT_MASK              = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__EN_WARN_MASK              = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__MAX_CNT_MASK              = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__INT_SENT_MASK            = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__MAX_CNT_MASK             = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_21__INT_SENT_MASK           = 0x80000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_21__MAX_CNT_MASK            = 0x7fffffff;
constexpr unsigned int SPI_WGP_WORK_PENDING__RESERVED_MASK                = 0xffff0000;
constexpr unsigned int SPI_WGP_WORK_PENDING__SPI_WGP_WORK_PENDING_MASK    = 0x0000ffff;
constexpr unsigned int SQG_CONFIG__SQG_ICPFT_CLR_MASK                     = 0x00000002;
constexpr unsigned int SQG_CONFIG__SQG_ICPFT_EN_MASK                      = 0x00000001;
constexpr unsigned int SQG_CONFIG__XNACK_INTR_MASK_MASK                   = 0xffff0000;
constexpr unsigned int SQG_GL1X_CTRL__SCOPE_MASK                          = 0x00000030;
constexpr unsigned int SQG_GL1X_CTRL__TEMPORAL_MASK                       = 0x00000007;
constexpr unsigned int SQG_GL1X_STATUS__ACK_ERR_DETECTED_MASK             = 0x00000001;
constexpr unsigned int SQG_GL1X_STATUS__XNACK_ERR_DETECTED_MASK           = 0x00000002;
constexpr unsigned int SQG_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL2__FORCE_EN_MASK               = 0x00000001;
constexpr unsigned int SQG_PERFCOUNTER_CTRL2__VMID_EN_MASK                = 0x0001fffe;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__CS_EN_MASK                   = 0x00000040;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME0PIPE0_PERF_MASK   = 0x00004000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME0PIPE1_PERF_MASK   = 0x00008000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE0_PERF_MASK   = 0x00010000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE1_PERF_MASK   = 0x00020000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE2_PERF_MASK   = 0x00040000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE3_PERF_MASK   = 0x00080000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__GS_EN_MASK                   = 0x00000004;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__HS_EN_MASK                   = 0x00000010;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__PS_EN_MASK                   = 0x00000001;
constexpr unsigned int SQG_PERF_SAMPLE_FINISH__STATUS_MASK                = 0x0000007f;
constexpr unsigned int SQG_STATUS__POWEROFF_RESTORE_MASK                  = 0x00000002;
constexpr unsigned int SQG_STATUS__REG_BUSY_MASK                          = 0x00000001;
constexpr unsigned int SQG_THREAD_TRACE_CONFIG__ALL_VMID_MASK             = 0x00000001;
constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA1_MASK             = 0xffff0000;
constexpr unsigned int SQ_ARB_CONFIG__FWD_PROG_INTERVAL_MASK              = 0x00000030;
constexpr unsigned int SQ_ARB_CONFIG__WG_RR_INTERVAL_MASK                 = 0x00000003;
constexpr unsigned int SQ_CLK_CTRL__EX_BRMSG_FGCG_OVERRIDE_MASK           = 0x04000000;
constexpr unsigned int SQ_CLK_CTRL__EX_SALU_FGCG_OVERRIDE_MASK            = 0x01000000;
constexpr unsigned int SQ_CLK_CTRL__EX_VALU_FGCG_OVERRIDE_MASK            = 0x02000000;
constexpr unsigned int SQ_CLK_CTRL__IB_IBUF_FGCG_OVERRIDE_MASK            = 0x00200000;
constexpr unsigned int SQ_CLK_CTRL__IB_MISC_FGCG_OVERRIDE_MASK            = 0x00800000;
constexpr unsigned int SQ_CLK_CTRL__IB_WINFO_FGCG_OVERRIDE_MASK           = 0x00400000;
constexpr unsigned int SQ_CLK_CTRL__ISC_CTRL_FGCG_OVERRIDE_MASK           = 0x00080000;
constexpr unsigned int SQ_CLK_CTRL__ISC_SET_FGCG_OVERRIDE_MASK            = 0x00040000;
constexpr unsigned int SQ_CLK_CTRL__ISC_WAVE_CTRL_FGCG_OVERRIDE_MASK      = 0x00100000;
constexpr unsigned int SQ_CLK_CTRL__IS_WAVECLK_IB_WCLK_OVERRIDE_MASK      = 0x00020000;
constexpr unsigned int SQ_CLK_CTRL__OVERRIDE_LDS_DIRECT_BUSY_MASK         = 0x00000200;
constexpr unsigned int SQ_CLK_CTRL__OVERRIDE_LDS_IDX_BUSY_MASK            = 0x00000100;
constexpr unsigned int SQ_CLK_CTRL__PERFMON_OVERRIDE_MASK                 = 0x00000080;
constexpr unsigned int SQ_CLK_CTRL__SQ_LDS_DIRECT_FGCG_OVERRIDE_MASK      = 0x00010000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SPI_EXPREQ_FGCG_OVERRIDE_MASK      = 0x00000008;
constexpr unsigned int SQ_CLK_CTRL__SQ_SPI_MSG_FGCG_OVERRIDE_MASK         = 0x00000004;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_CMD_FGCG_OVERRIDE_MASK          = 0x00001000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_CONST_FGCG_OVERRIDE_MASK        = 0x00002000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_EXP_FGCG_OVERRIDE_MASK          = 0x00004000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_ICG_FGCG_OVERRIDE_MASK          = 0x08000000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_VMEM_FGCG_OVERRIDE_MASK         = 0x00008000;
constexpr unsigned int SQ_CLK_CTRL__SQ_SQC_TTRACE_FGCG_OVERRIDE_MASK      = 0x00000020;
constexpr unsigned int SQ_CLK_CTRL__SQ_SX_EXPCMD_FGCG_OVERRIDE_MASK       = 0x00000010;
constexpr unsigned int SQ_CLK_CTRL__WCLK_OVERRIDE_MASK                    = 0x00000040;
constexpr unsigned int SQ_CLK_CTRL__WCLK_SLEEP_EXPALLOC_OVERRIDE_MASK     = 0x00000800;
constexpr unsigned int SQ_CLK_CTRL__WCLK_SLEEP_VMEM_OVERRIDE_MASK         = 0x00000400;
constexpr unsigned int SQ_CMD__CHECK_VMID_MASK                            = 0x00000080;
constexpr unsigned int SQ_CMD__CMD_MASK                                   = 0x0000000f;
constexpr unsigned int SQ_CMD__DATA_MASK                                  = 0x00000f00;
constexpr unsigned int SQ_CMD__MODE_MASK                                  = 0x00000070;
constexpr unsigned int SQ_CMD__QUEUE_ID_MASK                              = 0x07000000;
constexpr unsigned int SQ_CMD__VM_ID_MASK                                 = 0xf0000000;
constexpr unsigned int SQ_CMD__WAVE_ID_MASK                               = 0x001f0000;
constexpr unsigned int SQ_CONFIG__DISABLE_END_CLAUSE_TX_MASK              = 0x08000000;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_CLAUSE_DETECTION_MASK   = 0x04000000;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_EXPORT_DETECTION_MASK   = 0x02000000;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_OPCODE_DETECTION_MASK   = 0x00800000;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_TO_NOP_DETECTION_MASK   = 0x01000000;
constexpr unsigned int SQ_CONFIG__DISABLE_ISC_PREFETCH_LIMITER_MASK       = 0x80000000;
constexpr unsigned int SQ_CONFIG__DISABLE_SGPR_RD_KILL_MASK               = 0x00000400;
constexpr unsigned int SQ_CONFIG__DISABLE_SP_SINGLE_ISSUE_WAVE64_TRANS_MASK = 0x40000000;
constexpr unsigned int SQ_CONFIG__DISABLE_VMEM_EXEC_ZERO_SKIP_MASK        = 0x00000200;
constexpr unsigned int SQ_CONFIG__ECO_SPARE_MASK                          = 0x000000ff;
constexpr unsigned int SQ_CONFIG__ENABLE_HIPRIO_ON_EXP_RDY_GS_MASK        = 0x00040000;
constexpr unsigned int SQ_CONFIG__NEW_TRANS_ARB_SCHEME_MASK               = 0x00000100;
constexpr unsigned int SQ_CONFIG__PRIO_VAL_ON_EXP_RDY_GS_MASK             = 0x00180000;
constexpr unsigned int SQ_CONFIG__WCLK_HYSTERESIS_CNT_MASK                = 0x00600000;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_ENABLE_ERROR_INJECT_MASK       = 0x00000018;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_SELECT_INJECT_DELAY_MASK       = 0x00000020;
constexpr unsigned int SQ_DSM_CNTL2__LDS_INJECT_DELAY_MASK                = 0x000fc000;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_ENABLE_ERROR_INJECT_MASK       = 0x000000c0;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_SELECT_INJECT_DELAY_MASK       = 0x00000100;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_ENABLE_ERROR_INJECT_MASK        = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_SELECT_INJECT_DELAY_MASK        = 0x00000004;
constexpr unsigned int SQ_DSM_CNTL2__SP_ENABLE_ERROR_INJECT_MASK          = 0x00000600;
constexpr unsigned int SQ_DSM_CNTL2__SP_INJECT_DELAY_MASK                 = 0x03f00000;
constexpr unsigned int SQ_DSM_CNTL2__SP_SELECT_INJECT_DELAY_MASK          = 0x00000800;
constexpr unsigned int SQ_DSM_CNTL2__SQ_INJECT_DELAY_MASK                 = 0xfc000000;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE01_MASK        = 0x00040000;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE23_MASK        = 0x00200000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA0_MASK      = 0x00010000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA1_MASK      = 0x00020000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA2_MASK      = 0x00080000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA3_MASK      = 0x00100000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA0_MASK     = 0x00000100;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA1_MASK     = 0x00000200;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA0_MASK       = 0x01000000;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA1_MASK       = 0x02000000;
constexpr unsigned int SQ_DSM_CNTL__SGPR_ENABLE_SINGLE_WRITE_MASK         = 0x00000400;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_0_MASK               = 0x00000004;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_1_MASK               = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL__SP_ENABLE_SINGLE_WRITE_MASK           = 0x04000000;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_0_MASK                = 0x00000001;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_1_MASK                = 0x00000002;
constexpr unsigned int SQ_DYN_VGPR__BLOCK_SIZE_MASK                       = 0x00000100;
constexpr unsigned int SQ_DYN_VGPR__FWD_PROGRESS_MASK                     = 0x00000010;
constexpr unsigned int SQ_DYN_VGPR__MAX_BLOCK_ALLOC_MASK                  = 0x000000e0;
constexpr unsigned int SQ_DYN_VGPR__WAVE_LIMIT_MASK                       = 0x0000000f;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_GS_RESERVED_MASK         = 0x00003000;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PRIMPOS_LIMIT_MASK       = 0x00300000;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PS_RESERVED_MASK         = 0x0000c000;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_REDUCE_MASK              = 0x00030000;
constexpr unsigned int SQ_FIFO_SIZES__INTERRUPT_FIFO_SIZE_MASK            = 0x0000000f;
constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE_MASK               = 0x00000300;
constexpr unsigned int SQ_FIFO_SIZES__VMEM_DATA_FIFO_SIZE_MASK            = 0x000c0000;
constexpr unsigned int SQ_IND_DATA__DATA_MASK                             = 0xffffffff;
constexpr unsigned int SQ_IND_INDEX__AUTO_INCR_MASK                       = 0x00000800;
constexpr unsigned int SQ_IND_INDEX__INDEX_MASK                           = 0xffff0000;
constexpr unsigned int SQ_IND_INDEX__WAVE_ID_MASK                         = 0x0000001f;
constexpr unsigned int SQ_IND_INDEX__WORKITEM_ID_MASK                     = 0x000007e0;
constexpr unsigned int SQ_INTERRUPT_AUTO_MASK__MASK_MASK                  = 0x00ffffff;
constexpr unsigned int SQ_INTERRUPT_MSG_CTRL__STALL_MASK                  = 0x00000001;
constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA1_MASK             = 0xffff0000;
constexpr unsigned int SQ_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_SEL_MASK              = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SPM_MODE_MASK              = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_SEL_MASK             = 0x000001ff;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__FORCE_EN_MASK                = 0x00000001;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__VMID_EN_MASK                 = 0x0001fffe;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CS_EN_MASK                    = 0x00000040;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME0PIPE0_PERF_MASK    = 0x00004000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME0PIPE1_PERF_MASK    = 0x00008000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE0_PERF_MASK    = 0x00010000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE1_PERF_MASK    = 0x00020000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE2_PERF_MASK    = 0x00040000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE3_PERF_MASK    = 0x00080000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__GS_EN_MASK                    = 0x00000004;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__HS_EN_MASK                    = 0x00000010;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__PS_EN_MASK                    = 0x00000001;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__COUNT_INTERVAL_MASK         = 0x003c0000;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__COUNT_SEL_MASK              = 0x00020000;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__TEST_MODE_MASK              = 0x00400000;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__TIMER_ON_OFF_MASK           = 0x00000001;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__VMID_MASK_MASK              = 0x0001fffe;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_BRMSG_MASK = 0x00000040;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_EXPORT_MASK = 0x00000080;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_LDS_DIRECT_MASK = 0x00000100;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_LDS_MASK  = 0x00000200;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_RESERVED_MASK = 0x00002000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_SCALAR_MASK = 0x00000800;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_TEX_MASK  = 0x00000400;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_VALU_MASK = 0x00001000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_BRMSG_MASK = 0x00004000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_EXPORT_MASK = 0x00008000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_LDS_DIRECT_MASK = 0x00010000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_LDS_MASK = 0x00020000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_RESERVED_MASK = 0x00200000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_SCALAR_MASK = 0x00080000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_TEX_MASK = 0x00040000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_VALU_MASK = 0x00100000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__WAVE_CNT_MASK              = 0x0000003f;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__BVH_CNT_MASK               = 0x00007000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__DS_CNT_MASK                = 0x07e00000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__KM_CNT_MASK                = 0xf8000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__LOAD_CNT_MASK              = 0x0000003f;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__SAMPLE_CNT_MASK            = 0x001f8000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__STORE_CNT_MASK             = 0x00000fc0;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__INST_TYPE_MASK              = 0x0000003c;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__NO_ISSUE_REASON_MASK        = 0x000001c0;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__VALID_MASK                  = 0x00000001;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__WAVE_ID_MASK                = 0x00003e00;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__WAVE_ISSUE_MASK             = 0x00000002;
constexpr unsigned int SQ_PERF_SNAPSHOT_PC_HI__PC_HI_MASK                 = 0x0000ffff;
constexpr unsigned int SQ_PERF_SNAPSHOT_PC_LO__PC_LO_MASK                 = 0xffffffff;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__FORCE_IB_ARB_PRIO_MSK_VALID_MASK = 0x80000000;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RET_MASK                       = 0x0000007f;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG_MASK                       = 0x00fffc00;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RUI_MASK                       = 0x00000380;
constexpr unsigned int SQ_RUNTIME_CONFIG__UNUSED_REGISTER_MASK            = 0x00000001;
constexpr unsigned int SQ_SHADER_CYCLES_HI__CYCLES_HI_MASK                = 0x0fffffff;
constexpr unsigned int SQ_SHADER_CYCLES_LO__CYCLES_LO_MASK                = 0xffffffff;
constexpr unsigned int SQ_SHADER_TBA_HI__ADDR_HI_MASK                     = 0x000000ff;
constexpr unsigned int SQ_SHADER_TBA_HI__TRAP_EN_MASK                     = 0x80000000;
constexpr unsigned int SQ_SHADER_TBA_LO__ADDR_LO_MASK                     = 0xffffffff;
constexpr unsigned int SQ_SHADER_TMA_HI__ADDR_HI_MASK                     = 0x000000ff;
constexpr unsigned int SQ_SHADER_TMA_LO__ADDR_LO_MASK                     = 0xffffffff;
constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA0_MASK             = 0x0000ffff;
constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA1_MASK             = 0xffff0000;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE_HI__BASE_HI_MASK         = 0x00001fff;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE_LO__BASE_LO_MASK         = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__SIZE_MASK               = 0x003fffff;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE_HI__BASE_HI_MASK         = 0x00001fff;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE_LO__BASE_LO_MASK         = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__SIZE_MASK               = 0x003fffff;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__AUTO_FLUSH_MODE_MASK         = 0x20000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__AUTO_FLUSH_PADDING_DIS_MASK  = 0x10000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__DOUBLE_BUFFER_MASK           = 0x00000020;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__DRAW_EVENT_EN_MASK           = 0x80000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__GL1X_PREFETCH_PAGE_MASK      = 0x07800000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__GL1_PERF_EN_MASK             = 0x00000008;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__HIWATER_MASK                 = 0x000001c0;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__INTERRUPT_EN_MASK            = 0x00000010;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__LOWATER_OFFSET_MASK          = 0x00700000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__MODE_MASK                    = 0x00000003;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__NCP_REG_TOKEN_EN_MASK        = 0x40000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_AT_HWM_MASK              = 0x00000600;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SPI_STALL_EN_MASK            = 0x00000800;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SQ_STALL_EN_MASK             = 0x00001000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__STALL_ALL_SIMDS_MASK         = 0x00002000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_DRAWS_MASK        = 0x00080000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_MARKERS_MASK      = 0x00040000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__UTIL_TIMER_MASK              = 0x00004000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__WAVESTART_MODE_MASK          = 0x00018000;
constexpr unsigned int SQ_THREAD_TRACE_DROPPED_CNTR__CNTR_MASK            = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_GFX_DRAW_CNTR__CNTR_MASK           = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_GFX_MARKER_CNTR__CNTR_MASK         = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_HALT__CGCG_READY_MASK              = 0x00000002;
constexpr unsigned int SQ_THREAD_TRACE_HALT__ENTER_CGCG_MASK              = 0x00000001;
constexpr unsigned int SQ_THREAD_TRACE_HALT__ENTER_POWEROFF_MASK          = 0x00000004;
constexpr unsigned int SQ_THREAD_TRACE_HALT__POWEROFF_READY_MASK          = 0x00000008;
constexpr unsigned int SQ_THREAD_TRACE_HP3D_DRAW_CNTR__CNTR_MASK          = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_HP3D_MARKER_CNTR__CNTR_MASK        = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_ALLOC_MASK = 0x00080000;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_SHADERDATA_MASK = 0x00020000;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_WAVESTART_EXT_MASK = 0x00040000;
constexpr unsigned int SQ_THREAD_TRACE_MASK__SA_SEL_MASK                  = 0x00000200;
constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_SEL_MASK                = 0x00000003;
constexpr unsigned int SQ_THREAD_TRACE_MASK__WGP_SEL_MASK                 = 0x000000f0;
constexpr unsigned int SQ_THREAD_TRACE_MASK__WTYPE_INCLUDE_MASK           = 0x0001fc00;
constexpr unsigned int SQ_THREAD_TRACE_POWEROFF_RESTORE_1__STATES_MASK    = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF0_FULL_MASK            = 0x00000001;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF1_FULL_MASK            = 0x00000002;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF_ISSUE_MASK            = 0x00002000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF_ISSUE_STATUS_MASK     = 0x00001f00;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__PACKET_LOST_BUF_NO_LOCKDOWN_MASK = 0x00000010;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__WRITE_BUF_FULL_MASK       = 0x00004000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY_MASK                  = 0x02000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE_MASK           = 0x00fff000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING_MASK        = 0x00000fff;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__OWNER_VMID_MASK            = 0xf0000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__WRITE_ERROR_MASK           = 0x01000000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__BOP_EVENTS_TOKEN_INCLUDE_MASK = 0x00002000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__EXCLUDE_BARRIER_WAIT_MASK = 0x00004000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__INST_EXCLUDE_MASK      = 0x03000000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DETAIL_ALL_MASK    = 0x80000000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_EXCLUDE_MASK       = 0x1c000000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_INCLUDE_MASK       = 0x00ff0000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_EXCLUDE_MASK     = 0x00000fff;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TTRACE_EXEC_MASK       = 0x00001000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_0__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_1__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_2__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_3__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_4__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_5__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_6__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_7__DATA_MASK              = 0xffffffff;
constexpr unsigned int SQ_THREAD_TRACE_WPTR__BUFFER_ID_MASK               = 0x80000000;
constexpr unsigned int SQ_THREAD_TRACE_WPTR__OFFSET_MASK                  = 0x1fffffff;
constexpr unsigned int SQ_WATCH0_ADDR_H__ADDR_MASK                        = 0x0000ffff;
constexpr unsigned int SQ_WATCH0_ADDR_L__ADDR_MASK                        = 0xffffffc0;
constexpr unsigned int SQ_WATCH0_CNTL__MASK_MASK                          = 0x00ffffff;
constexpr unsigned int SQ_WATCH0_CNTL__VALID_MASK                         = 0x80000000;
constexpr unsigned int SQ_WATCH0_CNTL__VMID_MASK                          = 0x0f000000;
constexpr unsigned int SQ_WATCH1_ADDR_H__ADDR_MASK                        = 0x0000ffff;
constexpr unsigned int SQ_WATCH1_ADDR_L__ADDR_MASK                        = 0xffffffc0;
constexpr unsigned int SQ_WATCH1_CNTL__MASK_MASK                          = 0x00ffffff;
constexpr unsigned int SQ_WATCH1_CNTL__VALID_MASK                         = 0x80000000;
constexpr unsigned int SQ_WATCH1_CNTL__VMID_MASK                          = 0x0f000000;
constexpr unsigned int SQ_WATCH2_ADDR_H__ADDR_MASK                        = 0x0000ffff;
constexpr unsigned int SQ_WATCH2_ADDR_L__ADDR_MASK                        = 0xffffffc0;
constexpr unsigned int SQ_WATCH2_CNTL__MASK_MASK                          = 0x00ffffff;
constexpr unsigned int SQ_WATCH2_CNTL__VALID_MASK                         = 0x80000000;
constexpr unsigned int SQ_WATCH2_CNTL__VMID_MASK                          = 0x0f000000;
constexpr unsigned int SQ_WATCH3_ADDR_H__ADDR_MASK                        = 0x0000ffff;
constexpr unsigned int SQ_WATCH3_ADDR_L__ADDR_MASK                        = 0xffffffc0;
constexpr unsigned int SQ_WATCH3_CNTL__MASK_MASK                          = 0x00ffffff;
constexpr unsigned int SQ_WATCH3_CNTL__VALID_MASK                         = 0x80000000;
constexpr unsigned int SQ_WATCH3_CNTL__VMID_MASK                          = 0x0f000000;
constexpr unsigned int SQ_WAVE_ACTIVE__WAVE_SLOT_MASK                     = 0x000fffff;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT4_MASK              = 0x0000007f;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT5_MASK              = 0x00007f00;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT6_MASK              = 0x007f0000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT7_MASK              = 0x7f000000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT0_MASK              = 0x0000007f;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT1_MASK              = 0x00007f00;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT2_MASK              = 0x007f0000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT3_MASK              = 0x7f000000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__ADDR_WATCH_MASK            = 0x0000000f;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__FIRST_MEMVIOL_SOURCE_MASK  = 0xc0000000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__HOST_TRAP_MASK             = 0x00000080;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__ILLEGAL_INST_MASK          = 0x00000040;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__MEMVIOL_MASK               = 0x00000010;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__PERF_SNAPSHOT_MASK         = 0x00000400;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__SAVE_CONTEXT_MASK          = 0x00000020;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__TRAP_AFTER_INST_MASK       = 0x00000800;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__WAVE_END_MASK              = 0x00000200;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__WAVE_START_MASK            = 0x00000100;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__XNACK_ERROR_MASK           = 0x00001000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_FLOAT_DIV0_MASK        = 0x00000004;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INEXACT_MASK           = 0x00000020;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INPUT_DENORM_MASK      = 0x00000002;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INT_DIV0_MASK          = 0x00000040;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INVALID_MASK           = 0x00000001;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_OVERFLOW_MASK          = 0x00000008;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_UNDERFLOW_MASK         = 0x00000010;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__BUFFER_OOB_MASK            = 0x40000000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__LOD_CLAMPED_MASK           = 0x80000000;
constexpr unsigned int SQ_WAVE_EXEC_HI__EXEC_HI_MASK                      = 0xffffffff;
constexpr unsigned int SQ_WAVE_EXEC_LO__EXEC_LO_MASK                      = 0xffffffff;
constexpr unsigned int SQ_WAVE_FLUSH_IB__UNUSED_MASK                      = 0xffffffff;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_BASE_MASK                  = 0x000001ff;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_SIZE_MASK                  = 0x000ff000;
constexpr unsigned int SQ_WAVE_HW_ID1__DP_RATE_MASK                       = 0xe0000000;
constexpr unsigned int SQ_WAVE_HW_ID1__SA_ID_MASK                         = 0x00010000;
constexpr unsigned int SQ_WAVE_HW_ID1__SE_ID_MASK                         = 0x001c0000;
constexpr unsigned int SQ_WAVE_HW_ID1__SIMD_ID_MASK                       = 0x00000300;
constexpr unsigned int SQ_WAVE_HW_ID1__WAVE_ID_MASK                       = 0x0000001f;
constexpr unsigned int SQ_WAVE_HW_ID1__WGP_ID_MASK                        = 0x00003c00;
constexpr unsigned int SQ_WAVE_HW_ID2__ME_ID_MASK                         = 0x00000300;
constexpr unsigned int SQ_WAVE_HW_ID2__PIPE_ID_MASK                       = 0x00000030;
constexpr unsigned int SQ_WAVE_HW_ID2__QUEUE_ID_MASK                      = 0x0000000f;
constexpr unsigned int SQ_WAVE_HW_ID2__STATE_ID_MASK                      = 0x00007000;
constexpr unsigned int SQ_WAVE_HW_ID2__VM_ID_MASK                         = 0x0f000000;
constexpr unsigned int SQ_WAVE_HW_ID2__WG_ID_MASK                         = 0x001f0000;
constexpr unsigned int SQ_WAVE_IB_STS2__FWD_PROGRESS_MASK                 = 0x40000000;
constexpr unsigned int SQ_WAVE_IB_STS2__INST_PREFETCH_MASK                = 0x30000000;
constexpr unsigned int SQ_WAVE_IB_STS2__KM_CNT_MASK                       = 0x0000001f;
constexpr unsigned int SQ_WAVE_IB_STS2__TTRACE_EN_SPI_MASK                = 0x80000000;
constexpr unsigned int SQ_WAVE_IB_STS__BVH_CNT_MASK                       = 0x00e00000;
constexpr unsigned int SQ_WAVE_IB_STS__DS_CNT_MASK                        = 0x000001f8;
constexpr unsigned int SQ_WAVE_IB_STS__EXP_CNT_MASK                       = 0x00000007;
constexpr unsigned int SQ_WAVE_IB_STS__LOAD_CNT_MASK                      = 0x00007e00;
constexpr unsigned int SQ_WAVE_IB_STS__SAMPLE_CNT_MASK                    = 0x001f8000;
constexpr unsigned int SQ_WAVE_IB_STS__STORE_CNT_MASK                     = 0x3f000000;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_BASE_MASK                   = 0x000000ff;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_SIZE_MASK                   = 0x001ff000;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__VGPR_SHARED_SIZE_MASK           = 0x0f000000;
constexpr unsigned int SQ_WAVE_M0__M0_MASK                                = 0xffffffff;
constexpr unsigned int SQ_WAVE_MODE__DISABLE_PERF_MASK                    = 0x08000000;
constexpr unsigned int SQ_WAVE_MODE__FP16_OVFL_MASK                       = 0x00800000;
constexpr unsigned int SQ_WAVE_MODE__FP_DENORM_MASK                       = 0x000000f0;
constexpr unsigned int SQ_WAVE_MODE__FP_ROUND_MASK                        = 0x0000000f;
constexpr unsigned int SQ_WAVE_MODE__SCALAR_PREFETCH_EN_MASK              = 0x01000000;
constexpr unsigned int SQ_WAVE_PC_HI__PC_HI_MASK                          = 0x0000ffff;
constexpr unsigned int SQ_WAVE_PC_LO__PC_LO_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_SCHED_MODE__DEP_MODE_MASK                  = 0x00000003;
constexpr unsigned int SQ_WAVE_SCRATCH_BASE_HI__DATA_MASK                 = 0xffffffff;
constexpr unsigned int SQ_WAVE_SCRATCH_BASE_LO__DATA_MASK                 = 0xffffffff;
constexpr unsigned int SQ_WAVE_STATE_PRIV__BARRIER_COMPLETE_MASK          = 0x00000004;
constexpr unsigned int SQ_WAVE_STATE_PRIV__COND_DBG_SYS_MASK              = 0x00020000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__COND_DBG_USER_MASK             = 0x00010000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__HALT_MASK                      = 0x00004000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__NAMED_BARRIER_COMPLETE_MASK    = 0x00000008;
constexpr unsigned int SQ_WAVE_STATE_PRIV__NAMED_BARRIER_ID_MASK          = 0x000001f0;
constexpr unsigned int SQ_WAVE_STATE_PRIV__PERF_EN_MASK                   = 0x00080000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__POISON_ERR_MASK                = 0x00008000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SCC_MASK                       = 0x00000200;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SCRATCH_EN_MASK                = 0x00040000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SLEEP_WAKEUP_MASK              = 0x00000002;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SYS_PRIO_MASK                  = 0x00000c00;
constexpr unsigned int SQ_WAVE_STATE_PRIV__TTRACE_EN_MASK                 = 0x00100000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__USER_PRIO_MASK                 = 0x00003000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__WG_RR_EN_MASK                  = 0x00000001;
constexpr unsigned int SQ_WAVE_STATUS__DVGPR_EN_MASK                      = 0x40000000;
constexpr unsigned int SQ_WAVE_STATUS__EXECZ_MASK                         = 0x00000200;
constexpr unsigned int SQ_WAVE_STATUS__EXPORT_RDY_MASK                    = 0x00000100;
constexpr unsigned int SQ_WAVE_STATUS__FATAL_HALT_MASK                    = 0x00800000;
constexpr unsigned int SQ_WAVE_STATUS__IDLE_MASK                          = 0x10000000;
constexpr unsigned int SQ_WAVE_STATUS__IN_WG_MASK                         = 0x00000800;
constexpr unsigned int SQ_WAVE_STATUS__LDS_PARAM_READY_MASK               = 0x02000000;
constexpr unsigned int SQ_WAVE_STATUS__MUST_EXPORT_MASK                   = 0x08000000;
constexpr unsigned int SQ_WAVE_STATUS__MUST_GS_ALLOC_MASK                 = 0x04000000;
constexpr unsigned int SQ_WAVE_STATUS__NO_VGPRS_MASK                      = 0x01000000;
constexpr unsigned int SQ_WAVE_STATUS__OREO_CONFLICT_MASK                 = 0x00400000;
constexpr unsigned int SQ_WAVE_STATUS__PRIV_MASK                          = 0x00000020;
constexpr unsigned int SQ_WAVE_STATUS__SKIP_EXPORT_MASK                   = 0x00040000;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_BARRIER_COMPLETE_MASK         = 0x00008000;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_EN_MASK                       = 0x00000040;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_MASK                          = 0x00004000;
constexpr unsigned int SQ_WAVE_STATUS__VALID_MASK                         = 0x00010000;
constexpr unsigned int SQ_WAVE_STATUS__VCCZ_MASK                          = 0x00000400;
constexpr unsigned int SQ_WAVE_STATUS__WAVE64_MASK                        = 0x20000000;
constexpr unsigned int SQ_WAVE_STATUS__WGP_TAKEOVER_MASK                  = 0x80000000;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ADDR_WATCH_MASK                 = 0x00000080;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_FLOAT_DIV0_MASK             = 0x00000004;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INEXACT_MASK                = 0x00000020;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INPUT_DENORM_MASK           = 0x00000002;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INT_DIV0_MASK               = 0x00000040;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INVALID_MASK                = 0x00000001;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_OVERFLOW_MASK               = 0x00000008;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_UNDERFLOW_MASK              = 0x00000010;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__TRAP_AFTER_INST_MASK            = 0x00000200;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__WAVE_END_MASK                   = 0x00000100;
constexpr unsigned int SQ_WAVE_TTMP0__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP1__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP2__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP3__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP4__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP5__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP6__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP7__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP8__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP9__DATA_MASK                           = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP10__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP11__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP12__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP13__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP14__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_TTMP15__DATA_MASK                          = 0xffffffff;
constexpr unsigned int SQ_WAVE_VALID_AND_IDLE__WAVE_SLOT_MASK             = 0x000fffff;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_ALPHA_OPT_DISABLE_MASK  = 0x00000002;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_COLOR_OPT_DISABLE_MASK  = 0x00000001;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_ALPHA_OPT_DISABLE_MASK  = 0x00000020;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_COLOR_OPT_DISABLE_MASK  = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_ALPHA_OPT_DISABLE_MASK  = 0x00000200;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_COLOR_OPT_DISABLE_MASK  = 0x00000100;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_ALPHA_OPT_DISABLE_MASK  = 0x00002000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_COLOR_OPT_DISABLE_MASK  = 0x00001000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_ALPHA_OPT_DISABLE_MASK  = 0x00020000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_COLOR_OPT_DISABLE_MASK  = 0x00010000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_ALPHA_OPT_DISABLE_MASK  = 0x00200000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_COLOR_OPT_DISABLE_MASK  = 0x00100000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_ALPHA_OPT_DISABLE_MASK  = 0x02000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_COLOR_OPT_DISABLE_MASK  = 0x01000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_ALPHA_OPT_DISABLE_MASK  = 0x20000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_COLOR_OPT_DISABLE_MASK  = 0x10000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__PIXEN_ZERO_OPT_DISABLE_MASK  = 0x80000000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT0_EPSILON_MASK            = 0x0000000f;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT1_EPSILON_MASK            = 0x000000f0;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT2_EPSILON_MASK            = 0x00000f00;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT3_EPSILON_MASK            = 0x0000f000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT4_EPSILON_MASK            = 0x000f0000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT5_EPSILON_MASK            = 0x00f00000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT6_EPSILON_MASK            = 0x0f000000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT7_EPSILON_MASK            = 0xf0000000;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_COMB_FCN_MASK             = 0x07000000;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_DST_OPT_MASK              = 0x00700000;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_SRC_OPT_MASK              = 0x00070000;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_COMB_FCN_MASK             = 0x00000700;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_DST_OPT_MASK              = 0x00000070;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_SRC_OPT_MASK              = 0x00000007;
constexpr unsigned int SX_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT0_FMT_MAPPING_DISABLE_MASK = 0x00000001;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT1_FMT_MAPPING_DISABLE_MASK = 0x00000002;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT2_FMT_MAPPING_DISABLE_MASK = 0x00000004;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT3_FMT_MAPPING_DISABLE_MASK = 0x00000008;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT4_FMT_MAPPING_DISABLE_MASK = 0x00000010;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT5_FMT_MAPPING_DISABLE_MASK = 0x00000020;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT6_FMT_MAPPING_DISABLE_MASK = 0x00000040;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT7_FMT_MAPPING_DISABLE_MASK = 0x00000080;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT0_MASK                       = 0x0000000f;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT1_MASK                       = 0x000000f0;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT2_MASK                       = 0x00000f00;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT3_MASK                       = 0x0000f000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT4_MASK                       = 0x000f0000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT5_MASK                       = 0x00f00000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT6_MASK                       = 0x0f000000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT7_MASK                       = 0xf0000000;
constexpr unsigned int TA_BC_BASE_ADDR_HI__ADDRESS_MASK                   = 0x000000ff;
constexpr unsigned int TA_BC_BASE_ADDR__ADDRESS_MASK                      = 0xffffffff;
constexpr unsigned int TA_CNTL2__ELEMSIZE_HASH_DIS_MASK                   = 0x00020000;
constexpr unsigned int TA_CNTL2__ELIMINATE_UNLIT_QUAD_DIS_MASK            = 0x00080000;
constexpr unsigned int TA_CNTL2__MAX_RQ_ID_MASK                           = 0x00000070;
constexpr unsigned int TA_CNTL2__PRTPLUS_ACCUM_MODE_MASK                  = 0x00300000;
constexpr unsigned int TA_CNTL2__STORE_COMPONENT_MODE_MASK                = 0x00000001;
constexpr unsigned int TA_CNTL2__TRUNCATE_COORD_MODE_MASK                 = 0x00040000;
constexpr unsigned int TA_CNTL_AUX__ANISO_ERROR_FP_VBIAS_MASK             = 0x00001000;
constexpr unsigned int TA_CNTL_AUX__ANISO_HALF_THRESH_MASK                = 0x00000c00;
constexpr unsigned int TA_CNTL_AUX__ANISO_MAG_STEP_CLAMP_MASK             = 0x00000100;
constexpr unsigned int TA_CNTL_AUX__ANISO_RATIO_LUT_MASK                  = 0x00020000;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_MASK                       = 0x00004000;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_ORDER_MASK                 = 0x00002000;
constexpr unsigned int TA_CNTL_AUX__ANISO_TAP_MASK                        = 0x00040000;
constexpr unsigned int TA_CNTL_AUX__ANISO_WEIGHT_MODE_MASK                = 0x00010000;
constexpr unsigned int TA_CNTL_AUX__ARRAY_ROUND_MODE_MASK                 = 0xc0000000;
constexpr unsigned int TA_CNTL_AUX__AUTO_ALIGN_FORMAT_MASK                = 0x00000200;
constexpr unsigned int TA_CNTL_AUX__CORNER_SAMPLES_MIN_DIM_MASK           = 0x00000004;
constexpr unsigned int TA_CNTL_AUX__CUBEMAP_SLICE_CLAMP_MASK              = 0x10000000;
constexpr unsigned int TA_CNTL_AUX__DEPTH_AS_PITCH_DIS_MASK               = 0x00000002;
constexpr unsigned int TA_CNTL_AUX__DERIV_ADJUST_DIS_MASK                 = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_DFMT_NFMT_DISABLE_MASK    = 0x04000000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_MISC_DISABLE_MASK         = 0x00400000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_OPCODE_STRICT_DISABLE_MASK = 0x00200000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_RESERVED_DISABLE_MASK     = 0x00100000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLER_MSAA_DISABLE_MASK = 0x01000000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLE_C_DFMT_DISABLE_MASK = 0x00800000;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_WRITEOP_READFMT_DISABLE_MASK = 0x02000000;
constexpr unsigned int TA_CNTL_AUX__DISABLE_GATHER4_BC_SWIZZLE_MASK       = 0x00000080;
constexpr unsigned int TA_CNTL_AUX__GATHERH_DST_SEL_MASK                  = 0x00000040;
constexpr unsigned int TA_CNTL_AUX__MINMAG_UNNORM_MASK                    = 0x00008000;
constexpr unsigned int TA_CNTL_AUX__OVERRIDE_QUAD_MODE_DIS_MASK           = 0x00000008;
constexpr unsigned int TA_CNTL_AUX__SCOAL_DSWIZZLE_N_MASK                 = 0x00000001;
constexpr unsigned int TA_CNTL_AUX__TFAULT_EN_OVERRIDE_MASK               = 0x00000020;
constexpr unsigned int TA_CNTL_AUX__TRUNC_SMALL_NEG_MASK                  = 0x20000000;
constexpr unsigned int TA_CNTL__ALIGNER_CREDIT_MASK                       = 0x001f0000;
constexpr unsigned int TA_CNTL__TA_INPUT_CFIFO_VEC64_OPT_OVERRIDE_MASK    = 0x00000008;
constexpr unsigned int TA_CNTL__TA_INPUT_RDATA_PER_BANK_FGCG_OVERRIDE_MASK = 0x00000004;
constexpr unsigned int TA_CNTL__TA_SQ_XNACK_FGCG_DISABLE_MASK             = 0x00000001;
constexpr unsigned int TA_CNTL__TD_FIFO_CREDIT_MASK                       = 0xffc00000;
constexpr unsigned int TA_CS_BC_BASE_ADDR_HI__ADDRESS_MASK                = 0x000000ff;
constexpr unsigned int TA_CS_BC_BASE_ADDR__ADDRESS_MASK                   = 0xffffffff;
constexpr unsigned int TA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int TA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int TA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int TA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int TA_SCRATCH__SCRATCH_MASK                           = 0xffffffff;
constexpr unsigned int TA_STATUS__AL_BUSY_MASK                            = 0x40000000;
constexpr unsigned int TA_STATUS__BUSY_MASK                               = 0x80000000;
constexpr unsigned int TA_STATUS__FA_BUSY_MASK                            = 0x20000000;
constexpr unsigned int TA_STATUS__FA_LFIFO_EMPTYB_MASK                    = 0x00200000;
constexpr unsigned int TA_STATUS__FA_PFIFO_EMPTYB_MASK                    = 0x00100000;
constexpr unsigned int TA_STATUS__FA_SFIFO_EMPTYB_MASK                    = 0x00400000;
constexpr unsigned int TA_STATUS__FG_BUSY_MASK                            = 0x02000000;
constexpr unsigned int TA_STATUS__FG_LFIFO_EMPTYB_MASK                    = 0x00002000;
constexpr unsigned int TA_STATUS__FG_PFIFO_EMPTYB_MASK                    = 0x00001000;
constexpr unsigned int TA_STATUS__FG_SFIFO_EMPTYB_MASK                    = 0x00004000;
constexpr unsigned int TA_STATUS__FL_BUSY_MASK                            = 0x08000000;
constexpr unsigned int TA_STATUS__FL_LFIFO_EMPTYB_MASK                    = 0x00020000;
constexpr unsigned int TA_STATUS__FL_PFIFO_EMPTYB_MASK                    = 0x00010000;
constexpr unsigned int TA_STATUS__FL_SFIFO_EMPTYB_MASK                    = 0x00040000;
constexpr unsigned int TA_STATUS__IN_BUSY_MASK                            = 0x01000000;
constexpr unsigned int TA_STATUS__LA_BUSY_MASK                            = 0x04000000;
constexpr unsigned int TA_STATUS__TA_BUSY_MASK                            = 0x10000000;
constexpr unsigned int TCP_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK          = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK          = 0x0f000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0x00f00000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE1_MASK           = 0x0f000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_MODE_MASK            = 0xf0000000;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int TCP_PERFCOUNTER_FILTER2__REQ_MODE_MASK             = 0x00000007;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__BUFFER_MASK             = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE_MASK = 0x00000800;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DATA_FORMAT_MASK        = 0x00000008;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DIM_MASK                = 0x00000004;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__FLAT_MASK               = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_FORMAT_MASK         = 0x00000010;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_SAMPLES_MASK        = 0x00000040;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__OPCODE_TYPE_MASK        = 0x00000080;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__REQ_MODE_MASK           = 0x00001000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SCOPE_MASK              = 0x00002000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SW_MODE_MASK            = 0x00000020;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__TMPRL_MASK              = 0x00000100;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__BUFFER_MASK                = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE_MASK    = 0x00001000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT_MASK           = 0x00000fe0;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DIM_MASK                   = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__FLAT_MASK                  = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT_MASK            = 0x0001e000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES_MASK           = 0x00c00000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE_MASK           = 0x07000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__SCOPE_MASK                 = 0xc0000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE_MASK               = 0x003e0000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__TMPRL_MASK                 = 0x38000000;
constexpr unsigned int TD_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int TD_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK           = 0xf0000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK           = 0x0f000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK            = 0x000003ff;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK            = 0x000ffc00;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE1_MASK            = 0x0f000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1_MASK             = 0x000ffc00;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int TD_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK            = 0xffffffff;
constexpr unsigned int TD_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK            = 0xffffffff;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__CNTR_MODE_MASK             = 0x00f00000;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE_MASK             = 0xf0000000;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL_MASK              = 0x000003ff;
constexpr unsigned int UTCL1_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__COUNTER_MODE_MASK       = 0xf0000000;
constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int UTCL1_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__COUNTER_MODE_MASK       = 0xf0000000;
constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int UTCL1_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER2_SELECT__COUNTER_MODE_MASK       = 0xf0000000;
constexpr unsigned int UTCL1_PERFCOUNTER2_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int UTCL1_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK         = 0xffffffff;
constexpr unsigned int UTCL1_PERFCOUNTER3_SELECT__COUNTER_MODE_MASK       = 0xf0000000;
constexpr unsigned int UTCL1_PERFCOUNTER3_SELECT__PERF_SEL_MASK           = 0x000003ff;
constexpr unsigned int VGT_DMA_BASE_HI__BASE_ADDR_MASK                    = 0x0000ffff;
constexpr unsigned int VGT_DMA_BASE__BASE_ADDR_MASK                       = 0xffffffff;
constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH_MASK  = 0x000003ff;
constexpr unsigned int VGT_DMA_INDEX_TYPE__DISABLE_INSTANCE_PACKING_MASK  = 0x00004000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__INDEX_TYPE_MASK                = 0x00000003;
constexpr unsigned int VGT_DMA_INDEX_TYPE__MTYPE_MASK                     = 0x00003800;
constexpr unsigned int VGT_DMA_INDEX_TYPE__NOT_EOP_MASK                   = 0x00000200;
constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY_MASK              = 0x000000c0;
constexpr unsigned int VGT_DMA_INDEX_TYPE__SPEC_DATA_READ_MASK            = 0x00060000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__TEMPORAL_MASK                  = 0x00018000;
constexpr unsigned int VGT_DMA_MAX_SIZE__MAX_SIZE_MASK                    = 0xffffffff;
constexpr unsigned int VGT_DMA_NUM_INSTANCES__NUM_INSTANCES_MASK          = 0xffffffff;
constexpr unsigned int VGT_DMA_REQ_FIFO_DEPTH__DMA_REQ_FIFO_DEPTH_MASK    = 0x0000003f;
constexpr unsigned int VGT_DMA_SIZE__NUM_INDICES_MASK                     = 0xffffffff;
constexpr unsigned int VGT_DRAW_INITIATOR__NOT_EOP_MASK                   = 0x00000020;
constexpr unsigned int VGT_DRAW_INITIATOR__REG_RT_INDEX_MASK              = 0xe0000000;
constexpr unsigned int VGT_DRAW_INITIATOR__SOURCE_SELECT_MASK             = 0x00000003;
constexpr unsigned int VGT_DRAW_INITIATOR__USE_OPAQUE_MASK                = 0x00000040;
constexpr unsigned int VGT_DRAW_INIT_FIFO_DEPTH__DRAW_INIT_FIFO_DEPTH_MASK = 0x0000003f;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_DRAW_VP_MASK             = 0x00000010;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_PRIM_PAYLOAD_MASK        = 0x00000008;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_REG_RT_INDEX_MASK        = 0x00000002;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_VRS_RATE_MASK            = 0x00000040;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__UNUSED_MASK                 = 0x00000020;
constexpr unsigned int VGT_EVENT_ADDRESS_REG__ADDRESS_LOW_MASK            = 0x0fffffff;
constexpr unsigned int VGT_EVENT_INITIATOR__ADDRESS_HI_MASK               = 0x07fffc00;
constexpr unsigned int VGT_EVENT_INITIATOR__EVENT_TYPE_MASK               = 0x0000003f;
constexpr unsigned int VGT_EVENT_INITIATOR__EXTENDED_EVENT_MASK           = 0x08000000;
constexpr unsigned int VGT_GS_INSTANCE_CNT__CNT_MASK                      = 0x000000fc;
constexpr unsigned int VGT_GS_INSTANCE_CNT__ENABLE_MASK                   = 0x00000001;
constexpr unsigned int VGT_GS_INSTANCE_CNT__EN_MAX_VERT_OUT_PER_GS_INSTANCE_MASK = 0x80000000;
constexpr unsigned int VGT_GS_MAX_VERT_OUT__MAX_VERT_OUT_MASK             = 0x000007ff;
constexpr unsigned int VGT_GS_MAX_WAVE_ID__MAX_WAVE_ID_MASK               = 0x00000fff;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_MASK            = 0x0000003f;
constexpr unsigned int VGT_HOS_MAX_TESS_LEVEL__MAX_TESS_MASK              = 0xffffffff;
constexpr unsigned int VGT_HOS_MIN_TESS_LEVEL__MIN_TESS_MASK              = 0xffffffff;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING_MASK       = 0x000003ff;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY_MASK     = 0x00000c00;
constexpr unsigned int VGT_INDEX_TYPE__DISABLE_INSTANCE_PACKING_MASK      = 0x00004000;
constexpr unsigned int VGT_INDEX_TYPE__INDEX_TYPE_MASK                    = 0x00000003;
constexpr unsigned int VGT_INSTANCE_BASE_ID__INSTANCE_BASE_ID_MASK        = 0xffffffff;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_OUTPUT_CP_MASK            = 0x000fc000;
constexpr unsigned int VGT_LS_HS_CONFIG__NUM_PATCHES_MASK                 = 0x000000ff;
constexpr unsigned int VGT_MC_LAT_CNTL__MC_TIME_STAMP_RES_MASK            = 0x0000000f;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_INDX__RESET_INDX_MASK      = 0xffffffff;
constexpr unsigned int VGT_NUM_INDICES__NUM_INDICES_MASK                  = 0xffffffff;
constexpr unsigned int VGT_NUM_INSTANCES__NUM_INSTANCES_MASK              = 0xffffffff;
constexpr unsigned int VGT_PRIMITIVEID_EN__NGG_DISABLE_PROVOK_REUSE_MASK  = 0x00000004;
constexpr unsigned int VGT_PRIMITIVEID_RESET__VALUE_MASK                  = 0xffffffff;
constexpr unsigned int VGT_PRIMITIVE_TYPE__NUM_INPUT_CP_MASK              = 0x00000fc0;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIMS_PER_SUBGROUP_MASK        = 0x001ff000;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIM_TYPE_MASK                 = 0x0000003f;
constexpr unsigned int VGT_REUSE_OFF__REUSE_OFF_MASK                      = 0x00000001;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_EN_MASK                   = 0x00000020;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH_MASK          = 0x00080000;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_W32_EN_MASK               = 0x00400000;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_EN_MASK                   = 0x00000004;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_W32_EN_MASK               = 0x00200000;
constexpr unsigned int VGT_SHADER_STAGES_EN__NGG_WAVE_ID_EN_MASK          = 0x01000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_PASSTHRU_NO_MSG_MASK = 0x04000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE__SIZE_MASK = 0xffffffff;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_OFFSET__OFFSET_MASK        = 0xffffffff;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE__VERTEX_STRIDE_MASK = 0x000001ff;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_ISOLINE_MASK          = 0x000000ff;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_QUAD_MASK             = 0x00ff0000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_TRI_MASK              = 0x0000ff00;
constexpr unsigned int VGT_TESS_DISTRIBUTION__DONUT_SPLIT_MASK            = 0x1f000000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__TRAP_SPLIT_MASK             = 0xe0000000;
constexpr unsigned int VGT_TF_MEMORY_BASE_HI__BASE_HI_MASK                = 0x000000ff;
constexpr unsigned int VGT_TF_MEMORY_BASE__BASE_MASK                      = 0xffffffff;
constexpr unsigned int VGT_TF_PARAM__DETECT_ONE_MASK                      = 0x00080000;
constexpr unsigned int VGT_TF_PARAM__DETECT_ZERO_MASK                     = 0x00100000;
constexpr unsigned int VGT_TF_PARAM__DISABLE_DONUTS_MASK                  = 0x00004000;
constexpr unsigned int VGT_TF_PARAM__DISTRIBUTION_MODE_MASK               = 0x00060000;
constexpr unsigned int VGT_TF_PARAM__MTYPE_MASK                           = 0x03800000;
constexpr unsigned int VGT_TF_PARAM__PARTITIONING_MASK                    = 0x0000001c;
constexpr unsigned int VGT_TF_PARAM__SPEC_DATA_READ_MASK                  = 0x30000000;
constexpr unsigned int VGT_TF_PARAM__TEMPORAL_MASK                        = 0x00018000;
constexpr unsigned int VGT_TF_PARAM__TOPOLOGY_MASK                        = 0x000000e0;
constexpr unsigned int VGT_TF_PARAM__TYPE_MASK                            = 0x00000003;
constexpr unsigned int VGT_TF_RING_SIZE__SIZE_MASK                        = 0x0001ffff;
constexpr unsigned int WD_UTCL1_CNTL__BYPASS_MASK                         = 0x02000000;
constexpr unsigned int WD_UTCL1_CNTL__DROP_MODE_MASK                      = 0x01000000;
constexpr unsigned int WD_UTCL1_CNTL__FORCE_SNOOP_MASK                    = 0x10000000;
constexpr unsigned int WD_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK                = 0x08000000;
constexpr unsigned int WD_UTCL1_CNTL__INVALIDATE_MASK                     = 0x04000000;
constexpr unsigned int WD_UTCL1_CNTL__LLC_NOALLOC_OVERRIDE_MASK           = 0x40000000;
constexpr unsigned int WD_UTCL1_CNTL__MTYPE_OVERRIDE_MASK                 = 0x20000000;
constexpr unsigned int WD_UTCL1_CNTL__VMID_RESET_MODE_MASK                = 0x00800000;
constexpr unsigned int WD_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK           = 0x000fffff;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_DETECTED_MASK               = 0x00000001;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_INSTANCEID_MASK             = 0x0000c000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_UTCL1ID_MASK                = 0x00003f00;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_VMID_MASK                   = 0x000000f0;
constexpr unsigned int WD_UTCL1_STATUS__PRT_DETECTED_MASK                 = 0x00000004;
constexpr unsigned int WD_UTCL1_STATUS__PRT_INSTANCEID_MASK               = 0xc0000000;
constexpr unsigned int WD_UTCL1_STATUS__PRT_UTCL1ID_MASK                  = 0x3f000000;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_DETECTED_MASK               = 0x00000002;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_INSTANCEID_MASK             = 0x00c00000;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_UTCL1ID_MASK                = 0x003f0000;
constexpr unsigned int WGS_BUSY_HYSTERESIS__CAC_ACTIVE_MASK               = 0x000000ff;
constexpr unsigned int WGS_BUSY_HYSTERESIS__CPC_BUSY_MASK                 = 0x0000ff00;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE0_DC_BUSY_MASK            = 0x00040000;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE1_DC_BUSY_MASK            = 0x00080000;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE2_DC_BUSY_MASK            = 0x00100000;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE3_DC_BUSY_MASK            = 0x00200000;
constexpr unsigned int WGS_BUSY_STAT2__MES_DMA_BUSY_MASK                  = 0x00000100;
constexpr unsigned int WGS_BUSY_STAT2__MES_LOAD_BUSY_MASK                 = 0x00000001;
constexpr unsigned int WGS_BUSY_STAT2__MES_MESSAGE_BUSY_MASK              = 0x00000008;
constexpr unsigned int WGS_BUSY_STAT2__MES_MUTEX_BUSY_MASK                = 0x00000004;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE0_BUSY_MASK                = 0x00000400;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE1_BUSY_MASK                = 0x00000800;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE2_BUSY_MASK                = 0x00001000;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE3_BUSY_MASK                = 0x00002000;
constexpr unsigned int WGS_BUSY_STAT2__MES_TC_BUSY_MASK                   = 0x00000080;
constexpr unsigned int WGS_BUSY_STAT__MEC1_DMA_BUSY_MASK                  = 0x00000100;
constexpr unsigned int WGS_BUSY_STAT__MEC1_EOP_QUEUE_BUSY_MASK            = 0x00000010;
constexpr unsigned int WGS_BUSY_STAT__MEC1_IB_QUEUE_BUSY_MASK             = 0x00000040;
constexpr unsigned int WGS_BUSY_STAT__MEC1_IQ_QUEUE_BUSY_MASK             = 0x00000020;
constexpr unsigned int WGS_BUSY_STAT__MEC1_LOAD_BUSY_MASK                 = 0x00000001;
constexpr unsigned int WGS_BUSY_STAT__MEC1_MESSAGE_BUSY_MASK              = 0x00000008;
constexpr unsigned int WGS_BUSY_STAT__MEC1_MUTEX_BUSY_MASK                = 0x00000004;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PARTIAL_FLUSH_BUSY_MASK        = 0x00000200;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE0_BUSY_MASK                = 0x00000400;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE1_BUSY_MASK                = 0x00000800;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE2_BUSY_MASK                = 0x00001000;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE3_BUSY_MASK                = 0x00002000;
constexpr unsigned int WGS_BUSY_STAT__MEC1_TC_BUSY_MASK                   = 0x00000080;
constexpr unsigned int WGS_BUSY_STAT__MEC2_DMA_BUSY_MASK                  = 0x01000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_EOP_QUEUE_BUSY_MASK            = 0x00100000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_IB_QUEUE_BUSY_MASK             = 0x00400000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_IQ_QUEUE_BUSY_MASK             = 0x00200000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_LOAD_BUSY_MASK                 = 0x00010000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_MESSAGE_BUSY_MASK              = 0x00080000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_MUTEX_BUSY_MASK                = 0x00040000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PARTIAL_FLUSH_BUSY_MASK        = 0x02000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE0_BUSY_MASK                = 0x04000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE1_BUSY_MASK                = 0x08000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE2_BUSY_MASK                = 0x10000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE3_BUSY_MASK                = 0x20000000;
constexpr unsigned int WGS_BUSY_STAT__MEC2_TC_BUSY_MASK                   = 0x00800000;
constexpr unsigned int WGS_COMPUTE_DDID_INDEX__INDEX_MASK                 = 0x000007ff;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE0__CU_EN_MASK         = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE1__CU_EN_MASK         = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE2__CU_EN_MASK         = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE3__CU_EN_MASK         = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DIM_X__SIZE_MASK                       = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DIM_Y__SIZE_MASK                       = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DIM_Z__SIZE_MASK                       = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_END__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_ID__DISPATCH_ID_MASK          = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__AMP_SHADER_EN_MASK = 0x00010000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN_MASK = 0x00000001;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__CS_W32_EN_MASK     = 0x00008000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__DISABLE_DISP_PREMPT_EN_MASK = 0x00020000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000_MASK = 0x00000004;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__INTERLEAVE_2D_EN_MASK = 0x00040000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL_MASK = 0x00000008;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE_MASK = 0x00000010;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDER_MODE_MASK    = 0x00000040;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN_MASK = 0x00000002;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__PING_PONG_EN_MASK  = 0x00001000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__RESTORE_MASK       = 0x00004000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL_MASK = 0x00000400;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__TTRACE_QUEUE_ID_MASK = 0xe0000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE_MASK = 0x00002000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS_MASK = 0x00000020;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL_MASK = 0x00000800;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__WGS_DISPATCH_MASK  = 0x00080000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_1D_MASK = 0x000003ff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_X_SIZE_MASK = 0x000f0000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_Y_SIZE_MASK = 0x0f000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_PKT_ADDR_HI__DATA_MASK        = 0x000000ff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_PKT_ADDR_LO__DATA_MASK        = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA_MASK    = 0x000000ff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA_MASK    = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_DISPATCH_TUNNEL__OFF_DELAY_MASK        = 0x00001fff;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__RESERVED4_MASK          = 0x00000010;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__SEND_SEID_MASK          = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__WAVE_ID_BASE_MASK       = 0x0001ffe0;
constexpr unsigned int WGS_COMPUTE_NOWHERE__DATA_MASK                     = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__INTERLEAVE_BITS_X_MASK   = 0x0000e000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL_MASK     = 0x00001fff;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL_MASK  = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__INTERLEAVE_BITS_Y_MASK   = 0x0000e000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL_MASK     = 0x00001fff;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL_MASK  = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL_MASK     = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL_MASK  = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE_MASK = 0x00000001;
constexpr unsigned int WGS_COMPUTE_PGM_HI__DATA_MASK                      = 0x000000ff;
constexpr unsigned int WGS_COMPUTE_PGM_LO__DATA_MASK                      = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__BULKY_MASK                  = 0x01000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__CDBG_USER_MASK              = 0x02000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__DEBUG_MODE_MASK             = 0x00400000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__DISABLE_PERF_MASK           = 0x00800000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FLOAT_MODE_MASK             = 0x000ff000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FP16_OVFL_MASK              = 0x04000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FWD_PROGRESS_MASK           = 0x80000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__PRIORITY_MASK               = 0x00000c00;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__PRIV_MASK                   = 0x00100000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__SGPRS_MASK                  = 0x000003c0;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__VGPRS_MASK                  = 0x0000003f;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__WGP_MODE_MASK               = 0x20000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__WG_RR_EN_MASK               = 0x00200000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__DYNAMIC_VGPR_MASK           = 0x00000040;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__EXCP_EN_MASK                = 0x7f000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__EXCP_EN_MSB_MASK            = 0x00006000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__LDS_SIZE_MASK               = 0x00ff8000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__SCRATCH_EN_MASK             = 0x00000001;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_X_EN_MASK              = 0x00000080;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_Y_EN_MASK              = 0x00000100;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_Z_EN_MASK              = 0x00000200;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TG_SIZE_EN_MASK             = 0x00000400;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT_MASK         = 0x00001800;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__USER_SGPR_MASK              = 0x0000003e;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__WGP_TAKEOVER_MASK           = 0x80000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__GLG_EN_MASK                 = 0x00002000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__IMAGE_OP_MASK               = 0x80000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__INST_PREF_SIZE_MASK         = 0x00000ff0;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT_MASK        = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE_MASK = 0x00000001;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_X__SIZE_MASK             = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_Y__SIZE_MASK             = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_Z__SIZE_MASK             = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__IS_EVENT_MASK               = 0x40000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__IS_STATE_MASK               = 0x80000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__PAYLOAD_MASK                = 0x3fffffff;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__IS_EVENT_MASK                = 0x40000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__IS_STATE_MASK                = 0x80000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__PAYLOAD_MASK                 = 0x3fffffff;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT_MASK = 0x07f00000;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN_MASK      = 0x00010000;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS_MASK    = 0x00000200;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001e;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__SOFT_GROUPING_EN_MASK        = 0x00000001;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT_MASK   = 0x07000000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST_MASK  = 0x00800000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD_MASK   = 0x003f0000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL_MASK   = 0x00400000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__TG_PER_CU_MASK        = 0x0000f000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH_MASK     = 0x000003ff;
constexpr unsigned int WGS_COMPUTE_RESTART_X__RESTART_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_RESTART_Y__RESTART_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_RESTART_Z__RESTART_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_SHADER_CHKSUM__CHECKSUM_MASK           = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_START_X__START_MASK                    = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_START_Y__START_MASK                    = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_START_Z__START_MASK                    = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE4__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE4__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE5__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE5__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE6__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE6__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE7__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE7__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE8__SA0_CU_EN_MASK = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE8__SA1_CU_EN_MASK = 0xffff0000;
constexpr unsigned int WGS_COMPUTE_THREADGROUP_ID__THREADGROUP_ID_MASK    = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE_MASK = 0x00000001;
constexpr unsigned int WGS_COMPUTE_TMPRING_SIZE__WAVESIZE_MASK            = 0x3ffff000;
constexpr unsigned int WGS_COMPUTE_TMPRING_SIZE__WAVES_MASK               = 0x00000fff;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_0__CONTRIBUTION_MASK        = 0x0000007f;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_1__CONTRIBUTION_MASK        = 0x0000007f;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_2__CONTRIBUTION_MASK        = 0x0000007f;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_3__CONTRIBUTION_MASK        = 0x0000007f;
constexpr unsigned int WGS_COMPUTE_USER_DATA_0__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_1__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_2__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_3__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_4__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_5__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_6__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_7__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_8__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_9__DATA_MASK                 = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_10__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_11__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_12__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_13__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_14__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_USER_DATA_15__DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_COMPUTE_VMID__DATA_MASK                        = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR_MASK        = 0x0000ffff;
constexpr unsigned int WGS_COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR_MASK        = 0xffffffff;
constexpr unsigned int WGS_DATA1__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA2__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA3__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA4__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA5__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA6__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA7__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA8__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA9__DATA_MASK                               = 0xffffffff;
constexpr unsigned int WGS_DATA10__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA11__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA12__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA13__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA14__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA15__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DATA16__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE0_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE0_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE1_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE1_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE2_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE2_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE3_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE3_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE4_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE4_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE5_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE5_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE6_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE6_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE7_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE7_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE8_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE8_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE9_BASE__BASE_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__BYPASS_MODE_MASK            = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__ENABLE_MASK                 = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__SCOPE_MASK                  = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__TEMPORAL_MASK               = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__VMID_MASK                   = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE9_MASK__MASK_MASK                   = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE10_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE10_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE11_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE11_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE12_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE12_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE13_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE13_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE14_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE14_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE15_BASE__BASE_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__BYPASS_MODE_MASK           = 0x00000010;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__ENABLE_MASK                = 0x00000020;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__SCOPE_MASK                 = 0x000000c0;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__TEMPORAL_MASK              = 0x00000700;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__VMID_MASK                  = 0x0000000f;
constexpr unsigned int WGS_DC_APERTURE15_MASK__MASK_MASK                  = 0xffffffff;
constexpr unsigned int WGS_DC_BASE_CNTL__VMID_MASK                        = 0x0000000f;
constexpr unsigned int WGS_DC_BASE_HI__DC_BASE_HI_MASK                    = 0x0000ffff;
constexpr unsigned int WGS_DC_BASE_LO__DC_BASE_LO_MASK                    = 0xffff0000;
constexpr unsigned int WGS_DC_OP_CNTL__BYPASS_ALL_MASK                    = 0x00000004;
constexpr unsigned int WGS_DC_OP_CNTL__INVALIDATE_DCACHE_COMPLETE_MASK    = 0x00000002;
constexpr unsigned int WGS_DC_OP_CNTL__INVALIDATE_DCACHE_MASK             = 0x00000001;
constexpr unsigned int WGS_DDID_BASE_ADDR_HI__BASE_ADDR_HI_MASK           = 0x0000ffff;
constexpr unsigned int WGS_DDID_BASE_ADDR_LO__BASE_ADDR_LO_MASK           = 0xffffffc0;
constexpr unsigned int WGS_DDID_CNTL__ENABLE_MASK                         = 0x80000000;
constexpr unsigned int WGS_DDID_CNTL__MODE_MASK                           = 0x40000000;
constexpr unsigned int WGS_DDID_CNTL__NO_RING_MEMORY_MASK                 = 0x00080000;
constexpr unsigned int WGS_DDID_CNTL__POLICY_MASK                         = 0x30000000;
constexpr unsigned int WGS_DDID_CNTL__SIZE_MASK                           = 0x00010000;
constexpr unsigned int WGS_DDID_CNTL__THRESHOLD_MASK                      = 0x000000ff;
constexpr unsigned int WGS_DM_INDEX_ADDR__ADDR_MASK                       = 0xffffffff;
constexpr unsigned int WGS_DM_INDEX_DATA__DATA_MASK                       = 0xffffffff;
constexpr unsigned int WGS_ENDIAN_SWAP__ENDIAN_SWAP_MASK                  = 0x00000003;
constexpr unsigned int WGS_ERROR__RESERVED_MASK                           = 0xffffffff;
constexpr unsigned int WGS_GEN_BASE_HI__BASE_HI_MASK                      = 0x0000ffff;
constexpr unsigned int WGS_GEN_BASE_LO__BASE_LO_MASK                      = 0xfffff000;
constexpr unsigned int WGS_GP0_HI__M_RET_ADDR_MASK                        = 0xffffffff;
constexpr unsigned int WGS_GP0_LO__DATA_MASK                              = 0xfffffffe;
constexpr unsigned int WGS_GP0_LO__PG_VIRT_HALTED_MASK                    = 0x00000001;
constexpr unsigned int WGS_GP1_HI__RD_WR_SELECT_HI_MASK                   = 0xffffffff;
constexpr unsigned int WGS_GP1_LO__RD_WR_SELECT_LO_MASK                   = 0xffffffff;
constexpr unsigned int WGS_GP2_HI__STACK_PNTR_HI_MASK                     = 0xffffffff;
constexpr unsigned int WGS_GP2_LO__STACK_PNTR_LO_MASK                     = 0xffffffff;
constexpr unsigned int WGS_GP3_HI__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP3_LO__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP4_HI__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP4_LO__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP5_HI__M_RET_ADDR_MASK                        = 0xffffffff;
constexpr unsigned int WGS_GP5_LO__DATA_MASK                              = 0xfffffffe;
constexpr unsigned int WGS_GP5_LO__PG_VIRT_HALTED_MASK                    = 0x00000001;
constexpr unsigned int WGS_GP6_HI__RD_WR_SELECT_HI_MASK                   = 0xffffffff;
constexpr unsigned int WGS_GP6_LO__RD_WR_SELECT_LO_MASK                   = 0xffffffff;
constexpr unsigned int WGS_GP7_HI__STACK_PNTR_HI_MASK                     = 0xffffffff;
constexpr unsigned int WGS_GP7_LO__STACK_PNTR_LO_MASK                     = 0xffffffff;
constexpr unsigned int WGS_GP8_HI__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP8_LO__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP9_HI__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_GP9_LO__DATA_MASK                              = 0xffffffff;
constexpr unsigned int WGS_HALT_HYST_COUNT__COUNT_MASK                    = 0x0000000f;
constexpr unsigned int WGS_IC_BASE_CNTL__CACHE_POLICY_MASK                = 0x03000000;
constexpr unsigned int WGS_IC_BASE_CNTL__EXE_DISABLE_MASK                 = 0x00800000;
constexpr unsigned int WGS_IC_BASE_CNTL__PER_PIPE_MASK                    = 0x00000020;
constexpr unsigned int WGS_IC_BASE_CNTL__SCOPE_MASK                       = 0x000000c0;
constexpr unsigned int WGS_IC_BASE_CNTL__TEMPORAL_MASK                    = 0x00000700;
constexpr unsigned int WGS_IC_BASE_CNTL__VMID_MASK                        = 0x0000000f;
constexpr unsigned int WGS_IC_BASE_HI__IC_BASE_HI_MASK                    = 0x0000ffff;
constexpr unsigned int WGS_IC_BASE_LO__IC_BASE_LO_MASK                    = 0xfffff000;
constexpr unsigned int WGS_IC_OP_CNTL__HALT_ON_PRIME_MASK                 = 0x00000004;
constexpr unsigned int WGS_IC_OP_CNTL__ICACHE_PRIMED_MASK                 = 0x00000020;
constexpr unsigned int WGS_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE_MASK     = 0x00000002;
constexpr unsigned int WGS_IC_OP_CNTL__INVALIDATE_CACHE_MASK              = 0x00000001;
constexpr unsigned int WGS_IC_OP_CNTL__PRIME_ICACHE_MASK                  = 0x00000010;
constexpr unsigned int WGS_IC_OP_CNTL__PRIME_START_PC_MASK                = 0x00000008;
constexpr unsigned int WGS_IH_FREE_COUNT__COUNT_MASK                      = 0x000000ff;
constexpr unsigned int WGS_INT_CNTXID_HI__DATA_MASK                       = 0x000000ff;
constexpr unsigned int WGS_INT_CNTXID_LO__DATA_MASK                       = 0xffffffff;
constexpr unsigned int WGS_INT_INFO__RING_ID_MASK                         = 0x000000ff;
constexpr unsigned int WGS_INT_INFO__VMID_MASK                            = 0x00000f00;
constexpr unsigned int WGS_INT_STATUS__SEND_MASK                          = 0x00000100;
constexpr unsigned int WGS_INT_STATUS__SOURCE_ID_MASK                     = 0x000000ff;
constexpr unsigned int WGS_IQ_TIMER_MESSAGE__MESSAGE_MASK                 = 0x000000ff;
constexpr unsigned int WGS_IQ_TIMER__ACTIVE_MASK                          = 0x80000000;
constexpr unsigned int WGS_IQ_TIMER__CLOCK_COUNT_MASK                     = 0x0000c000;
constexpr unsigned int WGS_IQ_TIMER__IMMEDIATE_EXPIRE_MASK                = 0x00000800;
constexpr unsigned int WGS_IQ_TIMER__INTERRUPT_TYPE_MASK                  = 0x00003000;
constexpr unsigned int WGS_IQ_TIMER__QUANTUM_TIMER_MASK                   = 0x00400000;
constexpr unsigned int WGS_IQ_TIMER__QUEUE_TYPE_MASK                      = 0x08000000;
constexpr unsigned int WGS_IQ_TIMER__REARM_TIMER_MASK                     = 0x10000000;
constexpr unsigned int WGS_IQ_TIMER__RESERVED1_MASK                       = 0x60000000;
constexpr unsigned int WGS_IQ_TIMER__RESERVED2_MASK                       = 0x07800000;
constexpr unsigned int WGS_IQ_TIMER__RESERVED3_MASK                       = 0x003f0000;
constexpr unsigned int WGS_IQ_TIMER__RETRY_TYPE_MASK                      = 0x00000700;
constexpr unsigned int WGS_IQ_TIMER__WAIT_TIME_MASK                       = 0x000000ff;
constexpr unsigned int WGS_IQ_WAIT_TIME1__ATOMIC_OFFLOAD_MASK             = 0x0000ff00;
constexpr unsigned int WGS_IQ_WAIT_TIME1__GWS_MASK                        = 0xff000000;
constexpr unsigned int WGS_IQ_WAIT_TIME1__IB_OFFLOAD_MASK                 = 0x000000ff;
constexpr unsigned int WGS_IQ_WAIT_TIME1__WRM_OFFLOAD_MASK                = 0x00ff0000;
constexpr unsigned int WGS_IQ_WAIT_TIME2__DEQ_RETRY_MASK                  = 0xff000000;
constexpr unsigned int WGS_IQ_WAIT_TIME2__QUE_SLEEP_MASK                  = 0x000000ff;
constexpr unsigned int WGS_IQ_WAIT_TIME2__SCH_WAVE_MASK                   = 0x0000ff00;
constexpr unsigned int WGS_IQ_WAIT_TIME3__SUSPEND_QUE_MASK                = 0x000000ff;
constexpr unsigned int WGS_LATENCY_STATS_DATA__DATA_MASK                  = 0xffffffff;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__CLEAR_MASK               = 0x40000000;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__ENABLE_MASK              = 0x80000000;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__INDEX_MASK               = 0x0000001f;
constexpr unsigned int WGS_LOCAL_APERTURE__APERTURE_MASK                  = 0x00000007;
constexpr unsigned int WGS_LOCAL_APERTURE__SCOPE_MASK                     = 0x000000c0;
constexpr unsigned int WGS_LOCAL_APERTURE__TEMPORAL_MASK                  = 0x00000700;
constexpr unsigned int WGS_LOCAL_BASE0_HI__BASE0_HI_MASK                  = 0x0000ffff;
constexpr unsigned int WGS_LOCAL_BASE0_LO__BASE0_LO_MASK                  = 0xffff0000;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__APERTURE_MASK            = 0x00000007;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__SCOPE_MASK               = 0x000000c0;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__TEMPORAL_MASK            = 0x00000700;
constexpr unsigned int WGS_LOCAL_INSTR_BASE_HI__BASE_HI_MASK              = 0x0000ffff;
constexpr unsigned int WGS_LOCAL_INSTR_BASE_LO__BASE_LO_MASK              = 0xffff0000;
constexpr unsigned int WGS_LOCAL_INSTR_MASK_HI__MASK_HI_MASK              = 0x0000ffff;
constexpr unsigned int WGS_LOCAL_INSTR_MASK_LO__MASK_LO_MASK              = 0xffff0000;
constexpr unsigned int WGS_LOCAL_MASK0_HI__MASK0_HI_MASK                  = 0x0000ffff;
constexpr unsigned int WGS_LOCAL_MASK0_LO__MASK0_LO_MASK                  = 0xffff0000;
constexpr unsigned int WGS_LOCAL_SCRATCH_APERTURE__APERTURE_MASK          = 0x00000007;
constexpr unsigned int WGS_LOCAL_SCRATCH_BASE_HI__BASE_HI_MASK            = 0x0000ffff;
constexpr unsigned int WGS_LOCAL_SCRATCH_BASE_LO__BASE_LO_MASK            = 0xffff0000;
constexpr unsigned int WGS_MDBASE_HI__BASE_HI_MASK                        = 0x0000ffff;
constexpr unsigned int WGS_MDBASE_LO__BASE_LO_MASK                        = 0xffff0000;
constexpr unsigned int WGS_MDBOUND_HI__BOUND_HI_MASK                      = 0xffffffff;
constexpr unsigned int WGS_MDBOUND_LO__BOUND_LO_MASK                      = 0xffffffff;
constexpr unsigned int WGS_ME1_HEADER_DUMP__HEADER_DUMP_MASK              = 0xffffffff;
constexpr unsigned int WGS_ME1_PIPE0_PRIORITY__PRIORITY_MASK              = 0x00000003;
constexpr unsigned int WGS_ME1_PIPE1_PRIORITY__PRIORITY_MASK              = 0x00000003;
constexpr unsigned int WGS_ME1_PIPE2_PRIORITY__PRIORITY_MASK              = 0x00000003;
constexpr unsigned int WGS_ME1_PIPE3_PRIORITY__PRIORITY_MASK              = 0x00000003;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY1_CNT_MASK     = 0x000000ff;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT_MASK    = 0x0000ff00;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT_MASK    = 0x00ff0000;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY3_CNT_MASK     = 0xff000000;
constexpr unsigned int WGS_METADATA_BASE_ADDR_HI__MD_BASE_HI_MASK         = 0x0000ffff;
constexpr unsigned int WGS_METADATA_BASE_ADDR_LO__MD_BASE_LO_MASK         = 0xfffffffc;
constexpr unsigned int WGS_METADATA_CNTL__EVENT1_MASK                     = 0x00000800;
constexpr unsigned int WGS_METADATA_CNTL__EVENT_MODE_MASK                 = 0x00000030;
constexpr unsigned int WGS_METADATA_CNTL__QUEUE_ID_MASK                   = 0x00007000;
constexpr unsigned int WGS_METADATA_CNTL__SCOPE_MASK                      = 0x000000c0;
constexpr unsigned int WGS_METADATA_CNTL__TEMPORAL_MASK                   = 0x00000700;
constexpr unsigned int WGS_METADATA_CNTL__VMID_MASK                       = 0x0000000f;
constexpr unsigned int WGS_MGCG_SYNC_CNTL__COOLDOWN_PERIOD_MASK           = 0x000000ff;
constexpr unsigned int WGS_MGCG_SYNC_CNTL__WARMUP_PERIOD_MASK             = 0x0000ff00;
constexpr unsigned int WGS_MIBOUND_HI__BOUND_HI_MASK                      = 0xffffffff;
constexpr unsigned int WGS_MIBOUND_LO__BOUND_LO_MASK                      = 0xffffffff;
constexpr unsigned int WGS_MIE_HI__MEC_INT_MASK                           = 0xffffffff;
constexpr unsigned int WGS_MIE_LO__MEC_INT_MASK                           = 0xffffffff;
constexpr unsigned int WGS_MIP_HI__MIP_HI_MASK                            = 0xffffffff;
constexpr unsigned int WGS_MIP_LO__MIP_LO_MASK                            = 0xffffffff;
constexpr unsigned int WGS_MTIMECMP_HI__TIME_HI_MASK                      = 0xffffffff;
constexpr unsigned int WGS_MTIMECMP_LO__TIME_LO_MASK                      = 0xffffffff;
constexpr unsigned int WGS_MTVEC_HI__ADDR_LO_MASK                         = 0xffffffff;
constexpr unsigned int WGS_MTVEC_LO__ADDR_LO_MASK                         = 0xffffffff;
constexpr unsigned int WGS_OS_PIPES__OS_PIPES_MASK                        = 0x000000ff;
constexpr unsigned int WGS_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int WGS_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK          = 0xf0000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK          = 0x0f000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK           = 0x000003ff;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK           = 0x000ffc00;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK           = 0xf0000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK           = 0x0f000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__PERF_SEL1_MASK            = 0x000ffc00;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__SPM_MODE_MASK             = 0x00f00000;
constexpr unsigned int WGS_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK           = 0xffffffff;
constexpr unsigned int WGS_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK           = 0xffffffff;
constexpr unsigned int WGS_PERFCOUNTER1_SELECT__CNTR_MODE_MASK            = 0xf0000000;
constexpr unsigned int WGS_PERFCOUNTER1_SELECT__PERF_SEL_MASK             = 0x000003ff;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_ENABLE_MODE_MASK         = 0x00000300;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE_MASK       = 0x00000400;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_STATE_MASK               = 0x0000000f;
constexpr unsigned int WGS_PERFMON_CNTL__SPM_PERFMON_STATE_MASK           = 0x000000f0;
constexpr unsigned int WGS_RS64_CNTL__MEC_HALT_MASK                       = 0x40000000;
constexpr unsigned int WGS_RS64_CNTL__MEC_INVALIDATE_ICACHE_MASK          = 0x00000010;
constexpr unsigned int WGS_RS64_CNTL__MEC_STEP_MASK                       = 0x80000000;
constexpr unsigned int WGS_RS64_CNTL__RSRV1_MASK                          = 0x20000000;
constexpr unsigned int WGS_RS64_CNTL__RSRV2_MASK                          = 0x10000000;
constexpr unsigned int WGS_RS64_CNTL__RSRV3_MASK                          = 0x08000000;
constexpr unsigned int WGS_RS64_CNTL__RSRV4_MASK                          = 0x04000000;
constexpr unsigned int WGS_RS64_CNTL__RSRV5_MASK                          = 0x00080000;
constexpr unsigned int WGS_RS64_CNTL__RSRV6_MASK                          = 0x00040000;
constexpr unsigned int WGS_RS64_CNTL__RSRV7_MASK                          = 0x00020000;
constexpr unsigned int WGS_RS64_CNTL__RSRV8_MASK                          = 0x00010000;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_ILLEGAL_INSTRUCTION_MASK = 0x00000001;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_INSTRUCTION_ADDR_MASK = 0x07fffff0;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_MISALIGNED_ADDR_MASK = 0x00000002;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_PAGE_FAULT_MASK = 0x00000008;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_UNALIGNED_INSTRUTCION_MASK = 0x00000004;
constexpr unsigned int WGS_RS64_INSTR_PNTR__INSTR_PNTR_MASK               = 0x000fffff;
constexpr unsigned int WGS_RS64_INTERRUPT__MEC_INT_MASK                   = 0xffffffff;
constexpr unsigned int WGS_RS64_PENDING_INTERRUPT__PENDING_INTERRUPT_MASK = 0xffffffff;
constexpr unsigned int WGS_RS64_PERFCOUNT_CNTL__EVENT_SEL_MASK            = 0x0000001f;
constexpr unsigned int WGS_RS64_PRGRM_CNTR_START_HI__IP_START_MASK        = 0x3fffffff;
constexpr unsigned int WGS_RS64_PRGRM_CNTR_START__IP_START_MASK           = 0xffffffff;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_ILLEGAL_INSTRUCTION_MASK = 0x00000001;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_INSTRUCTION_ADDR_MASK = 0x07fffff0;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_MISALIGNED_ADDR_MASK = 0x00000002;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_PAGE_FAULT_MASK = 0x00000008;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_UNALIGNED_INSTRUTCION_MASK = 0x00000004;
constexpr unsigned int WGS_RS64_PRIV_LEVEL__GRBM_PRIV_LEVEL_MASK          = 0x00000002;
constexpr unsigned int WGS_RS64_PRIV_LEVEL__PRIV_LEVEL_MASK               = 0x00000001;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_INVALIDATE_ICACHE_MASK   = 0x00000010;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_PIPE_ACTIVE_MASK         = 0x04000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_PIPE_RESET_MASK          = 0x00010000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_STATUS_MASK              = 0x0000000f;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV1_MASK                   = 0x80000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV2_MASK                   = 0x20000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV3_MASK                   = 0x10000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV4_MASK                   = 0x08000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV5_MASK                   = 0x00080000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV6_MASK                   = 0x00040000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV7_MASK                   = 0x00020000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__SPARE_MASK                   = 0x40000000;
constexpr unsigned int WGS_SCRATCH_DATA__SCRATCH_DATA_MASK                = 0xffffffff;
constexpr unsigned int WGS_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE_MASK   = 0x80000000;
constexpr unsigned int WGS_SCRATCH_INDEX__SCRATCH_INDEX_MASK              = 0x000001ff;
constexpr unsigned int WGS_SECURE_REG0__DATA_MASK                         = 0xffffffff;
constexpr unsigned int WGS_SECURE_REG1__DATA_MASK                         = 0xffffffff;
constexpr unsigned int WGS_SECURE_REG2__DATA_MASK                         = 0xffffffff;
constexpr unsigned int WGS_SECURE_REG3__DATA_MASK                         = 0xffffffff;
constexpr unsigned int WGS_STALLED_STAT1__GCRIU_WAITING_ON_FREE_MASK      = 0x02000000;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_DECODING_PACKET_MASK       = 0x00000100;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_RCIU_MASK          = 0x00000200;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_RCIU_READ_MASK     = 0x00000400;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_ROQ_DATA_MASK      = 0x00002000;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_DECODING_PACKET_MASK       = 0x00010000;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_RCIU_MASK          = 0x00020000;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_RCIU_READ_MASK     = 0x00040000;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_ROQ_DATA_MASK      = 0x00200000;
constexpr unsigned int WGS_STALLED_STAT1__RCIU_PRIV_VIOLATION_MASK        = 0x00000010;
constexpr unsigned int WGS_STALLED_STAT1__RCIU_TX_FREE_STALL_MASK         = 0x00000008;
constexpr unsigned int WGS_STALLED_STAT1__TCIU_TX_FREE_STALL_MASK         = 0x00000040;
constexpr unsigned int WGS_STALLED_STAT1__TCIU_WAITING_ON_TAGS_MASK       = 0x00000080;
constexpr unsigned int WGS_STALLED_STAT1__UTCL1_WAITING_ON_TRANS_MASK     = 0x01000000;
constexpr unsigned int WGS_STALLED_STAT1__UTCL2IU_WAITING_ON_FREE_MASK    = 0x00400000;
constexpr unsigned int WGS_STALLED_STAT1__UTCL2IU_WAITING_ON_TAGS_MASK    = 0x00800000;
constexpr unsigned int WGS_STATUS__DC0_BUSY_MASK                          = 0x00000004;
constexpr unsigned int WGS_STATUS__DC1_BUSY_MASK                          = 0x00000008;
constexpr unsigned int WGS_STATUS__GCRIU_BUSY_MASK                        = 0x00008000;
constexpr unsigned int WGS_STATUS__GL1_XNACK_MASK                         = 0x00c00000;
constexpr unsigned int WGS_STATUS__MEC1_BUSY_MASK                         = 0x00000001;
constexpr unsigned int WGS_STATUS__MEC2_BUSY_MASK                         = 0x00000002;
constexpr unsigned int WGS_STATUS__MEC_DATA_CACHE_BUSY_MASK               = 0x00200000;
constexpr unsigned int WGS_STATUS__MES_BUSY_MASK                          = 0x00010000;
constexpr unsigned int WGS_STATUS__MES_DATA_CACHE_BUSY_MASK               = 0x00100000;
constexpr unsigned int WGS_STATUS__MES_INSTRUCTION_CACHE_BUSY_MASK        = 0x00080000;
constexpr unsigned int WGS_STATUS__MES_SCRATCH_RAM_BUSY_MASK              = 0x00020000;
constexpr unsigned int WGS_STATUS__QU_BUSY_MASK                           = 0x00001000;
constexpr unsigned int WGS_STATUS__RCIU1_BUSY_MASK                        = 0x00000010;
constexpr unsigned int WGS_STATUS__RCIU2_BUSY_MASK                        = 0x00000020;
constexpr unsigned int WGS_STATUS__RCIU3_BUSY_MASK                        = 0x00040000;
constexpr unsigned int WGS_STATUS__ROQ1_BUSY_MASK                         = 0x00000040;
constexpr unsigned int WGS_STATUS__ROQ2_BUSY_MASK                         = 0x00000080;
constexpr unsigned int WGS_STATUS__RSRV_MASK                              = 0x7f000000;
constexpr unsigned int WGS_STATUS__SAVE_RESTORE_BUSY_MASK                 = 0x00004000;
constexpr unsigned int WGS_STATUS__SCRATCH_RAM_BUSY_MASK                  = 0x00000800;
constexpr unsigned int WGS_STATUS__TCIU_BUSY_MASK                         = 0x00000400;
constexpr unsigned int WGS_STATUS__TMZ_STATE_MASK                         = 0x00000100;
constexpr unsigned int WGS_STATUS__UTCL2IU_BUSY_MASK                      = 0x00002000;
constexpr unsigned int WGS_STATUS__VMID_TMZ_MASK                          = 0x00000200;
constexpr unsigned int WGS_STATUS__WGS_BUSY_MASK                          = 0x80000000;
constexpr unsigned int WGS_SUSPEND_CNTL_STACK_OFFSET__OFFSET_MASK         = 0x0000fffc;
constexpr unsigned int WGS_SUSPEND_CNTL_STACK_SIZE__SIZE_MASK             = 0x0000f000;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_BASE_ADDR_HI__ADDR_HI_MASK    = 0x0000ffff;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_BASE_ADDR_LO__ADDR_MASK       = 0xfffff000;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_CONTROL__EXE_DISABLE_MASK     = 0x00800000;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_CONTROL__POLICY_MASK          = 0x00000018;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_SIZE__SIZE_MASK               = 0x03fff000;
constexpr unsigned int WGS_SUSPEND_RESUME_REQ__RESUME_REQ_MASK            = 0x00000002;
constexpr unsigned int WGS_SUSPEND_RESUME_REQ__SUSPEND_REQ_MASK           = 0x00000001;
constexpr unsigned int WGS_SUSPEND_WG_STATE_OFFSET__OFFSET_MASK           = 0x03fffffc;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__ALWAYS_MASK     = 0x40000000;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__ENABLE_MASK     = 0x80000000;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__INDEX_MASK      = 0x0000001f;
constexpr unsigned int WGS_TMZ_CNTL__PTE_DISABLE_MASK                     = 0x00000001;

} // inline namespace Chip
} // namespace Gfx12
} // namespace Pal
