/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx12
{
inline namespace Chip
{
constexpr unsigned int mmCB_BLEND0_CONTROL                                = 0xA1E0;
constexpr unsigned int mmCB_BLEND1_CONTROL                                = 0xA1E1;
constexpr unsigned int mmCB_BLEND2_CONTROL                                = 0xA1E2;
constexpr unsigned int mmCB_BLEND3_CONTROL                                = 0xA1E3;
constexpr unsigned int mmCB_BLEND4_CONTROL                                = 0xA1E4;
constexpr unsigned int mmCB_BLEND5_CONTROL                                = 0xA1E5;
constexpr unsigned int mmCB_BLEND6_CONTROL                                = 0xA1E6;
constexpr unsigned int mmCB_BLEND7_CONTROL                                = 0xA1E7;
constexpr unsigned int mmCB_BLEND_ALPHA                                   = 0xA108;
constexpr unsigned int mmCB_BLEND_BLUE                                    = 0xA107;
constexpr unsigned int mmCB_BLEND_GREEN                                   = 0xA106;
constexpr unsigned int mmCB_BLEND_RED                                     = 0xA105;
constexpr unsigned int mmCB_CACHE_EVICT_POINTS                            = 0x268E;
constexpr unsigned int mmCB_COLOR0_ATTRIB                                 = 0xA31B;
constexpr unsigned int mmCB_COLOR0_ATTRIB2                                = 0xA31E;
constexpr unsigned int mmCB_COLOR0_ATTRIB3                                = 0xA31F;
constexpr unsigned int mmCB_COLOR0_BASE                                   = 0xA318;
constexpr unsigned int mmCB_COLOR0_BASE_EXT                               = 0xA390;
constexpr unsigned int mmCB_COLOR0_FDCC_CONTROL                           = 0xA31C;
constexpr unsigned int mmCB_COLOR0_INFO                                   = 0xA3B0;
constexpr unsigned int mmCB_COLOR0_VIEW                                   = 0xA319;
constexpr unsigned int mmCB_COLOR0_VIEW2                                  = 0xA31A;
constexpr unsigned int mmCB_COLOR1_ATTRIB                                 = 0xA324;
constexpr unsigned int mmCB_COLOR1_ATTRIB2                                = 0xA327;
constexpr unsigned int mmCB_COLOR1_ATTRIB3                                = 0xA328;
constexpr unsigned int mmCB_COLOR1_BASE                                   = 0xA321;
constexpr unsigned int mmCB_COLOR1_BASE_EXT                               = 0xA391;
constexpr unsigned int mmCB_COLOR1_FDCC_CONTROL                           = 0xA325;
constexpr unsigned int mmCB_COLOR1_INFO                                   = 0xA3B1;
constexpr unsigned int mmCB_COLOR1_VIEW                                   = 0xA322;
constexpr unsigned int mmCB_COLOR1_VIEW2                                  = 0xA323;
constexpr unsigned int mmCB_COLOR2_ATTRIB                                 = 0xA32D;
constexpr unsigned int mmCB_COLOR2_ATTRIB2                                = 0xA330;
constexpr unsigned int mmCB_COLOR2_ATTRIB3                                = 0xA331;
constexpr unsigned int mmCB_COLOR2_BASE                                   = 0xA32A;
constexpr unsigned int mmCB_COLOR2_BASE_EXT                               = 0xA392;
constexpr unsigned int mmCB_COLOR2_FDCC_CONTROL                           = 0xA32E;
constexpr unsigned int mmCB_COLOR2_INFO                                   = 0xA3B2;
constexpr unsigned int mmCB_COLOR2_VIEW                                   = 0xA32B;
constexpr unsigned int mmCB_COLOR2_VIEW2                                  = 0xA32C;
constexpr unsigned int mmCB_COLOR3_ATTRIB                                 = 0xA336;
constexpr unsigned int mmCB_COLOR3_ATTRIB2                                = 0xA339;
constexpr unsigned int mmCB_COLOR3_ATTRIB3                                = 0xA33A;
constexpr unsigned int mmCB_COLOR3_BASE                                   = 0xA333;
constexpr unsigned int mmCB_COLOR3_BASE_EXT                               = 0xA393;
constexpr unsigned int mmCB_COLOR3_FDCC_CONTROL                           = 0xA337;
constexpr unsigned int mmCB_COLOR3_INFO                                   = 0xA3B3;
constexpr unsigned int mmCB_COLOR3_VIEW                                   = 0xA334;
constexpr unsigned int mmCB_COLOR3_VIEW2                                  = 0xA335;
constexpr unsigned int mmCB_COLOR4_ATTRIB                                 = 0xA33F;
constexpr unsigned int mmCB_COLOR4_ATTRIB2                                = 0xA342;
constexpr unsigned int mmCB_COLOR4_ATTRIB3                                = 0xA343;
constexpr unsigned int mmCB_COLOR4_BASE                                   = 0xA33C;
constexpr unsigned int mmCB_COLOR4_BASE_EXT                               = 0xA394;
constexpr unsigned int mmCB_COLOR4_FDCC_CONTROL                           = 0xA340;
constexpr unsigned int mmCB_COLOR4_INFO                                   = 0xA3B4;
constexpr unsigned int mmCB_COLOR4_VIEW                                   = 0xA33D;
constexpr unsigned int mmCB_COLOR4_VIEW2                                  = 0xA33E;
constexpr unsigned int mmCB_COLOR5_ATTRIB                                 = 0xA348;
constexpr unsigned int mmCB_COLOR5_ATTRIB2                                = 0xA34B;
constexpr unsigned int mmCB_COLOR5_ATTRIB3                                = 0xA34C;
constexpr unsigned int mmCB_COLOR5_BASE                                   = 0xA345;
constexpr unsigned int mmCB_COLOR5_BASE_EXT                               = 0xA395;
constexpr unsigned int mmCB_COLOR5_FDCC_CONTROL                           = 0xA349;
constexpr unsigned int mmCB_COLOR5_INFO                                   = 0xA3B5;
constexpr unsigned int mmCB_COLOR5_VIEW                                   = 0xA346;
constexpr unsigned int mmCB_COLOR5_VIEW2                                  = 0xA347;
constexpr unsigned int mmCB_COLOR6_ATTRIB                                 = 0xA351;
constexpr unsigned int mmCB_COLOR6_ATTRIB2                                = 0xA354;
constexpr unsigned int mmCB_COLOR6_ATTRIB3                                = 0xA355;
constexpr unsigned int mmCB_COLOR6_BASE                                   = 0xA34E;
constexpr unsigned int mmCB_COLOR6_BASE_EXT                               = 0xA396;
constexpr unsigned int mmCB_COLOR6_FDCC_CONTROL                           = 0xA352;
constexpr unsigned int mmCB_COLOR6_INFO                                   = 0xA3B6;
constexpr unsigned int mmCB_COLOR6_VIEW                                   = 0xA34F;
constexpr unsigned int mmCB_COLOR6_VIEW2                                  = 0xA350;
constexpr unsigned int mmCB_COLOR7_ATTRIB                                 = 0xA35A;
constexpr unsigned int mmCB_COLOR7_ATTRIB2                                = 0xA35D;
constexpr unsigned int mmCB_COLOR7_ATTRIB3                                = 0xA35E;
constexpr unsigned int mmCB_COLOR7_BASE                                   = 0xA357;
constexpr unsigned int mmCB_COLOR7_BASE_EXT                               = 0xA397;
constexpr unsigned int mmCB_COLOR7_FDCC_CONTROL                           = 0xA35B;
constexpr unsigned int mmCB_COLOR7_INFO                                   = 0xA3B7;
constexpr unsigned int mmCB_COLOR7_VIEW                                   = 0xA358;
constexpr unsigned int mmCB_COLOR7_VIEW2                                  = 0xA359;
constexpr unsigned int mmCB_COLOR_CONTROL                                 = 0xA216;
constexpr unsigned int mmCB_FGCG_SRAM_OVERRIDE                            = 0x268A;
constexpr unsigned int mmCB_HW_CONTROL                                    = 0x2684;
constexpr unsigned int mmCB_HW_CONTROL_1                                  = 0x2685;
constexpr unsigned int mmCB_HW_CONTROL_2                                  = 0x2686;
constexpr unsigned int mmCB_HW_CONTROL_3                                  = 0x2683;
constexpr unsigned int mmCB_HW_CONTROL_4                                  = 0x2682;
constexpr unsigned int mmCB_HW_MEM_ARBITER_CTL                            = 0x2688;
constexpr unsigned int mmCB_MEM0_INFO                                     = 0xA3C0;
constexpr unsigned int mmCB_MEM1_INFO                                     = 0xA3C1;
constexpr unsigned int mmCB_MEM2_INFO                                     = 0xA3C2;
constexpr unsigned int mmCB_MEM3_INFO                                     = 0xA3C3;
constexpr unsigned int mmCB_MEM4_INFO                                     = 0xA3C4;
constexpr unsigned int mmCB_MEM5_INFO                                     = 0xA3C5;
constexpr unsigned int mmCB_MEM6_INFO                                     = 0xA3C6;
constexpr unsigned int mmCB_MEM7_INFO                                     = 0xA3C7;
constexpr unsigned int mmCB_PERFCOUNTER0_HI                               = 0xD407;
constexpr unsigned int mmCB_PERFCOUNTER0_LO                               = 0xD406;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT                           = 0xDC01;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1                          = 0xDC02;
constexpr unsigned int mmCB_PERFCOUNTER1_HI                               = 0xD409;
constexpr unsigned int mmCB_PERFCOUNTER1_LO                               = 0xD408;
constexpr unsigned int mmCB_PERFCOUNTER1_SELECT                           = 0xDC03;
constexpr unsigned int mmCB_PERFCOUNTER2_HI                               = 0xD40B;
constexpr unsigned int mmCB_PERFCOUNTER2_LO                               = 0xD40A;
constexpr unsigned int mmCB_PERFCOUNTER2_SELECT                           = 0xDC04;
constexpr unsigned int mmCB_PERFCOUNTER3_HI                               = 0xD40D;
constexpr unsigned int mmCB_PERFCOUNTER3_LO                               = 0xD40C;
constexpr unsigned int mmCB_PERFCOUNTER3_SELECT                           = 0xDC05;
constexpr unsigned int mmCB_PERFCOUNTER_FILTER                            = 0xDC00;
constexpr unsigned int mmCB_READ_RESP_KEY_OVERRIDE                        = 0x268F;
constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL                         = 0xA104;
constexpr unsigned int mmCB_SHADER_MASK                                   = 0xA215;
constexpr unsigned int mmCB_TARGET_MASK                                   = 0xA214;
constexpr unsigned int mmCHA_PERFCOUNTER0_HI                              = 0xD601;
constexpr unsigned int mmCHA_PERFCOUNTER0_LO                              = 0xD600;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT                          = 0xDDE0;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT1                         = 0xDDE1;
constexpr unsigned int mmCHA_PERFCOUNTER1_HI                              = 0xD603;
constexpr unsigned int mmCHA_PERFCOUNTER1_LO                              = 0xD602;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT                          = 0xDDE2;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT1                         = 0xDDE3;
constexpr unsigned int mmCHA_PERFCOUNTER2_HI                              = 0xD605;
constexpr unsigned int mmCHA_PERFCOUNTER2_LO                              = 0xD604;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT                          = 0xDDE4;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT1                         = 0xDDE5;
constexpr unsigned int mmCHA_PERFCOUNTER3_HI                              = 0xD607;
constexpr unsigned int mmCHA_PERFCOUNTER3_LO                              = 0xD606;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT                          = 0xDDE6;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT1                         = 0xDDE7;
constexpr unsigned int mmCHC_PERFCOUNTER0_HI                              = 0xD3C1;
constexpr unsigned int mmCHC_PERFCOUNTER0_LO                              = 0xD3C0;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT                          = 0xDBC0;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT1                         = 0xDBC1;
constexpr unsigned int mmCHC_PERFCOUNTER1_HI                              = 0xD3C3;
constexpr unsigned int mmCHC_PERFCOUNTER1_LO                              = 0xD3C2;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT                          = 0xDBC2;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT1                         = 0xDBC3;
constexpr unsigned int mmCHC_PERFCOUNTER2_HI                              = 0xD3C5;
constexpr unsigned int mmCHC_PERFCOUNTER2_LO                              = 0xD3C4;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT                          = 0xDBC4;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT1                         = 0xDBC5;
constexpr unsigned int mmCHC_PERFCOUNTER3_HI                              = 0xD3C7;
constexpr unsigned int mmCHC_PERFCOUNTER3_LO                              = 0xD3C6;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT                          = 0xDBC6;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT1                         = 0xDBC7;
constexpr unsigned int mmCOHER_DEST_BASE_0                                = 0xA092;
constexpr unsigned int mmCOHER_DEST_BASE_1                                = 0xA093;
constexpr unsigned int mmCOHER_DEST_BASE_2                                = 0xA07E;
constexpr unsigned int mmCOHER_DEST_BASE_3                                = 0xA07F;
constexpr unsigned int mmCOHER_DEST_BASE_HI_0                             = 0xA07A;
constexpr unsigned int mmCOHER_DEST_BASE_HI_1                             = 0xA07B;
constexpr unsigned int mmCOHER_DEST_BASE_HI_2                             = 0xA07C;
constexpr unsigned int mmCOHER_DEST_BASE_HI_3                             = 0xA07D;
constexpr unsigned int mmCOMPUTE_DDID_INDEX                               = 0x2E29;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0                       = 0x2E16;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1                       = 0x2E17;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2                       = 0x2E19;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3                       = 0x2E1A;
constexpr unsigned int mmCOMPUTE_DIM_X                                    = 0x2E01;
constexpr unsigned int mmCOMPUTE_DIM_Y                                    = 0x2E02;
constexpr unsigned int mmCOMPUTE_DIM_Z                                    = 0x2E03;
constexpr unsigned int mmCOMPUTE_DISPATCH_END                             = 0x2E7E;
constexpr unsigned int mmCOMPUTE_DISPATCH_ID                              = 0x2E20;
constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR                       = 0x2E00;
constexpr unsigned int mmCOMPUTE_DISPATCH_INTERLEAVE                      = 0x2E2F;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI                     = 0x2E0F;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO                     = 0x2E0E;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI                 = 0x2E11;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO                 = 0x2E10;
constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL                          = 0x2E7D;
constexpr unsigned int mmCOMPUTE_MISC_RESERVED                            = 0x2E1F;
constexpr unsigned int mmCOMPUTE_NOWHERE                                  = 0x2E7F;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_X                             = 0x2E07;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y                             = 0x2E08;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z                             = 0x2E09;
constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE                         = 0x2E0B;
constexpr unsigned int mmCOMPUTE_PGM_HI                                   = 0x2E0D;
constexpr unsigned int mmCOMPUTE_PGM_LO                                   = 0x2E0C;
constexpr unsigned int mmCOMPUTE_PGM_RSRC1                                = 0x2E12;
constexpr unsigned int mmCOMPUTE_PGM_RSRC2                                = 0x2E13;
constexpr unsigned int mmCOMPUTE_PGM_RSRC3                                = 0x2E28;
constexpr unsigned int mmCOMPUTE_PIPELINESTAT_ENABLE                      = 0x2E0A;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_X                          = 0x2E35;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_Y                          = 0x2E36;
constexpr unsigned int mmCOMPUTE_PRESCALED_DIM_Z                          = 0x2E37;
constexpr unsigned int mmCOMPUTE_RELAUNCH                                 = 0x2E30;
constexpr unsigned int mmCOMPUTE_RELAUNCH2                                = 0x2E33;
constexpr unsigned int mmCOMPUTE_REQ_CTRL                                 = 0x2E22;
constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS                          = 0x2E15;
constexpr unsigned int mmCOMPUTE_RESTART_X                                = 0x2E1B;
constexpr unsigned int mmCOMPUTE_RESTART_Y                                = 0x2E1C;
constexpr unsigned int mmCOMPUTE_RESTART_Z                                = 0x2E1D;
constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM                            = 0x2E2A;
constexpr unsigned int mmCOMPUTE_START_X                                  = 0x2E04;
constexpr unsigned int mmCOMPUTE_START_Y                                  = 0x2E05;
constexpr unsigned int mmCOMPUTE_START_Z                                  = 0x2E06;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE0                   = 0x2E16;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE1                   = 0x2E17;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE2                   = 0x2E19;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE3                   = 0x2E1A;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE4                   = 0x2E2B;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE5                   = 0x2E2C;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE6                   = 0x2E2D;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE7                   = 0x2E2E;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE8                   = 0x2E23;
constexpr unsigned int mmCOMPUTE_THREADGROUP_ID                           = 0x2E21;
constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE                      = 0x2E1E;
constexpr unsigned int mmCOMPUTE_TMPRING_SIZE                             = 0x2E18;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_0                             = 0x2E24;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_1                             = 0x2E25;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_2                             = 0x2E26;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_3                             = 0x2E27;
constexpr unsigned int mmCOMPUTE_USER_DATA_0                              = 0x2E40;
constexpr unsigned int mmCOMPUTE_USER_DATA_1                              = 0x2E41;
constexpr unsigned int mmCOMPUTE_USER_DATA_2                              = 0x2E42;
constexpr unsigned int mmCOMPUTE_USER_DATA_3                              = 0x2E43;
constexpr unsigned int mmCOMPUTE_USER_DATA_4                              = 0x2E44;
constexpr unsigned int mmCOMPUTE_USER_DATA_5                              = 0x2E45;
constexpr unsigned int mmCOMPUTE_USER_DATA_6                              = 0x2E46;
constexpr unsigned int mmCOMPUTE_USER_DATA_7                              = 0x2E47;
constexpr unsigned int mmCOMPUTE_USER_DATA_8                              = 0x2E48;
constexpr unsigned int mmCOMPUTE_USER_DATA_9                              = 0x2E49;
constexpr unsigned int mmCOMPUTE_USER_DATA_10                             = 0x2E4A;
constexpr unsigned int mmCOMPUTE_USER_DATA_11                             = 0x2E4B;
constexpr unsigned int mmCOMPUTE_USER_DATA_12                             = 0x2E4C;
constexpr unsigned int mmCOMPUTE_USER_DATA_13                             = 0x2E4D;
constexpr unsigned int mmCOMPUTE_USER_DATA_14                             = 0x2E4E;
constexpr unsigned int mmCOMPUTE_USER_DATA_15                             = 0x2E4F;
constexpr unsigned int mmCOMPUTE_VMID                                     = 0x2E14;
constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI                     = 0x2E32;
constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO                     = 0x2E31;
constexpr unsigned int mmCPC_PERFCOUNTER0_HI                              = 0xD007;
constexpr unsigned int mmCPC_PERFCOUNTER0_LO                              = 0xD006;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT                          = 0xD809;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT1                         = 0xD804;
constexpr unsigned int mmCPC_PERFCOUNTER1_HI                              = 0xD005;
constexpr unsigned int mmCPC_PERFCOUNTER1_LO                              = 0xD004;
constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT                          = 0xD803;
constexpr unsigned int mmCPF_PERFCOUNTER0_HI                              = 0xD00B;
constexpr unsigned int mmCPF_PERFCOUNTER0_LO                              = 0xD00A;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT                          = 0xD807;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT1                         = 0xD806;
constexpr unsigned int mmCPF_PERFCOUNTER1_HI                              = 0xD009;
constexpr unsigned int mmCPF_PERFCOUNTER1_LO                              = 0xD008;
constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT                          = 0xD805;
constexpr unsigned int mmCPG_PERFCOUNTER0_HI                              = 0xD003;
constexpr unsigned int mmCPG_PERFCOUNTER0_LO                              = 0xD002;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT                          = 0xD802;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT1                         = 0xD801;
constexpr unsigned int mmCPG_PERFCOUNTER1_HI                              = 0xD001;
constexpr unsigned int mmCPG_PERFCOUNTER1_LO                              = 0xD000;
constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT                          = 0xD800;
constexpr unsigned int mmCP_DMA_CNTL                                      = 0xC08A;
constexpr unsigned int mmCP_DMA_ME_CMD_ADDR_HI                            = 0xC09D;
constexpr unsigned int mmCP_DMA_ME_CMD_ADDR_LO                            = 0xC09C;
constexpr unsigned int mmCP_DMA_ME_COMMAND                                = 0xC084;
constexpr unsigned int mmCP_DMA_ME_CONTROL                                = 0xC078;
constexpr unsigned int mmCP_DMA_ME_DST_ADDR                               = 0xC082;
constexpr unsigned int mmCP_DMA_ME_DST_ADDR_HI                            = 0xC083;
constexpr unsigned int mmCP_DMA_ME_SRC_ADDR                               = 0xC080;
constexpr unsigned int mmCP_DMA_ME_SRC_ADDR_HI                            = 0xC081;
constexpr unsigned int mmCP_DMA_PFP_CMD_ADDR_HI                           = 0xC09F;
constexpr unsigned int mmCP_DMA_PFP_CMD_ADDR_LO                           = 0xC09E;
constexpr unsigned int mmCP_DMA_PFP_COMMAND                               = 0xC089;
constexpr unsigned int mmCP_DMA_PFP_CONTROL                               = 0xC077;
constexpr unsigned int mmCP_DMA_PFP_DST_ADDR                              = 0xC087;
constexpr unsigned int mmCP_DMA_PFP_DST_ADDR_HI                           = 0xC088;
constexpr unsigned int mmCP_DMA_PFP_SRC_ADDR                              = 0xC085;
constexpr unsigned int mmCP_DMA_PFP_SRC_ADDR_HI                           = 0xC086;
constexpr unsigned int mmCP_DMA_PIO_COMMAND                               = 0xC0E8;
constexpr unsigned int mmCP_DMA_PIO_CONTROL                               = 0xC063;
constexpr unsigned int mmCP_DMA_PIO_DST_ADDR                              = 0xC066;
constexpr unsigned int mmCP_DMA_PIO_DST_ADDR_HI                           = 0xC067;
constexpr unsigned int mmCP_DMA_PIO_SRC_ADDR                              = 0xC064;
constexpr unsigned int mmCP_DMA_PIO_SRC_ADDR_HI                           = 0xC065;
constexpr unsigned int mmCP_DMA_READ_TAGS                                 = 0xC08B;
constexpr unsigned int mmCP_DMA_WATCH0_ADDR_HI                            = 0x3121;
constexpr unsigned int mmCP_DMA_WATCH0_ADDR_LO                            = 0x3120;
constexpr unsigned int mmCP_DMA_WATCH0_CNTL                               = 0x3123;
constexpr unsigned int mmCP_DMA_WATCH0_MASK                               = 0x3122;
constexpr unsigned int mmCP_DMA_WATCH1_ADDR_HI                            = 0x3125;
constexpr unsigned int mmCP_DMA_WATCH1_ADDR_LO                            = 0x3124;
constexpr unsigned int mmCP_DMA_WATCH1_CNTL                               = 0x3127;
constexpr unsigned int mmCP_DMA_WATCH1_MASK                               = 0x3126;
constexpr unsigned int mmCP_DMA_WATCH2_ADDR_HI                            = 0x3129;
constexpr unsigned int mmCP_DMA_WATCH2_ADDR_LO                            = 0x3128;
constexpr unsigned int mmCP_DMA_WATCH2_CNTL                               = 0x312B;
constexpr unsigned int mmCP_DMA_WATCH2_MASK                               = 0x312A;
constexpr unsigned int mmCP_DMA_WATCH3_ADDR_HI                            = 0x312D;
constexpr unsigned int mmCP_DMA_WATCH3_ADDR_LO                            = 0x312C;
constexpr unsigned int mmCP_DMA_WATCH3_CNTL                               = 0x312F;
constexpr unsigned int mmCP_DMA_WATCH3_MASK                               = 0x312E;
constexpr unsigned int mmCP_DMA_WATCH_STAT                                = 0x3132;
constexpr unsigned int mmCP_DMA_WATCH_STAT_ADDR_HI                        = 0x3131;
constexpr unsigned int mmCP_DMA_WATCH_STAT_ADDR_LO                        = 0x3130;
constexpr unsigned int mmCP_EOP_DONE_ADDR_HI                              = 0xC001;
constexpr unsigned int mmCP_EOP_DONE_ADDR_LO                              = 0xC000;
constexpr unsigned int mmCP_EOP_DONE_CNTX_ID                              = 0xC0D7;
constexpr unsigned int mmCP_EOP_DONE_DATA_CNTL                            = 0xC0D6;
constexpr unsigned int mmCP_EOP_DONE_DATA_HI                              = 0xC003;
constexpr unsigned int mmCP_EOP_DONE_DATA_LO                              = 0xC002;
constexpr unsigned int mmCP_EOP_DONE_EVENT_CNTL                           = 0xC0D5;
constexpr unsigned int mmCP_EOP_LAST_FENCE_HI                             = 0xC005;
constexpr unsigned int mmCP_EOP_LAST_FENCE_LO                             = 0xC004;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_BASE0                   = 0xCA49;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_BASE1                   = 0xCA79;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_CNTL0                   = 0xCA4B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_CNTL1                   = 0xCA7B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_MASK0                   = 0xCA4A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE0_MASK1                   = 0xCA7A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_BASE0                   = 0xCA4C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_BASE1                   = 0xCA7C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_CNTL0                   = 0xCA4E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_CNTL1                   = 0xCA7E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_MASK0                   = 0xCA4D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE1_MASK1                   = 0xCA7D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_BASE0                   = 0xCA4F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_BASE1                   = 0xCA7F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_CNTL0                   = 0xCA51;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_CNTL1                   = 0xCA81;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_MASK0                   = 0xCA50;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE2_MASK1                   = 0xCA80;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_BASE0                   = 0xCA52;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_BASE1                   = 0xCA82;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_CNTL0                   = 0xCA54;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_CNTL1                   = 0xCA84;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_MASK0                   = 0xCA53;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE3_MASK1                   = 0xCA83;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_BASE0                   = 0xCA55;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_BASE1                   = 0xCA85;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_CNTL0                   = 0xCA57;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_CNTL1                   = 0xCA87;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_MASK0                   = 0xCA56;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE4_MASK1                   = 0xCA86;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_BASE0                   = 0xCA58;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_BASE1                   = 0xCA88;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_CNTL0                   = 0xCA5A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_CNTL1                   = 0xCA8A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_MASK0                   = 0xCA59;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE5_MASK1                   = 0xCA89;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_BASE0                   = 0xCA5B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_BASE1                   = 0xCA8B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_CNTL0                   = 0xCA5D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_CNTL1                   = 0xCA8D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_MASK0                   = 0xCA5C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE6_MASK1                   = 0xCA8C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_BASE0                   = 0xCA5E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_BASE1                   = 0xCA8E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_CNTL0                   = 0xCA60;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_CNTL1                   = 0xCA90;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_MASK0                   = 0xCA5F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE7_MASK1                   = 0xCA8F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_BASE0                   = 0xCA61;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_BASE1                   = 0xCA91;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_CNTL0                   = 0xCA63;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_CNTL1                   = 0xCA93;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_MASK0                   = 0xCA62;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE8_MASK1                   = 0xCA92;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_BASE0                   = 0xCA64;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_BASE1                   = 0xCA94;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_CNTL0                   = 0xCA66;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_CNTL1                   = 0xCA96;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_MASK0                   = 0xCA65;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE9_MASK1                   = 0xCA95;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_BASE0                  = 0xCA67;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_BASE1                  = 0xCA97;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_CNTL0                  = 0xCA69;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_CNTL1                  = 0xCA99;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_MASK0                  = 0xCA68;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE10_MASK1                  = 0xCA98;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_BASE0                  = 0xCA6A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_BASE1                  = 0xCA9A;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_CNTL0                  = 0xCA6C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_CNTL1                  = 0xCA9C;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_MASK0                  = 0xCA6B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE11_MASK1                  = 0xCA9B;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_BASE0                  = 0xCA6D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_BASE1                  = 0xCA9D;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_CNTL0                  = 0xCA6F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_CNTL1                  = 0xCA9F;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_MASK0                  = 0xCA6E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE12_MASK1                  = 0xCA9E;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_BASE0                  = 0xCA70;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_BASE1                  = 0xCAA0;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_CNTL0                  = 0xCA72;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_CNTL1                  = 0xCAA2;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_MASK0                  = 0xCA71;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE13_MASK1                  = 0xCAA1;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_BASE0                  = 0xCA73;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_BASE1                  = 0xCAA3;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_CNTL0                  = 0xCA75;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_CNTL1                  = 0xCAA5;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_MASK0                  = 0xCA74;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE14_MASK1                  = 0xCAA4;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_BASE0                  = 0xCA76;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_BASE1                  = 0xCAA6;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_CNTL0                  = 0xCA78;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_CNTL1                  = 0xCAA8;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_MASK0                  = 0xCA77;
constexpr unsigned int mmCP_GFX_RS64_DC_APERTURE15_MASK1                  = 0xCAA7;
constexpr unsigned int mmCP_GFX_RS64_PERFCOUNT_CNTL0                      = 0xCA1A;
constexpr unsigned int mmCP_GFX_RS64_PERFCOUNT_CNTL1                      = 0xCA1B;
constexpr unsigned int mmCP_HQD_ACTIVE                                    = 0x320B;
constexpr unsigned int mmCP_HQD_AQL_CONTROL                               = 0x323E;
constexpr unsigned int mmCP_HQD_ATOMIC0_PREOP_HI                          = 0x3226;
constexpr unsigned int mmCP_HQD_ATOMIC0_PREOP_LO                          = 0x3225;
constexpr unsigned int mmCP_HQD_ATOMIC1_PREOP_HI                          = 0x3228;
constexpr unsigned int mmCP_HQD_ATOMIC1_PREOP_LO                          = 0x3227;
constexpr unsigned int mmCP_HQD_CNTL_STACK_OFFSET                         = 0x3237;
constexpr unsigned int mmCP_HQD_CNTL_STACK_SIZE                           = 0x3238;
constexpr unsigned int mmCP_HQD_CTX_SAVE_BASE_ADDR_HI                     = 0x3235;
constexpr unsigned int mmCP_HQD_CTX_SAVE_BASE_ADDR_LO                     = 0x3234;
constexpr unsigned int mmCP_HQD_CTX_SAVE_CONTROL                          = 0x3236;
constexpr unsigned int mmCP_HQD_CTX_SAVE_SIZE                             = 0x323A;
constexpr unsigned int mmCP_HQD_DDID_DELTA_RPT_COUNT                      = 0x3247;
constexpr unsigned int mmCP_HQD_DDID_INFLIGHT_COUNT                       = 0x3246;
constexpr unsigned int mmCP_HQD_DDID_RPTR                                 = 0x3244;
constexpr unsigned int mmCP_HQD_DDID_WPTR                                 = 0x3245;
constexpr unsigned int mmCP_HQD_DEQUEUE_REQUEST                           = 0x3221;
constexpr unsigned int mmCP_HQD_DEQUEUE_STATUS                            = 0x3248;
constexpr unsigned int mmCP_HQD_DMA_OFFLOAD                               = 0x3222;
constexpr unsigned int mmCP_HQD_EOP_BASE_ADDR                             = 0x322E;
constexpr unsigned int mmCP_HQD_EOP_BASE_ADDR_HI                          = 0x322F;
constexpr unsigned int mmCP_HQD_EOP_CONTROL                               = 0x3230;
constexpr unsigned int mmCP_HQD_EOP_EVENTS                                = 0x3233;
constexpr unsigned int mmCP_HQD_EOP_RPTR                                  = 0x3231;
constexpr unsigned int mmCP_HQD_EOP_WPTR                                  = 0x3232;
constexpr unsigned int mmCP_HQD_EOP_WPTR_MEM                              = 0x323D;
constexpr unsigned int mmCP_HQD_ERROR                                     = 0x323C;
constexpr unsigned int mmCP_HQD_GDS_RESOURCE_STATE                        = 0x323B;
constexpr unsigned int mmCP_HQD_GFX_CONTROL                               = 0x30FF;
constexpr unsigned int mmCP_HQD_GFX_STATUS                                = 0x3100;
constexpr unsigned int mmCP_HQD_HQ_CONTROL0                               = 0x322A;
constexpr unsigned int mmCP_HQD_HQ_CONTROL1                               = 0x322D;
constexpr unsigned int mmCP_HQD_HQ_SCHEDULER0                             = 0x3229;
constexpr unsigned int mmCP_HQD_HQ_SCHEDULER1                             = 0x322A;
constexpr unsigned int mmCP_HQD_HQ_STATUS0                                = 0x3229;
constexpr unsigned int mmCP_HQD_HQ_STATUS1                                = 0x322C;
constexpr unsigned int mmCP_HQD_IB_BASE_ADDR                              = 0x321B;
constexpr unsigned int mmCP_HQD_IB_BASE_ADDR_HI                           = 0x321C;
constexpr unsigned int mmCP_HQD_IB_CONTROL                                = 0x321E;
constexpr unsigned int mmCP_HQD_IB_RPTR                                   = 0x321D;
constexpr unsigned int mmCP_HQD_IQ_RPTR                                   = 0x3220;
constexpr unsigned int mmCP_HQD_IQ_TIMER                                  = 0x321F;
constexpr unsigned int mmCP_HQD_MSG_TYPE                                  = 0x3224;
constexpr unsigned int mmCP_HQD_OFFLOAD                                   = 0x3222;
constexpr unsigned int mmCP_HQD_PERSISTENT_STATE                          = 0x320D;
constexpr unsigned int mmCP_HQD_PIPE_PRIORITY                             = 0x320E;
constexpr unsigned int mmCP_HQD_PQ_BASE                                   = 0x3211;
constexpr unsigned int mmCP_HQD_PQ_BASE_HI                                = 0x3212;
constexpr unsigned int mmCP_HQD_PQ_CONTROL                                = 0x321A;
constexpr unsigned int mmCP_HQD_PQ_DOORBELL_CONTROL                       = 0x3218;
constexpr unsigned int mmCP_HQD_PQ_RPTR                                   = 0x3213;
constexpr unsigned int mmCP_HQD_PQ_RPTR_REPORT_ADDR                       = 0x3214;
constexpr unsigned int mmCP_HQD_PQ_RPTR_REPORT_ADDR_HI                    = 0x3215;
constexpr unsigned int mmCP_HQD_PQ_WPTR_HI                                = 0x3240;
constexpr unsigned int mmCP_HQD_PQ_WPTR_LO                                = 0x323F;
constexpr unsigned int mmCP_HQD_PQ_WPTR_POLL_ADDR                         = 0x3216;
constexpr unsigned int mmCP_HQD_PQ_WPTR_POLL_ADDR_HI                      = 0x3217;
constexpr unsigned int mmCP_HQD_QUANTUM                                   = 0x3210;
constexpr unsigned int mmCP_HQD_QUEUE_PRIORITY                            = 0x320F;
constexpr unsigned int mmCP_HQD_SECURE_REQ0                               = 0xB820;
constexpr unsigned int mmCP_HQD_SUSPEND_CNTL_STACK_DW_CNT                 = 0x3242;
constexpr unsigned int mmCP_HQD_SUSPEND_CNTL_STACK_OFFSET                 = 0x3241;
constexpr unsigned int mmCP_HQD_SUSPEND_WG_STATE_OFFSET                   = 0x3243;
constexpr unsigned int mmCP_HQD_VMID                                      = 0x320C;
constexpr unsigned int mmCP_HQD_WG_STATE_OFFSET                           = 0x3239;
constexpr unsigned int mmCP_INT_CNTL                                      = 0x3049;
constexpr unsigned int mmCP_INT_CNTL_RING0                                = 0x306A;
constexpr unsigned int mmCP_INT_STATUS                                    = 0x304A;
constexpr unsigned int mmCP_INT_STATUS_RING0                              = 0x306D;
constexpr unsigned int mmCP_MEC_RS64_PERFCOUNT_CNTL                       = 0xC934;
constexpr unsigned int mmCP_MES_PERFCOUNT_CNTL                            = 0xC899;
constexpr unsigned int mmCP_ME_COHER_BASE                                 = 0xC101;
constexpr unsigned int mmCP_ME_COHER_BASE_HI                              = 0xC102;
constexpr unsigned int mmCP_ME_COHER_CNTL                                 = 0xC0FE;
constexpr unsigned int mmCP_ME_COHER_SIZE                                 = 0xC0FF;
constexpr unsigned int mmCP_ME_COHER_SIZE_HI                              = 0xC100;
constexpr unsigned int mmCP_ME_COHER_STATUS                               = 0xC103;
constexpr unsigned int mmCP_MQD_BASE_ADDR                                 = 0x3209;
constexpr unsigned int mmCP_MQD_BASE_ADDR_HI                              = 0x320A;
constexpr unsigned int mmCP_MQD_CONTROL                                   = 0x322B;
constexpr unsigned int mmCP_PERFMON_CNTL                                  = 0xD808;
constexpr unsigned int mmCP_PERFMON_CNTX_CNTL                             = 0xA0D8;
constexpr unsigned int mmCP_PIPEID                                        = 0xA0D9;
constexpr unsigned int mmCP_PIPE_STATS_ADDR_HI                            = 0xC019;
constexpr unsigned int mmCP_PIPE_STATS_ADDR_LO                            = 0xC018;
constexpr unsigned int mmCP_PIPE_STATS_CONTROL                            = 0xC03D;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_HI                          = 0xC02D;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_LO                          = 0xC02C;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_HI                          = 0xC02F;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_LO                          = 0xC02E;
constexpr unsigned int mmCP_STAT                                          = 0x21A0;
constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_HI                          = 0xC033;
constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_LO                          = 0xC032;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_HI                          = 0xC031;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_LO                          = 0xC030;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_HI                          = 0xC027;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_LO                          = 0xC026;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_HI                          = 0xC023;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_LO                          = 0xC022;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_HI                           = 0xC01F;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_LO                           = 0xC01E;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_HI                          = 0xC025;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_LO                          = 0xC024;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_HI                           = 0xC01D;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_LO                           = 0xC01C;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_HI                           = 0xC01B;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_LO                           = 0xC01A;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_HI                          = 0xC021;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_LO                          = 0xC020;
constexpr unsigned int mmDB_ALPHA_TO_MASK                                 = 0xA01F;
constexpr unsigned int mmDB_ARB_CONFIG                                    = 0x2633;
constexpr unsigned int mmDB_CGTT_CLK_CTRL_0                               = 0xF0A4;
constexpr unsigned int mmDB_COUNT_CONTROL                                 = 0xA018;
constexpr unsigned int mmDB_CREDIT_LIMIT                                  = 0x2614;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX                              = 0xA015;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN                              = 0xA014;
constexpr unsigned int mmDB_DEPTH_CONTROL                                 = 0xA01C;
constexpr unsigned int mmDB_DEPTH_SIZE_XY                                 = 0xA005;
constexpr unsigned int mmDB_DEPTH_VIEW                                    = 0xA001;
constexpr unsigned int mmDB_DEPTH_VIEW1                                   = 0xA002;
constexpr unsigned int mmDB_DFD_INDIRECT_DAT                              = 0x2635;
constexpr unsigned int mmDB_DFD_INDIRECT_SEL                              = 0x2634;
constexpr unsigned int mmDB_EQAA                                          = 0xA01E;
constexpr unsigned int mmDB_EXCEPTION_CONTROL                             = 0x261F;
constexpr unsigned int mmDB_FGCG_INTERFACES_CLK_CTRL                      = 0x2638;
constexpr unsigned int mmDB_FGCG_SRAMS_CLK_CTRL                           = 0x2637;
constexpr unsigned int mmDB_FIFO_DEPTH1                                   = 0x2618;
constexpr unsigned int mmDB_FIFO_DEPTH2                                   = 0x2619;
constexpr unsigned int mmDB_FIFO_DEPTH3                                   = 0x261D;
constexpr unsigned int mmDB_FIFO_DEPTH4                                   = 0x2639;
constexpr unsigned int mmDB_FREE_CACHELINES                               = 0x2617;
constexpr unsigned int mmDB_GL1_INTERFACE_CONTROL                         = 0xA010;
constexpr unsigned int mmDB_HTILE_SURFACE                                 = 0xA2AF;
constexpr unsigned int mmDB_MEM_ARB_WATERMARKS                            = 0x261C;
constexpr unsigned int mmDB_MEM_CONFIG                                    = 0x2632;
constexpr unsigned int mmDB_MEM_TEMPORAL                                  = 0xA012;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI                           = 0xC3C1;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW                          = 0xC3C0;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI                           = 0xC3C3;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW                          = 0xC3C2;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI                           = 0xC3C5;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW                          = 0xC3C4;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI                           = 0xC3C7;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW                          = 0xC3C6;
constexpr unsigned int mmDB_PERFCOUNTER0_HI                               = 0xD441;
constexpr unsigned int mmDB_PERFCOUNTER0_LO                               = 0xD440;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT                           = 0xDC40;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1                          = 0xDC41;
constexpr unsigned int mmDB_PERFCOUNTER1_HI                               = 0xD443;
constexpr unsigned int mmDB_PERFCOUNTER1_LO                               = 0xD442;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT                           = 0xDC42;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1                          = 0xDC43;
constexpr unsigned int mmDB_PERFCOUNTER2_HI                               = 0xD445;
constexpr unsigned int mmDB_PERFCOUNTER2_LO                               = 0xD444;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT                           = 0xDC44;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT1                          = 0xDC45;
constexpr unsigned int mmDB_PERFCOUNTER3_HI                               = 0xD447;
constexpr unsigned int mmDB_PERFCOUNTER3_LO                               = 0xD446;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT                           = 0xDC46;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT1                          = 0xDC47;
constexpr unsigned int mmDB_RENDER_CONTROL                                = 0xA000;
constexpr unsigned int mmDB_RENDER_OVERRIDE                               = 0xA003;
constexpr unsigned int mmDB_RENDER_OVERRIDE2                              = 0xA004;
constexpr unsigned int mmDB_RING_CONTROL                                  = 0x261B;
constexpr unsigned int mmDB_SHADER_CONTROL                                = 0xA01B;
constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION                       = 0xA01A;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0                       = 0xA2B0;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1                       = 0xA2B1;
constexpr unsigned int mmDB_STENCIL_CONTROL                               = 0xA01D;
constexpr unsigned int mmDB_STENCIL_INFO                                  = 0xA007;
constexpr unsigned int mmDB_STENCIL_OPVAL                                 = 0xA023;
constexpr unsigned int mmDB_STENCIL_READ_BASE                             = 0xA00C;
constexpr unsigned int mmDB_STENCIL_READ_BASE_HI                          = 0xA00D;
constexpr unsigned int mmDB_STENCIL_READ_MASK                             = 0xA024;
constexpr unsigned int mmDB_STENCIL_REF                                   = 0xA022;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE                            = 0xA00E;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI                         = 0xA00F;
constexpr unsigned int mmDB_STENCIL_WRITE_MASK                            = 0xA025;
constexpr unsigned int mmDB_SUMMARIZER_TIMEOUTS                           = 0x2636;
constexpr unsigned int mmDB_VIEWPORT_CONTROL                              = 0xA019;
constexpr unsigned int mmDB_WATERMARKS                                    = 0x2615;
constexpr unsigned int mmDB_Z_INFO                                        = 0xA006;
constexpr unsigned int mmDB_Z_READ_BASE                                   = 0xA008;
constexpr unsigned int mmDB_Z_READ_BASE_HI                                = 0xA009;
constexpr unsigned int mmDB_Z_WRITE_BASE                                  = 0xA00A;
constexpr unsigned int mmDB_Z_WRITE_BASE_HI                               = 0xA00B;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x12400C81;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x12400C83;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x12400C85;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x12400C87;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x12400C89;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x12400C8B;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x12400C8D;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x12400C8F;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi8                         = 0x12400C91;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi9                         = 0x12400C93;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi10                        = 0x12400C95;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi11                        = 0x12400C97;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi12                        = 0x12400C99;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi13                        = 0x12400C9B;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi14                        = 0x12400C9D;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi15                        = 0x12400C9F;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x12400C80;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x12400C82;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x12400C84;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x12400C86;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x12400C88;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x12400C8A;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x12400C8C;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x12400C8E;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo8                         = 0x12400C90;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo9                         = 0x12400C92;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo10                        = 0x12400C94;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo11                        = 0x12400C96;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo12                        = 0x12400C98;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo13                        = 0x12400C9A;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo14                        = 0x12400C9C;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo15                        = 0x12400C9E;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x12400CC1;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x12400CC3;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x12400CC5;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x12400CC7;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x12400CC9;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x12400CCB;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x12400CCD;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x12400CCF;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi8                         = 0x12400CD1;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi9                         = 0x12400CD3;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi10                        = 0x12400CD5;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi11                        = 0x12400CD7;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi12                        = 0x12400CD9;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi13                        = 0x12400CDB;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi14                        = 0x12400CDD;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi15                        = 0x12400CDF;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x12400CC0;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x12400CC2;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x12400CC4;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x12400CC6;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x12400CC8;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x12400CCA;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x12400CCC;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x12400CCE;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo8                         = 0x12400CD0;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo9                         = 0x12400CD2;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo10                        = 0x12400CD4;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo11                        = 0x12400CD6;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo12                        = 0x12400CD8;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo13                        = 0x12400CDA;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo14                        = 0x12400CDC;
constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo15                        = 0x12400CDE;
constexpr unsigned int mmGB_ADDR_CONFIG                                   = 0x263E;
constexpr unsigned int mmGB_ADDR_CONFIG_READ                              = 0x2642;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG                      = 0xDD30;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG                      = 0xDD31;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG                      = 0xDD32;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG                      = 0xDD33;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG                      = 0xDD34;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG                      = 0xDD35;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG                      = 0xDD36;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG                      = 0xDD37;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI                        = 0xD4E5;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO                        = 0xD4E4;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                 = 0xDD38;
constexpr unsigned int mmGCR_PERFCOUNTER0_HI                              = 0xD521;
constexpr unsigned int mmGCR_PERFCOUNTER0_LO                              = 0xD520;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT                          = 0xDD60;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1                         = 0xDD61;
constexpr unsigned int mmGCR_PERFCOUNTER1_HI                              = 0xD523;
constexpr unsigned int mmGCR_PERFCOUNTER1_LO                              = 0xD522;
constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT                          = 0xDD62;
constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT1                         = 0xDD63;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI                         = 0xD4E2;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO                         = 0xD4E0;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE                       = 0xDD24;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT                     = 0xDD20;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1                    = 0xDD22;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI                         = 0xD4E3;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO                         = 0xD4E1;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE                       = 0xDD25;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT                     = 0xDD21;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1                    = 0xDD23;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_HI                       = 0xD261;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_LO                       = 0xD260;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_SELECT                   = 0xDA00;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER0_SELECT1                  = 0xDA01;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_HI                       = 0xD263;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_LO                       = 0xD262;
constexpr unsigned int mmGC_EA_CPWD_PERFCOUNTER1_SELECT                   = 0xDA02;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_HI                         = 0xD271;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_LO                         = 0xD270;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_SELECT                     = 0xDA20;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER0_SELECT1                    = 0xDA21;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_HI                         = 0xD273;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_LO                         = 0xD272;
constexpr unsigned int mmGC_EA_SE_PERFCOUNTER1_SELECT                     = 0xDA22;
constexpr unsigned int mmGE1_PERFCOUNTER0_HI                              = 0xD0A5;
constexpr unsigned int mmGE1_PERFCOUNTER0_LO                              = 0xD0A4;
constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT                          = 0xD8A4;
constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1                         = 0xD8A5;
constexpr unsigned int mmGE1_PERFCOUNTER1_HI                              = 0xD0A7;
constexpr unsigned int mmGE1_PERFCOUNTER1_LO                              = 0xD0A6;
constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT                          = 0xD8A6;
constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1                         = 0xD8A7;
constexpr unsigned int mmGE1_PERFCOUNTER2_HI                              = 0xD0A9;
constexpr unsigned int mmGE1_PERFCOUNTER2_LO                              = 0xD0A8;
constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT                          = 0xD8A8;
constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1                         = 0xD8A9;
constexpr unsigned int mmGE1_PERFCOUNTER3_HI                              = 0xD0AB;
constexpr unsigned int mmGE1_PERFCOUNTER3_LO                              = 0xD0AA;
constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT                          = 0xD8AA;
constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1                         = 0xD8AB;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI                         = 0xD0AD;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO                         = 0xD0AC;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT                     = 0xD8AC;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1                    = 0xD8AD;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI                         = 0xD0AF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO                         = 0xD0AE;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT                     = 0xD8AE;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1                    = 0xD8AF;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI                         = 0xD0B1;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO                         = 0xD0B0;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT                     = 0xD8B0;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1                    = 0xD8B1;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI                         = 0xD0B3;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO                         = 0xD0B2;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT                     = 0xD8B2;
constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1                    = 0xD8B3;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI                           = 0xD0B5;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO                           = 0xD0B4;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT                       = 0xD8B4;
constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1                      = 0xD8B5;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI                           = 0xD0B7;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO                           = 0xD0B6;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT                       = 0xD8B6;
constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1                      = 0xD8B7;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI                           = 0xD0B9;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO                           = 0xD0B8;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT                       = 0xD8B8;
constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1                      = 0xD8B9;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI                           = 0xD0BB;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO                           = 0xD0BA;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT                       = 0xD8BA;
constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1                      = 0xD8BB;
constexpr unsigned int mmGE_CNTL                                          = 0xC25B;
constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM                         = 0xC264;
constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_1                       = 0xC265;
constexpr unsigned int mmGE_GS_ORDERED_ID_BASE                            = 0xC26C;
constexpr unsigned int mmGE_GS_THROTTLE                                   = 0xC254;
constexpr unsigned int mmGE_IA_ENHANCE                                    = 0xA29C;
constexpr unsigned int mmGE_INDX_OFFSET                                   = 0xC24A;
constexpr unsigned int mmGE_MAX_OUTPUT_PER_SUBGROUP                       = 0xA1FF;
constexpr unsigned int mmGE_MAX_VTX_INDX                                  = 0xC259;
constexpr unsigned int mmGE_MIN_VTX_INDX                                  = 0xC249;
constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN                        = 0xC24B;
constexpr unsigned int mmGE_NGG_SUBGRP_CNTL                               = 0xA2D3;
constexpr unsigned int mmGE_PA_IF_SAFE_REG                                = 0x2279;
constexpr unsigned int mmGE_POS_RING_BASE                                 = 0xC268;
constexpr unsigned int mmGE_POS_RING_SIZE                                 = 0xC269;
constexpr unsigned int mmGE_PRIM_RING_BASE                                = 0xC26A;
constexpr unsigned int mmGE_PRIM_RING_SIZE                                = 0xC26B;
constexpr unsigned int mmGE_PRIV_CONTROL                                  = 0x2264;
constexpr unsigned int mmGE_RATE_CNTL_1                                   = 0x2254;
constexpr unsigned int mmGE_RATE_CNTL_2                                   = 0x2255;
constexpr unsigned int mmGE_SE_CNTL_STATUS                                = 0x2271;
constexpr unsigned int mmGE_SE_ENHANCE                                    = 0xA294;
constexpr unsigned int mmGE_SPI_IF_SAFE_REG                               = 0x2278;
constexpr unsigned int mmGE_STATUS                                        = 0x2265;
constexpr unsigned int mmGE_STEREO_CNTL                                   = 0xC25F;
constexpr unsigned int mmGE_USER_VGPR1                                    = 0xC25C;
constexpr unsigned int mmGE_USER_VGPR2                                    = 0xC25D;
constexpr unsigned int mmGE_USER_VGPR3                                    = 0xC25E;
constexpr unsigned int mmGE_USER_VGPR_EN                                  = 0xC260;
constexpr unsigned int mmGE_VRS_RATE                                      = 0xC263;
constexpr unsigned int mmGE_WD_CNTL_STATUS                                = 0x223F;
constexpr unsigned int mmGE_WD_ENHANCE                                    = 0xA2A0;
constexpr unsigned int mmGL1A_PERFCOUNTER0_HI                             = 0xD5C1;
constexpr unsigned int mmGL1A_PERFCOUNTER0_LO                             = 0xD5C0;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT                         = 0xDDC0;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT1                        = 0xDDC1;
constexpr unsigned int mmGL1A_PERFCOUNTER1_HI                             = 0xD5C3;
constexpr unsigned int mmGL1A_PERFCOUNTER1_LO                             = 0xD5C2;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT                         = 0xDDC2;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT1                        = 0xDDC3;
constexpr unsigned int mmGL1A_PERFCOUNTER2_HI                             = 0xD5C5;
constexpr unsigned int mmGL1A_PERFCOUNTER2_LO                             = 0xD5C4;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT                         = 0xDDC4;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT1                        = 0xDDC5;
constexpr unsigned int mmGL1A_PERFCOUNTER3_HI                             = 0xD5C7;
constexpr unsigned int mmGL1A_PERFCOUNTER3_LO                             = 0xD5C6;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT                         = 0xDDC6;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT1                        = 0xDDC7;
constexpr unsigned int mmGL1C_PERFCOUNTER0_HI                             = 0xD3A1;
constexpr unsigned int mmGL1C_PERFCOUNTER0_LO                             = 0xD3A0;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT                         = 0xDBA0;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT1                        = 0xDBA1;
constexpr unsigned int mmGL1C_PERFCOUNTER1_HI                             = 0xD3A3;
constexpr unsigned int mmGL1C_PERFCOUNTER1_LO                             = 0xD3A2;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT                         = 0xDBA2;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT1                        = 0xDBA3;
constexpr unsigned int mmGL1C_PERFCOUNTER2_HI                             = 0xD3A5;
constexpr unsigned int mmGL1C_PERFCOUNTER2_LO                             = 0xD3A4;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT                         = 0xDBA4;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT1                        = 0xDBA5;
constexpr unsigned int mmGL1C_PERFCOUNTER3_HI                             = 0xD3A7;
constexpr unsigned int mmGL1C_PERFCOUNTER3_LO                             = 0xD3A6;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT                         = 0xDBA6;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT1                        = 0xDBA7;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_HI                            = 0xD5C9;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_LO                            = 0xD5C8;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_SELECT                        = 0xDDC8;
constexpr unsigned int mmGL1XA_PERFCOUNTER0_SELECT1                       = 0xDDC9;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_HI                            = 0xD5CB;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_LO                            = 0xD5CA;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_SELECT                        = 0xDDCA;
constexpr unsigned int mmGL1XA_PERFCOUNTER1_SELECT1                       = 0xDDCB;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_HI                            = 0xD5CD;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_LO                            = 0xD5CC;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_SELECT                        = 0xDDCC;
constexpr unsigned int mmGL1XA_PERFCOUNTER2_SELECT1                       = 0xDDCD;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_HI                            = 0xD5CF;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_LO                            = 0xD5CE;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_SELECT                        = 0xDDCE;
constexpr unsigned int mmGL1XA_PERFCOUNTER3_SELECT1                       = 0xDDCF;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_HI                            = 0xD3A9;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_LO                            = 0xD3A8;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_SELECT                        = 0xDBA8;
constexpr unsigned int mmGL1XC_PERFCOUNTER0_SELECT1                       = 0xDBA9;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_HI                            = 0xD3AB;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_LO                            = 0xD3AA;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_SELECT                        = 0xDBAA;
constexpr unsigned int mmGL1XC_PERFCOUNTER1_SELECT1                       = 0xDBAB;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_HI                            = 0xD3AD;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_LO                            = 0xD3AC;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_SELECT                        = 0xDBAC;
constexpr unsigned int mmGL1XC_PERFCOUNTER2_SELECT1                       = 0xDBAD;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_HI                            = 0xD3AF;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_LO                            = 0xD3AE;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_SELECT                        = 0xDBAE;
constexpr unsigned int mmGL1XC_PERFCOUNTER3_SELECT1                       = 0xDBAF;
constexpr unsigned int mmGL2A_PERFCOUNTER0_HI                             = 0xD391;
constexpr unsigned int mmGL2A_PERFCOUNTER0_LO                             = 0xD390;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT                         = 0xDB90;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT1                        = 0xDB91;
constexpr unsigned int mmGL2A_PERFCOUNTER1_HI                             = 0xD393;
constexpr unsigned int mmGL2A_PERFCOUNTER1_LO                             = 0xD392;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT                         = 0xDB92;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT1                        = 0xDB93;
constexpr unsigned int mmGL2A_PERFCOUNTER2_HI                             = 0xD395;
constexpr unsigned int mmGL2A_PERFCOUNTER2_LO                             = 0xD394;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT                         = 0xDB94;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT1                        = 0xDB95;
constexpr unsigned int mmGL2A_PERFCOUNTER3_HI                             = 0xD397;
constexpr unsigned int mmGL2A_PERFCOUNTER3_LO                             = 0xD396;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT                         = 0xDB96;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT1                        = 0xDB97;
constexpr unsigned int mmGL2C_CTRL                                        = 0xCE00;
constexpr unsigned int mmGL2C_CTRL2                                       = 0xCE01;
constexpr unsigned int mmGL2C_CTRL3                                       = 0xCE0C;
constexpr unsigned int mmGL2C_CTRL4                                       = 0xCE17;
constexpr unsigned int mmGL2C_CTRL5                                       = 0xCE19;
constexpr unsigned int mmGL2C_PERFCOUNTER0_HI                             = 0xD381;
constexpr unsigned int mmGL2C_PERFCOUNTER0_LO                             = 0xD380;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT                         = 0xDB80;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT1                        = 0xDB81;
constexpr unsigned int mmGL2C_PERFCOUNTER1_HI                             = 0xD383;
constexpr unsigned int mmGL2C_PERFCOUNTER1_LO                             = 0xD382;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT                         = 0xDB82;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT1                        = 0xDB83;
constexpr unsigned int mmGL2C_PERFCOUNTER2_HI                             = 0xD385;
constexpr unsigned int mmGL2C_PERFCOUNTER2_LO                             = 0xD384;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT                         = 0xDB84;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT1                        = 0xDB85;
constexpr unsigned int mmGL2C_PERFCOUNTER3_HI                             = 0xD387;
constexpr unsigned int mmGL2C_PERFCOUNTER3_LO                             = 0xD386;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT                         = 0xDB86;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT1                        = 0xDB87;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_HI                            = 0xD0FB;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_LO                            = 0xD0FA;
constexpr unsigned int mmGRBMH_PERFCOUNTER0_SELECT                        = 0xD8F8;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_HI                            = 0xD0FD;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_LO                            = 0xD0FC;
constexpr unsigned int mmGRBMH_PERFCOUNTER1_SELECT                        = 0xD8F9;
constexpr unsigned int mmGRBMH_SYNC                                       = 0x2073;
constexpr unsigned int mmGRBM_GFX_INDEX                                   = 0xC200;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_DATA                           = 0xFA01;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_SELECT                         = 0xFA00;
constexpr unsigned int mmGRBM_NOWHERE                                     = 0xA901;
constexpr unsigned int mmGRBM_NOWHERE_2                                   = 0xC201;
constexpr unsigned int mmGRBM_PERFCOUNTER0_HI                             = 0xD041;
constexpr unsigned int mmGRBM_PERFCOUNTER0_LO                             = 0xD040;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT                         = 0xD840;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_HI                      = 0xD84D;
constexpr unsigned int mmGRBM_PERFCOUNTER1_HI                             = 0xD044;
constexpr unsigned int mmGRBM_PERFCOUNTER1_LO                             = 0xD043;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT                         = 0xD841;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_HI                      = 0xD84E;
constexpr unsigned int mmIA_UTCL1_CNTL                                    = 0x2246;
constexpr unsigned int mmIA_UTCL1_STATUS                                  = 0x2247;
constexpr unsigned int mmIA_UTCL1_STATUS_2                                = 0x2237;
constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x16343;
constexpr unsigned int mmPA_CL_CLIP_CNTL                                  = 0xA204;
constexpr unsigned int mmPA_CL_CNTL_STATUS                                = 0x2284;
constexpr unsigned int mmPA_CL_ENHANCE                                    = 0x2285;
constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ                           = 0xA10D;
constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ                           = 0xA10E;
constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ                           = 0xA10B;
constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ                           = 0xA10C;
constexpr unsigned int mmPA_CL_NANINF_CNTL                                = 0xA208;
constexpr unsigned int mmPA_CL_NGG_CNTL                                   = 0xA20E;
constexpr unsigned int mmPA_CL_POINT_CULL_RAD                             = 0xA1F8;
constexpr unsigned int mmPA_CL_POINT_SIZE                                 = 0xA1F7;
constexpr unsigned int mmPA_CL_POINT_X_RAD                                = 0xA1F5;
constexpr unsigned int mmPA_CL_POINT_Y_RAD                                = 0xA1F6;
constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z                           = 0xA0CC;
constexpr unsigned int mmPA_CL_UCP_0_W                                    = 0xA0B7;
constexpr unsigned int mmPA_CL_UCP_0_X                                    = 0xA0B4;
constexpr unsigned int mmPA_CL_UCP_0_Y                                    = 0xA0B5;
constexpr unsigned int mmPA_CL_UCP_0_Z                                    = 0xA0B6;
constexpr unsigned int mmPA_CL_UCP_1_W                                    = 0xA0BB;
constexpr unsigned int mmPA_CL_UCP_1_X                                    = 0xA0B8;
constexpr unsigned int mmPA_CL_UCP_1_Y                                    = 0xA0B9;
constexpr unsigned int mmPA_CL_UCP_1_Z                                    = 0xA0BA;
constexpr unsigned int mmPA_CL_UCP_2_W                                    = 0xA0BF;
constexpr unsigned int mmPA_CL_UCP_2_X                                    = 0xA0BC;
constexpr unsigned int mmPA_CL_UCP_2_Y                                    = 0xA0BD;
constexpr unsigned int mmPA_CL_UCP_2_Z                                    = 0xA0BE;
constexpr unsigned int mmPA_CL_UCP_3_W                                    = 0xA0C3;
constexpr unsigned int mmPA_CL_UCP_3_X                                    = 0xA0C0;
constexpr unsigned int mmPA_CL_UCP_3_Y                                    = 0xA0C1;
constexpr unsigned int mmPA_CL_UCP_3_Z                                    = 0xA0C2;
constexpr unsigned int mmPA_CL_UCP_4_W                                    = 0xA0C7;
constexpr unsigned int mmPA_CL_UCP_4_X                                    = 0xA0C4;
constexpr unsigned int mmPA_CL_UCP_4_Y                                    = 0xA0C5;
constexpr unsigned int mmPA_CL_UCP_4_Z                                    = 0xA0C6;
constexpr unsigned int mmPA_CL_UCP_5_W                                    = 0xA0CB;
constexpr unsigned int mmPA_CL_UCP_5_X                                    = 0xA0C8;
constexpr unsigned int mmPA_CL_UCP_5_Y                                    = 0xA0C9;
constexpr unsigned int mmPA_CL_UCP_5_Z                                    = 0xA0CA;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET                              = 0xA110;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1                            = 0xA118;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2                            = 0xA120;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3                            = 0xA128;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4                            = 0xA130;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5                            = 0xA138;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6                            = 0xA140;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7                            = 0xA148;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8                            = 0xA150;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9                            = 0xA158;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10                           = 0xA160;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11                           = 0xA168;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12                           = 0xA170;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13                           = 0xA178;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14                           = 0xA180;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15                           = 0xA188;
constexpr unsigned int mmPA_CL_VPORT_XSCALE                               = 0xA10F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_1                             = 0xA117;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_2                             = 0xA11F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_3                             = 0xA127;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_4                             = 0xA12F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_5                             = 0xA137;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_6                             = 0xA13F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_7                             = 0xA147;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_8                             = 0xA14F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_9                             = 0xA157;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_10                            = 0xA15F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_11                            = 0xA167;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_12                            = 0xA16F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_13                            = 0xA177;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_14                            = 0xA17F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_15                            = 0xA187;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET                              = 0xA112;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1                            = 0xA11A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2                            = 0xA122;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3                            = 0xA12A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4                            = 0xA132;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5                            = 0xA13A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6                            = 0xA142;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7                            = 0xA14A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8                            = 0xA152;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9                            = 0xA15A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10                           = 0xA162;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11                           = 0xA16A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12                           = 0xA172;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13                           = 0xA17A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14                           = 0xA182;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15                           = 0xA18A;
constexpr unsigned int mmPA_CL_VPORT_YSCALE                               = 0xA111;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_1                             = 0xA119;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_2                             = 0xA121;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_3                             = 0xA129;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_4                             = 0xA131;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_5                             = 0xA139;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_6                             = 0xA141;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_7                             = 0xA149;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_8                             = 0xA151;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_9                             = 0xA159;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_10                            = 0xA161;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_11                            = 0xA169;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_12                            = 0xA171;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_13                            = 0xA179;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_14                            = 0xA181;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_15                            = 0xA189;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET                              = 0xA114;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1                            = 0xA11C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2                            = 0xA124;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3                            = 0xA12C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4                            = 0xA134;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5                            = 0xA13C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6                            = 0xA144;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7                            = 0xA14C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8                            = 0xA154;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9                            = 0xA15C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10                           = 0xA164;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11                           = 0xA16C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12                           = 0xA174;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13                           = 0xA17C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14                           = 0xA184;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15                           = 0xA18C;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE                               = 0xA113;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1                             = 0xA11B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2                             = 0xA123;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3                             = 0xA12B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4                             = 0xA133;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5                             = 0xA13B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6                             = 0xA143;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7                             = 0xA14B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8                             = 0xA153;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9                             = 0xA15B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10                            = 0xA163;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11                            = 0xA16B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12                            = 0xA173;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13                            = 0xA17B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14                            = 0xA183;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15                            = 0xA18B;
constexpr unsigned int mmPA_CL_VRS_CNTL                                   = 0xA212;
constexpr unsigned int mmPA_CL_VS_OUT_CNTL                                = 0xA206;
constexpr unsigned int mmPA_CL_VTE_CNTL                                   = 0xA205;
constexpr unsigned int mmPA_PH_ENHANCE                                    = 0xA95F;
constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE                        = 0xA95E;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI                            = 0xD581;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO                            = 0xD580;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT                        = 0xDD80;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1                       = 0xDD81;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI                            = 0xD583;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO                            = 0xD582;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT                        = 0xDD82;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1                       = 0xDD90;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI                            = 0xD585;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO                            = 0xD584;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT                        = 0xDD83;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1                       = 0xDD91;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI                            = 0xD587;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO                            = 0xD586;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT                        = 0xDD84;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1                       = 0xDD92;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI                            = 0xD589;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO                            = 0xD588;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT                        = 0xDD85;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI                            = 0xD58B;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO                            = 0xD58A;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT                        = 0xDD86;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI                            = 0xD58D;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO                            = 0xD58C;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT                        = 0xDD87;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI                            = 0xD58F;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO                            = 0xD58E;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT                        = 0xDD88;
constexpr unsigned int mmPA_RATE_CNTL                                     = 0xA0CD;
constexpr unsigned int mmPA_SC_AA_CONFIG                                  = 0xA2F8;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0                          = 0xA30E;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1                          = 0xA30F;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0                = 0xA2FE;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1                = 0xA2FF;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2                = 0xA300;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3                = 0xA301;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0                = 0xA306;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1                = 0xA307;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2                = 0xA308;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3                = 0xA309;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0                = 0xA302;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1                = 0xA303;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2                = 0xA304;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3                = 0xA305;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0                = 0xA30A;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1                = 0xA30B;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2                = 0xA30C;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3                = 0xA30D;
constexpr unsigned int mmPA_SC_ATM_CNTL                                   = 0xA94D;
constexpr unsigned int mmPA_SC_BINNER_CNTL_0                              = 0xA311;
constexpr unsigned int mmPA_SC_BINNER_CNTL_1                              = 0xA312;
constexpr unsigned int mmPA_SC_BINNER_CNTL_2                              = 0xA313;
constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE                       = 0xA946;
constexpr unsigned int mmPA_SC_BINNER_DYNAMIC_BATCH_LIMIT                 = 0xA2EE;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0                        = 0xA950;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1                        = 0xA951;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2                        = 0xA952;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3                        = 0xA953;
constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_CNTL                 = 0xA2ED;
constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER              = 0xA310;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0                         = 0xA955;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1                         = 0xA956;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2                         = 0xA957;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3                         = 0xA958;
constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER                     = 0xA954;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0                        = 0xA2FC;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1                        = 0xA2FD;
constexpr unsigned int mmPA_SC_CLIPRECT_0_BR                              = 0xA085;
constexpr unsigned int mmPA_SC_CLIPRECT_0_EXT                             = 0xA0DD;
constexpr unsigned int mmPA_SC_CLIPRECT_0_TL                              = 0xA084;
constexpr unsigned int mmPA_SC_CLIPRECT_1_BR                              = 0xA087;
constexpr unsigned int mmPA_SC_CLIPRECT_1_EXT                             = 0xA0DE;
constexpr unsigned int mmPA_SC_CLIPRECT_1_TL                              = 0xA086;
constexpr unsigned int mmPA_SC_CLIPRECT_2_BR                              = 0xA089;
constexpr unsigned int mmPA_SC_CLIPRECT_2_EXT                             = 0xA0DF;
constexpr unsigned int mmPA_SC_CLIPRECT_2_TL                              = 0xA088;
constexpr unsigned int mmPA_SC_CLIPRECT_3_BR                              = 0xA08B;
constexpr unsigned int mmPA_SC_CLIPRECT_3_EXT                             = 0xA0E0;
constexpr unsigned int mmPA_SC_CLIPRECT_3_TL                              = 0xA08A;
constexpr unsigned int mmPA_SC_CLIPRECT_RULE                              = 0xA083;
constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL            = 0xA315;
constexpr unsigned int mmPA_SC_DSM_CNTL                                   = 0xA948;
constexpr unsigned int mmPA_SC_EDGERULE                                   = 0xA08C;
constexpr unsigned int mmPA_SC_ENHANCE                                    = 0xA941;
constexpr unsigned int mmPA_SC_ENHANCE_1                                  = 0xA942;
constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0xA943;
constexpr unsigned int mmPA_SC_ENHANCE_3                                  = 0xA944;
constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL                            = 0x2295;
constexpr unsigned int mmPA_SC_FIFO_SIZE                                  = 0xA94A;
constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS                         = 0xA94F;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR                         = 0xA091;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL                         = 0xA090;
constexpr unsigned int mmPA_SC_HISZ_CONTROL                               = 0xA2EF;
constexpr unsigned int mmPA_SC_HISZ_RENDER_OVERRIDE                       = 0xA2F0;
constexpr unsigned int mmPA_SC_HIS_BASE                                   = 0xA2EA;
constexpr unsigned int mmPA_SC_HIS_BASE_EXT                               = 0xA2EB;
constexpr unsigned int mmPA_SC_HIS_INFO                                   = 0xA2E6;
constexpr unsigned int mmPA_SC_HIS_SIZE_XY                                = 0xA2EC;
constexpr unsigned int mmPA_SC_HIS_SURFACE_CNTL                           = 0xA962;
constexpr unsigned int mmPA_SC_HIZ_BASE                                   = 0xA2E7;
constexpr unsigned int mmPA_SC_HIZ_BASE_EXT                               = 0xA2E8;
constexpr unsigned int mmPA_SC_HIZ_INFO                                   = 0xA2E5;
constexpr unsigned int mmPA_SC_HIZ_SIZE_XY                                = 0xA2E9;
constexpr unsigned int mmPA_SC_HIZ_SURFACE_CNTL                           = 0xA961;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT                     = 0xC2AC;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H                         = 0xC2A9;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_EN                     = 0xC2A8;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK                   = 0xA95C;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE                = 0xC2AB;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V                         = 0xC2AA;
constexpr unsigned int mmPA_SC_IF_FIFO_SIZE                               = 0xA94B;
constexpr unsigned int mmPA_SC_LINE_CNTL                                  = 0xA2F7;
constexpr unsigned int mmPA_SC_LINE_STIPPLE                               = 0xA283;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_RESET                         = 0xA291;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_STATE                         = 0xC281;
constexpr unsigned int mmPA_SC_MODE_CNTL_0                                = 0xA292;
constexpr unsigned int mmPA_SC_MODE_CNTL_1                                = 0xA293;
constexpr unsigned int mmPA_SC_NGG_MODE_CNTL                              = 0xA314;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT                      = 0xC2A4;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H                          = 0xC2A1;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_EN                      = 0xC2A0;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK                    = 0xA95B;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE                 = 0xC2A3;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V                          = 0xC2A2;
constexpr unsigned int mmPA_SC_PACKER_WAVE_ID_CNTL                        = 0xA94C;
constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG                          = 0xA947;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI                            = 0xD141;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO                            = 0xD140;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT                        = 0xD940;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1                       = 0xD941;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI                            = 0xD143;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO                            = 0xD142;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT                        = 0xD942;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI                            = 0xD145;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO                            = 0xD144;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT                        = 0xD943;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI                            = 0xD147;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO                            = 0xD146;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT                        = 0xD944;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI                            = 0xD149;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO                            = 0xD148;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT                        = 0xD945;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI                            = 0xD14B;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO                            = 0xD14A;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT                        = 0xD946;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI                            = 0xD14D;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO                            = 0xD14C;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT                        = 0xD947;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI                            = 0xD14F;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO                            = 0xD14E;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT                        = 0xD948;
constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL                        = 0xA94E;
constexpr unsigned int mmPA_SC_RASTER_CONFIG                              = 0xA0D4;
constexpr unsigned int mmPA_SC_RASTER_CONFIG_1                            = 0xA0D5;
constexpr unsigned int mmPA_SC_SAMPLE_PROPERTIES                          = 0xA317;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR                          = 0xA061;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL                          = 0xA060;
constexpr unsigned int mmPA_SC_SHADER_CONTROL                             = 0xA316;
constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE               = 0xA949;
constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE                     = 0xA0D7;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT                          = 0xC2B4;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_H                              = 0xC2B1;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_EN                          = 0xC2B0;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK                        = 0xA95D;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE                     = 0xC2B3;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_V                              = 0xC2B2;
constexpr unsigned int mmPA_SC_VPORT_0_BR                                 = 0xA041;
constexpr unsigned int mmPA_SC_VPORT_0_TL                                 = 0xA040;
constexpr unsigned int mmPA_SC_VPORT_1_BR                                 = 0xA043;
constexpr unsigned int mmPA_SC_VPORT_1_TL                                 = 0xA042;
constexpr unsigned int mmPA_SC_VPORT_2_BR                                 = 0xA045;
constexpr unsigned int mmPA_SC_VPORT_2_TL                                 = 0xA044;
constexpr unsigned int mmPA_SC_VPORT_3_BR                                 = 0xA047;
constexpr unsigned int mmPA_SC_VPORT_3_TL                                 = 0xA046;
constexpr unsigned int mmPA_SC_VPORT_4_BR                                 = 0xA049;
constexpr unsigned int mmPA_SC_VPORT_4_TL                                 = 0xA048;
constexpr unsigned int mmPA_SC_VPORT_5_BR                                 = 0xA04B;
constexpr unsigned int mmPA_SC_VPORT_5_TL                                 = 0xA04A;
constexpr unsigned int mmPA_SC_VPORT_6_BR                                 = 0xA04D;
constexpr unsigned int mmPA_SC_VPORT_6_TL                                 = 0xA04C;
constexpr unsigned int mmPA_SC_VPORT_7_BR                                 = 0xA04F;
constexpr unsigned int mmPA_SC_VPORT_7_TL                                 = 0xA04E;
constexpr unsigned int mmPA_SC_VPORT_8_BR                                 = 0xA051;
constexpr unsigned int mmPA_SC_VPORT_8_TL                                 = 0xA050;
constexpr unsigned int mmPA_SC_VPORT_9_BR                                 = 0xA053;
constexpr unsigned int mmPA_SC_VPORT_9_TL                                 = 0xA052;
constexpr unsigned int mmPA_SC_VPORT_10_BR                                = 0xA055;
constexpr unsigned int mmPA_SC_VPORT_10_TL                                = 0xA054;
constexpr unsigned int mmPA_SC_VPORT_11_BR                                = 0xA057;
constexpr unsigned int mmPA_SC_VPORT_11_TL                                = 0xA056;
constexpr unsigned int mmPA_SC_VPORT_12_BR                                = 0xA059;
constexpr unsigned int mmPA_SC_VPORT_12_TL                                = 0xA058;
constexpr unsigned int mmPA_SC_VPORT_13_BR                                = 0xA05B;
constexpr unsigned int mmPA_SC_VPORT_13_TL                                = 0xA05A;
constexpr unsigned int mmPA_SC_VPORT_14_BR                                = 0xA05D;
constexpr unsigned int mmPA_SC_VPORT_14_TL                                = 0xA05C;
constexpr unsigned int mmPA_SC_VPORT_15_BR                                = 0xA05F;
constexpr unsigned int mmPA_SC_VPORT_15_TL                                = 0xA05E;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR                         = 0xA095;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL                         = 0xA094;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR                         = 0xA097;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL                         = 0xA096;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR                         = 0xA099;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL                         = 0xA098;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR                         = 0xA09B;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL                         = 0xA09A;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR                         = 0xA09D;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL                         = 0xA09C;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR                         = 0xA09F;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL                         = 0xA09E;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR                         = 0xA0A1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL                         = 0xA0A0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR                         = 0xA0A3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL                         = 0xA0A2;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR                         = 0xA0A5;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL                         = 0xA0A4;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR                         = 0xA0A7;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL                         = 0xA0A6;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR                        = 0xA0A9;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL                        = 0xA0A8;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR                        = 0xA0AB;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL                        = 0xA0AA;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR                        = 0xA0AD;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL                        = 0xA0AC;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR                        = 0xA0AF;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL                        = 0xA0AE;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR                        = 0xA0B1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL                        = 0xA0B0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR                        = 0xA0B3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL                        = 0xA0B2;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_0                               = 0xA116;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_1                               = 0xA11E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_2                               = 0xA126;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_3                               = 0xA12E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_4                               = 0xA136;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_5                               = 0xA13E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_6                               = 0xA146;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_7                               = 0xA14E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_8                               = 0xA156;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_9                               = 0xA15E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_10                              = 0xA166;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_11                              = 0xA16E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_12                              = 0xA176;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_13                              = 0xA17E;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_14                              = 0xA186;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_15                              = 0xA18E;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_0                               = 0xA115;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_1                               = 0xA11D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_2                               = 0xA125;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_3                               = 0xA12D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_4                               = 0xA135;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_5                               = 0xA13D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_6                               = 0xA145;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_7                               = 0xA14D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_8                               = 0xA155;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_9                               = 0xA15D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_10                              = 0xA165;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_11                              = 0xA16D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_12                              = 0xA175;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_13                              = 0xA17D;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_14                              = 0xA185;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_15                              = 0xA18D;
constexpr unsigned int mmPA_SC_VRS_INFO                                   = 0xA0F8;
constexpr unsigned int mmPA_SC_VRS_OVERRIDE_CNTL                          = 0xA0F4;
constexpr unsigned int mmPA_SC_VRS_RATE_BASE                              = 0xA0FC;
constexpr unsigned int mmPA_SC_VRS_RATE_BASE_EXT                          = 0xA0FD;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE                     = 0xA0F5;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_EXT                 = 0xA0F6;
constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_SIZE_XY                  = 0xA0F7;
constexpr unsigned int mmPA_SC_VRS_RATE_SIZE_XY                           = 0xA0FE;
constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL                           = 0xA940;
constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_1                         = 0xA960;
constexpr unsigned int mmPA_SC_WINDOW_OFFSET                              = 0xA080;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR                          = 0xA082;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL                          = 0xA081;
constexpr unsigned int mmPA_STATE_STEREO_X                                = 0xA211;
constexpr unsigned int mmPA_STEREO_CNTL                                   = 0xA210;
constexpr unsigned int mmPA_SU_CNTL_STATUS                                = 0x2294;
constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET                     = 0xA08D;
constexpr unsigned int mmPA_SU_LINE_CNTL                                  = 0xA282;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL                          = 0xA209;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE                         = 0xA20A;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE                         = 0xC280;
constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL                    = 0xA20F;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI                            = 0xD101;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO                            = 0xD100;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT                        = 0xD900;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1                       = 0xD901;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI                            = 0xD103;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO                            = 0xD102;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT                        = 0xD902;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1                       = 0xD903;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI                            = 0xD105;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO                            = 0xD104;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT                        = 0xD904;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1                       = 0xD905;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI                            = 0xD107;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO                            = 0xD106;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT                        = 0xD906;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1                       = 0xD907;
constexpr unsigned int mmPA_SU_POINT_MINMAX                               = 0xA281;
constexpr unsigned int mmPA_SU_POINT_SIZE                                 = 0xA280;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET                    = 0xA2E3;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE                     = 0xA2E2;
constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP                          = 0xA2DF;
constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL                    = 0xA2DE;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET                   = 0xA2E1;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE                    = 0xA2E0;
constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL                           = 0xA20B;
constexpr unsigned int mmPA_SU_SC_MODE_CNTL                               = 0xA207;
constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL                     = 0xA20C;
constexpr unsigned int mmPA_SU_VTX_CNTL                                   = 0xA2F9;
constexpr unsigned int mmPC_PERFCOUNTER0_HI                               = 0xD18C;
constexpr unsigned int mmPC_PERFCOUNTER0_LO                               = 0xD18D;
constexpr unsigned int mmPC_PERFCOUNTER0_SELECT                           = 0xD990;
constexpr unsigned int mmPC_PERFCOUNTER0_SELECT1                          = 0xD994;
constexpr unsigned int mmPC_PERFCOUNTER1_HI                               = 0xD18E;
constexpr unsigned int mmPC_PERFCOUNTER1_LO                               = 0xD18F;
constexpr unsigned int mmPC_PERFCOUNTER1_SELECT                           = 0xD991;
constexpr unsigned int mmPC_PERFCOUNTER1_SELECT1                          = 0xD995;
constexpr unsigned int mmPC_PERFCOUNTER2_HI                               = 0xD190;
constexpr unsigned int mmPC_PERFCOUNTER2_LO                               = 0xD191;
constexpr unsigned int mmPC_PERFCOUNTER2_SELECT                           = 0xD992;
constexpr unsigned int mmPC_PERFCOUNTER2_SELECT1                          = 0xD996;
constexpr unsigned int mmPC_PERFCOUNTER3_HI                               = 0xD192;
constexpr unsigned int mmPC_PERFCOUNTER3_LO                               = 0xD193;
constexpr unsigned int mmPC_PERFCOUNTER3_SELECT                           = 0xD993;
constexpr unsigned int mmPC_PERFCOUNTER3_SELECT1                          = 0xD997;
constexpr unsigned int mmPerfMonCtl1                                      = 0x14344;
constexpr unsigned int mmPerfMonCtl2                                      = 0x14347;
constexpr unsigned int mmPerfMonCtl3                                      = 0x1434A;
constexpr unsigned int mmPerfMonCtl4                                      = 0x1434D;
constexpr unsigned int mmPerfMonCtl5                                      = 0x14350;
constexpr unsigned int mmPerfMonCtl6                                      = 0x14353;
constexpr unsigned int mmPerfMonCtl7                                      = 0x14356;
constexpr unsigned int mmPerfMonCtl8                                      = 0x14359;
constexpr unsigned int mmPerfMonCtl9                                      = 0x1435C;
constexpr unsigned int mmPerfMonCtl10                                     = 0x1435F;
constexpr unsigned int mmPerfMonCtl11                                     = 0x14362;
constexpr unsigned int mmPerfMonCtl12                                     = 0x14365;
constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x14346;
constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x14345;
constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x14349;
constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x14348;
constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434C;
constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434B;
constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x1434F;
constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x1434E;
constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14352;
constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14351;
constexpr unsigned int mmPerfMonCtr6_Hi                                   = 0x14355;
constexpr unsigned int mmPerfMonCtr6_Lo                                   = 0x14354;
constexpr unsigned int mmPerfMonCtr7_Hi                                   = 0x14358;
constexpr unsigned int mmPerfMonCtr7_Lo                                   = 0x14357;
constexpr unsigned int mmPerfMonCtr8_Hi                                   = 0x1435B;
constexpr unsigned int mmPerfMonCtr8_Lo                                   = 0x1435A;
constexpr unsigned int mmPerfMonCtr9_Hi                                   = 0x1435E;
constexpr unsigned int mmPerfMonCtr9_Lo                                   = 0x1435D;
constexpr unsigned int mmPerfMonCtr10_Hi                                  = 0x14361;
constexpr unsigned int mmPerfMonCtr10_Lo                                  = 0x14360;
constexpr unsigned int mmPerfMonCtr11_Hi                                  = 0x14364;
constexpr unsigned int mmPerfMonCtr11_Lo                                  = 0x14363;
constexpr unsigned int mmPerfMonCtr12_Hi                                  = 0x14367;
constexpr unsigned int mmPerfMonCtr12_Lo                                  = 0x14366;
constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14342;
constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14341;
constexpr unsigned int mmRLC_PERFCOUNTER0_HI                              = 0xD481;
constexpr unsigned int mmRLC_PERFCOUNTER0_LO                              = 0xD480;
constexpr unsigned int mmRLC_PERFCOUNTER0_SELECT                          = 0xDCC1;
constexpr unsigned int mmRLC_PERFCOUNTER1_HI                              = 0xD483;
constexpr unsigned int mmRLC_PERFCOUNTER1_LO                              = 0xD482;
constexpr unsigned int mmRLC_PERFCOUNTER1_SELECT                          = 0xDCC2;
constexpr unsigned int mmRLC_PERFMON_CNTL                                 = 0xDCC0;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRL                               = 0xDC9A;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR                       = 0xDC96;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET                = 0xDC98;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA                       = 0xDC97;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS         = 0xDC9F;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR                       = 0xDC92;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA                       = 0xDC93;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT                    = 0xDC9E;
constexpr unsigned int mmRLC_SPM_ACCUM_MODE                               = 0xDC9B;
constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED                  = 0xDC9D;
constexpr unsigned int mmRLC_SPM_ACCUM_STATUS                             = 0xDC99;
constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_ADDR                   = 0xDC94;
constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_DATA                   = 0xDC95;
constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD                          = 0xDC9C;
constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA5;
constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA4;
constexpr unsigned int mmRLC_SPM_GLOBAL_BLK_EN_MASK_IND_ADDR              = 0xED68;
constexpr unsigned int mmRLC_SPM_GLOBAL_BLK_EN_MASK_IND_DATA              = 0xED69;
constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_ADDR                    = 0xED64;
constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_DATA                    = 0xED65;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR                       = 0xDC88;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA                       = 0xDC89;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_0                       = 0xDCA8;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_1                       = 0xDCA9;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_2                       = 0xDCAA;
constexpr unsigned int mmRLC_SPM_GLOBAL_USER_DATA_3                       = 0xDCAB;
constexpr unsigned int mmRLC_SPM_GTS_TRIGGER_VALUE_HI                     = 0xDCA7;
constexpr unsigned int mmRLC_SPM_GTS_TRIGGER_VALUE_LO                     = 0xDCA6;
constexpr unsigned int mmRLC_SPM_INT_CNTL                                 = 0xA983;
constexpr unsigned int mmRLC_SPM_INT_INFO_1                               = 0xA985;
constexpr unsigned int mmRLC_SPM_INT_INFO_2                               = 0xA986;
constexpr unsigned int mmRLC_SPM_INT_STATUS                               = 0xA984;
constexpr unsigned int mmRLC_SPM_MC_CNTL                                  = 0xA982;
constexpr unsigned int mmRLC_SPM_MODE                                     = 0xDCAD;
constexpr unsigned int mmRLC_SPM_PAUSE                                    = 0xDCA2;
constexpr unsigned int mmRLC_SPM_PERFMON_CNTL                             = 0xDC80;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_HI                     = 0xDC82;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_LO                     = 0xDC81;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_SIZE                        = 0xDC83;
constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE                     = 0xDC87;
constexpr unsigned int mmRLC_SPM_RING_RDPTR                               = 0xDC85;
constexpr unsigned int mmRLC_SPM_RING_WRPTR                               = 0xDC84;
constexpr unsigned int mmRLC_SPM_RSPM_CMD                                 = 0xDCB8;
constexpr unsigned int mmRLC_SPM_RSPM_CMD_ACK                             = 0xDCB9;
constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA                            = 0xDCAE;
constexpr unsigned int mmRLC_SPM_RSPM_REQ_OP                              = 0xDCB0;
constexpr unsigned int mmRLC_SPM_RSPM_RET_DATA                            = 0xDCB1;
constexpr unsigned int mmRLC_SPM_RSPM_RET_OP                              = 0xDCB2;
constexpr unsigned int mmRLC_SPM_SAMPLE_CNT                               = 0xA981;
constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD                        = 0xDC86;
constexpr unsigned int mmRLC_SPM_SE_BLK_EN_MASK_IND_ADDR                  = 0xED6A;
constexpr unsigned int mmRLC_SPM_SE_BLK_EN_MASK_IND_DATA                  = 0xED6B;
constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_ADDR                        = 0xED66;
constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_DATA                        = 0xED67;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR                           = 0xDC8A;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA                           = 0xDC8B;
constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA                         = 0xDCB3;
constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_OP                           = 0xDCB5;
constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_DATA                         = 0xDCB6;
constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_OP                           = 0xDCB7;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_0                           = 0xDC8C;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_1                           = 0xDC8D;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_2                           = 0xDC8E;
constexpr unsigned int mmRLC_SPM_SE_USER_DATA_3                           = 0xDC8F;
constexpr unsigned int mmRLC_SPM_SPARE                                    = 0xDCBF;
constexpr unsigned int mmRLC_SPM_STATUS                                   = 0xDCA3;
constexpr unsigned int mmRLC_SPM_THREAD_TRACE_CTRL                        = 0xEDE6;
constexpr unsigned int mmRLC_SPM_UTCL1_CNTL                               = 0xECB5;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_1                            = 0xECBC;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_2                            = 0xECBD;
constexpr unsigned int mmRMI_PERFCOUNTER0_HI                              = 0xD4C1;
constexpr unsigned int mmRMI_PERFCOUNTER0_LO                              = 0xD4C0;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT                          = 0xDD00;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1                         = 0xDD01;
constexpr unsigned int mmRMI_PERFCOUNTER1_HI                              = 0xD4C3;
constexpr unsigned int mmRMI_PERFCOUNTER1_LO                              = 0xD4C2;
constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT                          = 0xDD02;
constexpr unsigned int mmRMI_PERFCOUNTER2_HI                              = 0xD4C5;
constexpr unsigned int mmRMI_PERFCOUNTER2_LO                              = 0xD4C4;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT                          = 0xDD03;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1                         = 0xDD04;
constexpr unsigned int mmRMI_PERFCOUNTER3_HI                              = 0xD4C7;
constexpr unsigned int mmRMI_PERFCOUNTER3_LO                              = 0xD4C6;
constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT                          = 0xDD05;
constexpr unsigned int mmRMI_PERF_COUNTER_CNTL                            = 0xDD06;
constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0C92;
constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0C93;
constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0C94;
constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0C95;
constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0C98;
constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0C99;
constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0C96;
constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0C97;
constexpr unsigned int mmSCRATCH_REG0                                     = 0xC040;
constexpr unsigned int mmSCRATCH_REG1                                     = 0xC041;
constexpr unsigned int mmSCRATCH_REG2                                     = 0xC042;
constexpr unsigned int mmSCRATCH_REG3                                     = 0xC043;
constexpr unsigned int mmSCRATCH_REG4                                     = 0xC044;
constexpr unsigned int mmSCRATCH_REG5                                     = 0xC045;
constexpr unsigned int mmSCRATCH_REG6                                     = 0xC046;
constexpr unsigned int mmSCRATCH_REG7                                     = 0xC047;
constexpr unsigned int mmSCRATCH_REGISTER0                                = 0x16BBD;
constexpr unsigned int mmSCRATCH_REGISTER1                                = 0x16BBE;
constexpr unsigned int mmSCRATCH_REGISTER2                                = 0x16BBF;
constexpr unsigned int mmSCRATCH_REGISTER3                                = 0x16BC0;
constexpr unsigned int mmSCRATCH_REGISTER4                                = 0x16BC1;
constexpr unsigned int mmSCRATCH_REGISTER5                                = 0x16BC2;
constexpr unsigned int mmSCRATCH_REGISTER6                                = 0x16BC3;
constexpr unsigned int mmSCRATCH_REGISTER7                                = 0x16BC4;
constexpr unsigned int mmSCRATCH_REG_ATOMIC                               = 0xC048;
constexpr unsigned int mmSCRATCH_REG_CMPSWAP_ATOMIC                       = 0xC048;
constexpr unsigned int mmSC_MEM_SCOPE                                     = 0xA965;
constexpr unsigned int mmSC_MEM_SPEC_READ                                 = 0xA03F;
constexpr unsigned int mmSC_MEM_TEMPORAL                                  = 0xA03E;
constexpr unsigned int mmSDMA0_PERFCNT_MISC_CNTL                          = 0xDE23;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE20;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE21;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_HI                     = 0xD661;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_LO                     = 0xD660;
constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE22;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI                            = 0xD663;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO                            = 0xD662;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT                        = 0xDE24;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1                       = 0xDE25;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI                            = 0xD665;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO                            = 0xD664;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT                        = 0xDE26;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1                       = 0xDE27;
constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL                          = 0xDE2F;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE2C;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE2D;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI                     = 0xD66D;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO                     = 0xD66C;
constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE2E;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0xD66F;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0xD66E;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0xDE30;
constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0xDE31;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0xD671;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0xD670;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0xDE32;
constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0xDE33;
constexpr unsigned int mmSPI_ARB_CNTL_0                                   = 0xB949;
constexpr unsigned int mmSPI_ARB_CYCLES_0                                 = 0x31C1;
constexpr unsigned int mmSPI_ARB_CYCLES_1                                 = 0x31C2;
constexpr unsigned int mmSPI_ARB_PRIORITY                                 = 0x31C0;
constexpr unsigned int mmSPI_ATTRIBUTE_RING_BASE                          = 0xC446;
constexpr unsigned int mmSPI_ATTRIBUTE_RING_SIZE                          = 0xC447;
constexpr unsigned int mmSPI_BARYC_CNTL                                   = 0xA196;
constexpr unsigned int mmSPI_BARYC_SSAA_CNTL                              = 0xA1B9;
constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET                          = 0x31D3;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE                          = 0x31D4;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_STATUS                   = 0xB94E;
constexpr unsigned int mmSPI_COMPUTE_WGS_CONTROL                          = 0xC449;
constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0xC440;
constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0xC441;
constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0xC442;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS0                           = 0x2457;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS1                           = 0x2458;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS2                           = 0x2459;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS3                           = 0x245A;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS4                           = 0x245B;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS5                           = 0x245C;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS6                           = 0x245D;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_CS7                           = 0x245E;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_GFX0                          = 0x2453;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_GFX1                          = 0x2455;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_HP3D0                         = 0x2454;
constexpr unsigned int mmSPI_CONFIG_CU_MASK_HP3D1                         = 0x2456;
constexpr unsigned int mmSPI_CONFIG_PS_CU_EN                              = 0x2452;
constexpr unsigned int mmSPI_CREST_MODE                                   = 0x24CD;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_0                        = 0x24DC;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_1                        = 0x24DD;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_2                        = 0x24DE;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_3                        = 0x24DF;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_STATUS                         = 0x24DB;
constexpr unsigned int mmSPI_CS_CRAWLER_CONFIG                            = 0x24F7;
constexpr unsigned int mmSPI_DSM_CNTL                                     = 0x2443;
constexpr unsigned int mmSPI_DSM_CNTL2                                    = 0x2444;
constexpr unsigned int mmSPI_EDC_CNT                                      = 0x2445;
constexpr unsigned int mmSPI_EXP_THROTTLE_CTRL                            = 0x2723;
constexpr unsigned int mmSPI_FEATURE_CTRL                                 = 0xB94A;
constexpr unsigned int mmSPI_GDS_CREDITS                                  = 0x24D8;
constexpr unsigned int mmSPI_GFX_CNTL                                     = 0x243C;
constexpr unsigned int mmSPI_GFX_CRAWLER_CONFIG                           = 0x24F6;
constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_HI                          = 0xA1BC;
constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_LO                          = 0xA1BB;
constexpr unsigned int mmSPI_GRP_LAUNCH_GUARANTEE_CTRL                    = 0xC44B;
constexpr unsigned int mmSPI_GRP_LAUNCH_GUARANTEE_ENABLE                  = 0xC44A;
constexpr unsigned int mmSPI_GS_THROTTLE_CNTL1                            = 0xC444;
constexpr unsigned int mmSPI_GS_THROTTLE_CNTL2                            = 0xC445;
constexpr unsigned int mmSPI_INTERP_CONTROL_0                             = 0xA191;
constexpr unsigned int mmSPI_LB_CTR_CTRL                                  = 0x24D4;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_CS                       = 0x24E7;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_HSGS                     = 0x24E5;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_PS                       = 0x24E6;
constexpr unsigned int mmSPI_LB_DATA_REG                                  = 0x24D6;
constexpr unsigned int mmSPI_LB_DATA_WAVES                                = 0x24E4;
constexpr unsigned int mmSPI_LB_WGP_MASK                                  = 0x24D5;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_GPR_MIN                       = 0x24F0;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_HI                       = 0x24ED;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_LO                       = 0x24EC;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_HI                       = 0x24EF;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_LO                       = 0x24EE;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_GPR_MIN                       = 0x24F5;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_HI                       = 0x24F2;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_LO                       = 0x24F1;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_HI                       = 0x24F4;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_LO                       = 0x24F3;
constexpr unsigned int mmSPI_PERFCOUNTER0_HI                              = 0xD180;
constexpr unsigned int mmSPI_PERFCOUNTER0_LO                              = 0xD181;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT                          = 0xD980;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT1                         = 0xD986;
constexpr unsigned int mmSPI_PERFCOUNTER1_HI                              = 0xD182;
constexpr unsigned int mmSPI_PERFCOUNTER1_LO                              = 0xD183;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT                          = 0xD981;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT1                         = 0xD987;
constexpr unsigned int mmSPI_PERFCOUNTER2_HI                              = 0xD184;
constexpr unsigned int mmSPI_PERFCOUNTER2_LO                              = 0xD185;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT                          = 0xD982;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT1                         = 0xD988;
constexpr unsigned int mmSPI_PERFCOUNTER3_HI                              = 0xD186;
constexpr unsigned int mmSPI_PERFCOUNTER3_LO                              = 0xD187;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT                          = 0xD983;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT1                         = 0xD989;
constexpr unsigned int mmSPI_PERFCOUNTER4_HI                              = 0xD188;
constexpr unsigned int mmSPI_PERFCOUNTER4_LO                              = 0xD189;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT                          = 0xD984;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT1                         = 0xD98A;
constexpr unsigned int mmSPI_PERFCOUNTER5_HI                              = 0xD18A;
constexpr unsigned int mmSPI_PERFCOUNTER5_LO                              = 0xD18B;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT                          = 0xD985;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT1                         = 0xD98B;
constexpr unsigned int mmSPI_PERFCOUNTER_BINS                             = 0xD98C;
constexpr unsigned int mmSPI_PG_ENABLE_STATIC_WGP_MASK                    = 0x24D7;
constexpr unsigned int mmSPI_PQEV_CTRL                                    = 0x2720;
constexpr unsigned int mmSPI_PS_INPUT_ADDR                                = 0xA198;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_0                              = 0xA199;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_1                              = 0xA19A;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_2                              = 0xA19B;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_3                              = 0xA19C;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_4                              = 0xA19D;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_5                              = 0xA19E;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_6                              = 0xA19F;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_7                              = 0xA1A0;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_8                              = 0xA1A1;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_9                              = 0xA1A2;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_10                             = 0xA1A3;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_11                             = 0xA1A4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_12                             = 0xA1A5;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_13                             = 0xA1A6;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_14                             = 0xA1A7;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_15                             = 0xA1A8;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_16                             = 0xA1A9;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_17                             = 0xA1AA;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_18                             = 0xA1AB;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_19                             = 0xA1AC;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_20                             = 0xA1AD;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_21                             = 0xA1AE;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_22                             = 0xA1AF;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_23                             = 0xA1B0;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_24                             = 0xA1B1;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_25                             = 0xA1B2;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_26                             = 0xA1B3;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_27                             = 0xA1B4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_28                             = 0xA1B5;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_29                             = 0xA1B6;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_30                             = 0xA1B7;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_31                             = 0xA1B8;
constexpr unsigned int mmSPI_PS_INPUT_ENA                                 = 0xA197;
constexpr unsigned int mmSPI_PS_IN_CONTROL                                = 0xA190;
constexpr unsigned int mmSPI_PS_MAX_WAVE_ID                               = 0x243A;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0                        = 0xBC00;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1                        = 0xBC01;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0xBC02;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0xBC03;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0xBC04;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0xBC05;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6                        = 0xBC06;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7                        = 0xBC07;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0xBC08;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0xBC09;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10                       = 0xBC0A;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11                       = 0xBC0B;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12                       = 0xBC0C;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13                       = 0xBC0D;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14                       = 0xBC0E;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15                       = 0xBC0F;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0                     = 0xBC10;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1                     = 0xBC11;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0xBC12;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0xBC13;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0xBC14;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0xBC15;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6                     = 0xBC16;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7                     = 0xBC17;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0xBC18;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0xBC19;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10                    = 0xBC1A;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11                    = 0xBC1B;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12                    = 0xBC1C;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13                    = 0xBC1D;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14                    = 0xBC1E;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15                    = 0xBC1F;
constexpr unsigned int mmSPI_SAVE_RESTORE_STATUS                          = 0x31D5;
constexpr unsigned int mmSPI_SCRATCH_ADDR_STATUS                          = 0x243B;
constexpr unsigned int mmSPI_SHADER_COL_FORMAT                            = 0xA195;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_CTRL                       = 0x2CAE;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_DIM                        = 0x2CAC;
constexpr unsigned int mmSPI_SHADER_GS_MESHLET_EXP_ALLOC                  = 0x2CAD;
constexpr unsigned int mmSPI_SHADER_GS_OUT_CONFIG_PS                      = 0x2C31;
constexpr unsigned int mmSPI_SHADER_GS_OUT_CONFIG_PS_GS                   = 0x2CB1;
constexpr unsigned int mmSPI_SHADER_IDX_FORMAT                            = 0xA192;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS                         = 0x2C80;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS                         = 0x2D00;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS                         = 0x2C05;
constexpr unsigned int mmSPI_SHADER_PGM_HI_ES                             = 0x2C86;
constexpr unsigned int mmSPI_SHADER_PGM_HI_GS                             = 0x2C85;
constexpr unsigned int mmSPI_SHADER_PGM_HI_HS                             = 0x2D05;
constexpr unsigned int mmSPI_SHADER_PGM_HI_LS                             = 0x2D06;
constexpr unsigned int mmSPI_SHADER_PGM_HI_PS                             = 0x2C09;
constexpr unsigned int mmSPI_SHADER_PGM_LO_ES                             = 0x2C89;
constexpr unsigned int mmSPI_SHADER_PGM_LO_GS                             = 0x2C84;
constexpr unsigned int mmSPI_SHADER_PGM_LO_HS                             = 0x2D04;
constexpr unsigned int mmSPI_SHADER_PGM_LO_LS                             = 0x2D09;
constexpr unsigned int mmSPI_SHADER_PGM_LO_PS                             = 0x2C08;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS                          = 0x2C8A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS                          = 0x2D0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS                          = 0x2C0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS                          = 0x2C8B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS                          = 0x2D0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS                          = 0x2C0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS                          = 0x2C87;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS                          = 0x2D07;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS                          = 0x2C06;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS                          = 0x2C88;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS                          = 0x2D08;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS                          = 0x2C07;
constexpr unsigned int mmSPI_SHADER_POS_FORMAT                            = 0xA193;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS                         = 0x2CB0;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS                         = 0x2D30;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS                           = 0x2C30;
constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL                       = 0xB94B;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0                     = 0x2CB2;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1                     = 0x2CB3;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2                     = 0x2CB4;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3                     = 0x2CB5;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0                     = 0x2D32;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1                     = 0x2D33;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2                     = 0x2D34;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3                     = 0x2D35;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0                       = 0x2C32;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1                       = 0x2C33;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2                       = 0x2C34;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3                       = 0x2C35;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS                  = 0x2C83;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS                  = 0x2D03;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS                  = 0x2C82;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS                  = 0x2D02;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0                        = 0x2C8C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1                        = 0x2C8D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2                        = 0x2C8E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3                        = 0x2C8F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4                        = 0x2C90;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5                        = 0x2C91;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6                        = 0x2C92;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7                        = 0x2C93;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8                        = 0x2C94;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9                        = 0x2C95;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10                       = 0x2C96;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11                       = 0x2C97;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12                       = 0x2C98;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13                       = 0x2C99;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14                       = 0x2C9A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15                       = 0x2C9B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16                       = 0x2C9C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17                       = 0x2C9D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18                       = 0x2C9E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19                       = 0x2C9F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20                       = 0x2CA0;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21                       = 0x2CA1;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22                       = 0x2CA2;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23                       = 0x2CA3;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24                       = 0x2CA4;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25                       = 0x2CA5;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26                       = 0x2CA6;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27                       = 0x2CA7;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28                       = 0x2CA8;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29                       = 0x2CA9;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30                       = 0x2CAA;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31                       = 0x2CAB;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0                        = 0x2D0C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1                        = 0x2D0D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2                        = 0x2D0E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3                        = 0x2D0F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4                        = 0x2D10;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5                        = 0x2D11;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6                        = 0x2D12;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7                        = 0x2D13;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8                        = 0x2D14;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9                        = 0x2D15;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10                       = 0x2D16;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11                       = 0x2D17;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12                       = 0x2D18;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13                       = 0x2D19;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14                       = 0x2D1A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15                       = 0x2D1B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16                       = 0x2D1C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17                       = 0x2D1D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18                       = 0x2D1E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19                       = 0x2D1F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20                       = 0x2D20;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21                       = 0x2D21;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22                       = 0x2D22;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23                       = 0x2D23;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24                       = 0x2D24;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25                       = 0x2D25;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26                       = 0x2D26;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27                       = 0x2D27;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28                       = 0x2D28;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29                       = 0x2D29;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30                       = 0x2D2A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31                       = 0x2D2B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0                        = 0x2C0C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1                        = 0x2C0D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2                        = 0x2C0E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3                        = 0x2C0F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4                        = 0x2C10;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5                        = 0x2C11;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6                        = 0x2C12;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7                        = 0x2C13;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8                        = 0x2C14;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9                        = 0x2C15;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10                       = 0x2C16;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11                       = 0x2C17;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12                       = 0x2C18;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13                       = 0x2C19;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14                       = 0x2C1A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15                       = 0x2C1B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16                       = 0x2C1C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17                       = 0x2C1D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18                       = 0x2C1E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19                       = 0x2C1F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20                       = 0x2C20;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21                       = 0x2C21;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22                       = 0x2C22;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23                       = 0x2C23;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24                       = 0x2C24;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25                       = 0x2C25;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26                       = 0x2C26;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27                       = 0x2C27;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28                       = 0x2C28;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29                       = 0x2C29;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30                       = 0x2C2A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31                       = 0x2C2B;
constexpr unsigned int mmSPI_SHADER_Z_FORMAT                              = 0xA194;
constexpr unsigned int mmSPI_SQG_EVENT_CTL                                = 0xC448;
constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES                       = 0x24D9;
constexpr unsigned int mmSPI_SX_SCOREBOARD_BUFFER_SIZES                   = 0x24DA;
constexpr unsigned int mmSPI_TMPRING_SIZE                                 = 0xA1BA;
constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL                         = 0x31D1;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS0                         = 0x31C9;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS1                         = 0x31CA;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS2                         = 0x31CB;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS3                         = 0x31CC;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4                         = 0x31CD;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5                         = 0x31CE;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6                         = 0x31CF;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7                         = 0x31D0;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX                         = 0x31C7;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_HP3D                        = 0x31C8;
constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_GFX                          = 0x24E8;
constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_HPG                          = 0x24E9;
constexpr unsigned int mmSPI_WF_LIFETIME_CNTL                             = 0x24AA;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_0                          = 0x24AB;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_2                          = 0x24AD;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_3                          = 0x24AE;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_0                         = 0x24B5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_2                         = 0x24B7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_4                         = 0x24B9;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_6                         = 0x24BB;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_7                         = 0x24BC;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_9                         = 0x24BE;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_11                        = 0x24C0;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_13                        = 0x24C2;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_14                        = 0x24C3;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_15                        = 0x24C4;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_16                        = 0x24C5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_17                        = 0x24C6;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_18                        = 0x24C7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_19                        = 0x24C8;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_20                        = 0x24C9;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_21                        = 0x24CB;
constexpr unsigned int mmSPI_WGP_WORK_PENDING                             = 0x24CC;
constexpr unsigned int mmSQG_CONFIG                                       = 0x231A;
constexpr unsigned int mmSQG_GL1X_CTRL                                    = 0x2318;
constexpr unsigned int mmSQG_GL1X_STATUS                                  = 0x2319;
constexpr unsigned int mmSQG_PERFCOUNTER0_HI                              = 0xD1E5;
constexpr unsigned int mmSQG_PERFCOUNTER0_LO                              = 0xD1E4;
constexpr unsigned int mmSQG_PERFCOUNTER0_SELECT                          = 0xD9D0;
constexpr unsigned int mmSQG_PERFCOUNTER1_HI                              = 0xD1E7;
constexpr unsigned int mmSQG_PERFCOUNTER1_LO                              = 0xD1E6;
constexpr unsigned int mmSQG_PERFCOUNTER1_SELECT                          = 0xD9D1;
constexpr unsigned int mmSQG_PERFCOUNTER2_HI                              = 0xD1E9;
constexpr unsigned int mmSQG_PERFCOUNTER2_LO                              = 0xD1E8;
constexpr unsigned int mmSQG_PERFCOUNTER2_SELECT                          = 0xD9D2;
constexpr unsigned int mmSQG_PERFCOUNTER3_HI                              = 0xD1EB;
constexpr unsigned int mmSQG_PERFCOUNTER3_LO                              = 0xD1EA;
constexpr unsigned int mmSQG_PERFCOUNTER3_SELECT                          = 0xD9D3;
constexpr unsigned int mmSQG_PERFCOUNTER4_HI                              = 0xD1ED;
constexpr unsigned int mmSQG_PERFCOUNTER4_LO                              = 0xD1EC;
constexpr unsigned int mmSQG_PERFCOUNTER4_SELECT                          = 0xD9D4;
constexpr unsigned int mmSQG_PERFCOUNTER5_HI                              = 0xD1EF;
constexpr unsigned int mmSQG_PERFCOUNTER5_LO                              = 0xD1EE;
constexpr unsigned int mmSQG_PERFCOUNTER5_SELECT                          = 0xD9D5;
constexpr unsigned int mmSQG_PERFCOUNTER6_HI                              = 0xD1F1;
constexpr unsigned int mmSQG_PERFCOUNTER6_LO                              = 0xD1F0;
constexpr unsigned int mmSQG_PERFCOUNTER6_SELECT                          = 0xD9D6;
constexpr unsigned int mmSQG_PERFCOUNTER7_HI                              = 0xD1F3;
constexpr unsigned int mmSQG_PERFCOUNTER7_LO                              = 0xD1F2;
constexpr unsigned int mmSQG_PERFCOUNTER7_SELECT                          = 0xD9D7;
constexpr unsigned int mmSQG_PERFCOUNTER_CTRL                             = 0xD9D8;
constexpr unsigned int mmSQG_PERFCOUNTER_CTRL2                            = 0xD9DA;
constexpr unsigned int mmSQG_PERF_SAMPLE_FINISH                           = 0xD9DB;
constexpr unsigned int mmSQG_STATUS                                       = 0x2304;
constexpr unsigned int mmSQG_THREAD_TRACE_CONFIG                          = 0x230A;
constexpr unsigned int mmSQ_ALU_CLK_CTRL                                  = 0xF08E;
constexpr unsigned int mmSQ_ARB_CONFIG                                    = 0x230C;
constexpr unsigned int mmSQ_CLK_CTRL                                      = 0xF091;
constexpr unsigned int mmSQ_CMD                                           = 0x237B;
constexpr unsigned int mmSQ_CONFIG                                        = 0x2300;
constexpr unsigned int mmSQ_DSM_CNTL                                      = 0x2306;
constexpr unsigned int mmSQ_DSM_CNTL2                                     = 0x2307;
constexpr unsigned int mmSQ_DYN_VGPR                                      = 0x230D;
constexpr unsigned int mmSQ_FIFO_SIZES                                    = 0x2305;
constexpr unsigned int mmSQ_IND_DATA                                      = 0x2379;
constexpr unsigned int mmSQ_IND_INDEX                                     = 0x2378;
constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK                           = 0x231E;
constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL                            = 0x231F;
constexpr unsigned int mmSQ_LDS_CLK_CTRL                                  = 0xF090;
constexpr unsigned int mmSQ_PERFCOUNTER0_LO                               = 0xD1C0;
constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT                           = 0xD9C0;
constexpr unsigned int mmSQ_PERFCOUNTER1_LO                               = 0xD1C2;
constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT                           = 0xD9C1;
constexpr unsigned int mmSQ_PERFCOUNTER2_LO                               = 0xD1C4;
constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT                           = 0xD9C2;
constexpr unsigned int mmSQ_PERFCOUNTER3_LO                               = 0xD1C6;
constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT                           = 0xD9C3;
constexpr unsigned int mmSQ_PERFCOUNTER4_LO                               = 0xD1C8;
constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT                           = 0xD9C4;
constexpr unsigned int mmSQ_PERFCOUNTER5_LO                               = 0xD1CA;
constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT                           = 0xD9C5;
constexpr unsigned int mmSQ_PERFCOUNTER6_LO                               = 0xD1CC;
constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT                           = 0xD9C6;
constexpr unsigned int mmSQ_PERFCOUNTER7_LO                               = 0xD1CE;
constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT                           = 0xD9C7;
constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT                           = 0xD9C8;
constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT                           = 0xD9C9;
constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT                          = 0xD9CA;
constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT                          = 0xD9CB;
constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT                          = 0xD9CC;
constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT                          = 0xD9CD;
constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT                          = 0xD9CE;
constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT                          = 0xD9CF;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL                              = 0xD9E0;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2                             = 0xD9E2;
constexpr unsigned int mmSQ_PERF_SNAPSHOT_CTRL                            = 0x231B;
constexpr unsigned int mmSQ_RANDOM_WAVE_PRI                               = 0x2303;
constexpr unsigned int mmSQ_RUNTIME_CONFIG                                = 0xA9E0;
constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0xA9E7;
constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0xA9E6;
constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0xA9E9;
constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0xA9E8;
constexpr unsigned int mmSQ_TEX_CLK_CTRL                                  = 0xF08F;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE_HI                     = 0xD9E8;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE_LO                     = 0xD9E7;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE                        = 0xD9E6;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE_HI                     = 0xD9EB;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE_LO                     = 0xD9EA;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE                        = 0xD9E9;
constexpr unsigned int mmSQ_THREAD_TRACE_CTRL                             = 0xD9EC;
constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR                     = 0xD9FA;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR                    = 0xD9F6;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR                  = 0xD9F7;
constexpr unsigned int mmSQ_THREAD_TRACE_HALT                             = 0xD9F0;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR                   = 0xD9F8;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR                 = 0xD9F9;
constexpr unsigned int mmSQ_THREAD_TRACE_MASK                             = 0xD9ED;
constexpr unsigned int mmSQ_THREAD_TRACE_POWEROFF_RESTORE_1               = 0xD9F1;
constexpr unsigned int mmSQ_THREAD_TRACE_STATUS                           = 0xD9F4;
constexpr unsigned int mmSQ_THREAD_TRACE_STATUS2                          = 0xD9F5;
constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK                       = 0xD9EE;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0                       = 0xC340;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1                       = 0xC341;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2                       = 0xC342;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3                       = 0xC343;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4                       = 0xC344;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5                       = 0xC345;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6                       = 0xC346;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7                       = 0xC347;
constexpr unsigned int mmSQ_THREAD_TRACE_WPTR                             = 0xD9EF;
constexpr unsigned int mmSQ_WATCH0_ADDR_H                                 = 0x2330;
constexpr unsigned int mmSQ_WATCH0_ADDR_L                                 = 0x2331;
constexpr unsigned int mmSQ_WATCH0_CNTL                                   = 0x2332;
constexpr unsigned int mmSQ_WATCH1_ADDR_H                                 = 0x2333;
constexpr unsigned int mmSQ_WATCH1_ADDR_L                                 = 0x2334;
constexpr unsigned int mmSQ_WATCH1_CNTL                                   = 0x2335;
constexpr unsigned int mmSQ_WATCH2_ADDR_H                                 = 0x2336;
constexpr unsigned int mmSQ_WATCH2_ADDR_L                                 = 0x2337;
constexpr unsigned int mmSQ_WATCH2_CNTL                                   = 0x2338;
constexpr unsigned int mmSQ_WATCH3_ADDR_H                                 = 0x2339;
constexpr unsigned int mmSQ_WATCH3_ADDR_L                                 = 0x233A;
constexpr unsigned int mmSQ_WATCH3_CNTL                                   = 0x233B;
constexpr unsigned int mmSX_BLEND_OPT_CONTROL                             = 0xA1D7;
constexpr unsigned int mmSX_BLEND_OPT_EPSILON                             = 0xA1D6;
constexpr unsigned int mmSX_MRT0_BLEND_OPT                                = 0xA1D8;
constexpr unsigned int mmSX_MRT1_BLEND_OPT                                = 0xA1D9;
constexpr unsigned int mmSX_MRT2_BLEND_OPT                                = 0xA1DA;
constexpr unsigned int mmSX_MRT3_BLEND_OPT                                = 0xA1DB;
constexpr unsigned int mmSX_MRT4_BLEND_OPT                                = 0xA1DC;
constexpr unsigned int mmSX_MRT5_BLEND_OPT                                = 0xA1DD;
constexpr unsigned int mmSX_MRT6_BLEND_OPT                                = 0xA1DE;
constexpr unsigned int mmSX_MRT7_BLEND_OPT                                = 0xA1DF;
constexpr unsigned int mmSX_PERFCOUNTER0_HI                               = 0xD241;
constexpr unsigned int mmSX_PERFCOUNTER0_LO                               = 0xD240;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT                           = 0xDA40;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1                          = 0xDA44;
constexpr unsigned int mmSX_PERFCOUNTER1_HI                               = 0xD243;
constexpr unsigned int mmSX_PERFCOUNTER1_LO                               = 0xD242;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT                           = 0xDA41;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1                          = 0xDA45;
constexpr unsigned int mmSX_PERFCOUNTER2_HI                               = 0xD245;
constexpr unsigned int mmSX_PERFCOUNTER2_LO                               = 0xD244;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT                           = 0xDA42;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT1                          = 0xDA46;
constexpr unsigned int mmSX_PERFCOUNTER3_HI                               = 0xD247;
constexpr unsigned int mmSX_PERFCOUNTER3_LO                               = 0xD246;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT                           = 0xDA43;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT1                          = 0xDA47;
constexpr unsigned int mmSX_PS_DOWNCONVERT                                = 0xA1D5;
constexpr unsigned int mmSX_PS_DOWNCONVERT_CONTROL                        = 0xA1D4;
constexpr unsigned int mmTA_BC_BASE_ADDR                                  = 0xA020;
constexpr unsigned int mmTA_BC_BASE_ADDR_HI                               = 0xA021;
constexpr unsigned int mmTA_CNTL                                          = 0x2541;
constexpr unsigned int mmTA_CNTL2                                         = 0x2545;
constexpr unsigned int mmTA_CNTL_AUX                                      = 0x2542;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR                               = 0xC380;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI                            = 0xC381;
constexpr unsigned int mmTA_PERFCOUNTER0_HI                               = 0xD2C1;
constexpr unsigned int mmTA_PERFCOUNTER0_LO                               = 0xD2C0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT                           = 0xDAC0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1                          = 0xDAC1;
constexpr unsigned int mmTA_PERFCOUNTER1_HI                               = 0xD2C3;
constexpr unsigned int mmTA_PERFCOUNTER1_LO                               = 0xD2C2;
constexpr unsigned int mmTA_PERFCOUNTER1_SELECT                           = 0xDAC2;
constexpr unsigned int mmTA_SCRATCH                                       = 0x2564;
constexpr unsigned int mmTA_STATUS                                        = 0x2548;
constexpr unsigned int mmTCP_PERFCOUNTER0_HI                              = 0xD341;
constexpr unsigned int mmTCP_PERFCOUNTER0_LO                              = 0xD340;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT                          = 0xDB40;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT1                         = 0xDB41;
constexpr unsigned int mmTCP_PERFCOUNTER1_HI                              = 0xD343;
constexpr unsigned int mmTCP_PERFCOUNTER1_LO                              = 0xD342;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT                          = 0xDB42;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT1                         = 0xDB43;
constexpr unsigned int mmTCP_PERFCOUNTER2_HI                              = 0xD345;
constexpr unsigned int mmTCP_PERFCOUNTER2_LO                              = 0xD344;
constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT                          = 0xDB44;
constexpr unsigned int mmTCP_PERFCOUNTER3_HI                              = 0xD347;
constexpr unsigned int mmTCP_PERFCOUNTER3_LO                              = 0xD346;
constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT                          = 0xDB45;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER                           = 0xD348;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2                          = 0xD349;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN                        = 0xD34A;
constexpr unsigned int mmTD_PERFCOUNTER0_HI                               = 0xD301;
constexpr unsigned int mmTD_PERFCOUNTER0_LO                               = 0xD300;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT                           = 0xDB00;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1                          = 0xDB01;
constexpr unsigned int mmTD_PERFCOUNTER1_HI                               = 0xD303;
constexpr unsigned int mmTD_PERFCOUNTER1_LO                               = 0xD302;
constexpr unsigned int mmTD_PERFCOUNTER1_SELECT                           = 0xDB02;
constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0x14344;
constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0x14347;
constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0x1434A;
constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0x1434D;
constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0x14350;
constexpr unsigned int mmUMCCH0_PerfMonCtl6                               = 0x14353;
constexpr unsigned int mmUMCCH0_PerfMonCtl7                               = 0x14356;
constexpr unsigned int mmUMCCH0_PerfMonCtl8                               = 0x14359;
constexpr unsigned int mmUMCCH0_PerfMonCtl9                               = 0x1435C;
constexpr unsigned int mmUMCCH0_PerfMonCtl10                              = 0x1435F;
constexpr unsigned int mmUMCCH0_PerfMonCtl11                              = 0x14362;
constexpr unsigned int mmUMCCH0_PerfMonCtl12                              = 0x14365;
constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0x14340;
constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0x14346;
constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0x14345;
constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0x14349;
constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0x14348;
constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0x1434C;
constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0x1434B;
constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0x1434F;
constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0x1434E;
constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0x14352;
constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0x14351;
constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi                            = 0x14355;
constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo                            = 0x14354;
constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi                            = 0x14358;
constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo                            = 0x14357;
constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi                            = 0x1435B;
constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo                            = 0x1435A;
constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi                            = 0x1435E;
constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo                            = 0x1435D;
constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi                           = 0x14361;
constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo                           = 0x14360;
constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi                           = 0x14364;
constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo                           = 0x14363;
constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi                           = 0x14367;
constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo                           = 0x14366;
constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0x14342;
constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0x14341;
constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14744;
constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14747;
constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x1474A;
constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x1474D;
constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14750;
constexpr unsigned int mmUMCCH1_PerfMonCtl6                               = 0x14753;
constexpr unsigned int mmUMCCH1_PerfMonCtl7                               = 0x14756;
constexpr unsigned int mmUMCCH1_PerfMonCtl8                               = 0x14759;
constexpr unsigned int mmUMCCH1_PerfMonCtl9                               = 0x1475C;
constexpr unsigned int mmUMCCH1_PerfMonCtl10                              = 0x1475F;
constexpr unsigned int mmUMCCH1_PerfMonCtl11                              = 0x14762;
constexpr unsigned int mmUMCCH1_PerfMonCtl12                              = 0x14765;
constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14740;
constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14746;
constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14745;
constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14749;
constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14748;
constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x1474C;
constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x1474B;
constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x1474F;
constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x1474E;
constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14752;
constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14751;
constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi                            = 0x14755;
constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo                            = 0x14754;
constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi                            = 0x14758;
constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo                            = 0x14757;
constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi                            = 0x1475B;
constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo                            = 0x1475A;
constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi                            = 0x1475E;
constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo                            = 0x1475D;
constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi                           = 0x14761;
constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo                           = 0x14760;
constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi                           = 0x14764;
constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo                           = 0x14763;
constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi                           = 0x14767;
constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo                           = 0x14766;
constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14742;
constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14741;
constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0x54344;
constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0x54347;
constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0x5434A;
constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0x5434D;
constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0x54350;
constexpr unsigned int mmUMCCH2_PerfMonCtl6                               = 0x54353;
constexpr unsigned int mmUMCCH2_PerfMonCtl7                               = 0x54356;
constexpr unsigned int mmUMCCH2_PerfMonCtl8                               = 0x54359;
constexpr unsigned int mmUMCCH2_PerfMonCtl9                               = 0x5435C;
constexpr unsigned int mmUMCCH2_PerfMonCtl10                              = 0x5435F;
constexpr unsigned int mmUMCCH2_PerfMonCtl11                              = 0x54362;
constexpr unsigned int mmUMCCH2_PerfMonCtl12                              = 0x54365;
constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0x54340;
constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0x54346;
constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0x54345;
constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0x54349;
constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0x54348;
constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0x5434C;
constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0x5434B;
constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0x5434F;
constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0x5434E;
constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0x54352;
constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0x54351;
constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi                            = 0x54355;
constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo                            = 0x54354;
constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi                            = 0x54358;
constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo                            = 0x54357;
constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi                            = 0x5435B;
constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo                            = 0x5435A;
constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi                            = 0x5435E;
constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo                            = 0x5435D;
constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi                           = 0x54361;
constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo                           = 0x54360;
constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi                           = 0x54364;
constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo                           = 0x54363;
constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi                           = 0x54367;
constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo                           = 0x54366;
constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0x54342;
constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0x54341;
constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54744;
constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54747;
constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x5474A;
constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x5474D;
constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54750;
constexpr unsigned int mmUMCCH3_PerfMonCtl6                               = 0x54753;
constexpr unsigned int mmUMCCH3_PerfMonCtl7                               = 0x54756;
constexpr unsigned int mmUMCCH3_PerfMonCtl8                               = 0x54759;
constexpr unsigned int mmUMCCH3_PerfMonCtl9                               = 0x5475C;
constexpr unsigned int mmUMCCH3_PerfMonCtl10                              = 0x5475F;
constexpr unsigned int mmUMCCH3_PerfMonCtl11                              = 0x54762;
constexpr unsigned int mmUMCCH3_PerfMonCtl12                              = 0x54765;
constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54740;
constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x54746;
constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x54745;
constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x54749;
constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x54748;
constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x5474C;
constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x5474B;
constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x5474F;
constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x5474E;
constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54752;
constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54751;
constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi                            = 0x54755;
constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo                            = 0x54754;
constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi                            = 0x54758;
constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo                            = 0x54757;
constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi                            = 0x5475B;
constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo                            = 0x5475A;
constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi                            = 0x5475E;
constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo                            = 0x5475D;
constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi                           = 0x54761;
constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo                           = 0x54760;
constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi                           = 0x54764;
constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo                           = 0x54763;
constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi                           = 0x54767;
constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo                           = 0x54766;
constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54742;
constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54741;
constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94344;
constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94347;
constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x9434A;
constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x9434D;
constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94350;
constexpr unsigned int mmUMCCH4_PerfMonCtl6                               = 0x94353;
constexpr unsigned int mmUMCCH4_PerfMonCtl7                               = 0x94356;
constexpr unsigned int mmUMCCH4_PerfMonCtl8                               = 0x94359;
constexpr unsigned int mmUMCCH4_PerfMonCtl9                               = 0x9435C;
constexpr unsigned int mmUMCCH4_PerfMonCtl10                              = 0x9435F;
constexpr unsigned int mmUMCCH4_PerfMonCtl11                              = 0x94362;
constexpr unsigned int mmUMCCH4_PerfMonCtl12                              = 0x94365;
constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x94346;
constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x94345;
constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x94349;
constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x94348;
constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434C;
constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434B;
constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x9434F;
constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x9434E;
constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94352;
constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94351;
constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi                            = 0x94355;
constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo                            = 0x94354;
constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi                            = 0x94358;
constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo                            = 0x94357;
constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi                            = 0x9435B;
constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo                            = 0x9435A;
constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi                            = 0x9435E;
constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo                            = 0x9435D;
constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi                           = 0x94361;
constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo                           = 0x94360;
constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi                           = 0x94364;
constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo                           = 0x94363;
constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi                           = 0x94367;
constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo                           = 0x94366;
constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94342;
constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94341;
constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94744;
constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94747;
constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x9474A;
constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x9474D;
constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94750;
constexpr unsigned int mmUMCCH5_PerfMonCtl6                               = 0x94753;
constexpr unsigned int mmUMCCH5_PerfMonCtl7                               = 0x94756;
constexpr unsigned int mmUMCCH5_PerfMonCtl8                               = 0x94759;
constexpr unsigned int mmUMCCH5_PerfMonCtl9                               = 0x9475C;
constexpr unsigned int mmUMCCH5_PerfMonCtl10                              = 0x9475F;
constexpr unsigned int mmUMCCH5_PerfMonCtl11                              = 0x94762;
constexpr unsigned int mmUMCCH5_PerfMonCtl12                              = 0x94765;
constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94740;
constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x94746;
constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x94745;
constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x94749;
constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x94748;
constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x9474C;
constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x9474B;
constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x9474F;
constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x9474E;
constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94752;
constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94751;
constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi                            = 0x94755;
constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo                            = 0x94754;
constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi                            = 0x94758;
constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo                            = 0x94757;
constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi                            = 0x9475B;
constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo                            = 0x9475A;
constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi                            = 0x9475E;
constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo                            = 0x9475D;
constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi                           = 0x94761;
constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo                           = 0x94760;
constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi                           = 0x94764;
constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo                           = 0x94763;
constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi                           = 0x94767;
constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo                           = 0x94766;
constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94742;
constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94741;
constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4344;
constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4347;
constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD434A;
constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD434D;
constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4350;
constexpr unsigned int mmUMCCH6_PerfMonCtl6                               = 0xD4353;
constexpr unsigned int mmUMCCH6_PerfMonCtl7                               = 0xD4356;
constexpr unsigned int mmUMCCH6_PerfMonCtl8                               = 0xD4359;
constexpr unsigned int mmUMCCH6_PerfMonCtl9                               = 0xD435C;
constexpr unsigned int mmUMCCH6_PerfMonCtl10                              = 0xD435F;
constexpr unsigned int mmUMCCH6_PerfMonCtl11                              = 0xD4362;
constexpr unsigned int mmUMCCH6_PerfMonCtl12                              = 0xD4365;
constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD4346;
constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD4345;
constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD4349;
constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD4348;
constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434C;
constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434B;
constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD434F;
constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD434E;
constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4352;
constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4351;
constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi                            = 0xD4355;
constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo                            = 0xD4354;
constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi                            = 0xD4358;
constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo                            = 0xD4357;
constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi                            = 0xD435B;
constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo                            = 0xD435A;
constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi                            = 0xD435E;
constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo                            = 0xD435D;
constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi                           = 0xD4361;
constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo                           = 0xD4360;
constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi                           = 0xD4364;
constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo                           = 0xD4363;
constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi                           = 0xD4367;
constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo                           = 0xD4366;
constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4342;
constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4341;
constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4744;
constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4747;
constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD474A;
constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD474D;
constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4750;
constexpr unsigned int mmUMCCH7_PerfMonCtl6                               = 0xD4753;
constexpr unsigned int mmUMCCH7_PerfMonCtl7                               = 0xD4756;
constexpr unsigned int mmUMCCH7_PerfMonCtl8                               = 0xD4759;
constexpr unsigned int mmUMCCH7_PerfMonCtl9                               = 0xD475C;
constexpr unsigned int mmUMCCH7_PerfMonCtl10                              = 0xD475F;
constexpr unsigned int mmUMCCH7_PerfMonCtl11                              = 0xD4762;
constexpr unsigned int mmUMCCH7_PerfMonCtl12                              = 0xD4765;
constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4740;
constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD4746;
constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD4745;
constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD4749;
constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD4748;
constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD474C;
constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD474B;
constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD474F;
constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD474E;
constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4752;
constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4751;
constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi                            = 0xD4755;
constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo                            = 0xD4754;
constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi                            = 0xD4758;
constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo                            = 0xD4757;
constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi                            = 0xD475B;
constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo                            = 0xD475A;
constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi                            = 0xD475E;
constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo                            = 0xD475D;
constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi                           = 0xD4761;
constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo                           = 0xD4760;
constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi                           = 0xD4764;
constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo                           = 0xD4763;
constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi                           = 0xD4767;
constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo                           = 0xD4766;
constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4742;
constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4741;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI                            = 0xD5A1;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO                            = 0xD5A0;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT                        = 0xDDA0;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI                            = 0xD5A3;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO                            = 0xD5A2;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT                        = 0xDDA1;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_HI                            = 0xD5A5;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_LO                            = 0xD5A4;
constexpr unsigned int mmUTCL1_PERFCOUNTER2_SELECT                        = 0xDDA2;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_HI                            = 0xD5A7;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_LO                            = 0xD5A6;
constexpr unsigned int mmUTCL1_PERFCOUNTER3_SELECT                        = 0xDDA3;
constexpr unsigned int mmVGT_DMA_BASE                                     = 0xA1FA;
constexpr unsigned int mmVGT_DMA_BASE_HI                                  = 0xA1F9;
constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH                          = 0x222D;
constexpr unsigned int mmVGT_DMA_INDEX_TYPE                               = 0xA29F;
constexpr unsigned int mmVGT_DMA_MAX_SIZE                                 = 0xA29E;
constexpr unsigned int mmVGT_DMA_NUM_INSTANCES                            = 0xA2A2;
constexpr unsigned int mmVGT_DMA_REQ_FIFO_DEPTH                           = 0x222E;
constexpr unsigned int mmVGT_DMA_SIZE                                     = 0xA29D;
constexpr unsigned int mmVGT_DRAW_INITIATOR                               = 0xA1FC;
constexpr unsigned int mmVGT_DRAW_INIT_FIFO_DEPTH                         = 0x222F;
constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL                            = 0xA2A8;
constexpr unsigned int mmVGT_EVENT_ADDRESS_REG                            = 0xA1FE;
constexpr unsigned int mmVGT_EVENT_INITIATOR                              = 0xA2A4;
constexpr unsigned int mmVGT_GS_INSTANCE_CNT                              = 0xA2CF;
constexpr unsigned int mmVGT_GS_MAX_VERT_OUT                              = 0xA2CE;
constexpr unsigned int mmVGT_GS_MAX_WAVE_ID                               = 0x2269;
constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE                             = 0xC266;
constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL                           = 0xA286;
constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL                           = 0xA287;
constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0xC24F;
constexpr unsigned int mmVGT_INDEX_TYPE                                   = 0xC243;
constexpr unsigned int mmVGT_INSTANCE_BASE_ID                             = 0xC25A;
constexpr unsigned int mmVGT_LS_HS_CONFIG                                 = 0xA2D6;
constexpr unsigned int mmVGT_MC_LAT_CNTL                                  = 0x2236;
constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX                     = 0xA103;
constexpr unsigned int mmVGT_NUM_INDICES                                  = 0xC24C;
constexpr unsigned int mmVGT_NUM_INSTANCES                                = 0xC24D;
constexpr unsigned int mmVGT_PRIMITIVEID_EN                               = 0xC262;
constexpr unsigned int mmVGT_PRIMITIVEID_RESET                            = 0xC26D;
constexpr unsigned int mmVGT_PRIMITIVE_TYPE                               = 0xC242;
constexpr unsigned int mmVGT_REUSE_OFF                                    = 0xA2A7;
constexpr unsigned int mmVGT_SHADER_STAGES_EN                             = 0xA2A6;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE       = 0xA2CB;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET                   = 0xA2CA;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE            = 0xA2CC;
constexpr unsigned int mmVGT_TESS_DISTRIBUTION                            = 0xA2D4;
constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0xC250;
constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0xC267;
constexpr unsigned int mmVGT_TF_PARAM                                     = 0xA2A9;
constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0xC24E;
constexpr unsigned int mmWD_UTCL1_CNTL                                    = 0x2243;
constexpr unsigned int mmWD_UTCL1_STATUS                                  = 0x2244;
constexpr unsigned int mmWGS_BUSY_HYSTERESIS                              = 0xC7BD;
constexpr unsigned int mmWGS_BUSY_STAT                                    = 0xC7D1;
constexpr unsigned int mmWGS_BUSY_STAT2                                   = 0xC7D3;
constexpr unsigned int mmWGS_COMPUTE_DDID_INDEX                           = 0xC6A9;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE0                   = 0xC696;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE1                   = 0xC697;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE2                   = 0xC699;
constexpr unsigned int mmWGS_COMPUTE_DESTINATION_EN_SE3                   = 0xC69A;
constexpr unsigned int mmWGS_COMPUTE_DIM_X                                = 0xC681;
constexpr unsigned int mmWGS_COMPUTE_DIM_Y                                = 0xC682;
constexpr unsigned int mmWGS_COMPUTE_DIM_Z                                = 0xC683;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_END                         = 0xC6FE;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_ID                          = 0xC6A0;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_INITIATOR                   = 0xC680;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_INTERLEAVE                  = 0xC6AF;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_PKT_ADDR_HI                 = 0xC68F;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_PKT_ADDR_LO                 = 0xC68E;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_SCRATCH_BASE_HI             = 0xC691;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_SCRATCH_BASE_LO             = 0xC690;
constexpr unsigned int mmWGS_COMPUTE_DISPATCH_TUNNEL                      = 0xC6FD;
constexpr unsigned int mmWGS_COMPUTE_MISC_RESERVED                        = 0xC69F;
constexpr unsigned int mmWGS_COMPUTE_NOWHERE                              = 0xC6FF;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_X                         = 0xC687;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_Y                         = 0xC688;
constexpr unsigned int mmWGS_COMPUTE_NUM_THREAD_Z                         = 0xC689;
constexpr unsigned int mmWGS_COMPUTE_PERFCOUNT_ENABLE                     = 0xC68B;
constexpr unsigned int mmWGS_COMPUTE_PGM_HI                               = 0xC68D;
constexpr unsigned int mmWGS_COMPUTE_PGM_LO                               = 0xC68C;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC1                            = 0xC692;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC2                            = 0xC693;
constexpr unsigned int mmWGS_COMPUTE_PGM_RSRC3                            = 0xC6A8;
constexpr unsigned int mmWGS_COMPUTE_PIPELINESTAT_ENABLE                  = 0xC68A;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_X                      = 0xC6B5;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_Y                      = 0xC6B6;
constexpr unsigned int mmWGS_COMPUTE_PRESCALED_DIM_Z                      = 0xC6B7;
constexpr unsigned int mmWGS_COMPUTE_RELAUNCH                             = 0xC6B0;
constexpr unsigned int mmWGS_COMPUTE_RELAUNCH2                            = 0xC6B3;
constexpr unsigned int mmWGS_COMPUTE_REQ_CTRL                             = 0xC6A2;
constexpr unsigned int mmWGS_COMPUTE_RESOURCE_LIMITS                      = 0xC695;
constexpr unsigned int mmWGS_COMPUTE_RESTART_X                            = 0xC69B;
constexpr unsigned int mmWGS_COMPUTE_RESTART_Y                            = 0xC69C;
constexpr unsigned int mmWGS_COMPUTE_RESTART_Z                            = 0xC69D;
constexpr unsigned int mmWGS_COMPUTE_SHADER_CHKSUM                        = 0xC6AA;
constexpr unsigned int mmWGS_COMPUTE_START_X                              = 0xC684;
constexpr unsigned int mmWGS_COMPUTE_START_Y                              = 0xC685;
constexpr unsigned int mmWGS_COMPUTE_START_Z                              = 0xC686;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE0               = 0xC696;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE1               = 0xC697;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE2               = 0xC699;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE3               = 0xC69A;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE4               = 0xC6AB;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE5               = 0xC6AC;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE6               = 0xC6AD;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE7               = 0xC6AE;
constexpr unsigned int mmWGS_COMPUTE_STATIC_THREAD_MGMT_SE8               = 0xC6A3;
constexpr unsigned int mmWGS_COMPUTE_THREADGROUP_ID                       = 0xC6A1;
constexpr unsigned int mmWGS_COMPUTE_THREAD_TRACE_ENABLE                  = 0xC69E;
constexpr unsigned int mmWGS_COMPUTE_TMPRING_SIZE                         = 0xC698;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_0                         = 0xC6A4;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_1                         = 0xC6A5;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_2                         = 0xC6A6;
constexpr unsigned int mmWGS_COMPUTE_USER_ACCUM_3                         = 0xC6A7;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_0                          = 0xC6C0;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_1                          = 0xC6C1;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_2                          = 0xC6C2;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_3                          = 0xC6C3;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_4                          = 0xC6C4;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_5                          = 0xC6C5;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_6                          = 0xC6C6;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_7                          = 0xC6C7;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_8                          = 0xC6C8;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_9                          = 0xC6C9;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_10                         = 0xC6CA;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_11                         = 0xC6CB;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_12                         = 0xC6CC;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_13                         = 0xC6CD;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_14                         = 0xC6CE;
constexpr unsigned int mmWGS_COMPUTE_USER_DATA_15                         = 0xC6CF;
constexpr unsigned int mmWGS_COMPUTE_VMID                                 = 0xC694;
constexpr unsigned int mmWGS_COMPUTE_WAVE_RESTORE_ADDR_HI                 = 0xC6B2;
constexpr unsigned int mmWGS_COMPUTE_WAVE_RESTORE_ADDR_LO                 = 0xC6B1;
constexpr unsigned int mmWGS_DATA1                                        = 0xC7DB;
constexpr unsigned int mmWGS_DATA2                                        = 0xC7DC;
constexpr unsigned int mmWGS_DATA3                                        = 0xC7DD;
constexpr unsigned int mmWGS_DATA4                                        = 0xC7DE;
constexpr unsigned int mmWGS_DATA5                                        = 0xC7DF;
constexpr unsigned int mmWGS_DATA6                                        = 0xC7E0;
constexpr unsigned int mmWGS_DATA7                                        = 0xC7E1;
constexpr unsigned int mmWGS_DATA8                                        = 0xC7E2;
constexpr unsigned int mmWGS_DATA9                                        = 0xC7E3;
constexpr unsigned int mmWGS_DATA10                                       = 0xC7E4;
constexpr unsigned int mmWGS_DATA11                                       = 0xC7E5;
constexpr unsigned int mmWGS_DATA12                                       = 0xC7E6;
constexpr unsigned int mmWGS_DATA13                                       = 0xC7E7;
constexpr unsigned int mmWGS_DATA14                                       = 0xC7E8;
constexpr unsigned int mmWGS_DATA15                                       = 0xC7E9;
constexpr unsigned int mmWGS_DATA16                                       = 0xC7EA;
constexpr unsigned int mmWGS_DC_APERTURE0_BASE                            = 0xC768;
constexpr unsigned int mmWGS_DC_APERTURE0_CNTL                            = 0xC76A;
constexpr unsigned int mmWGS_DC_APERTURE0_MASK                            = 0xC769;
constexpr unsigned int mmWGS_DC_APERTURE1_BASE                            = 0xC76B;
constexpr unsigned int mmWGS_DC_APERTURE1_CNTL                            = 0xC76D;
constexpr unsigned int mmWGS_DC_APERTURE1_MASK                            = 0xC76C;
constexpr unsigned int mmWGS_DC_APERTURE2_BASE                            = 0xC76E;
constexpr unsigned int mmWGS_DC_APERTURE2_CNTL                            = 0xC770;
constexpr unsigned int mmWGS_DC_APERTURE2_MASK                            = 0xC76F;
constexpr unsigned int mmWGS_DC_APERTURE3_BASE                            = 0xC771;
constexpr unsigned int mmWGS_DC_APERTURE3_CNTL                            = 0xC773;
constexpr unsigned int mmWGS_DC_APERTURE3_MASK                            = 0xC772;
constexpr unsigned int mmWGS_DC_APERTURE4_BASE                            = 0xC774;
constexpr unsigned int mmWGS_DC_APERTURE4_CNTL                            = 0xC776;
constexpr unsigned int mmWGS_DC_APERTURE4_MASK                            = 0xC775;
constexpr unsigned int mmWGS_DC_APERTURE5_BASE                            = 0xC777;
constexpr unsigned int mmWGS_DC_APERTURE5_CNTL                            = 0xC779;
constexpr unsigned int mmWGS_DC_APERTURE5_MASK                            = 0xC778;
constexpr unsigned int mmWGS_DC_APERTURE6_BASE                            = 0xC77A;
constexpr unsigned int mmWGS_DC_APERTURE6_CNTL                            = 0xC77C;
constexpr unsigned int mmWGS_DC_APERTURE6_MASK                            = 0xC77B;
constexpr unsigned int mmWGS_DC_APERTURE7_BASE                            = 0xC77D;
constexpr unsigned int mmWGS_DC_APERTURE7_CNTL                            = 0xC77F;
constexpr unsigned int mmWGS_DC_APERTURE7_MASK                            = 0xC77E;
constexpr unsigned int mmWGS_DC_APERTURE8_BASE                            = 0xC780;
constexpr unsigned int mmWGS_DC_APERTURE8_CNTL                            = 0xC782;
constexpr unsigned int mmWGS_DC_APERTURE8_MASK                            = 0xC781;
constexpr unsigned int mmWGS_DC_APERTURE9_BASE                            = 0xC783;
constexpr unsigned int mmWGS_DC_APERTURE9_CNTL                            = 0xC785;
constexpr unsigned int mmWGS_DC_APERTURE9_MASK                            = 0xC784;
constexpr unsigned int mmWGS_DC_APERTURE10_BASE                           = 0xC786;
constexpr unsigned int mmWGS_DC_APERTURE10_CNTL                           = 0xC788;
constexpr unsigned int mmWGS_DC_APERTURE10_MASK                           = 0xC787;
constexpr unsigned int mmWGS_DC_APERTURE11_BASE                           = 0xC789;
constexpr unsigned int mmWGS_DC_APERTURE11_CNTL                           = 0xC78B;
constexpr unsigned int mmWGS_DC_APERTURE11_MASK                           = 0xC78A;
constexpr unsigned int mmWGS_DC_APERTURE12_BASE                           = 0xC78C;
constexpr unsigned int mmWGS_DC_APERTURE12_CNTL                           = 0xC78E;
constexpr unsigned int mmWGS_DC_APERTURE12_MASK                           = 0xC78D;
constexpr unsigned int mmWGS_DC_APERTURE13_BASE                           = 0xC78F;
constexpr unsigned int mmWGS_DC_APERTURE13_CNTL                           = 0xC791;
constexpr unsigned int mmWGS_DC_APERTURE13_MASK                           = 0xC790;
constexpr unsigned int mmWGS_DC_APERTURE14_BASE                           = 0xC792;
constexpr unsigned int mmWGS_DC_APERTURE14_CNTL                           = 0xC794;
constexpr unsigned int mmWGS_DC_APERTURE14_MASK                           = 0xC793;
constexpr unsigned int mmWGS_DC_APERTURE15_BASE                           = 0xC795;
constexpr unsigned int mmWGS_DC_APERTURE15_CNTL                           = 0xC797;
constexpr unsigned int mmWGS_DC_APERTURE15_MASK                           = 0xC796;
constexpr unsigned int mmWGS_DC_BASE_CNTL                                 = 0xC732;
constexpr unsigned int mmWGS_DC_BASE_HI                                   = 0xC79A;
constexpr unsigned int mmWGS_DC_BASE_LO                                   = 0xC799;
constexpr unsigned int mmWGS_DC_OP_CNTL                                   = 0xC733;
constexpr unsigned int mmWGS_DDID_BASE_ADDR_HI                            = 0xC725;
constexpr unsigned int mmWGS_DDID_BASE_ADDR_LO                            = 0xC724;
constexpr unsigned int mmWGS_DDID_CNTL                                    = 0xC726;
constexpr unsigned int mmWGS_DM_INDEX_ADDR                                = 0xC74B;
constexpr unsigned int mmWGS_DM_INDEX_DATA                                = 0xC74C;
constexpr unsigned int mmWGS_ENDIAN_SWAP                                  = 0xC70D;
constexpr unsigned int mmWGS_ERROR                                        = 0xC70C;
constexpr unsigned int mmWGS_GEN_BASE_HI                                  = 0xC711;
constexpr unsigned int mmWGS_GEN_BASE_LO                                  = 0xC710;
constexpr unsigned int mmWGS_GP0_HI                                       = 0xC738;
constexpr unsigned int mmWGS_GP0_LO                                       = 0xC737;
constexpr unsigned int mmWGS_GP1_HI                                       = 0xC73A;
constexpr unsigned int mmWGS_GP1_LO                                       = 0xC739;
constexpr unsigned int mmWGS_GP2_HI                                       = 0xC73C;
constexpr unsigned int mmWGS_GP2_LO                                       = 0xC73B;
constexpr unsigned int mmWGS_GP3_HI                                       = 0xC73E;
constexpr unsigned int mmWGS_GP3_LO                                       = 0xC73D;
constexpr unsigned int mmWGS_GP4_HI                                       = 0xC740;
constexpr unsigned int mmWGS_GP4_LO                                       = 0xC73F;
constexpr unsigned int mmWGS_GP5_HI                                       = 0xC742;
constexpr unsigned int mmWGS_GP5_LO                                       = 0xC741;
constexpr unsigned int mmWGS_GP6_HI                                       = 0xC744;
constexpr unsigned int mmWGS_GP6_LO                                       = 0xC743;
constexpr unsigned int mmWGS_GP7_HI                                       = 0xC746;
constexpr unsigned int mmWGS_GP7_LO                                       = 0xC745;
constexpr unsigned int mmWGS_GP8_HI                                       = 0xC748;
constexpr unsigned int mmWGS_GP8_LO                                       = 0xC747;
constexpr unsigned int mmWGS_GP9_HI                                       = 0xC74A;
constexpr unsigned int mmWGS_GP9_LO                                       = 0xC749;
constexpr unsigned int mmWGS_HALT_HYST_COUNT                              = 0xC7EF;
constexpr unsigned int mmWGS_IC_BASE_CNTL                                 = 0xC7B9;
constexpr unsigned int mmWGS_IC_BASE_HI                                   = 0xC7B8;
constexpr unsigned int mmWGS_IC_BASE_LO                                   = 0xC7B7;
constexpr unsigned int mmWGS_IC_OP_CNTL                                   = 0xC79F;
constexpr unsigned int mmWGS_IH_FREE_COUNT                                = 0xC7A4;
constexpr unsigned int mmWGS_INT_CNTXID_HI                                = 0xC70B;
constexpr unsigned int mmWGS_INT_CNTXID_LO                                = 0xC70A;
constexpr unsigned int mmWGS_INT_INFO                                     = 0xC709;
constexpr unsigned int mmWGS_INT_STATUS                                   = 0xC7A3;
constexpr unsigned int mmWGS_IQ_TIMER                                     = 0xC7EE;
constexpr unsigned int mmWGS_IQ_TIMER_MESSAGE                             = 0xC7F0;
constexpr unsigned int mmWGS_IQ_WAIT_TIME1                                = 0xC7B4;
constexpr unsigned int mmWGS_IQ_WAIT_TIME2                                = 0xC7B5;
constexpr unsigned int mmWGS_IQ_WAIT_TIME3                                = 0xC723;
constexpr unsigned int mmWGS_LATENCY_STATS_DATA                           = 0xC7D9;
constexpr unsigned int mmWGS_LATENCY_STATS_SELECT                         = 0xC7D8;
constexpr unsigned int mmWGS_LOCAL_APERTURE                               = 0xC752;
constexpr unsigned int mmWGS_LOCAL_BASE0_HI                               = 0xC74F;
constexpr unsigned int mmWGS_LOCAL_BASE0_LO                               = 0xC74E;
constexpr unsigned int mmWGS_LOCAL_INSTR_APERTURE                         = 0xC757;
constexpr unsigned int mmWGS_LOCAL_INSTR_BASE_HI                          = 0xC754;
constexpr unsigned int mmWGS_LOCAL_INSTR_BASE_LO                          = 0xC753;
constexpr unsigned int mmWGS_LOCAL_INSTR_MASK_HI                          = 0xC756;
constexpr unsigned int mmWGS_LOCAL_INSTR_MASK_LO                          = 0xC755;
constexpr unsigned int mmWGS_LOCAL_MASK0_HI                               = 0xC751;
constexpr unsigned int mmWGS_LOCAL_MASK0_LO                               = 0xC750;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_APERTURE                       = 0xC758;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_BASE_HI                        = 0xC75A;
constexpr unsigned int mmWGS_LOCAL_SCRATCH_BASE_LO                        = 0xC759;
constexpr unsigned int mmWGS_MDBASE_HI                                    = 0xC79A;
constexpr unsigned int mmWGS_MDBASE_LO                                    = 0xC799;
constexpr unsigned int mmWGS_MDBOUND_HI                                   = 0xC79E;
constexpr unsigned int mmWGS_MDBOUND_LO                                   = 0xC79D;
constexpr unsigned int mmWGS_ME1_HEADER_DUMP                              = 0xC7D4;
constexpr unsigned int mmWGS_ME1_PIPE0_PRIORITY                           = 0xC7A7;
constexpr unsigned int mmWGS_ME1_PIPE1_PRIORITY                           = 0xC7A8;
constexpr unsigned int mmWGS_ME1_PIPE2_PRIORITY                           = 0xC7A9;
constexpr unsigned int mmWGS_ME1_PIPE3_PRIORITY                           = 0xC7AA;
constexpr unsigned int mmWGS_ME1_PIPE_PRIORITY_CNTS                       = 0xC7A6;
constexpr unsigned int mmWGS_METADATA_BASE_ADDR_HI                        = 0xC7EC;
constexpr unsigned int mmWGS_METADATA_BASE_ADDR_LO                        = 0xC7EB;
constexpr unsigned int mmWGS_METADATA_CNTL                                = 0xC7ED;
constexpr unsigned int mmWGS_MGCG_SYNC_CNTL                               = 0xC708;
constexpr unsigned int mmWGS_MIBOUND_HI                                   = 0xC79C;
constexpr unsigned int mmWGS_MIBOUND_LO                                   = 0xC79B;
constexpr unsigned int mmWGS_MIE_HI                                       = 0xC72D;
constexpr unsigned int mmWGS_MIE_LO                                       = 0xC72C;
constexpr unsigned int mmWGS_MIP_HI                                       = 0xC731;
constexpr unsigned int mmWGS_MIP_LO                                       = 0xC730;
constexpr unsigned int mmWGS_MTIMECMP_HI                                  = 0xC735;
constexpr unsigned int mmWGS_MTIMECMP_LO                                  = 0xC734;
constexpr unsigned int mmWGS_MTVEC_HI                                     = 0xC729;
constexpr unsigned int mmWGS_MTVEC_LO                                     = 0xC728;
constexpr unsigned int mmWGS_OS_PIPES                                     = 0xC720;
constexpr unsigned int mmWGS_PERFCOUNTER0_HI                              = 0xD5B3;
constexpr unsigned int mmWGS_PERFCOUNTER0_LO                              = 0xD5B2;
constexpr unsigned int mmWGS_PERFCOUNTER0_SELECT                          = 0xDDB3;
constexpr unsigned int mmWGS_PERFCOUNTER0_SELECT1                         = 0xDDB1;
constexpr unsigned int mmWGS_PERFCOUNTER1_HI                              = 0xD5B1;
constexpr unsigned int mmWGS_PERFCOUNTER1_LO                              = 0xD5B0;
constexpr unsigned int mmWGS_PERFCOUNTER1_SELECT                          = 0xDDB0;
constexpr unsigned int mmWGS_PERFMON_CNTL                                 = 0xD5B4;
constexpr unsigned int mmWGS_RS64_CNTL                                    = 0xC72B;
constexpr unsigned int mmWGS_RS64_EXCEPTION_STATUS                        = 0xC75E;
constexpr unsigned int mmWGS_RS64_INSTR_PNTR                              = 0xC72F;
constexpr unsigned int mmWGS_RS64_INTERRUPT                               = 0xC72E;
constexpr unsigned int mmWGS_RS64_PENDING_INTERRUPT                       = 0xC75C;
constexpr unsigned int mmWGS_RS64_PERFCOUNT_CNTL                          = 0xC75B;
constexpr unsigned int mmWGS_RS64_PRGRM_CNTR_START                        = 0xC727;
constexpr unsigned int mmWGS_RS64_PRGRM_CNTR_START_HI                     = 0xC75F;
constexpr unsigned int mmWGS_RS64_PRIV_LEVEL                              = 0xC75D;
constexpr unsigned int mmWGS_RS64_PRIV_LEVEL_VIOLATION_STATUS             = 0xC75E;
constexpr unsigned int mmWGS_RS64_THREAD_CNTL                             = 0xC7F6;
constexpr unsigned int mmWGS_SCRATCH_DATA                                 = 0xC7D7;
constexpr unsigned int mmWGS_SCRATCH_INDEX                                = 0xC7D6;
constexpr unsigned int mmWGS_SECURE_REG0                                  = 0xC7F1;
constexpr unsigned int mmWGS_SECURE_REG1                                  = 0xC7F2;
constexpr unsigned int mmWGS_SECURE_REG2                                  = 0xC7F3;
constexpr unsigned int mmWGS_SECURE_REG3                                  = 0xC7F4;
constexpr unsigned int mmWGS_STALLED_STAT1                                = 0xC7D2;
constexpr unsigned int mmWGS_STATUS                                       = 0xC7D0;
constexpr unsigned int mmWGS_SUSPEND_CNTL_STACK_OFFSET                    = 0xC71C;
constexpr unsigned int mmWGS_SUSPEND_CNTL_STACK_SIZE                      = 0xC71D;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_BASE_ADDR_HI                = 0xC71A;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_BASE_ADDR_LO                = 0xC719;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_CONTROL                     = 0xC71B;
constexpr unsigned int mmWGS_SUSPEND_CTX_SAVE_SIZE                        = 0xC71F;
constexpr unsigned int mmWGS_SUSPEND_RESUME_REQ                           = 0xC721;
constexpr unsigned int mmWGS_SUSPEND_WG_STATE_OFFSET                      = 0xC71E;
constexpr unsigned int mmWGS_TC_PERF_COUNTER_WINDOW_SELECT                = 0xC7DA;
constexpr unsigned int mmWGS_TMZ_CNTL                                     = 0xC7BA;

#if CHIP_HDR_NAVI48
namespace Nv48
{
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114347;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6                               = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7                               = 0x114356;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8                               = 0x114359;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9                               = 0x11435C;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10                              = 0x11435F;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11                              = 0x114362;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12                              = 0x114365;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x114346;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x114348;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi                            = 0x114355;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo                            = 0x114354;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi                            = 0x114358;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo                            = 0x114357;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi                            = 0x11435B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo                            = 0x11435A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi                            = 0x11435E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo                            = 0x11435D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi                           = 0x114361;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo                           = 0x114360;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi                           = 0x114364;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo                           = 0x114363;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi                           = 0x114367;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo                           = 0x114366;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114341;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114744;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114747;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x11474A;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x11474D;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114750;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6                               = 0x114753;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7                               = 0x114756;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8                               = 0x114759;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9                               = 0x11475C;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10                              = 0x11475F;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11                              = 0x114762;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12                              = 0x114765;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114740;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x114746;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x114745;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x114749;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x114748;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x11474C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x11474B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x11474F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x11474E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114752;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114751;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi                            = 0x114755;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo                            = 0x114754;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi                            = 0x114758;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo                            = 0x114757;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi                            = 0x11475B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo                            = 0x11475A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi                            = 0x11475E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo                            = 0x11475D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi                           = 0x114761;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo                           = 0x114760;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi                           = 0x114764;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo                           = 0x114763;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi                           = 0x114767;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo                           = 0x114766;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114742;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114741;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154347;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6                              = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7                              = 0x154356;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8                              = 0x154359;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9                              = 0x15435C;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10                             = 0x15435F;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11                             = 0x154362;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12                             = 0x154365;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x154346;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x154348;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi                           = 0x154355;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo                           = 0x154354;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi                           = 0x154358;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo                           = 0x154357;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi                           = 0x15435B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo                           = 0x15435A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi                           = 0x15435E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo                           = 0x15435D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi                          = 0x154361;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo                          = 0x154360;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi                          = 0x154364;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo                          = 0x154363;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi                          = 0x154367;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo                          = 0x154366;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154341;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154744;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154747;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x15474A;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x15474D;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154750;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6                              = 0x154753;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7                              = 0x154756;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8                              = 0x154759;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9                              = 0x15475C;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10                             = 0x15475F;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11                             = 0x154762;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12                             = 0x154765;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154740;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x154746;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x154745;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x154749;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x154748;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x15474C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x15474B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x15474F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x15474E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154752;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154751;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi                           = 0x154755;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo                           = 0x154754;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi                           = 0x154758;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo                           = 0x154757;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi                           = 0x15475B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo                           = 0x15475A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi                           = 0x15475E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo                           = 0x15475D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi                          = 0x154761;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo                          = 0x154760;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi                          = 0x154764;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo                          = 0x154763;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi                          = 0x154767;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo                          = 0x154766;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154742;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154741;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0x194344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0x194347;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0x19434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0x19434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0x194350;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6                              = 0x194353;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7                              = 0x194356;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8                              = 0x194359;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9                              = 0x19435C;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10                             = 0x19435F;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11                             = 0x194362;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12                             = 0x194365;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0x194346;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0x194345;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0x194349;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0x194348;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0x19434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0x19434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0x194352;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0x194351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi                           = 0x194355;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo                           = 0x194354;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi                           = 0x194358;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo                           = 0x194357;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi                           = 0x19435B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo                           = 0x19435A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi                           = 0x19435E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo                           = 0x19435D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi                          = 0x194361;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo                          = 0x194360;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi                          = 0x194364;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo                          = 0x194363;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi                          = 0x194367;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo                          = 0x194366;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0x194342;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0x194341;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0x194744;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0x194747;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0x19474A;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0x19474D;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0x194750;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6                              = 0x194753;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7                              = 0x194756;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8                              = 0x194759;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9                              = 0x19475C;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10                             = 0x19475F;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11                             = 0x194762;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12                             = 0x194765;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0x194740;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0x194746;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0x194745;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0x194749;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0x194748;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0x19474C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0x19474B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0x19474F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0x19474E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0x194752;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0x194751;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi                           = 0x194755;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo                           = 0x194754;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi                           = 0x194758;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo                           = 0x194757;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi                           = 0x19475B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo                           = 0x19475A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi                           = 0x19475E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo                           = 0x19475D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi                          = 0x194761;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo                          = 0x194760;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi                          = 0x194764;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo                          = 0x194763;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi                          = 0x194767;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo                          = 0x194766;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0x194742;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0x194741;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0x1D4344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0x1D4347;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0x1D434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0x1D434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0x1D4350;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6                              = 0x1D4353;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7                              = 0x1D4356;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8                              = 0x1D4359;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9                              = 0x1D435C;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10                             = 0x1D435F;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11                             = 0x1D4362;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12                             = 0x1D4365;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0x1D4346;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0x1D4345;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0x1D4349;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0x1D4348;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0x1D434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0x1D434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0x1D4352;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0x1D4351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi                           = 0x1D4355;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo                           = 0x1D4354;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi                           = 0x1D4358;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo                           = 0x1D4357;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi                           = 0x1D435B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo                           = 0x1D435A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi                           = 0x1D435E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo                           = 0x1D435D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi                          = 0x1D4361;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo                          = 0x1D4360;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi                          = 0x1D4364;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo                          = 0x1D4363;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi                          = 0x1D4367;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo                          = 0x1D4366;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0x1D4342;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0x1D4341;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0x1D4744;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0x1D4747;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0x1D474A;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0x1D474D;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0x1D4750;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6                              = 0x1D4753;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7                              = 0x1D4756;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8                              = 0x1D4759;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9                              = 0x1D475C;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10                             = 0x1D475F;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11                             = 0x1D4762;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12                             = 0x1D4765;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0x1D4740;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0x1D4746;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0x1D4745;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0x1D4749;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0x1D4748;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0x1D474C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0x1D474B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0x1D474F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0x1D474E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0x1D4752;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0x1D4751;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi                           = 0x1D4755;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo                           = 0x1D4754;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi                           = 0x1D4758;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo                           = 0x1D4757;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi                           = 0x1D475B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo                           = 0x1D475A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi                           = 0x1D475E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo                           = 0x1D475D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi                          = 0x1D4761;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo                          = 0x1D4760;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi                          = 0x1D4764;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo                          = 0x1D4763;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi                          = 0x1D4767;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo                          = 0x1D4766;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0x1D4742;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0x1D4741;
} // namespace Nv48
#endif

} // inline namespace Chip
} // namespace Gfx12
} // namespace Pal
