/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx12
{
inline namespace Chip
{
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND0_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND0_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND0_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND1_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND1_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND1_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND2_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND2_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND2_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND3_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND3_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND3_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND4_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND4_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND4_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND5_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND5_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND5_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND6_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND6_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND6_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND7_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND7_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND7_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND_ALPHA__BLEND_ALPHA__SHIFT                 = 0x00000000;
constexpr unsigned int CB_BLEND_BLUE__BLEND_BLUE__SHIFT                   = 0x00000000;
constexpr unsigned int CB_BLEND_GREEN__BLEND_GREEN__SHIFT                 = 0x00000000;
constexpr unsigned int CB_BLEND_RED__BLEND_RED__SHIFT                     = 0x00000000;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_CACHE_EVICT_POINT__SHIFT = 0x00000018;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_COLOR_EVICT_POINT__SHIFT = 0x00000000;
constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_FMASK_EVICT_POINT__SHIFT = 0x00000008;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR0_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR0_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR0_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR0_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR0_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR0_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR0_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR0_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR0_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR0_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR0_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR0_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR0_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR0_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR0_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR0_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR0_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR1_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR1_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR1_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR1_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR1_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR1_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR1_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR1_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR1_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR1_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR1_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR1_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR1_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR1_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR1_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR1_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR1_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR2_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR2_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR2_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR2_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR2_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR2_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR2_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR2_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR2_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR2_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR2_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR2_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR2_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR2_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR2_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR2_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR2_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR3_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR3_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR3_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR3_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR3_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR3_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR3_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR3_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR3_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR3_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR3_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR3_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR3_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR3_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR3_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR3_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR3_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR4_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR4_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR4_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR4_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR4_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR4_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR4_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR4_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR4_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR4_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR4_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR4_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR4_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR4_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR4_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR4_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR4_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR5_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR5_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR5_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR5_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR5_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR5_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR5_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR5_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR5_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR5_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR5_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR5_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR5_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR5_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR5_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR5_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR5_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR6_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR6_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR6_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR6_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR6_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR6_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR6_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR6_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR6_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR6_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR6_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR6_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR6_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR6_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR6_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR6_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR6_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x00000010;
constexpr unsigned int CB_COLOR7_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000f;
constexpr unsigned int CB_COLOR7_ATTRIB3__MAX_MIP__SHIFT                  = 0x00000013;
constexpr unsigned int CB_COLOR7_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
constexpr unsigned int CB_COLOR7_ATTRIB3__SPECULATIVE_READ__SHIFT         = 0x0000001a;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000002;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_LIMIT_COLOR_SECTOR_TO_256B_MAX__SHIFT = 0x00000003;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x00000000;
constexpr unsigned int CB_COLOR7_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR7_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__COMPRESSION_MODE__SHIFT    = 0x0000001a;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__ENABLE_MAX_COMP_FRAG_OVERRIDE__SHIFT = 0x0000001c;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__FRAGMENT_COMPRESS_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_COMP_FRAGS__SHIFT      = 0x0000001d;
constexpr unsigned int CB_COLOR7_FDCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR7_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR7_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR7_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR7_INFO__DISABLE_WA_FOR_PARTIAL_TARGET_MASK_ALL__SHIFT = 0x00000013;
constexpr unsigned int CB_COLOR7_INFO__FORMAT__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR7_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
constexpr unsigned int CB_COLOR7_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR7_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR7_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR7_VIEW2__MIP_LEVEL__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX__SHIFT                   = 0x0000000e;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__DEGAMMA_ENABLE__SHIFT            = 0x00000003;
constexpr unsigned int CB_COLOR_CONTROL__DISABLE_DUAL_QUAD__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__MODE__SHIFT                      = 0x00000004;
constexpr unsigned int CB_COLOR_CONTROL__ROP3__SHIFT                      = 0x00000010;
constexpr unsigned int CB_FGCG_SRAM_OVERRIDE__DISABLE_FGCG__SHIFT         = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS__SHIFT          = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_1__COLOR_SCOPE__SHIFT                = 0x00000018;
constexpr unsigned int CB_HW_CONTROL_1__DISABLE_RDLAT_FIFO_BYP__SHIFT     = 0x00000016;
constexpr unsigned int CB_HW_CONTROL_1__DISABLE_SRC_FIFO_BYP__SHIFT       = 0x00000015;
constexpr unsigned int CB_HW_CONTROL_1__ENABLE_COMPRESSION_ON_BYPASS__SHIFT = 0x00000017;
constexpr unsigned int CB_HW_CONTROL_1__GLX_NOFILL__SHIFT                 = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL_1__GLX_PERF_CNTR_EN__SHIFT           = 0x0000001f;
constexpr unsigned int CB_HW_CONTROL_1__GLX_VQID__SHIFT                   = 0x0000001b;
constexpr unsigned int CB_HW_CONTROL_2__RESERVED__SHIFT                   = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_OPT_WA_AND_FULLY_COVERED__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_CLEAR_KEY_OVERRIDE_FROM_ILLEGAL_DECODE__SHIFT = 0x0000001b;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_256B_CLEARS_BECOME_1FRAG__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_INSERT_BUBBLES_B2B__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_OPT_OVERRIDE_ROH_COMP__SHIFT = 0x00000019;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_READ_DAW_WAIT_SECOND_64B__SHIFT = 0x0000001c;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SHADER_BLEND_OPTS__SHIFT  = 0x00000007;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_GLX_REQ_CLKEN_HIGH__SHIFT   = 0x00000003;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_GLX_SRC_CLKEN_HIGH__SHIFT   = 0x00000004;
constexpr unsigned int CB_HW_CONTROL_3__SPLIT_ALL_FAST_MODE_TRANSFERS__SHIFT = 0x00000006;
constexpr unsigned int CB_HW_CONTROL_4__DISABLE_FRAGOP_MULTI_FRAGMENT__SHIFT = 0x0000000e;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_COARSE_RAW_HAZARD__SHIFT = 0x00000011;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_DS_RAW_HAZARD__SHIFT = 0x00000012;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_FRAGOP_STALLING_ON_RAW_HAZARD__SHIFT = 0x00000010;
constexpr unsigned int CB_HW_CONTROL_4__ENABLE_READ_RESIDENCY_TIMEOUT_CNTR__SHIFT = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_4__THRESHOLD_READ_RESIDENCY_TIMEOUT_CNTR__SHIFT = 0x00000001;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_BYPASS__SHIFT     = 0x00000019;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_RESULT_EQ_DEST__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_WHEN_DISABLED_SRCALPHA_IS_USED__SHIFT = 0x0000001b;
constexpr unsigned int CB_HW_CONTROL__DISABLE_EVICT_ILLEGAL_KEY_OVERRIDE__SHIFT = 0x0000000f;
constexpr unsigned int CB_HW_CONTROL__DISABLE_FMASK_REREAD_OPT__SHIFT     = 0x0000001e;
constexpr unsigned int CB_HW_CONTROL__DISABLE_GRBM_BUSY_CNTR__SHIFT       = 0x00000000;
constexpr unsigned int CB_HW_CONTROL__DISABLE_HOLE_COLLAPSE__SHIFT        = 0x0000001d;
constexpr unsigned int CB_HW_CONTROL__DISABLE_MULTICYCLE_WRITES__SHIFT    = 0x0000001c;
constexpr unsigned int CB_HW_CONTROL__DISABLE_POWER_OPT_HC__SHIFT         = 0x00000017;
constexpr unsigned int CB_HW_CONTROL__DISABLE_USE_OF_SET_HASH__SHIFT      = 0x00000014;
constexpr unsigned int CB_HW_CONTROL__DISABLE_VRS_FILLRATE_OPTIMIZATION__SHIFT = 0x00000001;
constexpr unsigned int CB_HW_CONTROL__ENABLE_SINGLE_KEY_WR_OPT__SHIFT     = 0x00000016;
constexpr unsigned int CB_HW_CONTROL__EN_KEY_OVERRIDE__SHIFT              = 0x0000001f;
constexpr unsigned int CB_HW_CONTROL__FORCE_EVICT_ALL_VALID__SHIFT        = 0x00000010;
constexpr unsigned int CB_HW_CONTROL__FORCE_NEEDS_DST__SHIFT              = 0x00000013;
constexpr unsigned int CB_HW_CONTROL__FORCE_WAIT_EOP_DONE_FLUSH__SHIFT    = 0x00000012;
constexpr unsigned int CB_HW_CONTROL__GLX_CREDITS__SHIFT                  = 0x00000006;
constexpr unsigned int CB_HW_CONTROL__NUM_CCC_SKID_FIFO_ENTRIES__SHIFT    = 0x0000000c;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__ARB_MODE__SHIFT             = 0x00000000;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CREDIT_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CRED_CNT_MAX__SHIFT    = 0x00000007;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__READ_CYC_WEIGHT__SHIFT      = 0x00000001;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CREDIT_MODE__SHIFT    = 0x0000001b;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CRED_CNT_MAX__SHIFT   = 0x00000013;
constexpr unsigned int CB_HW_MEM_ARBITER_CTL__WRITE_CYC_WEIGHT__SHIFT     = 0x0000000d;
constexpr unsigned int CB_MEM0_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM0_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM1_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM1_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM2_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM2_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM3_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM3_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM4_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM4_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM5_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM5_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM6_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM6_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_MEM7_INFO__TEMPORAL_READ__SHIFT                 = 0x00000000;
constexpr unsigned int CB_MEM7_INFO__TEMPORAL_WRITE__SHIFT                = 0x00000003;
constexpr unsigned int CB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_ENABLE__SHIFT  = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_SEL__SHIFT     = 0x0000000b;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_ENABLE__SHIFT = 0x00000004;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_SEL__SHIFT    = 0x00000005;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_ENABLE__SHIFT    = 0x0000000c;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_SEL__SHIFT       = 0x0000000d;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_SEL__SHIFT = 0x00000016;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_SEL__SHIFT = 0x00000012;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_ENABLE__SHIFT     = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_SEL__SHIFT        = 0x00000001;
constexpr unsigned int CB_READ_RESP_KEY_OVERRIDE__KEY_IDX__SHIFT          = 0x00000000;
constexpr unsigned int CB_READ_RESP_KEY_OVERRIDE__NEW_KEY_VALUE__SHIFT    = 0x00000008;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_L3_BYPASS__SHIFT   = 0x0000001b;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_RD_POLICY__SHIFT   = 0x00000016;
constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_WR_POLICY__SHIFT   = 0x00000002;
constexpr unsigned int CB_SHADER_MASK__OUTPUT0_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT1_ENABLE__SHIFT              = 0x00000004;
constexpr unsigned int CB_SHADER_MASK__OUTPUT2_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int CB_SHADER_MASK__OUTPUT3_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int CB_SHADER_MASK__OUTPUT4_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int CB_SHADER_MASK__OUTPUT5_ENABLE__SHIFT              = 0x00000014;
constexpr unsigned int CB_SHADER_MASK__OUTPUT6_ENABLE__SHIFT              = 0x00000018;
constexpr unsigned int CB_SHADER_MASK__OUTPUT7_ENABLE__SHIFT              = 0x0000001c;
constexpr unsigned int CB_TARGET_MASK__TARGET0_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int CB_TARGET_MASK__TARGET1_ENABLE__SHIFT              = 0x00000004;
constexpr unsigned int CB_TARGET_MASK__TARGET2_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int CB_TARGET_MASK__TARGET3_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int CB_TARGET_MASK__TARGET4_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int CB_TARGET_MASK__TARGET5_ENABLE__SHIFT              = 0x00000014;
constexpr unsigned int CB_TARGET_MASK__TARGET6_ENABLE__SHIFT              = 0x00000018;
constexpr unsigned int CB_TARGET_MASK__TARGET7_ENABLE__SHIFT              = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_0__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_1__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_2__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_3__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_0__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_1__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_2__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_3__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COMPUTE_DDID_INDEX__INDEX__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE0__CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE1__CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE2__CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int COMPUTE_DESTINATION_EN_SE3__CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int COMPUTE_DIM_X__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Y__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Z__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_END__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_ID__DISPATCH_ID__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__AMP_SHADER_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__CS_W32_EN__SHIFT       = 0x0000000f;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__DISABLE_DISP_PREMPT_EN__SHIFT = 0x00000011;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000__SHIFT = 0x00000002;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__INTERLEAVE_2D_EN__SHIFT = 0x00000012;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL__SHIFT = 0x00000003;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE__SHIFT = 0x00000004;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDER_MODE__SHIFT      = 0x00000006;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN__SHIFT   = 0x00000001;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PING_PONG_EN__SHIFT    = 0x0000000c;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESTORE__SHIFT         = 0x0000000e;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL__SHIFT = 0x0000000a;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TTRACE_QUEUE_ID__SHIFT = 0x0000001d;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE__SHIFT   = 0x0000000d;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS__SHIFT = 0x00000005;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL__SHIFT = 0x0000000b;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__WGS_DISPATCH__SHIFT    = 0x00000013;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_1D__SHIFT  = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_X_SIZE__SHIFT = 0x00000010;
constexpr unsigned int COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_Y_SIZE__SHIFT = 0x00000018;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_HI__DATA__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_LO__DATA__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__OFF_DELAY__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED4__SHIFT            = 0x00000004;
constexpr unsigned int COMPUTE_MISC_RESERVED__SEND_SEID__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__WAVE_ID_BASE__SHIFT         = 0x00000005;
constexpr unsigned int COMPUTE_NOWHERE__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__INTERLEAVE_BITS_X__SHIFT     = 0x0000000d;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__INTERLEAVE_BITS_Y__SHIFT     = 0x0000000d;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE__SHIFT  = 0x00000000;
constexpr unsigned int COMPUTE_PGM_HI__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int COMPUTE_PGM_LO__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__BULKY__SHIFT                    = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC1__CDBG_USER__SHIFT                = 0x00000019;
constexpr unsigned int COMPUTE_PGM_RSRC1__DEBUG_MODE__SHIFT               = 0x00000016;
constexpr unsigned int COMPUTE_PGM_RSRC1__DISABLE_PERF__SHIFT             = 0x00000017;
constexpr unsigned int COMPUTE_PGM_RSRC1__FLOAT_MODE__SHIFT               = 0x0000000c;
constexpr unsigned int COMPUTE_PGM_RSRC1__FP16_OVFL__SHIFT                = 0x0000001a;
constexpr unsigned int COMPUTE_PGM_RSRC1__FWD_PROGRESS__SHIFT             = 0x0000001f;
constexpr unsigned int COMPUTE_PGM_RSRC1__MEM_ORDERED__SHIFT              = 0x0000001e;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIORITY__SHIFT                 = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIV__SHIFT                     = 0x00000014;
constexpr unsigned int COMPUTE_PGM_RSRC1__SGPRS__SHIFT                    = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC1__VGPRS__SHIFT                    = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__WGP_MODE__SHIFT                 = 0x0000001d;
constexpr unsigned int COMPUTE_PGM_RSRC1__WG_RR_EN__SHIFT                 = 0x00000015;
constexpr unsigned int COMPUTE_PGM_RSRC2__DYNAMIC_VGPR__SHIFT             = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MSB__SHIFT              = 0x0000000d;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN__SHIFT                  = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC2__LDS_SIZE__SHIFT                 = 0x0000000f;
constexpr unsigned int COMPUTE_PGM_RSRC2__SCRATCH_EN__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_X_EN__SHIFT                = 0x00000007;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Y_EN__SHIFT                = 0x00000008;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Z_EN__SHIFT                = 0x00000009;
constexpr unsigned int COMPUTE_PGM_RSRC2__TG_SIZE_EN__SHIFT               = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT__SHIFT           = 0x0000000b;
constexpr unsigned int COMPUTE_PGM_RSRC2__USER_SGPR__SHIFT                = 0x00000001;
constexpr unsigned int COMPUTE_PGM_RSRC2__WGP_TAKEOVER__SHIFT             = 0x0000001f;
constexpr unsigned int COMPUTE_PGM_RSRC3__GLG_EN__SHIFT                   = 0x0000000d;
constexpr unsigned int COMPUTE_PGM_RSRC3__IMAGE_OP__SHIFT                 = 0x0000001f;
constexpr unsigned int COMPUTE_PGM_RSRC3__INST_PREF_SIZE__SHIFT           = 0x00000004;
constexpr unsigned int COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_PRESCALED_DIM_X__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_PRESCALED_DIM_Y__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_PRESCALED_DIM_Z__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_RELAUNCH2__IS_EVENT__SHIFT                 = 0x0000001e;
constexpr unsigned int COMPUTE_RELAUNCH2__IS_STATE__SHIFT                 = 0x0000001f;
constexpr unsigned int COMPUTE_RELAUNCH2__PAYLOAD__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_RELAUNCH__IS_EVENT__SHIFT                  = 0x0000001e;
constexpr unsigned int COMPUTE_RELAUNCH__IS_STATE__SHIFT                  = 0x0000001f;
constexpr unsigned int COMPUTE_RELAUNCH__PAYLOAD__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
constexpr unsigned int COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT__SHIFT = 0x00000014;
constexpr unsigned int COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN__SHIFT        = 0x00000010;
constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS__SHIFT      = 0x00000009;
constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD__SHIFT   = 0x0000000a;
constexpr unsigned int COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
constexpr unsigned int COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT__SHIFT  = 0x0000000f;
constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_EN__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT__SHIFT     = 0x00000018;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST__SHIFT    = 0x00000017;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD__SHIFT     = 0x00000010;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL__SHIFT     = 0x00000016;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__TG_PER_CU__SHIFT          = 0x0000000c;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_X__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Y__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Z__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_SHADER_CHKSUM__CHECKSUM__SHIFT             = 0x00000000;
constexpr unsigned int COMPUTE_START_X__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_START_Y__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_START_Z__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE4__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE4__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE5__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE5__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE6__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE6__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE7__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE7__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE8__SA0_CU_EN__SHIFT   = 0x00000000;
constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE8__SA1_CU_EN__SHIFT   = 0x00000010;
constexpr unsigned int COMPUTE_THREADGROUP_ID__THREADGROUP_ID__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVESIZE__SHIFT              = 0x0000000c;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVES__SHIFT                 = 0x00000000;
constexpr unsigned int COMPUTE_USER_ACCUM_0__CONTRIBUTION__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_USER_ACCUM_1__CONTRIBUTION__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_USER_ACCUM_2__CONTRIBUTION__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_USER_ACCUM_3__CONTRIBUTION__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_0__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_1__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_2__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_3__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_4__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_5__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_6__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_7__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_8__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_9__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_10__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_11__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_12__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_13__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_14__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_15__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_VMID__DATA__SHIFT                          = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR__SHIFT          = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPF_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int CP_DMA_CNTL__BUFFER_DEPTH__SHIFT                   = 0x00000010;
constexpr unsigned int CP_DMA_CNTL__MIN_AVAILSZ__SHIFT                    = 0x00000004;
constexpr unsigned int CP_DMA_CNTL__PIO_COUNT__SHIFT                      = 0x0000001e;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_EMPTY__SHIFT                 = 0x0000001c;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_FULL__SHIFT                  = 0x0000001d;
constexpr unsigned int CP_DMA_CNTL__SPECULATIVE_DATA_READ__SHIFT          = 0x00000006;
constexpr unsigned int CP_DMA_CNTL__UTCL1_FAULT_CONTROL__SHIFT            = 0x00000000;
constexpr unsigned int CP_DMA_CNTL__WATCH_CONTROL__SHIFT                  = 0x00000001;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__ADDR_HI__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__RSVD__SHIFT                 = 0x00000010;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__ADDR_LO__SHIFT              = 0x00000002;
constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__RSVD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_DMA_ME_COMMAND__BYTE_COUNT__SHIFT               = 0x00000000;
constexpr unsigned int CP_DMA_ME_COMMAND__DAIC__SHIFT                     = 0x0000001d;
constexpr unsigned int CP_DMA_ME_COMMAND__DAS__SHIFT                      = 0x0000001b;
constexpr unsigned int CP_DMA_ME_COMMAND__DIS_WC__SHIFT                   = 0x0000001f;
constexpr unsigned int CP_DMA_ME_COMMAND__RAW_WAIT__SHIFT                 = 0x0000001e;
constexpr unsigned int CP_DMA_ME_COMMAND__SAIC__SHIFT                     = 0x0000001c;
constexpr unsigned int CP_DMA_ME_COMMAND__SAS__SHIFT                      = 0x0000001a;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_CACHE_POLICY__SHIFT         = 0x00000019;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_SELECT__SHIFT               = 0x00000014;
constexpr unsigned int CP_DMA_ME_CONTROL__MEMLOG_CLEAR__SHIFT             = 0x0000000a;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_CACHE_POLICY__SHIFT         = 0x0000000d;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_SELECT__SHIFT               = 0x0000001d;
constexpr unsigned int CP_DMA_ME_CONTROL__VMID__SHIFT                     = 0x00000000;
constexpr unsigned int CP_DMA_ME_DST_ADDR_HI__DST_ADDR_HI__SHIFT          = 0x00000000;
constexpr unsigned int CP_DMA_ME_DST_ADDR__DST_ADDR__SHIFT                = 0x00000000;
constexpr unsigned int CP_DMA_ME_SRC_ADDR_HI__SRC_ADDR_HI__SHIFT          = 0x00000000;
constexpr unsigned int CP_DMA_ME_SRC_ADDR__SRC_ADDR__SHIFT                = 0x00000000;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__ADDR_HI__SHIFT             = 0x00000000;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__RSVD__SHIFT                = 0x00000010;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__ADDR_LO__SHIFT             = 0x00000002;
constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__RSVD__SHIFT                = 0x00000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__BYTE_COUNT__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAIC__SHIFT                    = 0x0000001d;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAS__SHIFT                     = 0x0000001b;
constexpr unsigned int CP_DMA_PFP_COMMAND__DIS_WC__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_DMA_PFP_COMMAND__RAW_WAIT__SHIFT                = 0x0000001e;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAIC__SHIFT                    = 0x0000001c;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAS__SHIFT                     = 0x0000001a;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_CACHE_POLICY__SHIFT        = 0x00000019;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_SELECT__SHIFT              = 0x00000014;
constexpr unsigned int CP_DMA_PFP_CONTROL__MEMLOG_CLEAR__SHIFT            = 0x0000000a;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_CACHE_POLICY__SHIFT        = 0x0000000d;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_SELECT__SHIFT              = 0x0000001d;
constexpr unsigned int CP_DMA_PFP_CONTROL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_PFP_DST_ADDR_HI__DST_ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_DMA_PFP_DST_ADDR__DST_ADDR__SHIFT               = 0x00000000;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR_HI__SRC_ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR__SRC_ADDR__SHIFT               = 0x00000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__BYTE_COUNT__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAIC__SHIFT                    = 0x0000001d;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAS__SHIFT                     = 0x0000001b;
constexpr unsigned int CP_DMA_PIO_COMMAND__DIS_WC__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_DMA_PIO_COMMAND__RAW_WAIT__SHIFT                = 0x0000001e;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAIC__SHIFT                    = 0x0000001c;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAS__SHIFT                     = 0x0000001a;
constexpr unsigned int CP_DMA_PIO_CONTROL__DST_CACHE_POLICY__SHIFT        = 0x00000019;
constexpr unsigned int CP_DMA_PIO_CONTROL__DST_SELECT__SHIFT              = 0x00000014;
constexpr unsigned int CP_DMA_PIO_CONTROL__MEMLOG_CLEAR__SHIFT            = 0x0000000a;
constexpr unsigned int CP_DMA_PIO_CONTROL__SRC_CACHE_POLICY__SHIFT        = 0x0000000d;
constexpr unsigned int CP_DMA_PIO_CONTROL__SRC_SELECT__SHIFT              = 0x0000001d;
constexpr unsigned int CP_DMA_PIO_CONTROL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_PIO_DST_ADDR_HI__DST_ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_DMA_PIO_DST_ADDR__DST_ADDR__SHIFT               = 0x00000000;
constexpr unsigned int CP_DMA_PIO_SRC_ADDR_HI__SRC_ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_DMA_PIO_SRC_ADDR__SRC_ADDR__SHIFT               = 0x00000000;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_VALID__SHIFT        = 0x0000001c;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__ADDR_HI__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__RSVD__SHIFT                 = 0x00000010;
constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__ADDR_LO__SHIFT              = 0x00000008;
constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__RSVD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_DMA_WATCH0_CNTL__ANY_VMID__SHIFT                = 0x0000000a;
constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD1__SHIFT                   = 0x00000004;
constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD2__SHIFT                   = 0x0000000b;
constexpr unsigned int CP_DMA_WATCH0_CNTL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_READS__SHIFT             = 0x00000008;
constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_WRITES__SHIFT            = 0x00000009;
constexpr unsigned int CP_DMA_WATCH0_MASK__MASK__SHIFT                    = 0x00000008;
constexpr unsigned int CP_DMA_WATCH0_MASK__RSVD__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__ADDR_HI__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__RSVD__SHIFT                 = 0x00000010;
constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__ADDR_LO__SHIFT              = 0x00000008;
constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__RSVD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_DMA_WATCH1_CNTL__ANY_VMID__SHIFT                = 0x0000000a;
constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD1__SHIFT                   = 0x00000004;
constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD2__SHIFT                   = 0x0000000b;
constexpr unsigned int CP_DMA_WATCH1_CNTL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_READS__SHIFT             = 0x00000008;
constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_WRITES__SHIFT            = 0x00000009;
constexpr unsigned int CP_DMA_WATCH1_MASK__MASK__SHIFT                    = 0x00000008;
constexpr unsigned int CP_DMA_WATCH1_MASK__RSVD__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__ADDR_HI__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__RSVD__SHIFT                 = 0x00000010;
constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__ADDR_LO__SHIFT              = 0x00000008;
constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__RSVD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_DMA_WATCH2_CNTL__ANY_VMID__SHIFT                = 0x0000000a;
constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD1__SHIFT                   = 0x00000004;
constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD2__SHIFT                   = 0x0000000b;
constexpr unsigned int CP_DMA_WATCH2_CNTL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_READS__SHIFT             = 0x00000008;
constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_WRITES__SHIFT            = 0x00000009;
constexpr unsigned int CP_DMA_WATCH2_MASK__MASK__SHIFT                    = 0x00000008;
constexpr unsigned int CP_DMA_WATCH2_MASK__RSVD__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__ADDR_HI__SHIFT              = 0x00000000;
constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__RSVD__SHIFT                 = 0x00000010;
constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__ADDR_LO__SHIFT              = 0x00000008;
constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__RSVD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_DMA_WATCH3_CNTL__ANY_VMID__SHIFT                = 0x0000000a;
constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD1__SHIFT                   = 0x00000004;
constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD2__SHIFT                   = 0x0000000b;
constexpr unsigned int CP_DMA_WATCH3_CNTL__VMID__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_READS__SHIFT             = 0x00000008;
constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_WRITES__SHIFT            = 0x00000009;
constexpr unsigned int CP_DMA_WATCH3_MASK__MASK__SHIFT                    = 0x00000008;
constexpr unsigned int CP_DMA_WATCH3_MASK__RSVD__SHIFT                    = 0x00000000;
constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_HI__ADDR_HI__SHIFT          = 0x00000000;
constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_LO__ADDR_LO__SHIFT          = 0x00000002;
constexpr unsigned int CP_DMA_WATCH_STAT__CLIENT_ID__SHIFT                = 0x00000008;
constexpr unsigned int CP_DMA_WATCH_STAT__PIPE__SHIFT                     = 0x0000000c;
constexpr unsigned int CP_DMA_WATCH_STAT__QUEUE_ID__SHIFT                 = 0x00000004;
constexpr unsigned int CP_DMA_WATCH_STAT__RD_WR__SHIFT                    = 0x00000014;
constexpr unsigned int CP_DMA_WATCH_STAT__TRAP_FLAG__SHIFT                = 0x0000001f;
constexpr unsigned int CP_DMA_WATCH_STAT__VMID__SHIFT                     = 0x00000000;
constexpr unsigned int CP_DMA_WATCH_STAT__WATCH_ID__SHIFT                 = 0x00000010;
constexpr unsigned int CP_EOP_DONE_ADDR_HI__ADDR_HI__SHIFT                = 0x00000000;
constexpr unsigned int CP_EOP_DONE_ADDR_LO__ADDR_LO__SHIFT                = 0x00000002;
constexpr unsigned int CP_EOP_DONE_CNTX_ID__CNTX_ID__SHIFT                = 0x00000000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__ACTION_ID__SHIFT            = 0x00000016;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__ACTION_PIPE_ID__SHIFT       = 0x00000014;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DATA_SEL__SHIFT             = 0x0000001d;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DST_SEL__SHIFT              = 0x00000010;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__INT_SEL__SHIFT              = 0x00000018;
constexpr unsigned int CP_EOP_DONE_DATA_HI__DATA_HI__SHIFT                = 0x00000000;
constexpr unsigned int CP_EOP_DONE_DATA_LO__DATA_LO__SHIFT                = 0x00000000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__CACHE_POLICY__SHIFT        = 0x00000019;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EXECUTE__SHIFT             = 0x0000001c;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GCR_CNTL__SHIFT            = 0x0000000c;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GLK_INV__SHIFT             = 0x0000001e;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__PWS_ENABLE__SHIFT          = 0x0000001f;
constexpr unsigned int CP_EOP_LAST_FENCE_HI__LAST_FENCE_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_EOP_LAST_FENCE_LO__LAST_FENCE_LO__SHIFT         = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE0_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE1_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE2_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE3_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE4_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE5_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE6_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE7_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE8_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_BASE0__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_BASE1__BASE__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL0__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__ENABLE__SHIFT      = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__SCOPE__SHIFT       = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__TEMPORAL__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_CNTL1__VMID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_MASK0__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE9_MASK1__MASK__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE10_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE11_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE12_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE13_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE14_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_BASE0__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_BASE1__BASE__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL0__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__BYPASS_MODE__SHIFT = 0x00000004;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__ENABLE__SHIFT     = 0x00000005;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__SCOPE__SHIFT      = 0x00000006;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__TEMPORAL__SHIFT   = 0x00000008;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_CNTL1__VMID__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_MASK0__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_DC_APERTURE15_MASK1__MASK__SHIFT       = 0x00000000;
constexpr unsigned int CP_GFX_RS64_PERFCOUNT_CNTL0__EVENT_SEL__SHIFT      = 0x00000000;
constexpr unsigned int CP_GFX_RS64_PERFCOUNT_CNTL1__EVENT_SEL__SHIFT      = 0x00000000;
constexpr unsigned int CP_HQD_ACTIVE__ACTIVE__SHIFT                       = 0x00000000;
constexpr unsigned int CP_HQD_ACTIVE__BUSY_GATE__SHIFT                    = 0x00000001;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_EN__SHIFT             = 0x0000000f;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0__SHIFT                = 0x00000000;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_EN__SHIFT             = 0x0000001f;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1__SHIFT                = 0x00000010;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_HI__ATOMIC0_PREOP_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_LO__ATOMIC0_PREOP_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_HI__ATOMIC1_PREOP_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_LO__ATOMIC1_PREOP_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_CNTL_STACK_OFFSET__OFFSET__SHIFT            = 0x00000002;
constexpr unsigned int CP_HQD_CNTL_STACK_SIZE__SIZE__SHIFT                = 0x0000000c;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_HI__ADDR_HI__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_LO__ADDR__SHIFT          = 0x0000000c;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__EXE_DISABLE__SHIFT        = 0x00000017;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__POLICY__SHIFT             = 0x00000003;
constexpr unsigned int CP_HQD_CTX_SAVE_SIZE__SIZE__SHIFT                  = 0x0000000c;
constexpr unsigned int CP_HQD_DDID_DELTA_RPT_COUNT__COUNT__SHIFT          = 0x00000000;
constexpr unsigned int CP_HQD_DDID_INFLIGHT_COUNT__COUNT__SHIFT           = 0x00000000;
constexpr unsigned int CP_HQD_DDID_RPTR__RPTR__SHIFT                      = 0x00000000;
constexpr unsigned int CP_HQD_DDID_WPTR__WPTR__SHIFT                      = 0x00000000;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_INT__SHIFT         = 0x00000008;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN__SHIFT      = 0x0000000a;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN__SHIFT      = 0x00000009;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND__SHIFT         = 0x00000004;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_EN__SHIFT      = 0x0000000a;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_EN__SHIFT  = 0x00000009;
constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND__SHIFT     = 0x00000004;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__AQL_OFFLOAD_EN__SHIFT          = 0x00000003;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__AQL_OFFLOAD__SHIFT             = 0x00000002;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD_EN__SHIFT          = 0x00000001;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__EOP_OFFLOAD_EN__SHIFT          = 0x00000005;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__EOP_OFFLOAD__SHIFT             = 0x00000004;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR__BASE_ADDR__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_EOP_CONTROL__CACHE_POLICY__SHIFT            = 0x00000018;
constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int CP_HQD_EOP_CONTROL__EXE_DISABLE__SHIFT             = 0x00000017;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_EN__SHIFT         = 0x00000016;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER__SHIFT            = 0x00000015;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOPIB__SHIFT        = 0x0000000d;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOP__SHIFT          = 0x00000008;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOPIB_EN__SHIFT        = 0x0000000e;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOP_EN__SHIFT          = 0x0000000c;
constexpr unsigned int CP_HQD_EOP_EVENTS__CS_PARTIAL_FLUSH_PEND__SHIFT    = 0x00000010;
constexpr unsigned int CP_HQD_EOP_EVENTS__EVENT_COUNT__SHIFT              = 0x00000000;
constexpr unsigned int CP_HQD_EOP_RPTR__DEQUEUE_PEND__SHIFT               = 0x0000001d;
constexpr unsigned int CP_HQD_EOP_RPTR__INIT_FETCHER__SHIFT               = 0x0000001f;
constexpr unsigned int CP_HQD_EOP_RPTR__RESET_FETCHER__SHIFT              = 0x0000001c;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_EQ_CSMD_WPTR__SHIFT          = 0x0000001e;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR__SHIFT                       = 0x00000000;
constexpr unsigned int CP_HQD_EOP_WPTR_MEM__WPTR__SHIFT                   = 0x00000000;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_AVAIL__SHIFT                  = 0x00000010;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_EMPTY__SHIFT                  = 0x0000000f;
constexpr unsigned int CP_HQD_EOP_WPTR__WPTR__SHIFT                       = 0x00000000;
constexpr unsigned int CP_HQD_ERROR__AQL_ERROR__SHIFT                     = 0x00000005;
constexpr unsigned int CP_HQD_ERROR__DMA_DST_UTCL1_ERROR__SHIFT           = 0x00000010;
constexpr unsigned int CP_HQD_ERROR__DMA_SRC_UTCL1_ERROR__SHIFT           = 0x0000000f;
constexpr unsigned int CP_HQD_ERROR__EDC_ERROR_ID__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_ERROR__EOP_UTCL1_ERROR__SHIFT               = 0x0000000a;
constexpr unsigned int CP_HQD_ERROR__IB_UTCL1_ERROR__SHIFT                = 0x00000009;
constexpr unsigned int CP_HQD_ERROR__IQ_UTCL1_ERROR__SHIFT                = 0x0000000b;
constexpr unsigned int CP_HQD_ERROR__PQ_UTCL1_ERROR__SHIFT                = 0x00000008;
constexpr unsigned int CP_HQD_ERROR__QU_UTCL1_ERROR__SHIFT                = 0x00000012;
constexpr unsigned int CP_HQD_ERROR__RRPT_UTCL1_ERROR__SHIFT              = 0x0000000c;
constexpr unsigned int CP_HQD_ERROR__SR_UTCL1_ERROR__SHIFT                = 0x00000011;
constexpr unsigned int CP_HQD_ERROR__SUA_ERROR__SHIFT                     = 0x00000004;
constexpr unsigned int CP_HQD_ERROR__TC_UTCL1_ERROR__SHIFT                = 0x00000013;
constexpr unsigned int CP_HQD_ERROR__WPP_UTCL1_ERROR__SHIFT               = 0x0000000d;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__GWS_PNTR__SHIFT         = 0x0000000c;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__GWS_SIZE__SHIFT         = 0x00000004;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__OA_ACQUIRED__SHIFT      = 0x00000001;
constexpr unsigned int CP_HQD_GDS_RESOURCE_STATE__OA_REQUIRED__SHIFT      = 0x00000000;
constexpr unsigned int CP_HQD_GFX_CONTROL__DB_UPDATED_MSG_EN__SHIFT       = 0x0000000f;
constexpr unsigned int CP_HQD_GFX_CONTROL__MESSAGE__SHIFT                 = 0x00000000;
constexpr unsigned int CP_HQD_GFX_CONTROL__MISC__SHIFT                    = 0x00000004;
constexpr unsigned int CP_HQD_GFX_STATUS__STATUS__SHIFT                   = 0x00000000;
constexpr unsigned int CP_HQD_HQ_CONTROL0__CONTROL__SHIFT                 = 0x00000000;
constexpr unsigned int CP_HQD_HQ_CONTROL1__CONTROL__SHIFT                 = 0x00000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__CONCURRENT_PROCESS_COUNT__SHIFT = 0x00000018;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__CWSR__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_INHERIT_VMID__SHIFT        = 0x00000009;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_QUEUE_DEBUG_EN__SHIFT      = 0x0000000e;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__C_QUEUE_USE_GWS__SHIFT       = 0x0000000d;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__DB_UPDATED_MSG_EN__SHIFT     = 0x0000001f;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__MES_INTERRUPT_ENABLED__SHIFT = 0x00000014;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__MES_INTERRUPT_PIPE__SHIFT    = 0x00000015;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_IDLE__SHIFT            = 0x0000001e;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_RUN_ONCE__SHIFT        = 0x00000006;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_SCHEDULER_TYPE__SHIFT  = 0x0000000a;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__QUEUE_SLOT_CONNECTED__SHIFT  = 0x0000000f;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__RSRV__SHIFT                  = 0x00000002;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SAVE_STATUS__SHIFT           = 0x00000001;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SCRATCH_RAM_INIT__SHIFT      = 0x00000007;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__STATIC_QUEUE__SHIFT          = 0x00000003;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__TCL2_DIRTY__SHIFT            = 0x00000008;
constexpr unsigned int CP_HQD_HQ_SCHEDULER1__SCHEDULER__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__CONCURRENT_PROCESS_COUNT__SHIFT = 0x00000018;
constexpr unsigned int CP_HQD_HQ_STATUS0__CWSR__SHIFT                     = 0x00000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_INHERIT_VMID__SHIFT           = 0x00000009;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_QUEUE_DEBUG_EN__SHIFT         = 0x0000000e;
constexpr unsigned int CP_HQD_HQ_STATUS0__C_QUEUE_USE_GWS__SHIFT          = 0x0000000d;
constexpr unsigned int CP_HQD_HQ_STATUS0__DB_UPDATED_MSG_EN__SHIFT        = 0x0000001f;
constexpr unsigned int CP_HQD_HQ_STATUS0__MES_INTERRUPT_ENABLED__SHIFT    = 0x00000014;
constexpr unsigned int CP_HQD_HQ_STATUS0__MES_INTERRUPT_PIPE__SHIFT       = 0x00000015;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_IDLE__SHIFT               = 0x0000001e;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_RUN_ONCE__SHIFT           = 0x00000006;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_SCHEDULER_TYPE__SHIFT     = 0x0000000a;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_SLOT_CONNECTED__SHIFT     = 0x0000000f;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSRV__SHIFT                     = 0x00000002;
constexpr unsigned int CP_HQD_HQ_STATUS0__SAVE_STATUS__SHIFT              = 0x00000001;
constexpr unsigned int CP_HQD_HQ_STATUS0__SCRATCH_RAM_INIT__SHIFT         = 0x00000007;
constexpr unsigned int CP_HQD_HQ_STATUS0__STATIC_QUEUE__SHIFT             = 0x00000003;
constexpr unsigned int CP_HQD_HQ_STATUS0__TCL2_DIRTY__SHIFT               = 0x00000008;
constexpr unsigned int CP_HQD_HQ_STATUS1__STATUS__SHIFT                   = 0x00000000;
constexpr unsigned int CP_HQD_IB_BASE_ADDR_HI__IB_BASE_ADDR_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_HQD_IB_BASE_ADDR__IB_BASE_ADDR__SHIFT           = 0x00000002;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_CACHE_POLICY__SHIFT          = 0x00000018;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_EXE_DISABLE__SHIFT           = 0x00000017;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_PRIV_STATE__SHIFT            = 0x0000001e;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_SIZE__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_IB_CONTROL__MIN_IB_AVAIL_SIZE__SHIFT        = 0x00000014;
constexpr unsigned int CP_HQD_IB_CONTROL__PROCESSING_IB__SHIFT            = 0x0000001f;
constexpr unsigned int CP_HQD_IB_RPTR__CONSUMED_OFFSET__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_IQ_RPTR__OFFSET__SHIFT                      = 0x00000000;
constexpr unsigned int CP_HQD_IQ_TIMER__ACTIVE__SHIFT                     = 0x0000001f;
constexpr unsigned int CP_HQD_IQ_TIMER__CACHE_POLICY__SHIFT               = 0x00000018;
constexpr unsigned int CP_HQD_IQ_TIMER__CLOCK_COUNT__SHIFT                = 0x0000000e;
constexpr unsigned int CP_HQD_IQ_TIMER__EXE_DISABLE__SHIFT                = 0x00000017;
constexpr unsigned int CP_HQD_IQ_TIMER__IMMEDIATE_EXPIRE__SHIFT           = 0x0000000b;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_SIZE__SHIFT             = 0x00000010;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_TYPE__SHIFT             = 0x0000000c;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESSING_IQ__SHIFT              = 0x0000001e;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESS_IQ_EN__SHIFT              = 0x0000001d;
constexpr unsigned int CP_HQD_IQ_TIMER__QUANTUM_TIMER__SHIFT              = 0x00000016;
constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE__SHIFT                 = 0x0000001b;
constexpr unsigned int CP_HQD_IQ_TIMER__REARM_TIMER__SHIFT                = 0x0000001c;
constexpr unsigned int CP_HQD_IQ_TIMER__RETRY_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CP_HQD_IQ_TIMER__WAIT_TIME__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_MSG_TYPE__ACTION__SHIFT                     = 0x00000000;
constexpr unsigned int CP_HQD_MSG_TYPE__SAVE_STATE__SHIFT                 = 0x00000004;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_EN__SHIFT              = 0x00000003;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD__SHIFT                 = 0x00000002;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_EN__SHIFT              = 0x00000001;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD__SHIFT                 = 0x00000000;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_EN__SHIFT              = 0x00000005;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD__SHIFT                 = 0x00000004;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__CACHE_FULL_PACKET_EN__SHIFT = 0x0000001b;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__DISP_ACTIVE__SHIFT        = 0x0000001f;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__EOP_SWITCH_QOS_EN__SHIFT  = 0x00000018;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IB_SWITCH_QOS_EN__SHIFT   = 0x00000017;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IQ_SWITCH_QOS_EN__SHIFT   = 0x00000016;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PQ_SWITCH_QOS_EN__SHIFT   = 0x00000019;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_REQ__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_SIZE__SHIFT       = 0x00000008;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__QSWITCH_MODE__SHIFT       = 0x0000001e;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RELAUNCH_WAVES__SHIFT     = 0x0000001d;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RESTORE_ACTIVE__SHIFT     = 0x0000001c;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__SUSPEND_STATUS__SHIFT     = 0x00000007;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TC_OFFLOAD_QOS_EN__SHIFT  = 0x0000001a;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_CONNECT_OVERRIDE__SHIFT = 0x00000001;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_MATCH_DIS__SHIFT      = 0x00000013;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TMZ_SWITCH_EXEMPT__SHIFT  = 0x00000012;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WGS_QUEUE__SHIFT          = 0x00000004;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_CLAMP_EN__SHIFT       = 0x00000014;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_SWITCH_QOS_EN__SHIFT  = 0x00000015;
constexpr unsigned int CP_HQD_PIPE_PRIORITY__PIPE_PRIORITY__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_PQ_BASE_HI__ADDR_HI__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_PQ_BASE__ADDR__SHIFT                        = 0x00000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__CACHE_POLICY__SHIFT             = 0x00000018;
constexpr unsigned int CP_HQD_PQ_CONTROL__EXE_DISABLE__SHIFT              = 0x00000017;
constexpr unsigned int CP_HQD_PQ_CONTROL__KMD_QUEUE__SHIFT                = 0x0000001f;
constexpr unsigned int CP_HQD_PQ_CONTROL__MIN_AVAIL_SIZE__SHIFT           = 0x00000014;
constexpr unsigned int CP_HQD_PQ_CONTROL__NO_UPDATE_RPTR__SHIFT           = 0x0000001b;
constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_EMPTY__SHIFT                 = 0x0000000f;
constexpr unsigned int CP_HQD_PQ_CONTROL__PRIV_STATE__SHIFT               = 0x0000001e;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_FULL_EN__SHIFT            = 0x0000000e;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_SIZE__SHIFT               = 0x00000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_BLOCK_SIZE__SHIFT          = 0x00000008;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_CARRY__SHIFT               = 0x00000007;
constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR__SHIFT          = 0x00000012;
constexpr unsigned int CP_HQD_PQ_CONTROL__TUNNEL_DISPATCH__SHIFT          = 0x0000001d;
constexpr unsigned int CP_HQD_PQ_CONTROL__UNORD_DISPATCH__SHIFT           = 0x0000001c;
constexpr unsigned int CP_HQD_PQ_CONTROL__WPTR_CARRY__SHIFT               = 0x00000006;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_BIF_DROP__SHIFT = 0x00000001;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_EN__SHIFT     = 0x0000001e;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_HIT__SHIFT    = 0x0000001f;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_MODE__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_OFFSET__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SCHD_HIT__SHIFT = 0x0000001d;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SOURCE__SHIFT = 0x0000001c;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR_HI__RPTR_REPORT_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR__RPTR_REPORT_ADDR__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_PQ_RPTR__CONSUMED_OFFSET__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_HI__DATA__SHIFT                     = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_LO__OFFSET__SHIFT                   = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR_HI__WPTR_ADDR_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR__WPTR_ADDR__SHIFT         = 0x00000003;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_ACTIVE__SHIFT              = 0x0000001f;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_DURATION__SHIFT            = 0x00000008;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_EN__SHIFT                  = 0x00000000;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_SCALE__SHIFT               = 0x00000004;
constexpr unsigned int CP_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_SECURE_REQ0__REQ_EN__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_HQD_SECURE_REQ0__REQ_TYPE__SHIFT                = 0x00000000;
constexpr unsigned int CP_HQD_SECURE_REQ0__RSP_EN__SHIFT                  = 0x0000001e;
constexpr unsigned int CP_HQD_SECURE_REQ0__RSP_TYPE__SHIFT                = 0x00000008;
constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_DW_CNT__CNT__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_OFFSET__OFFSET__SHIFT    = 0x00000002;
constexpr unsigned int CP_HQD_SUSPEND_WG_STATE_OFFSET__OFFSET__SHIFT      = 0x00000002;
constexpr unsigned int CP_HQD_VMID__IB_VMID__SHIFT                        = 0x00000008;
constexpr unsigned int CP_HQD_VMID__VMID__SHIFT                           = 0x00000000;
constexpr unsigned int CP_HQD_VMID__VQID__SHIFT                           = 0x00000010;
constexpr unsigned int CP_HQD_WG_STATE_OFFSET__OFFSET__SHIFT              = 0x00000002;
constexpr unsigned int CP_INT_CNTL_RING0__CMP_BUSY_INT_ENABLE__SHIFT      = 0x00000012;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_BUSY_INT_ENABLE__SHIFT     = 0x00000013;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_EMPTY_INT_ENABLE__SHIFT    = 0x00000014;
constexpr unsigned int CP_INT_CNTL_RING0__CP_ECC_ERROR_INT_ENABLE__SHIFT  = 0x0000000e;
constexpr unsigned int CP_INT_CNTL_RING0__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_CNTL_RING0__DMA_WATCH_INT_ENABLE__SHIFT     = 0x0000000a;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC0_INT_ENABLE__SHIFT      = 0x0000001f;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC1_INT_ENABLE__SHIFT      = 0x0000001e;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC2_INT_ENABLE__SHIFT      = 0x0000001d;
constexpr unsigned int CP_INT_CNTL_RING0__GFX_IDLE_INT_ENABLE__SHIFT      = 0x00000015;
constexpr unsigned int CP_INT_CNTL_RING0__GPF_INT_ENABLE__SHIFT           = 0x00000010;
constexpr unsigned int CP_INT_CNTL_RING0__OPCODE_ERROR_INT_ENABLE__SHIFT  = 0x00000018;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_INSTR_INT_ENABLE__SHIFT    = 0x00000016;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_REG_INT_ENABLE__SHIFT      = 0x00000017;
constexpr unsigned int CP_INT_CNTL_RING0__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_CNTL_RING0__RESUME_INT_ENABLE__SHIFT        = 0x00000008;
constexpr unsigned int CP_INT_CNTL_RING0__SUSPEND_INT_ENABLE__SHIFT       = 0x00000009;
constexpr unsigned int CP_INT_CNTL_RING0__TIME_STAMP_INT_ENABLE__SHIFT    = 0x0000001a;
constexpr unsigned int CP_INT_CNTL_RING0__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_CNTL__CMP_BUSY_INT_ENABLE__SHIFT            = 0x00000012;
constexpr unsigned int CP_INT_CNTL__CNTX_BUSY_INT_ENABLE__SHIFT           = 0x00000013;
constexpr unsigned int CP_INT_CNTL__CNTX_EMPTY_INT_ENABLE__SHIFT          = 0x00000014;
constexpr unsigned int CP_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT        = 0x0000000e;
constexpr unsigned int CP_INT_CNTL__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT   = 0x0000000b;
constexpr unsigned int CP_INT_CNTL__DMA_WATCH_INT_ENABLE__SHIFT           = 0x0000000a;
constexpr unsigned int CP_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT            = 0x0000001f;
constexpr unsigned int CP_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT            = 0x0000001e;
constexpr unsigned int CP_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT            = 0x0000001d;
constexpr unsigned int CP_INT_CNTL__GFX_IDLE_INT_ENABLE__SHIFT            = 0x00000015;
constexpr unsigned int CP_INT_CNTL__GPF_INT_ENABLE__SHIFT                 = 0x00000010;
constexpr unsigned int CP_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT        = 0x00000018;
constexpr unsigned int CP_INT_CNTL__PRIV_INSTR_INT_ENABLE__SHIFT          = 0x00000016;
constexpr unsigned int CP_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT            = 0x00000017;
constexpr unsigned int CP_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT  = 0x0000001b;
constexpr unsigned int CP_INT_CNTL__RESUME_INT_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int CP_INT_CNTL__SUSPEND_INT_ENABLE__SHIFT             = 0x00000009;
constexpr unsigned int CP_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT          = 0x0000001a;
constexpr unsigned int CP_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT    = 0x00000011;
constexpr unsigned int CP_INT_STATUS_RING0__CMP_BUSY_INT_STAT__SHIFT      = 0x00000012;
constexpr unsigned int CP_INT_STATUS_RING0__CNTX_EMPTY_INT_STAT__SHIFT    = 0x00000014;
constexpr unsigned int CP_INT_STATUS_RING0__CP_ECC_ERROR_INT_STAT__SHIFT  = 0x0000000e;
constexpr unsigned int CP_INT_STATUS_RING0__CP_VM_DOORBELL_WR_INT_STAT__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STATUS_RING0__DMA_WATCH_INT_STAT__SHIFT     = 0x0000000a;
constexpr unsigned int CP_INT_STATUS_RING0__GCNTX_BUSY_INT_STAT__SHIFT    = 0x00000013;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC0_INT_STAT__SHIFT      = 0x0000001f;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC1_INT_STAT__SHIFT      = 0x0000001e;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC2_INT_STAT__SHIFT      = 0x0000001d;
constexpr unsigned int CP_INT_STATUS_RING0__GFX_IDLE_INT_STAT__SHIFT      = 0x00000015;
constexpr unsigned int CP_INT_STATUS_RING0__GPF_INT_STAT__SHIFT           = 0x00000010;
constexpr unsigned int CP_INT_STATUS_RING0__OPCODE_ERROR_INT_STAT__SHIFT  = 0x00000018;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_INSTR_INT_STAT__SHIFT    = 0x00000016;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_REG_INT_STAT__SHIFT      = 0x00000017;
constexpr unsigned int CP_INT_STATUS_RING0__RESERVED_BIT_ERROR_INT_STAT__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STATUS_RING0__RESUME_INT_STAT__SHIFT        = 0x00000008;
constexpr unsigned int CP_INT_STATUS_RING0__SUSPEND_INT_STAT__SHIFT       = 0x00000009;
constexpr unsigned int CP_INT_STATUS_RING0__TIME_STAMP_INT_STAT__SHIFT    = 0x0000001a;
constexpr unsigned int CP_INT_STATUS_RING0__WRM_POLL_TIMEOUT_INT_STAT__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STATUS__CMP_BUSY_INT_STAT__SHIFT            = 0x00000012;
constexpr unsigned int CP_INT_STATUS__CNTX_BUSY_INT_STAT__SHIFT           = 0x00000013;
constexpr unsigned int CP_INT_STATUS__CNTX_EMPTY_INT_STAT__SHIFT          = 0x00000014;
constexpr unsigned int CP_INT_STATUS__CP_ECC_ERROR_INT_STAT__SHIFT        = 0x0000000e;
constexpr unsigned int CP_INT_STATUS__CP_VM_DOORBELL_WR_INT_STAT__SHIFT   = 0x0000000b;
constexpr unsigned int CP_INT_STATUS__DMA_WATCH_INT_STAT__SHIFT           = 0x0000000a;
constexpr unsigned int CP_INT_STATUS__GENERIC0_INT_STAT__SHIFT            = 0x0000001f;
constexpr unsigned int CP_INT_STATUS__GENERIC1_INT_STAT__SHIFT            = 0x0000001e;
constexpr unsigned int CP_INT_STATUS__GENERIC2_INT_STAT__SHIFT            = 0x0000001d;
constexpr unsigned int CP_INT_STATUS__GFX_IDLE_INT_STAT__SHIFT            = 0x00000015;
constexpr unsigned int CP_INT_STATUS__GPF_INT_STAT__SHIFT                 = 0x00000010;
constexpr unsigned int CP_INT_STATUS__OPCODE_ERROR_INT_STAT__SHIFT        = 0x00000018;
constexpr unsigned int CP_INT_STATUS__PRIV_INSTR_INT_STAT__SHIFT          = 0x00000016;
constexpr unsigned int CP_INT_STATUS__PRIV_REG_INT_STAT__SHIFT            = 0x00000017;
constexpr unsigned int CP_INT_STATUS__RESERVED_BIT_ERROR_INT_STAT__SHIFT  = 0x0000001b;
constexpr unsigned int CP_INT_STATUS__RESUME_INT_STAT__SHIFT              = 0x00000008;
constexpr unsigned int CP_INT_STATUS__SUSPEND_INT_STAT__SHIFT             = 0x00000009;
constexpr unsigned int CP_INT_STATUS__TIME_STAMP_INT_STAT__SHIFT          = 0x0000001a;
constexpr unsigned int CP_INT_STATUS__WRM_POLL_TIMEOUT_INT_STAT__SHIFT    = 0x00000011;
constexpr unsigned int CP_MEC_RS64_PERFCOUNT_CNTL__EVENT_SEL__SHIFT       = 0x00000000;
constexpr unsigned int CP_MES_PERFCOUNT_CNTL__EVENT_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CP_ME_COHER_BASE_HI__COHER_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int CP_ME_COHER_BASE__COHER_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__CB0_DEST_BASE_ENA__SHIFT         = 0x00000006;
constexpr unsigned int CP_ME_COHER_CNTL__CB1_DEST_BASE_ENA__SHIFT         = 0x00000007;
constexpr unsigned int CP_ME_COHER_CNTL__CB2_DEST_BASE_ENA__SHIFT         = 0x00000008;
constexpr unsigned int CP_ME_COHER_CNTL__CB3_DEST_BASE_ENA__SHIFT         = 0x00000009;
constexpr unsigned int CP_ME_COHER_CNTL__CB4_DEST_BASE_ENA__SHIFT         = 0x0000000a;
constexpr unsigned int CP_ME_COHER_CNTL__CB5_DEST_BASE_ENA__SHIFT         = 0x0000000b;
constexpr unsigned int CP_ME_COHER_CNTL__CB6_DEST_BASE_ENA__SHIFT         = 0x0000000c;
constexpr unsigned int CP_ME_COHER_CNTL__CB7_DEST_BASE_ENA__SHIFT         = 0x0000000d;
constexpr unsigned int CP_ME_COHER_CNTL__DB_DEST_BASE_ENA__SHIFT          = 0x0000000e;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_0_ENA__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_1_ENA__SHIFT           = 0x00000001;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_2_ENA__SHIFT           = 0x00000013;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_3_ENA__SHIFT           = 0x00000015;
constexpr unsigned int CP_ME_COHER_SIZE_HI__COHER_SIZE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int CP_ME_COHER_SIZE__COHER_SIZE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__MATCHING_GFX_CNTX__SHIFT       = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__STATUS__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_MQD_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT           = 0x00000000;
constexpr unsigned int CP_MQD_BASE_ADDR__BASE_ADDR__SHIFT                 = 0x00000002;
constexpr unsigned int CP_MQD_CONTROL__CACHE_POLICY__SHIFT                = 0x00000018;
constexpr unsigned int CP_MQD_CONTROL__EXE_DISABLE__SHIFT                 = 0x00000017;
constexpr unsigned int CP_MQD_CONTROL__PRIV_STATE__SHIFT                  = 0x00000008;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_EN__SHIFT           = 0x0000000d;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD__SHIFT              = 0x0000000c;
constexpr unsigned int CP_MQD_CONTROL__VMID__SHIFT                        = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_ENABLE_MODE__SHIFT        = 0x00000008;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT      = 0x0000000a;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_STATE__SHIFT              = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__SPM_PERFMON_STATE__SHIFT          = 0x00000004;
constexpr unsigned int CP_PERFMON_CNTX_CNTL__PERFMON_ENABLE__SHIFT        = 0x0000001f;
constexpr unsigned int CP_PIPEID__PIPE_ID__SHIFT                          = 0x00000000;
constexpr unsigned int CP_PIPE_STATS_ADDR_HI__PIPE_STATS_ADDR_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_PIPE_STATS_ADDR_LO__PIPE_STATS_ADDR_LO__SHIFT   = 0x00000002;
constexpr unsigned int CP_PIPE_STATS_CONTROL__CACHE_POLICY__SHIFT         = 0x00000019;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_HI__PSINVOC_COUNT0_HI__SHIFT  = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_LO__PSINVOC_COUNT0_LO__SHIFT  = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_HI__OBSOLETE__SHIFT           = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_LO__OBSOLETE__SHIFT           = 0x00000000;
constexpr unsigned int CP_STAT__CE_BUSY__SHIFT                            = 0x0000001a;
constexpr unsigned int CP_STAT__CP_BUSY__SHIFT                            = 0x0000001f;
constexpr unsigned int CP_STAT__DC_BUSY__SHIFT                            = 0x0000000d;
constexpr unsigned int CP_STAT__DMA_BUSY__SHIFT                           = 0x00000016;
constexpr unsigned int CP_STAT__GCRIU_BUSY__SHIFT                         = 0x00000019;
constexpr unsigned int CP_STAT__INTERRUPT_BUSY__SHIFT                     = 0x00000014;
constexpr unsigned int CP_STAT__MEQ_BUSY__SHIFT                           = 0x00000010;
constexpr unsigned int CP_STAT__ME_BUSY__SHIFT                            = 0x00000011;
constexpr unsigned int CP_STAT__PFP_BUSY__SHIFT                           = 0x0000000f;
constexpr unsigned int CP_STAT__QUERY_BUSY__SHIFT                         = 0x00000012;
constexpr unsigned int CP_STAT__RCIU_BUSY__SHIFT                          = 0x00000017;
constexpr unsigned int CP_STAT__ROQ_CE_DB_BUSY__SHIFT                     = 0x00000006;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT1_BUSY__SHIFT              = 0x0000001d;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT2_BUSY__SHIFT              = 0x0000001e;
constexpr unsigned int CP_STAT__ROQ_CE_RING_BUSY__SHIFT                   = 0x0000001c;
constexpr unsigned int CP_STAT__ROQ_DB_BUSY__SHIFT                        = 0x00000005;
constexpr unsigned int CP_STAT__ROQ_INDIRECT1_BUSY__SHIFT                 = 0x0000000a;
constexpr unsigned int CP_STAT__ROQ_INDIRECT2_BUSY__SHIFT                 = 0x0000000b;
constexpr unsigned int CP_STAT__ROQ_RING_BUSY__SHIFT                      = 0x00000009;
constexpr unsigned int CP_STAT__ROQ_STATE_BUSY__SHIFT                     = 0x0000000c;
constexpr unsigned int CP_STAT__SCRATCH_RAM_BUSY__SHIFT                   = 0x00000018;
constexpr unsigned int CP_STAT__SURFACE_SYNC_BUSY__SHIFT                  = 0x00000015;
constexpr unsigned int CP_STAT__TCIU_BUSY__SHIFT                          = 0x0000001b;
constexpr unsigned int CP_STAT__UTCL2IU_BUSY__SHIFT                       = 0x0000000e;
constexpr unsigned int CP_VGT_ASINVOC_COUNT_HI__ASINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_ASINVOC_COUNT_LO__ASINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_HI__CSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_LO__CSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_HI__DSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_LO__DSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_HI__GSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_LO__GSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_HI__GSPRIM_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_LO__GSPRIM_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_HI__HSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_LO__HSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_HI__IAPRIM_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_LO__IAPRIM_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_HI__IAVERT_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_LO__IAVERT_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_HI__VSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_LO__VSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_ENABLE__SHIFT      = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET0__SHIFT     = 0x00000008;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET1__SHIFT     = 0x0000000a;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET2__SHIFT     = 0x0000000c;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET3__SHIFT     = 0x0000000e;
constexpr unsigned int DB_ALPHA_TO_MASK__OFFSET_ROUND__SHIFT              = 0x00000010;
constexpr unsigned int DB_ARB_CONFIG__ARB_MODE__SHIFT                     = 0x00000000;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_MAX_RD__SHIFT               = 0x00000002;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_MAX_WR__SHIFT               = 0x0000000c;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_WEIGHT_RD__SHIFT            = 0x00000007;
constexpr unsigned int DB_ARB_CONFIG__CREDITS_WEIGHT_WR__SHIFT            = 0x00000011;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__RESERVED__SHIFT                = 0x0000000a;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE0__SHIFT          = 0x00000000;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE1__SHIFT          = 0x00000001;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE2__SHIFT          = 0x00000002;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE3__SHIFT          = 0x00000003;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE4__SHIFT          = 0x00000004;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE5__SHIFT          = 0x00000005;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE6__SHIFT          = 0x00000006;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE8__SHIFT          = 0x00000008;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE9__SHIFT          = 0x00000009;
constexpr unsigned int DB_COUNT_CONTROL__DBFAIL_ENABLE__SHIFT             = 0x00000014;
constexpr unsigned int DB_COUNT_CONTROL__DISABLE_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000002;
constexpr unsigned int DB_COUNT_CONTROL__ENHANCED_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000003;
constexpr unsigned int DB_COUNT_CONTROL__PERFECT_ZPASS_COUNTS__SHIFT      = 0x00000001;
constexpr unsigned int DB_COUNT_CONTROL__SFAIL_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_EVEN_ENABLE__SHIFT         = 0x00000018;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_ODD_ENABLE__SHIFT          = 0x0000001c;
constexpr unsigned int DB_COUNT_CONTROL__ZFAIL_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_EXPORT_CREDITS__SHIFT       = 0x0000000a;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_FREE_WAVE_CREDITS__SHIFT    = 0x00000012;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_QUAD_CREDITS__SHIFT         = 0x00000005;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_UPDATE_CREDITS__SHIFT       = 0x00000000;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_WAVE_CREDITS__SHIFT         = 0x0000000d;
constexpr unsigned int DB_DEPTH_BOUNDS_MAX__MAX__SHIFT                    = 0x00000000;
constexpr unsigned int DB_DEPTH_BOUNDS_MIN__MIN__SHIFT                    = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__BACKFACE_ENABLE__SHIFT           = 0x00000007;
constexpr unsigned int DB_DEPTH_CONTROL__DEPTH_BOUNDS_ENABLE__SHIFT       = 0x00000003;
constexpr unsigned int DB_DEPTH_CONTROL__RESERVED_FIELD_30__SHIFT         = 0x0000001e;
constexpr unsigned int DB_DEPTH_CONTROL__RESERVED_FIELD_31__SHIFT         = 0x0000001f;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_BF__SHIFT            = 0x00000014;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC__SHIFT               = 0x00000008;
constexpr unsigned int DB_DEPTH_CONTROL__STENCIL_ENABLE__SHIFT            = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__ZFUNC__SHIFT                     = 0x00000004;
constexpr unsigned int DB_DEPTH_CONTROL__Z_ENABLE__SHIFT                  = 0x00000001;
constexpr unsigned int DB_DEPTH_CONTROL__Z_WRITE_ENABLE__SHIFT            = 0x00000002;
constexpr unsigned int DB_DEPTH_SIZE_XY__X_MAX__SHIFT                     = 0x00000000;
constexpr unsigned int DB_DEPTH_SIZE_XY__Y_MAX__SHIFT                     = 0x00000010;
constexpr unsigned int DB_DEPTH_VIEW1__MIPID__SHIFT                       = 0x0000001a;
constexpr unsigned int DB_DEPTH_VIEW1__STENCIL_READ_ONLY__SHIFT           = 0x00000019;
constexpr unsigned int DB_DEPTH_VIEW1__Z_READ_ONLY__SHIFT                 = 0x00000018;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX__SHIFT                    = 0x00000010;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_START__SHIFT                  = 0x00000000;
constexpr unsigned int DB_DFD_INDIRECT_DAT__DFD_DATA__SHIFT               = 0x00000000;
constexpr unsigned int DB_DFD_INDIRECT_SEL__DFD_INDEX__SHIFT              = 0x00000000;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_NUM_SAMPLES__SHIFT          = 0x0000000c;
constexpr unsigned int DB_EQAA__ENABLE_POSTZ_OVERRASTERIZATION__SHIFT     = 0x0000001b;
constexpr unsigned int DB_EQAA__HIGH_QUALITY_INTERSECTIONS__SHIFT         = 0x00000010;
constexpr unsigned int DB_EQAA__MASK_EXPORT_NUM_SAMPLES__SHIFT            = 0x00000008;
constexpr unsigned int DB_EQAA__OVERRASTERIZATION_AMOUNT__SHIFT           = 0x00000018;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_1__SHIFT                   = 0x00000000;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_17__SHIFT                  = 0x00000011;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_18__SHIFT                  = 0x00000012;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_19__SHIFT                  = 0x00000013;
constexpr unsigned int DB_EQAA__RESERVED_FIELD_21__SHIFT                  = 0x00000015;
constexpr unsigned int DB_EQAA__STATIC_ANCHOR_ASSOCIATIONS__SHIFT         = 0x00000014;
constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_QUAD__SHIFT       = 0x00000003;
constexpr unsigned int DB_EXCEPTION_CONTROL__CAM_FREE_WATERMARK__SHIFT    = 0x00000018;
constexpr unsigned int DB_EXCEPTION_CONTROL__EARLY_Z_PANIC_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_EXCEPTION_CONTROL__FORCE_SUMMARIZE__SHIFT       = 0x00000004;
constexpr unsigned int DB_EXCEPTION_CONTROL__LATE_Z_PANIC_DISABLE__SHIFT  = 0x00000001;
constexpr unsigned int DB_EXCEPTION_CONTROL__LQUAD_FIFO_HI_WATERMARK__SHIFT = 0x00000010;
constexpr unsigned int DB_EXCEPTION_CONTROL__LQUAD_FIFO_LO_WATERMARK__SHIFT = 0x00000008;
constexpr unsigned int DB_EXCEPTION_CONTROL__RE_Z_PANIC_DISABLE__SHIFT    = 0x00000002;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_EXPORT_OVERRIDE__SHIFT = 0x00000002;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_RMIRET_OVERRIDE__SHIFT = 0x00000006;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_GL1_COMP_REQ_OVERRIDE__SHIFT = 0x00000003;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_GL1_SRC_OVERRIDE__SHIFT = 0x00000004;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_FREE_WAVE_OVERRIDE__SHIFT = 0x00000008;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_QUAD_OVERRIDE__SHIFT = 0x00000000;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_UPDATE_OVERRIDE__SHIFT = 0x00000005;
constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_WAVE_OVERRIDE__SHIFT = 0x00000007;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE0__SHIFT           = 0x00000000;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE1__SHIFT           = 0x00000001;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE2__SHIFT           = 0x00000002;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE3__SHIFT           = 0x00000003;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE4__SHIFT           = 0x00000004;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE5__SHIFT           = 0x00000005;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE6__SHIFT           = 0x00000006;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE7__SHIFT           = 0x00000007;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE8__SHIFT           = 0x00000008;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE9__SHIFT           = 0x00000009;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE10__SHIFT          = 0x0000000a;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE11__SHIFT          = 0x0000000b;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE12__SHIFT          = 0x0000000c;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE13__SHIFT          = 0x0000000d;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE14__SHIFT          = 0x0000000e;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE15__SHIFT          = 0x0000000f;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE16__SHIFT          = 0x00000010;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE17__SHIFT          = 0x00000011;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE18__SHIFT          = 0x00000012;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE19__SHIFT          = 0x00000013;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE20__SHIFT          = 0x00000014;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE22__SHIFT          = 0x00000016;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE23__SHIFT          = 0x00000017;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE24__SHIFT          = 0x00000018;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE26__SHIFT          = 0x0000001a;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE27__SHIFT          = 0x0000001b;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE28__SHIFT          = 0x0000001c;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE29__SHIFT          = 0x0000001d;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE30__SHIFT          = 0x0000001e;
constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE31__SHIFT          = 0x0000001f;
constexpr unsigned int DB_FIFO_DEPTH1__MI_RDREQ_FIFO_DEPTH__SHIFT         = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH1__MI_WRREQ_FIFO_DEPTH__SHIFT         = 0x00000008;
constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH__SHIFT                    = 0x00000018;
constexpr unsigned int DB_FIFO_DEPTH2__EQUAD_FIFO_DEPTH__SHIFT            = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH__SHIFT         = 0x00000008;
constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH__SHIFT            = 0x00000010;
constexpr unsigned int DB_FIFO_DEPTH2__LTILE_OP_FIFO_DEPTH__SHIFT         = 0x00000019;
constexpr unsigned int DB_FIFO_DEPTH3__LTILE_PROBE_FIFO_DEPTH__SHIFT      = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH3__OREO_WAVE_HIDE_DEPTH__SHIFT        = 0x00000010;
constexpr unsigned int DB_FIFO_DEPTH3__OSB_WAVE_TABLE_DEPTH__SHIFT        = 0x00000008;
constexpr unsigned int DB_FIFO_DEPTH3__QUAD_READ_REQS__SHIFT              = 0x00000018;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_EVENT_FIFO_DEPTH__SHIFT        = 0x00000018;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_SCORE_BOARD_DEPTH__SHIFT       = 0x00000010;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_SQUAD_TABLE_DEPTH__SHIFT       = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH4__OSB_TILE_TABLE_DEPTH__SHIFT        = 0x00000008;
constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH__SHIFT        = 0x00000000;
constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH__SHIFT        = 0x00000008;
constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH__SHIFT            = 0x00000010;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__OCCLUSION_COMPRESSION_MODE__SHIFT = 0x00000008;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__STENCIL_COMPRESSION_MODE__SHIFT = 0x00000006;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__STENCIL_SPECULATIVE_READ__SHIFT = 0x00000002;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__Z_COMPRESSION_MODE__SHIFT = 0x00000004;
constexpr unsigned int DB_GL1_INTERFACE_CONTROL__Z_SPECULATIVE_READ__SHIFT = 0x00000000;
constexpr unsigned int DB_HTILE_SURFACE__DST_OUTSIDE_ZERO_TO_ONE__SHIFT   = 0x00000010;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_1__SHIFT          = 0x00000000;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_2__SHIFT          = 0x00000002;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_3__SHIFT          = 0x00000003;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_4__SHIFT          = 0x00000004;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_5__SHIFT          = 0x0000000a;
constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_6__SHIFT          = 0x00000011;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT0_WATERMARK__SHIFT    = 0x00000000;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT1_WATERMARK__SHIFT    = 0x00000008;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT2_WATERMARK__SHIFT    = 0x00000010;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT3_WATERMARK__SHIFT    = 0x00000018;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_OCCLUSION__SHIFT = 0x00000008;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_STENCIL__SHIFT = 0x00000007;
constexpr unsigned int DB_MEM_CONFIG__ENABLE_OVERRIDE_COMP_MODE_Z__SHIFT  = 0x00000006;
constexpr unsigned int DB_MEM_CONFIG__FL_DISABLE_SINGLE_COMPRESS__SHIFT   = 0x0000000f;
constexpr unsigned int DB_MEM_CONFIG__OCCLUSION_OVERRIDE_COMPRESSION_MODE__SHIFT = 0x0000000d;
constexpr unsigned int DB_MEM_CONFIG__OCCLUSION_SCOPE__SHIFT              = 0x00000004;
constexpr unsigned int DB_MEM_CONFIG__STENCIL_OVERRIDE_COMPRESSION_MODE__SHIFT = 0x0000000b;
constexpr unsigned int DB_MEM_CONFIG__STENCIL_SCOPE__SHIFT                = 0x00000002;
constexpr unsigned int DB_MEM_CONFIG__Z_OVERRIDE_COMPRESSION_MODE__SHIFT  = 0x00000009;
constexpr unsigned int DB_MEM_CONFIG__Z_SCOPE__SHIFT                      = 0x00000000;
constexpr unsigned int DB_MEM_TEMPORAL__OCCLUSION_TEMPORAL_WRITE__SHIFT   = 0x0000000c;
constexpr unsigned int DB_MEM_TEMPORAL__STENCIL_TEMPORAL_READ__SHIFT      = 0x00000006;
constexpr unsigned int DB_MEM_TEMPORAL__STENCIL_TEMPORAL_WRITE__SHIFT     = 0x00000009;
constexpr unsigned int DB_MEM_TEMPORAL__Z_TEMPORAL_READ__SHIFT            = 0x00000000;
constexpr unsigned int DB_MEM_TEMPORAL__Z_TEMPORAL_WRITE__SHIFT           = 0x00000003;
constexpr unsigned int DB_OCCLUSION_COUNT0_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT0_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_RENDER_CONTROL__COPY_CENTROID__SHIFT            = 0x00000007;
constexpr unsigned int DB_RENDER_CONTROL__COPY_SAMPLE__SHIFT              = 0x00000008;
constexpr unsigned int DB_RENDER_CONTROL__DECOMPRESS_ENABLE__SHIFT        = 0x0000000c;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COMPRESS_DISABLE__SHIFT   = 0x00000006;
constexpr unsigned int DB_RENDER_CONTROL__FORCE_EXPORT_ORDER__SHIFT       = 0x00000013;
constexpr unsigned int DB_RENDER_CONTROL__FORCE_OREO_MODE__SHIFT          = 0x00000012;
constexpr unsigned int DB_RENDER_CONTROL__MAX_ALLOWED_STILES_IN_WAVE__SHIFT = 0x00000014;
constexpr unsigned int DB_RENDER_CONTROL__OREO_MODE__SHIFT                = 0x00000010;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_1__SHIFT         = 0x00000002;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_2__SHIFT         = 0x00000003;
constexpr unsigned int DB_RENDER_CONTROL__RESERVED_FIELD_4__SHIFT         = 0x00000004;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COMPRESS_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int DB_RENDER_OVERRIDE2__ALLOW_PARTIAL_RES_HIER_KILL__SHIFT = 0x00000019;
constexpr unsigned int DB_RENDER_OVERRIDE2__CENTROID_COMPUTATION_MODE__SHIFT = 0x0000001b;
constexpr unsigned int DB_RENDER_OVERRIDE2__DECOMPRESS_Z_ON_FLUSH__SHIFT  = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE2__DEPTH_BOUNDS_HIER_DEPTH_DISABLE__SHIFT = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_COLOR_ON_VALIDATION__SHIFT = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_FAST_PASS__SHIFT      = 0x00000017;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_NOZ__SHIFT            = 0x0000001d;
constexpr unsigned int DB_RENDER_OVERRIDE2__FORCE_SUMM_STENCIL_RANGE_TO_MAX__SHIFT = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE2__FORCE_SUMM_Z_RANGE_TO_MAX__SHIFT = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_CONTROL__SHIFT = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_COUNTDOWN__SHIFT = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_ZRANGE__SHIFT        = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_1__SHIFT       = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_2__SHIFT       = 0x0000000d;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_5__SHIFT       = 0x00000005;
constexpr unsigned int DB_RENDER_OVERRIDE2__RESERVED_FIELD_6__SHIFT       = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES__SHIFT = 0x0000001a;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_STENCIL_DISABLE__SHIFT    = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_Z_DISABLE__SHIFT          = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_COLOR_KILL__SHIFT        = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE__SHIFT      = 0x0000000d;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE0__SHIFT       = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE1__SHIFT       = 0x00000004;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIZ_ENABLE__SHIFT        = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_SHADER_Z_ORDER__SHIFT    = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_DIRTY__SHIFT     = 0x0000001c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_READ__SHIFT      = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_VALID__SHIFT     = 0x0000001e;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_ALLOC__SHIFT           = 0x0000000f;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_DIRTY__SHIFT           = 0x0000001b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_LIMIT_SUMM__SHIFT      = 0x00000013;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_READ__SHIFT            = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_VALID__SHIFT           = 0x0000001d;
constexpr unsigned int DB_RENDER_OVERRIDE__MAX_TILES_IN_DTT__SHIFT        = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE__NOOP_CULL_DISABLE__SHIFT       = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE__PRESERVE_COMPRESSION__SHIFT    = 0x0000001f;
constexpr unsigned int DB_RING_CONTROL__COUNTER_CONTROL__SHIFT            = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__ALPHA_TO_MASK_DISABLE__SHIFT    = 0x0000000b;
constexpr unsigned int DB_SHADER_CONTROL__CONSERVATIVE_Z_EXPORT__SHIFT    = 0x0000000d;
constexpr unsigned int DB_SHADER_CONTROL__COVERAGE_TO_MASK_ENABLE__SHIFT  = 0x00000007;
constexpr unsigned int DB_SHADER_CONTROL__DEPTH_BEFORE_SHADER__SHIFT      = 0x0000000c;
constexpr unsigned int DB_SHADER_CONTROL__DUAL_QUAD_DISABLE__SHIFT        = 0x0000000f;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_HIER_FAIL__SHIFT        = 0x00000009;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_NOOP__SHIFT             = 0x0000000a;
constexpr unsigned int DB_SHADER_CONTROL__KILL_ENABLE__SHIFT              = 0x00000006;
constexpr unsigned int DB_SHADER_CONTROL__MASK_EXPORT_ENABLE__SHIFT       = 0x00000008;
constexpr unsigned int DB_SHADER_CONTROL__OREO_BLEND_ENABLE__SHIFT        = 0x00000018;
constexpr unsigned int DB_SHADER_CONTROL__OVERRIDE_INTRINSIC_RATE_ENABLE__SHIFT = 0x00000019;
constexpr unsigned int DB_SHADER_CONTROL__OVERRIDE_INTRINSIC_RATE__SHIFT  = 0x0000001a;
constexpr unsigned int DB_SHADER_CONTROL__PRE_SHADER_DEPTH_COVERAGE_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int DB_SHADER_CONTROL__PRIMITIVE_ORDERED_PIXEL_SHADER__SHIFT = 0x00000010;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_OP_VAL_EXPORT_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_TEST_VAL_EXPORT_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_SHADER_CONTROL__Z_EXPORT_ENABLE__SHIFT          = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__Z_ORDER__SHIFT                  = 0x00000004;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_1X1__SHIFT = 0x00000000;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_1X2__SHIFT = 0x00000010;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_2X1__SHIFT = 0x00000008;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_X_OFFSET_2X2__SHIFT = 0x00000018;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_1X1__SHIFT = 0x00000004;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_1X2__SHIFT = 0x00000014;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_2X1__SHIFT = 0x0000000c;
constexpr unsigned int DB_SPI_VRS_CENTER_LOCATION__CENTER_Y_OFFSET_2X2__SHIFT = 0x0000001c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREFUNC0__SHIFT    = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREMASK0__SHIFT    = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREVALUE0__SHIFT   = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREFUNC1__SHIFT    = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREMASK1__SHIFT    = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREVALUE1__SHIFT   = 0x00000004;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_BF__SHIFT          = 0x0000000c;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL__SHIFT             = 0x00000000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_BF__SHIFT         = 0x00000014;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL__SHIFT            = 0x00000008;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_BF__SHIFT         = 0x00000010;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS__SHIFT            = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__FORMAT__SHIFT                     = 0x00000000;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_1__SHIFT           = 0x0000000d;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_2__SHIFT           = 0x00000009;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_11__SHIFT          = 0x0000000b;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_12__SHIFT          = 0x0000000c;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_20__SHIFT          = 0x00000014;
constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_27__SHIFT          = 0x0000001b;
constexpr unsigned int DB_STENCIL_INFO__SW_MODE__SHIFT                    = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__TILE_STENCIL_DISABLE__SHIFT       = 0x0000001d;
constexpr unsigned int DB_STENCIL_OPVAL__OPVAL_BF__SHIFT                  = 0x00000008;
constexpr unsigned int DB_STENCIL_OPVAL__OPVAL__SHIFT                     = 0x00000000;
constexpr unsigned int DB_STENCIL_READ_BASE_HI__BASE_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_STENCIL_READ_BASE__BASE_256B__SHIFT             = 0x00000000;
constexpr unsigned int DB_STENCIL_READ_MASK__TESTMASK_BF__SHIFT           = 0x00000008;
constexpr unsigned int DB_STENCIL_READ_MASK__TESTMASK__SHIFT              = 0x00000000;
constexpr unsigned int DB_STENCIL_REF__TESTVAL_BF__SHIFT                  = 0x00000008;
constexpr unsigned int DB_STENCIL_REF__TESTVAL__SHIFT                     = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE_HI__BASE_HI__SHIFT           = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE__BASE_256B__SHIFT            = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_MASK__WRITEMASK_BF__SHIFT         = 0x00000008;
constexpr unsigned int DB_STENCIL_WRITE_MASK__WRITEMASK__SHIFT            = 0x00000000;
constexpr unsigned int DB_SUMMARIZER_TIMEOUTS__SUMM_CNTL_EVICT_TIMEOUT__SHIFT = 0x00000000;
constexpr unsigned int DB_SUMMARIZER_TIMEOUTS__SUMM_EVICT_TIMEOUT__SHIFT  = 0x00000010;
constexpr unsigned int DB_VIEWPORT_CONTROL__DISABLE_VIEWPORT_CLAMP__SHIFT = 0x00000000;
constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE__SHIFT         = 0x00000018;
constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH__SHIFT                  = 0x00000008;
constexpr unsigned int DB_WATERMARKS__DEPTH_FREE__SHIFT                   = 0x00000000;
constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE__SHIFT           = 0x00000010;
constexpr unsigned int DB_Z_INFO__DECOMPRESS_ON_N_ZPLANES__SHIFT          = 0x00000017;
constexpr unsigned int DB_Z_INFO__FORMAT__SHIFT                           = 0x00000000;
constexpr unsigned int DB_Z_INFO__MAXMIP__SHIFT                           = 0x0000000f;
constexpr unsigned int DB_Z_INFO__NUM_SAMPLES__SHIFT                      = 0x00000002;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_1__SHIFT                 = 0x0000000d;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_2__SHIFT                 = 0x00000009;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_11__SHIFT                = 0x0000000b;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_12__SHIFT                = 0x0000000c;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_20__SHIFT                = 0x00000014;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_27__SHIFT                = 0x0000001b;
constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_28__SHIFT                = 0x0000001c;
constexpr unsigned int DB_Z_INFO__SW_MODE__SHIFT                          = 0x00000004;
constexpr unsigned int DB_Z_INFO__TILE_SURFACE_ENABLE__SHIFT              = 0x0000001d;
constexpr unsigned int DB_Z_READ_BASE_HI__BASE_HI__SHIFT                  = 0x00000000;
constexpr unsigned int DB_Z_READ_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE_HI__BASE_HI__SHIFT                 = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi8__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi8__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi9__EventSelectHi__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi9__Filter__SHIFT            = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi10__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi10__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi11__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi11__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi12__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi12__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi13__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi13__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi14__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi14__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi15__EventSelectHi__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlHi15__Filter__SHIFT           = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo8__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__BypassEn__SHIFT          = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__DsmTrig__SHIFT           = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__En__SHIFT                = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__EventSelectLo__SHIFT     = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__Mp1Int__SHIFT            = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__UnitMaskHi__SHIFT        = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo9__UnitMaskLo__SHIFT        = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo10__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo11__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo12__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo13__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo14__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__BypassEn__SHIFT         = 0x00000015;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__DsmTrig__SHIFT          = 0x00000013;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__En__SHIFT               = 0x00000016;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__EventSelectLo__SHIFT    = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__Mp1Int__SHIFT           = 0x00000014;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__UnitMaskHi__SHIFT       = 0x00000018;
constexpr unsigned int DF_PIE_AON_PerfMonCtlLo15__UnitMaskLo__SHIFT       = 0x00000008;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi0__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi1__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi2__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi3__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi4__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi5__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi6__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi7__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi8__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi9__CTR_47_32__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi10__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi11__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi12__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi13__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi14__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrHi15__CTR_47_32__SHIFT        = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo0__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo1__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo2__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo3__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo4__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo5__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo6__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo7__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo8__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo9__CTR_31_0__SHIFT          = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo10__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo11__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo12__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo13__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo14__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int DF_PIE_AON_PerfMonCtrLo15__CTR_31_0__SHIFT         = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__MAX_COMPRESSED_FRAGS__SHIFT   = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PIPES__SHIFT              = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PKRS__SHIFT               = 0x00000008;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_RB_PER_SE__SHIFT          = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_SHADER_ENGINES__SHIFT     = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG_READ__PIPE_INTERLEAVE_SIZE__SHIFT   = 0x00000003;
constexpr unsigned int GB_ADDR_CONFIG__MAX_COMPRESSED_FRAGS__SHIFT        = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PIPES__SHIFT                   = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PKRS__SHIFT                    = 0x00000008;
constexpr unsigned int GB_ADDR_CONFIG__NUM_RB_PER_SE__SHIFT               = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG__NUM_SHADER_ENGINES__SHIFT          = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG__PIPE_INTERLEAVE_SIZE__SHIFT        = 0x00000003;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__CLEAR__SHIFT          = 0x0000001d;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__ENABLE__SHIFT         = 0x0000001c;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE__SHIFT      = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT    = 0x00000010;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int GCR_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE0__SHIFT   = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE1__SHIFT   = 0x00000002;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE2__SHIFT   = 0x00000004;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE3__SHIFT   = 0x00000006;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE0__SHIFT  = 0x00000008;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE1__SHIFT  = 0x0000000c;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE2__SHIFT  = 0x00000010;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE3__SHIFT  = 0x00000014;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL__SHIFT      = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE0__SHIFT   = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE1__SHIFT   = 0x00000002;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE2__SHIFT   = 0x00000004;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE3__SHIFT   = 0x00000006;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE0__SHIFT  = 0x00000008;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE1__SHIFT  = 0x0000000c;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE2__SHIFT  = 0x00000010;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE3__SHIFT  = 0x00000014;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL__SHIFT      = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT  = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT  = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT  = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT  = 0x0000000a;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT   = 0x00000014;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT  = 0x00000018;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT   = 0x0000001c;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT   = 0x0000000a;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT  = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT  = 0x00000000;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_SELECT__COUNTER_MODE__SHIFT = 0x0000001c;
constexpr unsigned int GC_EA_CPWD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GC_EA_SE_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT      = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_SELECT__COUNTER_MODE__SHIFT  = 0x0000001c;
constexpr unsigned int GC_EA_SE_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT      = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
constexpr unsigned int GE1_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_MODE0__SHIFT    = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_SEL0__SHIFT     = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_MODE0__SHIFT    = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_SEL0__SHIFT     = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_MODE0__SHIFT    = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_SEL0__SHIFT     = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_MODE0__SHIFT    = 0x0000001c;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_SEL0__SHIFT     = 0x00000000;
constexpr unsigned int GE2_DIST_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT     = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT     = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT      = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT       = 0x00000014;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_MODE0__SHIFT      = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT      = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_SEL0__SHIFT       = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT       = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT     = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT     = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT      = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT       = 0x00000014;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_MODE0__SHIFT      = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT      = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_SEL0__SHIFT       = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT       = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT     = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT     = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT      = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT       = 0x00000014;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_MODE0__SHIFT      = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT      = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_SEL0__SHIFT       = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT       = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT     = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT     = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT      = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT      = 0x0000000a;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT       = 0x00000014;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_MODE0__SHIFT      = 0x0000001c;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT      = 0x00000018;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_SEL0__SHIFT       = 0x00000000;
constexpr unsigned int GE2_SE_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT       = 0x0000000a;
constexpr unsigned int GE_CNTL__BREAK_PRIMGRP_AT_EOI__SHIFT               = 0x00000014;
constexpr unsigned int GE_CNTL__BREAK_SUBGRP_AT_EOI__SHIFT                = 0x00000012;
constexpr unsigned int GE_CNTL__DIS_PG_SIZE_ADJUST_FOR_STRIP__SHIFT       = 0x0000001f;
constexpr unsigned int GE_CNTL__GCR_DISABLE__SHIFT                        = 0x0000001e;
constexpr unsigned int GE_CNTL__PACKET_TO_ONE_PA__SHIFT                   = 0x00000013;
constexpr unsigned int GE_CNTL__PRIMS_PER_SUBGRP__SHIFT                   = 0x00000000;
constexpr unsigned int GE_CNTL__PRIM_GRP_SIZE__SHIFT                      = 0x00000015;
constexpr unsigned int GE_CNTL__VERTS_PER_SUBGRP__SHIFT                   = 0x00000009;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM_1__GS_FL_DIM_Z__SHIFT     = 0x00000000;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM__GS_FL_DIM_X__SHIFT       = 0x00000000;
constexpr unsigned int GE_GS_FAST_LAUNCH_WG_DIM__GS_FL_DIM_Y__SHIFT       = 0x00000010;
constexpr unsigned int GE_GS_ORDERED_ID_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int GE_GS_THROTTLE__ENABLE_THROTTLE__SHIFT             = 0x00000016;
constexpr unsigned int GE_GS_THROTTLE__FACTOR1__SHIFT                     = 0x00000010;
constexpr unsigned int GE_GS_THROTTLE__FACTOR2__SHIFT                     = 0x00000013;
constexpr unsigned int GE_GS_THROTTLE__NUM_INIT_GRPS__SHIFT               = 0x00000017;
constexpr unsigned int GE_GS_THROTTLE__STALL_CYCLES__SHIFT                = 0x00000009;
constexpr unsigned int GE_GS_THROTTLE__T0__SHIFT                          = 0x00000000;
constexpr unsigned int GE_GS_THROTTLE__T1__SHIFT                          = 0x00000003;
constexpr unsigned int GE_GS_THROTTLE__T2__SHIFT                          = 0x00000006;
constexpr unsigned int GE_IA_ENHANCE__MISC__SHIFT                         = 0x00000000;
constexpr unsigned int GE_INDX_OFFSET__INDX_OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int GE_MAX_OUTPUT_PER_SUBGROUP__MAX_VERTS_PER_SUBGROUP__SHIFT = 0x00000000;
constexpr unsigned int GE_MAX_VTX_INDX__MAX_INDX__SHIFT                   = 0x00000000;
constexpr unsigned int GE_MIN_VTX_INDX__MIN_INDX__SHIFT                   = 0x00000000;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__DISABLE_FOR_AUTO_INDEX__SHIFT = 0x00000002;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS__SHIFT   = 0x00000001;
constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__RESET_EN__SHIFT         = 0x00000000;
constexpr unsigned int GE_NGG_SUBGRP_CNTL__PRIM_AMP_FACTOR__SHIFT         = 0x00000000;
constexpr unsigned int GE_NGG_SUBGRP_CNTL__THDS_PER_SUBGRP__SHIFT         = 0x00000009;
constexpr unsigned int GE_PA_IF_SAFE_REG__GE_PA_CSB__SHIFT                = 0x00000000;
constexpr unsigned int GE_PA_IF_SAFE_REG__GE_PA_PAYLOAD__SHIFT            = 0x0000000a;
constexpr unsigned int GE_POS_RING_BASE__BASE__SHIFT                      = 0x00000000;
constexpr unsigned int GE_POS_RING_SIZE__MEM_SIZE__SHIFT                  = 0x00000000;
constexpr unsigned int GE_PRIM_RING_BASE__BASE__SHIFT                     = 0x00000000;
constexpr unsigned int GE_PRIM_RING_SIZE__FORCE_SE_SCOPE__SHIFT           = 0x0000001a;
constexpr unsigned int GE_PRIM_RING_SIZE__MEM_SIZE__SHIFT                 = 0x00000000;
constexpr unsigned int GE_PRIM_RING_SIZE__PAB_NOFILL__SHIFT               = 0x0000001b;
constexpr unsigned int GE_PRIM_RING_SIZE__PAB_TEMPORAL__SHIFT             = 0x00000015;
constexpr unsigned int GE_PRIM_RING_SIZE__PAF_TEMPORAL__SHIFT             = 0x00000012;
constexpr unsigned int GE_PRIM_RING_SIZE__SCOPE__SHIFT                    = 0x00000010;
constexpr unsigned int GE_PRIM_RING_SIZE__SPEC_DATA_READ__SHIFT           = 0x00000018;
constexpr unsigned int GE_PRIV_CONTROL__CLAMP_HS_OFFCHIP_PER_SE_OVERRIDE__SHIFT = 0x00000010;
constexpr unsigned int GE_PRIV_CONTROL__CLAMP_PRIMGRP_SIZE__SHIFT         = 0x00000001;
constexpr unsigned int GE_PRIV_CONTROL__FGCG_OVERRIDE__SHIFT              = 0x0000000f;
constexpr unsigned int GE_PRIV_CONTROL__MIN_ATTR_GRPS__SHIFT              = 0x00000012;
constexpr unsigned int GE_PRIV_CONTROL__RESERVED__SHIFT                   = 0x00000000;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_ES_VERT__SHIFT          = 0x00000010;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_GS_PRIM__SHIFT          = 0x00000018;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_HS_VERT__SHIFT          = 0x00000008;
constexpr unsigned int GE_RATE_CNTL_1__ADD_X_CLKS_LS_VERT__SHIFT          = 0x00000000;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_ES_VERT__SHIFT       = 0x00000014;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_GS_PRIM__SHIFT       = 0x0000001c;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_HS_VERT__SHIFT       = 0x0000000c;
constexpr unsigned int GE_RATE_CNTL_1__AFTER_Y_TRANS_LS_VERT__SHIFT       = 0x00000004;
constexpr unsigned int GE_RATE_CNTL_2__ADD_X_CLKS_MERGED_HS_GS__SHIFT     = 0x00000010;
constexpr unsigned int GE_RATE_CNTL_2__ADD_X_CLKS_MERGED_LS_ES__SHIFT     = 0x00000014;
constexpr unsigned int GE_RATE_CNTL_2__ENABLE_RATE_CNTL__SHIFT            = 0x0000001a;
constexpr unsigned int GE_RATE_CNTL_2__MERGED_HS_GS_MODE__SHIFT           = 0x00000018;
constexpr unsigned int GE_RATE_CNTL_2__MERGED_LS_ES_MODE__SHIFT           = 0x00000019;
constexpr unsigned int GE_RATE_CNTL_2__SWAP_PRIORITY__SHIFT               = 0x0000001b;
constexpr unsigned int GE_SE_CNTL_STATUS__HS_BUSY__SHIFT                  = 0x00000002;
constexpr unsigned int GE_SE_CNTL_STATUS__NGG_BUSY__SHIFT                 = 0x00000001;
constexpr unsigned int GE_SE_CNTL_STATUS__TE_BUSY__SHIFT                  = 0x00000000;
constexpr unsigned int GE_SE_ENHANCE__MISC__SHIFT                         = 0x00000000;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_GRP__SHIFT              = 0x0000000c;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_HS_GS_DATA__SHIFT       = 0x00000006;
constexpr unsigned int GE_SPI_IF_SAFE_REG__GE_SPI_LS_ES_DATA__SHIFT       = 0x00000000;
constexpr unsigned int GE_STATUS__PERFCOUNTER_STATUS__SHIFT               = 0x00000000;
constexpr unsigned int GE_STATUS__THREAD_TRACE_STATUS__SHIFT              = 0x00000001;
constexpr unsigned int GE_STEREO_CNTL__EN_STEREO__SHIFT                   = 0x00000008;
constexpr unsigned int GE_STEREO_CNTL__RT_SLICE__SHIFT                    = 0x00000000;
constexpr unsigned int GE_STEREO_CNTL__UNUSED__SHIFT                      = 0x00000007;
constexpr unsigned int GE_STEREO_CNTL__VIEWPORT__SHIFT                    = 0x00000003;
constexpr unsigned int GE_USER_VGPR1__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int GE_USER_VGPR2__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int GE_USER_VGPR3__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR1__SHIFT              = 0x00000000;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR2__SHIFT              = 0x00000001;
constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR3__SHIFT              = 0x00000002;
constexpr unsigned int GE_VRS_RATE__RATE_X__SHIFT                         = 0x00000000;
constexpr unsigned int GE_VRS_RATE__RATE_Y__SHIFT                         = 0x00000004;
constexpr unsigned int GE_WD_CNTL_STATUS__DIST_BE_BUSY__SHIFT             = 0x00000001;
constexpr unsigned int GE_WD_CNTL_STATUS__DIST_BUSY__SHIFT                = 0x00000000;
constexpr unsigned int GE_WD_CNTL_STATUS__GE_UTCL1_BUSY__SHIFT            = 0x00000002;
constexpr unsigned int GE_WD_CNTL_STATUS__PC_MANAGER_BUSY__SHIFT          = 0x00000004;
constexpr unsigned int GE_WD_CNTL_STATUS__WD_TE11_BUSY__SHIFT             = 0x00000003;
constexpr unsigned int GE_WD_CNTL_STATUS__WLC_BUSY__SHIFT                 = 0x00000005;
constexpr unsigned int GE_WD_ENHANCE__MISC__SHIFT                         = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int GL1XC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2C_CTRL2__ADDR_MATCH_DISABLE__SHIFT              = 0x00000004;
constexpr unsigned int GL2C_CTRL2__COMPRESSED_WRITE_SAFE_MODE__SHIFT      = 0x00000011;
constexpr unsigned int GL2C_CTRL2__DCC_CLEAR_ERRORS__SHIFT                = 0x00000018;
constexpr unsigned int GL2C_CTRL2__DCC_COMPRESSION_DISABLE__SHIFT         = 0x0000000e;
constexpr unsigned int GL2C_CTRL2__DCC_COMP_TO_CONSTANT_EN__SHIFT         = 0x0000001b;
constexpr unsigned int GL2C_CTRL2__DCC_COMP_TO_SINGLE_EN__SHIFT           = 0x0000001a;
constexpr unsigned int GL2C_CTRL2__DECOMPRESS_WRITE_COMPRESSION_DISABLE__SHIFT = 0x00000016;
constexpr unsigned int GL2C_CTRL2__DF_COMPRESSION_MODE_OVERRIDE__SHIFT    = 0x0000000f;
constexpr unsigned int GL2C_CTRL2__DISABLE_CACHE_RAM_READ_FILTER__SHIFT   = 0x0000001e;
constexpr unsigned int GL2C_CTRL2__DISABLE_HI_PRIORITY__SHIFT             = 0x0000001c;
constexpr unsigned int GL2C_CTRL2__DISABLE_TAG_RAM_READ_FILTER__SHIFT     = 0x0000001f;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_32__SHIFT                    = 0x00000000;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_64__SHIFT                    = 0x00000002;
constexpr unsigned int GL2C_CTRL2__FILL_SIZE_128__SHIFT                   = 0x00000005;
constexpr unsigned int GL2C_CTRL2__FORCE_WRITE_DECOMPRESSION__SHIFT       = 0x00000017;
constexpr unsigned int GL2C_CTRL2__GCR_ALL_SET__SHIFT                     = 0x0000000d;
constexpr unsigned int GL2C_CTRL2__GCR_ARB_CTRL__SHIFT                    = 0x0000000a;
constexpr unsigned int GL2C_CTRL2__HIT_UNDER_MISS_DISABLE__SHIFT          = 0x00000007;
constexpr unsigned int GL2C_CTRL2__MAX_MIN_CTRL__SHIFT                    = 0x00000014;
constexpr unsigned int GL2C_CTRL2__OC_OVERRIDE_UNCOMP_LOGICAL_SIZE_DISABLE__SHIFT = 0x0000001d;
constexpr unsigned int GL2C_CTRL2__RO_DISABLE__SHIFT                      = 0x00000008;
constexpr unsigned int GL2C_CTRL2__SC_TO_HI_PRIORITY__SHIFT               = 0x00000006;
constexpr unsigned int GL2C_CTRL2__UNCOMP_RET_LATENCY_MODE__SHIFT         = 0x00000009;
constexpr unsigned int GL2C_CTRL2__USE_EA_EARLYWRRET_ON_WRITEBACK__SHIFT  = 0x00000012;
constexpr unsigned int GL2C_CTRL2__WRITEBACK_ALL_WAIT_FOR_ALL_EA_WRITE_COMPLETE__SHIFT = 0x00000013;
constexpr unsigned int GL2C_CTRL3__BANK_LINEAR_HASH_ENABLE__SHIFT         = 0x0000000b;
constexpr unsigned int GL2C_CTRL3__BANK_LINEAR_HASH_MODE__SHIFT           = 0x00000005;
constexpr unsigned int GL2C_CTRL3__COMP_STREAM_OVERRIDE_BYPASS__SHIFT     = 0x0000001a;
constexpr unsigned int GL2C_CTRL3__COMP_STREAM_OVERRIDE__SHIFT            = 0x00000000;
constexpr unsigned int GL2C_CTRL3__DECOMP_NBC_IND64_DISABLE__SHIFT        = 0x0000000d;
constexpr unsigned int GL2C_CTRL3__EA_GMI_DISABLE__SHIFT                  = 0x00000019;
constexpr unsigned int GL2C_CTRL3__EA_READ_SIZE_LIMIT__SHIFT              = 0x00000013;
constexpr unsigned int GL2C_CTRL3__EA_WRITE_SIZE_LIMIT__SHIFT             = 0x00000014;
constexpr unsigned int GL2C_CTRL3__ENABLE_64B_LAST_USE__SHIFT             = 0x00000006;
constexpr unsigned int GL2C_CTRL3__FGCG_OVERRIDE__SHIFT                   = 0x0000000f;
constexpr unsigned int GL2C_CTRL3__FORCE_MTYPE_UC__SHIFT                  = 0x00000010;
constexpr unsigned int GL2C_CTRL3__FORCE_READ_ON_WRITE_OP__SHIFT          = 0x0000000e;
constexpr unsigned int GL2C_CTRL3__FORCE_UNCOMP_READ__SHIFT               = 0x00000002;
constexpr unsigned int GL2C_CTRL3__HASH_256B_ENABLE__SHIFT                = 0x0000000c;
constexpr unsigned int GL2C_CTRL3__INF_NAN_CLAMP__SHIFT                   = 0x0000001b;
constexpr unsigned int GL2C_CTRL3__IO_CHANNEL_ENABLE__SHIFT               = 0x00000008;
constexpr unsigned int GL2C_CTRL3__LAST_USE_MODE__SHIFT                   = 0x00000001;
constexpr unsigned int GL2C_CTRL3__LAST_USE_SAFE_MODE__SHIFT              = 0x00000004;
constexpr unsigned int GL2C_CTRL3__SCRATCH__SHIFT                         = 0x0000001c;
constexpr unsigned int GL2C_CTRL3__SET_GROUP_LINEAR_HASH_ENABLE__SHIFT    = 0x00000018;
constexpr unsigned int GL2C_CTRL3__UNCACHED_TO_UC_QUEUE__SHIFT            = 0x00000007;
constexpr unsigned int GL2C_CTRL3__WB_OPT_BURST_MAX_COUNT__SHIFT          = 0x00000016;
constexpr unsigned int GL2C_CTRL3__WB_OPT_ENABLE__SHIFT                   = 0x00000015;
constexpr unsigned int GL2C_CTRL3__WRITE_SET_SECTOR_FULLY_WRITTEN__SHIFT  = 0x00000012;
constexpr unsigned int GL2C_CTRL4__CORE_MGCG_MODE__SHIFT                  = 0x00000007;
constexpr unsigned int GL2C_CTRL4__DCC_CLEAR_128B_CONSTANT_ENCODE_EN__SHIFT = 0x0000000f;
constexpr unsigned int GL2C_CTRL4__DCC_FORCE_BYPASS__SHIFT                = 0x0000000e;
constexpr unsigned int GL2C_CTRL4__EA_COMPRESSED_NACK_DISABLE__SHIFT      = 0x0000000d;
constexpr unsigned int GL2C_CTRL4__EA_NACK_DISABLE__SHIFT                 = 0x00000009;
constexpr unsigned int GL2C_CTRL4__EXECUTE_MGCG_MODE__SHIFT               = 0x00000008;
constexpr unsigned int GL2C_CTRL4__FED_SAFE_MODE__SHIFT                   = 0x0000000a;
constexpr unsigned int GL2C_CTRL4__FLUSH_SET_COUNTER_MASK_DISABLE__SHIFT  = 0x0000000b;
constexpr unsigned int GL2C_CTRL4__LFIFO_HASH_MODE__SHIFT                 = 0x00000010;
constexpr unsigned int GL2C_CTRL4__LFIFO_VMISS_DISABLE__SHIFT             = 0x0000000c;
constexpr unsigned int GL2C_CTRL4__OC_UNCOMP_128B_COMPRESS_EN_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int GL2C_CTRL4__SPA_CHANNEL_ENABLE__SHIFT              = 0x00000001;
constexpr unsigned int GL2C_CTRL4__TAG_MGCG_MODE__SHIFT                   = 0x00000006;
constexpr unsigned int GL2C_CTRL4__WRITEBACK_FIFO_STALL_ENABLE__SHIFT     = 0x00000003;
constexpr unsigned int GL2C_CTRL5__CB_SUPPORTED_COMP_SCHEME__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_CTRL5__CID_REMAP_ENABLE__SHIFT                = 0x0000000f;
constexpr unsigned int GL2C_CTRL5__COMP_BYPASS_READ_MODE__SHIFT           = 0x00000011;
constexpr unsigned int GL2C_CTRL5__CONCAT_GT_128B_DISABLE__SHIFT          = 0x00000008;
constexpr unsigned int GL2C_CTRL5__DB_SUPPORTED_COMP_SCHEME__SHIFT        = 0x00000004;
constexpr unsigned int GL2C_CTRL5__FORCE_UNCOMP_READ_ON_UNCOMPRESSED_CL__SHIFT = 0x00000009;
constexpr unsigned int GL2C_CTRL5__LAST_USE_SAFE_MODE_COMP__SHIFT         = 0x00000013;
constexpr unsigned int GL2C_CTRL5__PERF_CNTR_EN_OVERRIDE__SHIFT           = 0x00000010;
constexpr unsigned int GL2C_CTRL5__UNCACHED_COMP_WRITE_PASSTHROUGH_EN__SHIFT = 0x00000012;
constexpr unsigned int GL2C_CTRL5__UNCOMP_KEY_COMP_WRITE_EN__SHIFT        = 0x00000014;
constexpr unsigned int GL2C_CTRL5__VGT_GS_MAX_WAVE_ID_WIDTH__SHIFT        = 0x0000000a;
constexpr unsigned int GL2C_CTRL__CACHE_SIZE__SHIFT                       = 0x00000000;
constexpr unsigned int GL2C_CTRL__DCC_COMP_SKIP_LOW_COMP_RATIOS__SHIFT    = 0x0000000b;
constexpr unsigned int GL2C_CTRL__DCC_COMP_TRANSFER_SIZE_ENABLE__SHIFT    = 0x00000008;
constexpr unsigned int GL2C_CTRL__FORCE_HIT_QUEUE_POP__SHIFT              = 0x00000016;
constexpr unsigned int GL2C_CTRL__IGNORE_FULLY_WRITTEN__SHIFT             = 0x0000001b;
constexpr unsigned int GL2C_CTRL__LATENCY_FIFO_SIZE__SHIFT                = 0x00000010;
constexpr unsigned int GL2C_CTRL__LINEAR_SET_HASH__SHIFT                  = 0x00000015;
constexpr unsigned int GL2C_CTRL__RATE__SHIFT                             = 0x00000002;
constexpr unsigned int GL2C_CTRL__SINGLE_GL2__SHIFT                       = 0x0000001c;
constexpr unsigned int GL2C_CTRL__SRC_FIFO_SIZE__SHIFT                    = 0x0000000c;
constexpr unsigned int GL2C_CTRL__UNSUPPORTED_DF_ATOMIC_OPS__SHIFT        = 0x0000001d;
constexpr unsigned int GL2C_CTRL__WRITEBACK_MARGIN__SHIFT                 = 0x00000004;
constexpr unsigned int GL2C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__EA_LINK_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1A_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL1XCC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL2A_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__GL2C_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SC_CLEAN_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SQG_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBMH_PERFCOUNTER0_SELECT__WGS_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBMH_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__EA_LINK_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1A_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL1XCC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL2A_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__GL2C_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SC_CLEAN_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SQG_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBMH_PERFCOUNTER1_SELECT__WGS_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBMH_SYNC__GFX_PIPE0_PERFMON_SYNC__SHIFT          = 0x00000000;
constexpr unsigned int GRBMH_SYNC__GFX_PIPE0_SYNC__SHIFT                  = 0x00000010;
constexpr unsigned int GRBMH_SYNC__GFX_SYNC_SET_CLR__SHIFT                = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_BROADCAST_WRITES__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_INDEX__SHIFT      = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_BROADCAST_WRITES__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_INDEX__SHIFT            = 0x00000008;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_BROADCAST_WRITES__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_INDEX__SHIFT            = 0x00000010;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__INDEX__SHIFT             = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__VF_PF__SHIFT             = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_BROADCAST_WRITES__SHIFT   = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_INDEX__SHIFT              = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX__SA_BROADCAST_WRITES__SHIFT         = 0x0000001d;
constexpr unsigned int GRBM_GFX_INDEX__SA_INDEX__SHIFT                    = 0x00000008;
constexpr unsigned int GRBM_GFX_INDEX__SE_BROADCAST_WRITES__SHIFT         = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX__SE_INDEX__SHIFT                    = 0x00000010;
constexpr unsigned int GRBM_NOWHERE_2__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int GRBM_NOWHERE__DATA__SHIFT                          = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__EA_STAT_LINK_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1XCC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__WGS_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_CLEAN_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__EA_STAT_LINK_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1XCC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__WGS_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_CLEAN_USER_DEFINED_MASK__SHIFT = 0x00000009;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int IA_UTCL1_CNTL__BYPASS__SHIFT                       = 0x00000019;
constexpr unsigned int IA_UTCL1_CNTL__DROP_MODE__SHIFT                    = 0x00000018;
constexpr unsigned int IA_UTCL1_CNTL__FORCE_SNOOP__SHIFT                  = 0x0000001c;
constexpr unsigned int IA_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT              = 0x0000001b;
constexpr unsigned int IA_UTCL1_CNTL__INVALIDATE__SHIFT                   = 0x0000001a;
constexpr unsigned int IA_UTCL1_CNTL__LLC_NOALLOC_OVERRIDE__SHIFT         = 0x0000001e;
constexpr unsigned int IA_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT               = 0x0000001d;
constexpr unsigned int IA_UTCL1_CNTL__VMID_RESET_MODE__SHIFT              = 0x00000017;
constexpr unsigned int IA_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT         = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_DETECTED__SHIFT           = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_INSTANCEID__SHIFT         = 0x0000000e;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_UTCL1ID__SHIFT            = 0x00000008;
constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_VMID__SHIFT               = 0x00000004;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_DETECTED__SHIFT             = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_INSTANCEID__SHIFT           = 0x0000001e;
constexpr unsigned int IA_UTCL1_STATUS_2__PRT_UTCL1ID__SHIFT              = 0x00000018;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_DETECTED__SHIFT           = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_INSTANCEID__SHIFT         = 0x00000016;
constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_UTCL1ID__SHIFT            = 0x00000010;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_DETECTED__SHIFT             = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_INSTANCEID__SHIFT           = 0x0000000e;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT              = 0x00000008;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_VMID__SHIFT                 = 0x00000004;
constexpr unsigned int IA_UTCL1_STATUS__PRT_DETECTED__SHIFT               = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS__PRT_INSTANCEID__SHIFT             = 0x0000001e;
constexpr unsigned int IA_UTCL1_STATUS__PRT_UTCL1ID__SHIFT                = 0x00000018;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_DETECTED__SHIFT             = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_INSTANCEID__SHIFT           = 0x00000016;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT              = 0x00000010;
constexpr unsigned int MP1_SMN_FPS_CNT__COUNT__SHIFT                      = 0x00000000;
constexpr unsigned int PA_CL_CLIP_CNTL__BOUNDARY_EDGE_FLAG_ENA__SHIFT     = 0x00000012;
constexpr unsigned int PA_CL_CLIP_CNTL__CLIP_DISABLE__SHIFT               = 0x00000010;
constexpr unsigned int PA_CL_CLIP_CNTL__DIS_CLIP_ERR_DETECT__SHIFT        = 0x00000014;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_CLIP_SPACE_DEF__SHIFT          = 0x00000013;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_LINEAR_ATTR_CLIP_ENA__SHIFT    = 0x00000018;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_RASTERIZATION_KILL__SHIFT      = 0x00000016;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_MODE__SHIFT                = 0x0000000e;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_Y_SCALE_NEG__SHIFT         = 0x0000000d;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_CULL_ONLY_ENA__SHIFT          = 0x00000011;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_0__SHIFT                  = 0x00000000;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_1__SHIFT                  = 0x00000001;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_2__SHIFT                  = 0x00000002;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_3__SHIFT                  = 0x00000003;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_4__SHIFT                  = 0x00000004;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_5__SHIFT                  = 0x00000005;
constexpr unsigned int PA_CL_CLIP_CNTL__VTE_VPORT_PROVOKE_DISABLE__SHIFT  = 0x00000019;
constexpr unsigned int PA_CL_CLIP_CNTL__VTX_KILL_OR__SHIFT                = 0x00000015;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_FAR_DISABLE__SHIFT          = 0x0000001b;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_NEAR_DISABLE__SHIFT         = 0x0000001a;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_PROG_NEAR_ENA__SHIFT        = 0x0000001c;
constexpr unsigned int PA_CL_CNTL_STATUS__CL_BUSY__SHIFT                  = 0x0000001f;
constexpr unsigned int PA_CL_ENHANCE__BROADCAST_PERP_ENDCAP_PRIMS__SHIFT  = 0x0000001d;
constexpr unsigned int PA_CL_ENHANCE__BROADCAST_PMODE_PRIMS__SHIFT        = 0x0000001c;
constexpr unsigned int PA_CL_ENHANCE__CLAMP_NEGATIVE_BB_TO_ZERO__SHIFT    = 0x00000017;
constexpr unsigned int PA_CL_ENHANCE__CLIPPED_PRIM_SEQ_STALL__SHIFT       = 0x00000003;
constexpr unsigned int PA_CL_ENHANCE__CLIP_VTX_REORDER_ENA__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_PH_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000014;
constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_SX_REQ_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000015;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE0__SHIFT                   = 0x0000001f;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE1__SHIFT                   = 0x0000001e;
constexpr unsigned int PA_CL_ENHANCE__ENABLE_PA_RATE_CNTL__SHIFT          = 0x00000016;
constexpr unsigned int PA_CL_ENHANCE__IGNORE_PIPELINE_RESET__SHIFT        = 0x00000006;
constexpr unsigned int PA_CL_ENHANCE__KILL_INNER_EDGE_FLAGS__SHIFT        = 0x00000007;
constexpr unsigned int PA_CL_ENHANCE__NGG_BYPASS_PRIM_FILTER__SHIFT       = 0x0000000b;
constexpr unsigned int PA_CL_ENHANCE__NGG_PA_TO_ALL_SC__SHIFT             = 0x00000008;
constexpr unsigned int PA_CL_ENHANCE__NGG_PRIM_INDICES_FIFO_DEPTH__SHIFT  = 0x0000000e;
constexpr unsigned int PA_CL_ENHANCE__NGG_SIDEBAND_MEMORY_DEPTH__SHIFT    = 0x0000000c;
constexpr unsigned int PA_CL_ENHANCE__NUM_CLIP_SEQ__SHIFT                 = 0x00000001;
constexpr unsigned int PA_CL_ENHANCE__PAF_GEWD_CSB_CLK_OVERRIDE__SHIFT    = 0x0000001b;
constexpr unsigned int PA_CL_ENHANCE__PA_R_GL1X_REQ_CLK_OVERRIDE__SHIFT   = 0x0000001a;
constexpr unsigned int PA_CL_ENHANCE__PA_W_GL1X_REQ_CLK_OVERRIDE__SHIFT   = 0x00000019;
constexpr unsigned int PA_CL_ENHANCE__PA_W_GL1X_SRC_CLK_OVERRIDE__SHIFT   = 0x00000018;
constexpr unsigned int PA_CL_ENHANCE__POLY_INNER_EDGE_FLAG_DISABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_CL_ENHANCE__PROG_NEAR_CLIP_PLANE_ENABLE__SHIFT  = 0x00000011;
constexpr unsigned int PA_CL_ENHANCE__TC_LATENCY_TIME_STAMP_RESOLUTION__SHIFT = 0x00000009;
constexpr unsigned int PA_CL_ENHANCE__TC_REQUEST_PERF_CNTR_ENABLE__SHIFT  = 0x00000013;
constexpr unsigned int PA_CL_ENHANCE__VE_NAN_PROC_DISABLE__SHIFT          = 0x00000004;
constexpr unsigned int PA_CL_ENHANCE__XTRA_DEBUG_REG_SEL__SHIFT           = 0x00000005;
constexpr unsigned int PA_CL_GB_HORZ_CLIP_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_HORZ_DISC_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_CLIP_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_DISC_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_CLIP_DIST_INF_DISCARD__SHIFT = 0x0000000e;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_INF_RETAIN__SHIFT          = 0x0000000d;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_NAN_TO_INF__SHIFT          = 0x0000000c;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_INF_RETAIN__SHIFT         = 0x00000009;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_NAN_TO_INF__SHIFT         = 0x00000008;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_INF_RETAIN__SHIFT          = 0x0000000b;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_NAN_TO_INF__SHIFT          = 0x0000000a;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_0XNANINF_IS_0__SHIFT        = 0x00000003;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_NO_OUTPUT_NEG_0__SHIFT      = 0x00000014;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_INF_DISCARD__SHIFT        = 0x00000002;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_NAN_RETAIN__SHIFT         = 0x00000006;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_RECIP_NAN_IS_0__SHIFT     = 0x00000007;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_INF_DISCARD__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_NAN_RETAIN__SHIFT        = 0x00000004;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_INF_DISCARD__SHIFT        = 0x00000001;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_NAN_RETAIN__SHIFT         = 0x00000005;
constexpr unsigned int PA_CL_NGG_CNTL__INDEX_BUF_EDGE_FLAG_ENA__SHIFT     = 0x00000001;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_DEPTH__SHIFT          = 0x00000002;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_OFF__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_POINT_CULL_RAD__DATA_REGISTER__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_POINT_SIZE__DATA_REGISTER__SHIFT             = 0x00000000;
constexpr unsigned int PA_CL_POINT_X_RAD__DATA_REGISTER__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_POINT_Y_RAD__DATA_REGISTER__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_PROG_NEAR_CLIP_Z__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_1__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_2__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_3__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_4__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_5__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_6__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_7__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_8__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_9__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_10__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_11__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_12__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_13__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_14__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_15__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET__VPORT_XOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_1__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_2__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_3__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_4__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_5__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_6__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_7__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_8__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_9__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_10__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_11__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_12__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_13__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_14__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_15__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE__VPORT_XSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_1__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_2__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_3__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_4__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_5__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_6__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_7__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_8__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_9__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_10__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_11__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_12__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_13__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_14__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_15__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET__VPORT_YOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_1__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_2__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_3__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_4__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_5__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_6__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_7__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_8__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_9__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_10__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_11__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_12__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_13__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_14__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_15__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE__VPORT_YSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_1__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_2__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_3__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_4__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_5__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_6__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_7__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_8__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_9__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_10__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_11__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_12__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_13__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_14__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_15__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET__VPORT_ZOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_1__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_2__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_3__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_4__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_5__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_6__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_7__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_8__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_9__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_10__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_11__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_12__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_13__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_14__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_15__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE__VPORT_ZSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VRS_CNTL__CMASK_RATE_HINT_FORCE_ZERO__SHIFT  = 0x0000000e;
constexpr unsigned int PA_CL_VRS_CNTL__EXPOSE_VRS_PIXELS_MASK__SHIFT      = 0x0000000d;
constexpr unsigned int PA_CL_VRS_CNTL__HTILE_RATE_COMBINER_MODE__SHIFT    = 0x00000006;
constexpr unsigned int PA_CL_VRS_CNTL__PRIMITIVE_RATE_COMBINER_MODE__SHIFT = 0x00000003;
constexpr unsigned int PA_CL_VRS_CNTL__SAMPLE_COVERAGE_ENCODING__SHIFT    = 0x0000000f;
constexpr unsigned int PA_CL_VRS_CNTL__SAMPLE_ITER_COMBINER_MODE__SHIFT   = 0x00000009;
constexpr unsigned int PA_CL_VRS_CNTL__VERTEX_RATE_COMBINER_MODE__SHIFT   = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__BYPASS_PRIM_RATE_COMBINER__SHIFT = 0x0000001e;
constexpr unsigned int PA_CL_VS_OUT_CNTL__BYPASS_VTX_RATE_COMBINER__SHIFT = 0x0000001d;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_0__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_1__SHIFT          = 0x00000001;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_2__SHIFT          = 0x00000002;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_3__SHIFT          = 0x00000003;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_4__SHIFT          = 0x00000004;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_5__SHIFT          = 0x00000005;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_6__SHIFT          = 0x00000006;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_7__SHIFT          = 0x00000007;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_0__SHIFT          = 0x00000008;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_1__SHIFT          = 0x00000009;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_2__SHIFT          = 0x0000000a;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_3__SHIFT          = 0x0000000b;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_4__SHIFT          = 0x0000000c;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_5__SHIFT          = 0x0000000d;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_6__SHIFT          = 0x0000000e;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_7__SHIFT          = 0x0000000f;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_EDGE_FLAG__SHIFT        = 0x00000011;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_KILL_FLAG__SHIFT        = 0x00000014;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH__SHIFT       = 0x0000001b;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_POINT_SIZE__SHIFT       = 0x00000010;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_RENDER_TARGET_INDX__SHIFT = 0x00000012;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VIEWPORT_INDX__SHIFT    = 0x00000013;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VRS_RATE__SHIFT         = 0x0000001c;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST0_VEC_ENA__SHIFT   = 0x00000016;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST1_VEC_ENA__SHIFT   = 0x00000017;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_SIDE_BUS_ENA__SHIFT = 0x00000018;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_VEC_ENA__SHIFT      = 0x00000015;
constexpr unsigned int PA_CL_VTE_CNTL__PERFCOUNTER_REF__SHIFT             = 0x0000000b;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_OFFSET_ENA__SHIFT          = 0x00000001;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_SCALE_ENA__SHIFT           = 0x00000000;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_OFFSET_ENA__SHIFT          = 0x00000003;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_SCALE_ENA__SHIFT           = 0x00000002;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_OFFSET_ENA__SHIFT          = 0x00000005;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_SCALE_ENA__SHIFT           = 0x00000004;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_W0_FMT__SHIFT                  = 0x0000000a;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_XY_FMT__SHIFT                  = 0x00000008;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_Z_FMT__SHIFT                   = 0x00000009;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_SCAN_POST_RESET__SHIFT = 0x00000006;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT__SHIFT                = 0x00000005;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_PERF_REG_FGCG__SHIFT     = 0x00000009;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_CLKEN_CLOCK_GATE__SHIFT = 0x00000007;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000004;
constexpr unsigned int PA_PH_ENHANCE__DISABLE_USE_LAST_PH_ARBITER_PERFCOUNTER_SAMPLE_EVENT__SHIFT = 0x0000000d;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE0__SHIFT                   = 0x00000000;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE1__SHIFT                   = 0x00000001;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE2__SHIFT                   = 0x00000002;
constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE3__SHIFT                   = 0x00000003;
constexpr unsigned int PA_PH_ENHANCE__ENABLE_PH_INTF_CLKEN_STRETCH__SHIFT = 0x0000000a;
constexpr unsigned int PA_PH_ENHANCE__FORCE_PH_PERFCOUNTER_SAMPLE_ENABLE_ON__SHIFT = 0x0000000f;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_MODE_DISABLE__SHIFT = 0x00000011;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_MODE__SHIFT      = 0x00000010;
constexpr unsigned int PA_PH_ENHANCE__PH_SPI_GE_THROTTLE_PERFCOUNTER_COUNT_MODE__SHIFT = 0x00000012;
constexpr unsigned int PA_PH_ENHANCE__USE_PERFCOUNTER_START_STOP_EVENTS__SHIFT = 0x0000000e;
constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PA_PH_IF_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PH_SC_IF_FIFO_SIZE__SHIFT = 0x00000010;
constexpr unsigned int PA_PH_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_PH_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_RATE_CNTL__PRIM_RATE__SHIFT                     = 0x00000004;
constexpr unsigned int PA_RATE_CNTL__VERTEX_RATE__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_AA_CONFIG__AA_MASK_CENTROID_DTMN__SHIFT      = 0x00000004;
constexpr unsigned int PA_SC_AA_CONFIG__DETAIL_TO_EXPOSED_MODE__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_EXPOSED_SAMPLES__SHIFT       = 0x00000014;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_NUM_SAMPLES__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_AA_CONFIG__PS_ITER_SAMPLES__SHIFT            = 0x0000001e;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X0Y0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X1Y0__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X0Y1__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X1Y1__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_ATM_CNTL__DISABLE_MAX_ATTRIBUTES__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_ATM_CNTL__DISABLE_SC_PC_IF_FGCG_EN__SHIFT    = 0x00000007;
constexpr unsigned int PA_SC_ATM_CNTL__MAX_ATTRIBUTES_IN_WAVE__SHIFT      = 0x00000008;
constexpr unsigned int PA_SC_ATM_CNTL__SC_PC_IF_SIZE__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_ATM_CNTL__SELECT_MAX_ATTRIBUTES__SHIFT       = 0x00000011;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BINNING_MODE__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_MAPPING_MODE__SHIFT       = 0x0000001d;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_EXTEND__SHIFT      = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X__SHIFT             = 0x00000002;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_EXTEND__SHIFT      = 0x00000007;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y__SHIFT             = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_0__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_CNTL_0__DISABLE_START_OF_PRIM__SHIFT  = 0x00000012;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FPOVS_PER_BATCH__SHIFT        = 0x00000013;
constexpr unsigned int PA_SC_BINNER_CNTL_0__OPTIMAL_BIN_SELECTION__SHIFT  = 0x0000001b;
constexpr unsigned int PA_SC_BINNER_CNTL_0__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_BINNER_CNTL_0__RESERVED_31__SHIFT            = 0x0000001f;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_ALLOC_COUNT__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_PRIM_PER_BATCH__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_BINNER_CNTL_2__BIN_SIZE_X_MULT_BY_1P5X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_2__BIN_SIZE_Y_MULT_BY_1P5X__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_BINNER_CNTL_2__CONTEXT_DONE_EVENTS_PER_BIN__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_BINNER_CNTL_2__DISABLE_NOPCEXPORT_BREAKBATCH_CONDITION__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_BINNER_CNTL_2__DUAL_LIGHT_SHAFT_IN_DRAW__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ENABLE_LIGHT_VOLUME_RENDERING_OPTIMIZATION__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ENABLE_PING_PONG_BIN_ORDER__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_BINNER_CNTL_2__LIGHT_SHAFT_DRAW_CALL_LIMIT__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_CNTL_2__PING_PONG_BIN_ORDER_FLIP__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_CNTL_2__RESERVED_LIGHT_SHAFT_DRAW_CALL_LIMIT__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_2__SBB_ENABLE__SHIFT             = 0x00000016;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_AREA_THRESHOLD__SHIFT     = 0x0000000d;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_ENABLED__SHIFT            = 0x0000000b;
constexpr unsigned int PA_SC_BINNER_CNTL_2__ZPP_OPTIMIZATION_ENABLED__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__BINNING_MODE__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__DIRECT_OVERRIDE_MODE__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__FPOVS_PER_BATCH__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__OVERRIDE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_BINNER_DYNAMIC_BATCH_LIMIT__LIMIT__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__BREAK_BATCH__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_TS__SHIFT   = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CONTEXT_DONE__SHIFT     = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CS_PARTIAL_FLUSH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_IB_END__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_INCR_DE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__EVENT_STATE_CHANGE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RST_PIX_CNT__SHIFT      = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS1__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS2__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS3__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_SYNC__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VS_PARTIAL_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__BIN_CONF_OVERRIDE_CHECK__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_EVENT__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_TS_EVENT__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_DFSM__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_ES_OUTPUT__SHIFT  = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_HS_OUTPUT__SHIFT  = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_SAMPLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_START__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_STOP__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_START__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_STOP__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PS_PARTIAL_FLUSH__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__RESET_TO_LOWEST_VGT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SAMPLE_PIPELINESTAT__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SO_VGTSTREAMOUT_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__WAIT_SYNC__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BLOCK_CONTEXT_DONE__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BOTTOM_OF_PIPE_TS__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_DONE__SHIFT          = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__DB_CACHE_FLUSH_AND_INV__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_DATA_TS__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_META__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_DATA_TS__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_META__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_35__SHIFT      = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_41__SHIFT      = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESET_VTX_CNT__SHIFT    = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SAMPLE_STREAMOUTSTATS__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SC_SEND_DB_VPZ__SHIFT   = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SQ_NON_EVENT__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__TGID_ROLLOVER__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__VGT_FLUSH__SHIFT        = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__CONTEXT_SUSPEND__SHIFT  = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__DRAW_DONE__SHIFT        = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_NGG_PIPELINE__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_PIPELINE_NOT_USED__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__FLUSH_AND_INV_CB_PIXEL_DATA__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__OFFCHIP_HS_DEALLOC__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_CONTROL__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_DUMP__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PS_DONE__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_50__SHIFT      = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_DRAW__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FINISH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_MARKER__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_START__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_STOP__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_OUTPUT_TIMEOUT_CNTL__THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER__THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_TRIV_REJECTED_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BIN_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_COLUMNS_PER_ROW_THRESHOLD__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_ROWS_PER_PRIM_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_3__BATCH_HIST_NUM_PS_WAVE_BREAKS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_TIMEOUT_COUNTER__THRESHOLD__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_1__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_2__SHIFT       = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_3__SHIFT       = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_4__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_5__SHIFT       = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_6__SHIFT       = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_7__SHIFT       = 0x0000001c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_8__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_9__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_10__SHIFT      = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_11__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_12__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_13__SHIFT      = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_14__SHIFT      = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_15__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__BR_X_EXT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__BR_Y_EXT__SHIFT              = 0x00000002;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__TL_X_EXT__SHIFT              = 0x00000004;
constexpr unsigned int PA_SC_CLIPRECT_0_EXT__TL_Y_EXT__SHIFT              = 0x00000006;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__BR_X_EXT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__BR_Y_EXT__SHIFT              = 0x00000002;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__TL_X_EXT__SHIFT              = 0x00000004;
constexpr unsigned int PA_SC_CLIPRECT_1_EXT__TL_Y_EXT__SHIFT              = 0x00000006;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__BR_X_EXT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__BR_Y_EXT__SHIFT              = 0x00000002;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__TL_X_EXT__SHIFT              = 0x00000004;
constexpr unsigned int PA_SC_CLIPRECT_2_EXT__TL_Y_EXT__SHIFT              = 0x00000006;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__BR_X_EXT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__BR_Y_EXT__SHIFT              = 0x00000002;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__TL_X_EXT__SHIFT              = 0x00000004;
constexpr unsigned int PA_SC_CLIPRECT_3_EXT__TL_Y_EXT__SHIFT              = 0x00000006;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_RULE__CLIP_RULE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__CENTROID_SAMPLE_OVERRIDE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__COVERAGE_AA_MASK_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__INNER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__NULL_SQUAD_AA_MASK_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OUTER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_OVER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_UNDER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_SAMPLE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PBB_UNCERTAINTY_REGION_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__POSTZ_AA_MASK_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PREZ_AA_MASK_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MODE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MULT__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_PBB_MULT__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_ENABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_SAMPLE_SELECT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_EXTENT__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_0__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_1__SHIFT             = 0x00000001;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_BT__SHIFT                  = 0x0000001c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_LR__SHIFT                  = 0x0000000c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_RL__SHIFT                  = 0x00000012;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_TB__SHIFT                  = 0x00000018;
constexpr unsigned int PA_SC_EDGERULE__ER_POINT__SHIFT                    = 0x00000004;
constexpr unsigned int PA_SC_EDGERULE__ER_RECT__SHIFT                     = 0x00000008;
constexpr unsigned int PA_SC_EDGERULE__ER_TRI__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__BYPASS_PBB__SHIFT                 = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_COUNT_PIXELS__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_FORCE_SOP_ALL_EVENTS__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_INTF_CG__SHIFT            = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_NONBINNED_LIVE_PRIM_DG1_LS0_CL0_EOPKT_POKE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_ODC_ENHANCE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_BINNING_CLK_OPTIMIZATION__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_CLK_OPTIMIZATION__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_CLK_OPTIMIZATION__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_OPT__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_QUAD_PROC_FDCE_ENHANCE__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_BINNING__SHIFT         = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_DB_STILE_INTF_FINE_CLOCK_GATE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PROCESS_RESET_PBB__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_1__SHIFT = 0x0000001d;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SHADER_PROFILING_FOR_POWER__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE1__SHIFT                 = 0x00000006;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE2__SHIFT                 = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE3__SHIFT                 = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_1__ENABLE_DFSM_FLUSH_EVENT_TO_FLUSH_POPS_CAM__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE_1__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE_1__IOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_ENHANCE_1__OPTIMAL_BIN_SELECTION__SHIFT      = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE_1__PASS_VPZ_EVENT_TO_SPI__SHIFT      = 0x0000001e;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE__SHIFT    = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE_1__RESERVED_31__SHIFT                = 0x0000001f;
constexpr unsigned int PA_SC_ENHANCE_2__BREAK_WHEN_ONE_NULL_PRIM_BATCH__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPELINE_RESET__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPE_SWITCH__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_EXPOSED_GT_DETAIL_RATE_TILE_COV_ADJ__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_FULL_TILE_WAVE_BREAK__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_MAX_DEALLOC_FORCE_EOV_RESET_N_WAVES_COUNT__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PACKER_GRAD_FDCE_ENHANCE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_PRIM_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_QUAD_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_SPI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_FPOV_WAVE_BREAK__SHIFT     = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_LPOV_WAVE_BREAK__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PRIM_PAYLOAD__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_VPZ_INJECTION_BEFORE_NULL_PRIMS__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE_2__NULL_PRIM_BREAK_BATCH_LIMIT__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE_2__PBB_MAIN_CLK_REG_BUSY_WAKEUP__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_ENHANCE_2__PBB_TIMEOUT_THRESHOLD_MODE__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE_2__PROCESS_RESET_FORCE_STILE_MASK_TO_ZERO__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_16__SHIFT                = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_22__SHIFT                = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT                       = 0x0000001f;
constexpr unsigned int PA_SC_ENHANCE_3__APPLY_AA_MASK_AT_EXPOSED_RATE_FOR_VRS_COURSE_QUADS_WITH_CR__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_CP_CONTEXT_DONE_PERFCOUNT_SAMPLE_EN__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_EVENT_INCLUSION_IN_CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_FAST_NULL_PRIM_OPTIMIZATION__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_LIGHT_VOLUME_RENDERING_OPTIMIZATION__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PBB_EOP_OPTIMIZATION_WITH_SAME_CONTEXT_BATCHES__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PIXEL_WAIT_SYNC_COUNTERS__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_BCI_QUAD_NEW_PRIM_DATA_LOAD_OPTIMIZATION__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_FORCE_EOV_MAX_CLK_CNT_FOR_SPI_BACKPRESSURE_ONLY__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PKR_FORCE_EOV_MAX_REZ_CNT_FOR_SPI_BACKPRESSURE_ONLY__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_PWS_PRE_DEPTH_WAIT_SYNC_VPZ_INSERTION__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_RB_MASK_COPY_FOR_NONP2_SA_PAIR_HARVEST__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_CPG_PSINVOC_SEDC_ISOLATION_ACCUM__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_GL1X_REQ_FINE_CLOCK_GATE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SC_GL1X_SRC_FINE_CLOCK_GATE__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_SET_VPZ_DIRTY_EOPKT_LAST_PHASE_ONLY__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE_3__DISABLE_ZPRE_PASS_OPTIMIZATION__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE_3__DO_NOT_INCLUDE_OREO_WAVEID_IN_FORCE_EOV_MAX_CNT_DISABLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE0__SHIFT                 = 0x0000001c;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE1__SHIFT                 = 0x0000001d;
constexpr unsigned int PA_SC_ENHANCE_3__ECO_SPARE2__SHIFT                 = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_FIRST_PHASE_FILTER__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_LAST_PHASE_FILTER_FOR_PBB_BINNED_PRIMS__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_3__ENABLE_SINGLE_PA_EOPKT_LAST_PHASE_FILTER__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE_3__FORCE_PBB_WORKLOAD_MODE_TO_ZERO__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE_3__FORCE_USE_OF_SC_CENTROID_DATA__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_CNT_FORCE_EOV_AT_QS_EMPTY_ONLY__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_S0_FORCE_EOV_STALL__SHIFT     = 0x00000019;
constexpr unsigned int PA_SC_ENHANCE_3__PKR_S1_FORCE_EOV_STALL__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE_3__USE_PBB_PRIM_STORAGE_WHEN_STALLED__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_AA_MASK_FULL_FIX__SHIFT     = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_DUALGRAD_PERF_OPTIMIZATION__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OOO_NO_EOPG_SKEW_DESIRED_FIFO_IS_CURRENT_FIFO__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_PA_SC_GUIDANCE__SHIFT       = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SCISSOR_FIX__SHIFT          = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_DB_TILE_FIX__SHIFT       = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_PRIM__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_SUPERTILE__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_TILE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_VPZ_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOCATIONS__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOC_CENTROID__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_MULTICYCLE_BUBBLE_FREEZE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_POLY_MODE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_PA_SC_OUT_OF_ORDER__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE__IOO_DISABLE_SCAN_UNSELECTED_FIFOS_FOR_DUAL_GFX_RING_CHANGE__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOPG_SKEW_THRESHOLD_SWITCHING__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_ENHANCE__OOO_USE_ABSOLUTE_FIFO_COUNT_IN_THRESHOLD_SWITCHING__SHIFT = 0x0000001d;
constexpr unsigned int PA_SC_ENHANCE__SEND_UNLIT_STILES_TO_PACKER__SHIFT  = 0x00000006;
constexpr unsigned int PA_SC_FIFO_DEPTH_CNTL__DEPTH__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_BACKEND_PRIM_FIFO_SIZE__SHIFT  = 0x00000006;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_EARLYZ_TILE_FIFO_SIZE__SHIFT   = 0x00000015;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_FRONTEND_PRIM_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_HIZ_TILE_FIFO_SIZE__SHIFT      = 0x0000000f;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_CLK_CNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_REZ_CNT__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_HISZ_CONTROL__CONSERVATIVE_Z_EXPORT__SHIFT   = 0x00000003;
constexpr unsigned int PA_SC_HISZ_CONTROL__ROUND__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DEPTH_BOUNDS_HIER_DEPTH_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_FAST_PASS__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_SINGLE_STENCIL__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FAST_STENCIL_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FAST_Z_DISABLE__SHIFT  = 0x00000004;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_HIS_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__FORCE_HIZ_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HISZ_RENDER_OVERRIDE__PRESERVE_ZRANGE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_HIS_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_HIS_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_HIS_INFO__SURFACE_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_HIS_INFO__SW_MODE__SHIFT                     = 0x00000001;
constexpr unsigned int PA_SC_HIS_SIZE_XY__X_MAX__SHIFT                    = 0x00000000;
constexpr unsigned int PA_SC_HIS_SIZE_XY__Y_MAX__SHIFT                    = 0x00000010;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_CONTEXT_DONE_SYNC_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_DB_CONTEXT_DONE_SYNC_DISABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_EOP_SYNC_DISABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_EVICT_POINT__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_FLUSH_EVENT_MASK_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_FLUSH_NO_INV_DISABLE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_MAX_TAGS__SHIFT        = 0x00000013;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_NONSTALLING_FLUSH_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_OUTSTANDING_CONTEXT_FILTERING_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_PARTIAL_FLUSH_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_HIS_SURFACE_CNTL__HSC_PREFETCH_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_HIZ_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_HIZ_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_HIZ_INFO__DST_OUTSIDE_ZERO_TO_ONE__SHIFT     = 0x00000019;
constexpr unsigned int PA_SC_HIZ_INFO__FORMAT__SHIFT                      = 0x00000001;
constexpr unsigned int PA_SC_HIZ_INFO__SURFACE_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_HIZ_INFO__SW_MODE__SHIFT                     = 0x00000002;
constexpr unsigned int PA_SC_HIZ_SIZE_XY__X_MAX__SHIFT                    = 0x00000000;
constexpr unsigned int PA_SC_HIZ_SIZE_XY__Y_MAX__SHIFT                    = 0x00000010;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_CONTEXT_DONE_SYNC_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_DB_CONTEXT_DONE_SYNC_DISABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_EOP_SYNC_DISABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_EVICT_POINT__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_FLUSH_EVENT_MASK_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_FLUSH_NO_INV_DISABLE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_MAX_TAGS__SHIFT        = 0x00000013;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_NONSTALLING_FLUSH_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_OUTSTANDING_CONTEXT_FILTERING_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_PARTIAL_FLUSH_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_HIZ_SURFACE_CNTL__HZC_PREFETCH_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_COUNT__COUNT__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_H__X_COORD__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_V__Y_COORD__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_BCI_IF_FIFO_SIZE__SHIFT     = 0x00000012;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_QUAD_IF_FIFO_SIZE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_TILE_IF_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_SPI_IF_FIFO_SIZE__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__DX10_DIAMOND_TEST_ENA__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__EXPAND_LINE_WIDTH__SHIFT          = 0x00000009;
constexpr unsigned int PA_SC_LINE_CNTL__EXTRA_DX_DY_PRECISION__SHIFT      = 0x0000000d;
constexpr unsigned int PA_SC_LINE_CNTL__LAST_PIXEL__SHIFT                 = 0x0000000a;
constexpr unsigned int PA_SC_LINE_CNTL__PERPENDICULAR_ENDCAP_ENA__SHIFT   = 0x0000000b;
constexpr unsigned int PA_SC_LINE_STIPPLE_RESET__AUTO_RESET_CNTL__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_COUNT__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_PTR__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__LINE_PATTERN__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__PATTERN_BIT_ORDER__SHIFT       = 0x0000001c;
constexpr unsigned int PA_SC_LINE_STIPPLE__REPEAT_COUNT__SHIFT            = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_0__ALTERNATE_RBS_PER_TILE__SHIFT   = 0x00000005;
constexpr unsigned int PA_SC_MODE_CNTL_0__COARSE_TILE_STARTS_ON_EVEN_RB__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_MODE_CNTL_0__IMPLICIT_VPORT_SCISSOR_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_MODE_CNTL_0__LINE_STIPPLE_ENABLE__SHIFT      = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_0__MSAA_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_0__SEND_UNLIT_STILES_TO_PKR__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_0__VPORT_SCISSOR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__DISABLE_4X_TILE_PICKING__SHIFT  = 0x0000001f;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_CNTDWN_ENABLE__SHIFT  = 0x00000019;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_REZ_ENABLE__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_ENABLE__SHIFT   = 0x00000013;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE__SHIFT          = 0x00000014;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_DETAIL_MASK__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_HI_Z__SHIFT       = 0x0000000e;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_PRIM_DISCARD_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_SUPERTILE_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_PRIMITIVE_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_WATER_MARK__SHIFT  = 0x0000001c;
constexpr unsigned int PA_SC_MODE_CNTL_1__PS_ITER_SAMPLE__SHIFT           = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_1__SUPERTILE_WALK_ORDER_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_DISABLE__SHIFT       = 0x00000009;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_NO_SCISSOR__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_WALK_ORDER_ENABLE__SHIFT   = 0x00000008;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGN8_PRIM_FITS_ST__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGNMENT__SHIFT           = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_ENABLE__SHIFT        = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_SIZE__SHIFT          = 0x00000004;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_EXTENT__SHIFT          = 0x0000000b;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_OFFSET__SHIFT          = 0x0000000c;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_RECT_EXTENT__SHIFT          = 0x0000000d;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_FPOG_AND_DEALLOC_CONFLICT__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_MAX_ATTRIBUTES__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__DISABLE_MAX_DEALLOC__SHIFT    = 0x0000000d;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_ATTRIBUTES_IN_WAVE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_DEALLOCS_IN_WAVE__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_FPOVS_IN_WAVE__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_COUNT__COUNT__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_H__X_COORD__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_V__Y_COORD__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DEBUG_CONFLICT_QUAD__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_OREO_CONFLICT_QUAD__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_SC_DB_WAVE_IF_FGCG_EN__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__DISABLE_SC_SPI_WAVE_IF_FGCG_EN__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__SC_DB_WAVE_IF_FIFO_SIZE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__SC_SPI_WAVE_IF_FIFO_SIZE__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_PACKER_WAVE_ID_CNTL__WAVES_IN_FLIGHT_LIMIT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__OVERRIDE__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__PIPE_ID__SHIFT            = 0x00000001;
constexpr unsigned int PA_SC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PKR_WAVE_TABLE_CNTL__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_MAP__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL__SHIFT         = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL__SHIFT         = 0x00000004;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_MAP__SHIFT                = 0x00000008;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL2__SHIFT              = 0x0000000e;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL__SHIFT               = 0x0000000a;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_YSEL__SHIFT               = 0x0000000c;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR0__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR1__SHIFT            = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL2__SHIFT               = 0x00000004;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL__SHIFT                = 0x00000006;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_YSEL__SHIFT                = 0x00000007;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_MAP__SHIFT                 = 0x00000010;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_XSEL__SHIFT                = 0x00000012;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_YSEL__SHIFT                = 0x00000014;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_MAP__SHIFT                 = 0x00000018;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL__SHIFT                = 0x0000001a;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL__SHIFT                = 0x0000001c;
constexpr unsigned int PA_SC_SAMPLE_PROPERTIES__MAX_SAMPLE_DIST__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_SHADER_CONTROL__DISABLE_OREO_CONFLICT_QUAD__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_COLLISION_WAVEID__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_SHADER_CONTROL__PS_ITER_SAMPLE__SHIFT        = 0x00000008;
constexpr unsigned int PA_SC_SHADER_CONTROL__REALIGN_DQUADS_AFTER_N_WAVES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_SHADER_CONTROL__WAVE_BREAK_REGION_SIZE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__FORCE_TILE_STEERING_OVERRIDE_USE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__ONE_RB_MODE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__RB_SELECT__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SA_SELECT__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__ENABLE__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_PACKER_PER_SC__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SC__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SC__SHIFT        = 0x0000000c;
constexpr unsigned int PA_SC_TRAP_SCREEN_COUNT__COUNT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_H__X_COORD__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_V__Y_COORD__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_VPORT_0_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_0_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_0_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_0_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_1_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_1_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_1_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_1_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_2_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_2_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_2_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_2_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_3_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_3_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_3_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_3_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_4_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_4_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_4_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_4_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_5_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_5_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_5_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_5_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_6_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_6_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_6_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_6_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_7_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_7_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_7_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_7_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_8_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_8_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_8_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_8_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_9_BR__BR_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_9_BR__BR_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_9_TL__TL_X__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_9_TL__TL_Y__SHIFT                      = 0x00000010;
constexpr unsigned int PA_SC_VPORT_10_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_10_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_10_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_10_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_11_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_11_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_11_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_11_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_12_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_12_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_12_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_12_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_13_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_13_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_13_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_13_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_14_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_14_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_14_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_14_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_15_BR__BR_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_15_BR__BR_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_15_TL__TL_X__SHIFT                     = 0x00000000;
constexpr unsigned int PA_SC_VPORT_15_TL__TL_Y__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_ZMAX_0__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_1__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_2__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_3__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_4__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_5__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_6__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_7__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_8__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_9__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_10__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_11__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_12__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_13__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_14__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_15__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_0__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_1__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_2__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_3__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_4__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_5__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_6__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_7__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_8__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_9__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_10__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_11__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_12__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_13__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_14__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_15__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VRS_INFO__FEEDBACK_SW_MODE__SHIFT            = 0x00000003;
constexpr unsigned int PA_SC_VRS_INFO__RATE_SW_MODE__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__RATE_HINT_WRITE_BACK_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_FEEDBACK_RATE_OVERRIDE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_OVERRIDE_RATE_COMBINER_MODE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_RATE__SHIFT           = 0x00000004;
constexpr unsigned int PA_SC_VRS_OVERRIDE_CNTL__VRS_SURFACE_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_VRS_RATE_BASE_EXT__BASE_256B__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_BASE_EXT__TB_SYNC_SIM_ID__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_VRS_RATE_BASE__BASE_256B__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_SIZE_XY__X_MAX__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_FEEDBACK_SIZE_XY__Y_MAX__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_VRS_RATE_SIZE_XY__X_MAX__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_VRS_RATE_SIZE_XY__Y_MAX__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_CMASK_RATE_HINT_FORCE_ZERO_OVERRIDE__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_PS_ITER_RATE_COMBINER_PASSTHRU_OVERRIDE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_SSAA_DETAIL_TO_EXPOSED_RATE_CLAMPING__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__DISABLE_SSAA_VRS_RATE_NORMALIZATION__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTERFACE_RATE_8XAA__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTERFACE_RATE_16XAA__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_INTRINSIC_RATE_GT_4XAA__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_MASK_OPS_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_POPS__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_POST_DEPTH_IMPORT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_PRE_SHADER_DEPTH_COVERAGE_ENABLED__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_SHADER_KILL_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE_Z_OR_STENCIL__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__FORCE_SC_VRS_RATE_FINE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__USE_ONLY_VRS_RATE_FINE_CFG__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_0__SHIFT   = 0x00000015;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_1__SHIFT   = 0x00000016;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_2__SHIFT   = 0x00000017;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_3__SHIFT   = 0x00000018;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_4__SHIFT   = 0x00000019;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_5__SHIFT   = 0x0000001a;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_6__SHIFT   = 0x0000001b;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_7__SHIFT   = 0x0000001c;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_8__SHIFT   = 0x0000001d;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_9__SHIFT   = 0x0000001e;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL_1__VRS_ECO_SPARE_10__SHIFT  = 0x0000001f;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_CONTEXT_DONE_SYNC_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_EOP_SYNC_DISABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_EVICT_POINT__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_FLUSH_EVENT_MASK_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_FLUSH_NO_INV_DISABLE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_MAX_TAGS__SHIFT        = 0x00000013;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_NONSTALLING_FLUSH_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_PARTIAL_FLUSH_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRC_PREFETCH_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_VRS_SURFACE_CNTL__VRS_FEEDBACK_RATE_OVERRIDE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_X_OFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_Y_OFFSET__SHIFT        = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT               = 0x00000005;
constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT             = 0x00000008;
constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT                 = 0x00000001;
constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT                  = 0x00000010;
constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT                = 0x00000013;
constexpr unsigned int PA_SU_CNTL_STATUS__SU_BUSY__SHIFT                  = 0x0000001f;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_Y__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_LINE_CNTL__WIDTH__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__EXPAND_FULL_LENGTH__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__FRACTIONAL_ACCUM__SHIFT   = 0x00000003;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__LINE_STIPPLE_RESET__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_SCALE__LINE_STIPPLE_SCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_VALUE__LINE_STIPPLE_VALUE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_LINES__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_POINTS__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_RECTANGLES__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_TRIANGLES__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__USE_PROVOKING_ZW__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_POINT_MINMAX__MAX_SIZE__SHIFT                = 0x00000010;
constexpr unsigned int PA_SU_POINT_MINMAX__MIN_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__HEIGHT__SHIFT                    = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__WIDTH__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_OFFSET__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_SCALE__SCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_CLAMP__CLAMP__SHIFT              = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_DB_IS_FLOAT_FMT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_NEG_NUM_DB_BITS__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_OFFSET__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_SCALE__SCALE__SHIFT        = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_EXPAND_ENA__SHIFT     = 0x00000005;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_EXPAND_ENA__SHIFT    = 0x00000006;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__PRIM_EXPAND_CONSTANT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_EXPAND_ENA__SHIFT = 0x00000007;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_EXPAND_ENA__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__XMAX_RIGHT_EXCLUSION__SHIFT = 0x0000001e;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__YMAX_BOTTOM_EXCLUSION__SHIFT = 0x0000001f;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_BACK__SHIFT               = 0x00000001;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_FRONT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__FACE__SHIFT                    = 0x00000002;
constexpr unsigned int PA_SU_SC_MODE_CNTL__MULTI_PRIM_IB_ENA__SHIFT       = 0x00000015;
constexpr unsigned int PA_SU_SC_MODE_CNTL__NEW_QUAD_DECOMPOSITION__SHIFT  = 0x00000017;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PERSP_CORR_DIS__SHIFT          = 0x00000014;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_BACK_PTYPE__SHIFT     = 0x00000008;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_FRONT_PTYPE__SHIFT    = 0x00000005;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_MODE__SHIFT               = 0x00000003;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_BACK_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_FRONT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_PARA_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PROVOKING_VTX_LAST__SHIFT      = 0x00000013;
constexpr unsigned int PA_SU_SC_MODE_CNTL__RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF__SHIFT = 0x00000016;
constexpr unsigned int PA_SU_SC_MODE_CNTL__VTX_WINDOW_OFFSET_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SC_1XMSAA_COMPATIBLE_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SMALL_PRIM_FILTER_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_VTX_CNTL__PIX_CENTER__SHIFT                  = 0x00000000;
constexpr unsigned int PA_SU_VTX_CNTL__QUANT_MODE__SHIFT                  = 0x00000003;
constexpr unsigned int PA_SU_VTX_CNTL__ROUND_MODE__SHIFT                  = 0x00000001;
constexpr unsigned int PC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int PC_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int PC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int PerfMonCtl1__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl1__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl1__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl1__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl1__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl1__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl1__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl1__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl2__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl2__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl2__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl2__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl2__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl2__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl2__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl2__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl3__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl3__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl3__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl3__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl3__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl3__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl3__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl3__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl4__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl4__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl4__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl4__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl4__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl4__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl4__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl4__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl5__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl5__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl5__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl5__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl5__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl5__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl5__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl5__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl6__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl6__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl6__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl6__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl6__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl6__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl6__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl6__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl7__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl7__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl7__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl7__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl7__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl7__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl7__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl7__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl8__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl8__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl8__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl8__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl8__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl8__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl8__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl8__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl9__BankSel__SHIFT                        = 0x00000010;
constexpr unsigned int PerfMonCtl9__Enable__SHIFT                         = 0x0000001f;
constexpr unsigned int PerfMonCtl9__EventSelect__SHIFT                    = 0x00000000;
constexpr unsigned int PerfMonCtl9__PriorityMask__SHIFT                   = 0x0000000a;
constexpr unsigned int PerfMonCtl9__RdWrMask__SHIFT                       = 0x00000008;
constexpr unsigned int PerfMonCtl9__ReqSizeMask__SHIFT                    = 0x0000000e;
constexpr unsigned int PerfMonCtl9__SubChanMask__SHIFT                    = 0x0000001d;
constexpr unsigned int PerfMonCtl9__VCSel__SHIFT                          = 0x00000018;
constexpr unsigned int PerfMonCtl10__BankSel__SHIFT                       = 0x00000010;
constexpr unsigned int PerfMonCtl10__Enable__SHIFT                        = 0x0000001f;
constexpr unsigned int PerfMonCtl10__EventSelect__SHIFT                   = 0x00000000;
constexpr unsigned int PerfMonCtl10__PriorityMask__SHIFT                  = 0x0000000a;
constexpr unsigned int PerfMonCtl10__RdWrMask__SHIFT                      = 0x00000008;
constexpr unsigned int PerfMonCtl10__ReqSizeMask__SHIFT                   = 0x0000000e;
constexpr unsigned int PerfMonCtl10__SubChanMask__SHIFT                   = 0x0000001d;
constexpr unsigned int PerfMonCtl10__VCSel__SHIFT                         = 0x00000018;
constexpr unsigned int PerfMonCtl11__BankSel__SHIFT                       = 0x00000010;
constexpr unsigned int PerfMonCtl11__Enable__SHIFT                        = 0x0000001f;
constexpr unsigned int PerfMonCtl11__EventSelect__SHIFT                   = 0x00000000;
constexpr unsigned int PerfMonCtl11__PriorityMask__SHIFT                  = 0x0000000a;
constexpr unsigned int PerfMonCtl11__RdWrMask__SHIFT                      = 0x00000008;
constexpr unsigned int PerfMonCtl11__ReqSizeMask__SHIFT                   = 0x0000000e;
constexpr unsigned int PerfMonCtl11__SubChanMask__SHIFT                   = 0x0000001d;
constexpr unsigned int PerfMonCtl11__VCSel__SHIFT                         = 0x00000018;
constexpr unsigned int PerfMonCtl12__BankSel__SHIFT                       = 0x00000010;
constexpr unsigned int PerfMonCtl12__Enable__SHIFT                        = 0x0000001f;
constexpr unsigned int PerfMonCtl12__EventSelect__SHIFT                   = 0x00000000;
constexpr unsigned int PerfMonCtl12__PriorityMask__SHIFT                  = 0x0000000a;
constexpr unsigned int PerfMonCtl12__RdWrMask__SHIFT                      = 0x00000008;
constexpr unsigned int PerfMonCtl12__ReqSizeMask__SHIFT                   = 0x0000000e;
constexpr unsigned int PerfMonCtl12__SubChanMask__SHIFT                   = 0x0000001d;
constexpr unsigned int PerfMonCtl12__VCSel__SHIFT                         = 0x00000018;
constexpr unsigned int PerfMonCtlClk__ClkGate__SHIFT                      = 0x00000016;
constexpr unsigned int PerfMonCtlClk__CtrClkEn__SHIFT                     = 0x0000001f;
constexpr unsigned int PerfMonCtlClk__GlblMonEn__SHIFT                    = 0x00000019;
constexpr unsigned int PerfMonCtlClk__GlblResetMsk__SHIFT                 = 0x00000000;
constexpr unsigned int PerfMonCtlClk__GlblReset__SHIFT                    = 0x00000018;
constexpr unsigned int PerfMonCtlClk__NumCounters__SHIFT                  = 0x0000001a;
constexpr unsigned int PerfMonCtlClk__SpmEn__SHIFT                        = 0x00000017;
constexpr unsigned int PerfMonCtr1_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr1_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr1_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr1_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr1_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr2_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr2_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr2_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr2_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr2_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr3_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr3_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr3_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr3_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr3_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr4_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr4_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr4_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr4_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr4_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr5_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr5_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr5_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr5_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr5_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr6_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr6_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr6_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr6_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr6_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr7_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr7_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr7_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr7_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr7_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr8_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr8_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr8_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr8_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr8_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr9_Hi__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr9_Hi__Overflow__SHIFT                    = 0x00000010;
constexpr unsigned int PerfMonCtr9_Hi__ThreshCntEn__SHIFT                 = 0x00000012;
constexpr unsigned int PerfMonCtr9_Hi__ThreshCnt__SHIFT                   = 0x00000014;
constexpr unsigned int PerfMonCtr9_Lo__Data__SHIFT                        = 0x00000000;
constexpr unsigned int PerfMonCtr10_Hi__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtr10_Hi__Overflow__SHIFT                   = 0x00000010;
constexpr unsigned int PerfMonCtr10_Hi__ThreshCntEn__SHIFT                = 0x00000012;
constexpr unsigned int PerfMonCtr10_Hi__ThreshCnt__SHIFT                  = 0x00000014;
constexpr unsigned int PerfMonCtr10_Lo__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtr11_Hi__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtr11_Hi__Overflow__SHIFT                   = 0x00000010;
constexpr unsigned int PerfMonCtr11_Hi__ThreshCntEn__SHIFT                = 0x00000012;
constexpr unsigned int PerfMonCtr11_Hi__ThreshCnt__SHIFT                  = 0x00000014;
constexpr unsigned int PerfMonCtr11_Lo__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtr12_Hi__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtr12_Hi__Overflow__SHIFT                   = 0x00000010;
constexpr unsigned int PerfMonCtr12_Hi__ThreshCntEn__SHIFT                = 0x00000012;
constexpr unsigned int PerfMonCtr12_Hi__ThreshCnt__SHIFT                  = 0x00000014;
constexpr unsigned int PerfMonCtr12_Lo__Data__SHIFT                       = 0x00000000;
constexpr unsigned int PerfMonCtrClk_Hi__Data__SHIFT                      = 0x00000000;
constexpr unsigned int PerfMonCtrClk_Hi__Overflow__SHIFT                  = 0x00000010;
constexpr unsigned int PerfMonCtrClk_Lo__Data__SHIFT                      = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT     = 0x0000000a;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_STATE__SHIFT             = 0x00000000;
constexpr unsigned int RLC_PERFMON_CNTL__RESERVED_9_3__SHIFT              = 0x00000003;
constexpr unsigned int RLC_PERFMON_CNTL__RESERVED__SHIFT                  = 0x0000000b;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__global_offset__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__spmwithaccum_global_offset__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET__spmwithaccum_se_offset__SHIFT = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__ADDR__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__DATA__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobePerfmonSampleWires__SHIFT = 0x0000000a;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmAccum__SHIFT        = 0x00000002;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmSwaAccum__SHIFT     = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetPerfMonitors__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetSpmBlock__SHIFT     = 0x00000003;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartAccumulation__SHIFT = 0x00000001;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm__SHIFT          = 0x00000004;
constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSwa__SHIFT          = 0x00000009;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS__spp_addr_region__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS__swa_addr_region__SHIFT = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__ADDR__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_DATA__DATA__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__DataRamWrCount__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn__SHIFT             = 0x00000005;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable__SHIFT = 0x00000003;
constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn__SHIFT               = 0x00000007;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableAccum__SHIFT             = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableSpmWithAccumMode__SHIFT  = 0x00000001;
constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableSPPMode__SHIFT           = 0x00000002;
constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride__SHIFT    = 0x00000009;
constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_SwaLoadOverride__SHIFT = 0x0000000a;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_4__SHIFT              = 0x00000004;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_20_19__SHIFT          = 0x00000013;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_22_21__SHIFT          = 0x00000015;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_24_23__SHIFT          = 0x00000017;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_26_25__SHIFT          = 0x00000019;
constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_31_27__SHIFT          = 0x0000001b;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride__SHIFT        = 0x0000000b;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_SwaLoadOverride__SHIFT     = 0x0000000c;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_LoadOverride__SHIFT        = 0x0000000d;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_SwaLoadOverride__SHIFT     = 0x0000000e;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE2_LoadOverride__SHIFT        = 0x0000000f;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE2_SwaLoadOverride__SHIFT     = 0x00000010;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE3_LoadOverride__SHIFT        = 0x00000011;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SE3_SwaLoadOverride__SHIFT     = 0x00000012;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SwaAutoAccumEn__SHIFT          = 0x00000006;
constexpr unsigned int RLC_SPM_ACCUM_MODE__SwaAutoSpmEn__SHIFT            = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__SamplesRequested__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumArmed__SHIFT            = 0x0000000b;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumDone__SHIFT             = 0x00000008;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumOverflow__SHIFT         = 0x0000000a;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllFifosEmpty__SHIFT         = 0x0000000e;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllSegsDone__SHIFT           = 0x00000014;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__FinalSequenceInProgress__SHIFT = 0x0000000d;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__FSMIsIdle__SHIFT             = 0x0000000f;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__MultiSampleAborted__SHIFT    = 0x00000017;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__NumbSamplesCompleted__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__RearmSppPending__SHIFT       = 0x00000016;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__RearmSwaPending__SHIFT       = 0x00000015;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SequenceInProgress__SHIFT    = 0x0000000c;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SpmDone__SHIFT               = 0x00000009;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumArmed__SHIFT         = 0x00000013;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumDone__SHIFT          = 0x00000010;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaAccumOverflow__SHIFT      = 0x00000012;
constexpr unsigned int RLC_SPM_ACCUM_STATUS__SwaSpmDone__SHIFT            = 0x00000011;
constexpr unsigned int RLC_SPM_ACCUM_SWA_DATARAM_ADDR__ADDR__SHIFT        = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_SWA_DATARAM_DATA__DATA__SHIFT        = 0x00000000;
constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__Threshold__SHIFT          = 0x00000000;
constexpr unsigned int RLC_SPM_GFXCLOCK_HIGHCOUNT__GFXCLOCK_HIGHCOUNT__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_GFXCLOCK_LOWCOUNT__GFXCLOCK_LOWCOUNT__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_BLK_EN_MASK_IND_ADDR__ADDR__SHIFT   = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_BLK_EN_MASK_IND_DATA__DATA__SHIFT   = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_DELAY_IND_ADDR__ADDR__SHIFT         = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_DELAY_IND_DATA__DATA__SHIFT         = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__ADDR__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__SEL0__SHIFT            = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__SEL1__SHIFT            = 0x00000010;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_0__HI__SHIFT              = 0x00000010;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_0__LO__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_1__HI__SHIFT              = 0x00000010;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_1__LO__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_2__HI__SHIFT              = 0x00000010;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_2__LO__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_3__HI__SHIFT              = 0x00000010;
constexpr unsigned int RLC_SPM_GLOBAL_USER_DATA_3__LO__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_GTS_TRIGGER_VALUE_HI__VALUE_HI__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_GTS_TRIGGER_VALUE_LO__VALUE_LO__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_INT_CNTL__RESERVED__SHIFT                  = 0x00000001;
constexpr unsigned int RLC_SPM_INT_CNTL__RLC_SPM_INT_CNTL__SHIFT          = 0x00000000;
constexpr unsigned int RLC_SPM_INT_INFO_1__INTERRUPT_INFO_1__SHIFT        = 0x00000000;
constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_ID__SHIFT            = 0x00000010;
constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_INFO_2__SHIFT        = 0x00000000;
constexpr unsigned int RLC_SPM_INT_INFO_2__RESERVED__SHIFT                = 0x00000018;
constexpr unsigned int RLC_SPM_INT_STATUS__RESERVED__SHIFT                = 0x00000001;
constexpr unsigned int RLC_SPM_INT_STATUS__RLC_SPM_INT_STATUS__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED__SHIFT                   = 0x00000010;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_COMP_OVER__SHIFT          = 0x0000000d;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_COMP__SHIFT               = 0x0000000b;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED__SHIFT                = 0x00000007;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_NOFILL__SHIFT             = 0x0000000f;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR__SHIFT          = 0x00000006;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_RO__SHIFT                 = 0x0000000e;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_SDR__SHIFT                = 0x00000004;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_TEMPORAL__SHIFT           = 0x00000008;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VMID__SHIFT               = 0x00000000;
constexpr unsigned int RLC_SPM_MODE__MODE__SHIFT                          = 0x00000000;
constexpr unsigned int RLC_SPM_PAUSE__PAUSED__SHIFT                       = 0x00000001;
constexpr unsigned int RLC_SPM_PAUSE__PAUSE__SHIFT                        = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_RING_MODE__SHIFT     = 0x0000000c;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_START_MODE__SHIFT = 0x0000000e;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_TYPE__SHIFT = 0x0000000f;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RESERVED__SHIFT      = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RING_BASE_HI__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_LO__RING_BASE_LO__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_SIZE__RING_BASE_SIZE__SHIFT   = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__GLOBAL_NUM_SEGMENT__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE_NUM_SEGMENT__SHIFT = 0x00000018;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__TOTAL_NUM_SEGMENT__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_RING_RDPTR__PERFMON_RING_RDPTR__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_RING_WRPTR__PERFMON_RING_WRPTR__SHIFT      = 0x00000005;
constexpr unsigned int RLC_SPM_RING_WRPTR__RESERVED__SHIFT                = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE0_ACK__SHIFT               = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE1_ACK__SHIFT               = 0x00000001;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE2_ACK__SHIFT               = 0x00000002;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE3_ACK__SHIFT               = 0x00000003;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE4_ACK__SHIFT               = 0x00000004;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE5_ACK__SHIFT               = 0x00000005;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE6_ACK__SHIFT               = 0x00000006;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SE7_ACK__SHIFT               = 0x00000007;
constexpr unsigned int RLC_SPM_RSPM_CMD_ACK__SPM_ACK__SHIFT               = 0x00000008;
constexpr unsigned int RLC_SPM_RSPM_CMD__CMD__SHIFT                       = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_REQ_DATA__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_REQ_OP__OP__SHIFT                     = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_RET_DATA__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_RET_OP__OP__SHIFT                     = 0x00000000;
constexpr unsigned int RLC_SPM_RSPM_RET_OP__VALID__SHIFT                  = 0x00000008;
constexpr unsigned int RLC_SPM_SAMPLE_CNT__COUNT__SHIFT                   = 0x00000000;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__RESERVED__SHIFT         = 0x00000008;
constexpr unsigned int RLC_SPM_SE_BLK_EN_MASK_IND_ADDR__ADDR__SHIFT       = 0x00000000;
constexpr unsigned int RLC_SPM_SE_BLK_EN_MASK_IND_DATA__DATA__SHIFT       = 0x00000000;
constexpr unsigned int RLC_SPM_SE_DELAY_IND_ADDR__ADDR__SHIFT             = 0x00000000;
constexpr unsigned int RLC_SPM_SE_DELAY_IND_DATA__DATA__SHIFT             = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__ADDR__SHIFT                = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__SEL0__SHIFT                = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__SEL1__SHIFT                = 0x00000010;
constexpr unsigned int RLC_SPM_SE_RSPM_REQ_DATA__DATA__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_SE_RSPM_REQ_OP__OP__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_DATA__DATA__SHIFT              = 0x00000000;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_OP__OP__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SE_RSPM_RET_OP__VALID__SHIFT               = 0x00000008;
constexpr unsigned int RLC_SPM_SE_USER_DATA_0__HI__SHIFT                  = 0x00000010;
constexpr unsigned int RLC_SPM_SE_USER_DATA_0__LO__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_1__HI__SHIFT                  = 0x00000010;
constexpr unsigned int RLC_SPM_SE_USER_DATA_1__LO__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_2__HI__SHIFT                  = 0x00000010;
constexpr unsigned int RLC_SPM_SE_USER_DATA_2__LO__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SE_USER_DATA_3__HI__SHIFT                  = 0x00000010;
constexpr unsigned int RLC_SPM_SE_USER_DATA_3__LO__SHIFT                  = 0x00000000;
constexpr unsigned int RLC_SPM_SPARE__SPARE__SHIFT                        = 0x00000000;
constexpr unsigned int RLC_SPM_STATUS__ACCUM_BUSY__SHIFT                  = 0x0000000f;
constexpr unsigned int RLC_SPM_STATUS__CTL_BUSY__SHIFT                    = 0x00000000;
constexpr unsigned int RLC_SPM_STATUS__CTL_REQ_STATE__SHIFT               = 0x00000018;
constexpr unsigned int RLC_SPM_STATUS__CTL_RET_STATE__SHIFT               = 0x0000001a;
constexpr unsigned int RLC_SPM_STATUS__FSM_MASTER_STATE__SHIFT            = 0x00000010;
constexpr unsigned int RLC_SPM_STATUS__FSM_MEMORY_STATE__SHIFT            = 0x00000014;
constexpr unsigned int RLC_SPM_STATUS__RSPM_REG_BUSY__SHIFT               = 0x00000001;
constexpr unsigned int RLC_SPM_STATUS__SE_RSPM_IO_BUSY__SHIFT             = 0x00000004;
constexpr unsigned int RLC_SPM_STATUS__SPM_RSPM_BUSY__SHIFT               = 0x00000002;
constexpr unsigned int RLC_SPM_STATUS__SPM_RSPM_IO_BUSY__SHIFT            = 0x00000003;
constexpr unsigned int RLC_SPM_THREAD_TRACE_CTRL__THREAD_TRACE_INT_EN__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__BYPASS__SHIFT                  = 0x00000019;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__DROP_MODE__SHIFT               = 0x00000018;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SNOOP__SHIFT             = 0x0000001c;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT         = 0x0000001b;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__INVALIDATE__SHIFT              = 0x0000001a;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED_23_20__SHIFT          = 0x00000014;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED__SHIFT                = 0x0000001d;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT    = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorAddr_MSB__SHIFT = 0x00000006;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorVmid__SHIFT = 0x00000002;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqError__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_2__Translated_ReqErrorAddr_LSB__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__EVENT_BASED_PERF_EN_SEL__SHIFT = 0x00000002;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_CNTR_SPM_SEL__SHIFT    = 0x0000001a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_BURST_LENGTH_THRESHOLD__SHIFT = 0x00000013;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_CID__SHIFT     = 0x0000000a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_VMID__SHIFT    = 0x0000000e;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK0__SHIFT = 0x00000006;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_SOFT_RESET__SHIFT      = 0x00000019;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TC_PERF_EN_SEL__SHIFT       = 0x00000004;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TRANS_BASED_PERF_EN_SEL__SHIFT = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT           = 0x00000010;
constexpr unsigned int RPB_PERFCOUNTER_HI__COUNTER_HI__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_LO__COUNTER_LO__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT        = 0x00000019;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT       = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT    = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT     = 0x00000010;
constexpr unsigned int RPB_PERF_COUNTER_CNTL__PERF_COUNTER_SELECT__SHIFT  = 0x00000000;
constexpr unsigned int SCRATCH_REG0__SCRATCH_REG0__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG1__SCRATCH_REG1__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG2__SCRATCH_REG2__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG3__SCRATCH_REG3__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG4__SCRATCH_REG4__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG5__SCRATCH_REG5__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG6__SCRATCH_REG6__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REG7__SCRATCH_REG7__SHIFT                  = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER0__ScratchPad0__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER1__ScratchPad1__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER2__ScratchPad2__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER3__ScratchPad3__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER4__ScratchPad4__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER5__ScratchPad5__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER6__ScratchPad6__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REGISTER7__ScratchPad7__SHIFT              = 0x00000000;
constexpr unsigned int SCRATCH_REG_ATOMIC__ID__SHIFT                      = 0x00000018;
constexpr unsigned int SCRATCH_REG_ATOMIC__IMMED__SHIFT                   = 0x00000000;
constexpr unsigned int SCRATCH_REG_ATOMIC__OP__SHIFT                      = 0x0000001c;
constexpr unsigned int SCRATCH_REG_ATOMIC__reserved27__SHIFT              = 0x0000001b;
constexpr unsigned int SCRATCH_REG_ATOMIC__reserved31__SHIFT              = 0x0000001f;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__ID__SHIFT              = 0x00000018;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__IMMED_COMPARE__SHIFT   = 0x00000000;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__IMMED_REPLACE__SHIFT   = 0x0000000c;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__OP__SHIFT              = 0x0000001c;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__reserved27__SHIFT      = 0x0000001b;
constexpr unsigned int SCRATCH_REG_CMPSWAP_ATOMIC__reserved31__SHIFT      = 0x0000001f;
constexpr unsigned int SC_MEM_SCOPE__HIS_SCOPE__SHIFT                     = 0x00000006;
constexpr unsigned int SC_MEM_SCOPE__HIZ_SCOPE__SHIFT                     = 0x00000004;
constexpr unsigned int SC_MEM_SCOPE__VRS_FEEDBACK_SCOPE__SHIFT            = 0x00000002;
constexpr unsigned int SC_MEM_SCOPE__VRS_RATE_SCOPE__SHIFT                = 0x00000000;
constexpr unsigned int SC_MEM_SPEC_READ__HIS_SPECULATIVE_READ__SHIFT      = 0x00000004;
constexpr unsigned int SC_MEM_SPEC_READ__HIZ_SPECULATIVE_READ__SHIFT      = 0x00000002;
constexpr unsigned int SC_MEM_SPEC_READ__VRS_SPECULATIVE_READ__SHIFT      = 0x00000000;
constexpr unsigned int SC_MEM_TEMPORAL__HIS_TEMPORAL_READ__SHIFT          = 0x0000000c;
constexpr unsigned int SC_MEM_TEMPORAL__HIS_TEMPORAL_WRITE__SHIFT         = 0x0000000f;
constexpr unsigned int SC_MEM_TEMPORAL__HIZ_TEMPORAL_READ__SHIFT          = 0x00000006;
constexpr unsigned int SC_MEM_TEMPORAL__HIZ_TEMPORAL_WRITE__SHIFT         = 0x00000009;
constexpr unsigned int SC_MEM_TEMPORAL__VRS_TEMPORAL_READ__SHIFT          = 0x00000000;
constexpr unsigned int SC_MEM_TEMPORAL__VRS_TEMPORAL_WRITE__SHIFT         = 0x00000003;
constexpr unsigned int SDMA0_PERFCNT_MISC_CNTL__CMD_OP__SHIFT             = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_HI__COUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_LO__COUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int SDMA0_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_MISC_CNTL__CMD_OP__SHIFT             = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER0_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER1_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_HI__COUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_LO__COUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int SDMA1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_COL_WT__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_GDS_WT__SHIFT              = 0x00000008;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_POS_WT__SHIFT              = 0x00000004;
constexpr unsigned int SPI_ARB_CYCLES_0__TS0_DURATION__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_0__TS1_DURATION__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_CYCLES_1__TS2_DURATION__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_1__TS3_DURATION__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS0__SHIFT            = 0x00000000;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS1__SHIFT            = 0x00000003;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS2__SHIFT            = 0x00000006;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS3__SHIFT            = 0x00000009;
constexpr unsigned int SPI_ARB_PRIORITY__TS0_DUR_MULT__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_ARB_PRIORITY__TS1_DUR_MULT__SHIFT              = 0x0000000e;
constexpr unsigned int SPI_ARB_PRIORITY__TS2_DUR_MULT__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__TS3_DUR_MULT__SHIFT              = 0x00000012;
constexpr unsigned int SPI_ATTRIBUTE_RING_BASE__BASE__SHIFT               = 0x00000000;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__BIG_PAGE__SHIFT           = 0x00000010;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__GL1_PERF_COUNTER_DISABLE__SHIFT = 0x00000016;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__L1_POLICY__SHIFT          = 0x00000011;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__L2_POLICY__SHIFT          = 0x00000013;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__LLC_NOALLOC__SHIFT        = 0x00000015;
constexpr unsigned int SPI_ATTRIBUTE_RING_SIZE__MEM_SIZE__SHIFT           = 0x00000000;
constexpr unsigned int SPI_BARYC_CNTL__FRONT_FACE_ALL_BITS__SHIFT         = 0x00000018;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTER_CNTL__SHIFT          = 0x00000008;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTROID_CNTL__SHIFT        = 0x0000000c;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTER_CNTL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTROID_CNTL__SHIFT         = 0x00000004;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_LOCATION__SHIFT          = 0x00000010;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_ULC__SHIFT               = 0x00000014;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__CENTER_SSAA_MODE__SHIFT       = 0x00000000;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__CENTROID_SSAA_MODE__SHIFT     = 0x00000001;
constexpr unsigned int SPI_BARYC_SSAA_CNTL__COVERED_CENTROID_IS_CENTER__SHIFT = 0x00000002;
constexpr unsigned int SPI_COMPUTE_QUEUE_RESET__RESET__SHIFT              = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE0_SAVE_BUSY__SHIFT = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE1_SAVE_BUSY__SHIFT = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE2_SAVE_BUSY__SHIFT = 0x00000002;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE3_SAVE_BUSY__SHIFT = 0x00000003;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE4_SAVE_BUSY__SHIFT = 0x00000004;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE5_SAVE_BUSY__SHIFT = 0x00000005;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE6_SAVE_BUSY__SHIFT = 0x00000006;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE0_QUEUE7_SAVE_BUSY__SHIFT = 0x00000007;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE0_SAVE_BUSY__SHIFT = 0x00000008;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE1_SAVE_BUSY__SHIFT = 0x00000009;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE2_SAVE_BUSY__SHIFT = 0x0000000a;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE3_SAVE_BUSY__SHIFT = 0x0000000b;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE4_SAVE_BUSY__SHIFT = 0x0000000c;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE5_SAVE_BUSY__SHIFT = 0x0000000d;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE6_SAVE_BUSY__SHIFT = 0x0000000e;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE1_QUEUE7_SAVE_BUSY__SHIFT = 0x0000000f;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE0_SAVE_BUSY__SHIFT = 0x00000010;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE1_SAVE_BUSY__SHIFT = 0x00000011;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE2_SAVE_BUSY__SHIFT = 0x00000012;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE3_SAVE_BUSY__SHIFT = 0x00000013;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE4_SAVE_BUSY__SHIFT = 0x00000014;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE5_SAVE_BUSY__SHIFT = 0x00000015;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE6_SAVE_BUSY__SHIFT = 0x00000016;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE2_QUEUE7_SAVE_BUSY__SHIFT = 0x00000017;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE0_SAVE_BUSY__SHIFT = 0x00000018;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE1_SAVE_BUSY__SHIFT = 0x00000019;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE2_SAVE_BUSY__SHIFT = 0x0000001a;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE3_SAVE_BUSY__SHIFT = 0x0000001b;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE4_SAVE_BUSY__SHIFT = 0x0000001c;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE5_SAVE_BUSY__SHIFT = 0x0000001d;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE6_SAVE_BUSY__SHIFT = 0x0000001e;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE_STATUS__PIPE3_QUEUE7_SAVE_BUSY__SHIFT = 0x0000001f;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__DONE_INTERRUPT_EN__SHIFT  = 0x00000002;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__INITIATE__SHIFT           = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__SAVE_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_COMPUTE_WGS_CONTROL__WGS_ENABLE__SHIFT         = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSC_PWR_SAVE_DISABLE__SHIFT     = 0x0000000e;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSG_PWR_SAVE_DISABLE__SHIFT     = 0x0000000f;
constexpr unsigned int SPI_CONFIG_CNTL_1__EN_USER_ACCUM__SHIFT            = 0x00000015;
constexpr unsigned int SPI_CONFIG_CNTL_1__INTERP_ONE_PRIM_PER_ROW__SHIFT  = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_CNT__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_CONFIG_CNTL_1__MAX_VTX_SYNC_CNT__SHIFT         = 0x00000010;
constexpr unsigned int SPI_CONFIG_CNTL_1__OREO_EXPALLOC_STALL__SHIFT      = 0x00000009;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE__SHIFT          = 0x00000005;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_STRICT__SHIFT          = 0x00000007;
constexpr unsigned int SPI_CONFIG_CNTL_1__PS_GROUP_TIMEOUT_MODE__SHIFT    = 0x00000008;
constexpr unsigned int SPI_CONFIG_CNTL_1__PS_GROUP_TIMEOUT__SHIFT         = 0x00000017;
constexpr unsigned int SPI_CONFIG_CNTL_1__SA_SCREEN_MAP__SHIFT            = 0x00000016;
constexpr unsigned int SPI_CONFIG_CNTL_1__VTX_DONE_DELAY__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD__SHIFT = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD__SHIFT = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL_2__CSC_HALT_ACK_DELAY__SHIFT       = 0x0000000c;
constexpr unsigned int SPI_CONFIG_CNTL_2__PC_CONTEXT_DONE_SYNC_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_CSG_WAIT_DISABLE__SHIFT     = 0x00000008;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_GS_WAIT_DISABLE__SHIFT      = 0x0000000a;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_HS_WAIT_DISABLE__SHIFT      = 0x00000009;
constexpr unsigned int SPI_CONFIG_CNTL_2__PWS_PS_WAIT_DISABLE__SHIFT      = 0x0000000b;
constexpr unsigned int SPI_CONFIG_CNTL_2__SPP_TIMEOUT_CTR__SHIFT          = 0x00000011;
constexpr unsigned int SPI_CONFIG_CNTL__ALLOC_ARB_LRU_ENA__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_BOP_EVENTS__SHIFT      = 0x00000019;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_TOP_EVENTS__SHIFT      = 0x00000018;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_ARB_LRU_ENA__SHIFT            = 0x0000001d;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_PRIORITY_ORDER__SHIFT         = 0x00000015;
constexpr unsigned int SPI_CONFIG_CNTL__GPR_WRITE_PRIORITY__SHIFT         = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL__PS_PKR_PRIORITY_CNTL__SHIFT       = 0x0000001e;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS0__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS0__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS1__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS1__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS2__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS2__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS3__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS3__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS4__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS4__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS5__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS5__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS6__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS6__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS7__CU_EN_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_CS7__CU_EN_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX0__GS_CU_EN__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX0__HS_CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX1__CSG_CU_EN__SHIFT          = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_GFX1__PS_CU_EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D0__GS_CU_EN__SHIFT          = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D0__HS_CU_EN__SHIFT          = 0x00000000;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D1__CSG_CU_EN__SHIFT         = 0x00000010;
constexpr unsigned int SPI_CONFIG_CU_MASK_HP3D1__PS_CU_EN__SHIFT          = 0x00000000;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR2_OFFSET__SHIFT            = 0x00000004;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR3_OFFSET__SHIFT            = 0x00000008;
constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR_OFFSET__SHIFT             = 0x00000000;
constexpr unsigned int SPI_CREST_MODE__ENABLE_CREST__SHIFT                = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_STATUS__ACTIVE__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CS_CRAWLER_CONFIG__CSC_DEPTH__SHIFT            = 0x00000006;
constexpr unsigned int SPI_CS_CRAWLER_CONFIG__CSG_DEPTH__SHIFT            = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY__SHIFT      = 0x00000003;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
constexpr unsigned int SPI_EDC_CNT__SPI_SR_MEM_SED_COUNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__DOWNSTEP__SHIFT             = 0x00000009;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__ENABLE__SHIFT               = 0x00000000;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__EXP_STALL_THRESHOLD__SHIFT  = 0x00000013;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__HIGH_STALL_MON_HIST_COUNT__SHIFT = 0x00000010;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__LOW_STALL_MON_HIST_COUNT__SHIFT = 0x0000000d;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__PERIOD__SHIFT               = 0x00000001;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__SKEW_COUNT__SHIFT           = 0x0000001a;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__THROTTLE_RESET__SHIFT       = 0x0000001d;
constexpr unsigned int SPI_EXP_THROTTLE_CTRL__UPSTEP__SHIFT               = 0x00000005;
constexpr unsigned int SPI_FEATURE_CTRL__PS_THROTTLE_MAX_WAVE_LIMIT__SHIFT = 0x00000005;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_IGNORE__SHIFT           = 0x00000004;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_DISABLE__SHIFT     = 0x0000000e;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_OOO_CTRL__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_FEATURE_CTRL__RA_PROBE_SKEW_WIF_CTRL__SHIFT    = 0x0000000b;
constexpr unsigned int SPI_FEATURE_CTRL__TUNNELING_WAVE_LIMIT__SHIFT      = 0x00000000;
constexpr unsigned int SPI_GDS_CREDITS__DS_CMD_CREDITS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_GDS_CREDITS__DS_DATA_CREDITS__SHIFT            = 0x00000000;
constexpr unsigned int SPI_GFX_CNTL__RESET_COUNTS__SHIFT                  = 0x00000000;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__GS_DEPTH__SHIFT            = 0x00000005;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__HS_DEPTH__SHIFT            = 0x0000000b;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_ALLOC_DEPTH__SHIFT      = 0x00000011;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_DEPTH__SHIFT            = 0x00000000;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_LDS_DONE_CNTL__SHIFT    = 0x00000019;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__PS_LDS_DONE_DEPTH__SHIFT   = 0x00000016;
constexpr unsigned int SPI_GFX_CRAWLER_CONFIG__RA_PSWAVE_CREDITS__SHIFT   = 0x0000001a;
constexpr unsigned int SPI_GFX_SCRATCH_BASE_HI__DATA__SHIFT               = 0x00000000;
constexpr unsigned int SPI_GFX_SCRATCH_BASE_LO__DATA__SHIFT               = 0x00000000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__ALLOC_SUCCESS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__CS_WAVE_THRESHOLD_HIGH__SHIFT = 0x00000013;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__CU_MASK_ROTATE_PERIODS__SHIFT = 0x00000018;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__GFX_PENDING_THRESHOLD__SHIFT = 0x00000003;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__GFX_WAVE_THRESHOLD_HIGH__SHIFT = 0x0000000e;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__NUM_MRT_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_CTRL__PRIORITY_LOST_THRESHOLD__SHIFT = 0x00000006;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__CS_GLG_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__CS_NUM_LOCK_WGP__SHIFT = 0x00000008;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__ENABLE__SHIFT     = 0x00000000;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__GFX_NUM_LOCK_WGP__SHIFT = 0x00000005;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__GS_ASSIST_EN__SHIFT = 0x00000002;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__HS_ASSIST_EN__SHIFT = 0x00000001;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__LOCK_MAINT_COUNT__SHIFT = 0x0000000f;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__LOCK_PERIOD__SHIFT = 0x0000000b;
constexpr unsigned int SPI_GRP_LAUNCH_GUARANTEE_ENABLE__MRT_ASSIST_EN__SHIFT = 0x00000003;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_POLL_INTERVAL__SHIFT     = 0x00000000;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_THROTTLE_BASE__SHIFT     = 0x00000004;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__PH_THROTTLE_STEP_SIZE__SHIFT = 0x00000008;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_LDS_THRESHOLD__SHIFT    = 0x00000010;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_POLL_INTERVAL__SHIFT    = 0x00000014;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_THROTTLE_BASE__SHIFT    = 0x00000018;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_THROTTLE_STEP_SIZE__SHIFT = 0x0000001c;
constexpr unsigned int SPI_GS_THROTTLE_CNTL1__SPI_VGPR_THRESHOLD__SHIFT   = 0x0000000c;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_PENALTY1__SHIFT = 0x00000008;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_PENALTY2__SHIFT = 0x0000000b;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_THRESHOLD_FACTOR__SHIFT = 0x00000006;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__GRP_LIFETIME_THRESHOLD__SHIFT = 0x00000002;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__PH_MODE__SHIFT              = 0x00000010;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__PS_STALL_THRESHOLD__SHIFT   = 0x0000000e;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__RESERVED__SHIFT             = 0x00000011;
constexpr unsigned int SPI_GS_THROTTLE_CNTL2__SPI_THROTTLE_MODE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__FLAT_SHADE_ENA__SHIFT        = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_ENA__SHIFT        = 0x00000001;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_W__SHIFT     = 0x0000000b;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_X__SHIFT     = 0x00000002;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Y__SHIFT     = 0x00000005;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Z__SHIFT     = 0x00000008;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_TOP_1__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_LB_CTR_CTRL__CLEAR_ON_READ__SHIFT              = 0x00000003;
constexpr unsigned int SPI_LB_CTR_CTRL__LOAD__SHIFT                       = 0x00000000;
constexpr unsigned int SPI_LB_CTR_CTRL__RESET_COUNTS__SHIFT               = 0x00000004;
constexpr unsigned int SPI_LB_CTR_CTRL__WAVES_SELECT__SHIFT               = 0x00000001;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_CS__ACTIVE__SHIFT          = 0x00000000;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_GS__SHIFT   = 0x00000010;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_HS__SHIFT   = 0x00000000;
constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_PS__WGP_USED_PS__SHIFT     = 0x00000000;
constexpr unsigned int SPI_LB_DATA_REG__CNT_DATA__SHIFT                   = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT0__SHIFT                   = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT1__SHIFT                   = 0x00000010;
constexpr unsigned int SPI_LB_WGP_MASK__WGP_MASK__SHIFT                   = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT        = 0x00000006;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT        = 0x00000006;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MAX__SHIFT              = 0x00000004;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MIN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MAX__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MIN__SHIFT              = 0x00000008;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MAX__SHIFT              = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MIN__SHIFT              = 0x00000010;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MAX__SHIFT              = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MIN__SHIFT              = 0x00000018;
constexpr unsigned int SPI_PG_ENABLE_STATIC_WGP_MASK__WGP_MASK__SHIFT     = 0x00000000;
constexpr unsigned int SPI_PQEV_CTRL__COMPUTE_PIPE_EN__SHIFT              = 0x00000010;
constexpr unsigned int SPI_PQEV_CTRL__QUEUE_DURATION__SHIFT               = 0x0000000a;
constexpr unsigned int SPI_PQEV_CTRL__SCAN_PERIOD__SHIFT                  = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ADDR__ANCILLARY_ENA__SHIFT            = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ADDR__FRONT_FACE_ENA__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTER_ENA__SHIFT        = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTROID_ENA__SHIFT      = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_SAMPLE_ENA__SHIFT        = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINE_STIPPLE_TEX_ENA__SHIFT     = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTER_ENA__SHIFT         = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTROID_ENA__SHIFT       = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_PULL_MODEL_ENA__SHIFT     = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_SAMPLE_ENA__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_FIXED_PT_ENA__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_W_FLOAT_ENA__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_X_FLOAT_ENA__SHIFT          = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Y_FLOAT_ENA__SHIFT          = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Z_FLOAT_ENA__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ADDR__SAMPLE_COVERAGE_ENA__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PRIM_ATTR__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ROTATE_PC_PTR__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__PRIM_ATTR__SHIFT             = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ROTATE_PC_PTR__SHIFT         = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_ENA__ANCILLARY_ENA__SHIFT             = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ENA__COVERAGE_TO_SHADER_SELECT__SHIFT = 0x00000010;
constexpr unsigned int SPI_PS_INPUT_ENA__FRONT_FACE_ENA__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTER_ENA__SHIFT         = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTROID_ENA__SHIFT       = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_SAMPLE_ENA__SHIFT         = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ENA__LINE_STIPPLE_TEX_ENA__SHIFT      = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTER_ENA__SHIFT          = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTROID_ENA__SHIFT        = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_PULL_MODEL_ENA__SHIFT      = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_SAMPLE_ENA__SHIFT          = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_FIXED_PT_ENA__SHIFT          = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_W_FLOAT_ENA__SHIFT           = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_X_FLOAT_ENA__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Y_FLOAT_ENA__SHIFT           = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Z_FLOAT_ENA__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ENA__SAMPLE_COVERAGE_ENA__SHIFT       = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__BC_OPTIMIZE_DISABLE__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__PARAM_GEN__SHIFT                = 0x00000006;
constexpr unsigned int SPI_PS_IN_CONTROL__PS_W32_EN__SHIFT                = 0x0000000f;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_COLLISION_WAVE_ID__SHIFT   = 0x00000010;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS__SHIFT        = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR__SHIFT            = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN__SHIFT           = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK__SHIFT   = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK__SHIFT    = 0x00000001;
constexpr unsigned int SPI_SAVE_RESTORE_STATUS__PERFCOUNTER_EN__SHIFT     = 0x00000000;
constexpr unsigned int SPI_SAVE_RESTORE_STATUS__THREAD_TRACE_EN__SHIFT    = 0x00000001;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__ME_ID__SHIFT              = 0x00000002;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__OVERFLOW_DETECTED__SHIFT  = 0x00000001;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__PIPE_ID__SHIFT            = 0x00000004;
constexpr unsigned int SPI_SCRATCH_ADDR_STATUS__WRITE_DIS__SHIFT          = 0x00000000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL0_EXPORT_FORMAT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL1_EXPORT_FORMAT__SHIFT   = 0x00000004;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL2_EXPORT_FORMAT__SHIFT   = 0x00000008;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL3_EXPORT_FORMAT__SHIFT   = 0x0000000c;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL4_EXPORT_FORMAT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL5_EXPORT_FORMAT__SHIFT   = 0x00000014;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL6_EXPORT_FORMAT__SHIFT   = 0x00000018;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL7_EXPORT_FORMAT__SHIFT   = 0x0000001c;
constexpr unsigned int SPI_SHADER_GS_MESHLET_CTRL__INTERLEAVE_BITS_X__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_GS_MESHLET_CTRL__INTERLEAVE_BITS_Y__SHIFT = 0x00000004;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_X__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_Y__SHIFT = 0x00000008;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_NUM_THREAD_Z__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_GS_MESHLET_DIM__MESHLET_THREADGROUP_SIZE__SHIFT = 0x00000018;
constexpr unsigned int SPI_SHADER_GS_MESHLET_EXP_ALLOC__MAX_EXP_PRIMS__SHIFT = 0x00000009;
constexpr unsigned int SPI_SHADER_GS_MESHLET_EXP_ALLOC__MAX_EXP_VERTS__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NO_PC_EXPORT__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NUM_INTERP__SHIFT  = 0x0000000b;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__NUM_PRIM_INTERP__SHIFT = 0x00000011;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__PRIM_EXPORT_COUNT__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS_GS__VS_EXPORT_COUNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NO_PC_EXPORT__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NUM_INTERP__SHIFT     = 0x0000000b;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__NUM_PRIM_INTERP__SHIFT = 0x00000011;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__PRIM_EXPORT_COUNT__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_GS_OUT_CONFIG_PS__VS_EXPORT_COUNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_IDX_FORMAT__IDX0_EXPORT_FORMAT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_GS__CHECKSUM__SHIFT          = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_HS__CHECKSUM__SHIFT          = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_CHKSUM_PS__CHECKSUM__SHIFT          = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_ES__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_GS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_HS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_LS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_PS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_ES__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_GS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_HS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_LS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_PS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CDBG_USER__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CU_GROUP_ENABLE__SHIFT    = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DISABLE_PERF__SHIFT       = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FP16_OVFL__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FWD_PROGRESS__SHIFT       = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__GS_VGPR_COMP_CNT__SHIFT   = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WGP_MODE__SHIFT           = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WG_RR_EN__SHIFT           = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__CDBG_USER__SHIFT          = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DISABLE_PERF__SHIFT       = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FP16_OVFL__SHIFT          = 0x0000001e;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FWD_PROGRESS__SHIFT       = 0x00000019;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__LS_VGPR_COMP_CNT__SHIFT   = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WGP_MODE__SHIFT           = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WG_RR_EN__SHIFT           = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CDBG_USER__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CU_GROUP_DISABLE__SHIFT   = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DISABLE_PERF__SHIFT       = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FP16_OVFL__SHIFT          = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FWD_PROGRESS__SHIFT       = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__LOAD_PROVOKING_VTX__SHIFT = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__WG_RR_EN__SHIFT           = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__ES_VGPR_COMP_CNT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__EXCP_EN__SHIFT            = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__LDS_SIZE__SHIFT           = 0x00000013;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__OC_LDS_EN__SHIFT          = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN__SHIFT            = 0x00000009;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE__SHIFT           = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__OC_LDS_EN__SHIFT          = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TG_SIZE_EN__SHIFT         = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXCP_EN__SHIFT            = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXTRA_LDS_SIZE__SHIFT     = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_COLLISION_WAVEID__SHIFT = 0x00000019;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__WAVE_CNT_EN__SHIFT        = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GLG_EN_OVERRIDE__SHIFT    = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GLG_FORCE_DISABLE__SHIFT  = 0x0000000b;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__IMAGE_OP__SHIFT           = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__INST_PREF_SIZE__SHIFT     = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__PH_THROTTLE_EN__SHIFT     = 0x0000000e;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_THROTTLE_EN__SHIFT    = 0x0000000f;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__WAVE_LIMIT__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GLG_EN_OVERRIDE__SHIFT    = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GLG_FORCE_DISABLE__SHIFT  = 0x0000000b;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__IMAGE_OP__SHIFT           = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__INST_PREF_SIZE__SHIFT     = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__WAVE_LIMIT__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__IMAGE_OP__SHIFT           = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__INST_PREF_SIZE__SHIFT     = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__LDS_GROUP_SIZE__SHIFT     = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__WAVE_LIMIT__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS0_EXPORT_FORMAT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS1_EXPORT_FORMAT__SHIFT   = 0x00000004;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS2_EXPORT_FORMAT__SHIFT   = 0x00000008;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS3_EXPORT_FORMAT__SHIFT   = 0x0000000c;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS4_EXPORT_FORMAT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__GLOBAL_SCANNING_EN__SHIFT  = 0x00000010;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_EN__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x00000013;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT__SHIFT   = 0x0000000d;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT__SHIFT       = 0x00000014;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__PERFORMANCE_LIMIT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_PER_SIMD32__SHIFT = 0x00000005;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_WRAP_DISABLE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__WAVES_PER_SIMD32__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_0__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_1__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_2__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_3__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_0__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_1__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_2__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_3__CONTRIBUTION__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_0__CONTRIBUTION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_1__CONTRIBUTION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_2__CONTRIBUTION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_3__CONTRIBUTION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_GS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_HS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_GS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_HS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_0__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_1__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_2__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_3__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_4__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_5__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_6__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_7__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_8__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_9__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_10__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_11__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_12__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_13__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_14__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_15__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_16__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_17__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_18__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_19__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_20__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_21__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_22__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_23__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_24__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_25__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_26__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_27__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_28__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_29__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_30__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_GS_31__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_0__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_1__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_2__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_3__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_4__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_5__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_6__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_7__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_8__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_9__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_10__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_11__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_12__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_13__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_14__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_15__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_16__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_17__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_18__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_19__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_20__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_21__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_22__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_23__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_24__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_25__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_26__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_27__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_28__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_29__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_30__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_HS_31__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_0__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_1__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_2__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_3__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_4__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_5__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_6__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_7__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_8__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_9__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_10__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_11__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_12__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_13__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_14__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_15__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_16__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_17__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_18__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_19__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_20__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_21__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_22__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_23__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_24__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_25__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_26__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_27__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_28__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_29__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_30__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_31__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_Z_FORMAT__Z_EXPORT_FORMAT__SHIFT        = 0x00000000;
constexpr unsigned int SPI_SQG_EVENT_CTL__ENABLE_SQG_BOP_EVENTS__SHIFT    = 0x00000001;
constexpr unsigned int SPI_SQG_EVENT_CTL__ENABLE_SQG_TOP_EVENTS__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__COLOR_BUFFER_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__POSITION_BUFFER_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__COLOR_SCOREBOARD_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__POSITION_SCOREBOARD_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_TMPRING_SIZE__WAVESIZE__SHIFT                  = 0x0000000c;
constexpr unsigned int SPI_TMPRING_SIZE__WAVES__SHIFT                     = 0x00000000;
constexpr unsigned int SPI_USER_ACCUM_VMID_CNTL__EN_USER_ACCUM__SHIFT     = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS0__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS1__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS2__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS3__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__GS_GRP_VALUE__SHIFT      = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__HS_GRP_VALUE__SHIFT      = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__GS_GRP_VALUE__SHIFT     = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__HS_GRP_VALUE__SHIFT     = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__VALUE__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_GFX__WF_ACTIVE__SHIFT          = 0x00000008;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_GFX__WF_ALLOCATED__SHIFT       = 0x00000000;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_HPG__WF_ACTIVE__SHIFT          = 0x00000008;
constexpr unsigned int SPI_WF_ACTIVE_COUNT_HPG__WF_ALLOCATED__SHIFT       = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__EN__SHIFT                    = 0x00000004;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__SAMPLE_PERIOD__SHIFT         = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_21__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_21__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WGP_WORK_PENDING__RESERVED__SHIFT              = 0x00000010;
constexpr unsigned int SPI_WGP_WORK_PENDING__SPI_WGP_WORK_PENDING__SHIFT  = 0x00000000;
constexpr unsigned int SQG_CONFIG__SQG_ICPFT_CLR__SHIFT                   = 0x00000001;
constexpr unsigned int SQG_CONFIG__SQG_ICPFT_EN__SHIFT                    = 0x00000000;
constexpr unsigned int SQG_CONFIG__XNACK_INTR_MASK__SHIFT                 = 0x00000010;
constexpr unsigned int SQG_GL1X_CTRL__SCOPE__SHIFT                        = 0x00000004;
constexpr unsigned int SQG_GL1X_CTRL__TEMPORAL__SHIFT                     = 0x00000000;
constexpr unsigned int SQG_GL1X_STATUS__ACK_ERR_DETECTED__SHIFT           = 0x00000000;
constexpr unsigned int SQG_GL1X_STATUS__XNACK_ERR_DETECTED__SHIFT         = 0x00000001;
constexpr unsigned int SQG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER2_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER3_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER4_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER5_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER6_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER7_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQG_PERFCOUNTER_CTRL2__FORCE_EN__SHIFT             = 0x00000000;
constexpr unsigned int SQG_PERFCOUNTER_CTRL2__VMID_EN__SHIFT              = 0x00000001;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__CS_EN__SHIFT                 = 0x00000006;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME0PIPE0_PERF__SHIFT = 0x0000000e;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME0PIPE1_PERF__SHIFT = 0x0000000f;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE0_PERF__SHIFT = 0x00000010;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE1_PERF__SHIFT = 0x00000011;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE2_PERF__SHIFT = 0x00000012;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__DISABLE_ME1PIPE3_PERF__SHIFT = 0x00000013;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__GS_EN__SHIFT                 = 0x00000002;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__HS_EN__SHIFT                 = 0x00000004;
constexpr unsigned int SQG_PERFCOUNTER_CTRL__PS_EN__SHIFT                 = 0x00000000;
constexpr unsigned int SQG_PERF_SAMPLE_FINISH__STATUS__SHIFT              = 0x00000000;
constexpr unsigned int SQG_STATUS__POWEROFF_RESTORE__SHIFT                = 0x00000001;
constexpr unsigned int SQG_STATUS__REG_BUSY__SHIFT                        = 0x00000000;
constexpr unsigned int SQG_THREAD_TRACE_CONFIG__ALL_VMID__SHIFT           = 0x00000000;
constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SQ_ARB_CONFIG__FWD_PROG_INTERVAL__SHIFT            = 0x00000004;
constexpr unsigned int SQ_ARB_CONFIG__WG_RR_INTERVAL__SHIFT               = 0x00000000;
constexpr unsigned int SQ_CLK_CTRL__EX_BRMSG_FGCG_OVERRIDE__SHIFT         = 0x0000001a;
constexpr unsigned int SQ_CLK_CTRL__EX_SALU_FGCG_OVERRIDE__SHIFT          = 0x00000018;
constexpr unsigned int SQ_CLK_CTRL__EX_VALU_FGCG_OVERRIDE__SHIFT          = 0x00000019;
constexpr unsigned int SQ_CLK_CTRL__IB_IBUF_FGCG_OVERRIDE__SHIFT          = 0x00000015;
constexpr unsigned int SQ_CLK_CTRL__IB_MISC_FGCG_OVERRIDE__SHIFT          = 0x00000017;
constexpr unsigned int SQ_CLK_CTRL__IB_WINFO_FGCG_OVERRIDE__SHIFT         = 0x00000016;
constexpr unsigned int SQ_CLK_CTRL__ISC_CTRL_FGCG_OVERRIDE__SHIFT         = 0x00000013;
constexpr unsigned int SQ_CLK_CTRL__ISC_SET_FGCG_OVERRIDE__SHIFT          = 0x00000012;
constexpr unsigned int SQ_CLK_CTRL__ISC_WAVE_CTRL_FGCG_OVERRIDE__SHIFT    = 0x00000014;
constexpr unsigned int SQ_CLK_CTRL__IS_WAVECLK_IB_WCLK_OVERRIDE__SHIFT    = 0x00000011;
constexpr unsigned int SQ_CLK_CTRL__OVERRIDE_LDS_DIRECT_BUSY__SHIFT       = 0x00000009;
constexpr unsigned int SQ_CLK_CTRL__OVERRIDE_LDS_IDX_BUSY__SHIFT          = 0x00000008;
constexpr unsigned int SQ_CLK_CTRL__PERFMON_OVERRIDE__SHIFT               = 0x00000007;
constexpr unsigned int SQ_CLK_CTRL__SQ_LDS_DIRECT_FGCG_OVERRIDE__SHIFT    = 0x00000010;
constexpr unsigned int SQ_CLK_CTRL__SQ_SPI_EXPREQ_FGCG_OVERRIDE__SHIFT    = 0x00000003;
constexpr unsigned int SQ_CLK_CTRL__SQ_SPI_MSG_FGCG_OVERRIDE__SHIFT       = 0x00000002;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_CMD_FGCG_OVERRIDE__SHIFT        = 0x0000000c;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_CONST_FGCG_OVERRIDE__SHIFT      = 0x0000000d;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_EXP_FGCG_OVERRIDE__SHIFT        = 0x0000000e;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_ICG_FGCG_OVERRIDE__SHIFT        = 0x0000001b;
constexpr unsigned int SQ_CLK_CTRL__SQ_SP_VMEM_FGCG_OVERRIDE__SHIFT       = 0x0000000f;
constexpr unsigned int SQ_CLK_CTRL__SQ_SQC_TTRACE_FGCG_OVERRIDE__SHIFT    = 0x00000005;
constexpr unsigned int SQ_CLK_CTRL__SQ_SX_EXPCMD_FGCG_OVERRIDE__SHIFT     = 0x00000004;
constexpr unsigned int SQ_CLK_CTRL__WCLK_OVERRIDE__SHIFT                  = 0x00000006;
constexpr unsigned int SQ_CLK_CTRL__WCLK_SLEEP_EXPALLOC_OVERRIDE__SHIFT   = 0x0000000b;
constexpr unsigned int SQ_CLK_CTRL__WCLK_SLEEP_VMEM_OVERRIDE__SHIFT       = 0x0000000a;
constexpr unsigned int SQ_CMD__CHECK_VMID__SHIFT                          = 0x00000007;
constexpr unsigned int SQ_CMD__CMD__SHIFT                                 = 0x00000000;
constexpr unsigned int SQ_CMD__DATA__SHIFT                                = 0x00000008;
constexpr unsigned int SQ_CMD__MODE__SHIFT                                = 0x00000004;
constexpr unsigned int SQ_CMD__QUEUE_ID__SHIFT                            = 0x00000018;
constexpr unsigned int SQ_CMD__VM_ID__SHIFT                               = 0x0000001c;
constexpr unsigned int SQ_CMD__WAVE_ID__SHIFT                             = 0x00000010;
constexpr unsigned int SQ_CONFIG__DISABLE_END_CLAUSE_TX__SHIFT            = 0x0000001b;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_CLAUSE_DETECTION__SHIFT = 0x0000001a;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_EXPORT_DETECTION__SHIFT = 0x00000019;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_OPCODE_DETECTION__SHIFT = 0x00000017;
constexpr unsigned int SQ_CONFIG__DISABLE_ILLEGAL_TO_NOP_DETECTION__SHIFT = 0x00000018;
constexpr unsigned int SQ_CONFIG__DISABLE_ISC_PREFETCH_LIMITER__SHIFT     = 0x0000001f;
constexpr unsigned int SQ_CONFIG__DISABLE_SGPR_RD_KILL__SHIFT             = 0x0000000a;
constexpr unsigned int SQ_CONFIG__DISABLE_SP_SINGLE_ISSUE_WAVE64_TRANS__SHIFT = 0x0000001e;
constexpr unsigned int SQ_CONFIG__DISABLE_VMEM_EXEC_ZERO_SKIP__SHIFT      = 0x00000009;
constexpr unsigned int SQ_CONFIG__ECO_SPARE__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_CONFIG__ENABLE_HIPRIO_ON_EXP_RDY_GS__SHIFT      = 0x00000012;
constexpr unsigned int SQ_CONFIG__NEW_TRANS_ARB_SCHEME__SHIFT             = 0x00000008;
constexpr unsigned int SQ_CONFIG__PRIO_VAL_ON_EXP_RDY_GS__SHIFT           = 0x00000013;
constexpr unsigned int SQ_CONFIG__WCLK_HYSTERESIS_CNT__SHIFT              = 0x00000015;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_ENABLE_ERROR_INJECT__SHIFT     = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_SELECT_INJECT_DELAY__SHIFT     = 0x00000005;
constexpr unsigned int SQ_DSM_CNTL2__LDS_INJECT_DELAY__SHIFT              = 0x0000000e;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_ENABLE_ERROR_INJECT__SHIFT     = 0x00000006;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_SELECT_INJECT_DELAY__SHIFT     = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_ENABLE_ERROR_INJECT__SHIFT      = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_SELECT_INJECT_DELAY__SHIFT      = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL2__SP_ENABLE_ERROR_INJECT__SHIFT        = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL2__SP_INJECT_DELAY__SHIFT               = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL2__SP_SELECT_INJECT_DELAY__SHIFT        = 0x0000000b;
constexpr unsigned int SQ_DSM_CNTL2__SQ_INJECT_DELAY__SHIFT               = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE01__SHIFT      = 0x00000012;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE23__SHIFT      = 0x00000015;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA0__SHIFT    = 0x00000010;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA1__SHIFT    = 0x00000011;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA2__SHIFT    = 0x00000013;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA3__SHIFT    = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA0__SHIFT   = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA1__SHIFT   = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA0__SHIFT     = 0x00000018;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA1__SHIFT     = 0x00000019;
constexpr unsigned int SQ_DSM_CNTL__SGPR_ENABLE_SINGLE_WRITE__SHIFT       = 0x0000000a;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_0__SHIFT             = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_1__SHIFT             = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL__SP_ENABLE_SINGLE_WRITE__SHIFT         = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_0__SHIFT              = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_1__SHIFT              = 0x00000001;
constexpr unsigned int SQ_DYN_VGPR__BLOCK_SIZE__SHIFT                     = 0x00000008;
constexpr unsigned int SQ_DYN_VGPR__FWD_PROGRESS__SHIFT                   = 0x00000004;
constexpr unsigned int SQ_DYN_VGPR__MAX_BLOCK_ALLOC__SHIFT                = 0x00000005;
constexpr unsigned int SQ_DYN_VGPR__WAVE_LIMIT__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_GS_RESERVED__SHIFT       = 0x0000000c;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PRIMPOS_LIMIT__SHIFT     = 0x00000014;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PS_RESERVED__SHIFT       = 0x0000000e;
constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_REDUCE__SHIFT            = 0x00000010;
constexpr unsigned int SQ_FIFO_SIZES__INTERRUPT_FIFO_SIZE__SHIFT          = 0x00000000;
constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE__SHIFT             = 0x00000008;
constexpr unsigned int SQ_FIFO_SIZES__VMEM_DATA_FIFO_SIZE__SHIFT          = 0x00000012;
constexpr unsigned int SQ_IND_DATA__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_IND_INDEX__AUTO_INCR__SHIFT                     = 0x0000000b;
constexpr unsigned int SQ_IND_INDEX__INDEX__SHIFT                         = 0x00000010;
constexpr unsigned int SQ_IND_INDEX__WAVE_ID__SHIFT                       = 0x00000000;
constexpr unsigned int SQ_IND_INDEX__WORKITEM_ID__SHIFT                   = 0x00000005;
constexpr unsigned int SQ_INTERRUPT_AUTO_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int SQ_INTERRUPT_MSG_CTRL__STALL__SHIFT                = 0x00000000;
constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SQ_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__FORCE_EN__SHIFT              = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__VMID_EN__SHIFT               = 0x00000001;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CS_EN__SHIFT                  = 0x00000006;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME0PIPE0_PERF__SHIFT  = 0x0000000e;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME0PIPE1_PERF__SHIFT  = 0x0000000f;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE0_PERF__SHIFT  = 0x00000010;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE1_PERF__SHIFT  = 0x00000011;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE2_PERF__SHIFT  = 0x00000012;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_ME1PIPE3_PERF__SHIFT  = 0x00000013;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__GS_EN__SHIFT                  = 0x00000002;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__HS_EN__SHIFT                  = 0x00000004;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__PS_EN__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__COUNT_INTERVAL__SHIFT       = 0x00000012;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__COUNT_SEL__SHIFT            = 0x00000011;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__TEST_MODE__SHIFT            = 0x00000016;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__TIMER_ON_OFF__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_CTRL__VMID_MASK__SHIFT            = 0x00000001;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_BRMSG__SHIFT = 0x00000006;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_EXPORT__SHIFT = 0x00000007;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_LDS_DIRECT__SHIFT = 0x00000008;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_LDS__SHIFT = 0x00000009;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_RESERVED__SHIFT = 0x0000000d;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_SCALAR__SHIFT = 0x0000000b;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_TEX__SHIFT = 0x0000000a;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_ISSUED_VALU__SHIFT = 0x0000000c;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_BRMSG__SHIFT = 0x0000000e;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_EXPORT__SHIFT = 0x0000000f;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_LDS_DIRECT__SHIFT = 0x00000010;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_LDS__SHIFT = 0x00000011;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_RESERVED__SHIFT = 0x00000015;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_SCALAR__SHIFT = 0x00000013;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_TEX__SHIFT = 0x00000012;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__ARB_STATE_STALLED_VALU__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA1__WAVE_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__BVH_CNT__SHIFT             = 0x0000000c;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__DS_CNT__SHIFT              = 0x00000015;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__KM_CNT__SHIFT              = 0x0000001b;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__LOAD_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__SAMPLE_CNT__SHIFT          = 0x0000000f;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA2__STORE_CNT__SHIFT           = 0x00000006;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__INST_TYPE__SHIFT            = 0x00000002;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__NO_ISSUE_REASON__SHIFT      = 0x00000006;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__VALID__SHIFT                = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__WAVE_ID__SHIFT              = 0x00000009;
constexpr unsigned int SQ_PERF_SNAPSHOT_DATA__WAVE_ISSUE__SHIFT           = 0x00000001;
constexpr unsigned int SQ_PERF_SNAPSHOT_PC_HI__PC_HI__SHIFT               = 0x00000000;
constexpr unsigned int SQ_PERF_SNAPSHOT_PC_LO__PC_LO__SHIFT               = 0x00000000;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__FORCE_IB_ARB_PRIO_MSK_VALID__SHIFT = 0x0000001f;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RET__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG__SHIFT                     = 0x0000000a;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RUI__SHIFT                     = 0x00000007;
constexpr unsigned int SQ_RUNTIME_CONFIG__UNUSED_REGISTER__SHIFT          = 0x00000000;
constexpr unsigned int SQ_SHADER_CYCLES_HI__CYCLES_HI__SHIFT              = 0x00000000;
constexpr unsigned int SQ_SHADER_CYCLES_LO__CYCLES_LO__SHIFT              = 0x00000000;
constexpr unsigned int SQ_SHADER_TBA_HI__ADDR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TBA_HI__TRAP_EN__SHIFT                   = 0x0000001f;
constexpr unsigned int SQ_SHADER_TBA_LO__ADDR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_HI__ADDR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_LO__ADDR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE_HI__BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE_LO__BASE_LO__SHIFT       = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE_HI__BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE_LO__BASE_LO__SHIFT       = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__AUTO_FLUSH_MODE__SHIFT       = 0x0000001d;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__AUTO_FLUSH_PADDING_DIS__SHIFT = 0x0000001c;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__DOUBLE_BUFFER__SHIFT         = 0x00000005;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__DRAW_EVENT_EN__SHIFT         = 0x0000001f;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__GL1X_PREFETCH_PAGE__SHIFT    = 0x00000017;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__GL1_PERF_EN__SHIFT           = 0x00000003;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__HIWATER__SHIFT               = 0x00000006;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__INTERRUPT_EN__SHIFT          = 0x00000004;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__LOWATER_OFFSET__SHIFT        = 0x00000014;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__MODE__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__NCP_REG_TOKEN_EN__SHIFT      = 0x0000001e;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_AT_HWM__SHIFT            = 0x00000009;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SPI_STALL_EN__SHIFT          = 0x0000000b;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SQ_STALL_EN__SHIFT           = 0x0000000c;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__STALL_ALL_SIMDS__SHIFT       = 0x0000000d;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_DRAWS__SHIFT      = 0x00000013;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_MARKERS__SHIFT    = 0x00000012;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__UTIL_TIMER__SHIFT            = 0x0000000e;
constexpr unsigned int SQ_THREAD_TRACE_CTRL__WAVESTART_MODE__SHIFT        = 0x0000000f;
constexpr unsigned int SQ_THREAD_TRACE_DROPPED_CNTR__CNTR__SHIFT          = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_GFX_DRAW_CNTR__CNTR__SHIFT         = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_GFX_MARKER_CNTR__CNTR__SHIFT       = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_HALT__CGCG_READY__SHIFT            = 0x00000001;
constexpr unsigned int SQ_THREAD_TRACE_HALT__ENTER_CGCG__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_HALT__ENTER_POWEROFF__SHIFT        = 0x00000002;
constexpr unsigned int SQ_THREAD_TRACE_HALT__POWEROFF_READY__SHIFT        = 0x00000003;
constexpr unsigned int SQ_THREAD_TRACE_HP3D_DRAW_CNTR__CNTR__SHIFT        = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_HP3D_MARKER_CNTR__CNTR__SHIFT      = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_ALLOC__SHIFT = 0x00000013;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_SHADERDATA__SHIFT = 0x00000011;
constexpr unsigned int SQ_THREAD_TRACE_MASK__EXCLUDE_NONDETAIL_WAVESTART_EXT__SHIFT = 0x00000012;
constexpr unsigned int SQ_THREAD_TRACE_MASK__SA_SEL__SHIFT                = 0x00000009;
constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_SEL__SHIFT              = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_MASK__WGP_SEL__SHIFT               = 0x00000004;
constexpr unsigned int SQ_THREAD_TRACE_MASK__WTYPE_INCLUDE__SHIFT         = 0x0000000a;
constexpr unsigned int SQ_THREAD_TRACE_POWEROFF_RESTORE_1__STATES__SHIFT  = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF0_FULL__SHIFT          = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF1_FULL__SHIFT          = 0x00000001;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF_ISSUE_STATUS__SHIFT   = 0x00000008;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__BUF_ISSUE__SHIFT          = 0x0000000d;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__PACKET_LOST_BUF_NO_LOCKDOWN__SHIFT = 0x00000004;
constexpr unsigned int SQ_THREAD_TRACE_STATUS2__WRITE_BUF_FULL__SHIFT     = 0x0000000e;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY__SHIFT                = 0x00000019;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE__SHIFT         = 0x0000000c;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING__SHIFT      = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__OWNER_VMID__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__WRITE_ERROR__SHIFT         = 0x00000018;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__BOP_EVENTS_TOKEN_INCLUDE__SHIFT = 0x0000000d;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__EXCLUDE_BARRIER_WAIT__SHIFT = 0x0000000e;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__INST_EXCLUDE__SHIFT    = 0x00000018;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DETAIL_ALL__SHIFT  = 0x0000001f;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_EXCLUDE__SHIFT     = 0x0000001a;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_INCLUDE__SHIFT     = 0x00000010;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_EXCLUDE__SHIFT   = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TTRACE_EXEC__SHIFT     = 0x0000000c;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_0__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_1__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_2__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_3__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_4__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_5__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_6__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_7__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_WPTR__BUFFER_ID__SHIFT             = 0x0000001f;
constexpr unsigned int SQ_THREAD_TRACE_WPTR__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SQ_WATCH0_ADDR_H__ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WATCH0_ADDR_L__ADDR__SHIFT                      = 0x00000006;
constexpr unsigned int SQ_WATCH0_CNTL__MASK__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WATCH0_CNTL__VALID__SHIFT                       = 0x0000001f;
constexpr unsigned int SQ_WATCH0_CNTL__VMID__SHIFT                        = 0x00000018;
constexpr unsigned int SQ_WATCH1_ADDR_H__ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WATCH1_ADDR_L__ADDR__SHIFT                      = 0x00000006;
constexpr unsigned int SQ_WATCH1_CNTL__MASK__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WATCH1_CNTL__VALID__SHIFT                       = 0x0000001f;
constexpr unsigned int SQ_WATCH1_CNTL__VMID__SHIFT                        = 0x00000018;
constexpr unsigned int SQ_WATCH2_ADDR_H__ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WATCH2_ADDR_L__ADDR__SHIFT                      = 0x00000006;
constexpr unsigned int SQ_WATCH2_CNTL__MASK__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WATCH2_CNTL__VALID__SHIFT                       = 0x0000001f;
constexpr unsigned int SQ_WATCH2_CNTL__VMID__SHIFT                        = 0x00000018;
constexpr unsigned int SQ_WATCH3_ADDR_H__ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WATCH3_ADDR_L__ADDR__SHIFT                      = 0x00000006;
constexpr unsigned int SQ_WATCH3_CNTL__MASK__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WATCH3_CNTL__VALID__SHIFT                       = 0x0000001f;
constexpr unsigned int SQ_WATCH3_CNTL__VMID__SHIFT                        = 0x00000018;
constexpr unsigned int SQ_WAVE_ACTIVE__WAVE_SLOT__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT4__SHIFT            = 0x00000000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT5__SHIFT            = 0x00000008;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT6__SHIFT            = 0x00000010;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_HI__SEGMENT7__SHIFT            = 0x00000018;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT0__SHIFT            = 0x00000000;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT1__SHIFT            = 0x00000008;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT2__SHIFT            = 0x00000010;
constexpr unsigned int SQ_WAVE_DVGPR_ALLOC_LO__SEGMENT3__SHIFT            = 0x00000018;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__ADDR_WATCH__SHIFT          = 0x00000000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__FIRST_MEMVIOL_SOURCE__SHIFT = 0x0000001e;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__HOST_TRAP__SHIFT           = 0x00000007;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__ILLEGAL_INST__SHIFT        = 0x00000006;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__MEMVIOL__SHIFT             = 0x00000004;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__PERF_SNAPSHOT__SHIFT       = 0x0000000a;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__SAVE_CONTEXT__SHIFT        = 0x00000005;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__TRAP_AFTER_INST__SHIFT     = 0x0000000b;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__WAVE_END__SHIFT            = 0x00000009;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__WAVE_START__SHIFT          = 0x00000008;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_PRIV__XNACK_ERROR__SHIFT         = 0x0000000c;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_FLOAT_DIV0__SHIFT      = 0x00000002;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INEXACT__SHIFT         = 0x00000005;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INPUT_DENORM__SHIFT    = 0x00000001;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INT_DIV0__SHIFT        = 0x00000006;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_INVALID__SHIFT         = 0x00000000;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_OVERFLOW__SHIFT        = 0x00000003;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__ALU_UNDERFLOW__SHIFT       = 0x00000004;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__BUFFER_OOB__SHIFT          = 0x0000001e;
constexpr unsigned int SQ_WAVE_EXCP_FLAG_USER__LOD_CLAMPED__SHIFT         = 0x0000001f;
constexpr unsigned int SQ_WAVE_EXEC_HI__EXEC_HI__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_EXEC_LO__EXEC_LO__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_FLUSH_IB__UNUSED__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_BASE__SHIFT                = 0x00000000;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_SIZE__SHIFT                = 0x0000000c;
constexpr unsigned int SQ_WAVE_HW_ID1__DP_RATE__SHIFT                     = 0x0000001d;
constexpr unsigned int SQ_WAVE_HW_ID1__SA_ID__SHIFT                       = 0x00000010;
constexpr unsigned int SQ_WAVE_HW_ID1__SE_ID__SHIFT                       = 0x00000012;
constexpr unsigned int SQ_WAVE_HW_ID1__SIMD_ID__SHIFT                     = 0x00000008;
constexpr unsigned int SQ_WAVE_HW_ID1__WAVE_ID__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_WAVE_HW_ID1__WGP_ID__SHIFT                      = 0x0000000a;
constexpr unsigned int SQ_WAVE_HW_ID2__ME_ID__SHIFT                       = 0x00000008;
constexpr unsigned int SQ_WAVE_HW_ID2__PIPE_ID__SHIFT                     = 0x00000004;
constexpr unsigned int SQ_WAVE_HW_ID2__QUEUE_ID__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_HW_ID2__STATE_ID__SHIFT                    = 0x0000000c;
constexpr unsigned int SQ_WAVE_HW_ID2__VM_ID__SHIFT                       = 0x00000018;
constexpr unsigned int SQ_WAVE_HW_ID2__WG_ID__SHIFT                       = 0x00000010;
constexpr unsigned int SQ_WAVE_IB_STS2__FWD_PROGRESS__SHIFT               = 0x0000001e;
constexpr unsigned int SQ_WAVE_IB_STS2__INST_PREFETCH__SHIFT              = 0x0000001c;
constexpr unsigned int SQ_WAVE_IB_STS2__KM_CNT__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_WAVE_IB_STS2__TTRACE_EN_SPI__SHIFT              = 0x0000001f;
constexpr unsigned int SQ_WAVE_IB_STS__BVH_CNT__SHIFT                     = 0x00000015;
constexpr unsigned int SQ_WAVE_IB_STS__DS_CNT__SHIFT                      = 0x00000003;
constexpr unsigned int SQ_WAVE_IB_STS__EXP_CNT__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_WAVE_IB_STS__LOAD_CNT__SHIFT                    = 0x00000009;
constexpr unsigned int SQ_WAVE_IB_STS__SAMPLE_CNT__SHIFT                  = 0x0000000f;
constexpr unsigned int SQ_WAVE_IB_STS__STORE_CNT__SHIFT                   = 0x00000018;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_BASE__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_SIZE__SHIFT                 = 0x0000000c;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__VGPR_SHARED_SIZE__SHIFT         = 0x00000018;
constexpr unsigned int SQ_WAVE_M0__M0__SHIFT                              = 0x00000000;
constexpr unsigned int SQ_WAVE_MODE__DISABLE_PERF__SHIFT                  = 0x0000001b;
constexpr unsigned int SQ_WAVE_MODE__FP16_OVFL__SHIFT                     = 0x00000017;
constexpr unsigned int SQ_WAVE_MODE__FP_DENORM__SHIFT                     = 0x00000004;
constexpr unsigned int SQ_WAVE_MODE__FP_ROUND__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WAVE_MODE__SCALAR_PREFETCH_EN__SHIFT            = 0x00000018;
constexpr unsigned int SQ_WAVE_PC_HI__PC_HI__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_PC_LO__PC_LO__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_SCHED_MODE__DEP_MODE__SHIFT                = 0x00000000;
constexpr unsigned int SQ_WAVE_SCRATCH_BASE_HI__DATA__SHIFT               = 0x00000000;
constexpr unsigned int SQ_WAVE_SCRATCH_BASE_LO__DATA__SHIFT               = 0x00000000;
constexpr unsigned int SQ_WAVE_STATE_PRIV__BARRIER_COMPLETE__SHIFT        = 0x00000002;
constexpr unsigned int SQ_WAVE_STATE_PRIV__COND_DBG_SYS__SHIFT            = 0x00000011;
constexpr unsigned int SQ_WAVE_STATE_PRIV__COND_DBG_USER__SHIFT           = 0x00000010;
constexpr unsigned int SQ_WAVE_STATE_PRIV__HALT__SHIFT                    = 0x0000000e;
constexpr unsigned int SQ_WAVE_STATE_PRIV__NAMED_BARRIER_COMPLETE__SHIFT  = 0x00000003;
constexpr unsigned int SQ_WAVE_STATE_PRIV__NAMED_BARRIER_ID__SHIFT        = 0x00000004;
constexpr unsigned int SQ_WAVE_STATE_PRIV__PERF_EN__SHIFT                 = 0x00000013;
constexpr unsigned int SQ_WAVE_STATE_PRIV__POISON_ERR__SHIFT              = 0x0000000f;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SCC__SHIFT                     = 0x00000009;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SCRATCH_EN__SHIFT              = 0x00000012;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SLEEP_WAKEUP__SHIFT            = 0x00000001;
constexpr unsigned int SQ_WAVE_STATE_PRIV__SYS_PRIO__SHIFT                = 0x0000000a;
constexpr unsigned int SQ_WAVE_STATE_PRIV__TTRACE_EN__SHIFT               = 0x00000014;
constexpr unsigned int SQ_WAVE_STATE_PRIV__USER_PRIO__SHIFT               = 0x0000000c;
constexpr unsigned int SQ_WAVE_STATE_PRIV__WG_RR_EN__SHIFT                = 0x00000000;
constexpr unsigned int SQ_WAVE_STATUS__DVGPR_EN__SHIFT                    = 0x0000001e;
constexpr unsigned int SQ_WAVE_STATUS__EXECZ__SHIFT                       = 0x00000009;
constexpr unsigned int SQ_WAVE_STATUS__EXPORT_RDY__SHIFT                  = 0x00000008;
constexpr unsigned int SQ_WAVE_STATUS__FATAL_HALT__SHIFT                  = 0x00000017;
constexpr unsigned int SQ_WAVE_STATUS__IDLE__SHIFT                        = 0x0000001c;
constexpr unsigned int SQ_WAVE_STATUS__IN_WG__SHIFT                       = 0x0000000b;
constexpr unsigned int SQ_WAVE_STATUS__LDS_PARAM_READY__SHIFT             = 0x00000019;
constexpr unsigned int SQ_WAVE_STATUS__MUST_EXPORT__SHIFT                 = 0x0000001b;
constexpr unsigned int SQ_WAVE_STATUS__MUST_GS_ALLOC__SHIFT               = 0x0000001a;
constexpr unsigned int SQ_WAVE_STATUS__NO_VGPRS__SHIFT                    = 0x00000018;
constexpr unsigned int SQ_WAVE_STATUS__OREO_CONFLICT__SHIFT               = 0x00000016;
constexpr unsigned int SQ_WAVE_STATUS__PRIV__SHIFT                        = 0x00000005;
constexpr unsigned int SQ_WAVE_STATUS__SKIP_EXPORT__SHIFT                 = 0x00000012;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_BARRIER_COMPLETE__SHIFT       = 0x0000000f;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_EN__SHIFT                     = 0x00000006;
constexpr unsigned int SQ_WAVE_STATUS__TRAP__SHIFT                        = 0x0000000e;
constexpr unsigned int SQ_WAVE_STATUS__VALID__SHIFT                       = 0x00000010;
constexpr unsigned int SQ_WAVE_STATUS__VCCZ__SHIFT                        = 0x0000000a;
constexpr unsigned int SQ_WAVE_STATUS__WAVE64__SHIFT                      = 0x0000001d;
constexpr unsigned int SQ_WAVE_STATUS__WGP_TAKEOVER__SHIFT                = 0x0000001f;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ADDR_WATCH__SHIFT               = 0x00000007;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_FLOAT_DIV0__SHIFT           = 0x00000002;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INEXACT__SHIFT              = 0x00000005;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INPUT_DENORM__SHIFT         = 0x00000001;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INT_DIV0__SHIFT             = 0x00000006;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_INVALID__SHIFT              = 0x00000000;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_OVERFLOW__SHIFT             = 0x00000003;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__ALU_UNDERFLOW__SHIFT            = 0x00000004;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__TRAP_AFTER_INST__SHIFT          = 0x00000009;
constexpr unsigned int SQ_WAVE_TRAP_CTRL__WAVE_END__SHIFT                 = 0x00000008;
constexpr unsigned int SQ_WAVE_TTMP0__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP1__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP2__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP3__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP4__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP5__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP6__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP7__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP8__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP9__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP10__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP11__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP12__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP13__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP14__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP15__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_VALID_AND_IDLE__WAVE_SLOT__SHIFT           = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_ALPHA_OPT_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_COLOR_OPT_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_ALPHA_OPT_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_COLOR_OPT_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_ALPHA_OPT_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_COLOR_OPT_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_ALPHA_OPT_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_COLOR_OPT_DISABLE__SHIFT = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_ALPHA_OPT_DISABLE__SHIFT = 0x00000011;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_COLOR_OPT_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_ALPHA_OPT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_COLOR_OPT_DISABLE__SHIFT = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_ALPHA_OPT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_COLOR_OPT_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_ALPHA_OPT_DISABLE__SHIFT = 0x0000001d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_COLOR_OPT_DISABLE__SHIFT = 0x0000001c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__PIXEN_ZERO_OPT_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT0_EPSILON__SHIFT          = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT1_EPSILON__SHIFT          = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT2_EPSILON__SHIFT          = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT3_EPSILON__SHIFT          = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT4_EPSILON__SHIFT          = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT5_EPSILON__SHIFT          = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT6_EPSILON__SHIFT          = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT7_EPSILON__SHIFT          = 0x0000001c;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT0_FMT_MAPPING_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT1_FMT_MAPPING_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT2_FMT_MAPPING_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT3_FMT_MAPPING_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT4_FMT_MAPPING_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT5_FMT_MAPPING_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT6_FMT_MAPPING_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int SX_PS_DOWNCONVERT_CONTROL__MRT7_FMT_MAPPING_DISABLE__SHIFT = 0x00000007;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT0__SHIFT                     = 0x00000000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT1__SHIFT                     = 0x00000004;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT2__SHIFT                     = 0x00000008;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT3__SHIFT                     = 0x0000000c;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT4__SHIFT                     = 0x00000010;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT5__SHIFT                     = 0x00000014;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT6__SHIFT                     = 0x00000018;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT7__SHIFT                     = 0x0000001c;
constexpr unsigned int TA_BC_BASE_ADDR_HI__ADDRESS__SHIFT                 = 0x00000000;
constexpr unsigned int TA_BC_BASE_ADDR__ADDRESS__SHIFT                    = 0x00000000;
constexpr unsigned int TA_CNTL2__ELEMSIZE_HASH_DIS__SHIFT                 = 0x00000011;
constexpr unsigned int TA_CNTL2__ELIMINATE_UNLIT_QUAD_DIS__SHIFT          = 0x00000013;
constexpr unsigned int TA_CNTL2__MAX_RQ_ID__SHIFT                         = 0x00000004;
constexpr unsigned int TA_CNTL2__PRTPLUS_ACCUM_MODE__SHIFT                = 0x00000014;
constexpr unsigned int TA_CNTL2__STORE_COMPONENT_MODE__SHIFT              = 0x00000000;
constexpr unsigned int TA_CNTL2__TRUNCATE_COORD_MODE__SHIFT               = 0x00000012;
constexpr unsigned int TA_CNTL_AUX__ANISO_ERROR_FP_VBIAS__SHIFT           = 0x0000000c;
constexpr unsigned int TA_CNTL_AUX__ANISO_HALF_THRESH__SHIFT              = 0x0000000a;
constexpr unsigned int TA_CNTL_AUX__ANISO_MAG_STEP_CLAMP__SHIFT           = 0x00000008;
constexpr unsigned int TA_CNTL_AUX__ANISO_RATIO_LUT__SHIFT                = 0x00000011;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_ORDER__SHIFT               = 0x0000000d;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP__SHIFT                     = 0x0000000e;
constexpr unsigned int TA_CNTL_AUX__ANISO_TAP__SHIFT                      = 0x00000012;
constexpr unsigned int TA_CNTL_AUX__ANISO_WEIGHT_MODE__SHIFT              = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__ARRAY_ROUND_MODE__SHIFT               = 0x0000001e;
constexpr unsigned int TA_CNTL_AUX__AUTO_ALIGN_FORMAT__SHIFT              = 0x00000009;
constexpr unsigned int TA_CNTL_AUX__CORNER_SAMPLES_MIN_DIM__SHIFT         = 0x00000002;
constexpr unsigned int TA_CNTL_AUX__CUBEMAP_SLICE_CLAMP__SHIFT            = 0x0000001c;
constexpr unsigned int TA_CNTL_AUX__DEPTH_AS_PITCH_DIS__SHIFT             = 0x00000001;
constexpr unsigned int TA_CNTL_AUX__DERIV_ADJUST_DIS__SHIFT               = 0x00000004;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_DFMT_NFMT_DISABLE__SHIFT  = 0x0000001a;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_MISC_DISABLE__SHIFT       = 0x00000016;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_OPCODE_STRICT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_RESERVED_DISABLE__SHIFT   = 0x00000014;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLER_MSAA_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLE_C_DFMT_DISABLE__SHIFT = 0x00000017;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_WRITEOP_READFMT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int TA_CNTL_AUX__DISABLE_GATHER4_BC_SWIZZLE__SHIFT     = 0x00000007;
constexpr unsigned int TA_CNTL_AUX__GATHERH_DST_SEL__SHIFT                = 0x00000006;
constexpr unsigned int TA_CNTL_AUX__MINMAG_UNNORM__SHIFT                  = 0x0000000f;
constexpr unsigned int TA_CNTL_AUX__OVERRIDE_QUAD_MODE_DIS__SHIFT         = 0x00000003;
constexpr unsigned int TA_CNTL_AUX__SCOAL_DSWIZZLE_N__SHIFT               = 0x00000000;
constexpr unsigned int TA_CNTL_AUX__TFAULT_EN_OVERRIDE__SHIFT             = 0x00000005;
constexpr unsigned int TA_CNTL_AUX__TRUNC_SMALL_NEG__SHIFT                = 0x0000001d;
constexpr unsigned int TA_CNTL__ALIGNER_CREDIT__SHIFT                     = 0x00000010;
constexpr unsigned int TA_CNTL__TA_INPUT_CFIFO_VEC64_OPT_OVERRIDE__SHIFT  = 0x00000003;
constexpr unsigned int TA_CNTL__TA_INPUT_RDATA_PER_BANK_FGCG_OVERRIDE__SHIFT = 0x00000002;
constexpr unsigned int TA_CNTL__TA_SQ_XNACK_FGCG_DISABLE__SHIFT           = 0x00000000;
constexpr unsigned int TA_CNTL__TD_FIFO_CREDIT__SHIFT                     = 0x00000016;
constexpr unsigned int TA_CS_BC_BASE_ADDR_HI__ADDRESS__SHIFT              = 0x00000000;
constexpr unsigned int TA_CS_BC_BASE_ADDR__ADDRESS__SHIFT                 = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TA_SCRATCH__SCRATCH__SHIFT                         = 0x00000000;
constexpr unsigned int TA_STATUS__AL_BUSY__SHIFT                          = 0x0000001e;
constexpr unsigned int TA_STATUS__BUSY__SHIFT                             = 0x0000001f;
constexpr unsigned int TA_STATUS__FA_BUSY__SHIFT                          = 0x0000001d;
constexpr unsigned int TA_STATUS__FA_LFIFO_EMPTYB__SHIFT                  = 0x00000015;
constexpr unsigned int TA_STATUS__FA_PFIFO_EMPTYB__SHIFT                  = 0x00000014;
constexpr unsigned int TA_STATUS__FA_SFIFO_EMPTYB__SHIFT                  = 0x00000016;
constexpr unsigned int TA_STATUS__FG_BUSY__SHIFT                          = 0x00000019;
constexpr unsigned int TA_STATUS__FG_LFIFO_EMPTYB__SHIFT                  = 0x0000000d;
constexpr unsigned int TA_STATUS__FG_PFIFO_EMPTYB__SHIFT                  = 0x0000000c;
constexpr unsigned int TA_STATUS__FG_SFIFO_EMPTYB__SHIFT                  = 0x0000000e;
constexpr unsigned int TA_STATUS__FL_BUSY__SHIFT                          = 0x0000001b;
constexpr unsigned int TA_STATUS__FL_LFIFO_EMPTYB__SHIFT                  = 0x00000011;
constexpr unsigned int TA_STATUS__FL_PFIFO_EMPTYB__SHIFT                  = 0x00000010;
constexpr unsigned int TA_STATUS__FL_SFIFO_EMPTYB__SHIFT                  = 0x00000012;
constexpr unsigned int TA_STATUS__IN_BUSY__SHIFT                          = 0x00000018;
constexpr unsigned int TA_STATUS__LA_BUSY__SHIFT                          = 0x0000001a;
constexpr unsigned int TA_STATUS__TA_BUSY__SHIFT                          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER2__REQ_MODE__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__BUFFER__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DATA_FORMAT__SHIFT      = 0x00000003;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DIM__SHIFT              = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__FLAT__SHIFT             = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_FORMAT__SHIFT       = 0x00000004;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_SAMPLES__SHIFT      = 0x00000006;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__OPCODE_TYPE__SHIFT      = 0x00000007;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__REQ_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SCOPE__SHIFT            = 0x0000000d;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SW_MODE__SHIFT          = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__TMPRL__SHIFT            = 0x00000008;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__BUFFER__SHIFT              = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE__SHIFT  = 0x0000000c;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT__SHIFT         = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DIM__SHIFT                 = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__FLAT__SHIFT                = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT__SHIFT          = 0x0000000d;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES__SHIFT         = 0x00000016;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE__SHIFT         = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__SCOPE__SHIFT               = 0x0000001e;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE__SHIFT             = 0x00000011;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__TMPRL__SHIFT               = 0x0000001b;
constexpr unsigned int TD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER2_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int UTCL1_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int UTCL1_PERFCOUNTER3_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
constexpr unsigned int UTCL1_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int VGT_DMA_BASE_HI__BASE_ADDR__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_DMA_BASE__BASE_ADDR__SHIFT                     = 0x00000000;
constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__DISABLE_INSTANCE_PACKING__SHIFT = 0x0000000e;
constexpr unsigned int VGT_DMA_INDEX_TYPE__INDEX_TYPE__SHIFT              = 0x00000000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__MTYPE__SHIFT                   = 0x0000000b;
constexpr unsigned int VGT_DMA_INDEX_TYPE__NOT_EOP__SHIFT                 = 0x00000009;
constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY__SHIFT            = 0x00000006;
constexpr unsigned int VGT_DMA_INDEX_TYPE__SPEC_DATA_READ__SHIFT          = 0x00000011;
constexpr unsigned int VGT_DMA_INDEX_TYPE__TEMPORAL__SHIFT                = 0x0000000f;
constexpr unsigned int VGT_DMA_MAX_SIZE__MAX_SIZE__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_DMA_NUM_INSTANCES__NUM_INSTANCES__SHIFT        = 0x00000000;
constexpr unsigned int VGT_DMA_REQ_FIFO_DEPTH__DMA_REQ_FIFO_DEPTH__SHIFT  = 0x00000000;
constexpr unsigned int VGT_DMA_SIZE__NUM_INDICES__SHIFT                   = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__NOT_EOP__SHIFT                 = 0x00000005;
constexpr unsigned int VGT_DRAW_INITIATOR__REG_RT_INDEX__SHIFT            = 0x0000001d;
constexpr unsigned int VGT_DRAW_INITIATOR__SOURCE_SELECT__SHIFT           = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__USE_OPAQUE__SHIFT              = 0x00000006;
constexpr unsigned int VGT_DRAW_INIT_FIFO_DEPTH__DRAW_INIT_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_DRAW_VP__SHIFT           = 0x00000004;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_PRIM_PAYLOAD__SHIFT      = 0x00000003;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_REG_RT_INDEX__SHIFT      = 0x00000001;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_VRS_RATE__SHIFT          = 0x00000006;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__UNUSED__SHIFT               = 0x00000005;
constexpr unsigned int VGT_EVENT_ADDRESS_REG__ADDRESS_LOW__SHIFT          = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__ADDRESS_HI__SHIFT             = 0x0000000a;
constexpr unsigned int VGT_EVENT_INITIATOR__EVENT_TYPE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__EXTENDED_EVENT__SHIFT         = 0x0000001b;
constexpr unsigned int VGT_GS_INSTANCE_CNT__CNT__SHIFT                    = 0x00000002;
constexpr unsigned int VGT_GS_INSTANCE_CNT__ENABLE__SHIFT                 = 0x00000000;
constexpr unsigned int VGT_GS_INSTANCE_CNT__EN_MAX_VERT_OUT_PER_GS_INSTANCE__SHIFT = 0x0000001f;
constexpr unsigned int VGT_GS_MAX_VERT_OUT__MAX_VERT_OUT__SHIFT           = 0x00000000;
constexpr unsigned int VGT_GS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE__SHIFT          = 0x00000000;
constexpr unsigned int VGT_HOS_MAX_TESS_LEVEL__MAX_TESS__SHIFT            = 0x00000000;
constexpr unsigned int VGT_HOS_MIN_TESS_LEVEL__MIN_TESS__SHIFT            = 0x00000000;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING__SHIFT     = 0x00000000;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY__SHIFT   = 0x0000000a;
constexpr unsigned int VGT_INDEX_TYPE__DISABLE_INSTANCE_PACKING__SHIFT    = 0x0000000e;
constexpr unsigned int VGT_INDEX_TYPE__INDEX_TYPE__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_INSTANCE_BASE_ID__INSTANCE_BASE_ID__SHIFT      = 0x00000000;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_OUTPUT_CP__SHIFT          = 0x0000000e;
constexpr unsigned int VGT_LS_HS_CONFIG__NUM_PATCHES__SHIFT               = 0x00000000;
constexpr unsigned int VGT_MC_LAT_CNTL__MC_TIME_STAMP_RES__SHIFT          = 0x00000000;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_INDX__RESET_INDX__SHIFT    = 0x00000000;
constexpr unsigned int VGT_NUM_INDICES__NUM_INDICES__SHIFT                = 0x00000000;
constexpr unsigned int VGT_NUM_INSTANCES__NUM_INSTANCES__SHIFT            = 0x00000000;
constexpr unsigned int VGT_PRIMITIVEID_EN__NGG_DISABLE_PROVOK_REUSE__SHIFT = 0x00000002;
constexpr unsigned int VGT_PRIMITIVEID_RESET__VALUE__SHIFT                = 0x00000000;
constexpr unsigned int VGT_PRIMITIVE_TYPE__NUM_INPUT_CP__SHIFT            = 0x00000006;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIMS_PER_SUBGROUP__SHIFT      = 0x0000000c;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIM_TYPE__SHIFT               = 0x00000000;
constexpr unsigned int VGT_REUSE_OFF__REUSE_OFF__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_EN__SHIFT                 = 0x00000005;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH__SHIFT        = 0x00000013;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_W32_EN__SHIFT             = 0x00000016;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_EN__SHIFT                 = 0x00000002;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_W32_EN__SHIFT             = 0x00000015;
constexpr unsigned int VGT_SHADER_STAGES_EN__NGG_WAVE_ID_EN__SHIFT        = 0x00000018;
constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_PASSTHRU_NO_MSG__SHIFT = 0x0000001a;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_OFFSET__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE__VERTEX_STRIDE__SHIFT = 0x00000000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_ISOLINE__SHIFT        = 0x00000000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_QUAD__SHIFT           = 0x00000010;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_TRI__SHIFT            = 0x00000008;
constexpr unsigned int VGT_TESS_DISTRIBUTION__DONUT_SPLIT__SHIFT          = 0x00000018;
constexpr unsigned int VGT_TESS_DISTRIBUTION__TRAP_SPLIT__SHIFT           = 0x0000001d;
constexpr unsigned int VGT_TF_MEMORY_BASE_HI__BASE_HI__SHIFT              = 0x00000000;
constexpr unsigned int VGT_TF_MEMORY_BASE__BASE__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_TF_PARAM__DETECT_ONE__SHIFT                    = 0x00000013;
constexpr unsigned int VGT_TF_PARAM__DETECT_ZERO__SHIFT                   = 0x00000014;
constexpr unsigned int VGT_TF_PARAM__DISABLE_DONUTS__SHIFT                = 0x0000000e;
constexpr unsigned int VGT_TF_PARAM__DISTRIBUTION_MODE__SHIFT             = 0x00000011;
constexpr unsigned int VGT_TF_PARAM__MTYPE__SHIFT                         = 0x00000017;
constexpr unsigned int VGT_TF_PARAM__PARTITIONING__SHIFT                  = 0x00000002;
constexpr unsigned int VGT_TF_PARAM__SPEC_DATA_READ__SHIFT                = 0x0000001c;
constexpr unsigned int VGT_TF_PARAM__TEMPORAL__SHIFT                      = 0x0000000f;
constexpr unsigned int VGT_TF_PARAM__TOPOLOGY__SHIFT                      = 0x00000005;
constexpr unsigned int VGT_TF_PARAM__TYPE__SHIFT                          = 0x00000000;
constexpr unsigned int VGT_TF_RING_SIZE__SIZE__SHIFT                      = 0x00000000;
constexpr unsigned int WD_UTCL1_CNTL__BYPASS__SHIFT                       = 0x00000019;
constexpr unsigned int WD_UTCL1_CNTL__DROP_MODE__SHIFT                    = 0x00000018;
constexpr unsigned int WD_UTCL1_CNTL__FORCE_SNOOP__SHIFT                  = 0x0000001c;
constexpr unsigned int WD_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT              = 0x0000001b;
constexpr unsigned int WD_UTCL1_CNTL__INVALIDATE__SHIFT                   = 0x0000001a;
constexpr unsigned int WD_UTCL1_CNTL__LLC_NOALLOC_OVERRIDE__SHIFT         = 0x0000001e;
constexpr unsigned int WD_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT               = 0x0000001d;
constexpr unsigned int WD_UTCL1_CNTL__VMID_RESET_MODE__SHIFT              = 0x00000017;
constexpr unsigned int WD_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT         = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_DETECTED__SHIFT             = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_INSTANCEID__SHIFT           = 0x0000000e;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT              = 0x00000008;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_VMID__SHIFT                 = 0x00000004;
constexpr unsigned int WD_UTCL1_STATUS__PRT_DETECTED__SHIFT               = 0x00000002;
constexpr unsigned int WD_UTCL1_STATUS__PRT_INSTANCEID__SHIFT             = 0x0000001e;
constexpr unsigned int WD_UTCL1_STATUS__PRT_UTCL1ID__SHIFT                = 0x00000018;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_DETECTED__SHIFT             = 0x00000001;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_INSTANCEID__SHIFT           = 0x00000016;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT              = 0x00000010;
constexpr unsigned int WGS_BUSY_HYSTERESIS__CAC_ACTIVE__SHIFT             = 0x00000000;
constexpr unsigned int WGS_BUSY_HYSTERESIS__CPC_BUSY__SHIFT               = 0x00000008;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE0_DC_BUSY__SHIFT          = 0x00000012;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE1_DC_BUSY__SHIFT          = 0x00000013;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE2_DC_BUSY__SHIFT          = 0x00000014;
constexpr unsigned int WGS_BUSY_STAT2__MEC1_PIPE3_DC_BUSY__SHIFT          = 0x00000015;
constexpr unsigned int WGS_BUSY_STAT2__MES_DMA_BUSY__SHIFT                = 0x00000008;
constexpr unsigned int WGS_BUSY_STAT2__MES_LOAD_BUSY__SHIFT               = 0x00000000;
constexpr unsigned int WGS_BUSY_STAT2__MES_MESSAGE_BUSY__SHIFT            = 0x00000003;
constexpr unsigned int WGS_BUSY_STAT2__MES_MUTEX_BUSY__SHIFT              = 0x00000002;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE0_BUSY__SHIFT              = 0x0000000a;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE1_BUSY__SHIFT              = 0x0000000b;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE2_BUSY__SHIFT              = 0x0000000c;
constexpr unsigned int WGS_BUSY_STAT2__MES_PIPE3_BUSY__SHIFT              = 0x0000000d;
constexpr unsigned int WGS_BUSY_STAT2__MES_TC_BUSY__SHIFT                 = 0x00000007;
constexpr unsigned int WGS_BUSY_STAT__MEC1_DMA_BUSY__SHIFT                = 0x00000008;
constexpr unsigned int WGS_BUSY_STAT__MEC1_EOP_QUEUE_BUSY__SHIFT          = 0x00000004;
constexpr unsigned int WGS_BUSY_STAT__MEC1_IB_QUEUE_BUSY__SHIFT           = 0x00000006;
constexpr unsigned int WGS_BUSY_STAT__MEC1_IQ_QUEUE_BUSY__SHIFT           = 0x00000005;
constexpr unsigned int WGS_BUSY_STAT__MEC1_LOAD_BUSY__SHIFT               = 0x00000000;
constexpr unsigned int WGS_BUSY_STAT__MEC1_MESSAGE_BUSY__SHIFT            = 0x00000003;
constexpr unsigned int WGS_BUSY_STAT__MEC1_MUTEX_BUSY__SHIFT              = 0x00000002;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PARTIAL_FLUSH_BUSY__SHIFT      = 0x00000009;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE0_BUSY__SHIFT              = 0x0000000a;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE1_BUSY__SHIFT              = 0x0000000b;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE2_BUSY__SHIFT              = 0x0000000c;
constexpr unsigned int WGS_BUSY_STAT__MEC1_PIPE3_BUSY__SHIFT              = 0x0000000d;
constexpr unsigned int WGS_BUSY_STAT__MEC1_TC_BUSY__SHIFT                 = 0x00000007;
constexpr unsigned int WGS_BUSY_STAT__MEC2_DMA_BUSY__SHIFT                = 0x00000018;
constexpr unsigned int WGS_BUSY_STAT__MEC2_EOP_QUEUE_BUSY__SHIFT          = 0x00000014;
constexpr unsigned int WGS_BUSY_STAT__MEC2_IB_QUEUE_BUSY__SHIFT           = 0x00000016;
constexpr unsigned int WGS_BUSY_STAT__MEC2_IQ_QUEUE_BUSY__SHIFT           = 0x00000015;
constexpr unsigned int WGS_BUSY_STAT__MEC2_LOAD_BUSY__SHIFT               = 0x00000010;
constexpr unsigned int WGS_BUSY_STAT__MEC2_MESSAGE_BUSY__SHIFT            = 0x00000013;
constexpr unsigned int WGS_BUSY_STAT__MEC2_MUTEX_BUSY__SHIFT              = 0x00000012;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PARTIAL_FLUSH_BUSY__SHIFT      = 0x00000019;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE0_BUSY__SHIFT              = 0x0000001a;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE1_BUSY__SHIFT              = 0x0000001b;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE2_BUSY__SHIFT              = 0x0000001c;
constexpr unsigned int WGS_BUSY_STAT__MEC2_PIPE3_BUSY__SHIFT              = 0x0000001d;
constexpr unsigned int WGS_BUSY_STAT__MEC2_TC_BUSY__SHIFT                 = 0x00000017;
constexpr unsigned int WGS_COMPUTE_DDID_INDEX__INDEX__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE0__CU_EN__SHIFT       = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE1__CU_EN__SHIFT       = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE2__CU_EN__SHIFT       = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DESTINATION_EN_SE3__CU_EN__SHIFT       = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DIM_X__SIZE__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DIM_Y__SIZE__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DIM_Z__SIZE__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_END__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_ID__DISPATCH_ID__SHIFT        = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__AMP_SHADER_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__CS_W32_EN__SHIFT   = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__DISABLE_DISP_PREMPT_EN__SHIFT = 0x00000011;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000__SHIFT = 0x00000002;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__INTERLEAVE_2D_EN__SHIFT = 0x00000012;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL__SHIFT = 0x00000003;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE__SHIFT = 0x00000004;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__ORDER_MODE__SHIFT  = 0x00000006;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN__SHIFT = 0x00000001;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__PING_PONG_EN__SHIFT = 0x0000000c;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__RESTORE__SHIFT     = 0x0000000e;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL__SHIFT = 0x0000000a;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__TTRACE_QUEUE_ID__SHIFT = 0x0000001d;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS__SHIFT = 0x00000005;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL__SHIFT = 0x0000000b;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INITIATOR__WGS_DISPATCH__SHIFT = 0x00000013;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_1D__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_X_SIZE__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_DISPATCH_INTERLEAVE__INTERLEAVE_2D_Y_SIZE__SHIFT = 0x00000018;
constexpr unsigned int WGS_COMPUTE_DISPATCH_PKT_ADDR_HI__DATA__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_PKT_ADDR_LO__DATA__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA__SHIFT  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA__SHIFT  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_DISPATCH_TUNNEL__OFF_DELAY__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__RESERVED4__SHIFT        = 0x00000004;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__SEND_SEID__SHIFT        = 0x00000000;
constexpr unsigned int WGS_COMPUTE_MISC_RESERVED__WAVE_ID_BASE__SHIFT     = 0x00000005;
constexpr unsigned int WGS_COMPUTE_NOWHERE__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__INTERLEAVE_BITS_X__SHIFT = 0x0000000d;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL__SHIFT   = 0x00000000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__INTERLEAVE_BITS_Y__SHIFT = 0x0000000d;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL__SHIFT   = 0x00000000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL__SHIFT   = 0x00000000;
constexpr unsigned int WGS_COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PGM_HI__DATA__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PGM_LO__DATA__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__BULKY__SHIFT                = 0x00000018;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__CDBG_USER__SHIFT            = 0x00000019;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__DEBUG_MODE__SHIFT           = 0x00000016;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__DISABLE_PERF__SHIFT         = 0x00000017;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FLOAT_MODE__SHIFT           = 0x0000000c;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FP16_OVFL__SHIFT            = 0x0000001a;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__FWD_PROGRESS__SHIFT         = 0x0000001f;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__PRIORITY__SHIFT             = 0x0000000a;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__PRIV__SHIFT                 = 0x00000014;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__SGPRS__SHIFT                = 0x00000006;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__VGPRS__SHIFT                = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__WGP_MODE__SHIFT             = 0x0000001d;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC1__WG_RR_EN__SHIFT             = 0x00000015;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__DYNAMIC_VGPR__SHIFT         = 0x00000006;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__EXCP_EN_MSB__SHIFT          = 0x0000000d;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__EXCP_EN__SHIFT              = 0x00000018;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__LDS_SIZE__SHIFT             = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__SCRATCH_EN__SHIFT           = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_X_EN__SHIFT            = 0x00000007;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_Y_EN__SHIFT            = 0x00000008;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TGID_Z_EN__SHIFT            = 0x00000009;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TG_SIZE_EN__SHIFT           = 0x0000000a;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT__SHIFT       = 0x0000000b;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__USER_SGPR__SHIFT            = 0x00000001;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC2__WGP_TAKEOVER__SHIFT         = 0x0000001f;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__GLG_EN__SHIFT               = 0x0000000d;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__IMAGE_OP__SHIFT             = 0x0000001f;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__INST_PREF_SIZE__SHIFT       = 0x00000004;
constexpr unsigned int WGS_COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_X__SIZE__SHIFT           = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_Y__SIZE__SHIFT           = 0x00000000;
constexpr unsigned int WGS_COMPUTE_PRESCALED_DIM_Z__SIZE__SHIFT           = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__IS_EVENT__SHIFT             = 0x0000001e;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__IS_STATE__SHIFT             = 0x0000001f;
constexpr unsigned int WGS_COMPUTE_RELAUNCH2__PAYLOAD__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__IS_EVENT__SHIFT              = 0x0000001e;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__IS_STATE__SHIFT              = 0x0000001f;
constexpr unsigned int WGS_COMPUTE_RELAUNCH__PAYLOAD__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT__SHIFT = 0x00000014;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN__SHIFT    = 0x00000010;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS__SHIFT  = 0x00000009;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
constexpr unsigned int WGS_COMPUTE_REQ_CTRL__SOFT_GROUPING_EN__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT__SHIFT = 0x00000018;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST__SHIFT = 0x00000017;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL__SHIFT = 0x00000016;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__TG_PER_CU__SHIFT      = 0x0000000c;
constexpr unsigned int WGS_COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH__SHIFT   = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RESTART_X__RESTART__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RESTART_Y__RESTART__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_RESTART_Z__RESTART__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_SHADER_CHKSUM__CHECKSUM__SHIFT         = 0x00000000;
constexpr unsigned int WGS_COMPUTE_START_X__START__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_START_Y__START__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_START_Z__START__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE4__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE4__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE5__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE5__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE6__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE6__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE7__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE7__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE8__SA0_CU_EN__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_STATIC_THREAD_MGMT_SE8__SA1_CU_EN__SHIFT = 0x00000010;
constexpr unsigned int WGS_COMPUTE_THREADGROUP_ID__THREADGROUP_ID__SHIFT  = 0x00000000;
constexpr unsigned int WGS_COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int WGS_COMPUTE_TMPRING_SIZE__WAVESIZE__SHIFT          = 0x0000000c;
constexpr unsigned int WGS_COMPUTE_TMPRING_SIZE__WAVES__SHIFT             = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_0__CONTRIBUTION__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_1__CONTRIBUTION__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_2__CONTRIBUTION__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_ACCUM_3__CONTRIBUTION__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_0__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_1__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_2__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_3__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_4__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_5__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_6__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_7__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_8__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_9__DATA__SHIFT               = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_10__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_11__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_12__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_13__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_14__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_USER_DATA_15__DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_COMPUTE_VMID__DATA__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR__SHIFT      = 0x00000000;
constexpr unsigned int WGS_COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR__SHIFT      = 0x00000000;
constexpr unsigned int WGS_DATA1__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA2__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA3__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA4__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA5__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA6__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA7__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA8__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA9__DATA__SHIFT                             = 0x00000000;
constexpr unsigned int WGS_DATA10__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA11__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA12__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA13__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA14__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA15__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DATA16__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE0_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE0_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE0_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE1_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE1_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE1_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE2_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE2_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE2_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE3_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE3_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE3_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE4_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE4_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE4_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE5_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE5_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE5_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE6_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE6_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE6_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE7_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE7_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE7_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE8_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE8_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE8_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE9_BASE__BASE__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__BYPASS_MODE__SHIFT          = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__ENABLE__SHIFT               = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__SCOPE__SHIFT                = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__TEMPORAL__SHIFT             = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE9_CNTL__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE9_MASK__MASK__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE10_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE10_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE10_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE11_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE11_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE11_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE12_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE12_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE12_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE13_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE13_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE13_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE14_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE14_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE14_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE15_BASE__BASE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__BYPASS_MODE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__ENABLE__SHIFT              = 0x00000005;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__SCOPE__SHIFT               = 0x00000006;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__TEMPORAL__SHIFT            = 0x00000008;
constexpr unsigned int WGS_DC_APERTURE15_CNTL__VMID__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_APERTURE15_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int WGS_DC_BASE_CNTL__VMID__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_DC_BASE_HI__DC_BASE_HI__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_DC_BASE_LO__DC_BASE_LO__SHIFT                  = 0x00000010;
constexpr unsigned int WGS_DC_OP_CNTL__BYPASS_ALL__SHIFT                  = 0x00000002;
constexpr unsigned int WGS_DC_OP_CNTL__INVALIDATE_DCACHE_COMPLETE__SHIFT  = 0x00000001;
constexpr unsigned int WGS_DC_OP_CNTL__INVALIDATE_DCACHE__SHIFT           = 0x00000000;
constexpr unsigned int WGS_DDID_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int WGS_DDID_BASE_ADDR_LO__BASE_ADDR_LO__SHIFT         = 0x00000006;
constexpr unsigned int WGS_DDID_CNTL__ENABLE__SHIFT                       = 0x0000001f;
constexpr unsigned int WGS_DDID_CNTL__MODE__SHIFT                         = 0x0000001e;
constexpr unsigned int WGS_DDID_CNTL__NO_RING_MEMORY__SHIFT               = 0x00000013;
constexpr unsigned int WGS_DDID_CNTL__POLICY__SHIFT                       = 0x0000001c;
constexpr unsigned int WGS_DDID_CNTL__SIZE__SHIFT                         = 0x00000010;
constexpr unsigned int WGS_DDID_CNTL__THRESHOLD__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_DM_INDEX_ADDR__ADDR__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_DM_INDEX_DATA__DATA__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_ENDIAN_SWAP__ENDIAN_SWAP__SHIFT                = 0x00000000;
constexpr unsigned int WGS_ERROR__RESERVED__SHIFT                         = 0x00000000;
constexpr unsigned int WGS_GEN_BASE_HI__BASE_HI__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_GEN_BASE_LO__BASE_LO__SHIFT                    = 0x0000000c;
constexpr unsigned int WGS_GP0_HI__M_RET_ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_GP0_LO__DATA__SHIFT                            = 0x00000001;
constexpr unsigned int WGS_GP0_LO__PG_VIRT_HALTED__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_GP1_HI__RD_WR_SELECT_HI__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_GP1_LO__RD_WR_SELECT_LO__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_GP2_HI__STACK_PNTR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_GP2_LO__STACK_PNTR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_GP3_HI__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP3_LO__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP4_HI__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP4_LO__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP5_HI__M_RET_ADDR__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_GP5_LO__DATA__SHIFT                            = 0x00000001;
constexpr unsigned int WGS_GP5_LO__PG_VIRT_HALTED__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_GP6_HI__RD_WR_SELECT_HI__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_GP6_LO__RD_WR_SELECT_LO__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_GP7_HI__STACK_PNTR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_GP7_LO__STACK_PNTR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_GP8_HI__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP8_LO__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP9_HI__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_GP9_LO__DATA__SHIFT                            = 0x00000000;
constexpr unsigned int WGS_HALT_HYST_COUNT__COUNT__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_IC_BASE_CNTL__CACHE_POLICY__SHIFT              = 0x00000018;
constexpr unsigned int WGS_IC_BASE_CNTL__EXE_DISABLE__SHIFT               = 0x00000017;
constexpr unsigned int WGS_IC_BASE_CNTL__PER_PIPE__SHIFT                  = 0x00000005;
constexpr unsigned int WGS_IC_BASE_CNTL__SCOPE__SHIFT                     = 0x00000006;
constexpr unsigned int WGS_IC_BASE_CNTL__TEMPORAL__SHIFT                  = 0x00000008;
constexpr unsigned int WGS_IC_BASE_CNTL__VMID__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_IC_BASE_HI__IC_BASE_HI__SHIFT                  = 0x00000000;
constexpr unsigned int WGS_IC_BASE_LO__IC_BASE_LO__SHIFT                  = 0x0000000c;
constexpr unsigned int WGS_IC_OP_CNTL__HALT_ON_PRIME__SHIFT               = 0x00000002;
constexpr unsigned int WGS_IC_OP_CNTL__ICACHE_PRIMED__SHIFT               = 0x00000005;
constexpr unsigned int WGS_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE__SHIFT   = 0x00000001;
constexpr unsigned int WGS_IC_OP_CNTL__INVALIDATE_CACHE__SHIFT            = 0x00000000;
constexpr unsigned int WGS_IC_OP_CNTL__PRIME_ICACHE__SHIFT                = 0x00000004;
constexpr unsigned int WGS_IC_OP_CNTL__PRIME_START_PC__SHIFT              = 0x00000003;
constexpr unsigned int WGS_IH_FREE_COUNT__COUNT__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_INT_CNTXID_HI__DATA__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_INT_CNTXID_LO__DATA__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_INT_INFO__RING_ID__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_INT_INFO__VMID__SHIFT                          = 0x00000008;
constexpr unsigned int WGS_INT_STATUS__SEND__SHIFT                        = 0x00000008;
constexpr unsigned int WGS_INT_STATUS__SOURCE_ID__SHIFT                   = 0x00000000;
constexpr unsigned int WGS_IQ_TIMER_MESSAGE__MESSAGE__SHIFT               = 0x00000000;
constexpr unsigned int WGS_IQ_TIMER__ACTIVE__SHIFT                        = 0x0000001f;
constexpr unsigned int WGS_IQ_TIMER__CLOCK_COUNT__SHIFT                   = 0x0000000e;
constexpr unsigned int WGS_IQ_TIMER__IMMEDIATE_EXPIRE__SHIFT              = 0x0000000b;
constexpr unsigned int WGS_IQ_TIMER__INTERRUPT_TYPE__SHIFT                = 0x0000000c;
constexpr unsigned int WGS_IQ_TIMER__QUANTUM_TIMER__SHIFT                 = 0x00000016;
constexpr unsigned int WGS_IQ_TIMER__QUEUE_TYPE__SHIFT                    = 0x0000001b;
constexpr unsigned int WGS_IQ_TIMER__REARM_TIMER__SHIFT                   = 0x0000001c;
constexpr unsigned int WGS_IQ_TIMER__RESERVED1__SHIFT                     = 0x0000001d;
constexpr unsigned int WGS_IQ_TIMER__RESERVED2__SHIFT                     = 0x00000017;
constexpr unsigned int WGS_IQ_TIMER__RESERVED3__SHIFT                     = 0x00000010;
constexpr unsigned int WGS_IQ_TIMER__RETRY_TYPE__SHIFT                    = 0x00000008;
constexpr unsigned int WGS_IQ_TIMER__WAIT_TIME__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_IQ_WAIT_TIME1__ATOMIC_OFFLOAD__SHIFT           = 0x00000008;
constexpr unsigned int WGS_IQ_WAIT_TIME1__GWS__SHIFT                      = 0x00000018;
constexpr unsigned int WGS_IQ_WAIT_TIME1__IB_OFFLOAD__SHIFT               = 0x00000000;
constexpr unsigned int WGS_IQ_WAIT_TIME1__WRM_OFFLOAD__SHIFT              = 0x00000010;
constexpr unsigned int WGS_IQ_WAIT_TIME2__DEQ_RETRY__SHIFT                = 0x00000018;
constexpr unsigned int WGS_IQ_WAIT_TIME2__QUE_SLEEP__SHIFT                = 0x00000000;
constexpr unsigned int WGS_IQ_WAIT_TIME2__SCH_WAVE__SHIFT                 = 0x00000008;
constexpr unsigned int WGS_IQ_WAIT_TIME3__SUSPEND_QUE__SHIFT              = 0x00000000;
constexpr unsigned int WGS_LATENCY_STATS_DATA__DATA__SHIFT                = 0x00000000;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__CLEAR__SHIFT             = 0x0000001e;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__ENABLE__SHIFT            = 0x0000001f;
constexpr unsigned int WGS_LATENCY_STATS_SELECT__INDEX__SHIFT             = 0x00000000;
constexpr unsigned int WGS_LOCAL_APERTURE__APERTURE__SHIFT                = 0x00000000;
constexpr unsigned int WGS_LOCAL_APERTURE__SCOPE__SHIFT                   = 0x00000006;
constexpr unsigned int WGS_LOCAL_APERTURE__TEMPORAL__SHIFT                = 0x00000008;
constexpr unsigned int WGS_LOCAL_BASE0_HI__BASE0_HI__SHIFT                = 0x00000000;
constexpr unsigned int WGS_LOCAL_BASE0_LO__BASE0_LO__SHIFT                = 0x00000010;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__APERTURE__SHIFT          = 0x00000000;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__SCOPE__SHIFT             = 0x00000006;
constexpr unsigned int WGS_LOCAL_INSTR_APERTURE__TEMPORAL__SHIFT          = 0x00000008;
constexpr unsigned int WGS_LOCAL_INSTR_BASE_HI__BASE_HI__SHIFT            = 0x00000000;
constexpr unsigned int WGS_LOCAL_INSTR_BASE_LO__BASE_LO__SHIFT            = 0x00000010;
constexpr unsigned int WGS_LOCAL_INSTR_MASK_HI__MASK_HI__SHIFT            = 0x00000000;
constexpr unsigned int WGS_LOCAL_INSTR_MASK_LO__MASK_LO__SHIFT            = 0x00000010;
constexpr unsigned int WGS_LOCAL_MASK0_HI__MASK0_HI__SHIFT                = 0x00000000;
constexpr unsigned int WGS_LOCAL_MASK0_LO__MASK0_LO__SHIFT                = 0x00000010;
constexpr unsigned int WGS_LOCAL_SCRATCH_APERTURE__APERTURE__SHIFT        = 0x00000000;
constexpr unsigned int WGS_LOCAL_SCRATCH_BASE_HI__BASE_HI__SHIFT          = 0x00000000;
constexpr unsigned int WGS_LOCAL_SCRATCH_BASE_LO__BASE_LO__SHIFT          = 0x00000010;
constexpr unsigned int WGS_MDBASE_HI__BASE_HI__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_MDBASE_LO__BASE_LO__SHIFT                      = 0x00000010;
constexpr unsigned int WGS_MDBOUND_HI__BOUND_HI__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_MDBOUND_LO__BOUND_LO__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_ME1_HEADER_DUMP__HEADER_DUMP__SHIFT            = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE0_PRIORITY__PRIORITY__SHIFT            = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE1_PRIORITY__PRIORITY__SHIFT            = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE2_PRIORITY__PRIORITY__SHIFT            = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE3_PRIORITY__PRIORITY__SHIFT            = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT   = 0x00000000;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT  = 0x00000008;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT  = 0x00000010;
constexpr unsigned int WGS_ME1_PIPE_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT   = 0x00000018;
constexpr unsigned int WGS_METADATA_BASE_ADDR_HI__MD_BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int WGS_METADATA_BASE_ADDR_LO__MD_BASE_LO__SHIFT       = 0x00000002;
constexpr unsigned int WGS_METADATA_CNTL__EVENT1__SHIFT                   = 0x0000000b;
constexpr unsigned int WGS_METADATA_CNTL__EVENT_MODE__SHIFT               = 0x00000004;
constexpr unsigned int WGS_METADATA_CNTL__QUEUE_ID__SHIFT                 = 0x0000000c;
constexpr unsigned int WGS_METADATA_CNTL__SCOPE__SHIFT                    = 0x00000006;
constexpr unsigned int WGS_METADATA_CNTL__TEMPORAL__SHIFT                 = 0x00000008;
constexpr unsigned int WGS_METADATA_CNTL__VMID__SHIFT                     = 0x00000000;
constexpr unsigned int WGS_MGCG_SYNC_CNTL__COOLDOWN_PERIOD__SHIFT         = 0x00000000;
constexpr unsigned int WGS_MGCG_SYNC_CNTL__WARMUP_PERIOD__SHIFT           = 0x00000008;
constexpr unsigned int WGS_MIBOUND_HI__BOUND_HI__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_MIBOUND_LO__BOUND_LO__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_MIE_HI__MEC_INT__SHIFT                         = 0x00000000;
constexpr unsigned int WGS_MIE_LO__MEC_INT__SHIFT                         = 0x00000000;
constexpr unsigned int WGS_MIP_HI__MIP_HI__SHIFT                          = 0x00000000;
constexpr unsigned int WGS_MIP_LO__MIP_LO__SHIFT                          = 0x00000000;
constexpr unsigned int WGS_MTIMECMP_HI__TIME_HI__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_MTIMECMP_LO__TIME_LO__SHIFT                    = 0x00000000;
constexpr unsigned int WGS_MTVEC_HI__ADDR_LO__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_MTVEC_LO__ADDR_LO__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_OS_PIPES__OS_PIPES__SHIFT                      = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int WGS_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int WGS_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int WGS_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_ENABLE_MODE__SHIFT       = 0x00000008;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT     = 0x0000000a;
constexpr unsigned int WGS_PERFMON_CNTL__PERFMON_STATE__SHIFT             = 0x00000000;
constexpr unsigned int WGS_PERFMON_CNTL__SPM_PERFMON_STATE__SHIFT         = 0x00000004;
constexpr unsigned int WGS_RS64_CNTL__MEC_HALT__SHIFT                     = 0x0000001e;
constexpr unsigned int WGS_RS64_CNTL__MEC_INVALIDATE_ICACHE__SHIFT        = 0x00000004;
constexpr unsigned int WGS_RS64_CNTL__MEC_STEP__SHIFT                     = 0x0000001f;
constexpr unsigned int WGS_RS64_CNTL__RSRV1__SHIFT                        = 0x0000001d;
constexpr unsigned int WGS_RS64_CNTL__RSRV2__SHIFT                        = 0x0000001c;
constexpr unsigned int WGS_RS64_CNTL__RSRV3__SHIFT                        = 0x0000001b;
constexpr unsigned int WGS_RS64_CNTL__RSRV4__SHIFT                        = 0x0000001a;
constexpr unsigned int WGS_RS64_CNTL__RSRV5__SHIFT                        = 0x00000013;
constexpr unsigned int WGS_RS64_CNTL__RSRV6__SHIFT                        = 0x00000012;
constexpr unsigned int WGS_RS64_CNTL__RSRV7__SHIFT                        = 0x00000011;
constexpr unsigned int WGS_RS64_CNTL__RSRV8__SHIFT                        = 0x00000010;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_ILLEGAL_INSTRUCTION__SHIFT = 0x00000000;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_INSTRUCTION_ADDR__SHIFT = 0x00000004;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_MISALIGNED_ADDR__SHIFT = 0x00000001;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_PAGE_FAULT__SHIFT = 0x00000003;
constexpr unsigned int WGS_RS64_EXCEPTION_STATUS__RS64_EXCEPTION_UNALIGNED_INSTRUTCION__SHIFT = 0x00000002;
constexpr unsigned int WGS_RS64_INSTR_PNTR__INSTR_PNTR__SHIFT             = 0x00000000;
constexpr unsigned int WGS_RS64_INTERRUPT__MEC_INT__SHIFT                 = 0x00000000;
constexpr unsigned int WGS_RS64_PENDING_INTERRUPT__PENDING_INTERRUPT__SHIFT = 0x00000000;
constexpr unsigned int WGS_RS64_PERFCOUNT_CNTL__EVENT_SEL__SHIFT          = 0x00000000;
constexpr unsigned int WGS_RS64_PRGRM_CNTR_START_HI__IP_START__SHIFT      = 0x00000000;
constexpr unsigned int WGS_RS64_PRGRM_CNTR_START__IP_START__SHIFT         = 0x00000000;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_ILLEGAL_INSTRUCTION__SHIFT = 0x00000000;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_INSTRUCTION_ADDR__SHIFT = 0x00000004;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_MISALIGNED_ADDR__SHIFT = 0x00000001;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_PAGE_FAULT__SHIFT = 0x00000003;
constexpr unsigned int WGS_RS64_PRIV_LEVEL_VIOLATION_STATUS__RS64_EXCEPTION_UNALIGNED_INSTRUTCION__SHIFT = 0x00000002;
constexpr unsigned int WGS_RS64_PRIV_LEVEL__GRBM_PRIV_LEVEL__SHIFT        = 0x00000001;
constexpr unsigned int WGS_RS64_PRIV_LEVEL__PRIV_LEVEL__SHIFT             = 0x00000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_INVALIDATE_ICACHE__SHIFT = 0x00000004;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_PIPE_ACTIVE__SHIFT       = 0x0000001a;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_PIPE_RESET__SHIFT        = 0x00000010;
constexpr unsigned int WGS_RS64_THREAD_CNTL__MEC_STATUS__SHIFT            = 0x00000000;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV1__SHIFT                 = 0x0000001f;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV2__SHIFT                 = 0x0000001d;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV3__SHIFT                 = 0x0000001c;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV4__SHIFT                 = 0x0000001b;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV5__SHIFT                 = 0x00000013;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV6__SHIFT                 = 0x00000012;
constexpr unsigned int WGS_RS64_THREAD_CNTL__RSRV7__SHIFT                 = 0x00000011;
constexpr unsigned int WGS_RS64_THREAD_CNTL__SPARE__SHIFT                 = 0x0000001e;
constexpr unsigned int WGS_SCRATCH_DATA__SCRATCH_DATA__SHIFT              = 0x00000000;
constexpr unsigned int WGS_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE__SHIFT = 0x0000001f;
constexpr unsigned int WGS_SCRATCH_INDEX__SCRATCH_INDEX__SHIFT            = 0x00000000;
constexpr unsigned int WGS_SECURE_REG0__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_SECURE_REG1__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_SECURE_REG2__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_SECURE_REG3__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_STALLED_STAT1__GCRIU_WAITING_ON_FREE__SHIFT    = 0x00000019;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_DECODING_PACKET__SHIFT     = 0x00000008;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_RCIU_READ__SHIFT   = 0x0000000a;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_RCIU__SHIFT        = 0x00000009;
constexpr unsigned int WGS_STALLED_STAT1__MEC1_WAIT_ON_ROQ_DATA__SHIFT    = 0x0000000d;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_DECODING_PACKET__SHIFT     = 0x00000010;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_RCIU_READ__SHIFT   = 0x00000012;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_RCIU__SHIFT        = 0x00000011;
constexpr unsigned int WGS_STALLED_STAT1__MEC2_WAIT_ON_ROQ_DATA__SHIFT    = 0x00000015;
constexpr unsigned int WGS_STALLED_STAT1__RCIU_PRIV_VIOLATION__SHIFT      = 0x00000004;
constexpr unsigned int WGS_STALLED_STAT1__RCIU_TX_FREE_STALL__SHIFT       = 0x00000003;
constexpr unsigned int WGS_STALLED_STAT1__TCIU_TX_FREE_STALL__SHIFT       = 0x00000006;
constexpr unsigned int WGS_STALLED_STAT1__TCIU_WAITING_ON_TAGS__SHIFT     = 0x00000007;
constexpr unsigned int WGS_STALLED_STAT1__UTCL1_WAITING_ON_TRANS__SHIFT   = 0x00000018;
constexpr unsigned int WGS_STALLED_STAT1__UTCL2IU_WAITING_ON_FREE__SHIFT  = 0x00000016;
constexpr unsigned int WGS_STALLED_STAT1__UTCL2IU_WAITING_ON_TAGS__SHIFT  = 0x00000017;
constexpr unsigned int WGS_STATUS__DC0_BUSY__SHIFT                        = 0x00000002;
constexpr unsigned int WGS_STATUS__DC1_BUSY__SHIFT                        = 0x00000003;
constexpr unsigned int WGS_STATUS__GCRIU_BUSY__SHIFT                      = 0x0000000f;
constexpr unsigned int WGS_STATUS__GL1_XNACK__SHIFT                       = 0x00000016;
constexpr unsigned int WGS_STATUS__MEC1_BUSY__SHIFT                       = 0x00000000;
constexpr unsigned int WGS_STATUS__MEC2_BUSY__SHIFT                       = 0x00000001;
constexpr unsigned int WGS_STATUS__MEC_DATA_CACHE_BUSY__SHIFT             = 0x00000015;
constexpr unsigned int WGS_STATUS__MES_BUSY__SHIFT                        = 0x00000010;
constexpr unsigned int WGS_STATUS__MES_DATA_CACHE_BUSY__SHIFT             = 0x00000014;
constexpr unsigned int WGS_STATUS__MES_INSTRUCTION_CACHE_BUSY__SHIFT      = 0x00000013;
constexpr unsigned int WGS_STATUS__MES_SCRATCH_RAM_BUSY__SHIFT            = 0x00000011;
constexpr unsigned int WGS_STATUS__QU_BUSY__SHIFT                         = 0x0000000c;
constexpr unsigned int WGS_STATUS__RCIU1_BUSY__SHIFT                      = 0x00000004;
constexpr unsigned int WGS_STATUS__RCIU2_BUSY__SHIFT                      = 0x00000005;
constexpr unsigned int WGS_STATUS__RCIU3_BUSY__SHIFT                      = 0x00000012;
constexpr unsigned int WGS_STATUS__ROQ1_BUSY__SHIFT                       = 0x00000006;
constexpr unsigned int WGS_STATUS__ROQ2_BUSY__SHIFT                       = 0x00000007;
constexpr unsigned int WGS_STATUS__RSRV__SHIFT                            = 0x00000018;
constexpr unsigned int WGS_STATUS__SAVE_RESTORE_BUSY__SHIFT               = 0x0000000e;
constexpr unsigned int WGS_STATUS__SCRATCH_RAM_BUSY__SHIFT                = 0x0000000b;
constexpr unsigned int WGS_STATUS__TCIU_BUSY__SHIFT                       = 0x0000000a;
constexpr unsigned int WGS_STATUS__TMZ_STATE__SHIFT                       = 0x00000008;
constexpr unsigned int WGS_STATUS__UTCL2IU_BUSY__SHIFT                    = 0x0000000d;
constexpr unsigned int WGS_STATUS__VMID_TMZ__SHIFT                        = 0x00000009;
constexpr unsigned int WGS_STATUS__WGS_BUSY__SHIFT                        = 0x0000001f;
constexpr unsigned int WGS_SUSPEND_CNTL_STACK_OFFSET__OFFSET__SHIFT       = 0x00000002;
constexpr unsigned int WGS_SUSPEND_CNTL_STACK_SIZE__SIZE__SHIFT           = 0x0000000c;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_BASE_ADDR_HI__ADDR_HI__SHIFT  = 0x00000000;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_BASE_ADDR_LO__ADDR__SHIFT     = 0x0000000c;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_CONTROL__EXE_DISABLE__SHIFT   = 0x00000017;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_CONTROL__POLICY__SHIFT        = 0x00000003;
constexpr unsigned int WGS_SUSPEND_CTX_SAVE_SIZE__SIZE__SHIFT             = 0x0000000c;
constexpr unsigned int WGS_SUSPEND_RESUME_REQ__RESUME_REQ__SHIFT          = 0x00000001;
constexpr unsigned int WGS_SUSPEND_RESUME_REQ__SUSPEND_REQ__SHIFT         = 0x00000000;
constexpr unsigned int WGS_SUSPEND_WG_STATE_OFFSET__OFFSET__SHIFT         = 0x00000002;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__ALWAYS__SHIFT   = 0x0000001e;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__ENABLE__SHIFT   = 0x0000001f;
constexpr unsigned int WGS_TC_PERF_COUNTER_WINDOW_SELECT__INDEX__SHIFT    = 0x00000000;
constexpr unsigned int WGS_TMZ_CNTL__PTE_DISABLE__SHIFT                   = 0x00000000;

} // inline namespace Chip
} // namespace Gfx12
} // namespace Pal
