/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx9
{
inline namespace Chip
{
constexpr unsigned int mmCB_DCC_CONFIG_DEFAULT                            = 0x0000;
constexpr unsigned int mmCB_HW_CONTROL_3_DEFAULT                          = 0x0000;
constexpr unsigned int mmCB_PERFCOUNTER_FILTER_DEFAULT                    = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHA_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCHA_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCHA_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCHC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCHC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCHC_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCHC_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmCOHER_DEST_BASE_0_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_1_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_2_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_3_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_0_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_1_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_2_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOHER_DEST_BASE_HI_3_DEFAULT                     = 0x0000;
constexpr unsigned int mmCOMPUTE_DISPATCH_ID_DEFAULT                      = 0x0000;
constexpr unsigned int mmCOMPUTE_PIPELINESTAT_ENABLE_DEFAULT              = 0x0001;
constexpr unsigned int mmCOMPUTE_RESTART_X_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_RESTART_Y_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_RESTART_Z_DEFAULT                        = 0x0000;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE0_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE1_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE2_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE3_DEFAULT           = 0xFFFFFFFF;
constexpr unsigned int mmCOMPUTE_THREADGROUP_ID_DEFAULT                   = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPF_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPF_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmCPG_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCPG_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_ME_COHER_BASE_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_BASE_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_ME_COHER_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_SIZE_DEFAULT                         = 0x0000;
constexpr unsigned int mmCP_ME_COHER_SIZE_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmCP_ME_COHER_STATUS_DEFAULT                       = 0x0000;
constexpr unsigned int mmCP_PERFMON_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmCP_PERFMON_CNTX_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_HI_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_LO_DEFAULT                   = 0x0000;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmDB_CREDIT_LIMIT_DEFAULT                          = 0x0000;
constexpr unsigned int mmDB_EQUAD_STUTTER_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_ETILE_STUTTER_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_FGCG_INTERFACES_CLK_CTRL_DEFAULT              = 0x0000;
constexpr unsigned int mmDB_FGCG_SRAMS_CLK_CTRL_DEFAULT                   = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH1_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH2_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FIFO_DEPTH3_DEFAULT                           = 0x0000;
constexpr unsigned int mmDB_FREE_CACHELINES_DEFAULT                       = 0x0000;
constexpr unsigned int mmDB_LQUAD_STUTTER_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_LTILE_STUTTER_CONTROL_DEFAULT                 = 0x0000;
constexpr unsigned int mmDB_MEM_ARB_WATERMARKS_DEFAULT                    = 0x4040404;
constexpr unsigned int mmDB_RING_CONTROL_DEFAULT                          = 0x0001;
constexpr unsigned int mmDB_SUBTILE_CONTROL_DEFAULT                       = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG_DEFAULT                    = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG_DEFAULT                    = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER2_MODE_DEFAULT                   = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGCEA_PERFCOUNTER_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL_DEFAULT               = 0x4000000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG_DEFAULT              = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI_DEFAULT                = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO_DEFAULT                = 0x0000;
constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT         = 0x4000000;
constexpr unsigned int mmGCR_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCR_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE_DEFAULT               = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO_DEFAULT                 = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE_DEFAULT               = 0x0000;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1_DEFAULT            = 0xFFFFF;
constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT_DEFAULT             = 0xFFFFF;
constexpr unsigned int mmGE_MAX_OUTPUT_PER_SUBGROUP_DEFAULT               = 0x0000;
constexpr unsigned int mmGE_PC_ALLOC_DEFAULT                              = 0x0000;
constexpr unsigned int mmGE_STATUS_DEFAULT                                = 0x0000;
constexpr unsigned int mmGE_USER_VGPR1_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_USER_VGPR2_DEFAULT                            = 0x0000;
constexpr unsigned int mmGE_USER_VGPR3_DEFAULT                            = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1A_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL1A_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL1A_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL1C_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL1C_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL1C_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL1C_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL2A_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2A_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL2A_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL2C_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT1_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmGL2C_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGL2C_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
constexpr unsigned int mmGRBM_GFX_INDEX_DEFAULT                           = 0xE0000000;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_DATA_DEFAULT                   = 0xE0000000;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_HI_DEFAULT              = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_DEFAULT                 = 0x0000;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_HI_DEFAULT              = 0x0000;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
constexpr unsigned int mmIA_UTCL1_CNTL_DEFAULT                            = 0x0080;
constexpr unsigned int mmIA_UTCL1_STATUS_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_PH_ENHANCE_DEFAULT                            = 0x1000;
constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE_DEFAULT               = 0x8000000;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1_DEFAULT                = 0x82000008;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3_DEFAULT                = 0xC2400024;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_DSM_CNTL_DEFAULT                           = 0x0000;
constexpr unsigned int mmPA_SC_FIFO_SIZE_DEFAULT                          = 0x0000;
constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS_DEFAULT                 = 0xFFFFFF;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_EN_DEFAULT             = 0x0000;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK_DEFAULT           = 0x0000;
constexpr unsigned int mmPA_SC_IF_FIFO_SIZE_DEFAULT                       = 0x0000;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_STATE_DEFAULT                 = 0x0000;
constexpr unsigned int mmPA_SC_MODE_CNTL_1_DEFAULT                        = 0x6000000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_EN_DEFAULT              = 0x0000;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK_DEFAULT            = 0x0000;
constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL_DEFAULT                = 0x0000;
constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE_DEFAULT       = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_EN_DEFAULT                  = 0x0000;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
constexpr unsigned int mmRLC_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
constexpr unsigned int mmRLC_PERFMON_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRL_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT_DEFAULT            = 0x0000;
constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED_DEFAULT          = 0x0001;
constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD_DEFAULT                  = 0x0001;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA_DEFAULT               = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_CNTL_DEFAULT                         = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_INFO_1_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_INT_INFO_2_DEFAULT                       = 0xCA0000;
constexpr unsigned int mmRLC_SPM_INT_STATUS_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_MC_CNTL_DEFAULT                          = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_HI_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_LO_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE_DEFAULT             = 0x0000;
constexpr unsigned int mmRLC_SPM_RING_RDPTR_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_RING_WRPTR_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_SAMPLE_CNT_DEFAULT                       = 0x0000;
constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA_DEFAULT                   = 0x0000;
constexpr unsigned int mmRLC_SPM_THREAD_TRACE_CTRL_DEFAULT                = 0x0000;
constexpr unsigned int mmRLC_SPM_UTCL1_CNTL_DEFAULT                       = 0x0080;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_1_DEFAULT                    = 0x0000;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_2_DEFAULT                    = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmRMI_PERF_COUNTER_CNTL_DEFAULT                    = 0x80240;
constexpr unsigned int mmRPB_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER2_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER3_CFG_DEFAULT                     = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
constexpr unsigned int mmRPB_PERF_COUNTER_CNTL_DEFAULT                    = 0x0010;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
constexpr unsigned int mmSPI_ARB_CNTL_0_DEFAULT                           = 0x0000;
constexpr unsigned int mmSPI_ARB_CYCLES_0_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_ARB_CYCLES_1_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_ARB_PRIORITY_DEFAULT                         = 0x0000;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_DEFAULT                  = 0x0000;
constexpr unsigned int mmSPI_CONFIG_CNTL_DEFAULT                          = 0xC062C688;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_2_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_3_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_STATUS_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_DSM_CNTL2_DEFAULT                            = 0x0000;
constexpr unsigned int mmSPI_DSM_CNTL_DEFAULT                             = 0x0000;
constexpr unsigned int mmSPI_GFX_CNTL_DEFAULT                             = 0x0000;
constexpr unsigned int mmSPI_LB_CTR_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_CS_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_HSGS_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_REG_DEFAULT                          = 0x0000;
constexpr unsigned int mmSPI_LB_DATA_WAVES_DEFAULT                        = 0x0000;
constexpr unsigned int mmSPI_LB_WGP_MASK_DEFAULT                          = 0xFFFF;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_GPR_MIN_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_GPR_MIN_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_HI_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_LO_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmSPI_PERFCOUNTER_BINS_DEFAULT                     = 0xFCB87430;
constexpr unsigned int mmSPI_PG_ENABLE_STATIC_WGP_MASK_DEFAULT            = 0xFFFF;
constexpr unsigned int mmSPI_PQEV_CTRL_DEFAULT                            = 0xFF1008;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1_DEFAULT             = 0x0000;
constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL_DEFAULT               = 0x0000;
constexpr unsigned int mmSPI_SX_SCOREBOARD_BUFFER_SIZES_DEFAULT           = 0x800040;
constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_DEFAULT                      = 0x0000;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS0_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS1_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS2_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS3_DEFAULT                 = 0x007F;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_HP3D_DEFAULT                = 0x7C1F07F;
constexpr unsigned int mmSPI_WF_LIFETIME_CNTL_DEFAULT                     = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_0_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_1_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_2_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_3_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_4_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_5_DEFAULT                  = 0x0100;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_0_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_2_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_4_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_6_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_7_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_9_DEFAULT                 = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_11_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_13_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_14_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_15_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_16_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_17_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_18_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_19_DEFAULT                = 0x0000;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_20_DEFAULT                = 0x0000;
constexpr unsigned int mmSQG_STATUS_DEFAULT                               = 0x0000;
constexpr unsigned int mmSQ_ALU_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_ARB_CONFIG_DEFAULT                            = 0x0030;
constexpr unsigned int mmSQ_DSM_CNTL2_DEFAULT                             = 0x0000;
constexpr unsigned int mmSQ_DSM_CNTL_DEFAULT                              = 0x0000;
constexpr unsigned int mmSQ_FIFO_SIZES_DEFAULT                            = 0xD001;
constexpr unsigned int mmSQ_IND_INDEX_DEFAULT                             = 0x0000;
constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK_DEFAULT                   = 0xFFFFFF;
constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL_DEFAULT                    = 0x0000;
constexpr unsigned int mmSQ_LDS_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_RANDOM_WAVE_PRI_DEFAULT                       = 0x007F;
constexpr unsigned int mmSQ_RUNTIME_CONFIG_DEFAULT                        = 0x0000;
constexpr unsigned int mmSQ_SHADER_TBA_HI_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TBA_LO_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TMA_HI_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_SHADER_TMA_LO_DEFAULT                         = 0x0000;
constexpr unsigned int mmSQ_TEX_CLK_CTRL_DEFAULT                          = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE_DEFAULT                = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR_DEFAULT             = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR_DEFAULT            = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR_DEFAULT          = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR_DEFAULT           = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR_DEFAULT         = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_MASK_DEFAULT                     = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_STATUS_DEFAULT                   = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK_DEFAULT               = 0x0000;
constexpr unsigned int mmSQ_THREAD_TRACE_WPTR_DEFAULT                     = 0x0000;
constexpr unsigned int mmTA_CGTT_CTRL_DEFAULT                             = 0x0100;
constexpr unsigned int mmTA_CNTL_AUX_DEFAULT                              = 0x1030000;
constexpr unsigned int mmTA_SCRATCH_DEFAULT                               = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
constexpr unsigned int mmTCP_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmTCP_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN_DEFAULT                = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_DMA_REQ_FIFO_DEPTH_DEFAULT                   = 0x0020;
constexpr unsigned int mmVGT_DRAW_INIT_FIFO_DEPTH_DEFAULT                 = 0x0020;
constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_INSTANCE_BASE_ID_DEFAULT                     = 0x0000;
constexpr unsigned int mmVGT_PRIMITIVEID_RESET_DEFAULT                    = 0x0000;
constexpr unsigned int mmVGT_SYS_CONFIG_DEFAULT                           = 0x0011;
constexpr unsigned int mmVGT_TF_MEMORY_BASE_DEFAULT                       = 0x0000;
constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_DEFAULT                    = 0x0000;
constexpr unsigned int mmWD_QOS_DEFAULT                                   = 0x0000;
constexpr unsigned int mmWD_UTCL1_CNTL_DEFAULT                            = 0x0080;
constexpr unsigned int mmWD_UTCL1_STATUS_DEFAULT                          = 0x0000;

namespace Apu103
{
    constexpr unsigned int mmCB_HW_CONTROL_2_DEFAULT                          = 0x29000000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE_DEFAULT              = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1_DEFAULT           = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT          = 0x4000000;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x01FE;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0018;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0004;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180060;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
} // namespace Apu103

namespace Apu11
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE_DEFAULT              = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1_DEFAULT           = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT          = 0x4000000;
    constexpr unsigned int mmGE_SPI_IF_SAFE_REG_DEFAULT                       = 0x18A69;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0028;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
} // namespace Apu11

namespace Gfx10
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL_DEFAULT                        = 0x0100;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_RD_DEFAULT                     = 0x29000;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_WR_DEFAULT                     = 0x29000;
    constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER0_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER1_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER2_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER3_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_RMI_BC_GL2_CACHE_CONTROL_DEFAULT              = 0x550055;
    constexpr unsigned int mmCB_STUTTER_CONTROL_CMASK_RDLAT_DEFAULT           = 0x0000;
    constexpr unsigned int mmCB_STUTTER_CONTROL_COLOR_RDLAT_DEFAULT           = 0x0000;
    constexpr unsigned int mmCB_STUTTER_CONTROL_FMASK_RDLAT_DEFAULT           = 0x0000;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0_DEFAULT               = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1_DEFAULT               = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2_DEFAULT               = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3_DEFAULT               = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_MISC_RESERVED_DEFAULT                    = 0x0003;
    constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCOMPUTE_REQ_CTRL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE_DEFAULT              = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_0_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_1_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_2_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_3_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmCP_COHER_BASE_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCP_COHER_BASE_HI_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCP_COHER_CNTL_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCP_COHER_SIZE_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCP_COHER_SIZE_HI_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCP_COHER_START_DELAY_DEFAULT                     = 0x0020;
    constexpr unsigned int mmCP_COHER_STATUS_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_HI_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_LO_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_HI_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_LO_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_HI_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_LO_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_HI_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_LO_DEFAULT            = 0x0000;
    constexpr unsigned int mmCP_STRMOUT_CNTL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmDB_CGTT_CLK_CTRL_0_DEFAULT                       = 0x0100;
    constexpr unsigned int mmDB_DFSM_FLUSH_ENABLE_DEFAULT                     = 0x07FF;
    constexpr unsigned int mmDB_DFSM_PRIMS_IN_FLIGHT_DEFAULT                  = 0x00C8;
    constexpr unsigned int mmDB_DFSM_TILES_IN_FLIGHT_DEFAULT                  = 0x03E8;
    constexpr unsigned int mmDB_DFSM_WATCHDOG_DEFAULT                         = 0xF4240;
    constexpr unsigned int mmDB_RMI_BC_GL2_CACHE_CONTROL_DEFAULT              = 0x150055;
    constexpr unsigned int mmDB_WATERMARKS_DEFAULT                            = 0xA040A04;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE_DMA_FIRST_INDEX_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGRBM_CHIP_REVISION_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM_DEFAULT                       = 0x00FF;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM_PIPED_DEFAULT                 = 0x6000FF;
    constexpr unsigned int mmPA_SC_BC_WAVE_BREAK_DEFAULT                      = 0x360040;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2_DEFAULT                = 0x9118AAB8;
    constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SC_ENHANCE_2_DEFAULT                          = 0x0020;
    constexpr unsigned int mmPA_SC_ENHANCE_INTERNAL_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_SC_SHADER_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_SIDEBAND_REQUEST_DELAYS_DEFAULT               = 0x8000020;
    constexpr unsigned int mmRLC_CGTT_MGCG_OVERRIDE_DEFAULT                   = 0xFFFFFFFF;
    constexpr unsigned int mmRLC_PERFMON_CLK_CNTL_DEFAULT                     = 0x0001;
    constexpr unsigned int mmRLC_SPM_ACCUM_STATUS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmRLC_SPM_DESER_START_SKEW_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_ADDR_DEFAULT         = 0x0000;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_DATA_DEFAULT         = 0x0000;
    constexpr unsigned int mmRLC_SPM_GLOBALS_MUXSEL_SKEW_DEFAULT              = 0x0000;
    constexpr unsigned int mmRLC_SPM_GLOBALS_SAMPLE_SKEW_DEFAULT              = 0x0000;
    constexpr unsigned int mmRLC_SPM_PERFMON_GLB_SEGMENT_SIZE_DEFAULT         = 0x0000;
    constexpr unsigned int mmRLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE_DEFAULT      = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_SKEW_DEFAULT                   = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_ADDR_DEFAULT          = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_DATA_DEFAULT          = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLE_SKEW_DEFAULT                   = 0x0000;
    constexpr unsigned int mmRLC_SPM_VIRT_CTRL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmRLC_SPM_VIRT_STATUS_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_DEFAULT                        = 0x0011;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_VSPS_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_VS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS_DEFAULT                  = 0xFFFF0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS_DEFAULT                  = 0xFFFF;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_VS_DEFAULT                  = 0xFFFF;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS_DEFAULT                  = 0x10FFFF;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS_DEFAULT                  = 0xFFFF;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS_DEFAULT                  = 0xFFFF;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_VS_DEFAULT                  = 0xFFFF;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_VS_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_0_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_1_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_2_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_3_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_8_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSQG_CONFIG_DEFAULT                               = 0x0000;
    constexpr unsigned int mmSQG_UTCL0_CNTL1_DEFAULT                          = 0x0580;
    constexpr unsigned int mmSQG_UTCL0_CNTL2_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSQG_UTCL0_STATUS_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_EDC_CNT_DEFAULT                               = 0x0000;
    constexpr unsigned int mmSQ_EDC_FUE_CNTL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSQ_LB_CTR_CTRL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_LB_CTR_SEL0_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_LB_CTR_SEL1_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_LB_DATA0_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_LB_DATA1_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_LB_DATA2_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_LB_DATA3_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER_CTRL_DEFAULT                      = 0x0200;
    constexpr unsigned int mmSQ_TIME_HI_DEFAULT                               = 0x0000;
    constexpr unsigned int mmSQ_TIME_LO_DEFAULT                               = 0x0000;
    constexpr unsigned int mmSQ_WATCH0_ADDR_H_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH0_ADDR_L_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH0_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_WATCH1_ADDR_H_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH1_ADDR_L_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH1_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_WATCH2_ADDR_H_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH2_ADDR_L_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH2_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSQ_WATCH3_ADDR_H_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH3_ADDR_L_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSQ_WATCH3_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmTA_RESERVED_010C_DEFAULT                         = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_CACHE_INVALIDATION_DEFAULT                   = 0x9000000;
    constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH_DEFAULT                  = 0x0200;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_GS_VERTEX_REUSE_DEFAULT                      = 0x0010;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_CONFIG_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_CONFIG_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_DELAY_DEFAULT                        = 0x92400;
    constexpr unsigned int mmVGT_TF_RING_SIZE_DEFAULT                         = 0xC000;
    constexpr unsigned int mmVGT_VTX_VECT_EJECT_REG_DEFAULT                   = 0x007D;
    constexpr unsigned int mmWD_BUF_RESOURCE_1_DEFAULT                        = 0x0000;
    constexpr unsigned int mmWD_BUF_RESOURCE_2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmWD_CNTL_SB_BUF_BASE_DEFAULT                      = 0x0000;
    constexpr unsigned int mmWD_CNTL_SB_BUF_BASE_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmWD_INDEX_BUF_BASE_DEFAULT                        = 0x0000;
    constexpr unsigned int mmWD_INDEX_BUF_BASE_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmWD_POS_BUF_BASE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmWD_POS_BUF_BASE_HI_DEFAULT                       = 0x0000;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmCB_CACHE_EVICT_POINTS_DEFAULT                    = 0xB101410;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR0_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR0_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR1_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR1_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR2_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR2_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR3_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR3_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR4_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR4_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR5_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR5_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR6_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR6_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_DCC_CONTROL_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR7_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR7_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0xCD0049;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL_DEFAULT                  = 0x0D0D;
    constexpr unsigned int mmCB_DCC_CONTROL_DEFAULT                           = 0x454D;
    constexpr unsigned int mmCB_HW_CONTROL_1_DEFAULT                          = 0x10000000;
    constexpr unsigned int mmCB_HW_CONTROL_2_DEFAULT                          = 0x24000000;
    constexpr unsigned int mmCB_HW_CONTROL_4_DEFAULT                          = 0x0014;
    constexpr unsigned int mmCB_HW_CONTROL_DEFAULT                            = 0x40000;
    constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0xC0CD00CD;
    constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x05CD;
    constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0xCC4D;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x05CD;
    constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x00CD;
    constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0xC5CDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x000D;
    constexpr unsigned int mmCOMPUTE_PREF_PRI_ACCUM_0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCOMPUTE_PREF_PRI_ACCUM_1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCOMPUTE_PREF_PRI_ACCUM_2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCOMPUTE_PREF_PRI_ACCUM_3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x5CDC1CD;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x000D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x1CD01;
    constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0001;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CLEAR_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0xC04005CD;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0xDCD0DCD;
    constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0xC1CDCDCD;
    constexpr unsigned int mmDB_DFSM_CONFIG_DEFAULT                           = 0x0000;
    constexpr unsigned int mmDB_DFSM_CONTROL_DEFAULT                          = 0x000D;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0xD4545;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x5CDCD;
    constexpr unsigned int mmDB_LAST_OF_BURST_CONFIG_DEFAULT                  = 0x2060410;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PRELOAD_CONTROL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0x0DCD;
    constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0xDC540;
    constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0xC80DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_1_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_2_DEFAULT                        = 0xC00DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_3_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0x10D00CD;
    constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0xC1CDC5;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_STENCILREFMASK_BF_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCILREFMASK_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_CLEAR_DEFAULT                         = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0xCDCDCD;
    constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x800CDC0;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmDB_ZPASS_COUNT_HI_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmDB_ZPASS_COUNT_LOW_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x880DCDCC;
    constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x00CD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0044;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0044;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE_DEFAULT              = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1_DEFAULT           = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT          = 0x4000000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0xDCDCD;
    constexpr unsigned int mmGE_FAST_CLKS_DEFAULT                             = 0x0000;
    constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0001;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x1CDCD;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0400;
    constexpr unsigned int mmGE_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER4_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER4_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER4_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER5_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER5_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER5_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER6_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER6_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER6_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER7_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER7_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER7_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER8_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER8_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER8_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER9_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER9_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER9_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER10_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER10_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER10_SELECT_DEFAULT                  = 0x01CD;
    constexpr unsigned int mmGE_PERFCOUNTER11_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER11_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE_PERFCOUNTER11_SELECT_DEFAULT                  = 0x01CD;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x00FE;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0005;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
    constexpr unsigned int mmIA_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
    constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x000D;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0xD4DC00D;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000005;
    constexpr unsigned int mmPA_CL_ENHANCE_DEFAULT                            = 0xA00007;
    constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x4DCD;
    constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x0001;
    constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0xDCDCDCD;
    constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0D0D;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0100;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0xD41C005;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0_DEFAULT                = 0x842A4402;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0xCDCD;
    constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0xDCDCDCD;
    constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_ENHANCE_1_DEFAULT                          = 0x4040000;
    constexpr unsigned int mmPA_SC_ENHANCE_DEFAULT                            = 0x8000001;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0100;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0C00;
    constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x40CDCDCD;
    constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x0045;
    constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0xCD05CD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x000D;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_DEFAULT                      = 0xD0DCDCD;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x10145;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0xCDCD4DCD;
    constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0xD4D0DCC;
    constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x1CD01CD;
    constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x000D;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0xCDCDCD;
    constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x000D;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x01CD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0xC000CDCD;
    constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x1C90DCD;
    constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x004D;
    constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x000D;
    constexpr unsigned int mmPerfMonCtl1_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl2_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl3_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl4_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl5_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtlClk_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPerfMonCtr1_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr1_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Hi_DEFAULT                         = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Lo_DEFAULT                         = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_RESULT_DEFAULT                = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_RESULT_DEFAULT                = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCOUNTER_TAG_DELAY_RANGE_DEFAULT        = 0x640000;
    constexpr unsigned int mmSDMA0_PERFMON_CNTL_DEFAULT                       = 0xFF7FD;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_RESULT_DEFAULT                = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_RESULT_DEFAULT                = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER_TAG_DELAY_RANGE_DEFAULT        = 0x640000;
    constexpr unsigned int mmSDMA1_PERFMON_CNTL_DEFAULT                       = 0xFF7FD;
    constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x1010101;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0001;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0xC0104;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_REMAP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_REMAP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_CONFIG_CNTL_REMAP_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0001;
    constexpr unsigned int mmSPI_GDS_CREDITS_DEFAULT                          = 0x203C;
    constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x1CDC50D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x14C050D;
    constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0xC1CD;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000FF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x000D;
    constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS_DEFAULT                 = 0x000D;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_VS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_VS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_ES_DEFAULT                  = 0xC5CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x4DCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_LS_DEFAULT                  = 0x41CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0x5CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_DEFAULT                  = 0xDC1CDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_GS_DEFAULT               = 0xDC1CDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_VS_DEFAULT               = 0xDC1CDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS_DEFAULT               = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_DEFAULT                  = 0x1CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_ES_DEFAULT               = 0x1CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_HS_DEFAULT               = 0x1CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_VS_DEFAULT               = 0x1CDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS_DEFAULT                  = 0x94DCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_ES_DEFAULT                  = 0xFFFE;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0xFFFE;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_LS_DEFAULT                  = 0xFFFC;
    constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_ESGS_0_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_ESGS_1_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_ESGS_2_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_ESGS_3_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_LSHS_0_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_LSHS_1_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_LSHS_2_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_LSHS_3_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_PS_0_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_PS_1_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_PS_2_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_PS_3_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_VS_0_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_VS_1_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_VS_2_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_ACCUM_VS_3_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS_DEFAULT       = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS_DEFAULT       = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_PS_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_VS_DEFAULT         = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x000D;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x0004;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000400;
    constexpr unsigned int mmSPI_SYS_COMPUTE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSPI_SYS_WIF_CNTL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x1CDCDCD;
    constexpr unsigned int mmSPI_VS_OUT_CONFIG_DEFAULT                        = 0x00CC;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_REMAP_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX_DEFAULT                 = 0x7FFFFFF;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_6_DEFAULT                  = 0x0100;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_7_DEFAULT                  = 0x0100;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_8_DEFAULT                  = 0x0100;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_9_DEFAULT                  = 0x0100;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_10_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_12_DEFAULT                = 0x0000;
    constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0xC50D0DCD;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x1180000;
    constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER4_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER5_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER6_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER7_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER8_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER9_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT_DEFAULT                   = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER10_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER11_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER12_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER13_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER14_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_PERFCOUNTER15_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT_DEFAULT                  = 0xF000;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_HI_DEFAULT                        = 0xC400CDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_LO_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x81010101;
    constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER0_SELECT_DEFAULT                   = 0xCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_SELECT_DEFAULT                   = 0xCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_SELECT_DEFAULT                   = 0xCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_SELECT_DEFAULT                   = 0xCDCDCD;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xA004005A;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0x1CCCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmTA_POWER_CNTL_DEFAULT                            = 0x20002;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0xCD454000;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0005;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x1CCCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0x1CCCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_CNTL_STATUS_DEFAULT                          = 0x05CD;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmVGT_DMA_CONTROL_DEFAULT                          = 0x8CDCD;
    constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR_DEFAULT                  = 0xDCDCC0D;
    constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x0DCD;
    constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG_DEFAULT                     = 0x0D00;
    constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE_DEFAULT                   = 0x000D;
    constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0xC00001CD;
    constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x000D;
    constexpr unsigned int mmVGT_ENHANCE_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_ES_PER_GS_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0xDCDCDCD;
    constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0xDCDCC0D;
    constexpr unsigned int mmVGT_FIFO_DEPTHS_DEFAULT                          = 0x105000C0;
    constexpr unsigned int mmVGT_GROUP_DECR_DEFAULT                           = 0x000D;
    constexpr unsigned int mmVGT_GROUP_FIRST_DECR_DEFAULT                     = 0x000D;
    constexpr unsigned int mmVGT_GROUP_PRIM_TYPE_DEFAULT                      = 0x5C00D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x800001CD;
    constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x05CD;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x03FF;
    constexpr unsigned int mmVGT_GS_MODE_DEFAULT                              = 0x4DCDCD;
    constexpr unsigned int mmVGT_GS_ONCHIP_CNTL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GS_PER_ES_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_GS_PER_VS_DEFAULT                            = 0x000D;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmVGT_HOS_CNTL_DEFAULT                             = 0x0001;
    constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_REUSE_DEPTH_DEFAULT                      = 0x00CD;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_UMD_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_IMMED_DATA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x0001;
    constexpr unsigned int mmVGT_INDX_OFFSET_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_LAST_COPY_STATE_DEFAULT                      = 0x50005;
    constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmVGT_MAX_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MC_LAT_CNTL_DEFAULT                          = 0x00FE;
    constexpr unsigned int mmVGT_MIN_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN_DEFAULT               = 0x0001;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL_DEFAULT                     = 0x0005;
    constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL_DEFAULT                     = 0x004D;
    constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0005;
    constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x000D;
    constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0001;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_UMD_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x18DCDCD;
    constexpr unsigned int mmVGT_TF_RING_SIZE_UMD_DEFAULT                     = 0xC000;
    constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL_DEFAULT              = 0x00CD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x01FF;
    constexpr unsigned int mmVGT_VTX_CNT_EN_DEFAULT                           = 0x0001;
    constexpr unsigned int mmWD_CNTL_STATUS_DEFAULT                           = 0x000D;
    constexpr unsigned int mmWD_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
} // namespace Gfx101

namespace Gfx103Plus
{
    constexpr unsigned int mmCB_HW_CONTROL_1_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0_DEFAULT                = 0x842A4C02;
    constexpr unsigned int mmPA_SC_ENHANCE_1_DEFAULT                          = 0x40C2000;
    constexpr unsigned int mmPA_SC_ENHANCE_DEFAULT                            = 0x8000009;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_DEFAULT                      = 0x2A00126A;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET_DEFAULT        = 0x0008;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS_DEFAULT = 0xFFFF;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_ADDR_DEFAULT           = 0x0000;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_DATA_DEFAULT           = 0x0000;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT_DEFAULT               = 0x0000;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT_DEFAULT                = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSPI_CONFIG_PS_CU_EN_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_CSG_PIPE_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_CS_CRAWLER_CONFIG_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSPI_EXP_THROTTLE_CTRL_DEFAULT                    = 0x8782E2E;
    constexpr unsigned int mmSPI_GFX_CRAWLER_CONFIG_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX_DEFAULT                 = 0x7C1F07F;
    constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_GFX_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_HPG_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_21_DEFAULT                = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL_DEFAULT                     = 0x400000;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS2_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmSX_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmSX_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmSX_PERFCOUNTER2_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmSX_PERFCOUNTER3_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_CONTROL_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_MC_LAT_CNTL_DEFAULT                          = 0x0002;
} // namespace Gfx103Plus

namespace Gfx10Vrs
{
    constexpr unsigned int mmCB_CACHE_EVICT_POINTS_DEFAULT                    = 0xE101410;
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL1_DEFAULT                       = 0x0100;
    constexpr unsigned int mmCB_HW_CONTROL_4_DEFAULT                          = 0x3C0014;
    constexpr unsigned int mmCB_HW_CONTROL_DEFAULT                            = 0x0100;
    constexpr unsigned int mmDB_DFSM_CONFIG_DEFAULT                           = 0x0002;
    constexpr unsigned int mmDB_LAST_OF_BURST_CONFIG_DEFAULT                  = 0x1C28210;
    constexpr unsigned int mmPA_CL_ENHANCE_DEFAULT                            = 0x200007;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET_DEFAULT        = 0x0000;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE_DEFAULT     = 0x0000;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE_DEFAULT  = 0x0000;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_SEGMENT_SIZE_DEFAULT         = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR_OFFSET_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_GDS_CREDITS_DEFAULT                          = 0x403C;
    constexpr unsigned int mmSPI_IND_DATA_DEFAULT                             = 0x0000;
    constexpr unsigned int mmSPI_IND_INDEX_DEFAULT                            = 0x0000;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000800;
    constexpr unsigned int mmSQ_CLK_CTRL_DEFAULT                              = 0x0200;
    constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTA_POWER_CNTL_DEFAULT                            = 0x22222222;
} // namespace Gfx10Vrs

namespace Gfx11
{
    constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0xCDCD0DCD;
    constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmCB_CACHE_EVICT_POINTS_DEFAULT                    = 0x410051A;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0x4105CDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0x000D;
    constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x1C58D8D;
    constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0xCD0049;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL_DEFAULT                  = 0x0D0D;
    constexpr unsigned int mmCB_DCC_CONFIG2_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_FDCC_CONTROL_DEFAULT                          = 0x454D;
    constexpr unsigned int mmCB_FGCG_SRAM_OVERRIDE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_HW_CONTROL_2_DEFAULT                          = 0x3700;
    constexpr unsigned int mmCB_HW_CONTROL_4_DEFAULT                          = 0x1814;
    constexpr unsigned int mmCB_HW_CONTROL_DEFAULT                            = 0x0140;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_RD_DEFAULT                     = 0x2000;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_WR_DEFAULT                     = 0x2000;
    constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmCB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x05CD;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0x0C00;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INTERLEAVE_DEFAULT              = 0x0040;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x05CD;
    constexpr unsigned int mmCOMPUTE_MISC_RESERVED_DEFAULT                    = 0x000F;
    constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE_DEFAULT                 = 0x0001;
    constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x00CD;
    constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0xC5CDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x80000DCD;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_REQ_CTRL_DEFAULT                         = 0x5CDCDCD;
    constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x5CDC1CD;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE4_DEFAULT           = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE5_DEFAULT           = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE6_DEFAULT           = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE7_DEFAULT           = 0xFFFFFFFF;
    constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE_DEFAULT              = 0x0001;
    constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x5CDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_0_DEFAULT                     = 0x004D;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_1_DEFAULT                     = 0x004D;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_2_DEFAULT                     = 0x004D;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_3_DEFAULT                     = 0x004D;
    constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x000D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x1CD01;
    constexpr unsigned int mmDB_CGTT_CLK_CTRL_0_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CLEAR_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0xC04005CD;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0xDCD0DCD;
    constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0xC1CDCDCD;
    constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0xD4545;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmDB_FIFO_DEPTH4_DEFAULT                           = 0x0000;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x5CDCD;
    constexpr unsigned int mmDB_LAST_OF_BURST_CONFIG_DEFAULT                  = 0xC28210;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmDB_PRELOAD_CONTROL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0xD0DCD;
    constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0x80DC540;
    constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0xC80D4DCD;
    constexpr unsigned int mmDB_RESERVED_REG_1_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_2_DEFAULT                        = 0xC00DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_3_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0xD81CDC5;
    constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_STENCILREFMASK_BF_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCILREFMASK_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_CLEAR_DEFAULT                         = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0xCDCDCD;
    constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x800CDC0;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmDB_WATERMARKS_DEFAULT                            = 0xA040A05;
    constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x880DCDCC;
    constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x00CD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmGDS_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT_DEFAULT             = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT_DEFAULT             = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT_DEFAULT             = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT_DEFAULT             = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1_DEFAULT              = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1_DEFAULT              = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1_DEFAULT              = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1_DEFAULT              = 0xFFFFF;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0xCDCDCDCD;
    constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_1_DEFAULT               = 0xCDCD;
    constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0005;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x1CDCD;
    constexpr unsigned int mmGE_PA_IF_SAFE_REG_DEFAULT                        = 0xDC37;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x01FE;
    constexpr unsigned int mmGE_RATE_CNTL_1_DEFAULT                           = 0x10101010;
    constexpr unsigned int mmGE_RATE_CNTL_2_DEFAULT                           = 0x1010;
    constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0005;
    constexpr unsigned int mmGE_VRS_RATE_DEFAULT                              = 0x0001;
    constexpr unsigned int mmGRBM_CHIP_REVISION_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmIA_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0xD4DC00D;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_CL_ENHANCE_DEFAULT                            = 0x80007;
    constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x4DCD;
    constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VRS_CNTL_DEFAULT                           = 0x4DCD;
    constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0D0D;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_RATE_CNTL_DEFAULT                             = 0x00CD;
    constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0xD41C005;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_ATM_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2_DEFAULT                = 0x1118AAB8;
    constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER_DEFAULT             = 0x0800;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0xCDCD;
    constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0xDCDCDCD;
    constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_ENHANCE_2_DEFAULT                          = 0x0820;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0C00;
    constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x40CDCDCD;
    constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x004D;
    constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0xCDCD45CD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_PACKER_WAVE_ID_CNTL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x000D;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_SHADER_CONTROL_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x10001;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VRS_OVERRIDE_CNTL_DEFAULT                  = 0x40C5;
    constexpr unsigned int mmPA_SC_VRS_RATE_BASE_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VRS_RATE_BASE_EXT_DEFAULT                  = 0xC00000CD;
    constexpr unsigned int mmPA_SC_VRS_RATE_CACHE_CNTL_DEFAULT                = 0x0DCD;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_EXT_DEFAULT         = 0x00CD;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_SIZE_XY_DEFAULT          = 0x5CD05CD;
    constexpr unsigned int mmPA_SC_VRS_RATE_SIZE_XY_DEFAULT                   = 0x5CD05CD;
    constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0xCDCD4DCD;
    constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x1CD01CD;
    constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x000D;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x000D;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x01CD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0xC000CDCD;
    constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x1C90DCD;
    constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x004D;
    constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x000D;
    constexpr unsigned int mmPC_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER1_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER2_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER2_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPC_PERFCOUNTER3_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmPC_PERFCOUNTER3_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmRLC_CGTT_MGCG_OVERRIDE_DEFAULT                   = 0x607FF;
    constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_SPM_ACCUM_STATUS_DEFAULT                     = 0x184800;
    constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_ADDR_DEFAULT            = 0x0000;
    constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_DATA_DEFAULT            = 0x0000;
    constexpr unsigned int mmRLC_SPM_MODE_DEFAULT                             = 0x0000;
    constexpr unsigned int mmRLC_SPM_PAUSE_DEFAULT                            = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_CMD_ACK_DEFAULT                     = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_CMD_DEFAULT                         = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_OP_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_RET_DATA_DEFAULT                    = 0x0000;
    constexpr unsigned int mmRLC_SPM_RSPM_RET_OP_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_ADDR_DEFAULT                = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_DATA_DEFAULT                = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA_HI_DEFAULT              = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA_LO_DEFAULT              = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_OP_DEFAULT                   = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_DATA_DEFAULT                 = 0x0000;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_OP_DEFAULT                   = 0x0000;
    constexpr unsigned int mmRLC_SPM_SPARE_DEFAULT                            = 0x0000;
    constexpr unsigned int mmRLC_SPM_STATUS_DEFAULT                           = 0x0000;
    constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT_DEFAULT                  = 0x03FF;
    constexpr unsigned int mmSPI_ATTRIBUTE_RING_BASE_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_ATTRIBUTE_RING_SIZE_DEFAULT                  = 0x20000;
    constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x1010101;
    constexpr unsigned int mmSPI_BARYC_SSAA_CNTL_DEFAULT                      = 0x0001;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0001;
    constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_STATUS_DEFAULT           = 0x0000;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x80070000;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_DEFAULT                        = 0x10011;
    constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0001;
    constexpr unsigned int mmSPI_GDS_CREDITS_DEFAULT                          = 0x4040;
    constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_HI_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_LO_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_GS_THROTTLE_CNTL1_DEFAULT                    = 0x12355123;
    constexpr unsigned int mmSPI_GS_THROTTLE_CNTL2_DEFAULT                    = 0x1544D;
    constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_PS_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x1CC0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15_DEFAULT            = 0x0000;
    constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_GS_MESHLET_DIM_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_GS_MESHLET_EXP_ALLOC_DEFAULT          = 0x1CDCD;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x000D;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x4DCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS_DEFAULT                  = 0xCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS_DEFAULT                  = 0xCDCD0DCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS_DEFAULT                  = 0xC00DCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS_DEFAULT                  = 0xC00DCDCD;
    constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3_DEFAULT             = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0_DEFAULT               = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1_DEFAULT               = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2_DEFAULT               = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3_DEFAULT               = 0x004D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x000D;
    constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x5CDCDCD;
    constexpr unsigned int mmSPI_VS_OUT_CONFIG_DEFAULT                        = 0x0D8C;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7_DEFAULT                 = 0x007F;
    constexpr unsigned int mmSQG_CONFIG_DEFAULT                               = 0x2000;
    constexpr unsigned int mmSQG_GL1H_STATUS_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER0_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER1_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER2_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER3_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER4_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER4_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER4_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER5_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER5_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER5_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER6_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER6_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER6_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER7_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER7_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQG_PERFCOUNTER7_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQG_PERFCOUNTER_CTRL2_DEFAULT                    = 0x1FFFE;
    constexpr unsigned int mmSQG_PERFCOUNTER_CTRL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSQG_PERF_SAMPLE_FINISH_DEFAULT                   = 0x0000;
    constexpr unsigned int mmSQ_CLK_CTRL_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0xC50D0DCD;
    constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT_DEFAULT                   = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT_DEFAULT                  = 0x01FF;
    constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2_DEFAULT                     = 0x1FFFE;
    constexpr unsigned int mmSQ_PERFCOUNTER_CTRL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERF_SNAPSHOT_CTRL_DEFAULT                    = 0x1FFFE;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_WATCH0_ADDR_H_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSQ_WATCH0_ADDR_L_DEFAULT                         = 0xCDCDCDC0;
    constexpr unsigned int mmSQ_WATCH0_CNTL_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmSQ_WATCH1_ADDR_H_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSQ_WATCH1_ADDR_L_DEFAULT                         = 0xCDCDCDC0;
    constexpr unsigned int mmSQ_WATCH1_CNTL_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmSQ_WATCH2_ADDR_H_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSQ_WATCH2_ADDR_L_DEFAULT                         = 0xCDCDCDC0;
    constexpr unsigned int mmSQ_WATCH2_CNTL_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmSQ_WATCH3_ADDR_H_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSQ_WATCH3_ADDR_L_DEFAULT                         = 0xCDCDCDC0;
    constexpr unsigned int mmSQ_WATCH3_CNTL_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmTA_CNTL2_DEFAULT                                 = 0x0000;
    constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xC0040000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0xCD454000;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_SELECT_DEFAULT                = 0x03FF;
    constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x4DCD;
    constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0xC000004D;
    constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x0048;
    constexpr unsigned int mmVGT_ENHANCE_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0xDCDCDCD;
    constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0xDCDCC0D;
    constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x05CD;
    constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x4001;
    constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0005;
    constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x000D;
    constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0001;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x5CDC1CD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x01CD;
    constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x18DCDCD;
    constexpr unsigned int mmVGT_TF_RING_SIZE_DEFAULT                         = 0x3000;
    constexpr unsigned int mmWD_CNTL_STATUS_DEFAULT                           = 0x000D;
    constexpr unsigned int mmWD_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
} // namespace Gfx11

namespace Gfx110
{
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL_DEFAULT                        = 0x0100;
    constexpr unsigned int mmCB_KEY_OVERRIDE_0_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_1_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_4_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_5_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_6_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_7_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x000D;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0xC9CDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_2_DEFAULT                      = 0xDCDCD;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_1_DEFAULT                 = 0x55488100;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0xD4D0DCC;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180000;
    constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH_DEFAULT                  = 0x0200;
} // namespace Gfx110

namespace Gfx115
{
    constexpr unsigned int mmCB_KEY_OVERRIDE_0_DEFAULT                        = 0xFFFF0000;
    constexpr unsigned int mmCB_KEY_OVERRIDE_1_DEFAULT                        = 0xFFFFFFFF;
    constexpr unsigned int mmCB_KEY_OVERRIDE_2_DEFAULT                        = 0xF888FFF0;
    constexpr unsigned int mmCB_KEY_OVERRIDE_3_DEFAULT                        = 0xFFFFFFFF;
    constexpr unsigned int mmCB_KEY_OVERRIDE_4_DEFAULT                        = 0xFC00FF80;
    constexpr unsigned int mmCB_KEY_OVERRIDE_5_DEFAULT                        = 0xC0C0E0E0;
    constexpr unsigned int mmCB_KEY_OVERRIDE_6_DEFAULT                        = 0xF000F888;
    constexpr unsigned int mmCB_KEY_OVERRIDE_7_DEFAULT                        = 0x8888;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x8CC0000D;
    constexpr unsigned int mmDB_CGTT_CLK_CTRL_1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0xD0D00CD;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x014D;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0x49CDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_2_DEFAULT                      = 0x4DCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_DYNAMIC_BATCH_LIMIT_DEFAULT         = 0x0000;
    constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_CNTL_DEFAULT         = 0xCDCD;
    constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER_DEFAULT      = 0x0000;
    constexpr unsigned int mmPA_SC_ENHANCE_4_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_LIGHT_SHAFT_EVENT_CONFIG_0_DEFAULT         = 0x5D4070;
    constexpr unsigned int mmPA_SC_LIGHT_SHAFT_EVENT_CONFIG_1_DEFAULT         = 0x80027D04;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_1_DEFAULT                 = 0x55480100;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0x4D0DCC;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x380000;
} // namespace Gfx115

namespace Mall
{
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0xD0D00CD;
} // namespace Mall

namespace Nv21
{
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0xF80000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0444;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0444;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0400;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x00FE;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000005;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0100;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0100;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x7E004;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA2_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA3_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0xC0104;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000CF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x00A0;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180020;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0xCD454000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x07FF;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x02FF;
} // namespace Nv21

namespace Nv22
{
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0xF80000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0444;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0444;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0400;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x00FE;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000005;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0100;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0100;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x6004;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0xC0104;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000CF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x00A0;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180020;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0xCD454000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x01CD;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x03FF;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x017F;
} // namespace Nv22

namespace Nv23
{
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x880000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0343;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0343;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0400;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x01FE;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0100;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0180;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x6004;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x70103;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000BF;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x0004;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180060;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x03FF;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x5CDCDCD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x017F;
} // namespace Nv23

namespace Nv24
{
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x880000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0242;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0242;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0200;
    constexpr unsigned int mmGE_PRIV_CONTROL_DEFAULT                          = 0x01FE;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0018;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0004;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x70103;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000BF;
    constexpr unsigned int mmSPI_START_PHASE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmSQ_CONFIG_DEFAULT                                = 0x180060;
    constexpr unsigned int mmTA_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTA_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmTA_STATUS_DEFAULT                                = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER0_SELECT_DEFAULT                   = 0xFFFFF;
    constexpr unsigned int mmTD_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTD_PERFCOUNTER1_SELECT_DEFAULT                   = 0x03FF;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x01FF;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x5CDCDCD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x00BF;
} // namespace Nv24

namespace Nv2x
{
    constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR0_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR0_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR1_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR1_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR2_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR2_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR3_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR3_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR4_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR4_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR5_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR5_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR6_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR6_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR7_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR7_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0xCD0049;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL_DEFAULT                  = 0x0D0D;
    constexpr unsigned int mmCB_DCC_CONTROL_DEFAULT                           = 0x454D;
    constexpr unsigned int mmCB_HW_CONTROL_2_DEFAULT                          = 0x30000000;
    constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0xCDCD00CD;
    constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x05CD;
    constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0xCC4D;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x05CD;
    constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x00CD;
    constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0xC5CDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x000D;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x5CDC1CD;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x000D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x1CD01;
    constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0001;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CLEAR_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0xC04005CD;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0xDCD0DCD;
    constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0xC1CDCDCD;
    constexpr unsigned int mmDB_DFSM_CONTROL_DEFAULT                          = 0x000D;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0xD4545;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x5CDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PRELOAD_CONTROL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0x0DCD;
    constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0xC0DC540;
    constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0xC80DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_1_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_2_DEFAULT                        = 0xC00DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_3_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0xC1CDC5;
    constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_STENCILREFMASK_BF_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCILREFMASK_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_CLEAR_DEFAULT                         = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0xCDCDCD;
    constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x800CDC0;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmDB_VRS_OVERRIDE_CNTL_DEFAULT                     = 0x00C5;
    constexpr unsigned int mmDB_ZPASS_COUNT_HI_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmDB_ZPASS_COUNT_LOW_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x880DCDCC;
    constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x00CD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0xDCDCD;
    constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0001;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x1CDCD;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0005;
    constexpr unsigned int mmGE_VRS_RATE_DEFAULT                              = 0x0001;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
    constexpr unsigned int mmIA_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
    constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x000D;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0xD4DC00D;
    constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x4DCD;
    constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VRS_CNTL_DEFAULT                           = 0x4DCD;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0x49CDCDCD;
    constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0D0D;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0xD41C005;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0xCDCD;
    constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0xDCDCDCD;
    constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0C00;
    constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x40CDCDCD;
    constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x0045;
    constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0xCD05CD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x000D;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x10045;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0xCDCD4DCD;
    constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0xD4D0DCC;
    constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x1CD01CD;
    constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x000D;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0xCDCDCD;
    constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x000D;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x01CD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0xC000CDCD;
    constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x1C90DCD;
    constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x004D;
    constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x000D;
    constexpr unsigned int mmPerfMonCtl1_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl2_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl3_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl4_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl5_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtlClk_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPerfMonCtr1_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr1_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Hi_DEFAULT                         = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Lo_DEFAULT                         = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x1010101;
    constexpr unsigned int mmSPI_BARYC_SSAA_CNTL_DEFAULT                      = 0x0001;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0001;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_REMAP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_REMAP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_CONFIG_CNTL_REMAP_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0001;
    constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x000D;
    constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS_DEFAULT                 = 0x000D;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_VS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_VS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x4DCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS_DEFAULT               = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS_DEFAULT                  = 0x94DCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0xFFFE;
    constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x000D;
    constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x1CDCDCD;
    constexpr unsigned int mmSPI_VS_OUT_CONFIG_DEFAULT                        = 0x0DCC;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_REMAP_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0xC50D0DCD;
    constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_HI_DEFAULT                        = 0xC400CDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_LO_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x81010101;
    constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xC0040000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0005;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmVGT_DMA_CONTROL_DEFAULT                          = 0x8CDCD;
    constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR_DEFAULT                  = 0xDCDCC0D;
    constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x4DCD;
    constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG_DEFAULT                     = 0x0D00;
    constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE_DEFAULT                   = 0x000D;
    constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0xC000004D;
    constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x0048;
    constexpr unsigned int mmVGT_ENHANCE_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_ES_PER_GS_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0xDCDCDCD;
    constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0xDCDCC0D;
    constexpr unsigned int mmVGT_FIFO_DEPTHS_DEFAULT                          = 0x105800C0;
    constexpr unsigned int mmVGT_GROUP_DECR_DEFAULT                           = 0x000D;
    constexpr unsigned int mmVGT_GROUP_FIRST_DECR_DEFAULT                     = 0x000D;
    constexpr unsigned int mmVGT_GROUP_PRIM_TYPE_DEFAULT                      = 0x5C00D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x800001CD;
    constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x05CD;
    constexpr unsigned int mmVGT_GS_MODE_DEFAULT                              = 0x4DCDCD;
    constexpr unsigned int mmVGT_GS_ONCHIP_CNTL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GS_PER_ES_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_GS_PER_VS_DEFAULT                            = 0x000D;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmVGT_HOS_CNTL_DEFAULT                             = 0x0001;
    constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_REUSE_DEPTH_DEFAULT                      = 0x00CD;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_UMD_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_IMMED_DATA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x4001;
    constexpr unsigned int mmVGT_INDX_OFFSET_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_LAST_COPY_STATE_DEFAULT                      = 0x50005;
    constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmVGT_MAX_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MIN_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN_DEFAULT               = 0x0001;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL_DEFAULT                     = 0x0005;
    constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL_DEFAULT                     = 0x004D;
    constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0005;
    constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x000D;
    constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0001;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_UMD_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_UMD_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x18DCDCD;
    constexpr unsigned int mmVGT_TF_RING_SIZE_UMD_DEFAULT                     = 0xC000;
    constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL_DEFAULT              = 0x00CD;
    constexpr unsigned int mmVGT_VTX_CNT_EN_DEFAULT                           = 0x0001;
    constexpr unsigned int mmWD_CNTL_STATUS_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmWD_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
} // namespace Nv2x

namespace Nv31
{
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT             = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0545;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0545;
    constexpr unsigned int mmGE_SPI_IF_SAFE_REG_DEFAULT                       = 0x20DB6;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0034;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0034;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x7FE004;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000160;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x0BFF;
} // namespace Nv31

namespace Nv32
{
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7_alt_5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi7_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo0_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo1_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo2_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo3_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo4_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo5_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo6_DEFAULT             = 0x0000;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo7_DEFAULT             = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0545;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0545;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG_DEFAULT               = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO_DEFAULT                = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE_DEFAULT              = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1_DEFAULT           = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT_DEFAULT            = 0xFFFFF;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL_DEFAULT          = 0x4000000;
    constexpr unsigned int mmGE_FED_STATUS_DEFAULT                            = 0x0000;
    constexpr unsigned int mmGE_SPI_IF_SAFE_REG_DEFAULT                       = 0x20DB6;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0034;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0034;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x1E004;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000160;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk_DEFAULT                    = 0x30000000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi_DEFAULT                 = 0x0000;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x05FF;
} // namespace Nv32

namespace Nv33
{
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0343;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0343;
    constexpr unsigned int mmGE_SPI_IF_SAFE_REG_DEFAULT                       = 0x18A69;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE_DEFAULT                = 0x0028;
    constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL_DEFAULT                    = 0x0028;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x6004;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000140;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x03FF;
} // namespace Nv33

namespace Nv3x
{
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x8CC0000D;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT_DEFAULT                 = 0x03FF;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xFFFFF;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL_DEFAULT                = 0x4000000;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0180;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x42000000;
    constexpr unsigned int mmPerfMonCtl1_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl2_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl3_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl4_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl5_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl6_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl7_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl8_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl9_DEFAULT                              = 0x0000;
    constexpr unsigned int mmPerfMonCtl10_DEFAULT                             = 0x0000;
    constexpr unsigned int mmPerfMonCtl11_DEFAULT                             = 0x0000;
    constexpr unsigned int mmPerfMonCtl12_DEFAULT                             = 0x0000;
    constexpr unsigned int mmPerfMonCtlClk_DEFAULT                            = 0x30000000;
    constexpr unsigned int mmPerfMonCtr1_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr1_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr2_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr3_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr4_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr5_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr6_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr6_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr7_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr7_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr8_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr8_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr9_Hi_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr9_Lo_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPerfMonCtr10_Hi_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtr10_Lo_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtr11_Hi_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtr11_Lo_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtr12_Hi_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtr12_Lo_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Hi_DEFAULT                         = 0x0000;
    constexpr unsigned int mmPerfMonCtrClk_Lo_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG_DEFAULT           = 0xFFFF;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL_DEFAULT      = 0x4000000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1_DEFAULT               = 0xFFFFF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT_DEFAULT                = 0xFFFFF;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x13E0;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000FF;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtl12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk_DEFAULT                     = 0x30000000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo_DEFAULT                    = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo_DEFAULT                   = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi_DEFAULT                  = 0x0000;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo_DEFAULT                  = 0x0000;
} // namespace Nv3x

namespace Phx1
{
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x80C0000D;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0x10D00CD;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0242;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0242;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x42000000;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0004;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x11E0;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000BF;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000120;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x017F;
} // namespace Phx1

namespace Phx2
{
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x80C0000D;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0x10D00CD;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0142;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0142;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x10800000;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0004;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x11E0;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x200007F;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000120;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x007F;
} // namespace Phx2

namespace Raphael
{
    constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0x4DCD0DCD;
    constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR0_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR0_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR0_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR1_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR1_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR1_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR2_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR2_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR2_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR3_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR3_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR3_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR4_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR4_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR4_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR5_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR5_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR5_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR6_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR6_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR6_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_CMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE_DEFAULT                    = 0x0DCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT_DEFAULT                   = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_DCC_CONTROL_DEFAULT                    = 0x4DCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmCB_COLOR7_FMASK_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x8C0DCDCD;
    constexpr unsigned int mmCB_COLOR7_PITCH_DEFAULT                          = 0x4DC005CD;
    constexpr unsigned int mmCB_COLOR7_SLICE_DEFAULT                          = 0xDCDCD;
    constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0xCD0049;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL_DEFAULT                  = 0x0D0D;
    constexpr unsigned int mmCB_DCC_CONTROL_DEFAULT                           = 0x454D;
    constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0xC0CD00CD;
    constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x05CD;
    constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0xCC4D;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x00CD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x05CD;
    constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x00CD;
    constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0xC5CDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x000D;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x5CDC1CD;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x1CDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x000D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x1CD01;
    constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0001;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CLEAR_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0xC04005CD;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0xDCD0DCD;
    constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0xC1CDCDCD;
    constexpr unsigned int mmDB_DFSM_CONTROL_DEFAULT                          = 0x000D;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0xD4545;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x880000;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x5CDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0xCD0DCDCD;
    constexpr unsigned int mmDB_PRELOAD_CONTROL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0x0DCD;
    constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0xC0DC540;
    constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0xC80DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_1_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_2_DEFAULT                        = 0xC00DCDCD;
    constexpr unsigned int mmDB_RESERVED_REG_3_DEFAULT                        = 0xDCDCD;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0x10D00CD;
    constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0xC1CDC5;
    constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x10DCDC5;
    constexpr unsigned int mmDB_STENCILREFMASK_BF_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCILREFMASK_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_CLEAR_DEFAULT                         = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0xCDCDCD;
    constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x800CDC0;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x00CD;
    constexpr unsigned int mmDB_VRS_OVERRIDE_CNTL_DEFAULT                     = 0x00C5;
    constexpr unsigned int mmDB_ZPASS_COUNT_HI_DEFAULT                        = 0x4DCDCDCD;
    constexpr unsigned int mmDB_ZPASS_COUNT_LOW_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x880DCDCC;
    constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x00CD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi8_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi9_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi10_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi11_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi12_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi13_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi14_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi15_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo8_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo9_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo10_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo11_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo12_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo13_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo14_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo15_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi8_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi9_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi10_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi11_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi12_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi13_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi14_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi15_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo8_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo9_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo10_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo11_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo12_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo13_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo14_DEFAULT                = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo15_DEFAULT                = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0042;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0042;
    constexpr unsigned int mmGDS_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xCD0DCDCD;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1_DEFAULT                 = 0xDCDCD;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT_DEFAULT                  = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1_DEFAULT            = 0xDCDCD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT_DEFAULT             = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1_DEFAULT              = 0xDCDCD;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT_DEFAULT               = 0xDCDCD;
    constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0xDCDCD;
    constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0001;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x1CDCD;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0200;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0005;
    constexpr unsigned int mmGE_VRS_RATE_DEFAULT                              = 0x0001;
    constexpr unsigned int mmIA_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
    constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x000D;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0xD4DC00D;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x4DCD;
    constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x01CD;
    constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_CL_VRS_CNTL_DEFAULT                           = 0x4DCD;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0x49CDCDCD;
    constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0D0D;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0xD41C005;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0xCDCD;
    constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0xDCDCDCD;
    constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0xCDCD;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0DCD;
    constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0C00;
    constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x40CDCDCD;
    constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x0045;
    constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0xCD05CD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0xCDCD;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0DCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x01CD;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x000D;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x10045;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0xCDCD;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0xCDCD4DCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x4DCD4DCD;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0xCDCD4DCD;
    constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0xD4D0DCC;
    constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x80000000;
    constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x1CD01CD;
    constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x000D;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0xCDCDCD;
    constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x000D;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0xCD0DCDCD;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x01CD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0xCDCDCDCD;
    constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0xC000CDCD;
    constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x1C90DCD;
    constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x004D;
    constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x000D;
    constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x1010101;
    constexpr unsigned int mmSPI_BARYC_SSAA_CNTL_DEFAULT                      = 0x0001;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0001;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x70103;
    constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0001;
    constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x1CDCD0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x14C0D0D;
    constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0xCDCD;
    constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0xCDCD;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x200003F;
    constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x000D;
    constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS_DEFAULT                 = 0x000D;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS_DEFAULT                  = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_VS_DEFAULT                     = 0x00CD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_VS_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x4DCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS_DEFAULT               = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0xDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS_DEFAULT                  = 0x94DCDCD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0xFFFD;
    constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0xDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x000D;
    constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x1CDCDCD;
    constexpr unsigned int mmSPI_VS_OUT_CONFIG_DEFAULT                        = 0x0DCC;
    constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0xC50D0DCD;
    constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER8_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER9_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER10_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER11_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER12_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER13_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_HI_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_PERFCOUNTER15_LO_DEFAULT                      = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0xCDCDCDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_HI_DEFAULT                        = 0xC400CDCD;
    constexpr unsigned int mmSQ_WREXEC_EXEC_LO_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x81010101;
    constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0xCDCDCDCD;
    constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x5450545;
    constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x00CD;
    constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xA0040000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x00CD;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0005;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x4DCDCDCD;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX_DEFAULT                  = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0xCDCD;
    constexpr unsigned int mmVGT_DMA_CONTROL_DEFAULT                          = 0x8CDCD;
    constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR_DEFAULT                  = 0xDCDCC0D;
    constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x4DCD;
    constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG_DEFAULT                     = 0x0D00;
    constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE_DEFAULT                   = 0x000D;
    constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0xC000004D;
    constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x0048;
    constexpr unsigned int mmVGT_ENHANCE_DEFAULT                              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_ES_PER_GS_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0xDCDCDCD;
    constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0xDCDCC0D;
    constexpr unsigned int mmVGT_FIFO_DEPTHS_DEFAULT                          = 0x105800C0;
    constexpr unsigned int mmVGT_GROUP_DECR_DEFAULT                           = 0x000D;
    constexpr unsigned int mmVGT_GROUP_FIRST_DECR_DEFAULT                     = 0x000D;
    constexpr unsigned int mmVGT_GROUP_PRIM_TYPE_DEFAULT                      = 0x5C00D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL_DEFAULT                    = 0xCDCD0D;
    constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x800001CD;
    constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x05CD;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x003F;
    constexpr unsigned int mmVGT_GS_MODE_DEFAULT                              = 0x4DCDCD;
    constexpr unsigned int mmVGT_GS_ONCHIP_CNTL_DEFAULT                       = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_GS_PER_ES_DEFAULT                            = 0x05CD;
    constexpr unsigned int mmVGT_GS_PER_VS_DEFAULT                            = 0x000D;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3_DEFAULT                   = 0x4DCD;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_DEFAULT                     = 0x4DCD;
    constexpr unsigned int mmVGT_HOS_CNTL_DEFAULT                             = 0x0001;
    constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_HOS_REUSE_DEPTH_DEFAULT                      = 0x00CD;
    constexpr unsigned int mmVGT_IMMED_DATA_DEFAULT                           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x4001;
    constexpr unsigned int mmVGT_INDX_OFFSET_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1_DEFAULT                 = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_LAST_COPY_STATE_DEFAULT                      = 0x50005;
    constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0xDCDCD;
    constexpr unsigned int mmVGT_MAX_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MIN_VTX_INDX_DEFAULT                         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN_DEFAULT               = 0x0001;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL_DEFAULT                     = 0x0005;
    constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL_DEFAULT                     = 0x004D;
    constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0005;
    constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x000D;
    constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0001;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x5CDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3_DEFAULT         = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3_DEFAULT              = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3_DEFAULT                = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3_DEFAULT                 = 0x01CD;
    constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0xCDCDCDCD;
    constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x18DCDCD;
    constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL_DEFAULT              = 0x00CD;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x003F;
    constexpr unsigned int mmVGT_VTX_CNT_EN_DEFAULT                           = 0x0001;
    constexpr unsigned int mmWD_CNTL_STATUS_DEFAULT                           = 0xDCDCDCD;
    constexpr unsigned int mmWD_ENHANCE_DEFAULT                               = 0xCDCDCDCD;
} // namespace Raphael

namespace Rembrandt
{
    constexpr unsigned int mmCB_BLEND0_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND1_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND2_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND3_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND4_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND5_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND6_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND7_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_BLEND_ALPHA_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_BLEND_BLUE_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCB_BLEND_GREEN_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_BLEND_RED_DEFAULT                             = 0x0000;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR0_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR0_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR0_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR0_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR0_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR0_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR0_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR0_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR0_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR1_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR1_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR1_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR1_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR1_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR1_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR1_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR1_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR1_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR2_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR2_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR2_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR2_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR2_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR2_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR2_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR2_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR2_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR3_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR3_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR3_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR3_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR3_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR3_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR3_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR3_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR3_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR4_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR4_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR4_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR4_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR4_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR4_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR4_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR4_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR4_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR5_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR5_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR5_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR5_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR5_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR5_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR5_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR5_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR5_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR6_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR6_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR6_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR6_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR6_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR6_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR6_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR6_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR6_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCB_COLOR7_ATTRIB_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COLOR7_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR7_CMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmCB_COLOR7_DCC_CONTROL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_COLOR7_FMASK_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCB_COLOR7_INFO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR7_PITCH_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR7_SLICE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCB_COLOR7_VIEW_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_COLOR_CONTROL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmCB_DCC_CONTROL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmCB_SHADER_MASK_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCB_TARGET_MASK_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX_DEFAULT                       = 0x0000;
    constexpr unsigned int mmCOMPUTE_DIM_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DIM_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DIM_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_END_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR_DEFAULT               = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI_DEFAULT         = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO_DEFAULT         = 0x0000;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmCOMPUTE_NOWHERE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_X_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_PGM_HI_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCOMPUTE_PGM_LO_DEFAULT                           = 0x0000;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC1_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmCOMPUTE_RELAUNCH_DEFAULT                         = 0x0000;
    constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM_DEFAULT                    = 0x0000;
    constexpr unsigned int mmCOMPUTE_START_X_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_START_Y_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_START_Z_DEFAULT                          = 0x0000;
    constexpr unsigned int mmCOMPUTE_TMPRING_SIZE_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_0_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_13_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_14_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_USER_DATA_15_DEFAULT                     = 0x0000;
    constexpr unsigned int mmCOMPUTE_VMID_DEFAULT                             = 0x0000;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI_DEFAULT             = 0x0000;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO_DEFAULT             = 0x0000;
    constexpr unsigned int mmDB_ALPHA_TO_MASK_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_COUNT_CONTROL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX_DEFAULT                      = 0x0000;
    constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN_DEFAULT                      = 0x0000;
    constexpr unsigned int mmDB_DEPTH_CLEAR_DEFAULT                           = 0x0000;
    constexpr unsigned int mmDB_DEPTH_CONTROL_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_DEPTH_VIEW_DEFAULT                            = 0x0000;
    constexpr unsigned int mmDB_DFSM_CONTROL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_EQAA_DEFAULT                                  = 0x0000;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL_DEFAULT                     = 0x880000;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmDB_HTILE_SURFACE_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER0_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER1_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER2_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_PERFCOUNTER3_SELECT_DEFAULT                   = 0x0000;
    constexpr unsigned int mmDB_PRELOAD_CONTROL_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_RENDER_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_RENDER_OVERRIDE2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmDB_RENDER_OVERRIDE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_RESERVED_REG_1_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_RESERVED_REG_2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_RESERVED_REG_3_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_SHADER_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION_DEFAULT               = 0x0000;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0_DEFAULT               = 0x0000;
    constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1_DEFAULT               = 0x0000;
    constexpr unsigned int mmDB_STENCILREFMASK_BF_DEFAULT                     = 0x0000;
    constexpr unsigned int mmDB_STENCILREFMASK_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_STENCIL_CLEAR_DEFAULT                         = 0x0000;
    constexpr unsigned int mmDB_STENCIL_CONTROL_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_STENCIL_INFO_DEFAULT                          = 0x0000;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_DEFAULT                     = 0x0000;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_DEFAULT                    = 0x0000;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDB_VRS_OVERRIDE_CNTL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmDB_ZPASS_COUNT_HI_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_ZPASS_COUNT_LOW_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDB_Z_INFO_DEFAULT                                = 0x0000;
    constexpr unsigned int mmDB_Z_READ_BASE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmDB_Z_READ_BASE_HI_DEFAULT                        = 0x0000;
    constexpr unsigned int mmDB_Z_WRITE_BASE_DEFAULT                          = 0x0000;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0242;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0242;
    constexpr unsigned int mmGDS_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1_DEFAULT            = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT_DEFAULT             = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1_DEFAULT            = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT_DEFAULT             = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1_DEFAULT            = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT_DEFAULT             = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1_DEFAULT            = 0x0000;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT_DEFAULT             = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1_DEFAULT              = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT_DEFAULT               = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1_DEFAULT              = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT_DEFAULT               = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1_DEFAULT              = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT_DEFAULT               = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO_DEFAULT                   = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1_DEFAULT              = 0x0000;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT_DEFAULT               = 0x0000;
    constexpr unsigned int mmGE_CNTL_DEFAULT                                  = 0x0000;
    constexpr unsigned int mmGE_INDX_OFFSET_DEFAULT                           = 0x0000;
    constexpr unsigned int mmGE_MAX_VTX_INDX_DEFAULT                          = 0x0000;
    constexpr unsigned int mmGE_MIN_VTX_INDX_DEFAULT                          = 0x0000;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN_DEFAULT                = 0x0000;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL_DEFAULT                       = 0x0000;
    constexpr unsigned int mmGE_PC_CNTL_DEFAULT                               = 0x0100;
    constexpr unsigned int mmGE_STEREO_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmGE_USER_VGPR_EN_DEFAULT                          = 0x0000;
    constexpr unsigned int mmGE_VRS_RATE_DEFAULT                              = 0x0000;
    constexpr unsigned int mmIA_ENHANCE_DEFAULT                               = 0x0000;
    constexpr unsigned int mmIA_UTCL1_STATUS_2_DEFAULT                        = 0x0000;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_CLIP_CNTL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_CL_CNTL_STATUS_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_NANINF_CNTL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_CL_NGG_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_CL_POINT_CULL_RAD_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_POINT_SIZE_DEFAULT                         = 0x0000;
    constexpr unsigned int mmPA_CL_POINT_X_RAD_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_CL_POINT_Y_RAD_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_0_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_0_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_0_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_0_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_1_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_1_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_1_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_1_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_2_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_2_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_2_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_2_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_3_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_3_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_3_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_3_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_4_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_4_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_4_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_4_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_5_W_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_5_X_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_5_Y_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_UCP_5_Z_DEFAULT                            = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XOFFSET_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_1_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_2_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_3_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_4_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_5_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_6_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_7_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_8_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_9_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_10_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_11_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_12_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_13_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_14_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_15_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_XSCALE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YOFFSET_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_1_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_2_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_3_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_4_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_5_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_6_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_7_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_8_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_9_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_10_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_11_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_12_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_13_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_14_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_15_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_YSCALE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9_DEFAULT                     = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_CL_VPORT_ZSCALE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_CL_VRS_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_CL_VS_OUT_CNTL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_CL_VTE_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_AA_CONFIG_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_0_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_BR_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_0_TL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_BR_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_1_TL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_BR_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_2_TL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_BR_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_3_TL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CLIPRECT_RULE_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL_DEFAULT    = 0x0000;
    constexpr unsigned int mmPA_SC_EDGERULE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE_DEFAULT        = 0x0000;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_LINE_CNTL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_LINE_STIPPLE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_MODE_CNTL_0_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_SC_NGG_MODE_CNTL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT_DEFAULT              = 0x0000;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE_DEFAULT         = 0x0000;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_RASTER_CONFIG_1_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_H_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_V_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_0_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_13_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_14_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMAX_15_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_0_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_1_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_2_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_3_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_4_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_5_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_6_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_7_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_8_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_9_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_10_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_11_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_12_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_13_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_14_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_VPORT_ZMIN_15_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_WINDOW_OFFSET_DEFAULT                      = 0x0000;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_STATE_STEREO_X_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_STEREO_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmPA_SU_CNTL_STATUS_DEFAULT                        = 0x0000;
    constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SU_LINE_CNTL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE_DEFAULT                 = 0x0000;
    constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL_DEFAULT            = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO_DEFAULT                    = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1_DEFAULT               = 0x0000;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT_DEFAULT                = 0x0000;
    constexpr unsigned int mmPA_SU_POINT_MINMAX_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SU_POINT_SIZE_DEFAULT                         = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET_DEFAULT            = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP_DEFAULT                  = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL_DEFAULT            = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET_DEFAULT           = 0x0000;
    constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE_DEFAULT            = 0x0000;
    constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL_DEFAULT                   = 0x0000;
    constexpr unsigned int mmPA_SU_SC_MODE_CNTL_DEFAULT                       = 0x0000;
    constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL_DEFAULT             = 0x0000;
    constexpr unsigned int mmPA_SU_VTX_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmRLC_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_BARYC_CNTL_DEFAULT                           = 0x0000;
    constexpr unsigned int mmSPI_BARYC_SSAA_CNTL_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_DEFAULT                        = 0x70103;
    constexpr unsigned int mmSPI_EDC_CNT_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSPI_INTERP_CONTROL_0_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER0_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER0_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER1_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER1_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER2_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER2_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER3_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER3_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER4_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER4_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER5_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PERFCOUNTER5_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_ADDR_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_0_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_1_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_2_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_3_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_4_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_5_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_6_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_7_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_8_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_9_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_10_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_11_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_12_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_13_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_14_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_15_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_16_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_17_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_18_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_19_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_20_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_21_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_22_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_23_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_24_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_25_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_26_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_27_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_28_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_29_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_30_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_CNTL_31_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_PS_INPUT_ENA_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSPI_PS_IN_CONTROL_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x200008F;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5_DEFAULT             = 0x0000;
    constexpr unsigned int mmSPI_SHADER_COL_FORMAT_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS_DEFAULT                 = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_GS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_HS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_PS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_VS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_GS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_HS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_PS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_VS_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS_DEFAULT                  = 0x0000;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS_DEFAULT                  = 0xFFFE;
    constexpr unsigned int mmSPI_SHADER_POS_FORMAT_DEFAULT                    = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS_DEFAULT          = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS_DEFAULT          = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS_DEFAULT          = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS_DEFAULT          = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9_DEFAULT                = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31_DEFAULT               = 0x0000;
    constexpr unsigned int mmSPI_SHADER_Z_FORMAT_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSPI_TMPRING_SIZE_DEFAULT                         = 0x0000;
    constexpr unsigned int mmSPI_VS_OUT_CONFIG_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSQ_CMD_DEFAULT                                   = 0x0000;
    constexpr unsigned int mmSQ_IND_DATA_DEFAULT                              = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER4_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER4_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER5_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER5_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER6_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER6_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER7_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER7_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER8_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER8_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER9_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER9_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER10_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER10_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER11_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER11_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER12_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER12_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER13_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER13_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER14_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER14_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER15_HI_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_PERFCOUNTER15_LO_DEFAULT                      = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7_DEFAULT               = 0x0000;
    constexpr unsigned int mmSQ_WREXEC_EXEC_HI_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSQ_WREXEC_EXEC_LO_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_BLEND_OPT_CONTROL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSX_BLEND_OPT_EPSILON_DEFAULT                     = 0x0000;
    constexpr unsigned int mmSX_MRT0_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT1_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT2_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT3_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT4_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT5_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT6_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_MRT7_BLEND_OPT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER0_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER0_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER1_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER1_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER2_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER2_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER3_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PERFCOUNTER3_LO_DEFAULT                       = 0x0000;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_DEFAULT                        = 0x0000;
    constexpr unsigned int mmTA_BC_BASE_ADDR_DEFAULT                          = 0x0000;
    constexpr unsigned int mmTA_BC_BASE_ADDR_HI_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_CNTL_DEFAULT                                  = 0xA0040000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_DEFAULT                       = 0x0000;
    constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI_DEFAULT                    = 0x0000;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2_DEFAULT                  = 0x0000;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX_DEFAULT                  = 0x0000;
    constexpr unsigned int mmVGT_DMA_BASE_DEFAULT                             = 0x0000;
    constexpr unsigned int mmVGT_DMA_BASE_HI_DEFAULT                          = 0x0000;
    constexpr unsigned int mmVGT_DMA_CONTROL_DEFAULT                          = 0x0000;
    constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR_DEFAULT                  = 0x0000;
    constexpr unsigned int mmVGT_DMA_INDEX_TYPE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_DMA_MAX_SIZE_DEFAULT                         = 0x0000;
    constexpr unsigned int mmVGT_DMA_NUM_INSTANCES_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_DMA_SIZE_DEFAULT                             = 0x0000;
    constexpr unsigned int mmVGT_DRAW_INITIATOR_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_ENHANCE_DEFAULT                              = 0x0000;
    constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_ES_PER_GS_DEFAULT                            = 0x0000;
    constexpr unsigned int mmVGT_EVENT_ADDRESS_REG_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_EVENT_INITIATOR_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_FIFO_DEPTHS_DEFAULT                          = 0x10180040;
    constexpr unsigned int mmVGT_GROUP_DECR_DEFAULT                           = 0x0000;
    constexpr unsigned int mmVGT_GROUP_FIRST_DECR_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_GROUP_PRIM_TYPE_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_INSTANCE_CNT_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_VERT_OUT_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x017F;
    constexpr unsigned int mmVGT_GS_MODE_DEFAULT                              = 0x0000;
    constexpr unsigned int mmVGT_GS_ONCHIP_CNTL_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_GS_PER_ES_DEFAULT                            = 0x0000;
    constexpr unsigned int mmVGT_GS_PER_VS_DEFAULT                            = 0x0000;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_HOS_CNTL_DEFAULT                             = 0x0000;
    constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL_DEFAULT                   = 0x0000;
    constexpr unsigned int mmVGT_HOS_REUSE_DEPTH_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_IMMED_DATA_DEFAULT                           = 0x0000;
    constexpr unsigned int mmVGT_INDEX_TYPE_DEFAULT                           = 0x0000;
    constexpr unsigned int mmVGT_INDX_OFFSET_DEFAULT                          = 0x0000;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_LAST_COPY_STATE_DEFAULT                      = 0x0000;
    constexpr unsigned int mmVGT_LS_HS_CONFIG_DEFAULT                         = 0x0000;
    constexpr unsigned int mmVGT_MAX_VTX_INDX_DEFAULT                         = 0x0000;
    constexpr unsigned int mmVGT_MIN_VTX_INDX_DEFAULT                         = 0x0000;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN_DEFAULT               = 0x0000;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX_DEFAULT             = 0x0000;
    constexpr unsigned int mmVGT_NUM_INDICES_DEFAULT                          = 0x0000;
    constexpr unsigned int mmVGT_NUM_INSTANCES_DEFAULT                        = 0x0000;
    constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_PRIMITIVEID_EN_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_PRIMITIVE_TYPE_DEFAULT                       = 0x0000;
    constexpr unsigned int mmVGT_REUSE_OFF_DEFAULT                            = 0x0000;
    constexpr unsigned int mmVGT_SHADER_STAGES_EN_DEFAULT                     = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0_DEFAULT         = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1_DEFAULT         = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2_DEFAULT         = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3_DEFAULT         = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0_DEFAULT              = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1_DEFAULT              = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2_DEFAULT              = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3_DEFAULT              = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3_DEFAULT                = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE_DEFAULT = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET_DEFAULT           = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE_DEFAULT    = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmVGT_TESS_DISTRIBUTION_DEFAULT                    = 0x0000;
    constexpr unsigned int mmVGT_TF_PARAM_DEFAULT                             = 0x0000;
    constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL_DEFAULT              = 0x0000;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID_DEFAULT                       = 0x00FF;
    constexpr unsigned int mmVGT_VTX_CNT_EN_DEFAULT                           = 0x0000;
    constexpr unsigned int mmWD_CNTL_STATUS_DEFAULT                           = 0x0000;
    constexpr unsigned int mmWD_ENHANCE_DEFAULT                               = 0x0000;
} // namespace Rembrandt

namespace Stx1
{
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0242;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0242;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x42000000;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x0004;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x13E0;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000FF;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000130;
    constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH_DEFAULT                  = 0x0100;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x01FF;
} // namespace Stx1

#if CHIP_HDR_STRIX_HALO
namespace StxH
{
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6_DEFAULT                 = 0x0000;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7_DEFAULT                 = 0x0000;
    constexpr unsigned int mmGB_ADDR_CONFIG_DEFAULT                           = 0x0343;
    constexpr unsigned int mmGB_ADDR_CONFIG_READ_DEFAULT                      = 0x0343;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO_DEFAULT                  = 0x0000;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT_DEFAULT              = 0x0000;
    constexpr unsigned int mmMP1_SMN_FPS_CNT_DEFAULT                          = 0x0000;
    constexpr unsigned int mmPA_SC_ENHANCE_3_DEFAULT                          = 0x0180;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_DEFAULT                   = 0x42000000;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE_DEFAULT                       = 0x6004;
    constexpr unsigned int mmSPI_FEATURE_CTRL_DEFAULT                         = 0x13E0;
    constexpr unsigned int mmSPI_PS_MAX_WAVE_ID_DEFAULT                       = 0x20000FF;
    constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES_DEFAULT               = 0x10000150;
    constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH_DEFAULT                  = 0x0200;
    constexpr unsigned int mmVGT_GS_MAX_WAVE_ID_DEFAULT                       = 0x03FF;
} // namespace StxH
#endif

} // inline namespace Chip
} // namespace Gfx9
} // namespace Pal
