/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx9
{
inline namespace Chip
{
constexpr unsigned int mmCB_BLEND0_CONTROL                                = 0xA1E0;
constexpr unsigned int mmCB_BLEND1_CONTROL                                = 0xA1E1;
constexpr unsigned int mmCB_BLEND2_CONTROL                                = 0xA1E2;
constexpr unsigned int mmCB_BLEND3_CONTROL                                = 0xA1E3;
constexpr unsigned int mmCB_BLEND4_CONTROL                                = 0xA1E4;
constexpr unsigned int mmCB_BLEND5_CONTROL                                = 0xA1E5;
constexpr unsigned int mmCB_BLEND6_CONTROL                                = 0xA1E6;
constexpr unsigned int mmCB_BLEND7_CONTROL                                = 0xA1E7;
constexpr unsigned int mmCB_BLEND_ALPHA                                   = 0xA108;
constexpr unsigned int mmCB_BLEND_BLUE                                    = 0xA107;
constexpr unsigned int mmCB_BLEND_GREEN                                   = 0xA106;
constexpr unsigned int mmCB_BLEND_RED                                     = 0xA105;
constexpr unsigned int mmCB_CACHE_EVICT_POINTS                            = 0x268E;
constexpr unsigned int mmCB_COLOR0_ATTRIB                                 = 0xA31D;
constexpr unsigned int mmCB_COLOR0_ATTRIB2                                = 0xA3B0;
constexpr unsigned int mmCB_COLOR0_ATTRIB3                                = 0xA3B8;
constexpr unsigned int mmCB_COLOR0_BASE                                   = 0xA318;
constexpr unsigned int mmCB_COLOR0_BASE_EXT                               = 0xA390;
constexpr unsigned int mmCB_COLOR0_DCC_BASE                               = 0xA325;
constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT                           = 0xA3A8;
constexpr unsigned int mmCB_COLOR0_DCC_CONTROL                            = 0xA31E;
constexpr unsigned int mmCB_COLOR0_INFO                                   = 0xA31C;
constexpr unsigned int mmCB_COLOR0_VIEW                                   = 0xA31B;
constexpr unsigned int mmCB_COLOR1_ATTRIB                                 = 0xA32C;
constexpr unsigned int mmCB_COLOR1_ATTRIB2                                = 0xA3B1;
constexpr unsigned int mmCB_COLOR1_ATTRIB3                                = 0xA3B9;
constexpr unsigned int mmCB_COLOR1_BASE                                   = 0xA327;
constexpr unsigned int mmCB_COLOR1_BASE_EXT                               = 0xA391;
constexpr unsigned int mmCB_COLOR1_DCC_BASE                               = 0xA334;
constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT                           = 0xA3A9;
constexpr unsigned int mmCB_COLOR1_DCC_CONTROL                            = 0xA32D;
constexpr unsigned int mmCB_COLOR1_INFO                                   = 0xA32B;
constexpr unsigned int mmCB_COLOR1_VIEW                                   = 0xA32A;
constexpr unsigned int mmCB_COLOR2_ATTRIB                                 = 0xA33B;
constexpr unsigned int mmCB_COLOR2_ATTRIB2                                = 0xA3B2;
constexpr unsigned int mmCB_COLOR2_ATTRIB3                                = 0xA3BA;
constexpr unsigned int mmCB_COLOR2_BASE                                   = 0xA336;
constexpr unsigned int mmCB_COLOR2_BASE_EXT                               = 0xA392;
constexpr unsigned int mmCB_COLOR2_DCC_BASE                               = 0xA343;
constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT                           = 0xA3AA;
constexpr unsigned int mmCB_COLOR2_DCC_CONTROL                            = 0xA33C;
constexpr unsigned int mmCB_COLOR2_INFO                                   = 0xA33A;
constexpr unsigned int mmCB_COLOR2_VIEW                                   = 0xA339;
constexpr unsigned int mmCB_COLOR3_ATTRIB                                 = 0xA34A;
constexpr unsigned int mmCB_COLOR3_ATTRIB2                                = 0xA3B3;
constexpr unsigned int mmCB_COLOR3_ATTRIB3                                = 0xA3BB;
constexpr unsigned int mmCB_COLOR3_BASE                                   = 0xA345;
constexpr unsigned int mmCB_COLOR3_BASE_EXT                               = 0xA393;
constexpr unsigned int mmCB_COLOR3_DCC_BASE                               = 0xA352;
constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT                           = 0xA3AB;
constexpr unsigned int mmCB_COLOR3_DCC_CONTROL                            = 0xA34B;
constexpr unsigned int mmCB_COLOR3_INFO                                   = 0xA349;
constexpr unsigned int mmCB_COLOR3_VIEW                                   = 0xA348;
constexpr unsigned int mmCB_COLOR4_ATTRIB                                 = 0xA359;
constexpr unsigned int mmCB_COLOR4_ATTRIB2                                = 0xA3B4;
constexpr unsigned int mmCB_COLOR4_ATTRIB3                                = 0xA3BC;
constexpr unsigned int mmCB_COLOR4_BASE                                   = 0xA354;
constexpr unsigned int mmCB_COLOR4_BASE_EXT                               = 0xA394;
constexpr unsigned int mmCB_COLOR4_DCC_BASE                               = 0xA361;
constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT                           = 0xA3AC;
constexpr unsigned int mmCB_COLOR4_DCC_CONTROL                            = 0xA35A;
constexpr unsigned int mmCB_COLOR4_INFO                                   = 0xA358;
constexpr unsigned int mmCB_COLOR4_VIEW                                   = 0xA357;
constexpr unsigned int mmCB_COLOR5_ATTRIB                                 = 0xA368;
constexpr unsigned int mmCB_COLOR5_ATTRIB2                                = 0xA3B5;
constexpr unsigned int mmCB_COLOR5_ATTRIB3                                = 0xA3BD;
constexpr unsigned int mmCB_COLOR5_BASE                                   = 0xA363;
constexpr unsigned int mmCB_COLOR5_BASE_EXT                               = 0xA395;
constexpr unsigned int mmCB_COLOR5_DCC_BASE                               = 0xA370;
constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT                           = 0xA3AD;
constexpr unsigned int mmCB_COLOR5_DCC_CONTROL                            = 0xA369;
constexpr unsigned int mmCB_COLOR5_INFO                                   = 0xA367;
constexpr unsigned int mmCB_COLOR5_VIEW                                   = 0xA366;
constexpr unsigned int mmCB_COLOR6_ATTRIB                                 = 0xA377;
constexpr unsigned int mmCB_COLOR6_ATTRIB2                                = 0xA3B6;
constexpr unsigned int mmCB_COLOR6_ATTRIB3                                = 0xA3BE;
constexpr unsigned int mmCB_COLOR6_BASE                                   = 0xA372;
constexpr unsigned int mmCB_COLOR6_BASE_EXT                               = 0xA396;
constexpr unsigned int mmCB_COLOR6_DCC_BASE                               = 0xA37F;
constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT                           = 0xA3AE;
constexpr unsigned int mmCB_COLOR6_DCC_CONTROL                            = 0xA378;
constexpr unsigned int mmCB_COLOR6_INFO                                   = 0xA376;
constexpr unsigned int mmCB_COLOR6_VIEW                                   = 0xA375;
constexpr unsigned int mmCB_COLOR7_ATTRIB                                 = 0xA386;
constexpr unsigned int mmCB_COLOR7_ATTRIB2                                = 0xA3B7;
constexpr unsigned int mmCB_COLOR7_ATTRIB3                                = 0xA3BF;
constexpr unsigned int mmCB_COLOR7_BASE                                   = 0xA381;
constexpr unsigned int mmCB_COLOR7_BASE_EXT                               = 0xA397;
constexpr unsigned int mmCB_COLOR7_DCC_BASE                               = 0xA38E;
constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT                           = 0xA3AF;
constexpr unsigned int mmCB_COLOR7_DCC_CONTROL                            = 0xA387;
constexpr unsigned int mmCB_COLOR7_INFO                                   = 0xA385;
constexpr unsigned int mmCB_COLOR7_VIEW                                   = 0xA384;
constexpr unsigned int mmCB_COLOR_CONTROL                                 = 0xA202;
constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL                          = 0xA10A;
constexpr unsigned int mmCB_DCC_CONFIG                                    = 0x2687;
constexpr unsigned int mmCB_HW_CONTROL                                    = 0x2684;
constexpr unsigned int mmCB_HW_CONTROL_1                                  = 0x2685;
constexpr unsigned int mmCB_HW_CONTROL_2                                  = 0x2686;
constexpr unsigned int mmCB_HW_CONTROL_3                                  = 0x2683;
constexpr unsigned int mmCB_HW_CONTROL_4                                  = 0x2682;
constexpr unsigned int mmCB_HW_MEM_ARBITER_RD                             = 0x2688;
constexpr unsigned int mmCB_HW_MEM_ARBITER_WR                             = 0x2689;
constexpr unsigned int mmCB_PERFCOUNTER0_HI                               = 0xD407;
constexpr unsigned int mmCB_PERFCOUNTER0_LO                               = 0xD406;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT                           = 0xDC01;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1                          = 0xDC02;
constexpr unsigned int mmCB_PERFCOUNTER1_HI                               = 0xD409;
constexpr unsigned int mmCB_PERFCOUNTER1_LO                               = 0xD408;
constexpr unsigned int mmCB_PERFCOUNTER1_SELECT                           = 0xDC03;
constexpr unsigned int mmCB_PERFCOUNTER2_HI                               = 0xD40B;
constexpr unsigned int mmCB_PERFCOUNTER2_LO                               = 0xD40A;
constexpr unsigned int mmCB_PERFCOUNTER2_SELECT                           = 0xDC04;
constexpr unsigned int mmCB_PERFCOUNTER3_HI                               = 0xD40D;
constexpr unsigned int mmCB_PERFCOUNTER3_LO                               = 0xD40C;
constexpr unsigned int mmCB_PERFCOUNTER3_SELECT                           = 0xDC05;
constexpr unsigned int mmCB_PERFCOUNTER_FILTER                            = 0xDC00;
constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL                         = 0xA104;
constexpr unsigned int mmCB_SHADER_MASK                                   = 0xA08F;
constexpr unsigned int mmCB_TARGET_MASK                                   = 0xA08E;
constexpr unsigned int mmCHA_PERFCOUNTER0_HI                              = 0xD601;
constexpr unsigned int mmCHA_PERFCOUNTER0_LO                              = 0xD600;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT                          = 0xDDE0;
constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT1                         = 0xDDE1;
constexpr unsigned int mmCHA_PERFCOUNTER1_HI                              = 0xD603;
constexpr unsigned int mmCHA_PERFCOUNTER1_LO                              = 0xD602;
constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT                          = 0xDDE2;
constexpr unsigned int mmCHA_PERFCOUNTER2_HI                              = 0xD605;
constexpr unsigned int mmCHA_PERFCOUNTER2_LO                              = 0xD604;
constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT                          = 0xDDE3;
constexpr unsigned int mmCHA_PERFCOUNTER3_HI                              = 0xD607;
constexpr unsigned int mmCHA_PERFCOUNTER3_LO                              = 0xD606;
constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT                          = 0xDDE4;
constexpr unsigned int mmCHC_PERFCOUNTER0_HI                              = 0xD3C1;
constexpr unsigned int mmCHC_PERFCOUNTER0_LO                              = 0xD3C0;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT                          = 0xDBC0;
constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT1                         = 0xDBC1;
constexpr unsigned int mmCHC_PERFCOUNTER1_HI                              = 0xD3C3;
constexpr unsigned int mmCHC_PERFCOUNTER1_LO                              = 0xD3C2;
constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT                          = 0xDBC2;
constexpr unsigned int mmCHC_PERFCOUNTER2_HI                              = 0xD3C5;
constexpr unsigned int mmCHC_PERFCOUNTER2_LO                              = 0xD3C4;
constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT                          = 0xDBC3;
constexpr unsigned int mmCHC_PERFCOUNTER3_HI                              = 0xD3C7;
constexpr unsigned int mmCHC_PERFCOUNTER3_LO                              = 0xD3C6;
constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT                          = 0xDBC4;
constexpr unsigned int mmCOHER_DEST_BASE_0                                = 0xA092;
constexpr unsigned int mmCOHER_DEST_BASE_1                                = 0xA093;
constexpr unsigned int mmCOHER_DEST_BASE_2                                = 0xA07E;
constexpr unsigned int mmCOHER_DEST_BASE_3                                = 0xA07F;
constexpr unsigned int mmCOHER_DEST_BASE_HI_0                             = 0xA07A;
constexpr unsigned int mmCOHER_DEST_BASE_HI_1                             = 0xA07B;
constexpr unsigned int mmCOHER_DEST_BASE_HI_2                             = 0xA07C;
constexpr unsigned int mmCOHER_DEST_BASE_HI_3                             = 0xA07D;
constexpr unsigned int mmCOMPUTE_DDID_INDEX                               = 0x2E29;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0                       = 0x2E16;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1                       = 0x2E17;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2                       = 0x2E19;
constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3                       = 0x2E1A;
constexpr unsigned int mmCOMPUTE_DIM_X                                    = 0x2E01;
constexpr unsigned int mmCOMPUTE_DIM_Y                                    = 0x2E02;
constexpr unsigned int mmCOMPUTE_DIM_Z                                    = 0x2E03;
constexpr unsigned int mmCOMPUTE_DISPATCH_END                             = 0x2E7E;
constexpr unsigned int mmCOMPUTE_DISPATCH_ID                              = 0x2E20;
constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR                       = 0x2E00;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI                     = 0x2E0F;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO                     = 0x2E0E;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI                 = 0x2E11;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO                 = 0x2E10;
constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL                          = 0x2E7D;
constexpr unsigned int mmCOMPUTE_MISC_RESERVED                            = 0x2E1F;
constexpr unsigned int mmCOMPUTE_NOWHERE                                  = 0x2E7F;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_X                             = 0x2E07;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y                             = 0x2E08;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z                             = 0x2E09;
constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE                         = 0x2E0B;
constexpr unsigned int mmCOMPUTE_PGM_HI                                   = 0x2E0D;
constexpr unsigned int mmCOMPUTE_PGM_LO                                   = 0x2E0C;
constexpr unsigned int mmCOMPUTE_PGM_RSRC1                                = 0x2E12;
constexpr unsigned int mmCOMPUTE_PGM_RSRC2                                = 0x2E13;
constexpr unsigned int mmCOMPUTE_PGM_RSRC3                                = 0x2E28;
constexpr unsigned int mmCOMPUTE_PIPELINESTAT_ENABLE                      = 0x2E0A;
constexpr unsigned int mmCOMPUTE_REQ_CTRL                                 = 0x2E22;
constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS                          = 0x2E15;
constexpr unsigned int mmCOMPUTE_RESTART_X                                = 0x2E1B;
constexpr unsigned int mmCOMPUTE_RESTART_Y                                = 0x2E1C;
constexpr unsigned int mmCOMPUTE_RESTART_Z                                = 0x2E1D;
constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM                            = 0x2E2A;
constexpr unsigned int mmCOMPUTE_START_X                                  = 0x2E04;
constexpr unsigned int mmCOMPUTE_START_Y                                  = 0x2E05;
constexpr unsigned int mmCOMPUTE_START_Z                                  = 0x2E06;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE0                   = 0x2E16;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE1                   = 0x2E17;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE2                   = 0x2E19;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE3                   = 0x2E1A;
constexpr unsigned int mmCOMPUTE_THREADGROUP_ID                           = 0x2E21;
constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE                      = 0x2E1E;
constexpr unsigned int mmCOMPUTE_TMPRING_SIZE                             = 0x2E18;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_0                             = 0x2E24;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_1                             = 0x2E25;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_2                             = 0x2E26;
constexpr unsigned int mmCOMPUTE_USER_ACCUM_3                             = 0x2E27;
constexpr unsigned int mmCOMPUTE_USER_DATA_0                              = 0x2E40;
constexpr unsigned int mmCOMPUTE_USER_DATA_1                              = 0x2E41;
constexpr unsigned int mmCOMPUTE_USER_DATA_2                              = 0x2E42;
constexpr unsigned int mmCOMPUTE_USER_DATA_3                              = 0x2E43;
constexpr unsigned int mmCOMPUTE_USER_DATA_4                              = 0x2E44;
constexpr unsigned int mmCOMPUTE_USER_DATA_5                              = 0x2E45;
constexpr unsigned int mmCOMPUTE_USER_DATA_6                              = 0x2E46;
constexpr unsigned int mmCOMPUTE_USER_DATA_7                              = 0x2E47;
constexpr unsigned int mmCOMPUTE_USER_DATA_8                              = 0x2E48;
constexpr unsigned int mmCOMPUTE_USER_DATA_9                              = 0x2E49;
constexpr unsigned int mmCOMPUTE_USER_DATA_10                             = 0x2E4A;
constexpr unsigned int mmCOMPUTE_USER_DATA_11                             = 0x2E4B;
constexpr unsigned int mmCOMPUTE_USER_DATA_12                             = 0x2E4C;
constexpr unsigned int mmCOMPUTE_USER_DATA_13                             = 0x2E4D;
constexpr unsigned int mmCOMPUTE_USER_DATA_14                             = 0x2E4E;
constexpr unsigned int mmCOMPUTE_USER_DATA_15                             = 0x2E4F;
constexpr unsigned int mmCOMPUTE_VMID                                     = 0x2E14;
constexpr unsigned int mmCPC_PERFCOUNTER0_HI                              = 0xD007;
constexpr unsigned int mmCPC_PERFCOUNTER0_LO                              = 0xD006;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT                          = 0xD809;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT1                         = 0xD804;
constexpr unsigned int mmCPC_PERFCOUNTER1_HI                              = 0xD005;
constexpr unsigned int mmCPC_PERFCOUNTER1_LO                              = 0xD004;
constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT                          = 0xD803;
constexpr unsigned int mmCPF_PERFCOUNTER0_HI                              = 0xD00B;
constexpr unsigned int mmCPF_PERFCOUNTER0_LO                              = 0xD00A;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT                          = 0xD807;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT1                         = 0xD806;
constexpr unsigned int mmCPF_PERFCOUNTER1_HI                              = 0xD009;
constexpr unsigned int mmCPF_PERFCOUNTER1_LO                              = 0xD008;
constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT                          = 0xD805;
constexpr unsigned int mmCPG_PERFCOUNTER0_HI                              = 0xD003;
constexpr unsigned int mmCPG_PERFCOUNTER0_LO                              = 0xD002;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT                          = 0xD802;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT1                         = 0xD801;
constexpr unsigned int mmCPG_PERFCOUNTER1_HI                              = 0xD001;
constexpr unsigned int mmCPG_PERFCOUNTER1_LO                              = 0xD000;
constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT                          = 0xD800;
constexpr unsigned int mmCP_ME_COHER_BASE                                 = 0xC101;
constexpr unsigned int mmCP_ME_COHER_BASE_HI                              = 0xC102;
constexpr unsigned int mmCP_ME_COHER_CNTL                                 = 0xC0FE;
constexpr unsigned int mmCP_ME_COHER_SIZE                                 = 0xC0FF;
constexpr unsigned int mmCP_ME_COHER_SIZE_HI                              = 0xC100;
constexpr unsigned int mmCP_ME_COHER_STATUS                               = 0xC103;
constexpr unsigned int mmCP_PERFMON_CNTL                                  = 0xD808;
constexpr unsigned int mmCP_PERFMON_CNTX_CNTL                             = 0xA0D8;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_HI                          = 0xC02D;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_LO                          = 0xC02C;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_HI                          = 0xC02F;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_LO                          = 0xC02E;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_HI                          = 0xC031;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_LO                          = 0xC030;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_HI                          = 0xC027;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_LO                          = 0xC026;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_HI                          = 0xC023;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_LO                          = 0xC022;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_HI                           = 0xC01F;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_LO                           = 0xC01E;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_HI                          = 0xC025;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_LO                          = 0xC024;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_HI                           = 0xC01D;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_LO                           = 0xC01C;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_HI                           = 0xC01B;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_LO                           = 0xC01A;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_HI                          = 0xC021;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_LO                          = 0xC020;
constexpr unsigned int mmDB_ALPHA_TO_MASK                                 = 0xA2DC;
constexpr unsigned int mmDB_CGTT_CLK_CTRL_0                               = 0xF0A4;
constexpr unsigned int mmDB_COUNT_CONTROL                                 = 0xA001;
constexpr unsigned int mmDB_CREDIT_LIMIT                                  = 0x2614;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX                              = 0xA009;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN                              = 0xA008;
constexpr unsigned int mmDB_DEPTH_CLEAR                                   = 0xA00B;
constexpr unsigned int mmDB_DEPTH_CONTROL                                 = 0xA200;
constexpr unsigned int mmDB_DEPTH_SIZE_XY                                 = 0xA007;
constexpr unsigned int mmDB_DEPTH_VIEW                                    = 0xA002;
constexpr unsigned int mmDB_EQAA                                          = 0xA201;
constexpr unsigned int mmDB_EQUAD_STUTTER_CONTROL                         = 0x2612;
constexpr unsigned int mmDB_ETILE_STUTTER_CONTROL                         = 0x2610;
constexpr unsigned int mmDB_EXCEPTION_CONTROL                             = 0x261F;
constexpr unsigned int mmDB_FGCG_INTERFACES_CLK_CTRL                      = 0x2638;
constexpr unsigned int mmDB_FGCG_SRAMS_CLK_CTRL                           = 0x2637;
constexpr unsigned int mmDB_FIFO_DEPTH1                                   = 0x2618;
constexpr unsigned int mmDB_FIFO_DEPTH2                                   = 0x2619;
constexpr unsigned int mmDB_FIFO_DEPTH3                                   = 0x261D;
constexpr unsigned int mmDB_FREE_CACHELINES                               = 0x2617;
constexpr unsigned int mmDB_HTILE_DATA_BASE                               = 0xA005;
constexpr unsigned int mmDB_HTILE_DATA_BASE_HI                            = 0xA01E;
constexpr unsigned int mmDB_HTILE_SURFACE                                 = 0xA2AF;
constexpr unsigned int mmDB_LAST_OF_BURST_CONFIG                          = 0x261A;
constexpr unsigned int mmDB_LQUAD_STUTTER_CONTROL                         = 0x2613;
constexpr unsigned int mmDB_LTILE_STUTTER_CONTROL                         = 0x2611;
constexpr unsigned int mmDB_MEM_ARB_WATERMARKS                            = 0x261C;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI                           = 0xC3C1;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW                          = 0xC3C0;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI                           = 0xC3C3;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW                          = 0xC3C2;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI                           = 0xC3C5;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW                          = 0xC3C4;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI                           = 0xC3C7;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW                          = 0xC3C6;
constexpr unsigned int mmDB_PERFCOUNTER0_HI                               = 0xD441;
constexpr unsigned int mmDB_PERFCOUNTER0_LO                               = 0xD440;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT                           = 0xDC40;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1                          = 0xDC41;
constexpr unsigned int mmDB_PERFCOUNTER1_HI                               = 0xD443;
constexpr unsigned int mmDB_PERFCOUNTER1_LO                               = 0xD442;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT                           = 0xDC42;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1                          = 0xDC43;
constexpr unsigned int mmDB_PERFCOUNTER2_HI                               = 0xD445;
constexpr unsigned int mmDB_PERFCOUNTER2_LO                               = 0xD444;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT                           = 0xDC44;
constexpr unsigned int mmDB_PERFCOUNTER3_HI                               = 0xD447;
constexpr unsigned int mmDB_PERFCOUNTER3_LO                               = 0xD446;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT                           = 0xDC46;
constexpr unsigned int mmDB_PRELOAD_CONTROL                               = 0xA2B2;
constexpr unsigned int mmDB_RENDER_CONTROL                                = 0xA000;
constexpr unsigned int mmDB_RENDER_OVERRIDE                               = 0xA003;
constexpr unsigned int mmDB_RENDER_OVERRIDE2                              = 0xA004;
constexpr unsigned int mmDB_RESERVED_REG_1                                = 0xA016;
constexpr unsigned int mmDB_RESERVED_REG_2                                = 0xA00F;
constexpr unsigned int mmDB_RESERVED_REG_3                                = 0xA017;
constexpr unsigned int mmDB_RING_CONTROL                                  = 0x261B;
constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL                          = 0xA01F;
constexpr unsigned int mmDB_SHADER_CONTROL                                = 0xA203;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0                       = 0xA2B0;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1                       = 0xA2B1;
constexpr unsigned int mmDB_STENCILREFMASK                                = 0xA10C;
constexpr unsigned int mmDB_STENCILREFMASK_BF                             = 0xA10D;
constexpr unsigned int mmDB_STENCIL_CLEAR                                 = 0xA00A;
constexpr unsigned int mmDB_STENCIL_CONTROL                               = 0xA10B;
constexpr unsigned int mmDB_STENCIL_INFO                                  = 0xA011;
constexpr unsigned int mmDB_STENCIL_READ_BASE                             = 0xA013;
constexpr unsigned int mmDB_STENCIL_READ_BASE_HI                          = 0xA01B;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE                            = 0xA015;
constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI                         = 0xA01D;
constexpr unsigned int mmDB_SUBTILE_CONTROL                               = 0x2616;
constexpr unsigned int mmDB_WATERMARKS                                    = 0x2615;
constexpr unsigned int mmDB_Z_INFO                                        = 0xA010;
constexpr unsigned int mmDB_Z_READ_BASE                                   = 0xA012;
constexpr unsigned int mmDB_Z_READ_BASE_HI                                = 0xA01A;
constexpr unsigned int mmDB_Z_WRITE_BASE                                  = 0xA014;
constexpr unsigned int mmDB_Z_WRITE_BASE_HI                               = 0xA01C;
constexpr unsigned int mmGB_ADDR_CONFIG                                   = 0x263E;
constexpr unsigned int mmGB_ADDR_CONFIG_READ                              = 0x2642;
constexpr unsigned int mmGCEA_PERFCOUNTER2_HI                             = 0xD261;
constexpr unsigned int mmGCEA_PERFCOUNTER2_LO                             = 0xD260;
constexpr unsigned int mmGCEA_PERFCOUNTER2_MODE                           = 0xDA02;
constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT                         = 0xDA00;
constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT1                        = 0xDA01;
constexpr unsigned int mmGCR_PERFCOUNTER0_HI                              = 0xD521;
constexpr unsigned int mmGCR_PERFCOUNTER0_LO                              = 0xD520;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT                          = 0xDD60;
constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1                         = 0xDD61;
constexpr unsigned int mmGCR_PERFCOUNTER1_HI                              = 0xD523;
constexpr unsigned int mmGCR_PERFCOUNTER1_LO                              = 0xD522;
constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT                          = 0xDD62;
constexpr unsigned int mmGDS_PERFCOUNTER0_HI                              = 0xD281;
constexpr unsigned int mmGDS_PERFCOUNTER0_LO                              = 0xD280;
constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT                          = 0xDA80;
constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1                         = 0xDA84;
constexpr unsigned int mmGDS_PERFCOUNTER1_HI                              = 0xD283;
constexpr unsigned int mmGDS_PERFCOUNTER1_LO                              = 0xD282;
constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT                          = 0xDA81;
constexpr unsigned int mmGDS_PERFCOUNTER2_HI                              = 0xD285;
constexpr unsigned int mmGDS_PERFCOUNTER2_LO                              = 0xD284;
constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT                          = 0xDA82;
constexpr unsigned int mmGDS_PERFCOUNTER3_HI                              = 0xD287;
constexpr unsigned int mmGDS_PERFCOUNTER3_LO                              = 0xD286;
constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT                          = 0xDA83;
constexpr unsigned int mmGE_CNTL                                          = 0xC25B;
constexpr unsigned int mmGE_INDX_OFFSET                                   = 0xC24A;
constexpr unsigned int mmGE_MAX_OUTPUT_PER_SUBGROUP                       = 0xA1FF;
constexpr unsigned int mmGE_MAX_VTX_INDX                                  = 0xC259;
constexpr unsigned int mmGE_MIN_VTX_INDX                                  = 0xC249;
constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN                        = 0xC24B;
constexpr unsigned int mmGE_NGG_SUBGRP_CNTL                               = 0xA2D3;
constexpr unsigned int mmGE_PC_ALLOC                                      = 0xC260;
constexpr unsigned int mmGE_PRIV_CONTROL                                  = 0x2264;
constexpr unsigned int mmGE_STATUS                                        = 0x2265;
constexpr unsigned int mmGE_STEREO_CNTL                                   = 0xC25F;
constexpr unsigned int mmGE_USER_VGPR1                                    = 0xC25C;
constexpr unsigned int mmGE_USER_VGPR2                                    = 0xC25D;
constexpr unsigned int mmGE_USER_VGPR3                                    = 0xC25E;
constexpr unsigned int mmGE_USER_VGPR_EN                                  = 0xC262;
constexpr unsigned int mmGL1A_PERFCOUNTER0_HI                             = 0xD5C1;
constexpr unsigned int mmGL1A_PERFCOUNTER0_LO                             = 0xD5C0;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT                         = 0xDDC0;
constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT1                        = 0xDDC1;
constexpr unsigned int mmGL1A_PERFCOUNTER1_HI                             = 0xD5C3;
constexpr unsigned int mmGL1A_PERFCOUNTER1_LO                             = 0xD5C2;
constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT                         = 0xDDC2;
constexpr unsigned int mmGL1A_PERFCOUNTER2_HI                             = 0xD5C5;
constexpr unsigned int mmGL1A_PERFCOUNTER2_LO                             = 0xD5C4;
constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT                         = 0xDDC3;
constexpr unsigned int mmGL1A_PERFCOUNTER3_HI                             = 0xD5C7;
constexpr unsigned int mmGL1A_PERFCOUNTER3_LO                             = 0xD5C6;
constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT                         = 0xDDC4;
constexpr unsigned int mmGL1C_PERFCOUNTER0_HI                             = 0xD3A1;
constexpr unsigned int mmGL1C_PERFCOUNTER0_LO                             = 0xD3A0;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT                         = 0xDBA0;
constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT1                        = 0xDBA1;
constexpr unsigned int mmGL1C_PERFCOUNTER1_HI                             = 0xD3A3;
constexpr unsigned int mmGL1C_PERFCOUNTER1_LO                             = 0xD3A2;
constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT                         = 0xDBA2;
constexpr unsigned int mmGL1C_PERFCOUNTER2_HI                             = 0xD3A5;
constexpr unsigned int mmGL1C_PERFCOUNTER2_LO                             = 0xD3A4;
constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT                         = 0xDBA3;
constexpr unsigned int mmGL1C_PERFCOUNTER3_HI                             = 0xD3A7;
constexpr unsigned int mmGL1C_PERFCOUNTER3_LO                             = 0xD3A6;
constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT                         = 0xDBA4;
constexpr unsigned int mmGL2A_PERFCOUNTER0_HI                             = 0xD391;
constexpr unsigned int mmGL2A_PERFCOUNTER0_LO                             = 0xD390;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT                         = 0xDB90;
constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT1                        = 0xDB91;
constexpr unsigned int mmGL2A_PERFCOUNTER1_HI                             = 0xD393;
constexpr unsigned int mmGL2A_PERFCOUNTER1_LO                             = 0xD392;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT                         = 0xDB92;
constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT1                        = 0xDB93;
constexpr unsigned int mmGL2A_PERFCOUNTER2_HI                             = 0xD395;
constexpr unsigned int mmGL2A_PERFCOUNTER2_LO                             = 0xD394;
constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT                         = 0xDB94;
constexpr unsigned int mmGL2A_PERFCOUNTER3_HI                             = 0xD397;
constexpr unsigned int mmGL2A_PERFCOUNTER3_LO                             = 0xD396;
constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT                         = 0xDB95;
constexpr unsigned int mmGL2C_PERFCOUNTER0_HI                             = 0xD381;
constexpr unsigned int mmGL2C_PERFCOUNTER0_LO                             = 0xD380;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT                         = 0xDB80;
constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT1                        = 0xDB81;
constexpr unsigned int mmGL2C_PERFCOUNTER1_HI                             = 0xD383;
constexpr unsigned int mmGL2C_PERFCOUNTER1_LO                             = 0xD382;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT                         = 0xDB82;
constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT1                        = 0xDB83;
constexpr unsigned int mmGL2C_PERFCOUNTER2_HI                             = 0xD385;
constexpr unsigned int mmGL2C_PERFCOUNTER2_LO                             = 0xD384;
constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT                         = 0xDB84;
constexpr unsigned int mmGL2C_PERFCOUNTER3_HI                             = 0xD387;
constexpr unsigned int mmGL2C_PERFCOUNTER3_LO                             = 0xD386;
constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT                         = 0xDB85;
constexpr unsigned int mmGRBM_CHIP_REVISION                               = 0x2021;
constexpr unsigned int mmGRBM_GFX_INDEX                                   = 0xC200;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_DATA                           = 0xFA01;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_SELECT                         = 0xFA00;
constexpr unsigned int mmGRBM_PERFCOUNTER0_HI                             = 0xD041;
constexpr unsigned int mmGRBM_PERFCOUNTER0_LO                             = 0xD040;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT                         = 0xD840;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_HI                      = 0xD84D;
constexpr unsigned int mmGRBM_PERFCOUNTER1_HI                             = 0xD044;
constexpr unsigned int mmGRBM_PERFCOUNTER1_LO                             = 0xD043;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT                         = 0xD841;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_HI                      = 0xD84E;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_HI                          = 0xD046;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_LO                          = 0xD045;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_SELECT                      = 0xD842;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_HI                          = 0xD048;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_LO                          = 0xD047;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_SELECT                      = 0xD843;
constexpr unsigned int mmIA_ENHANCE                                       = 0xA29C;
constexpr unsigned int mmIA_UTCL1_CNTL                                    = 0x2246;
constexpr unsigned int mmIA_UTCL1_STATUS                                  = 0x2247;
constexpr unsigned int mmPA_CL_CLIP_CNTL                                  = 0xA204;
constexpr unsigned int mmPA_CL_CNTL_STATUS                                = 0x2284;
constexpr unsigned int mmPA_CL_ENHANCE                                    = 0x2285;
constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ                           = 0xA2FC;
constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ                           = 0xA2FD;
constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ                           = 0xA2FA;
constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ                           = 0xA2FB;
constexpr unsigned int mmPA_CL_NANINF_CNTL                                = 0xA208;
constexpr unsigned int mmPA_CL_NGG_CNTL                                   = 0xA20E;
constexpr unsigned int mmPA_CL_POINT_CULL_RAD                             = 0xA1F8;
constexpr unsigned int mmPA_CL_POINT_SIZE                                 = 0xA1F7;
constexpr unsigned int mmPA_CL_POINT_X_RAD                                = 0xA1F5;
constexpr unsigned int mmPA_CL_POINT_Y_RAD                                = 0xA1F6;
constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z                           = 0xA187;
constexpr unsigned int mmPA_CL_UCP_0_W                                    = 0xA172;
constexpr unsigned int mmPA_CL_UCP_0_X                                    = 0xA16F;
constexpr unsigned int mmPA_CL_UCP_0_Y                                    = 0xA170;
constexpr unsigned int mmPA_CL_UCP_0_Z                                    = 0xA171;
constexpr unsigned int mmPA_CL_UCP_1_W                                    = 0xA176;
constexpr unsigned int mmPA_CL_UCP_1_X                                    = 0xA173;
constexpr unsigned int mmPA_CL_UCP_1_Y                                    = 0xA174;
constexpr unsigned int mmPA_CL_UCP_1_Z                                    = 0xA175;
constexpr unsigned int mmPA_CL_UCP_2_W                                    = 0xA17A;
constexpr unsigned int mmPA_CL_UCP_2_X                                    = 0xA177;
constexpr unsigned int mmPA_CL_UCP_2_Y                                    = 0xA178;
constexpr unsigned int mmPA_CL_UCP_2_Z                                    = 0xA179;
constexpr unsigned int mmPA_CL_UCP_3_W                                    = 0xA17E;
constexpr unsigned int mmPA_CL_UCP_3_X                                    = 0xA17B;
constexpr unsigned int mmPA_CL_UCP_3_Y                                    = 0xA17C;
constexpr unsigned int mmPA_CL_UCP_3_Z                                    = 0xA17D;
constexpr unsigned int mmPA_CL_UCP_4_W                                    = 0xA182;
constexpr unsigned int mmPA_CL_UCP_4_X                                    = 0xA17F;
constexpr unsigned int mmPA_CL_UCP_4_Y                                    = 0xA180;
constexpr unsigned int mmPA_CL_UCP_4_Z                                    = 0xA181;
constexpr unsigned int mmPA_CL_UCP_5_W                                    = 0xA186;
constexpr unsigned int mmPA_CL_UCP_5_X                                    = 0xA183;
constexpr unsigned int mmPA_CL_UCP_5_Y                                    = 0xA184;
constexpr unsigned int mmPA_CL_UCP_5_Z                                    = 0xA185;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET                              = 0xA110;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1                            = 0xA116;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2                            = 0xA11C;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3                            = 0xA122;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4                            = 0xA128;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5                            = 0xA12E;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6                            = 0xA134;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7                            = 0xA13A;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8                            = 0xA140;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9                            = 0xA146;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10                           = 0xA14C;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11                           = 0xA152;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12                           = 0xA158;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13                           = 0xA15E;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14                           = 0xA164;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15                           = 0xA16A;
constexpr unsigned int mmPA_CL_VPORT_XSCALE                               = 0xA10F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_1                             = 0xA115;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_2                             = 0xA11B;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_3                             = 0xA121;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_4                             = 0xA127;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_5                             = 0xA12D;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_6                             = 0xA133;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_7                             = 0xA139;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_8                             = 0xA13F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_9                             = 0xA145;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_10                            = 0xA14B;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_11                            = 0xA151;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_12                            = 0xA157;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_13                            = 0xA15D;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_14                            = 0xA163;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_15                            = 0xA169;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET                              = 0xA112;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1                            = 0xA118;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2                            = 0xA11E;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3                            = 0xA124;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4                            = 0xA12A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5                            = 0xA130;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6                            = 0xA136;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7                            = 0xA13C;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8                            = 0xA142;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9                            = 0xA148;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10                           = 0xA14E;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11                           = 0xA154;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12                           = 0xA15A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13                           = 0xA160;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14                           = 0xA166;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15                           = 0xA16C;
constexpr unsigned int mmPA_CL_VPORT_YSCALE                               = 0xA111;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_1                             = 0xA117;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_2                             = 0xA11D;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_3                             = 0xA123;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_4                             = 0xA129;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_5                             = 0xA12F;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_6                             = 0xA135;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_7                             = 0xA13B;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_8                             = 0xA141;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_9                             = 0xA147;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_10                            = 0xA14D;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_11                            = 0xA153;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_12                            = 0xA159;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_13                            = 0xA15F;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_14                            = 0xA165;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_15                            = 0xA16B;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET                              = 0xA114;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1                            = 0xA11A;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2                            = 0xA120;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3                            = 0xA126;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4                            = 0xA12C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5                            = 0xA132;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6                            = 0xA138;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7                            = 0xA13E;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8                            = 0xA144;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9                            = 0xA14A;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10                           = 0xA150;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11                           = 0xA156;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12                           = 0xA15C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13                           = 0xA162;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14                           = 0xA168;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15                           = 0xA16E;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE                               = 0xA113;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1                             = 0xA119;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2                             = 0xA11F;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3                             = 0xA125;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4                             = 0xA12B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5                             = 0xA131;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6                             = 0xA137;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7                             = 0xA13D;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8                             = 0xA143;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9                             = 0xA149;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10                            = 0xA14F;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11                            = 0xA155;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12                            = 0xA15B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13                            = 0xA161;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14                            = 0xA167;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15                            = 0xA16D;
constexpr unsigned int mmPA_CL_VS_OUT_CNTL                                = 0xA207;
constexpr unsigned int mmPA_CL_VTE_CNTL                                   = 0xA206;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI                            = 0xD581;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO                            = 0xD580;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT                        = 0xDD80;
constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1                       = 0xDD81;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI                            = 0xD583;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO                            = 0xD582;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT                        = 0xDD82;
constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1                       = 0xDD90;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI                            = 0xD585;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO                            = 0xD584;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT                        = 0xDD83;
constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1                       = 0xDD91;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI                            = 0xD587;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO                            = 0xD586;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT                        = 0xDD84;
constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1                       = 0xDD92;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI                            = 0xD589;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO                            = 0xD588;
constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT                        = 0xDD85;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI                            = 0xD58B;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO                            = 0xD58A;
constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT                        = 0xDD86;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI                            = 0xD58D;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO                            = 0xD58C;
constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT                        = 0xDD87;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI                            = 0xD58F;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO                            = 0xD58E;
constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT                        = 0xDD88;
constexpr unsigned int mmPA_SC_AA_CONFIG                                  = 0xA2F8;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0                          = 0xA30E;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1                          = 0xA30F;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0                = 0xA2FE;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1                = 0xA2FF;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2                = 0xA300;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3                = 0xA301;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0                = 0xA306;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1                = 0xA307;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2                = 0xA308;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3                = 0xA309;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0                = 0xA302;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1                = 0xA303;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2                = 0xA304;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3                = 0xA305;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0                = 0xA30A;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1                = 0xA30B;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2                = 0xA30C;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3                = 0xA30D;
constexpr unsigned int mmPA_SC_BINNER_CNTL_0                              = 0xA311;
constexpr unsigned int mmPA_SC_BINNER_CNTL_1                              = 0xA312;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0                        = 0xA2F5;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1                        = 0xA2F6;
constexpr unsigned int mmPA_SC_CLIPRECT_0_BR                              = 0xA085;
constexpr unsigned int mmPA_SC_CLIPRECT_0_TL                              = 0xA084;
constexpr unsigned int mmPA_SC_CLIPRECT_1_BR                              = 0xA087;
constexpr unsigned int mmPA_SC_CLIPRECT_1_TL                              = 0xA086;
constexpr unsigned int mmPA_SC_CLIPRECT_2_BR                              = 0xA089;
constexpr unsigned int mmPA_SC_CLIPRECT_2_TL                              = 0xA088;
constexpr unsigned int mmPA_SC_CLIPRECT_3_BR                              = 0xA08B;
constexpr unsigned int mmPA_SC_CLIPRECT_3_TL                              = 0xA08A;
constexpr unsigned int mmPA_SC_CLIPRECT_RULE                              = 0xA083;
constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL            = 0xA313;
constexpr unsigned int mmPA_SC_EDGERULE                                   = 0xA08C;
constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL                            = 0x2295;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR                         = 0xA091;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL                         = 0xA090;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT                     = 0xC2AC;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H                         = 0xC2A9;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_EN                     = 0xC2A8;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE                = 0xC2AB;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V                         = 0xC2AA;
constexpr unsigned int mmPA_SC_LINE_CNTL                                  = 0xA2F7;
constexpr unsigned int mmPA_SC_LINE_STIPPLE                               = 0xA283;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_STATE                         = 0xC281;
constexpr unsigned int mmPA_SC_MODE_CNTL_0                                = 0xA292;
constexpr unsigned int mmPA_SC_MODE_CNTL_1                                = 0xA293;
constexpr unsigned int mmPA_SC_NGG_MODE_CNTL                              = 0xA314;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT                      = 0xC2A4;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H                          = 0xC2A1;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_EN                      = 0xC2A0;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE                 = 0xC2A3;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V                          = 0xC2A2;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI                            = 0xD141;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO                            = 0xD140;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT                        = 0xD940;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1                       = 0xD941;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI                            = 0xD143;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO                            = 0xD142;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT                        = 0xD942;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI                            = 0xD145;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO                            = 0xD144;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT                        = 0xD943;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI                            = 0xD147;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO                            = 0xD146;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT                        = 0xD944;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI                            = 0xD149;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO                            = 0xD148;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT                        = 0xD945;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI                            = 0xD14B;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO                            = 0xD14A;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT                        = 0xD946;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI                            = 0xD14D;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO                            = 0xD14C;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT                        = 0xD947;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI                            = 0xD14F;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO                            = 0xD14E;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT                        = 0xD948;
constexpr unsigned int mmPA_SC_RASTER_CONFIG                              = 0xA0D4;
constexpr unsigned int mmPA_SC_RASTER_CONFIG_1                            = 0xA0D5;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR                          = 0xA00D;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL                          = 0xA00C;
constexpr unsigned int mmPA_SC_SHADER_CONTROL                             = 0xA310;
constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE                     = 0xA0D7;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT                          = 0xC2B4;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_H                              = 0xC2B1;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_EN                          = 0xC2B0;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE                     = 0xC2B3;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_V                              = 0xC2B2;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR                         = 0xA095;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL                         = 0xA094;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR                         = 0xA097;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL                         = 0xA096;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR                         = 0xA099;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL                         = 0xA098;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR                         = 0xA09B;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL                         = 0xA09A;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR                         = 0xA09D;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL                         = 0xA09C;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR                         = 0xA09F;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL                         = 0xA09E;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR                         = 0xA0A1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL                         = 0xA0A0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR                         = 0xA0A3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL                         = 0xA0A2;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR                         = 0xA0A5;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL                         = 0xA0A4;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR                         = 0xA0A7;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL                         = 0xA0A6;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR                        = 0xA0A9;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL                        = 0xA0A8;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR                        = 0xA0AB;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL                        = 0xA0AA;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR                        = 0xA0AD;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL                        = 0xA0AC;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR                        = 0xA0AF;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL                        = 0xA0AE;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR                        = 0xA0B1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL                        = 0xA0B0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR                        = 0xA0B3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL                        = 0xA0B2;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_0                               = 0xA0B5;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_1                               = 0xA0B7;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_2                               = 0xA0B9;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_3                               = 0xA0BB;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_4                               = 0xA0BD;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_5                               = 0xA0BF;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_6                               = 0xA0C1;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_7                               = 0xA0C3;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_8                               = 0xA0C5;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_9                               = 0xA0C7;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_10                              = 0xA0C9;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_11                              = 0xA0CB;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_12                              = 0xA0CD;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_13                              = 0xA0CF;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_14                              = 0xA0D1;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_15                              = 0xA0D3;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_0                               = 0xA0B4;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_1                               = 0xA0B6;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_2                               = 0xA0B8;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_3                               = 0xA0BA;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_4                               = 0xA0BC;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_5                               = 0xA0BE;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_6                               = 0xA0C0;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_7                               = 0xA0C2;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_8                               = 0xA0C4;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_9                               = 0xA0C6;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_10                              = 0xA0C8;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_11                              = 0xA0CA;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_12                              = 0xA0CC;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_13                              = 0xA0CE;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_14                              = 0xA0D0;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_15                              = 0xA0D2;
constexpr unsigned int mmPA_SC_WINDOW_OFFSET                              = 0xA080;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR                          = 0xA082;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL                          = 0xA081;
constexpr unsigned int mmPA_STATE_STEREO_X                                = 0xA211;
constexpr unsigned int mmPA_STEREO_CNTL                                   = 0xA210;
constexpr unsigned int mmPA_SU_CNTL_STATUS                                = 0x2294;
constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET                     = 0xA08D;
constexpr unsigned int mmPA_SU_LINE_CNTL                                  = 0xA282;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL                          = 0xA209;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE                         = 0xA20A;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE                         = 0xC280;
constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL                    = 0xA20F;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI                            = 0xD101;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO                            = 0xD100;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT                        = 0xD900;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1                       = 0xD901;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI                            = 0xD103;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO                            = 0xD102;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT                        = 0xD902;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1                       = 0xD903;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI                            = 0xD105;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO                            = 0xD104;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT                        = 0xD904;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1                       = 0xD905;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI                            = 0xD107;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO                            = 0xD106;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT                        = 0xD906;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1                       = 0xD907;
constexpr unsigned int mmPA_SU_POINT_MINMAX                               = 0xA281;
constexpr unsigned int mmPA_SU_POINT_SIZE                                 = 0xA280;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET                    = 0xA2E3;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE                     = 0xA2E2;
constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP                          = 0xA2DF;
constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL                    = 0xA2DE;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET                   = 0xA2E1;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE                    = 0xA2E0;
constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL                           = 0xA20B;
constexpr unsigned int mmPA_SU_SC_MODE_CNTL                               = 0xA205;
constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL                     = 0xA20C;
constexpr unsigned int mmPA_SU_VTX_CNTL                                   = 0xA2F9;
constexpr unsigned int mmRLC_CGTT_MGCG_OVERRIDE                           = 0xEC48;
constexpr unsigned int mmRLC_PERFCOUNTER0_HI                              = 0xD481;
constexpr unsigned int mmRLC_PERFCOUNTER0_LO                              = 0xD480;
constexpr unsigned int mmRLC_PERFCOUNTER0_SELECT                          = 0xDCC1;
constexpr unsigned int mmRLC_PERFCOUNTER1_HI                              = 0xD483;
constexpr unsigned int mmRLC_PERFCOUNTER1_LO                              = 0xD482;
constexpr unsigned int mmRLC_PERFCOUNTER1_SELECT                          = 0xDCC2;
constexpr unsigned int mmRLC_PERFMON_CNTL                                 = 0xDCC0;
constexpr unsigned int mmRLC_SPM_ACCUM_CTRL                               = 0xDC9A;
constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT                    = 0xDC9E;
constexpr unsigned int mmRLC_SPM_ACCUM_MODE                               = 0xDC9B;
constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED                  = 0xDC9D;
constexpr unsigned int mmRLC_SPM_ACCUM_STATUS                             = 0xDC99;
constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD                          = 0xDC9C;
constexpr unsigned int mmRLC_SPM_PERFMON_CNTL                             = 0xDC80;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_HI                     = 0xDC82;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_LO                     = 0xDC81;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_SIZE                        = 0xDC83;
constexpr unsigned int mmRLC_SPM_RING_RDPTR                               = 0xDC85;
constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD                        = 0xDC86;
constexpr unsigned int mmRLC_SPM_THREAD_TRACE_CTRL                        = 0xEDE6;
constexpr unsigned int mmRLC_SPM_UTCL1_CNTL                               = 0xECB5;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_1                            = 0xECBC;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_2                            = 0xECBD;
constexpr unsigned int mmRMI_PERFCOUNTER0_HI                              = 0xD4C1;
constexpr unsigned int mmRMI_PERFCOUNTER0_LO                              = 0xD4C0;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT                          = 0xDD00;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1                         = 0xDD01;
constexpr unsigned int mmRMI_PERFCOUNTER1_HI                              = 0xD4C3;
constexpr unsigned int mmRMI_PERFCOUNTER1_LO                              = 0xD4C2;
constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT                          = 0xDD02;
constexpr unsigned int mmRMI_PERFCOUNTER2_HI                              = 0xD4C5;
constexpr unsigned int mmRMI_PERFCOUNTER2_LO                              = 0xD4C4;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT                          = 0xDD03;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1                         = 0xDD04;
constexpr unsigned int mmRMI_PERFCOUNTER3_HI                              = 0xD4C7;
constexpr unsigned int mmRMI_PERFCOUNTER3_LO                              = 0xD4C6;
constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT                          = 0xDD05;
constexpr unsigned int mmRMI_PERF_COUNTER_CNTL                            = 0xDD06;
constexpr unsigned int mmSPI_ARB_CYCLES_0                                 = 0x31C1;
constexpr unsigned int mmSPI_ARB_CYCLES_1                                 = 0x31C2;
constexpr unsigned int mmSPI_ARB_PRIORITY                                 = 0x31C0;
constexpr unsigned int mmSPI_BARYC_CNTL                                   = 0xA1B8;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_0                        = 0x24DC;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_1                        = 0x24DD;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_2                        = 0x24DE;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_3                        = 0x24DF;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_STATUS                         = 0x24DB;
constexpr unsigned int mmSPI_DSM_CNTL                                     = 0x2443;
constexpr unsigned int mmSPI_DSM_CNTL2                                    = 0x2444;
constexpr unsigned int mmSPI_EDC_CNT                                      = 0x2445;
constexpr unsigned int mmSPI_GDS_CREDITS                                  = 0x24D8;
constexpr unsigned int mmSPI_GFX_CNTL                                     = 0x243C;
constexpr unsigned int mmSPI_INTERP_CONTROL_0                             = 0xA1B5;
constexpr unsigned int mmSPI_LB_CTR_CTRL                                  = 0x24D4;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_CS                       = 0x24E7;
constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_HSGS                     = 0x24E5;
constexpr unsigned int mmSPI_LB_DATA_REG                                  = 0x24D6;
constexpr unsigned int mmSPI_LB_DATA_WAVES                                = 0x24E4;
constexpr unsigned int mmSPI_LB_WGP_MASK                                  = 0x24D5;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_GPR_MIN                       = 0x24F0;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_HI                       = 0x24ED;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_LO                       = 0x24EC;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_HI                       = 0x24EF;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_LO                       = 0x24EE;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_GPR_MIN                       = 0x24F5;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_HI                       = 0x24F2;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_LO                       = 0x24F1;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_HI                       = 0x24F4;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_LO                       = 0x24F3;
constexpr unsigned int mmSPI_PERFCOUNTER0_HI                              = 0xD180;
constexpr unsigned int mmSPI_PERFCOUNTER0_LO                              = 0xD181;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT                          = 0xD980;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT1                         = 0xD984;
constexpr unsigned int mmSPI_PERFCOUNTER1_HI                              = 0xD182;
constexpr unsigned int mmSPI_PERFCOUNTER1_LO                              = 0xD183;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT                          = 0xD981;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT1                         = 0xD985;
constexpr unsigned int mmSPI_PERFCOUNTER2_HI                              = 0xD184;
constexpr unsigned int mmSPI_PERFCOUNTER2_LO                              = 0xD185;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT                          = 0xD982;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT1                         = 0xD986;
constexpr unsigned int mmSPI_PERFCOUNTER3_HI                              = 0xD186;
constexpr unsigned int mmSPI_PERFCOUNTER3_LO                              = 0xD187;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT                          = 0xD983;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT1                         = 0xD987;
constexpr unsigned int mmSPI_PERFCOUNTER4_HI                              = 0xD188;
constexpr unsigned int mmSPI_PERFCOUNTER4_LO                              = 0xD189;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT                          = 0xD988;
constexpr unsigned int mmSPI_PERFCOUNTER5_HI                              = 0xD18A;
constexpr unsigned int mmSPI_PERFCOUNTER5_LO                              = 0xD18B;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT                          = 0xD989;
constexpr unsigned int mmSPI_PERFCOUNTER_BINS                             = 0xD98A;
constexpr unsigned int mmSPI_PG_ENABLE_STATIC_WGP_MASK                    = 0x24D7;
constexpr unsigned int mmSPI_PQEV_CTRL                                    = 0x2720;
constexpr unsigned int mmSPI_PS_INPUT_ADDR                                = 0xA1B4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_0                              = 0xA191;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_1                              = 0xA192;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_2                              = 0xA193;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_3                              = 0xA194;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_4                              = 0xA195;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_5                              = 0xA196;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_6                              = 0xA197;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_7                              = 0xA198;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_8                              = 0xA199;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_9                              = 0xA19A;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_10                             = 0xA19B;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_11                             = 0xA19C;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_12                             = 0xA19D;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_13                             = 0xA19E;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_14                             = 0xA19F;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_15                             = 0xA1A0;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_16                             = 0xA1A1;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_17                             = 0xA1A2;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_18                             = 0xA1A3;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_19                             = 0xA1A4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_20                             = 0xA1A5;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_21                             = 0xA1A6;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_22                             = 0xA1A7;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_23                             = 0xA1A8;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_24                             = 0xA1A9;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_25                             = 0xA1AA;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_26                             = 0xA1AB;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_27                             = 0xA1AC;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_28                             = 0xA1AD;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_29                             = 0xA1AE;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_30                             = 0xA1AF;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_31                             = 0xA1B0;
constexpr unsigned int mmSPI_PS_INPUT_ENA                                 = 0xA1B3;
constexpr unsigned int mmSPI_PS_IN_CONTROL                                = 0xA1B6;
constexpr unsigned int mmSPI_PS_MAX_WAVE_ID                               = 0x243A;
constexpr unsigned int mmSPI_SHADER_COL_FORMAT                            = 0xA1C5;
constexpr unsigned int mmSPI_SHADER_IDX_FORMAT                            = 0xA1C2;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS                         = 0x2C80;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS                         = 0x2D00;
constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS                         = 0x2C06;
constexpr unsigned int mmSPI_SHADER_PGM_HI_ES                             = 0x2CC9;
constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS                          = 0x2C85;
constexpr unsigned int mmSPI_SHADER_PGM_HI_GS                             = 0x2C89;
constexpr unsigned int mmSPI_SHADER_PGM_HI_HS                             = 0x2D09;
constexpr unsigned int mmSPI_SHADER_PGM_HI_LS                             = 0x2D49;
constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS                          = 0x2D05;
constexpr unsigned int mmSPI_SHADER_PGM_HI_PS                             = 0x2C09;
constexpr unsigned int mmSPI_SHADER_PGM_LO_ES                             = 0x2CC8;
constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS                          = 0x2C84;
constexpr unsigned int mmSPI_SHADER_PGM_LO_GS                             = 0x2C88;
constexpr unsigned int mmSPI_SHADER_PGM_LO_HS                             = 0x2D08;
constexpr unsigned int mmSPI_SHADER_PGM_LO_LS                             = 0x2D48;
constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS                          = 0x2D04;
constexpr unsigned int mmSPI_SHADER_PGM_LO_PS                             = 0x2C08;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS                          = 0x2C8A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS                          = 0x2D0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS                          = 0x2C0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS                          = 0x2C8B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS                          = 0x2D0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS                          = 0x2C0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS                          = 0x2C87;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS                          = 0x2D07;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS                          = 0x2C07;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS                          = 0x2C81;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS                          = 0x2D01;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS                          = 0x2C01;
constexpr unsigned int mmSPI_SHADER_POS_FORMAT                            = 0xA1C3;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS                         = 0x2CB0;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS                         = 0x2D30;
constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS                           = 0x2C30;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0                     = 0x2CB2;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1                     = 0x2CB3;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2                     = 0x2CB4;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3                     = 0x2CB5;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0                     = 0x2D32;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1                     = 0x2D33;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2                     = 0x2D34;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3                     = 0x2D35;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0                       = 0x2C32;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1                       = 0x2C33;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2                       = 0x2C34;
constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3                       = 0x2C35;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS                  = 0x2C83;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS                  = 0x2D03;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS                  = 0x2C82;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS                  = 0x2D02;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0                        = 0x2C8C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1                        = 0x2C8D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2                        = 0x2C8E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3                        = 0x2C8F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4                        = 0x2C90;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5                        = 0x2C91;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6                        = 0x2C92;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7                        = 0x2C93;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8                        = 0x2C94;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9                        = 0x2C95;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10                       = 0x2C96;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11                       = 0x2C97;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12                       = 0x2C98;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13                       = 0x2C99;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14                       = 0x2C9A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15                       = 0x2C9B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16                       = 0x2C9C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17                       = 0x2C9D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18                       = 0x2C9E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19                       = 0x2C9F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20                       = 0x2CA0;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21                       = 0x2CA1;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22                       = 0x2CA2;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23                       = 0x2CA3;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24                       = 0x2CA4;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25                       = 0x2CA5;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26                       = 0x2CA6;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27                       = 0x2CA7;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28                       = 0x2CA8;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29                       = 0x2CA9;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30                       = 0x2CAA;
constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31                       = 0x2CAB;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0                        = 0x2D0C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1                        = 0x2D0D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2                        = 0x2D0E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3                        = 0x2D0F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4                        = 0x2D10;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5                        = 0x2D11;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6                        = 0x2D12;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7                        = 0x2D13;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8                        = 0x2D14;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9                        = 0x2D15;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10                       = 0x2D16;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11                       = 0x2D17;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12                       = 0x2D18;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13                       = 0x2D19;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14                       = 0x2D1A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15                       = 0x2D1B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16                       = 0x2D1C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17                       = 0x2D1D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18                       = 0x2D1E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19                       = 0x2D1F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20                       = 0x2D20;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21                       = 0x2D21;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22                       = 0x2D22;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23                       = 0x2D23;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24                       = 0x2D24;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25                       = 0x2D25;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26                       = 0x2D26;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27                       = 0x2D27;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28                       = 0x2D28;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29                       = 0x2D29;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30                       = 0x2D2A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31                       = 0x2D2B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0                        = 0x2C0C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1                        = 0x2C0D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2                        = 0x2C0E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3                        = 0x2C0F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4                        = 0x2C10;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5                        = 0x2C11;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6                        = 0x2C12;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7                        = 0x2C13;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8                        = 0x2C14;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9                        = 0x2C15;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10                       = 0x2C16;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11                       = 0x2C17;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12                       = 0x2C18;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13                       = 0x2C19;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14                       = 0x2C1A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15                       = 0x2C1B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16                       = 0x2C1C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17                       = 0x2C1D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18                       = 0x2C1E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19                       = 0x2C1F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20                       = 0x2C20;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21                       = 0x2C21;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22                       = 0x2C22;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23                       = 0x2C23;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24                       = 0x2C24;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25                       = 0x2C25;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26                       = 0x2C26;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27                       = 0x2C27;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28                       = 0x2C28;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29                       = 0x2C29;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30                       = 0x2C2A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31                       = 0x2C2B;
constexpr unsigned int mmSPI_SHADER_Z_FORMAT                              = 0xA1C4;
constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES                       = 0x24D9;
constexpr unsigned int mmSPI_SX_SCOREBOARD_BUFFER_SIZES                   = 0x24DA;
constexpr unsigned int mmSPI_TMPRING_SIZE                                 = 0xA1BA;
constexpr unsigned int mmSPI_VS_OUT_CONFIG                                = 0xA1B1;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS0                         = 0x31C9;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS1                         = 0x31CA;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS2                         = 0x31CB;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS3                         = 0x31CC;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX                         = 0x31C7;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_HP3D                        = 0x31C8;
constexpr unsigned int mmSPI_WF_LIFETIME_CNTL                             = 0x24AA;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_0                          = 0x24AB;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_1                          = 0x24AC;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_2                          = 0x24AD;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_3                          = 0x24AE;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_4                          = 0x24AF;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_5                          = 0x24B0;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_0                         = 0x24B5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_2                         = 0x24B7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_4                         = 0x24B9;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_6                         = 0x24BB;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_7                         = 0x24BC;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_9                         = 0x24BE;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_11                        = 0x24C0;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_13                        = 0x24C2;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_14                        = 0x24C3;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_15                        = 0x24C4;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_16                        = 0x24C5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_17                        = 0x24C6;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_18                        = 0x24C7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_19                        = 0x24C8;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_20                        = 0x24C9;
constexpr unsigned int mmSQG_CONFIG                                       = 0x231A;
constexpr unsigned int mmSQG_STATUS                                       = 0x2304;
constexpr unsigned int mmSQ_ALU_CLK_CTRL                                  = 0xF08E;
constexpr unsigned int mmSQ_ARB_CONFIG                                    = 0x230C;
constexpr unsigned int mmSQ_CMD                                           = 0x237B;
constexpr unsigned int mmSQ_CONFIG                                        = 0x2300;
constexpr unsigned int mmSQ_DSM_CNTL                                      = 0x2306;
constexpr unsigned int mmSQ_DSM_CNTL2                                     = 0x2307;
constexpr unsigned int mmSQ_FIFO_SIZES                                    = 0x2305;
constexpr unsigned int mmSQ_IND_DATA                                      = 0x2379;
constexpr unsigned int mmSQ_IND_INDEX                                     = 0x2378;
constexpr unsigned int mmSQ_LDS_CLK_CTRL                                  = 0xF090;
constexpr unsigned int mmSQ_PERFCOUNTER0_LO                               = 0xD1C0;
constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT                           = 0xD9C0;
constexpr unsigned int mmSQ_PERFCOUNTER1_LO                               = 0xD1C2;
constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT                           = 0xD9C1;
constexpr unsigned int mmSQ_PERFCOUNTER2_LO                               = 0xD1C4;
constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT                           = 0xD9C2;
constexpr unsigned int mmSQ_PERFCOUNTER3_LO                               = 0xD1C6;
constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT                           = 0xD9C3;
constexpr unsigned int mmSQ_PERFCOUNTER4_LO                               = 0xD1C8;
constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT                           = 0xD9C4;
constexpr unsigned int mmSQ_PERFCOUNTER5_LO                               = 0xD1CA;
constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT                           = 0xD9C5;
constexpr unsigned int mmSQ_PERFCOUNTER6_LO                               = 0xD1CC;
constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT                           = 0xD9C6;
constexpr unsigned int mmSQ_PERFCOUNTER7_LO                               = 0xD1CE;
constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT                           = 0xD9C7;
constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT                           = 0xD9C8;
constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT                           = 0xD9C9;
constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT                          = 0xD9CA;
constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT                          = 0xD9CB;
constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT                          = 0xD9CC;
constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT                          = 0xD9CD;
constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT                          = 0xD9CE;
constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT                          = 0xD9CF;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL                              = 0xD9E0;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2                             = 0xD9E2;
constexpr unsigned int mmSQ_RANDOM_WAVE_PRI                               = 0x2303;
constexpr unsigned int mmSQ_TEX_CLK_CTRL                                  = 0xF08F;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0                       = 0xC340;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1                       = 0xC341;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2                       = 0xC342;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3                       = 0xC343;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4                       = 0xC344;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5                       = 0xC345;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6                       = 0xC346;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7                       = 0xC347;
constexpr unsigned int mmSQ_WATCH0_ADDR_H                                 = 0x2330;
constexpr unsigned int mmSQ_WATCH0_ADDR_L                                 = 0x2331;
constexpr unsigned int mmSQ_WATCH0_CNTL                                   = 0x2332;
constexpr unsigned int mmSQ_WATCH1_ADDR_H                                 = 0x2333;
constexpr unsigned int mmSQ_WATCH1_ADDR_L                                 = 0x2334;
constexpr unsigned int mmSQ_WATCH1_CNTL                                   = 0x2335;
constexpr unsigned int mmSQ_WATCH2_ADDR_H                                 = 0x2336;
constexpr unsigned int mmSQ_WATCH2_ADDR_L                                 = 0x2337;
constexpr unsigned int mmSQ_WATCH2_CNTL                                   = 0x2338;
constexpr unsigned int mmSQ_WATCH3_ADDR_H                                 = 0x2339;
constexpr unsigned int mmSQ_WATCH3_ADDR_L                                 = 0x233A;
constexpr unsigned int mmSQ_WATCH3_CNTL                                   = 0x233B;
constexpr unsigned int mmSX_BLEND_OPT_CONTROL                             = 0xA1D7;
constexpr unsigned int mmSX_BLEND_OPT_EPSILON                             = 0xA1D6;
constexpr unsigned int mmSX_MRT0_BLEND_OPT                                = 0xA1D8;
constexpr unsigned int mmSX_MRT1_BLEND_OPT                                = 0xA1D9;
constexpr unsigned int mmSX_MRT2_BLEND_OPT                                = 0xA1DA;
constexpr unsigned int mmSX_MRT3_BLEND_OPT                                = 0xA1DB;
constexpr unsigned int mmSX_MRT4_BLEND_OPT                                = 0xA1DC;
constexpr unsigned int mmSX_MRT5_BLEND_OPT                                = 0xA1DD;
constexpr unsigned int mmSX_MRT6_BLEND_OPT                                = 0xA1DE;
constexpr unsigned int mmSX_MRT7_BLEND_OPT                                = 0xA1DF;
constexpr unsigned int mmSX_PERFCOUNTER0_HI                               = 0xD241;
constexpr unsigned int mmSX_PERFCOUNTER0_LO                               = 0xD240;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT                           = 0xDA40;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1                          = 0xDA44;
constexpr unsigned int mmSX_PERFCOUNTER1_HI                               = 0xD243;
constexpr unsigned int mmSX_PERFCOUNTER1_LO                               = 0xD242;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT                           = 0xDA41;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1                          = 0xDA45;
constexpr unsigned int mmSX_PERFCOUNTER2_HI                               = 0xD245;
constexpr unsigned int mmSX_PERFCOUNTER2_LO                               = 0xD244;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT                           = 0xDA42;
constexpr unsigned int mmSX_PERFCOUNTER3_HI                               = 0xD247;
constexpr unsigned int mmSX_PERFCOUNTER3_LO                               = 0xD246;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT                           = 0xDA43;
constexpr unsigned int mmSX_PS_DOWNCONVERT                                = 0xA1D5;
constexpr unsigned int mmTA_BC_BASE_ADDR                                  = 0xA020;
constexpr unsigned int mmTA_BC_BASE_ADDR_HI                               = 0xA021;
constexpr unsigned int mmTA_CGTT_CTRL                                     = 0xF09D;
constexpr unsigned int mmTA_CNTL                                          = 0x2541;
constexpr unsigned int mmTA_CNTL_AUX                                      = 0x2542;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR                               = 0xC380;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI                            = 0xC381;
constexpr unsigned int mmTA_PERFCOUNTER0_HI                               = 0xD2C1;
constexpr unsigned int mmTA_PERFCOUNTER0_LO                               = 0xD2C0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT                           = 0xDAC0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1                          = 0xDAC1;
constexpr unsigned int mmTA_PERFCOUNTER1_HI                               = 0xD2C3;
constexpr unsigned int mmTA_PERFCOUNTER1_LO                               = 0xD2C2;
constexpr unsigned int mmTA_PERFCOUNTER1_SELECT                           = 0xDAC2;
constexpr unsigned int mmTA_SCRATCH                                       = 0x2564;
constexpr unsigned int mmTA_STATUS                                        = 0x2548;
constexpr unsigned int mmTCP_PERFCOUNTER0_HI                              = 0xD341;
constexpr unsigned int mmTCP_PERFCOUNTER0_LO                              = 0xD340;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT                          = 0xDB40;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT1                         = 0xDB41;
constexpr unsigned int mmTCP_PERFCOUNTER1_HI                              = 0xD343;
constexpr unsigned int mmTCP_PERFCOUNTER1_LO                              = 0xD342;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT                          = 0xDB42;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT1                         = 0xDB43;
constexpr unsigned int mmTCP_PERFCOUNTER2_HI                              = 0xD345;
constexpr unsigned int mmTCP_PERFCOUNTER2_LO                              = 0xD344;
constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT                          = 0xDB44;
constexpr unsigned int mmTCP_PERFCOUNTER3_HI                              = 0xD347;
constexpr unsigned int mmTCP_PERFCOUNTER3_LO                              = 0xD346;
constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT                          = 0xDB45;
constexpr unsigned int mmTD_PERFCOUNTER0_HI                               = 0xD301;
constexpr unsigned int mmTD_PERFCOUNTER0_LO                               = 0xD300;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT                           = 0xDB00;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1                          = 0xDB01;
constexpr unsigned int mmTD_PERFCOUNTER1_HI                               = 0xD303;
constexpr unsigned int mmTD_PERFCOUNTER1_LO                               = 0xD302;
constexpr unsigned int mmTD_PERFCOUNTER1_SELECT                           = 0xDB02;
constexpr unsigned int mmVGT_DMA_BASE                                     = 0xA1FA;
constexpr unsigned int mmVGT_DMA_BASE_HI                                  = 0xA1F9;
constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH                          = 0x222D;
constexpr unsigned int mmVGT_DMA_INDEX_TYPE                               = 0xA29F;
constexpr unsigned int mmVGT_DMA_MAX_SIZE                                 = 0xA29E;
constexpr unsigned int mmVGT_DMA_NUM_INSTANCES                            = 0xA2A2;
constexpr unsigned int mmVGT_DMA_REQ_FIFO_DEPTH                           = 0x222E;
constexpr unsigned int mmVGT_DMA_SIZE                                     = 0xA29D;
constexpr unsigned int mmVGT_DRAW_INITIATOR                               = 0xA1FC;
constexpr unsigned int mmVGT_DRAW_INIT_FIFO_DEPTH                         = 0x222F;
constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL                            = 0xA2A6;
constexpr unsigned int mmVGT_ENHANCE                                      = 0xA294;
constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE                           = 0xA2AB;
constexpr unsigned int mmVGT_EVENT_ADDRESS_REG                            = 0xA1FE;
constexpr unsigned int mmVGT_EVENT_INITIATOR                              = 0xA2A4;
constexpr unsigned int mmVGT_GS_INSTANCE_CNT                              = 0xA2E4;
constexpr unsigned int mmVGT_GS_MAX_VERT_OUT                              = 0xA2CE;
constexpr unsigned int mmVGT_GS_MAX_WAVE_ID                               = 0x2269;
constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL                           = 0xA286;
constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL                           = 0xA287;
constexpr unsigned int mmVGT_INDEX_TYPE                                   = 0xC243;
constexpr unsigned int mmVGT_INSTANCE_BASE_ID                             = 0xC25A;
constexpr unsigned int mmVGT_LS_HS_CONFIG                                 = 0xA2D6;
constexpr unsigned int mmVGT_MC_LAT_CNTL                                  = 0x2236;
constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX                     = 0xA103;
constexpr unsigned int mmVGT_NUM_INDICES                                  = 0xC24C;
constexpr unsigned int mmVGT_NUM_INSTANCES                                = 0xC24D;
constexpr unsigned int mmVGT_PRIMITIVEID_EN                               = 0xA2A1;
constexpr unsigned int mmVGT_PRIMITIVEID_RESET                            = 0xA2A3;
constexpr unsigned int mmVGT_PRIMITIVE_TYPE                               = 0xC242;
constexpr unsigned int mmVGT_REUSE_OFF                                    = 0xA2AD;
constexpr unsigned int mmVGT_SHADER_STAGES_EN                             = 0xA2D5;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE       = 0xA2CB;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET                   = 0xA2CA;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE            = 0xA2CC;
constexpr unsigned int mmVGT_SYS_CONFIG                                   = 0x2263;
constexpr unsigned int mmVGT_TESS_DISTRIBUTION                            = 0xA2D4;
constexpr unsigned int mmVGT_TF_PARAM                                     = 0xA2DB;
constexpr unsigned int mmWD_CNTL_STATUS                                   = 0x223F;
constexpr unsigned int mmWD_ENHANCE                                       = 0xA2A0;
constexpr unsigned int mmWD_QOS                                           = 0x2242;
constexpr unsigned int mmWD_UTCL1_CNTL                                    = 0x2243;
constexpr unsigned int mmWD_UTCL1_STATUS                                  = 0x2244;

namespace Apu103
{
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG                       = 0xDD20;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG                       = 0xDD21;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI                        = 0xD4FD;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO                        = 0xD4FC;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE                      = 0xDD4E;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT                    = 0xDD4C;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1                   = 0xDD4D;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI                         = 0xD4E1;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO                         = 0xD4E0;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL                  = 0xDD22;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA5;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA4;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0xC440;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0xC442;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0xC443;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14B41;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14B42;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x14B43;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x14B44;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14B45;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14B40;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14B4B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14B4A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14B4D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14B4C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x14B4F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x14B4E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x14B51;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x14B50;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14B53;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14B52;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14B49;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14B48;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54B41;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54B42;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x54B43;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x54B44;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54B45;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54B40;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x54B4B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x54B4A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x54B4D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x54B4C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x54B4F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x54B4E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x54B51;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x54B50;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54B53;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54B52;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54B49;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54B48;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94B41;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94B42;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94B43;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94B44;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94B45;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94B40;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x94B4B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x94B4A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x94B4D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x94B4C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x94B4F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x94B4E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94B51;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94B50;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94B53;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94B52;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94B49;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94B48;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4B41;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4B42;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4B43;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4B44;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4B45;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4B40;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD4B4B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD4B4A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD4B4D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD4B4C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD4B4F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD4B4E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4B51;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4B50;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4B53;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4B52;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4B49;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4B48;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x114343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114B41;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114B42;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x114B43;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x114B44;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114B45;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114B40;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x114B4B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x114B4A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x114B4D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x114B4C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x114B4F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x114B4E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x114B51;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x114B50;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114B53;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114B52;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114B49;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114B48;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154B41;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154B42;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x154B43;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x154B44;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154B45;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154B40;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x154B4B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x154B4A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x154B4D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x154B4C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x154B4F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x154B4E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x154B51;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x154B50;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154B53;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154B52;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154B49;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154B48;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0x194341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0x194342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0x194343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0x194344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0x194345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0x19434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0x19434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0x19434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0x19434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0x194351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0x194350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0x194353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0x194352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0x194349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0x194348;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0x194B41;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0x194B42;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0x194B43;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0x194B44;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0x194B45;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0x194B40;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0x194B4B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0x194B4A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0x194B4D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0x194B4C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0x194B4F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0x194B4E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0x194B51;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0x194B50;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0x194B53;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0x194B52;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0x194B49;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0x194B48;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0x1D4341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0x1D4342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0x1D4343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0x1D4344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0x1D4345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0x1D434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0x1D434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0x1D434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0x1D434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0x1D4351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0x1D4350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0x1D4353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0x1D4352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0x1D4349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0x1D4348;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0x1D4B41;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0x1D4B42;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0x1D4B43;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0x1D4B44;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0x1D4B45;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0x1D4B40;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0x1D4B4B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0x1D4B4A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0x1D4B4D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0x1D4B4C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0x1D4B4F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0x1D4B4E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0x1D4B51;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0x1D4B50;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0x1D4B53;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0x1D4B52;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0x1D4B49;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0x1D4B48;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE                               = 0xC240;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE                               = 0xC241;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0xC24F;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0xC250;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0xC261;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0xC24E;
} // namespace Apu103

namespace Apu11
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG                             = 0x0C0D;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG                             = 0x0C0E;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG                             = 0x0C0F;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG                             = 0x0C10;
    constexpr unsigned int mmATC_PERFCOUNTER_HI                               = 0x0C0C;
    constexpr unsigned int mmATC_PERFCOUNTER_LO                               = 0x0C0B;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL                        = 0x0C11;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG                       = 0xDD44;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG                       = 0xDD45;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI                        = 0xD4F5;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO                        = 0xD4F4;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE                      = 0xDD42;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT                    = 0xDD40;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1                   = 0xDD41;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI                         = 0xD4F9;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO                         = 0xD4F8;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL                  = 0xDD46;
} // namespace Apu11

namespace Gfx10
{
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL                                = 0xF0A8;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0                            = 0xA323;
    constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1                            = 0xA324;
    constexpr unsigned int mmCB_COLOR0_CMASK                                  = 0xA31F;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT                         = 0xA398;
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE                            = 0xA320;
    constexpr unsigned int mmCB_COLOR0_FMASK                                  = 0xA321;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT                         = 0xA3A0;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE                            = 0xA322;
    constexpr unsigned int mmCB_COLOR0_PITCH                                  = 0xA319;
    constexpr unsigned int mmCB_COLOR0_SLICE                                  = 0xA31A;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0                            = 0xA332;
    constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1                            = 0xA333;
    constexpr unsigned int mmCB_COLOR1_CMASK                                  = 0xA32E;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT                         = 0xA399;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE                            = 0xA32F;
    constexpr unsigned int mmCB_COLOR1_FMASK                                  = 0xA330;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT                         = 0xA3A1;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE                            = 0xA331;
    constexpr unsigned int mmCB_COLOR1_PITCH                                  = 0xA328;
    constexpr unsigned int mmCB_COLOR1_SLICE                                  = 0xA329;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0                            = 0xA341;
    constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1                            = 0xA342;
    constexpr unsigned int mmCB_COLOR2_CMASK                                  = 0xA33D;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT                         = 0xA39A;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE                            = 0xA33E;
    constexpr unsigned int mmCB_COLOR2_FMASK                                  = 0xA33F;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT                         = 0xA3A2;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE                            = 0xA340;
    constexpr unsigned int mmCB_COLOR2_PITCH                                  = 0xA337;
    constexpr unsigned int mmCB_COLOR2_SLICE                                  = 0xA338;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0                            = 0xA350;
    constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1                            = 0xA351;
    constexpr unsigned int mmCB_COLOR3_CMASK                                  = 0xA34C;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT                         = 0xA39B;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE                            = 0xA34D;
    constexpr unsigned int mmCB_COLOR3_FMASK                                  = 0xA34E;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT                         = 0xA3A3;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE                            = 0xA34F;
    constexpr unsigned int mmCB_COLOR3_PITCH                                  = 0xA346;
    constexpr unsigned int mmCB_COLOR3_SLICE                                  = 0xA347;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0                            = 0xA35F;
    constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1                            = 0xA360;
    constexpr unsigned int mmCB_COLOR4_CMASK                                  = 0xA35B;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT                         = 0xA39C;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE                            = 0xA35C;
    constexpr unsigned int mmCB_COLOR4_FMASK                                  = 0xA35D;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT                         = 0xA3A4;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE                            = 0xA35E;
    constexpr unsigned int mmCB_COLOR4_PITCH                                  = 0xA355;
    constexpr unsigned int mmCB_COLOR4_SLICE                                  = 0xA356;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0                            = 0xA36E;
    constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1                            = 0xA36F;
    constexpr unsigned int mmCB_COLOR5_CMASK                                  = 0xA36A;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT                         = 0xA39D;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE                            = 0xA36B;
    constexpr unsigned int mmCB_COLOR5_FMASK                                  = 0xA36C;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT                         = 0xA3A5;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE                            = 0xA36D;
    constexpr unsigned int mmCB_COLOR5_PITCH                                  = 0xA364;
    constexpr unsigned int mmCB_COLOR5_SLICE                                  = 0xA365;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0                            = 0xA37D;
    constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1                            = 0xA37E;
    constexpr unsigned int mmCB_COLOR6_CMASK                                  = 0xA379;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT                         = 0xA39E;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE                            = 0xA37A;
    constexpr unsigned int mmCB_COLOR6_FMASK                                  = 0xA37B;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT                         = 0xA3A6;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE                            = 0xA37C;
    constexpr unsigned int mmCB_COLOR6_PITCH                                  = 0xA373;
    constexpr unsigned int mmCB_COLOR6_SLICE                                  = 0xA374;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0                            = 0xA38C;
    constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1                            = 0xA38D;
    constexpr unsigned int mmCB_COLOR7_CMASK                                  = 0xA388;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT                         = 0xA39F;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE                            = 0xA389;
    constexpr unsigned int mmCB_COLOR7_FMASK                                  = 0xA38A;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT                         = 0xA3A7;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE                            = 0xA38B;
    constexpr unsigned int mmCB_COLOR7_PITCH                                  = 0xA382;
    constexpr unsigned int mmCB_COLOR7_SLICE                                  = 0xA383;
    constexpr unsigned int mmCB_DCC_CONTROL                                   = 0xA109;
    constexpr unsigned int mmCB_RMI_BC_GL2_CACHE_CONTROL                      = 0x268A;
    constexpr unsigned int mmCB_STUTTER_CONTROL_CMASK_RDLAT                   = 0x268B;
    constexpr unsigned int mmCB_STUTTER_CONTROL_COLOR_RDLAT                   = 0x268D;
    constexpr unsigned int mmCB_STUTTER_CONTROL_FMASK_RDLAT                   = 0x268C;
    constexpr unsigned int mmCOMPUTE_RELAUNCH                                 = 0x2E2B;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2                                = 0x2E2E;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI                     = 0x2E2D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO                     = 0x2E2C;
    constexpr unsigned int mmCP_COHER_BASE                                    = 0xC07E;
    constexpr unsigned int mmCP_COHER_BASE_HI                                 = 0xC079;
    constexpr unsigned int mmCP_COHER_CNTL                                    = 0xC07C;
    constexpr unsigned int mmCP_COHER_SIZE                                    = 0xC07D;
    constexpr unsigned int mmCP_COHER_SIZE_HI                                 = 0xC08C;
    constexpr unsigned int mmCP_COHER_START_DELAY                             = 0xC07B;
    constexpr unsigned int mmCP_COHER_STATUS                                  = 0xC07F;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_HI                     = 0xC00B;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_LO                     = 0xC00A;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_HI                     = 0xC00F;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_LO                     = 0xC00E;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_HI                     = 0xC013;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_LO                     = 0xC012;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_HI                     = 0xC017;
    constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_LO                     = 0xC016;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_HI                    = 0xC009;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_LO                    = 0xC008;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_HI                    = 0xC00D;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_LO                    = 0xC00C;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_HI                    = 0xC011;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_LO                    = 0xC010;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_HI                    = 0xC015;
    constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_LO                    = 0xC014;
    constexpr unsigned int mmCP_STRMOUT_CNTL                                  = 0xC03F;
    constexpr unsigned int mmDB_DFSM_CONFIG                                   = 0x2630;
    constexpr unsigned int mmDB_DFSM_CONTROL                                  = 0xA00E;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT                          = 0x2636;
    constexpr unsigned int mmDB_DFSM_FLUSH_ENABLE                             = 0x2635;
    constexpr unsigned int mmDB_DFSM_PRIMS_IN_FLIGHT                          = 0x2633;
    constexpr unsigned int mmDB_DFSM_TILES_IN_FLIGHT                          = 0x2632;
    constexpr unsigned int mmDB_DFSM_WATCHDOG                                 = 0x2634;
    constexpr unsigned int mmDB_RMI_BC_GL2_CACHE_CONTROL                      = 0x261E;
    constexpr unsigned int mmDB_ZPASS_COUNT_HI                                = 0xC3FF;
    constexpr unsigned int mmDB_ZPASS_COUNT_LOW                               = 0xC3FE;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG                      = 0xDD2C;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG                      = 0xDD2D;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG                      = 0xDD2E;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG                      = 0xDD2F;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG                      = 0xDD30;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG                      = 0xDD31;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG                      = 0xDD32;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG                      = 0xDD33;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI                        = 0xD4E9;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO                        = 0xD4E8;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                 = 0xDD34;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI                         = 0xD4FA;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO                         = 0xD4F8;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE                       = 0xDD40;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT                     = 0xDD3C;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1                    = 0xDD3E;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI                         = 0xD4FB;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO                         = 0xD4F9;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE                       = 0xDD41;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT                     = 0xDD3D;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1                    = 0xDD3F;
    constexpr unsigned int mmGE_DMA_FIRST_INDEX                               = 0xC251;
    constexpr unsigned int mmGE_PC_CNTL                                       = 0x2245;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI                          = 0xD04A;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO                          = 0xD049;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT                      = 0xD844;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI                          = 0xD04C;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO                          = 0xD04B;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT                      = 0xD845;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM                               = 0xA2AA;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM_PIPED                         = 0xC258;
    constexpr unsigned int mmIA_UTCL1_STATUS_2                                = 0x2237;
    constexpr unsigned int mmPA_PH_ENHANCE                                    = 0x22E1;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE                        = 0x22E0;
    constexpr unsigned int mmPA_SC_BC_WAVE_BREAK                              = 0x22E4;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE                       = 0x22DE;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0                        = 0x22CC;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1                        = 0x22CD;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2                        = 0x22CE;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3                        = 0x22CF;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0                         = 0x22D1;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1                         = 0x22D2;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2                         = 0x22D3;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3                         = 0x22D4;
    constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER                     = 0x22D0;
    constexpr unsigned int mmPA_SC_DSM_CNTL                                   = 0x22FE;
    constexpr unsigned int mmPA_SC_ENHANCE                                    = 0x22FC;
    constexpr unsigned int mmPA_SC_ENHANCE_1                                  = 0x22FD;
    constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0x22DC;
    constexpr unsigned int mmPA_SC_ENHANCE_INTERNAL                           = 0x22DD;
    constexpr unsigned int mmPA_SC_FIFO_SIZE                                  = 0x22F3;
    constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS                         = 0x22C9;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK                   = 0x22C1;
    constexpr unsigned int mmPA_SC_IF_FIFO_SIZE                               = 0x22F5;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK                    = 0x22C0;
    constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG                          = 0x22DF;
    constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL                        = 0x22F8;
    constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE               = 0x22FF;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK                        = 0x22C2;
    constexpr unsigned int mmPA_SIDEBAND_REQUEST_DELAYS                       = 0x22FB;
    constexpr unsigned int mmRLC_PERFMON_CLK_CNTL                             = 0xDCE4;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR                       = 0xDC97;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA                       = 0xDC98;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR                       = 0xDC95;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA                       = 0xDC96;
    constexpr unsigned int mmRLC_SPM_DESER_START_SKEW                         = 0xDC8B;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_ADDR                 = 0xDC90;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_DATA                 = 0xDC91;
    constexpr unsigned int mmRLC_SPM_GLOBALS_MUXSEL_SKEW                      = 0xDC8D;
    constexpr unsigned int mmRLC_SPM_GLOBALS_SAMPLE_SKEW                      = 0xDC8C;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR                       = 0xDC89;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA                       = 0xDC8A;
    constexpr unsigned int mmRLC_SPM_INT_CNTL                                 = 0xEC72;
    constexpr unsigned int mmRLC_SPM_INT_INFO_1                               = 0xEC6F;
    constexpr unsigned int mmRLC_SPM_INT_INFO_2                               = 0xEC70;
    constexpr unsigned int mmRLC_SPM_INT_STATUS                               = 0xEC73;
    constexpr unsigned int mmRLC_SPM_MC_CNTL                                  = 0xEC71;
    constexpr unsigned int mmRLC_SPM_PERFMON_GLB_SEGMENT_SIZE                 = 0xDCA0;
    constexpr unsigned int mmRLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE              = 0xDC9F;
    constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE                     = 0xDC84;
    constexpr unsigned int mmRLC_SPM_RING_WRPTR                               = 0xDC94;
    constexpr unsigned int mmRLC_SPM_SAMPLE_CNT                               = 0xED25;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR                           = 0xDC87;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA                           = 0xDC88;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_SKEW                           = 0xDC8F;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_ADDR                  = 0xDC92;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_DATA                  = 0xDC93;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLE_SKEW                           = 0xDC8E;
    constexpr unsigned int mmRLC_SPM_VIRT_CTRL                                = 0xDCA1;
    constexpr unsigned int mmRLC_SPM_VIRT_STATUS                              = 0xDCA3;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0CEB;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0CEC;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0CED;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0CEE;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0CEA;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0CE9;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0CEF;
    constexpr unsigned int mmSPI_ARB_CNTL_0                                   = 0x31FD;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET                          = 0x31DB;
    constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE                          = 0x31FC;
    constexpr unsigned int mmSPI_FEATURE_CTRL                                 = 0x31FE;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_VSPS                     = 0x24E6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0                        = 0x31DC;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1                        = 0x31DD;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0                     = 0x31E6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1                     = 0x31E7;
    constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS                         = 0x2C47;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_VS                         = 0x2C45;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_VS                             = 0x2C49;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_VS                             = 0x2C48;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS                          = 0x2C4A;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS                       = 0x2C7B;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS                          = 0x2C4B;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_VS                          = 0x2C46;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_VS                          = 0x2C41;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_VS                           = 0x2C70;
    constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL                       = 0x31FF;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_0                       = 0x2C72;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_1                       = 0x2C73;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_2                       = 0x2C74;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_3                       = 0x2C75;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0                        = 0x2C4C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1                        = 0x2C4D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2                        = 0x2C4E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3                        = 0x2C4F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4                        = 0x2C50;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5                        = 0x2C51;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6                        = 0x2C52;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7                        = 0x2C53;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8                        = 0x2C54;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9                        = 0x2C55;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10                       = 0x2C56;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11                       = 0x2C57;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12                       = 0x2C58;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13                       = 0x2C59;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14                       = 0x2C5A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15                       = 0x2C5B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16                       = 0x2C5C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17                       = 0x2C5D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18                       = 0x2C5E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19                       = 0x2C5F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20                       = 0x2C60;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21                       = 0x2C61;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22                       = 0x2C62;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23                       = 0x2C63;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24                       = 0x2C64;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25                       = 0x2C65;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26                       = 0x2C66;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27                       = 0x2C67;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28                       = 0x2C68;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29                       = 0x2C69;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30                       = 0x2C6A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31                       = 0x2C6B;
    constexpr unsigned int mmSPI_START_PHASE                                  = 0x243B;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_1                         = 0x24B6;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_8                         = 0x24BD;
    constexpr unsigned int mmSQG_UTCL0_CNTL1                                  = 0x2317;
    constexpr unsigned int mmSQG_UTCL0_CNTL2                                  = 0x2318;
    constexpr unsigned int mmSQG_UTCL0_STATUS                                 = 0x2319;
    constexpr unsigned int mmSQ_EDC_CNT                                       = 0x23A6;
    constexpr unsigned int mmSQ_EDC_FUE_CNTL                                  = 0x23A7;
    constexpr unsigned int mmSQ_LB_CTR_CTRL                                   = 0x2398;
    constexpr unsigned int mmSQ_LB_CTR_SEL0                                   = 0x239D;
    constexpr unsigned int mmSQ_LB_CTR_SEL1                                   = 0x239E;
    constexpr unsigned int mmSQ_LB_DATA0                                      = 0x2399;
    constexpr unsigned int mmSQ_LB_DATA1                                      = 0x239A;
    constexpr unsigned int mmSQ_LB_DATA2                                      = 0x239B;
    constexpr unsigned int mmSQ_LB_DATA3                                      = 0x239C;
    constexpr unsigned int mmSQ_PERFCOUNTER0_HI                               = 0xD1C1;
    constexpr unsigned int mmSQ_PERFCOUNTER1_HI                               = 0xD1C3;
    constexpr unsigned int mmSQ_PERFCOUNTER2_HI                               = 0xD1C5;
    constexpr unsigned int mmSQ_PERFCOUNTER3_HI                               = 0xD1C7;
    constexpr unsigned int mmSQ_PERFCOUNTER4_HI                               = 0xD1C9;
    constexpr unsigned int mmSQ_PERFCOUNTER5_HI                               = 0xD1CB;
    constexpr unsigned int mmSQ_PERFCOUNTER6_HI                               = 0xD1CD;
    constexpr unsigned int mmSQ_PERFCOUNTER7_HI                               = 0xD1CF;
    constexpr unsigned int mmSQ_PERFCOUNTER8_HI                               = 0xD1D1;
    constexpr unsigned int mmSQ_PERFCOUNTER8_LO                               = 0xD1D0;
    constexpr unsigned int mmSQ_PERFCOUNTER9_HI                               = 0xD1D3;
    constexpr unsigned int mmSQ_PERFCOUNTER9_LO                               = 0xD1D2;
    constexpr unsigned int mmSQ_PERFCOUNTER10_HI                              = 0xD1D5;
    constexpr unsigned int mmSQ_PERFCOUNTER10_LO                              = 0xD1D4;
    constexpr unsigned int mmSQ_PERFCOUNTER11_HI                              = 0xD1D7;
    constexpr unsigned int mmSQ_PERFCOUNTER11_LO                              = 0xD1D6;
    constexpr unsigned int mmSQ_PERFCOUNTER12_HI                              = 0xD1D9;
    constexpr unsigned int mmSQ_PERFCOUNTER12_LO                              = 0xD1D8;
    constexpr unsigned int mmSQ_PERFCOUNTER13_HI                              = 0xD1DB;
    constexpr unsigned int mmSQ_PERFCOUNTER13_LO                              = 0xD1DA;
    constexpr unsigned int mmSQ_PERFCOUNTER14_HI                              = 0xD1DD;
    constexpr unsigned int mmSQ_PERFCOUNTER14_LO                              = 0xD1DC;
    constexpr unsigned int mmSQ_PERFCOUNTER15_HI                              = 0xD1DF;
    constexpr unsigned int mmSQ_PERFCOUNTER15_LO                              = 0xD1DE;
    constexpr unsigned int mmSQ_RUNTIME_CONFIG                                = 0x2308;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE                        = 0x2340;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE                        = 0x2341;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE                        = 0x2342;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE                        = 0x2343;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL                             = 0x2347;
    constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR                     = 0x2349;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR                    = 0x234B;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR                  = 0x234C;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR                   = 0x234D;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR                 = 0x234E;
    constexpr unsigned int mmSQ_THREAD_TRACE_MASK                             = 0x2345;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS                           = 0x2348;
    constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK                       = 0x2346;
    constexpr unsigned int mmSQ_THREAD_TRACE_WPTR                             = 0x2344;
    constexpr unsigned int mmSQ_TIME_HI                                       = 0x237C;
    constexpr unsigned int mmSQ_TIME_LO                                       = 0x237D;
    constexpr unsigned int mmSQ_WREXEC_EXEC_HI                                = 0x23B1;
    constexpr unsigned int mmSQ_WREXEC_EXEC_LO                                = 0x23B1;
    constexpr unsigned int mmTA_POWER_CNTL                                    = 0x2540;
    constexpr unsigned int mmTA_RESERVED_010C                                 = 0x2543;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER                           = 0x32B9;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2                          = 0x32BB;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN                        = 0x32BA;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0x14341;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0x14342;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0x14343;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0x14344;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0x14345;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0x14340;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0x1434B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0x1434A;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0x1434D;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0x1434C;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0x1434F;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0x1434E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0x14351;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0x14350;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0x14353;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0x14352;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0x14349;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0x14348;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0x54341;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0x54342;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0x54343;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0x54344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0x54345;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0x54340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0x5434B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0x5434A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0x5434D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0x5434C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0x5434F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0x5434E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0x54351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0x54350;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0x54353;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0x54352;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0x54349;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0x54348;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI                            = 0xD51D;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO                            = 0xD51C;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT                        = 0xDD63;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI                            = 0xD51F;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO                            = 0xD51E;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT                        = 0xDD64;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX                          = 0xA2DD;
    constexpr unsigned int mmVGT_DMA_CONTROL                                  = 0x2272;
    constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR                          = 0xA2E7;
    constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG                             = 0x2273;
    constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE                           = 0x2271;
    constexpr unsigned int mmVGT_ES_PER_GS                                    = 0xA296;
    constexpr unsigned int mmVGT_FIFO_DEPTHS                                  = 0x2234;
    constexpr unsigned int mmVGT_GROUP_DECR                                   = 0xA28B;
    constexpr unsigned int mmVGT_GROUP_FIRST_DECR                             = 0xA28A;
    constexpr unsigned int mmVGT_GROUP_PRIM_TYPE                              = 0xA289;
    constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL                            = 0xA28C;
    constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL                        = 0xA28E;
    constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL                            = 0xA28D;
    constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL                        = 0xA28F;
    constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE                           = 0xA2AC;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1                           = 0xA298;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2                           = 0xA299;
    constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3                           = 0xA29A;
    constexpr unsigned int mmVGT_GS_MODE                                      = 0xA290;
    constexpr unsigned int mmVGT_GS_ONCHIP_CNTL                               = 0xA291;
    constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE                             = 0xA29B;
    constexpr unsigned int mmVGT_GS_PER_ES                                    = 0xA295;
    constexpr unsigned int mmVGT_GS_PER_VS                                    = 0xA297;
    constexpr unsigned int mmVGT_GS_VERTEX_REUSE                              = 0x2235;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE                             = 0xA2D7;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1                           = 0xA2D8;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2                           = 0xA2D9;
    constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3                           = 0xA2DA;
    constexpr unsigned int mmVGT_HOS_CNTL                                     = 0xA285;
    constexpr unsigned int mmVGT_HOS_REUSE_DEPTH                              = 0xA288;
    constexpr unsigned int mmVGT_IMMED_DATA                                   = 0xA1FD;
    constexpr unsigned int mmVGT_INDX_OFFSET                                  = 0xA102;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0                         = 0xA2A8;
    constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1                         = 0xA2A9;
    constexpr unsigned int mmVGT_LAST_COPY_STATE                              = 0x2230;
    constexpr unsigned int mmVGT_MAX_VTX_INDX                                 = 0xA100;
    constexpr unsigned int mmVGT_MIN_VTX_INDX                                 = 0xA101;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN                       = 0xA2A5;
    constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL                             = 0xA284;
    constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL                             = 0xA317;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_CONFIG                        = 0xA2E6;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0                 = 0xC244;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1                 = 0xC245;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2                 = 0xC246;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3                 = 0xC247;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0                      = 0xA2B7;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1                      = 0xA2BB;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2                      = 0xA2BF;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3                      = 0xA2C3;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0                        = 0xA2B4;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1                        = 0xA2B8;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2                        = 0xA2BC;
    constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3                        = 0xA2C0;
    constexpr unsigned int mmVGT_STRMOUT_CONFIG                               = 0xA2E5;
    constexpr unsigned int mmVGT_STRMOUT_DELAY                                = 0x2275;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0                         = 0xA2B5;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1                         = 0xA2B9;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2                         = 0xA2BD;
    constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3                         = 0xA2C1;
    constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL                      = 0xA316;
    constexpr unsigned int mmVGT_VS_MAX_WAVE_ID                               = 0x2268;
    constexpr unsigned int mmVGT_VTX_CNT_EN                                   = 0xA2AE;
    constexpr unsigned int mmVGT_VTX_VECT_EJECT_REG                           = 0x222C;
    constexpr unsigned int mmWD_BUF_RESOURCE_1                                = 0x2276;
    constexpr unsigned int mmWD_BUF_RESOURCE_2                                = 0x2277;
    constexpr unsigned int mmWD_CNTL_SB_BUF_BASE                              = 0xC254;
    constexpr unsigned int mmWD_CNTL_SB_BUF_BASE_HI                           = 0xC255;
    constexpr unsigned int mmWD_INDEX_BUF_BASE                                = 0xC256;
    constexpr unsigned int mmWD_INDEX_BUF_BASE_HI                             = 0xC257;
    constexpr unsigned int mmWD_POS_BUF_BASE                                  = 0xC252;
    constexpr unsigned int mmWD_POS_BUF_BASE_HI                               = 0xC253;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG                             = 0x0C1E;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG                             = 0x0C1F;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG                             = 0x0C20;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG                             = 0x0C21;
    constexpr unsigned int mmATC_PERFCOUNTER_HI                               = 0x0C24;
    constexpr unsigned int mmATC_PERFCOUNTER_LO                               = 0x0C23;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL                        = 0x0C22;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI                             = 0xD3C9;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO                             = 0xD3C8;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT                         = 0xDBC6;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1                        = 0xDBC7;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI                             = 0xD3CB;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO                             = 0xD3CA;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT                         = 0xDBC8;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI                             = 0xD3CD;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO                             = 0xD3CC;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT                         = 0xDBC9;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI                             = 0xD3CF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO                             = 0xD3CE;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT                         = 0xDBCA;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x7511;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x7515;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x7519;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x751D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x7621;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x7623;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x7625;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x7627;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x7510;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x7514;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x7518;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x751C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x7620;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x7622;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x7624;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x7626;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x7513;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x7517;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x751B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x751F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x75E5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x75E7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x75E9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x75EB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x7512;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x7516;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x751A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x751E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x75E4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x75E6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x75E8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x75EA;
    constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG                            = 0x2706;
    constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG                            = 0x2707;
    constexpr unsigned int mmGCEA_PERFCOUNTER_HI                              = 0x2705;
    constexpr unsigned int mmGCEA_PERFCOUNTER_LO                              = 0x2704;
    constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL                       = 0x2708;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG                       = 0xDD20;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG                       = 0xDD21;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI                        = 0xD4FD;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO                        = 0xD4FC;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE                      = 0xDD4E;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT                    = 0xDD4C;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1                   = 0xDD4D;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI                         = 0xD4E1;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO                         = 0xD4E0;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL                  = 0xDD22;
    constexpr unsigned int mmGE_FAST_CLKS                                     = 0x2248;
    constexpr unsigned int mmGE_PERFCOUNTER0_HI                               = 0xD081;
    constexpr unsigned int mmGE_PERFCOUNTER0_LO                               = 0xD080;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT                           = 0xD880;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT1                          = 0xD881;
    constexpr unsigned int mmGE_PERFCOUNTER1_HI                               = 0xD083;
    constexpr unsigned int mmGE_PERFCOUNTER1_LO                               = 0xD082;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT                           = 0xD882;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT1                          = 0xD883;
    constexpr unsigned int mmGE_PERFCOUNTER2_HI                               = 0xD085;
    constexpr unsigned int mmGE_PERFCOUNTER2_LO                               = 0xD084;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT                           = 0xD884;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT1                          = 0xD885;
    constexpr unsigned int mmGE_PERFCOUNTER3_HI                               = 0xD087;
    constexpr unsigned int mmGE_PERFCOUNTER3_LO                               = 0xD086;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT                           = 0xD886;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT1                          = 0xD887;
    constexpr unsigned int mmGE_PERFCOUNTER4_HI                               = 0xD089;
    constexpr unsigned int mmGE_PERFCOUNTER4_LO                               = 0xD088;
    constexpr unsigned int mmGE_PERFCOUNTER4_SELECT                           = 0xD888;
    constexpr unsigned int mmGE_PERFCOUNTER5_HI                               = 0xD08B;
    constexpr unsigned int mmGE_PERFCOUNTER5_LO                               = 0xD08A;
    constexpr unsigned int mmGE_PERFCOUNTER5_SELECT                           = 0xD88A;
    constexpr unsigned int mmGE_PERFCOUNTER6_HI                               = 0xD08D;
    constexpr unsigned int mmGE_PERFCOUNTER6_LO                               = 0xD08C;
    constexpr unsigned int mmGE_PERFCOUNTER6_SELECT                           = 0xD88C;
    constexpr unsigned int mmGE_PERFCOUNTER7_HI                               = 0xD08F;
    constexpr unsigned int mmGE_PERFCOUNTER7_LO                               = 0xD08E;
    constexpr unsigned int mmGE_PERFCOUNTER7_SELECT                           = 0xD88E;
    constexpr unsigned int mmGE_PERFCOUNTER8_HI                               = 0xD091;
    constexpr unsigned int mmGE_PERFCOUNTER8_LO                               = 0xD090;
    constexpr unsigned int mmGE_PERFCOUNTER8_SELECT                           = 0xD890;
    constexpr unsigned int mmGE_PERFCOUNTER9_HI                               = 0xD093;
    constexpr unsigned int mmGE_PERFCOUNTER9_LO                               = 0xD092;
    constexpr unsigned int mmGE_PERFCOUNTER9_SELECT                           = 0xD892;
    constexpr unsigned int mmGE_PERFCOUNTER10_HI                              = 0xD095;
    constexpr unsigned int mmGE_PERFCOUNTER10_LO                              = 0xD094;
    constexpr unsigned int mmGE_PERFCOUNTER10_SELECT                          = 0xD894;
    constexpr unsigned int mmGE_PERFCOUNTER11_HI                              = 0xD097;
    constexpr unsigned int mmGE_PERFCOUNTER11_LO                              = 0xD096;
    constexpr unsigned int mmGE_PERFCOUNTER11_SELECT                          = 0xD896;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG                             = 0xCC40;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG                             = 0xCC41;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI                              = 0xD641;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO                              = 0xD640;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE                            = 0xDE02;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT                          = 0xDE00;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1                         = 0xDE01;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI                               = 0xCC3F;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO                               = 0xCC3E;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL                        = 0xCC42;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
    constexpr unsigned int mmPerfMonCtl1                                      = 0x14341;
    constexpr unsigned int mmPerfMonCtl2                                      = 0x14342;
    constexpr unsigned int mmPerfMonCtl3                                      = 0x14343;
    constexpr unsigned int mmPerfMonCtl4                                      = 0x14344;
    constexpr unsigned int mmPerfMonCtl5                                      = 0x14345;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x1434B;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x1434A;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x1434D;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x1434C;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434F;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434E;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x14351;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x14350;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14353;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14352;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14349;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14348;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CE2;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI                            = 0x12CB;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO                            = 0x12CA;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_RESULT                        = 0x12B8;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT                        = 0x12C8;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1                       = 0x12C9;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI                            = 0x12CF;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO                            = 0x12CE;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_RESULT                        = 0x12B9;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT                        = 0x12CC;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1                       = 0x12CD;
    constexpr unsigned int mmSDMA0_PERFCOUNTER_TAG_DELAY_RANGE                = 0x12BA;
    constexpr unsigned int mmSDMA0_PERFMON_CNTL                               = 0x12B7;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0x18CB;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0x18CA;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_RESULT                        = 0x18B8;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0x18C8;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0x18C9;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0x18CF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0x18CE;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_RESULT                        = 0x18B9;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0x18CC;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0x18CD;
    constexpr unsigned int mmSDMA1_PERFCOUNTER_TAG_DELAY_RANGE                = 0x18BA;
    constexpr unsigned int mmSDMA1_PERFMON_CNTL                               = 0x18B7;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0x2440;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0x244F;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_REMAP                          = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0x244E;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_REMAP                          = 0xC442;
    constexpr unsigned int mmSPI_CONFIG_CNTL_REMAP                            = 0xC440;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_4                        = 0x24E0;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_5                        = 0x24E1;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_6                        = 0x24E2;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_7                        = 0x24E3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0x31DE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0x31DF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0x31E0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0x31E1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6                        = 0x31E2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7                        = 0x31E3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0x31E4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0x31E5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10                       = 0x31F0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11                       = 0x31F1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12                       = 0x31F4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13                       = 0x31F5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14                       = 0x31F6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15                       = 0x31F7;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0x31E8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0x31E9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0x31EA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0x31EB;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6                     = 0x31EC;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7                     = 0x31ED;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0x31EE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0x31EF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10                    = 0x31F2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11                    = 0x31F3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12                    = 0x31F8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13                    = 0x31F9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14                    = 0x31FA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15                    = 0x31FB;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_ES                          = 0x2CCA;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_LS                          = 0x2D4A;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES                          = 0x2CCB;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_GS                       = 0x2CBC;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_VS                       = 0x2C7C;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS                          = 0x2D4B;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_ES                       = 0x2CFD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_HS                       = 0x2D3D;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_VS                       = 0x2C7D;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_ES                          = 0x2CC7;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_LS                          = 0x2D47;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS               = 0x2CB1;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS               = 0x2D31;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_PS                 = 0x2C31;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_VS                 = 0x2C71;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_0                        = 0x2CCC;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_1                        = 0x2CCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_2                        = 0x2CCE;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_3                        = 0x2CCF;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_4                        = 0x2CD0;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_5                        = 0x2CD1;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_6                        = 0x2CD2;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_7                        = 0x2CD3;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_8                        = 0x2CD4;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_9                        = 0x2CD5;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_10                       = 0x2CD6;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_11                       = 0x2CD7;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_12                       = 0x2CD8;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_13                       = 0x2CD9;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_14                       = 0x2CDA;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_15                       = 0x2CDB;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_0                        = 0x2D4C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_1                        = 0x2D4D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_2                        = 0x2D4E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_3                        = 0x2D4F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_4                        = 0x2D50;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_5                        = 0x2D51;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_6                        = 0x2D52;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_7                        = 0x2D53;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_8                        = 0x2D54;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_9                        = 0x2D55;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_10                       = 0x2D56;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_11                       = 0x2D57;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_12                       = 0x2D58;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_13                       = 0x2D59;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_14                       = 0x2D5A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_15                       = 0x2D5B;
    constexpr unsigned int mmSPI_SYS_COMPUTE                                  = 0x2721;
    constexpr unsigned int mmSPI_SYS_WIF_CNTL                                 = 0x2722;
    constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL                         = 0x243F;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0x244D;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_REMAP                        = 0xC443;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4                         = 0x31CD;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5                         = 0x31CE;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6                         = 0x31CF;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7                         = 0x31D0;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_6                          = 0x24B1;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_7                          = 0x24B2;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_8                          = 0x24B3;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_9                          = 0x24B4;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_3                         = 0x24B8;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_5                         = 0x24BA;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_10                        = 0x24BF;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_12                        = 0x24C1;
    constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK                           = 0x2314;
    constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL                            = 0x2315;
    constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0x231D;
    constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0x231C;
    constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0x231F;
    constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0x231E;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14B41;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14B42;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x14B43;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x14B44;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14B45;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14B40;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14B4B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14B4A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14B4D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14B4C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x14B4F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x14B4E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x14B51;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x14B50;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14B53;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14B52;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14B49;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14B48;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54B41;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54B42;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x54B43;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x54B44;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54B45;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54B40;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x54B4B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x54B4A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x54B4D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x54B4C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x54B4F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x54B4E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x54B51;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x54B50;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54B53;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54B52;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54B49;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54B48;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94B41;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94B42;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94B43;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94B44;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94B45;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94B40;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x94B4B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x94B4A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x94B4D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x94B4C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x94B4F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x94B4E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94B51;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94B50;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94B53;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94B52;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94B49;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94B48;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4B41;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4B42;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4B43;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4B44;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4B45;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4B40;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD4B4B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD4B4A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD4B4D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD4B4C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD4B4F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD4B4E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4B51;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4B50;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4B53;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4B52;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4B49;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4B48;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x114343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114B41;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114B42;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x114B43;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x114B44;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114B45;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114B40;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x114B4B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x114B4A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x114B4D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x114B4C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x114B4F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x114B4E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x114B51;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x114B50;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114B53;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114B52;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114B49;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114B48;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154B41;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154B42;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x154B43;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x154B44;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154B45;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154B40;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x154B4B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x154B4A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x154B4D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x154B4C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x154B4F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x154B4E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x154B51;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x154B50;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154B53;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154B52;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154B49;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154B48;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0x194341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0x194342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0x194343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0x194344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0x194345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0x19434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0x19434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0x19434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0x19434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0x194351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0x194350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0x194353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0x194352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0x194349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0x194348;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0x194B41;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0x194B42;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0x194B43;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0x194B44;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0x194B45;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0x194B40;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0x194B4B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0x194B4A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0x194B4D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0x194B4C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0x194B4F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0x194B4E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0x194B51;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0x194B50;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0x194B53;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0x194B52;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0x194B49;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0x194B48;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0x1D4341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0x1D4342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0x1D4343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0x1D4344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0x1D4345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0x1D434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0x1D434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0x1D434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0x1D434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0x1D4351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0x1D4350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0x1D4353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0x1D4352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0x1D4349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0x1D4348;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0x1D4B41;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0x1D4B42;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0x1D4B43;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0x1D4B44;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0x1D4B45;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0x1D4B40;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0x1D4B4B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0x1D4B4A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0x1D4B4D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0x1D4B4C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0x1D4B4F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0x1D4B4E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0x1D4B51;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0x1D4B50;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0x1D4B53;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0x1D4B52;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0x1D4B49;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0x1D4B48;
    constexpr unsigned int mmVGT_CACHE_INVALIDATION                           = 0x2231;
    constexpr unsigned int mmVGT_CNTL_STATUS                                  = 0x223C;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE                               = 0x2232;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_UMD                           = 0xC240;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE                               = 0x2233;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_UMD                           = 0xC241;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0x226C;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_UMD                         = 0xC24F;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0x226E;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0x2278;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_UMD                        = 0xC261;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_UMD                           = 0xC250;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0x2262;
    constexpr unsigned int mmVGT_TF_RING_SIZE_UMD                             = 0xC24E;
} // namespace Gfx101

namespace Gfx103Plus
{
    constexpr unsigned int mmDB_SPI_VRS_CENTER_LOCATION                       = 0xA018;
    constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG                            = 0xDA03;
    constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG                            = 0xDA04;
    constexpr unsigned int mmGCEA_PERFCOUNTER_HI                              = 0xD263;
    constexpr unsigned int mmGCEA_PERFCOUNTER_LO                              = 0xD262;
    constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL                       = 0xDA05;
    constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT1                         = 0xDA85;
    constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT1                         = 0xDA86;
    constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT1                         = 0xDA87;
    constexpr unsigned int mmGE1_PERFCOUNTER0_HI                              = 0xD0A5;
    constexpr unsigned int mmGE1_PERFCOUNTER0_LO                              = 0xD0A4;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT                          = 0xD8A4;
    constexpr unsigned int mmGE1_PERFCOUNTER0_SELECT1                         = 0xD8A5;
    constexpr unsigned int mmGE1_PERFCOUNTER1_HI                              = 0xD0A7;
    constexpr unsigned int mmGE1_PERFCOUNTER1_LO                              = 0xD0A6;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT                          = 0xD8A6;
    constexpr unsigned int mmGE1_PERFCOUNTER1_SELECT1                         = 0xD8A7;
    constexpr unsigned int mmGE1_PERFCOUNTER2_HI                              = 0xD0A9;
    constexpr unsigned int mmGE1_PERFCOUNTER2_LO                              = 0xD0A8;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT                          = 0xD8A8;
    constexpr unsigned int mmGE1_PERFCOUNTER2_SELECT1                         = 0xD8A9;
    constexpr unsigned int mmGE1_PERFCOUNTER3_HI                              = 0xD0AB;
    constexpr unsigned int mmGE1_PERFCOUNTER3_LO                              = 0xD0AA;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT                          = 0xD8AA;
    constexpr unsigned int mmGE1_PERFCOUNTER3_SELECT1                         = 0xD8AB;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_HI                         = 0xD0AD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_LO                         = 0xD0AC;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT                     = 0xD8AC;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER0_SELECT1                    = 0xD8AD;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_HI                         = 0xD0AF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_LO                         = 0xD0AE;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT                     = 0xD8AE;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER1_SELECT1                    = 0xD8AF;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_HI                         = 0xD0B1;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_LO                         = 0xD0B0;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT                     = 0xD8B0;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER2_SELECT1                    = 0xD8B1;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_HI                         = 0xD0B3;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_LO                         = 0xD0B2;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT                     = 0xD8B2;
    constexpr unsigned int mmGE2_DIST_PERFCOUNTER3_SELECT1                    = 0xD8B3;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_HI                           = 0xD0B5;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_LO                           = 0xD0B4;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT                       = 0xD8B4;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER0_SELECT1                      = 0xD8B5;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_HI                           = 0xD0B7;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_LO                           = 0xD0B6;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT                       = 0xD8B6;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER1_SELECT1                      = 0xD8B7;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_HI                           = 0xD0B9;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_LO                           = 0xD0B8;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT                       = 0xD8B8;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER2_SELECT1                      = 0xD8B9;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_HI                           = 0xD0BB;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_LO                           = 0xD0BA;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT                       = 0xD8BA;
    constexpr unsigned int mmGE2_SE_PERFCOUNTER3_SELECT1                      = 0xD8BB;
    constexpr unsigned int mmGE_VRS_RATE                                      = 0xC263;
    constexpr unsigned int mmPA_CL_VRS_CNTL                                   = 0xA212;
    constexpr unsigned int mmSDMA0_PERFCNT_MISC_CNTL                          = 0xDE23;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE20;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE21;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_HI                     = 0xD661;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_LO                     = 0xD660;
    constexpr unsigned int mmSDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE22;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI                            = 0xD663;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO                            = 0xD662;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT                        = 0xDE24;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1                       = 0xDE25;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI                            = 0xD665;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO                            = 0xD664;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT                        = 0xDE26;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1                       = 0xDE27;
    constexpr unsigned int mmSPI_BARYC_SSAA_CNTL                              = 0xA1B7;
    constexpr unsigned int mmSPI_CONFIG_PS_CU_EN                              = 0x2452;
    constexpr unsigned int mmSPI_CSG_PIPE_CONTROL                             = 0x243D;
    constexpr unsigned int mmSPI_CS_CRAWLER_CONFIG                            = 0x24F7;
    constexpr unsigned int mmSPI_EXP_THROTTLE_CTRL                            = 0x2723;
    constexpr unsigned int mmSPI_GFX_CRAWLER_CONFIG                           = 0x24F6;
    constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_GFX                          = 0x24E8;
    constexpr unsigned int mmSPI_WF_ACTIVE_COUNT_HPG                          = 0x24E9;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_21                        = 0x24CB;
    constexpr unsigned int mmSQ_CLK_CTRL                                      = 0xF091;
    constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK                           = 0x231E;
    constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL                            = 0x231F;
    constexpr unsigned int mmSX_PS_DOWNCONVERT_CONTROL                        = 0xA1D4;
} // namespace Gfx103Plus

namespace Gfx10Vrs
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG                             = 0x0C10;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG                             = 0x0C11;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG                             = 0x0C12;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG                             = 0x0C13;
    constexpr unsigned int mmATC_PERFCOUNTER_HI                               = 0x0C16;
    constexpr unsigned int mmATC_PERFCOUNTER_LO                               = 0x0C15;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL                        = 0x0C14;
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL1                               = 0xF0A9;
    constexpr unsigned int mmDB_VRS_OVERRIDE_CNTL                             = 0xA019;
    constexpr unsigned int mmPA_SC_ENHANCE_3                                  = 0x22E5;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET                = 0xDCAB;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS         = 0xDCAD;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_ADDR                   = 0xDCA9;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_DATA                   = 0xDCAA;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET                = 0xDCA7;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE             = 0xDCAC;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE          = 0xDCA6;
    constexpr unsigned int mmRLC_SPM_PERFMON_SWA_SEGMENT_SIZE                 = 0xDCA2;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR_OFFSET                    = 0xDCA8;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CE7;
    constexpr unsigned int mmSPI_IND_DATA                                     = 0xF053;
    constexpr unsigned int mmSPI_IND_INDEX                                    = 0xF052;
    constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL                         = 0x244B;
    constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0x2313;
    constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0x2312;
    constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0x2315;
    constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0x2314;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS2                          = 0x234F;
    constexpr unsigned int mmVGT_CACHE_INVALIDATION                           = 0x2220;
} // namespace Gfx10Vrs

namespace Gfx11
{
    constexpr unsigned int mmCB_DCC_CONFIG2                                   = 0x268B;
    constexpr unsigned int mmCB_FDCC_CONTROL                                  = 0xA109;
    constexpr unsigned int mmCB_FGCG_SRAM_OVERRIDE                            = 0x268A;
    constexpr unsigned int mmCB_KEY_OVERRIDE_0                                = 0x267A;
    constexpr unsigned int mmCB_KEY_OVERRIDE_1                                = 0x267B;
    constexpr unsigned int mmCB_KEY_OVERRIDE_2                                = 0x267C;
    constexpr unsigned int mmCB_KEY_OVERRIDE_3                                = 0x267D;
    constexpr unsigned int mmCB_KEY_OVERRIDE_4                                = 0x267E;
    constexpr unsigned int mmCB_KEY_OVERRIDE_5                                = 0x267F;
    constexpr unsigned int mmCB_KEY_OVERRIDE_6                                = 0x2680;
    constexpr unsigned int mmCB_KEY_OVERRIDE_7                                = 0x2681;
    constexpr unsigned int mmCOMPUTE_DISPATCH_INTERLEAVE                      = 0x2E2F;
    constexpr unsigned int mmCOMPUTE_RELAUNCH                                 = 0x2E30;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2                                = 0x2E33;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE4                   = 0x2E2B;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE5                   = 0x2E2C;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE6                   = 0x2E2D;
    constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE7                   = 0x2E2E;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI                     = 0x2E32;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO                     = 0x2E31;
    constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_HI                          = 0xC033;
    constexpr unsigned int mmCP_VGT_ASINVOC_COUNT_LO                          = 0xC032;
    constexpr unsigned int mmDB_FIFO_DEPTH4                                   = 0x2639;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG                      = 0xDD30;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG                      = 0xDD31;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG                      = 0xDD32;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG                      = 0xDD33;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG                      = 0xDD34;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG                      = 0xDD35;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG                      = 0xDD36;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG                      = 0xDD37;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI                        = 0xD4E5;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO                        = 0xD4E4;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                 = 0xDD38;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI                         = 0xD4E2;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO                         = 0xD4E0;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE                       = 0xDD24;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT                     = 0xDD20;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1                    = 0xDD22;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI                         = 0xD4E3;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO                         = 0xD4E1;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE                       = 0xDD25;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT                     = 0xDD21;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1                    = 0xDD23;
    constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM                         = 0xC264;
    constexpr unsigned int mmGE_GS_FAST_LAUNCH_WG_DIM_1                       = 0xC265;
    constexpr unsigned int mmGE_PA_IF_SAFE_REG                                = 0x2279;
    constexpr unsigned int mmGE_RATE_CNTL_1                                   = 0x2254;
    constexpr unsigned int mmGE_RATE_CNTL_2                                   = 0x2255;
    constexpr unsigned int mmGE_SPI_IF_SAFE_REG                               = 0x2278;
    constexpr unsigned int mmPA_PH_ENHANCE                                    = 0xA95F;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE                        = 0xA95E;
    constexpr unsigned int mmPA_RATE_CNTL                                     = 0xA188;
    constexpr unsigned int mmPA_SC_ATM_CNTL                                   = 0xA94D;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_2                              = 0xA315;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE                       = 0xA946;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0                        = 0xA950;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1                        = 0xA951;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2                        = 0xA952;
    constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3                        = 0xA953;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0                         = 0xA955;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1                         = 0xA956;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2                         = 0xA957;
    constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3                         = 0xA958;
    constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER                     = 0xA954;
    constexpr unsigned int mmPA_SC_DSM_CNTL                                   = 0xA948;
    constexpr unsigned int mmPA_SC_ENHANCE                                    = 0xA941;
    constexpr unsigned int mmPA_SC_ENHANCE_1                                  = 0xA942;
    constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0xA943;
    constexpr unsigned int mmPA_SC_ENHANCE_3                                  = 0xA944;
    constexpr unsigned int mmPA_SC_FIFO_SIZE                                  = 0xA94A;
    constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS                         = 0xA94F;
    constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK                   = 0xA95C;
    constexpr unsigned int mmPA_SC_IF_FIFO_SIZE                               = 0xA94B;
    constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK                    = 0xA95B;
    constexpr unsigned int mmPA_SC_PACKER_WAVE_ID_CNTL                        = 0xA94C;
    constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG                          = 0xA947;
    constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL                        = 0xA94E;
    constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE               = 0xA949;
    constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK                        = 0xA95D;
    constexpr unsigned int mmPA_SC_VRS_OVERRIDE_CNTL                          = 0xA0F4;
    constexpr unsigned int mmPA_SC_VRS_RATE_BASE                              = 0xA0FC;
    constexpr unsigned int mmPA_SC_VRS_RATE_BASE_EXT                          = 0xA0FD;
    constexpr unsigned int mmPA_SC_VRS_RATE_CACHE_CNTL                        = 0xA0F9;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE                     = 0xA0F5;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_BASE_EXT                 = 0xA0F6;
    constexpr unsigned int mmPA_SC_VRS_RATE_FEEDBACK_SIZE_XY                  = 0xA0F7;
    constexpr unsigned int mmPA_SC_VRS_RATE_SIZE_XY                           = 0xA0FE;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL                           = 0xA940;
    constexpr unsigned int mmPA_SC_VRS_SURFACE_CNTL_1                         = 0xA960;
    constexpr unsigned int mmPC_PERFCOUNTER0_HI                               = 0xD18C;
    constexpr unsigned int mmPC_PERFCOUNTER0_LO                               = 0xD18D;
    constexpr unsigned int mmPC_PERFCOUNTER0_SELECT                           = 0xD98C;
    constexpr unsigned int mmPC_PERFCOUNTER0_SELECT1                          = 0xD990;
    constexpr unsigned int mmPC_PERFCOUNTER1_HI                               = 0xD18E;
    constexpr unsigned int mmPC_PERFCOUNTER1_LO                               = 0xD18F;
    constexpr unsigned int mmPC_PERFCOUNTER1_SELECT                           = 0xD98D;
    constexpr unsigned int mmPC_PERFCOUNTER1_SELECT1                          = 0xD991;
    constexpr unsigned int mmPC_PERFCOUNTER2_HI                               = 0xD190;
    constexpr unsigned int mmPC_PERFCOUNTER2_LO                               = 0xD191;
    constexpr unsigned int mmPC_PERFCOUNTER2_SELECT                           = 0xD98E;
    constexpr unsigned int mmPC_PERFCOUNTER2_SELECT1                          = 0xD992;
    constexpr unsigned int mmPC_PERFCOUNTER3_HI                               = 0xD192;
    constexpr unsigned int mmPC_PERFCOUNTER3_LO                               = 0xD193;
    constexpr unsigned int mmPC_PERFCOUNTER3_SELECT                           = 0xD98F;
    constexpr unsigned int mmPC_PERFCOUNTER3_SELECT1                          = 0xD993;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR                       = 0xDC96;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET                = 0xDC98;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA                       = 0xDC97;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS         = 0xDC9F;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR                       = 0xDC92;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA                       = 0xDC93;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_ADDR                   = 0xDC94;
    constexpr unsigned int mmRLC_SPM_ACCUM_SWA_DATARAM_DATA                   = 0xDC95;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA5;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA4;
    constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_ADDR                    = 0xED64;
    constexpr unsigned int mmRLC_SPM_GLOBAL_DELAY_IND_DATA                    = 0xED65;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR                       = 0xDC88;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA                       = 0xDC89;
    constexpr unsigned int mmRLC_SPM_INT_CNTL                                 = 0xA983;
    constexpr unsigned int mmRLC_SPM_INT_INFO_1                               = 0xA985;
    constexpr unsigned int mmRLC_SPM_INT_INFO_2                               = 0xA986;
    constexpr unsigned int mmRLC_SPM_INT_STATUS                               = 0xA984;
    constexpr unsigned int mmRLC_SPM_MC_CNTL                                  = 0xA982;
    constexpr unsigned int mmRLC_SPM_MODE                                     = 0xDCAD;
    constexpr unsigned int mmRLC_SPM_PAUSE                                    = 0xDCA2;
    constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE                     = 0xDC87;
    constexpr unsigned int mmRLC_SPM_RING_WRPTR                               = 0xDC84;
    constexpr unsigned int mmRLC_SPM_RSPM_CMD                                 = 0xDCB8;
    constexpr unsigned int mmRLC_SPM_RSPM_CMD_ACK                             = 0xDCB9;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA_HI                         = 0xDCAF;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_DATA_LO                         = 0xDCAE;
    constexpr unsigned int mmRLC_SPM_RSPM_REQ_OP                              = 0xDCB0;
    constexpr unsigned int mmRLC_SPM_RSPM_RET_DATA                            = 0xDCB1;
    constexpr unsigned int mmRLC_SPM_RSPM_RET_OP                              = 0xDCB2;
    constexpr unsigned int mmRLC_SPM_SAMPLE_CNT                               = 0xA981;
    constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_ADDR                        = 0xED66;
    constexpr unsigned int mmRLC_SPM_SE_DELAY_IND_DATA                        = 0xED67;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR                           = 0xDC8A;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA                           = 0xDC8B;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA_HI                      = 0xDCB4;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_DATA_LO                      = 0xDCB3;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_REQ_OP                           = 0xDCB5;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_DATA                         = 0xDCB6;
    constexpr unsigned int mmRLC_SPM_SE_RSPM_RET_OP                           = 0xDCB7;
    constexpr unsigned int mmRLC_SPM_SPARE                                    = 0xDCBF;
    constexpr unsigned int mmRLC_SPM_STATUS                                   = 0xDCA3;
    constexpr unsigned int mmSPI_ARB_CNTL_0                                   = 0xB949;
    constexpr unsigned int mmSPI_ATTRIBUTE_RING_BASE                          = 0xC446;
    constexpr unsigned int mmSPI_ATTRIBUTE_RING_SIZE                          = 0xC447;
    constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET                          = 0x31D3;
    constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE                          = 0x31D4;
    constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE_STATUS                   = 0xB94E;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0xC440;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0xC442;
    constexpr unsigned int mmSPI_FEATURE_CTRL                                 = 0xB94A;
    constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_HI                          = 0xA1BC;
    constexpr unsigned int mmSPI_GFX_SCRATCH_BASE_LO                          = 0xA1BB;
    constexpr unsigned int mmSPI_GS_THROTTLE_CNTL1                            = 0xC444;
    constexpr unsigned int mmSPI_GS_THROTTLE_CNTL2                            = 0xC445;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_PS                       = 0x24E6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0                        = 0xBC00;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1                        = 0xBC01;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0xBC02;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0xBC03;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0xBC04;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0xBC05;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6                        = 0xBC06;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7                        = 0xBC07;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0xBC08;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0xBC09;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10                       = 0xBC0A;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11                       = 0xBC0B;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12                       = 0xBC0C;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13                       = 0xBC0D;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14                       = 0xBC0E;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15                       = 0xBC0F;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0                     = 0xBC10;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1                     = 0xBC11;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0xBC12;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0xBC13;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0xBC14;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0xBC15;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6                     = 0xBC16;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7                     = 0xBC17;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0xBC18;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0xBC19;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10                    = 0xBC1A;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11                    = 0xBC1B;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12                    = 0xBC1C;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13                    = 0xBC1D;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14                    = 0xBC1E;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15                    = 0xBC1F;
    constexpr unsigned int mmSPI_SHADER_GS_MESHLET_DIM                        = 0x2CAC;
    constexpr unsigned int mmSPI_SHADER_GS_MESHLET_EXP_ALLOC                  = 0x2CAD;
    constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL                       = 0xB94B;
    constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL                         = 0x31D1;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0xC443;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4                         = 0x31CD;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5                         = 0x31CE;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6                         = 0x31CF;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7                         = 0x31D0;
    constexpr unsigned int mmSQG_GL1H_STATUS                                  = 0x2319;
    constexpr unsigned int mmSQG_PERFCOUNTER0_HI                              = 0xD1E5;
    constexpr unsigned int mmSQG_PERFCOUNTER0_LO                              = 0xD1E4;
    constexpr unsigned int mmSQG_PERFCOUNTER0_SELECT                          = 0xD9D0;
    constexpr unsigned int mmSQG_PERFCOUNTER1_HI                              = 0xD1E7;
    constexpr unsigned int mmSQG_PERFCOUNTER1_LO                              = 0xD1E6;
    constexpr unsigned int mmSQG_PERFCOUNTER1_SELECT                          = 0xD9D1;
    constexpr unsigned int mmSQG_PERFCOUNTER2_HI                              = 0xD1E9;
    constexpr unsigned int mmSQG_PERFCOUNTER2_LO                              = 0xD1E8;
    constexpr unsigned int mmSQG_PERFCOUNTER2_SELECT                          = 0xD9D2;
    constexpr unsigned int mmSQG_PERFCOUNTER3_HI                              = 0xD1EB;
    constexpr unsigned int mmSQG_PERFCOUNTER3_LO                              = 0xD1EA;
    constexpr unsigned int mmSQG_PERFCOUNTER3_SELECT                          = 0xD9D3;
    constexpr unsigned int mmSQG_PERFCOUNTER4_HI                              = 0xD1ED;
    constexpr unsigned int mmSQG_PERFCOUNTER4_LO                              = 0xD1EC;
    constexpr unsigned int mmSQG_PERFCOUNTER4_SELECT                          = 0xD9D4;
    constexpr unsigned int mmSQG_PERFCOUNTER5_HI                              = 0xD1EF;
    constexpr unsigned int mmSQG_PERFCOUNTER5_LO                              = 0xD1EE;
    constexpr unsigned int mmSQG_PERFCOUNTER5_SELECT                          = 0xD9D5;
    constexpr unsigned int mmSQG_PERFCOUNTER6_HI                              = 0xD1F1;
    constexpr unsigned int mmSQG_PERFCOUNTER6_LO                              = 0xD1F0;
    constexpr unsigned int mmSQG_PERFCOUNTER6_SELECT                          = 0xD9D6;
    constexpr unsigned int mmSQG_PERFCOUNTER7_HI                              = 0xD1F3;
    constexpr unsigned int mmSQG_PERFCOUNTER7_LO                              = 0xD1F2;
    constexpr unsigned int mmSQG_PERFCOUNTER7_SELECT                          = 0xD9D7;
    constexpr unsigned int mmSQG_PERFCOUNTER_CTRL                             = 0xD9D8;
    constexpr unsigned int mmSQG_PERFCOUNTER_CTRL2                            = 0xD9DA;
    constexpr unsigned int mmSQG_PERF_SAMPLE_FINISH                           = 0xD9DB;
    constexpr unsigned int mmSQ_PERF_SNAPSHOT_CTRL                            = 0x231B;
    constexpr unsigned int mmSQ_RUNTIME_CONFIG                                = 0xA9E0;
    constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0xA9E7;
    constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0xA9E6;
    constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0xA9E9;
    constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0xA9E8;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE                        = 0xD9E8;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE                        = 0xD9E9;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE                        = 0xD9EA;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE                        = 0xD9EB;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL                             = 0xD9EC;
    constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR                     = 0xD9FA;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR                    = 0xD9F6;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR                  = 0xD9F7;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR                   = 0xD9F8;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR                 = 0xD9F9;
    constexpr unsigned int mmSQ_THREAD_TRACE_MASK                             = 0xD9ED;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS                           = 0xD9F4;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS2                          = 0xD9F5;
    constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK                       = 0xD9EE;
    constexpr unsigned int mmSQ_THREAD_TRACE_WPTR                             = 0xD9EF;
    constexpr unsigned int mmTA_CNTL2                                         = 0x2545;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER                           = 0xD348;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2                          = 0xD349;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN                        = 0xD34A;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI                            = 0xD5A1;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO                            = 0xD5A0;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT                        = 0xDDA0;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI                            = 0xD5A3;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO                            = 0xD5A2;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT                        = 0xDDA1;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_HI                            = 0xD5A5;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_LO                            = 0xD5A4;
    constexpr unsigned int mmUTCL1_PERFCOUNTER2_SELECT                        = 0xDDA2;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_HI                            = 0xD5A7;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_LO                            = 0xD5A6;
    constexpr unsigned int mmUTCL1_PERFCOUNTER3_SELECT                        = 0xDDA3;
    constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE                             = 0xC266;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0xC24F;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0xC250;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0xC261;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0xC24E;
} // namespace Gfx11

namespace Gfx110
{
    constexpr unsigned int mmCB_CGTT_SCLK_CTRL                                = 0xF0A8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x12400C81;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x12400C83;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x12400C85;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x12400C87;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x12400C89;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x12400C8B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x12400C8D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x12400C8F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x12400C80;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x12400C82;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x12400C84;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x12400C86;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x12400C88;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x12400C8A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x12400C8C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x12400C8E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x12400CC1;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x12400CC3;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x12400CC5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x12400CC7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x12400CC9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x12400CCB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x12400CCD;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x12400CCF;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x12400CC0;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x12400CC2;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x12400CC4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x12400CC6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x12400CC8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x12400CCA;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x12400CCC;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x12400CCE;
    constexpr unsigned int mmIA_UTCL1_STATUS_2                                = 0x2237;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
} // namespace Gfx110

namespace Gfx115
{
    constexpr unsigned int mmDB_CGTT_CLK_CTRL_1                               = 0xF0A5;
    constexpr unsigned int mmPA_SC_BINNER_DYNAMIC_BATCH_LIMIT                 = 0xA963;
    constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_CNTL                 = 0xA316;
    constexpr unsigned int mmPA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER              = 0xA964;
    constexpr unsigned int mmPA_SC_ENHANCE_4                                  = 0xA945;
    constexpr unsigned int mmPA_SC_LIGHT_SHAFT_EVENT_CONFIG_0                 = 0xA961;
    constexpr unsigned int mmPA_SC_LIGHT_SHAFT_EVENT_CONFIG_1                 = 0xA962;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0CE9;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0CEA;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0CEB;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0CEC;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0CEF;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0CF0;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0CED;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CEE;
} // namespace Gfx115

namespace Nv21
{
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA4;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA5;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL                          = 0xDE2F;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE2C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE2D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI                     = 0xD66D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO                     = 0xD66C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE2E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0xD66F;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0xD66E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0xDE30;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0xDE31;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0xD671;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0xD670;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0xDE32;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0xDE33;
    constexpr unsigned int mmSDMA2_PERFCNT_MISC_CNTL                          = 0xDE3B;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE38;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE39;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_HI                     = 0xD679;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_LO                     = 0xD678;
    constexpr unsigned int mmSDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE3A;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_HI                            = 0xD67B;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_LO                            = 0xD67A;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_SELECT                        = 0xDE3C;
    constexpr unsigned int mmSDMA2_PERFCOUNTER0_SELECT1                       = 0xDE3D;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_HI                            = 0xD67D;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_LO                            = 0xD67C;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_SELECT                        = 0xDE3E;
    constexpr unsigned int mmSDMA2_PERFCOUNTER1_SELECT1                       = 0xDE3F;
    constexpr unsigned int mmSDMA3_PERFCNT_MISC_CNTL                          = 0xDE47;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE44;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE45;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_HI                     = 0xD685;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_LO                     = 0xD684;
    constexpr unsigned int mmSDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE46;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_HI                            = 0xD687;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_LO                            = 0xD686;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_SELECT                        = 0xDE48;
    constexpr unsigned int mmSDMA3_PERFCOUNTER0_SELECT1                       = 0xDE49;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_HI                            = 0xD689;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_LO                            = 0xD688;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_SELECT                        = 0xDE4A;
    constexpr unsigned int mmSDMA3_PERFCOUNTER1_SELECT1                       = 0xDE4B;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0x31E4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0x31E5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0x31EE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0x31EF;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94741;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94742;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94743;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94745;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x9474B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x9474A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x9474D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x9474C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x9474F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x9474E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94750;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94753;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94752;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94749;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94748;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4741;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4742;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4743;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4745;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4750;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4753;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4752;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4749;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4748;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x114343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114741;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114742;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x114743;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x114744;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114745;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114740;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x11474B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x11474A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x11474D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x11474C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x11474F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x11474E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x114751;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x114750;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114753;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114752;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114749;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114748;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154741;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154742;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x154743;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x154744;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154745;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154740;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x15474B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x15474A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x15474D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x15474C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x15474F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x15474E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x154751;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x154750;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154753;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154752;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154749;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154748;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0x194341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0x194342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0x194343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0x194344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0x194345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0x19434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0x19434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0x19434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0x19434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0x194351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0x194350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0x194353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0x194352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0x194349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0x194348;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0x194741;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0x194742;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0x194743;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0x194744;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0x194745;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0x194740;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0x19474B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0x19474A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0x19474D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0x19474C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0x19474F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0x19474E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0x194751;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0x194750;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0x194753;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0x194752;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0x194749;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0x194748;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0x1D4341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0x1D4342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0x1D4343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0x1D4344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0x1D4345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0x1D434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0x1D434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0x1D434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0x1D434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0x1D4351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0x1D4350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0x1D4353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0x1D4352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0x1D4349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0x1D4348;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0x1D4741;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0x1D4742;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0x1D4743;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0x1D4744;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0x1D4745;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0x1D4740;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0x1D474B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0x1D474A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0x1D474D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0x1D474C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0x1D474F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0x1D474E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0x1D4751;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0x1D4750;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0x1D4753;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0x1D4752;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0x1D4749;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0x1D4748;
} // namespace Nv21

namespace Nv22
{
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA4;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA5;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL                          = 0xDE2F;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE2C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE2D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI                     = 0xD66D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO                     = 0xD66C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE2E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0xD66F;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0xD66E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0xDE30;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0xDE31;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0xD671;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0xD670;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0xDE32;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0xDE33;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0x31E4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0x31E5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0x31EE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0x31EF;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94741;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94742;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94743;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94745;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x9474B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x9474A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x9474D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x9474C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x9474F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x9474E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94750;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94753;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94752;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94749;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94748;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4741;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4742;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4743;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4745;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4750;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4753;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4752;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4749;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4748;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x114343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114741;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114742;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x114743;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x114744;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114745;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114740;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x11474B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x11474A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x11474D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x11474C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x11474F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x11474E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x114751;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x114750;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114753;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114752;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114749;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114748;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154741;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154742;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x154743;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x154744;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154745;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154740;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x15474B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x15474A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x15474D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x15474C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x15474F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x15474E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x154751;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x154750;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154753;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154752;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154749;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154748;
} // namespace Nv22

namespace Nv23
{
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA5;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA4;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL                          = 0xDE2F;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE2C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE2D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI                     = 0xD66D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO                     = 0xD66C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE2E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0xD66F;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0xD66E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0xDE30;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0xDE31;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0xD671;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0xD670;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0xDE32;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0xDE33;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94741;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94742;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94743;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94745;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x9474B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x9474A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x9474D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x9474C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x9474F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x9474E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94750;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94753;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94752;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94749;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94748;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4741;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4742;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4743;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4745;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4750;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4753;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4752;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4749;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4748;
} // namespace Nv23

namespace Nv24
{
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_HIGHCOUNT                       = 0xDCA5;
    constexpr unsigned int mmRLC_SPM_GFXCLOCK_LOWCOUNT                        = 0xDCA4;
} // namespace Nv24

namespace Nv2x
{
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI                             = 0xD3C9;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO                             = 0xD3C8;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT                         = 0xDBC6;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1                        = 0xDBC7;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI                             = 0xD3CB;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO                             = 0xD3CA;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT                         = 0xDBC8;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI                             = 0xD3CD;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO                             = 0xD3CC;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT                         = 0xDBC9;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI                             = 0xD3CF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO                             = 0xD3CE;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT                         = 0xDBCA;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x7511;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x7515;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x7519;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x751D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x7621;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x7623;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x7625;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x7627;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x7510;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x7514;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x7518;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x751C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x7620;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x7622;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x7624;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x7626;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x7513;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x7517;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x751B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x751F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x75E5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x75E7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x75E9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x75EB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x7512;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x7516;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x751A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x751E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x75E4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x75E6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x75E8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x75EA;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG                             = 0xDE03;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG                             = 0xDE04;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI                              = 0xD641;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO                              = 0xD640;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE                            = 0xDE02;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT                          = 0xDE00;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1                         = 0xDE01;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI                               = 0xD643;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO                               = 0xD642;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL                        = 0xDE05;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
    constexpr unsigned int mmPerfMonCtl1                                      = 0x14341;
    constexpr unsigned int mmPerfMonCtl2                                      = 0x14342;
    constexpr unsigned int mmPerfMonCtl3                                      = 0x14343;
    constexpr unsigned int mmPerfMonCtl4                                      = 0x14344;
    constexpr unsigned int mmPerfMonCtl5                                      = 0x14345;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x1434B;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x1434A;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x1434D;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x1434C;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434F;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434E;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x14351;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x14350;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14353;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14352;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14349;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14348;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0x244C;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0x244F;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_REMAP                          = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0x244E;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_REMAP                          = 0xC442;
    constexpr unsigned int mmSPI_CONFIG_CNTL_REMAP                            = 0xC440;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0x31DE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0x31DF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0x31E0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0x31E1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6                        = 0x31E2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7                        = 0x31E3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0x31E8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0x31E9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0x31EA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0x31EB;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6                     = 0x31EC;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7                     = 0x31ED;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0x244D;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_REMAP                        = 0xC443;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14741;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14742;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x14743;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x14744;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14745;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14740;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x1474B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x1474A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x1474D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x1474C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x1474F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x1474E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x14751;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x14750;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14753;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14752;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14749;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14748;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54741;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54742;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x54743;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x54744;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54745;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54740;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x5474B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x5474A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x5474D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x5474C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x5474F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x5474E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x54751;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x54750;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54753;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54752;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54749;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54748;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE                               = 0x2221;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_UMD                           = 0xC240;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE                               = 0x2222;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_UMD                           = 0xC241;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0x2224;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_UMD                         = 0xC24F;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0x2225;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0x2226;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_UMD                        = 0xC261;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_UMD                           = 0xC250;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0x2223;
    constexpr unsigned int mmVGT_TF_RING_SIZE_UMD                             = 0xC24E;
} // namespace Nv2x

namespace Nv31
{
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xC022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xC022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xC022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xC022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xC022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xC022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xC022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xC022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xC022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xC022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xC022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xC022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xC022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xC022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xC022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xC022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xC022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xC022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xC022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xC022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xC022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xC022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xC022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xC022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xC022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xC022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xC022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xC022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xC022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xC022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xC022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xC022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xC822C81;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xC822C83;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xC822C85;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xC822C87;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xC822C89;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xC822C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xC822C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xC822C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xC822C80;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xC822C82;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xC822C84;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xC822C86;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xC822C88;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xC822C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xC822C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xC822C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xC822CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xC822CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xC822CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xC822CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xC822CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xC822CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xC822CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xC822CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xC822CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xC822CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xC822CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xC822CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xC822CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xC822CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xC822CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xC822CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xD022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xD022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xD022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xD022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xD022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xD022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xD022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xD022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xD022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xD022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xD022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xD022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xD022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xD022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xD022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xD022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xD022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xD022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xD022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xD022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xD022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xD022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xD022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xD022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xD022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xD022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xD022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xD022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xD022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xD022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xD022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xD022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xD822C81;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xD822C83;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xD822C85;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xD822C87;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xD822C89;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xD822C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xD822C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xD822C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xD822C80;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xD822C82;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xD822C84;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xD822C86;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xD822C88;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xD822C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xD822C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xD822C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xD822CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xD822CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xD822CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xD822CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xD822CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xD822CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xD822CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xD822CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xD822CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xD822CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xD822CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xD822CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xD822CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xD822CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xD822CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xD822CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xE022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xE022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xE022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xE022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xE022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xE022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xE022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xE022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xE022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xE022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xE022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xE022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xE022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xE022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xE022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xE022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xE022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xE022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xE022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xE022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xE022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xE022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xE022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xE022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xE022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xE022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xE022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xE022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xE022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xE022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xE022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON4_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xE022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xE822C81;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xE822C83;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xE822C85;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xE822C87;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xE822C89;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xE822C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xE822C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xE822C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xE822C80;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xE822C82;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xE822C84;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xE822C86;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xE822C88;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xE822C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xE822C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xE822C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xE822CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xE822CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xE822CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xE822CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xE822CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xE822CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xE822CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xE822CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xE822CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xE822CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xE822CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xE822CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xE822CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xE822CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xE822CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON5_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xE822CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi0                     = 0xC022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi1                     = 0xC022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi2                     = 0xC022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi3                     = 0xC022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi4                     = 0xC022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi5                     = 0xC022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi6                     = 0xC022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi7                     = 0xC022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo0                     = 0xC022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo1                     = 0xC022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo2                     = 0xC022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo3                     = 0xC022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo4                     = 0xC022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo5                     = 0xC022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo6                     = 0xC022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo7                     = 0xC022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi0                     = 0xC022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi1                     = 0xC022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi2                     = 0xC022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi3                     = 0xC022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi4                     = 0xC022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi5                     = 0xC022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi6                     = 0xC022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi7                     = 0xC022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo0                     = 0xC022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo1                     = 0xC022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo2                     = 0xC022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo3                     = 0xC022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo4                     = 0xC022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo5                     = 0xC022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo6                     = 0xC022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo7                     = 0xC022CCE;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI                          = 0xD04C;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO                          = 0xD04B;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT                      = 0xD845;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_HI                          = 0xD04E;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_LO                          = 0xD04D;
    constexpr unsigned int mmGRBM_SE4_PERFCOUNTER_SELECT                      = 0xD846;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_HI                          = 0xD050;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_LO                          = 0xD04F;
    constexpr unsigned int mmGRBM_SE5_PERFCOUNTER_SELECT                      = 0xD847;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_HI                          = 0xD052;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_LO                          = 0xD051;
    constexpr unsigned int mmGRBM_SE6_PERFCOUNTER_SELECT                      = 0xD848;
    constexpr unsigned int mmPerfMonCtl1                                      = 0xC400344;
    constexpr unsigned int mmPerfMonCtl2                                      = 0xC400347;
    constexpr unsigned int mmPerfMonCtl3                                      = 0xC40034A;
    constexpr unsigned int mmPerfMonCtl4                                      = 0xC40034D;
    constexpr unsigned int mmPerfMonCtl5                                      = 0xC400350;
    constexpr unsigned int mmPerfMonCtl6                                      = 0xC400353;
    constexpr unsigned int mmPerfMonCtl7                                      = 0xC400356;
    constexpr unsigned int mmPerfMonCtl8                                      = 0xC400359;
    constexpr unsigned int mmPerfMonCtl9                                      = 0xC40035C;
    constexpr unsigned int mmPerfMonCtl10                                     = 0xC40035F;
    constexpr unsigned int mmPerfMonCtl11                                     = 0xC400362;
    constexpr unsigned int mmPerfMonCtl12                                     = 0xC400365;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0xC400340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0xC400346;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0xC400345;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0xC400349;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0xC400348;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0xC40034C;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0xC40034B;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0xC40034F;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0xC40034E;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0xC400352;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0xC400351;
    constexpr unsigned int mmPerfMonCtr6_Hi                                   = 0xC400355;
    constexpr unsigned int mmPerfMonCtr6_Lo                                   = 0xC400354;
    constexpr unsigned int mmPerfMonCtr7_Hi                                   = 0xC400358;
    constexpr unsigned int mmPerfMonCtr7_Lo                                   = 0xC400357;
    constexpr unsigned int mmPerfMonCtr8_Hi                                   = 0xC40035B;
    constexpr unsigned int mmPerfMonCtr8_Lo                                   = 0xC40035A;
    constexpr unsigned int mmPerfMonCtr9_Hi                                   = 0xC40035E;
    constexpr unsigned int mmPerfMonCtr9_Lo                                   = 0xC40035D;
    constexpr unsigned int mmPerfMonCtr10_Hi                                  = 0xC400361;
    constexpr unsigned int mmPerfMonCtr10_Lo                                  = 0xC400360;
    constexpr unsigned int mmPerfMonCtr11_Hi                                  = 0xC400364;
    constexpr unsigned int mmPerfMonCtr11_Lo                                  = 0xC400363;
    constexpr unsigned int mmPerfMonCtr12_Hi                                  = 0xC400367;
    constexpr unsigned int mmPerfMonCtr12_Lo                                  = 0xC400366;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0xC400342;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0xC400341;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0xC400344;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0xC400347;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0xC40034A;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0xC40034D;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0xC400350;
    constexpr unsigned int mmUMCCH0_PerfMonCtl6                               = 0xC400353;
    constexpr unsigned int mmUMCCH0_PerfMonCtl7                               = 0xC400356;
    constexpr unsigned int mmUMCCH0_PerfMonCtl8                               = 0xC400359;
    constexpr unsigned int mmUMCCH0_PerfMonCtl9                               = 0xC40035C;
    constexpr unsigned int mmUMCCH0_PerfMonCtl10                              = 0xC40035F;
    constexpr unsigned int mmUMCCH0_PerfMonCtl11                              = 0xC400362;
    constexpr unsigned int mmUMCCH0_PerfMonCtl12                              = 0xC400365;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0xC400340;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0xC400346;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0xC400345;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0xC400349;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0xC400348;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0xC40034C;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0xC40034B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0xC40034F;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0xC40034E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0xC400352;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0xC400351;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi                            = 0xC400355;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo                            = 0xC400354;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi                            = 0xC400358;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo                            = 0xC400357;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi                            = 0xC40035B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo                            = 0xC40035A;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi                            = 0xC40035E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo                            = 0xC40035D;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi                           = 0xC400361;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo                           = 0xC400360;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi                           = 0xC400364;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo                           = 0xC400363;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi                           = 0xC400367;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo                           = 0xC400366;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0xC400342;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0xC400341;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0xC400744;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0xC400747;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0xC40074A;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0xC40074D;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0xC400750;
    constexpr unsigned int mmUMCCH1_PerfMonCtl6                               = 0xC400753;
    constexpr unsigned int mmUMCCH1_PerfMonCtl7                               = 0xC400756;
    constexpr unsigned int mmUMCCH1_PerfMonCtl8                               = 0xC400759;
    constexpr unsigned int mmUMCCH1_PerfMonCtl9                               = 0xC40075C;
    constexpr unsigned int mmUMCCH1_PerfMonCtl10                              = 0xC40075F;
    constexpr unsigned int mmUMCCH1_PerfMonCtl11                              = 0xC400762;
    constexpr unsigned int mmUMCCH1_PerfMonCtl12                              = 0xC400765;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0xC400740;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0xC400746;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0xC400745;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0xC400749;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0xC400748;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0xC40074C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0xC40074B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0xC40074F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0xC40074E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0xC400752;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0xC400751;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi                            = 0xC400755;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo                            = 0xC400754;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi                            = 0xC400758;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo                            = 0xC400757;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi                            = 0xC40075B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo                            = 0xC40075A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi                            = 0xC40075E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo                            = 0xC40075D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi                           = 0xC400761;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo                           = 0xC400760;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi                           = 0xC400764;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo                           = 0xC400763;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi                           = 0xC400767;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo                           = 0xC400766;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0xC400742;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0xC400741;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0xC404344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0xC404347;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0xC40434A;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0xC40434D;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0xC404350;
    constexpr unsigned int mmUMCCH2_PerfMonCtl6                               = 0xC404353;
    constexpr unsigned int mmUMCCH2_PerfMonCtl7                               = 0xC404356;
    constexpr unsigned int mmUMCCH2_PerfMonCtl8                               = 0xC404359;
    constexpr unsigned int mmUMCCH2_PerfMonCtl9                               = 0xC40435C;
    constexpr unsigned int mmUMCCH2_PerfMonCtl10                              = 0xC40435F;
    constexpr unsigned int mmUMCCH2_PerfMonCtl11                              = 0xC404362;
    constexpr unsigned int mmUMCCH2_PerfMonCtl12                              = 0xC404365;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0xC404340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0xC404346;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0xC404345;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0xC404349;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0xC404348;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0xC40434C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0xC40434B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0xC40434F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0xC40434E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0xC404352;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0xC404351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi                            = 0xC404355;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo                            = 0xC404354;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi                            = 0xC404358;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo                            = 0xC404357;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi                            = 0xC40435B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo                            = 0xC40435A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi                            = 0xC40435E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo                            = 0xC40435D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi                           = 0xC404361;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo                           = 0xC404360;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi                           = 0xC404364;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo                           = 0xC404363;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi                           = 0xC404367;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo                           = 0xC404366;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0xC404342;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0xC404341;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0xC404744;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0xC404747;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0xC40474A;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0xC40474D;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0xC404750;
    constexpr unsigned int mmUMCCH3_PerfMonCtl6                               = 0xC404753;
    constexpr unsigned int mmUMCCH3_PerfMonCtl7                               = 0xC404756;
    constexpr unsigned int mmUMCCH3_PerfMonCtl8                               = 0xC404759;
    constexpr unsigned int mmUMCCH3_PerfMonCtl9                               = 0xC40475C;
    constexpr unsigned int mmUMCCH3_PerfMonCtl10                              = 0xC40475F;
    constexpr unsigned int mmUMCCH3_PerfMonCtl11                              = 0xC404762;
    constexpr unsigned int mmUMCCH3_PerfMonCtl12                              = 0xC404765;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0xC404740;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0xC404746;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0xC404745;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0xC404749;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0xC404748;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0xC40474C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0xC40474B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0xC40474F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0xC40474E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0xC404752;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0xC404751;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi                            = 0xC404755;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo                            = 0xC404754;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi                            = 0xC404758;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo                            = 0xC404757;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi                            = 0xC40475B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo                            = 0xC40475A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi                            = 0xC40475E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo                            = 0xC40475D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi                           = 0xC404761;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo                           = 0xC404760;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi                           = 0xC404764;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo                           = 0xC404763;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi                           = 0xC404767;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo                           = 0xC404766;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0xC404742;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0xC404741;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0xCC00344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0xCC00347;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0xCC0034A;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0xCC0034D;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0xCC00350;
    constexpr unsigned int mmUMCCH4_PerfMonCtl6                               = 0xCC00353;
    constexpr unsigned int mmUMCCH4_PerfMonCtl7                               = 0xCC00356;
    constexpr unsigned int mmUMCCH4_PerfMonCtl8                               = 0xCC00359;
    constexpr unsigned int mmUMCCH4_PerfMonCtl9                               = 0xCC0035C;
    constexpr unsigned int mmUMCCH4_PerfMonCtl10                              = 0xCC0035F;
    constexpr unsigned int mmUMCCH4_PerfMonCtl11                              = 0xCC00362;
    constexpr unsigned int mmUMCCH4_PerfMonCtl12                              = 0xCC00365;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0xCC00340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0xCC00346;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0xCC00345;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0xCC00349;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0xCC00348;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0xCC0034C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0xCC0034B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0xCC0034F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0xCC0034E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0xCC00352;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0xCC00351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi                            = 0xCC00355;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo                            = 0xCC00354;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi                            = 0xCC00358;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo                            = 0xCC00357;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi                            = 0xCC0035B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo                            = 0xCC0035A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi                            = 0xCC0035E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo                            = 0xCC0035D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi                           = 0xCC00361;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo                           = 0xCC00360;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi                           = 0xCC00364;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo                           = 0xCC00363;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi                           = 0xCC00367;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo                           = 0xCC00366;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0xCC00342;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0xCC00341;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0xCC00744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0xCC00747;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0xCC0074A;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0xCC0074D;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0xCC00750;
    constexpr unsigned int mmUMCCH5_PerfMonCtl6                               = 0xCC00753;
    constexpr unsigned int mmUMCCH5_PerfMonCtl7                               = 0xCC00756;
    constexpr unsigned int mmUMCCH5_PerfMonCtl8                               = 0xCC00759;
    constexpr unsigned int mmUMCCH5_PerfMonCtl9                               = 0xCC0075C;
    constexpr unsigned int mmUMCCH5_PerfMonCtl10                              = 0xCC0075F;
    constexpr unsigned int mmUMCCH5_PerfMonCtl11                              = 0xCC00762;
    constexpr unsigned int mmUMCCH5_PerfMonCtl12                              = 0xCC00765;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0xCC00740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0xCC00746;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0xCC00745;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0xCC00749;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0xCC00748;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0xCC0074C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0xCC0074B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0xCC0074F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0xCC0074E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0xCC00752;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0xCC00751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi                            = 0xCC00755;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo                            = 0xCC00754;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi                            = 0xCC00758;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo                            = 0xCC00757;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi                            = 0xCC0075B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo                            = 0xCC0075A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi                            = 0xCC0075E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo                            = 0xCC0075D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi                           = 0xCC00761;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo                           = 0xCC00760;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi                           = 0xCC00764;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo                           = 0xCC00763;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi                           = 0xCC00767;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo                           = 0xCC00766;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0xCC00742;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0xCC00741;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xCC04344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xCC04347;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xCC0434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xCC0434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xCC04350;
    constexpr unsigned int mmUMCCH6_PerfMonCtl6                               = 0xCC04353;
    constexpr unsigned int mmUMCCH6_PerfMonCtl7                               = 0xCC04356;
    constexpr unsigned int mmUMCCH6_PerfMonCtl8                               = 0xCC04359;
    constexpr unsigned int mmUMCCH6_PerfMonCtl9                               = 0xCC0435C;
    constexpr unsigned int mmUMCCH6_PerfMonCtl10                              = 0xCC0435F;
    constexpr unsigned int mmUMCCH6_PerfMonCtl11                              = 0xCC04362;
    constexpr unsigned int mmUMCCH6_PerfMonCtl12                              = 0xCC04365;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xCC04340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xCC04346;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xCC04345;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xCC04349;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xCC04348;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xCC0434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xCC0434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xCC0434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xCC0434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xCC04352;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xCC04351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi                            = 0xCC04355;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo                            = 0xCC04354;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi                            = 0xCC04358;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo                            = 0xCC04357;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi                            = 0xCC0435B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo                            = 0xCC0435A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi                            = 0xCC0435E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo                            = 0xCC0435D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi                           = 0xCC04361;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo                           = 0xCC04360;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi                           = 0xCC04364;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo                           = 0xCC04363;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi                           = 0xCC04367;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo                           = 0xCC04366;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xCC04342;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xCC04341;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xCC04744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xCC04747;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xCC0474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xCC0474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xCC04750;
    constexpr unsigned int mmUMCCH7_PerfMonCtl6                               = 0xCC04753;
    constexpr unsigned int mmUMCCH7_PerfMonCtl7                               = 0xCC04756;
    constexpr unsigned int mmUMCCH7_PerfMonCtl8                               = 0xCC04759;
    constexpr unsigned int mmUMCCH7_PerfMonCtl9                               = 0xCC0475C;
    constexpr unsigned int mmUMCCH7_PerfMonCtl10                              = 0xCC0475F;
    constexpr unsigned int mmUMCCH7_PerfMonCtl11                              = 0xCC04762;
    constexpr unsigned int mmUMCCH7_PerfMonCtl12                              = 0xCC04765;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xCC04740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xCC04746;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xCC04745;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xCC04749;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xCC04748;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xCC0474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xCC0474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xCC0474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xCC0474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xCC04752;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xCC04751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi                            = 0xCC04755;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo                            = 0xCC04754;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi                            = 0xCC04758;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo                            = 0xCC04757;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi                            = 0xCC0475B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo                            = 0xCC0475A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi                            = 0xCC0475E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo                            = 0xCC0475D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi                           = 0xCC04761;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo                           = 0xCC04760;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi                           = 0xCC04764;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo                           = 0xCC04763;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi                           = 0xCC04767;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo                           = 0xCC04766;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xCC04742;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xCC04741;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0xD400344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0xD400347;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0xD40034A;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0xD40034D;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0xD400350;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6                               = 0xD400353;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7                               = 0xD400356;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8                               = 0xD400359;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9                               = 0xD40035C;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10                              = 0xD40035F;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11                              = 0xD400362;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12                              = 0xD400365;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0xD400340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0xD400346;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0xD400345;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0xD400349;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0xD400348;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0xD40034C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0xD40034B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0xD40034F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0xD40034E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0xD400352;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0xD400351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi                            = 0xD400355;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo                            = 0xD400354;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi                            = 0xD400358;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo                            = 0xD400357;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi                            = 0xD40035B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo                            = 0xD40035A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi                            = 0xD40035E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo                            = 0xD40035D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi                           = 0xD400361;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo                           = 0xD400360;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi                           = 0xD400364;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo                           = 0xD400363;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi                           = 0xD400367;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo                           = 0xD400366;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0xD400342;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0xD400341;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0xD400744;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0xD400747;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0xD40074A;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0xD40074D;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0xD400750;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6                               = 0xD400753;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7                               = 0xD400756;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8                               = 0xD400759;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9                               = 0xD40075C;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10                              = 0xD40075F;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11                              = 0xD400762;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12                              = 0xD400765;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0xD400740;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0xD400746;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0xD400745;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0xD400749;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0xD400748;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0xD40074C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0xD40074B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0xD40074F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0xD40074E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0xD400752;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0xD400751;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi                            = 0xD400755;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo                            = 0xD400754;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi                            = 0xD400758;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo                            = 0xD400757;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi                            = 0xD40075B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo                            = 0xD40075A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi                            = 0xD40075E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo                            = 0xD40075D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi                           = 0xD400761;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo                           = 0xD400760;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi                           = 0xD400764;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo                           = 0xD400763;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi                           = 0xD400767;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo                           = 0xD400766;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0xD400742;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0xD400741;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0xD404344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0xD404347;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0xD40434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0xD40434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0xD404350;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6                              = 0xD404353;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7                              = 0xD404356;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8                              = 0xD404359;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9                              = 0xD40435C;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10                             = 0xD40435F;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11                             = 0xD404362;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12                             = 0xD404365;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0xD404340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0xD404346;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0xD404345;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0xD404349;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0xD404348;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0xD40434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0xD40434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0xD40434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0xD40434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0xD404352;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0xD404351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi                           = 0xD404355;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo                           = 0xD404354;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi                           = 0xD404358;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo                           = 0xD404357;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi                           = 0xD40435B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo                           = 0xD40435A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi                           = 0xD40435E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo                           = 0xD40435D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi                          = 0xD404361;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo                          = 0xD404360;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi                          = 0xD404364;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo                          = 0xD404363;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi                          = 0xD404367;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo                          = 0xD404366;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0xD404342;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0xD404341;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0xD404744;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0xD404747;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0xD40474A;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0xD40474D;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0xD404750;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6                              = 0xD404753;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7                              = 0xD404756;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8                              = 0xD404759;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9                              = 0xD40475C;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10                             = 0xD40475F;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11                             = 0xD404762;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12                             = 0xD404765;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0xD404740;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0xD404746;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0xD404745;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0xD404749;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0xD404748;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0xD40474C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0xD40474B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0xD40474F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0xD40474E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0xD404752;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0xD404751;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi                           = 0xD404755;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo                           = 0xD404754;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi                           = 0xD404758;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo                           = 0xD404757;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi                           = 0xD40475B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo                           = 0xD40475A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi                           = 0xD40475E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo                           = 0xD40475D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi                          = 0xD404761;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo                          = 0xD404760;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi                          = 0xD404764;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo                          = 0xD404763;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi                          = 0xD404767;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo                          = 0xD404766;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0xD404742;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0xD404741;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0xDC00344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0xDC00347;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0xDC0034A;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0xDC0034D;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0xDC00350;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6                              = 0xDC00353;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7                              = 0xDC00356;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8                              = 0xDC00359;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9                              = 0xDC0035C;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10                             = 0xDC0035F;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11                             = 0xDC00362;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12                             = 0xDC00365;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0xDC00340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0xDC00346;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0xDC00345;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0xDC00349;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0xDC00348;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0xDC0034C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0xDC0034B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0xDC0034F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0xDC0034E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0xDC00352;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0xDC00351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi                           = 0xDC00355;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo                           = 0xDC00354;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi                           = 0xDC00358;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo                           = 0xDC00357;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi                           = 0xDC0035B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo                           = 0xDC0035A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi                           = 0xDC0035E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo                           = 0xDC0035D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi                          = 0xDC00361;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo                          = 0xDC00360;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi                          = 0xDC00364;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo                          = 0xDC00363;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi                          = 0xDC00367;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo                          = 0xDC00366;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0xDC00342;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0xDC00341;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0xDC00744;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0xDC00747;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0xDC0074A;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0xDC0074D;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0xDC00750;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6                              = 0xDC00753;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7                              = 0xDC00756;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8                              = 0xDC00759;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9                              = 0xDC0075C;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10                             = 0xDC0075F;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11                             = 0xDC00762;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12                             = 0xDC00765;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0xDC00740;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0xDC00746;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0xDC00745;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0xDC00749;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0xDC00748;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0xDC0074C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0xDC0074B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0xDC0074F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0xDC0074E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0xDC00752;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0xDC00751;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi                           = 0xDC00755;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo                           = 0xDC00754;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi                           = 0xDC00758;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo                           = 0xDC00757;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi                           = 0xDC0075B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo                           = 0xDC0075A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi                           = 0xDC0075E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo                           = 0xDC0075D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi                          = 0xDC00761;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo                          = 0xDC00760;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi                          = 0xDC00764;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo                          = 0xDC00763;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi                          = 0xDC00767;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo                          = 0xDC00766;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0xDC00742;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0xDC00741;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0xDC04344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0xDC04347;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0xDC0434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0xDC0434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0xDC04350;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6                              = 0xDC04353;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7                              = 0xDC04356;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8                              = 0xDC04359;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9                              = 0xDC0435C;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10                             = 0xDC0435F;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11                             = 0xDC04362;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12                             = 0xDC04365;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0xDC04340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0xDC04346;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0xDC04345;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0xDC04349;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0xDC04348;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0xDC0434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0xDC0434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0xDC0434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0xDC0434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0xDC04352;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0xDC04351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi                           = 0xDC04355;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo                           = 0xDC04354;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi                           = 0xDC04358;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo                           = 0xDC04357;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi                           = 0xDC0435B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo                           = 0xDC0435A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi                           = 0xDC0435E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo                           = 0xDC0435D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi                          = 0xDC04361;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo                          = 0xDC04360;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi                          = 0xDC04364;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo                          = 0xDC04363;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi                          = 0xDC04367;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo                          = 0xDC04366;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0xDC04342;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0xDC04341;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0xDC04744;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0xDC04747;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0xDC0474A;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0xDC0474D;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0xDC04750;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6                              = 0xDC04753;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7                              = 0xDC04756;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8                              = 0xDC04759;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9                              = 0xDC0475C;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10                             = 0xDC0475F;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11                             = 0xDC04762;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12                             = 0xDC04765;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0xDC04740;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0xDC04746;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0xDC04745;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0xDC04749;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0xDC04748;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0xDC0474C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0xDC0474B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0xDC0474F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0xDC0474E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0xDC04752;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0xDC04751;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi                           = 0xDC04755;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo                           = 0xDC04754;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi                           = 0xDC04758;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo                           = 0xDC04757;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi                           = 0xDC0475B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo                           = 0xDC0475A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi                           = 0xDC0475E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo                           = 0xDC0475D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi                          = 0xDC04761;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo                          = 0xDC04760;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi                          = 0xDC04764;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo                          = 0xDC04763;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi                          = 0xDC04767;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo                          = 0xDC04766;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0xDC04742;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0xDC04741;
    constexpr unsigned int mmUMCCH16_PerfMonCtl1                              = 0xE400344;
    constexpr unsigned int mmUMCCH16_PerfMonCtl2                              = 0xE400347;
    constexpr unsigned int mmUMCCH16_PerfMonCtl3                              = 0xE40034A;
    constexpr unsigned int mmUMCCH16_PerfMonCtl4                              = 0xE40034D;
    constexpr unsigned int mmUMCCH16_PerfMonCtl5                              = 0xE400350;
    constexpr unsigned int mmUMCCH16_PerfMonCtl6                              = 0xE400353;
    constexpr unsigned int mmUMCCH16_PerfMonCtl7                              = 0xE400356;
    constexpr unsigned int mmUMCCH16_PerfMonCtl8                              = 0xE400359;
    constexpr unsigned int mmUMCCH16_PerfMonCtl9                              = 0xE40035C;
    constexpr unsigned int mmUMCCH16_PerfMonCtl10                             = 0xE40035F;
    constexpr unsigned int mmUMCCH16_PerfMonCtl11                             = 0xE400362;
    constexpr unsigned int mmUMCCH16_PerfMonCtl12                             = 0xE400365;
    constexpr unsigned int mmUMCCH16_PerfMonCtlClk                            = 0xE400340;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Hi                           = 0xE400346;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Lo                           = 0xE400345;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Hi                           = 0xE400349;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Lo                           = 0xE400348;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Hi                           = 0xE40034C;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Lo                           = 0xE40034B;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Hi                           = 0xE40034F;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Lo                           = 0xE40034E;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Hi                           = 0xE400352;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Lo                           = 0xE400351;
    constexpr unsigned int mmUMCCH16_PerfMonCtr6_Hi                           = 0xE400355;
    constexpr unsigned int mmUMCCH16_PerfMonCtr6_Lo                           = 0xE400354;
    constexpr unsigned int mmUMCCH16_PerfMonCtr7_Hi                           = 0xE400358;
    constexpr unsigned int mmUMCCH16_PerfMonCtr7_Lo                           = 0xE400357;
    constexpr unsigned int mmUMCCH16_PerfMonCtr8_Hi                           = 0xE40035B;
    constexpr unsigned int mmUMCCH16_PerfMonCtr8_Lo                           = 0xE40035A;
    constexpr unsigned int mmUMCCH16_PerfMonCtr9_Hi                           = 0xE40035E;
    constexpr unsigned int mmUMCCH16_PerfMonCtr9_Lo                           = 0xE40035D;
    constexpr unsigned int mmUMCCH16_PerfMonCtr10_Hi                          = 0xE400361;
    constexpr unsigned int mmUMCCH16_PerfMonCtr10_Lo                          = 0xE400360;
    constexpr unsigned int mmUMCCH16_PerfMonCtr11_Hi                          = 0xE400364;
    constexpr unsigned int mmUMCCH16_PerfMonCtr11_Lo                          = 0xE400363;
    constexpr unsigned int mmUMCCH16_PerfMonCtr12_Hi                          = 0xE400367;
    constexpr unsigned int mmUMCCH16_PerfMonCtr12_Lo                          = 0xE400366;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Hi                         = 0xE400342;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Lo                         = 0xE400341;
    constexpr unsigned int mmUMCCH17_PerfMonCtl1                              = 0xE400744;
    constexpr unsigned int mmUMCCH17_PerfMonCtl2                              = 0xE400747;
    constexpr unsigned int mmUMCCH17_PerfMonCtl3                              = 0xE40074A;
    constexpr unsigned int mmUMCCH17_PerfMonCtl4                              = 0xE40074D;
    constexpr unsigned int mmUMCCH17_PerfMonCtl5                              = 0xE400750;
    constexpr unsigned int mmUMCCH17_PerfMonCtl6                              = 0xE400753;
    constexpr unsigned int mmUMCCH17_PerfMonCtl7                              = 0xE400756;
    constexpr unsigned int mmUMCCH17_PerfMonCtl8                              = 0xE400759;
    constexpr unsigned int mmUMCCH17_PerfMonCtl9                              = 0xE40075C;
    constexpr unsigned int mmUMCCH17_PerfMonCtl10                             = 0xE40075F;
    constexpr unsigned int mmUMCCH17_PerfMonCtl11                             = 0xE400762;
    constexpr unsigned int mmUMCCH17_PerfMonCtl12                             = 0xE400765;
    constexpr unsigned int mmUMCCH17_PerfMonCtlClk                            = 0xE400740;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Hi                           = 0xE400746;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Lo                           = 0xE400745;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Hi                           = 0xE400749;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Lo                           = 0xE400748;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Hi                           = 0xE40074C;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Lo                           = 0xE40074B;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Hi                           = 0xE40074F;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Lo                           = 0xE40074E;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Hi                           = 0xE400752;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Lo                           = 0xE400751;
    constexpr unsigned int mmUMCCH17_PerfMonCtr6_Hi                           = 0xE400755;
    constexpr unsigned int mmUMCCH17_PerfMonCtr6_Lo                           = 0xE400754;
    constexpr unsigned int mmUMCCH17_PerfMonCtr7_Hi                           = 0xE400758;
    constexpr unsigned int mmUMCCH17_PerfMonCtr7_Lo                           = 0xE400757;
    constexpr unsigned int mmUMCCH17_PerfMonCtr8_Hi                           = 0xE40075B;
    constexpr unsigned int mmUMCCH17_PerfMonCtr8_Lo                           = 0xE40075A;
    constexpr unsigned int mmUMCCH17_PerfMonCtr9_Hi                           = 0xE40075E;
    constexpr unsigned int mmUMCCH17_PerfMonCtr9_Lo                           = 0xE40075D;
    constexpr unsigned int mmUMCCH17_PerfMonCtr10_Hi                          = 0xE400761;
    constexpr unsigned int mmUMCCH17_PerfMonCtr10_Lo                          = 0xE400760;
    constexpr unsigned int mmUMCCH17_PerfMonCtr11_Hi                          = 0xE400764;
    constexpr unsigned int mmUMCCH17_PerfMonCtr11_Lo                          = 0xE400763;
    constexpr unsigned int mmUMCCH17_PerfMonCtr12_Hi                          = 0xE400767;
    constexpr unsigned int mmUMCCH17_PerfMonCtr12_Lo                          = 0xE400766;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Hi                         = 0xE400742;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Lo                         = 0xE400741;
    constexpr unsigned int mmUMCCH18_PerfMonCtl1                              = 0xE404344;
    constexpr unsigned int mmUMCCH18_PerfMonCtl2                              = 0xE404347;
    constexpr unsigned int mmUMCCH18_PerfMonCtl3                              = 0xE40434A;
    constexpr unsigned int mmUMCCH18_PerfMonCtl4                              = 0xE40434D;
    constexpr unsigned int mmUMCCH18_PerfMonCtl5                              = 0xE404350;
    constexpr unsigned int mmUMCCH18_PerfMonCtl6                              = 0xE404353;
    constexpr unsigned int mmUMCCH18_PerfMonCtl7                              = 0xE404356;
    constexpr unsigned int mmUMCCH18_PerfMonCtl8                              = 0xE404359;
    constexpr unsigned int mmUMCCH18_PerfMonCtl9                              = 0xE40435C;
    constexpr unsigned int mmUMCCH18_PerfMonCtl10                             = 0xE40435F;
    constexpr unsigned int mmUMCCH18_PerfMonCtl11                             = 0xE404362;
    constexpr unsigned int mmUMCCH18_PerfMonCtl12                             = 0xE404365;
    constexpr unsigned int mmUMCCH18_PerfMonCtlClk                            = 0xE404340;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Hi                           = 0xE404346;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Lo                           = 0xE404345;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Hi                           = 0xE404349;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Lo                           = 0xE404348;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Hi                           = 0xE40434C;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Lo                           = 0xE40434B;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Hi                           = 0xE40434F;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Lo                           = 0xE40434E;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Hi                           = 0xE404352;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Lo                           = 0xE404351;
    constexpr unsigned int mmUMCCH18_PerfMonCtr6_Hi                           = 0xE404355;
    constexpr unsigned int mmUMCCH18_PerfMonCtr6_Lo                           = 0xE404354;
    constexpr unsigned int mmUMCCH18_PerfMonCtr7_Hi                           = 0xE404358;
    constexpr unsigned int mmUMCCH18_PerfMonCtr7_Lo                           = 0xE404357;
    constexpr unsigned int mmUMCCH18_PerfMonCtr8_Hi                           = 0xE40435B;
    constexpr unsigned int mmUMCCH18_PerfMonCtr8_Lo                           = 0xE40435A;
    constexpr unsigned int mmUMCCH18_PerfMonCtr9_Hi                           = 0xE40435E;
    constexpr unsigned int mmUMCCH18_PerfMonCtr9_Lo                           = 0xE40435D;
    constexpr unsigned int mmUMCCH18_PerfMonCtr10_Hi                          = 0xE404361;
    constexpr unsigned int mmUMCCH18_PerfMonCtr10_Lo                          = 0xE404360;
    constexpr unsigned int mmUMCCH18_PerfMonCtr11_Hi                          = 0xE404364;
    constexpr unsigned int mmUMCCH18_PerfMonCtr11_Lo                          = 0xE404363;
    constexpr unsigned int mmUMCCH18_PerfMonCtr12_Hi                          = 0xE404367;
    constexpr unsigned int mmUMCCH18_PerfMonCtr12_Lo                          = 0xE404366;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Hi                         = 0xE404342;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Lo                         = 0xE404341;
    constexpr unsigned int mmUMCCH19_PerfMonCtl1                              = 0xE404744;
    constexpr unsigned int mmUMCCH19_PerfMonCtl2                              = 0xE404747;
    constexpr unsigned int mmUMCCH19_PerfMonCtl3                              = 0xE40474A;
    constexpr unsigned int mmUMCCH19_PerfMonCtl4                              = 0xE40474D;
    constexpr unsigned int mmUMCCH19_PerfMonCtl5                              = 0xE404750;
    constexpr unsigned int mmUMCCH19_PerfMonCtl6                              = 0xE404753;
    constexpr unsigned int mmUMCCH19_PerfMonCtl7                              = 0xE404756;
    constexpr unsigned int mmUMCCH19_PerfMonCtl8                              = 0xE404759;
    constexpr unsigned int mmUMCCH19_PerfMonCtl9                              = 0xE40475C;
    constexpr unsigned int mmUMCCH19_PerfMonCtl10                             = 0xE40475F;
    constexpr unsigned int mmUMCCH19_PerfMonCtl11                             = 0xE404762;
    constexpr unsigned int mmUMCCH19_PerfMonCtl12                             = 0xE404765;
    constexpr unsigned int mmUMCCH19_PerfMonCtlClk                            = 0xE404740;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Hi                           = 0xE404746;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Lo                           = 0xE404745;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Hi                           = 0xE404749;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Lo                           = 0xE404748;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Hi                           = 0xE40474C;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Lo                           = 0xE40474B;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Hi                           = 0xE40474F;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Lo                           = 0xE40474E;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Hi                           = 0xE404752;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Lo                           = 0xE404751;
    constexpr unsigned int mmUMCCH19_PerfMonCtr6_Hi                           = 0xE404755;
    constexpr unsigned int mmUMCCH19_PerfMonCtr6_Lo                           = 0xE404754;
    constexpr unsigned int mmUMCCH19_PerfMonCtr7_Hi                           = 0xE404758;
    constexpr unsigned int mmUMCCH19_PerfMonCtr7_Lo                           = 0xE404757;
    constexpr unsigned int mmUMCCH19_PerfMonCtr8_Hi                           = 0xE40475B;
    constexpr unsigned int mmUMCCH19_PerfMonCtr8_Lo                           = 0xE40475A;
    constexpr unsigned int mmUMCCH19_PerfMonCtr9_Hi                           = 0xE40475E;
    constexpr unsigned int mmUMCCH19_PerfMonCtr9_Lo                           = 0xE40475D;
    constexpr unsigned int mmUMCCH19_PerfMonCtr10_Hi                          = 0xE404761;
    constexpr unsigned int mmUMCCH19_PerfMonCtr10_Lo                          = 0xE404760;
    constexpr unsigned int mmUMCCH19_PerfMonCtr11_Hi                          = 0xE404764;
    constexpr unsigned int mmUMCCH19_PerfMonCtr11_Lo                          = 0xE404763;
    constexpr unsigned int mmUMCCH19_PerfMonCtr12_Hi                          = 0xE404767;
    constexpr unsigned int mmUMCCH19_PerfMonCtr12_Lo                          = 0xE404766;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Hi                         = 0xE404742;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Lo                         = 0xE404741;
    constexpr unsigned int mmUMCCH20_PerfMonCtl1                              = 0xEC00344;
    constexpr unsigned int mmUMCCH20_PerfMonCtl2                              = 0xEC00347;
    constexpr unsigned int mmUMCCH20_PerfMonCtl3                              = 0xEC0034A;
    constexpr unsigned int mmUMCCH20_PerfMonCtl4                              = 0xEC0034D;
    constexpr unsigned int mmUMCCH20_PerfMonCtl5                              = 0xEC00350;
    constexpr unsigned int mmUMCCH20_PerfMonCtl6                              = 0xEC00353;
    constexpr unsigned int mmUMCCH20_PerfMonCtl7                              = 0xEC00356;
    constexpr unsigned int mmUMCCH20_PerfMonCtl8                              = 0xEC00359;
    constexpr unsigned int mmUMCCH20_PerfMonCtl9                              = 0xEC0035C;
    constexpr unsigned int mmUMCCH20_PerfMonCtl10                             = 0xEC0035F;
    constexpr unsigned int mmUMCCH20_PerfMonCtl11                             = 0xEC00362;
    constexpr unsigned int mmUMCCH20_PerfMonCtl12                             = 0xEC00365;
    constexpr unsigned int mmUMCCH20_PerfMonCtlClk                            = 0xEC00340;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Hi                           = 0xEC00346;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Lo                           = 0xEC00345;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Hi                           = 0xEC00349;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Lo                           = 0xEC00348;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Hi                           = 0xEC0034C;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Lo                           = 0xEC0034B;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Hi                           = 0xEC0034F;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Lo                           = 0xEC0034E;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Hi                           = 0xEC00352;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Lo                           = 0xEC00351;
    constexpr unsigned int mmUMCCH20_PerfMonCtr6_Hi                           = 0xEC00355;
    constexpr unsigned int mmUMCCH20_PerfMonCtr6_Lo                           = 0xEC00354;
    constexpr unsigned int mmUMCCH20_PerfMonCtr7_Hi                           = 0xEC00358;
    constexpr unsigned int mmUMCCH20_PerfMonCtr7_Lo                           = 0xEC00357;
    constexpr unsigned int mmUMCCH20_PerfMonCtr8_Hi                           = 0xEC0035B;
    constexpr unsigned int mmUMCCH20_PerfMonCtr8_Lo                           = 0xEC0035A;
    constexpr unsigned int mmUMCCH20_PerfMonCtr9_Hi                           = 0xEC0035E;
    constexpr unsigned int mmUMCCH20_PerfMonCtr9_Lo                           = 0xEC0035D;
    constexpr unsigned int mmUMCCH20_PerfMonCtr10_Hi                          = 0xEC00361;
    constexpr unsigned int mmUMCCH20_PerfMonCtr10_Lo                          = 0xEC00360;
    constexpr unsigned int mmUMCCH20_PerfMonCtr11_Hi                          = 0xEC00364;
    constexpr unsigned int mmUMCCH20_PerfMonCtr11_Lo                          = 0xEC00363;
    constexpr unsigned int mmUMCCH20_PerfMonCtr12_Hi                          = 0xEC00367;
    constexpr unsigned int mmUMCCH20_PerfMonCtr12_Lo                          = 0xEC00366;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Hi                         = 0xEC00342;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Lo                         = 0xEC00341;
    constexpr unsigned int mmUMCCH21_PerfMonCtl1                              = 0xEC00744;
    constexpr unsigned int mmUMCCH21_PerfMonCtl2                              = 0xEC00747;
    constexpr unsigned int mmUMCCH21_PerfMonCtl3                              = 0xEC0074A;
    constexpr unsigned int mmUMCCH21_PerfMonCtl4                              = 0xEC0074D;
    constexpr unsigned int mmUMCCH21_PerfMonCtl5                              = 0xEC00750;
    constexpr unsigned int mmUMCCH21_PerfMonCtl6                              = 0xEC00753;
    constexpr unsigned int mmUMCCH21_PerfMonCtl7                              = 0xEC00756;
    constexpr unsigned int mmUMCCH21_PerfMonCtl8                              = 0xEC00759;
    constexpr unsigned int mmUMCCH21_PerfMonCtl9                              = 0xEC0075C;
    constexpr unsigned int mmUMCCH21_PerfMonCtl10                             = 0xEC0075F;
    constexpr unsigned int mmUMCCH21_PerfMonCtl11                             = 0xEC00762;
    constexpr unsigned int mmUMCCH21_PerfMonCtl12                             = 0xEC00765;
    constexpr unsigned int mmUMCCH21_PerfMonCtlClk                            = 0xEC00740;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Hi                           = 0xEC00746;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Lo                           = 0xEC00745;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Hi                           = 0xEC00749;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Lo                           = 0xEC00748;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Hi                           = 0xEC0074C;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Lo                           = 0xEC0074B;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Hi                           = 0xEC0074F;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Lo                           = 0xEC0074E;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Hi                           = 0xEC00752;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Lo                           = 0xEC00751;
    constexpr unsigned int mmUMCCH21_PerfMonCtr6_Hi                           = 0xEC00755;
    constexpr unsigned int mmUMCCH21_PerfMonCtr6_Lo                           = 0xEC00754;
    constexpr unsigned int mmUMCCH21_PerfMonCtr7_Hi                           = 0xEC00758;
    constexpr unsigned int mmUMCCH21_PerfMonCtr7_Lo                           = 0xEC00757;
    constexpr unsigned int mmUMCCH21_PerfMonCtr8_Hi                           = 0xEC0075B;
    constexpr unsigned int mmUMCCH21_PerfMonCtr8_Lo                           = 0xEC0075A;
    constexpr unsigned int mmUMCCH21_PerfMonCtr9_Hi                           = 0xEC0075E;
    constexpr unsigned int mmUMCCH21_PerfMonCtr9_Lo                           = 0xEC0075D;
    constexpr unsigned int mmUMCCH21_PerfMonCtr10_Hi                          = 0xEC00761;
    constexpr unsigned int mmUMCCH21_PerfMonCtr10_Lo                          = 0xEC00760;
    constexpr unsigned int mmUMCCH21_PerfMonCtr11_Hi                          = 0xEC00764;
    constexpr unsigned int mmUMCCH21_PerfMonCtr11_Lo                          = 0xEC00763;
    constexpr unsigned int mmUMCCH21_PerfMonCtr12_Hi                          = 0xEC00767;
    constexpr unsigned int mmUMCCH21_PerfMonCtr12_Lo                          = 0xEC00766;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Hi                         = 0xEC00742;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Lo                         = 0xEC00741;
    constexpr unsigned int mmUMCCH22_PerfMonCtl1                              = 0xEC04344;
    constexpr unsigned int mmUMCCH22_PerfMonCtl2                              = 0xEC04347;
    constexpr unsigned int mmUMCCH22_PerfMonCtl3                              = 0xEC0434A;
    constexpr unsigned int mmUMCCH22_PerfMonCtl4                              = 0xEC0434D;
    constexpr unsigned int mmUMCCH22_PerfMonCtl5                              = 0xEC04350;
    constexpr unsigned int mmUMCCH22_PerfMonCtl6                              = 0xEC04353;
    constexpr unsigned int mmUMCCH22_PerfMonCtl7                              = 0xEC04356;
    constexpr unsigned int mmUMCCH22_PerfMonCtl8                              = 0xEC04359;
    constexpr unsigned int mmUMCCH22_PerfMonCtl9                              = 0xEC0435C;
    constexpr unsigned int mmUMCCH22_PerfMonCtl10                             = 0xEC0435F;
    constexpr unsigned int mmUMCCH22_PerfMonCtl11                             = 0xEC04362;
    constexpr unsigned int mmUMCCH22_PerfMonCtl12                             = 0xEC04365;
    constexpr unsigned int mmUMCCH22_PerfMonCtlClk                            = 0xEC04340;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Hi                           = 0xEC04346;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Lo                           = 0xEC04345;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Hi                           = 0xEC04349;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Lo                           = 0xEC04348;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Hi                           = 0xEC0434C;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Lo                           = 0xEC0434B;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Hi                           = 0xEC0434F;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Lo                           = 0xEC0434E;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Hi                           = 0xEC04352;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Lo                           = 0xEC04351;
    constexpr unsigned int mmUMCCH22_PerfMonCtr6_Hi                           = 0xEC04355;
    constexpr unsigned int mmUMCCH22_PerfMonCtr6_Lo                           = 0xEC04354;
    constexpr unsigned int mmUMCCH22_PerfMonCtr7_Hi                           = 0xEC04358;
    constexpr unsigned int mmUMCCH22_PerfMonCtr7_Lo                           = 0xEC04357;
    constexpr unsigned int mmUMCCH22_PerfMonCtr8_Hi                           = 0xEC0435B;
    constexpr unsigned int mmUMCCH22_PerfMonCtr8_Lo                           = 0xEC0435A;
    constexpr unsigned int mmUMCCH22_PerfMonCtr9_Hi                           = 0xEC0435E;
    constexpr unsigned int mmUMCCH22_PerfMonCtr9_Lo                           = 0xEC0435D;
    constexpr unsigned int mmUMCCH22_PerfMonCtr10_Hi                          = 0xEC04361;
    constexpr unsigned int mmUMCCH22_PerfMonCtr10_Lo                          = 0xEC04360;
    constexpr unsigned int mmUMCCH22_PerfMonCtr11_Hi                          = 0xEC04364;
    constexpr unsigned int mmUMCCH22_PerfMonCtr11_Lo                          = 0xEC04363;
    constexpr unsigned int mmUMCCH22_PerfMonCtr12_Hi                          = 0xEC04367;
    constexpr unsigned int mmUMCCH22_PerfMonCtr12_Lo                          = 0xEC04366;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Hi                         = 0xEC04342;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Lo                         = 0xEC04341;
    constexpr unsigned int mmUMCCH23_PerfMonCtl1                              = 0xEC04744;
    constexpr unsigned int mmUMCCH23_PerfMonCtl2                              = 0xEC04747;
    constexpr unsigned int mmUMCCH23_PerfMonCtl3                              = 0xEC0474A;
    constexpr unsigned int mmUMCCH23_PerfMonCtl4                              = 0xEC0474D;
    constexpr unsigned int mmUMCCH23_PerfMonCtl5                              = 0xEC04750;
    constexpr unsigned int mmUMCCH23_PerfMonCtl6                              = 0xEC04753;
    constexpr unsigned int mmUMCCH23_PerfMonCtl7                              = 0xEC04756;
    constexpr unsigned int mmUMCCH23_PerfMonCtl8                              = 0xEC04759;
    constexpr unsigned int mmUMCCH23_PerfMonCtl9                              = 0xEC0475C;
    constexpr unsigned int mmUMCCH23_PerfMonCtl10                             = 0xEC0475F;
    constexpr unsigned int mmUMCCH23_PerfMonCtl11                             = 0xEC04762;
    constexpr unsigned int mmUMCCH23_PerfMonCtl12                             = 0xEC04765;
    constexpr unsigned int mmUMCCH23_PerfMonCtlClk                            = 0xEC04740;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Hi                           = 0xEC04746;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Lo                           = 0xEC04745;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Hi                           = 0xEC04749;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Lo                           = 0xEC04748;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Hi                           = 0xEC0474C;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Lo                           = 0xEC0474B;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Hi                           = 0xEC0474F;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Lo                           = 0xEC0474E;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Hi                           = 0xEC04752;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Lo                           = 0xEC04751;
    constexpr unsigned int mmUMCCH23_PerfMonCtr6_Hi                           = 0xEC04755;
    constexpr unsigned int mmUMCCH23_PerfMonCtr6_Lo                           = 0xEC04754;
    constexpr unsigned int mmUMCCH23_PerfMonCtr7_Hi                           = 0xEC04758;
    constexpr unsigned int mmUMCCH23_PerfMonCtr7_Lo                           = 0xEC04757;
    constexpr unsigned int mmUMCCH23_PerfMonCtr8_Hi                           = 0xEC0475B;
    constexpr unsigned int mmUMCCH23_PerfMonCtr8_Lo                           = 0xEC0475A;
    constexpr unsigned int mmUMCCH23_PerfMonCtr9_Hi                           = 0xEC0475E;
    constexpr unsigned int mmUMCCH23_PerfMonCtr9_Lo                           = 0xEC0475D;
    constexpr unsigned int mmUMCCH23_PerfMonCtr10_Hi                          = 0xEC04761;
    constexpr unsigned int mmUMCCH23_PerfMonCtr10_Lo                          = 0xEC04760;
    constexpr unsigned int mmUMCCH23_PerfMonCtr11_Hi                          = 0xEC04764;
    constexpr unsigned int mmUMCCH23_PerfMonCtr11_Lo                          = 0xEC04763;
    constexpr unsigned int mmUMCCH23_PerfMonCtr12_Hi                          = 0xEC04767;
    constexpr unsigned int mmUMCCH23_PerfMonCtr12_Lo                          = 0xEC04766;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Hi                         = 0xEC04742;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Lo                         = 0xEC04741;
} // namespace Nv31

namespace Nv32
{
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xC022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi0_alt_1 = 0x10022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xC022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi1_alt_1 = 0x10022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xC022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi2_alt_1 = 0x10022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xC022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi3_alt_1 = 0x10022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xC022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi4_alt_1 = 0x10022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xC022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi5_alt_1 = 0x10022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xC022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi6_alt_1 = 0x10022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xC022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlHi7_alt_1 = 0x10022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xC022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo0_alt_1 = 0x10022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xC022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo1_alt_1 = 0x10022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xC022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo2_alt_1 = 0x10022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xC022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo3_alt_1 = 0x10022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xC022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo4_alt_1 = 0x10022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xC022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo5_alt_1 = 0x10022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xC022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo6_alt_1 = 0x10022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xC022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtlLo7_alt_1 = 0x10022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xC022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi0_alt_1 = 0x10022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xC022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi1_alt_1 = 0x10022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xC022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi2_alt_1 = 0x10022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xC022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi3_alt_1 = 0x10022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xC022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi4_alt_1 = 0x10022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xC022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi5_alt_1 = 0x10022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xC022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi6_alt_1 = 0x10022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xC022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrHi7_alt_1 = 0x10022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xC022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo0_alt_1 = 0x10022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xC022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo1_alt_1 = 0x10022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xC022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo2_alt_1 = 0x10022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xC022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo3_alt_1 = 0x10022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xC022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo4_alt_1 = 0x10022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xC022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo5_alt_1 = 0x10022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xC022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo6_alt_1 = 0x10022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xC022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON0_DF_MCD_PIE_AON_PerfMonCtrLo7_alt_1 = 0x10022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xC822C81;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xC822C83;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xC822C85;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xC822C87;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xC822C89;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xC822C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xC822C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xC822C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xC822C80;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xC822C82;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xC822C84;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xC822C86;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xC822C88;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xC822C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xC822C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xC822C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xC822CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xC822CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xC822CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xC822CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xC822CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xC822CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xC822CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xC822CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xC822CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xC822CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xC822CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xC822CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xC822CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xC822CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xC822CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON1_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xC822CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xD022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xD022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xD022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xD022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xD022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xD022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xD022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xD022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xD022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xD022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xD022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xD022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xD022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xD022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xD022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xD022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xD022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xD022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xD022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xD022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xD022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xD022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xD022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xD022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xD022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xD022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xD022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xD022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xD022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xD022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xD022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON2_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xD022CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi0     = 0xD822C81;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi1     = 0xD822C83;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi2     = 0xD822C85;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi3     = 0xD822C87;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi4     = 0xD822C89;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi5     = 0xD822C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi6     = 0xD822C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlHi7     = 0xD822C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo0     = 0xD822C80;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo1     = 0xD822C82;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo2     = 0xD822C84;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo3     = 0xD822C86;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo4     = 0xD822C88;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo5     = 0xD822C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo6     = 0xD822C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtlLo7     = 0xD822C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi0     = 0xD822CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi1     = 0xD822CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi2     = 0xD822CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi3     = 0xD822CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi4     = 0xD822CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi5     = 0xD822CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi6     = 0xD822CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrHi7     = 0xD822CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo0     = 0xD822CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo1     = 0xD822CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo2     = 0xD822CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo3     = 0xD822CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo4     = 0xD822CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo5     = 0xD822CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo6     = 0xD822CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON3_DF_MCD_PIE_AON_PerfMonCtrLo7     = 0xD822CCE;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi0                     = 0xC022C81;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi1                     = 0xC022C83;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi2                     = 0xC022C85;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi3                     = 0xC022C87;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi4                     = 0xC022C89;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi5                     = 0xC022C8B;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi6                     = 0xC022C8D;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlHi7                     = 0xC022C8F;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo0                     = 0xC022C80;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo1                     = 0xC022C82;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo2                     = 0xC022C84;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo3                     = 0xC022C86;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo4                     = 0xC022C88;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo5                     = 0xC022C8A;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo6                     = 0xC022C8C;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtlLo7                     = 0xC022C8E;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi0                     = 0xC022CC1;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi1                     = 0xC022CC3;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi2                     = 0xC022CC5;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi3                     = 0xC022CC7;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi4                     = 0xC022CC9;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi5                     = 0xC022CCB;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi6                     = 0xC022CCD;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrHi7                     = 0xC022CCF;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo0                     = 0xC022CC0;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo1                     = 0xC022CC2;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo2                     = 0xC022CC4;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo3                     = 0xC022CC6;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo4                     = 0xC022CC8;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo5                     = 0xC022CCA;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo6                     = 0xC022CCC;
    constexpr unsigned int mmDF_MCD_PIE_AON_PerfMonCtrLo7                     = 0xC022CCE;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG                       = 0xDD44;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG                       = 0xDD45;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI                        = 0xD4F5;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO                        = 0xD4F4;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE                      = 0xDD42;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT                    = 0xDD40;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1                   = 0xDD41;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI                         = 0xD4F9;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO                         = 0xD4F8;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL                  = 0xDD46;
    constexpr unsigned int mmGE_FED_STATUS                                    = 0x224A;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI                          = 0xD04C;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO                          = 0xD04B;
    constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT                      = 0xD845;
    constexpr unsigned int mmPerfMonCtl1                                      = 0xC400344;
    constexpr unsigned int mmPerfMonCtl2                                      = 0xC400347;
    constexpr unsigned int mmPerfMonCtl3                                      = 0xC40034A;
    constexpr unsigned int mmPerfMonCtl4                                      = 0xC40034D;
    constexpr unsigned int mmPerfMonCtl5                                      = 0xC400350;
    constexpr unsigned int mmPerfMonCtl6                                      = 0xC400353;
    constexpr unsigned int mmPerfMonCtl7                                      = 0xC400356;
    constexpr unsigned int mmPerfMonCtl8                                      = 0xC400359;
    constexpr unsigned int mmPerfMonCtl9                                      = 0xC40035C;
    constexpr unsigned int mmPerfMonCtl10                                     = 0xC40035F;
    constexpr unsigned int mmPerfMonCtl11                                     = 0xC400362;
    constexpr unsigned int mmPerfMonCtl12                                     = 0xC400365;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0xC400340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0xC400346;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0xC400345;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0xC400349;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0xC400348;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0xC40034C;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0xC40034B;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0xC40034F;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0xC40034E;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0xC400352;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0xC400351;
    constexpr unsigned int mmPerfMonCtr6_Hi                                   = 0xC400355;
    constexpr unsigned int mmPerfMonCtr6_Lo                                   = 0xC400354;
    constexpr unsigned int mmPerfMonCtr7_Hi                                   = 0xC400358;
    constexpr unsigned int mmPerfMonCtr7_Lo                                   = 0xC400357;
    constexpr unsigned int mmPerfMonCtr8_Hi                                   = 0xC40035B;
    constexpr unsigned int mmPerfMonCtr8_Lo                                   = 0xC40035A;
    constexpr unsigned int mmPerfMonCtr9_Hi                                   = 0xC40035E;
    constexpr unsigned int mmPerfMonCtr9_Lo                                   = 0xC40035D;
    constexpr unsigned int mmPerfMonCtr10_Hi                                  = 0xC400361;
    constexpr unsigned int mmPerfMonCtr10_Lo                                  = 0xC400360;
    constexpr unsigned int mmPerfMonCtr11_Hi                                  = 0xC400364;
    constexpr unsigned int mmPerfMonCtr11_Lo                                  = 0xC400363;
    constexpr unsigned int mmPerfMonCtr12_Hi                                  = 0xC400367;
    constexpr unsigned int mmPerfMonCtr12_Lo                                  = 0xC400366;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0xC400342;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0xC400341;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0xC400344;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0xC400347;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0xC40034A;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0xC40034D;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0xC400350;
    constexpr unsigned int mmUMCCH0_PerfMonCtl6                               = 0xC400353;
    constexpr unsigned int mmUMCCH0_PerfMonCtl7                               = 0xC400356;
    constexpr unsigned int mmUMCCH0_PerfMonCtl8                               = 0xC400359;
    constexpr unsigned int mmUMCCH0_PerfMonCtl9                               = 0xC40035C;
    constexpr unsigned int mmUMCCH0_PerfMonCtl10                              = 0xC40035F;
    constexpr unsigned int mmUMCCH0_PerfMonCtl11                              = 0xC400362;
    constexpr unsigned int mmUMCCH0_PerfMonCtl12                              = 0xC400365;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0xC400340;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0xC400346;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0xC400345;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0xC400349;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0xC400348;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0xC40034C;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0xC40034B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0xC40034F;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0xC40034E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0xC400352;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0xC400351;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi                            = 0xC400355;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo                            = 0xC400354;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi                            = 0xC400358;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo                            = 0xC400357;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi                            = 0xC40035B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo                            = 0xC40035A;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi                            = 0xC40035E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo                            = 0xC40035D;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi                           = 0xC400361;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo                           = 0xC400360;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi                           = 0xC400364;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo                           = 0xC400363;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi                           = 0xC400367;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo                           = 0xC400366;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0xC400342;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0xC400341;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0xC400744;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0xC400747;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0xC40074A;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0xC40074D;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0xC400750;
    constexpr unsigned int mmUMCCH1_PerfMonCtl6                               = 0xC400753;
    constexpr unsigned int mmUMCCH1_PerfMonCtl7                               = 0xC400756;
    constexpr unsigned int mmUMCCH1_PerfMonCtl8                               = 0xC400759;
    constexpr unsigned int mmUMCCH1_PerfMonCtl9                               = 0xC40075C;
    constexpr unsigned int mmUMCCH1_PerfMonCtl10                              = 0xC40075F;
    constexpr unsigned int mmUMCCH1_PerfMonCtl11                              = 0xC400762;
    constexpr unsigned int mmUMCCH1_PerfMonCtl12                              = 0xC400765;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0xC400740;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0xC400746;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0xC400745;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0xC400749;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0xC400748;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0xC40074C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0xC40074B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0xC40074F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0xC40074E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0xC400752;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0xC400751;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi                            = 0xC400755;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo                            = 0xC400754;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi                            = 0xC400758;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo                            = 0xC400757;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi                            = 0xC40075B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo                            = 0xC40075A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi                            = 0xC40075E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo                            = 0xC40075D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi                           = 0xC400761;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo                           = 0xC400760;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi                           = 0xC400764;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo                           = 0xC400763;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi                           = 0xC400767;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo                           = 0xC400766;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0xC400742;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0xC400741;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0xC404344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0xC404347;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0xC40434A;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0xC40434D;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0xC404350;
    constexpr unsigned int mmUMCCH2_PerfMonCtl6                               = 0xC404353;
    constexpr unsigned int mmUMCCH2_PerfMonCtl7                               = 0xC404356;
    constexpr unsigned int mmUMCCH2_PerfMonCtl8                               = 0xC404359;
    constexpr unsigned int mmUMCCH2_PerfMonCtl9                               = 0xC40435C;
    constexpr unsigned int mmUMCCH2_PerfMonCtl10                              = 0xC40435F;
    constexpr unsigned int mmUMCCH2_PerfMonCtl11                              = 0xC404362;
    constexpr unsigned int mmUMCCH2_PerfMonCtl12                              = 0xC404365;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0xC404340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0xC404346;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0xC404345;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0xC404349;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0xC404348;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0xC40434C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0xC40434B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0xC40434F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0xC40434E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0xC404352;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0xC404351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi                            = 0xC404355;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo                            = 0xC404354;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi                            = 0xC404358;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo                            = 0xC404357;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi                            = 0xC40435B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo                            = 0xC40435A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi                            = 0xC40435E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo                            = 0xC40435D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi                           = 0xC404361;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo                           = 0xC404360;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi                           = 0xC404364;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo                           = 0xC404363;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi                           = 0xC404367;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo                           = 0xC404366;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0xC404342;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0xC404341;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0xC404744;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0xC404747;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0xC40474A;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0xC40474D;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0xC404750;
    constexpr unsigned int mmUMCCH3_PerfMonCtl6                               = 0xC404753;
    constexpr unsigned int mmUMCCH3_PerfMonCtl7                               = 0xC404756;
    constexpr unsigned int mmUMCCH3_PerfMonCtl8                               = 0xC404759;
    constexpr unsigned int mmUMCCH3_PerfMonCtl9                               = 0xC40475C;
    constexpr unsigned int mmUMCCH3_PerfMonCtl10                              = 0xC40475F;
    constexpr unsigned int mmUMCCH3_PerfMonCtl11                              = 0xC404762;
    constexpr unsigned int mmUMCCH3_PerfMonCtl12                              = 0xC404765;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0xC404740;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0xC404746;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0xC404745;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0xC404749;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0xC404748;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0xC40474C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0xC40474B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0xC40474F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0xC40474E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0xC404752;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0xC404751;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi                            = 0xC404755;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo                            = 0xC404754;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi                            = 0xC404758;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo                            = 0xC404757;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi                            = 0xC40475B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo                            = 0xC40475A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi                            = 0xC40475E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo                            = 0xC40475D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi                           = 0xC404761;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo                           = 0xC404760;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi                           = 0xC404764;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo                           = 0xC404763;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi                           = 0xC404767;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo                           = 0xC404766;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0xC404742;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0xC404741;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0xCC00344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0xCC00347;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0xCC0034A;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0xCC0034D;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0xCC00350;
    constexpr unsigned int mmUMCCH4_PerfMonCtl6                               = 0xCC00353;
    constexpr unsigned int mmUMCCH4_PerfMonCtl7                               = 0xCC00356;
    constexpr unsigned int mmUMCCH4_PerfMonCtl8                               = 0xCC00359;
    constexpr unsigned int mmUMCCH4_PerfMonCtl9                               = 0xCC0035C;
    constexpr unsigned int mmUMCCH4_PerfMonCtl10                              = 0xCC0035F;
    constexpr unsigned int mmUMCCH4_PerfMonCtl11                              = 0xCC00362;
    constexpr unsigned int mmUMCCH4_PerfMonCtl12                              = 0xCC00365;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0xCC00340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0xCC00346;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0xCC00345;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0xCC00349;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0xCC00348;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0xCC0034C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0xCC0034B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0xCC0034F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0xCC0034E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0xCC00352;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0xCC00351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi                            = 0xCC00355;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo                            = 0xCC00354;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi                            = 0xCC00358;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo                            = 0xCC00357;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi                            = 0xCC0035B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo                            = 0xCC0035A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi                            = 0xCC0035E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo                            = 0xCC0035D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi                           = 0xCC00361;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo                           = 0xCC00360;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi                           = 0xCC00364;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo                           = 0xCC00363;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi                           = 0xCC00367;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo                           = 0xCC00366;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0xCC00342;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0xCC00341;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0xCC00744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0xCC00747;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0xCC0074A;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0xCC0074D;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0xCC00750;
    constexpr unsigned int mmUMCCH5_PerfMonCtl6                               = 0xCC00753;
    constexpr unsigned int mmUMCCH5_PerfMonCtl7                               = 0xCC00756;
    constexpr unsigned int mmUMCCH5_PerfMonCtl8                               = 0xCC00759;
    constexpr unsigned int mmUMCCH5_PerfMonCtl9                               = 0xCC0075C;
    constexpr unsigned int mmUMCCH5_PerfMonCtl10                              = 0xCC0075F;
    constexpr unsigned int mmUMCCH5_PerfMonCtl11                              = 0xCC00762;
    constexpr unsigned int mmUMCCH5_PerfMonCtl12                              = 0xCC00765;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0xCC00740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0xCC00746;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0xCC00745;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0xCC00749;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0xCC00748;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0xCC0074C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0xCC0074B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0xCC0074F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0xCC0074E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0xCC00752;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0xCC00751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi                            = 0xCC00755;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo                            = 0xCC00754;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi                            = 0xCC00758;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo                            = 0xCC00757;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi                            = 0xCC0075B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo                            = 0xCC0075A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi                            = 0xCC0075E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo                            = 0xCC0075D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi                           = 0xCC00761;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo                           = 0xCC00760;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi                           = 0xCC00764;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo                           = 0xCC00763;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi                           = 0xCC00767;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo                           = 0xCC00766;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0xCC00742;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0xCC00741;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xCC04344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xCC04347;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xCC0434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xCC0434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xCC04350;
    constexpr unsigned int mmUMCCH6_PerfMonCtl6                               = 0xCC04353;
    constexpr unsigned int mmUMCCH6_PerfMonCtl7                               = 0xCC04356;
    constexpr unsigned int mmUMCCH6_PerfMonCtl8                               = 0xCC04359;
    constexpr unsigned int mmUMCCH6_PerfMonCtl9                               = 0xCC0435C;
    constexpr unsigned int mmUMCCH6_PerfMonCtl10                              = 0xCC0435F;
    constexpr unsigned int mmUMCCH6_PerfMonCtl11                              = 0xCC04362;
    constexpr unsigned int mmUMCCH6_PerfMonCtl12                              = 0xCC04365;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xCC04340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xCC04346;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xCC04345;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xCC04349;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xCC04348;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xCC0434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xCC0434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xCC0434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xCC0434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xCC04352;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xCC04351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi                            = 0xCC04355;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo                            = 0xCC04354;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi                            = 0xCC04358;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo                            = 0xCC04357;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi                            = 0xCC0435B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo                            = 0xCC0435A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi                            = 0xCC0435E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo                            = 0xCC0435D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi                           = 0xCC04361;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo                           = 0xCC04360;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi                           = 0xCC04364;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo                           = 0xCC04363;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi                           = 0xCC04367;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo                           = 0xCC04366;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xCC04342;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xCC04341;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xCC04744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xCC04747;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xCC0474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xCC0474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xCC04750;
    constexpr unsigned int mmUMCCH7_PerfMonCtl6                               = 0xCC04753;
    constexpr unsigned int mmUMCCH7_PerfMonCtl7                               = 0xCC04756;
    constexpr unsigned int mmUMCCH7_PerfMonCtl8                               = 0xCC04759;
    constexpr unsigned int mmUMCCH7_PerfMonCtl9                               = 0xCC0475C;
    constexpr unsigned int mmUMCCH7_PerfMonCtl10                              = 0xCC0475F;
    constexpr unsigned int mmUMCCH7_PerfMonCtl11                              = 0xCC04762;
    constexpr unsigned int mmUMCCH7_PerfMonCtl12                              = 0xCC04765;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xCC04740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xCC04746;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xCC04745;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xCC04749;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xCC04748;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xCC0474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xCC0474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xCC0474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xCC0474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xCC04752;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xCC04751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi                            = 0xCC04755;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo                            = 0xCC04754;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi                            = 0xCC04758;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo                            = 0xCC04757;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi                            = 0xCC0475B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo                            = 0xCC0475A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi                            = 0xCC0475E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo                            = 0xCC0475D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi                           = 0xCC04761;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo                           = 0xCC04760;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi                           = 0xCC04764;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo                           = 0xCC04763;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi                           = 0xCC04767;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo                           = 0xCC04766;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xCC04742;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xCC04741;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0xD400344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0xD400347;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0xD40034A;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0xD40034D;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0xD400350;
    constexpr unsigned int mmUMCCH8_PerfMonCtl6                               = 0xD400353;
    constexpr unsigned int mmUMCCH8_PerfMonCtl7                               = 0xD400356;
    constexpr unsigned int mmUMCCH8_PerfMonCtl8                               = 0xD400359;
    constexpr unsigned int mmUMCCH8_PerfMonCtl9                               = 0xD40035C;
    constexpr unsigned int mmUMCCH8_PerfMonCtl10                              = 0xD40035F;
    constexpr unsigned int mmUMCCH8_PerfMonCtl11                              = 0xD400362;
    constexpr unsigned int mmUMCCH8_PerfMonCtl12                              = 0xD400365;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0xD400340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0xD400346;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0xD400345;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0xD400349;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0xD400348;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0xD40034C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0xD40034B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0xD40034F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0xD40034E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0xD400352;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0xD400351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Hi                            = 0xD400355;
    constexpr unsigned int mmUMCCH8_PerfMonCtr6_Lo                            = 0xD400354;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Hi                            = 0xD400358;
    constexpr unsigned int mmUMCCH8_PerfMonCtr7_Lo                            = 0xD400357;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Hi                            = 0xD40035B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr8_Lo                            = 0xD40035A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Hi                            = 0xD40035E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr9_Lo                            = 0xD40035D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Hi                           = 0xD400361;
    constexpr unsigned int mmUMCCH8_PerfMonCtr10_Lo                           = 0xD400360;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Hi                           = 0xD400364;
    constexpr unsigned int mmUMCCH8_PerfMonCtr11_Lo                           = 0xD400363;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Hi                           = 0xD400367;
    constexpr unsigned int mmUMCCH8_PerfMonCtr12_Lo                           = 0xD400366;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0xD400342;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0xD400341;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0xD400744;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0xD400747;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0xD40074A;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0xD40074D;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0xD400750;
    constexpr unsigned int mmUMCCH9_PerfMonCtl6                               = 0xD400753;
    constexpr unsigned int mmUMCCH9_PerfMonCtl7                               = 0xD400756;
    constexpr unsigned int mmUMCCH9_PerfMonCtl8                               = 0xD400759;
    constexpr unsigned int mmUMCCH9_PerfMonCtl9                               = 0xD40075C;
    constexpr unsigned int mmUMCCH9_PerfMonCtl10                              = 0xD40075F;
    constexpr unsigned int mmUMCCH9_PerfMonCtl11                              = 0xD400762;
    constexpr unsigned int mmUMCCH9_PerfMonCtl12                              = 0xD400765;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0xD400740;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0xD400746;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0xD400745;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0xD400749;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0xD400748;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0xD40074C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0xD40074B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0xD40074F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0xD40074E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0xD400752;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0xD400751;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Hi                            = 0xD400755;
    constexpr unsigned int mmUMCCH9_PerfMonCtr6_Lo                            = 0xD400754;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Hi                            = 0xD400758;
    constexpr unsigned int mmUMCCH9_PerfMonCtr7_Lo                            = 0xD400757;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Hi                            = 0xD40075B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr8_Lo                            = 0xD40075A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Hi                            = 0xD40075E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr9_Lo                            = 0xD40075D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Hi                           = 0xD400761;
    constexpr unsigned int mmUMCCH9_PerfMonCtr10_Lo                           = 0xD400760;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Hi                           = 0xD400764;
    constexpr unsigned int mmUMCCH9_PerfMonCtr11_Lo                           = 0xD400763;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Hi                           = 0xD400767;
    constexpr unsigned int mmUMCCH9_PerfMonCtr12_Lo                           = 0xD400766;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0xD400742;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0xD400741;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0xD404344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0xD404347;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0xD40434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0xD40434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0xD404350;
    constexpr unsigned int mmUMCCH10_PerfMonCtl6                              = 0xD404353;
    constexpr unsigned int mmUMCCH10_PerfMonCtl7                              = 0xD404356;
    constexpr unsigned int mmUMCCH10_PerfMonCtl8                              = 0xD404359;
    constexpr unsigned int mmUMCCH10_PerfMonCtl9                              = 0xD40435C;
    constexpr unsigned int mmUMCCH10_PerfMonCtl10                             = 0xD40435F;
    constexpr unsigned int mmUMCCH10_PerfMonCtl11                             = 0xD404362;
    constexpr unsigned int mmUMCCH10_PerfMonCtl12                             = 0xD404365;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0xD404340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0xD404346;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0xD404345;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0xD404349;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0xD404348;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0xD40434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0xD40434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0xD40434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0xD40434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0xD404352;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0xD404351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Hi                           = 0xD404355;
    constexpr unsigned int mmUMCCH10_PerfMonCtr6_Lo                           = 0xD404354;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Hi                           = 0xD404358;
    constexpr unsigned int mmUMCCH10_PerfMonCtr7_Lo                           = 0xD404357;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Hi                           = 0xD40435B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr8_Lo                           = 0xD40435A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Hi                           = 0xD40435E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr9_Lo                           = 0xD40435D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Hi                          = 0xD404361;
    constexpr unsigned int mmUMCCH10_PerfMonCtr10_Lo                          = 0xD404360;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Hi                          = 0xD404364;
    constexpr unsigned int mmUMCCH10_PerfMonCtr11_Lo                          = 0xD404363;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Hi                          = 0xD404367;
    constexpr unsigned int mmUMCCH10_PerfMonCtr12_Lo                          = 0xD404366;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0xD404342;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0xD404341;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0xD404744;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0xD404747;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0xD40474A;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0xD40474D;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0xD404750;
    constexpr unsigned int mmUMCCH11_PerfMonCtl6                              = 0xD404753;
    constexpr unsigned int mmUMCCH11_PerfMonCtl7                              = 0xD404756;
    constexpr unsigned int mmUMCCH11_PerfMonCtl8                              = 0xD404759;
    constexpr unsigned int mmUMCCH11_PerfMonCtl9                              = 0xD40475C;
    constexpr unsigned int mmUMCCH11_PerfMonCtl10                             = 0xD40475F;
    constexpr unsigned int mmUMCCH11_PerfMonCtl11                             = 0xD404762;
    constexpr unsigned int mmUMCCH11_PerfMonCtl12                             = 0xD404765;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0xD404740;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0xD404746;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0xD404745;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0xD404749;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0xD404748;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0xD40474C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0xD40474B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0xD40474F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0xD40474E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0xD404752;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0xD404751;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Hi                           = 0xD404755;
    constexpr unsigned int mmUMCCH11_PerfMonCtr6_Lo                           = 0xD404754;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Hi                           = 0xD404758;
    constexpr unsigned int mmUMCCH11_PerfMonCtr7_Lo                           = 0xD404757;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Hi                           = 0xD40475B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr8_Lo                           = 0xD40475A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Hi                           = 0xD40475E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr9_Lo                           = 0xD40475D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Hi                          = 0xD404761;
    constexpr unsigned int mmUMCCH11_PerfMonCtr10_Lo                          = 0xD404760;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Hi                          = 0xD404764;
    constexpr unsigned int mmUMCCH11_PerfMonCtr11_Lo                          = 0xD404763;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Hi                          = 0xD404767;
    constexpr unsigned int mmUMCCH11_PerfMonCtr12_Lo                          = 0xD404766;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0xD404742;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0xD404741;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0xDC00344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0xDC00347;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0xDC0034A;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0xDC0034D;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0xDC00350;
    constexpr unsigned int mmUMCCH12_PerfMonCtl6                              = 0xDC00353;
    constexpr unsigned int mmUMCCH12_PerfMonCtl7                              = 0xDC00356;
    constexpr unsigned int mmUMCCH12_PerfMonCtl8                              = 0xDC00359;
    constexpr unsigned int mmUMCCH12_PerfMonCtl9                              = 0xDC0035C;
    constexpr unsigned int mmUMCCH12_PerfMonCtl10                             = 0xDC0035F;
    constexpr unsigned int mmUMCCH12_PerfMonCtl11                             = 0xDC00362;
    constexpr unsigned int mmUMCCH12_PerfMonCtl12                             = 0xDC00365;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0xDC00340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0xDC00346;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0xDC00345;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0xDC00349;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0xDC00348;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0xDC0034C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0xDC0034B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0xDC0034F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0xDC0034E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0xDC00352;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0xDC00351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Hi                           = 0xDC00355;
    constexpr unsigned int mmUMCCH12_PerfMonCtr6_Lo                           = 0xDC00354;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Hi                           = 0xDC00358;
    constexpr unsigned int mmUMCCH12_PerfMonCtr7_Lo                           = 0xDC00357;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Hi                           = 0xDC0035B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr8_Lo                           = 0xDC0035A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Hi                           = 0xDC0035E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr9_Lo                           = 0xDC0035D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Hi                          = 0xDC00361;
    constexpr unsigned int mmUMCCH12_PerfMonCtr10_Lo                          = 0xDC00360;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Hi                          = 0xDC00364;
    constexpr unsigned int mmUMCCH12_PerfMonCtr11_Lo                          = 0xDC00363;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Hi                          = 0xDC00367;
    constexpr unsigned int mmUMCCH12_PerfMonCtr12_Lo                          = 0xDC00366;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0xDC00342;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0xDC00341;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0xDC00744;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0xDC00747;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0xDC0074A;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0xDC0074D;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0xDC00750;
    constexpr unsigned int mmUMCCH13_PerfMonCtl6                              = 0xDC00753;
    constexpr unsigned int mmUMCCH13_PerfMonCtl7                              = 0xDC00756;
    constexpr unsigned int mmUMCCH13_PerfMonCtl8                              = 0xDC00759;
    constexpr unsigned int mmUMCCH13_PerfMonCtl9                              = 0xDC0075C;
    constexpr unsigned int mmUMCCH13_PerfMonCtl10                             = 0xDC0075F;
    constexpr unsigned int mmUMCCH13_PerfMonCtl11                             = 0xDC00762;
    constexpr unsigned int mmUMCCH13_PerfMonCtl12                             = 0xDC00765;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0xDC00740;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0xDC00746;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0xDC00745;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0xDC00749;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0xDC00748;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0xDC0074C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0xDC0074B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0xDC0074F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0xDC0074E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0xDC00752;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0xDC00751;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Hi                           = 0xDC00755;
    constexpr unsigned int mmUMCCH13_PerfMonCtr6_Lo                           = 0xDC00754;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Hi                           = 0xDC00758;
    constexpr unsigned int mmUMCCH13_PerfMonCtr7_Lo                           = 0xDC00757;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Hi                           = 0xDC0075B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr8_Lo                           = 0xDC0075A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Hi                           = 0xDC0075E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr9_Lo                           = 0xDC0075D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Hi                          = 0xDC00761;
    constexpr unsigned int mmUMCCH13_PerfMonCtr10_Lo                          = 0xDC00760;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Hi                          = 0xDC00764;
    constexpr unsigned int mmUMCCH13_PerfMonCtr11_Lo                          = 0xDC00763;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Hi                          = 0xDC00767;
    constexpr unsigned int mmUMCCH13_PerfMonCtr12_Lo                          = 0xDC00766;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0xDC00742;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0xDC00741;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0xDC04344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0xDC04347;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0xDC0434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0xDC0434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0xDC04350;
    constexpr unsigned int mmUMCCH14_PerfMonCtl6                              = 0xDC04353;
    constexpr unsigned int mmUMCCH14_PerfMonCtl7                              = 0xDC04356;
    constexpr unsigned int mmUMCCH14_PerfMonCtl8                              = 0xDC04359;
    constexpr unsigned int mmUMCCH14_PerfMonCtl9                              = 0xDC0435C;
    constexpr unsigned int mmUMCCH14_PerfMonCtl10                             = 0xDC0435F;
    constexpr unsigned int mmUMCCH14_PerfMonCtl11                             = 0xDC04362;
    constexpr unsigned int mmUMCCH14_PerfMonCtl12                             = 0xDC04365;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0xDC04340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0xDC04346;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0xDC04345;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0xDC04349;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0xDC04348;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0xDC0434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0xDC0434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0xDC0434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0xDC0434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0xDC04352;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0xDC04351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Hi                           = 0xDC04355;
    constexpr unsigned int mmUMCCH14_PerfMonCtr6_Lo                           = 0xDC04354;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Hi                           = 0xDC04358;
    constexpr unsigned int mmUMCCH14_PerfMonCtr7_Lo                           = 0xDC04357;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Hi                           = 0xDC0435B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr8_Lo                           = 0xDC0435A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Hi                           = 0xDC0435E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr9_Lo                           = 0xDC0435D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Hi                          = 0xDC04361;
    constexpr unsigned int mmUMCCH14_PerfMonCtr10_Lo                          = 0xDC04360;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Hi                          = 0xDC04364;
    constexpr unsigned int mmUMCCH14_PerfMonCtr11_Lo                          = 0xDC04363;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Hi                          = 0xDC04367;
    constexpr unsigned int mmUMCCH14_PerfMonCtr12_Lo                          = 0xDC04366;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0xDC04342;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0xDC04341;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0xDC04744;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0xDC04747;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0xDC0474A;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0xDC0474D;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0xDC04750;
    constexpr unsigned int mmUMCCH15_PerfMonCtl6                              = 0xDC04753;
    constexpr unsigned int mmUMCCH15_PerfMonCtl7                              = 0xDC04756;
    constexpr unsigned int mmUMCCH15_PerfMonCtl8                              = 0xDC04759;
    constexpr unsigned int mmUMCCH15_PerfMonCtl9                              = 0xDC0475C;
    constexpr unsigned int mmUMCCH15_PerfMonCtl10                             = 0xDC0475F;
    constexpr unsigned int mmUMCCH15_PerfMonCtl11                             = 0xDC04762;
    constexpr unsigned int mmUMCCH15_PerfMonCtl12                             = 0xDC04765;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0xDC04740;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0xDC04746;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0xDC04745;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0xDC04749;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0xDC04748;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0xDC0474C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0xDC0474B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0xDC0474F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0xDC0474E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0xDC04752;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0xDC04751;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Hi                           = 0xDC04755;
    constexpr unsigned int mmUMCCH15_PerfMonCtr6_Lo                           = 0xDC04754;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Hi                           = 0xDC04758;
    constexpr unsigned int mmUMCCH15_PerfMonCtr7_Lo                           = 0xDC04757;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Hi                           = 0xDC0475B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr8_Lo                           = 0xDC0475A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Hi                           = 0xDC0475E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr9_Lo                           = 0xDC0475D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Hi                          = 0xDC04761;
    constexpr unsigned int mmUMCCH15_PerfMonCtr10_Lo                          = 0xDC04760;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Hi                          = 0xDC04764;
    constexpr unsigned int mmUMCCH15_PerfMonCtr11_Lo                          = 0xDC04763;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Hi                          = 0xDC04767;
    constexpr unsigned int mmUMCCH15_PerfMonCtr12_Lo                          = 0xDC04766;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0xDC04742;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0xDC04741;
} // namespace Nv32

namespace Nv33
{
    constexpr unsigned int mmPerfMonCtl1                                      = 0x14344;
    constexpr unsigned int mmPerfMonCtl2                                      = 0x14347;
    constexpr unsigned int mmPerfMonCtl3                                      = 0x1434A;
    constexpr unsigned int mmPerfMonCtl4                                      = 0x1434D;
    constexpr unsigned int mmPerfMonCtl5                                      = 0x14350;
    constexpr unsigned int mmPerfMonCtl6                                      = 0x14353;
    constexpr unsigned int mmPerfMonCtl7                                      = 0x14356;
    constexpr unsigned int mmPerfMonCtl8                                      = 0x14359;
    constexpr unsigned int mmPerfMonCtl9                                      = 0x1435C;
    constexpr unsigned int mmPerfMonCtl10                                     = 0x1435F;
    constexpr unsigned int mmPerfMonCtl11                                     = 0x14362;
    constexpr unsigned int mmPerfMonCtl12                                     = 0x14365;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x14346;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x14345;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x14349;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x14348;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434C;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434B;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x1434F;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x1434E;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14352;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14351;
    constexpr unsigned int mmPerfMonCtr6_Hi                                   = 0x14355;
    constexpr unsigned int mmPerfMonCtr6_Lo                                   = 0x14354;
    constexpr unsigned int mmPerfMonCtr7_Hi                                   = 0x14358;
    constexpr unsigned int mmPerfMonCtr7_Lo                                   = 0x14357;
    constexpr unsigned int mmPerfMonCtr8_Hi                                   = 0x1435B;
    constexpr unsigned int mmPerfMonCtr8_Lo                                   = 0x1435A;
    constexpr unsigned int mmPerfMonCtr9_Hi                                   = 0x1435E;
    constexpr unsigned int mmPerfMonCtr9_Lo                                   = 0x1435D;
    constexpr unsigned int mmPerfMonCtr10_Hi                                  = 0x14361;
    constexpr unsigned int mmPerfMonCtr10_Lo                                  = 0x14360;
    constexpr unsigned int mmPerfMonCtr11_Hi                                  = 0x14364;
    constexpr unsigned int mmPerfMonCtr11_Lo                                  = 0x14363;
    constexpr unsigned int mmPerfMonCtr12_Hi                                  = 0x14367;
    constexpr unsigned int mmPerfMonCtr12_Lo                                  = 0x14366;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14342;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14341;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0x14344;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0x14347;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0x1434A;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0x1434D;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0x14350;
    constexpr unsigned int mmUMCCH0_PerfMonCtl6                               = 0x14353;
    constexpr unsigned int mmUMCCH0_PerfMonCtl7                               = 0x14356;
    constexpr unsigned int mmUMCCH0_PerfMonCtl8                               = 0x14359;
    constexpr unsigned int mmUMCCH0_PerfMonCtl9                               = 0x1435C;
    constexpr unsigned int mmUMCCH0_PerfMonCtl10                              = 0x1435F;
    constexpr unsigned int mmUMCCH0_PerfMonCtl11                              = 0x14362;
    constexpr unsigned int mmUMCCH0_PerfMonCtl12                              = 0x14365;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0x14340;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0x14346;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0x14345;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0x14349;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0x14348;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0x1434C;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0x1434B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0x1434F;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0x1434E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0x14352;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0x14351;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Hi                            = 0x14355;
    constexpr unsigned int mmUMCCH0_PerfMonCtr6_Lo                            = 0x14354;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Hi                            = 0x14358;
    constexpr unsigned int mmUMCCH0_PerfMonCtr7_Lo                            = 0x14357;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Hi                            = 0x1435B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr8_Lo                            = 0x1435A;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Hi                            = 0x1435E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr9_Lo                            = 0x1435D;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Hi                           = 0x14361;
    constexpr unsigned int mmUMCCH0_PerfMonCtr10_Lo                           = 0x14360;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Hi                           = 0x14364;
    constexpr unsigned int mmUMCCH0_PerfMonCtr11_Lo                           = 0x14363;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Hi                           = 0x14367;
    constexpr unsigned int mmUMCCH0_PerfMonCtr12_Lo                           = 0x14366;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0x14342;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0x14341;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14744;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14747;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x1474A;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x1474D;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14750;
    constexpr unsigned int mmUMCCH1_PerfMonCtl6                               = 0x14753;
    constexpr unsigned int mmUMCCH1_PerfMonCtl7                               = 0x14756;
    constexpr unsigned int mmUMCCH1_PerfMonCtl8                               = 0x14759;
    constexpr unsigned int mmUMCCH1_PerfMonCtl9                               = 0x1475C;
    constexpr unsigned int mmUMCCH1_PerfMonCtl10                              = 0x1475F;
    constexpr unsigned int mmUMCCH1_PerfMonCtl11                              = 0x14762;
    constexpr unsigned int mmUMCCH1_PerfMonCtl12                              = 0x14765;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14740;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14746;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14745;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14749;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14748;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x1474C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x1474B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x1474F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x1474E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14752;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14751;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Hi                            = 0x14755;
    constexpr unsigned int mmUMCCH1_PerfMonCtr6_Lo                            = 0x14754;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Hi                            = 0x14758;
    constexpr unsigned int mmUMCCH1_PerfMonCtr7_Lo                            = 0x14757;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Hi                            = 0x1475B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr8_Lo                            = 0x1475A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Hi                            = 0x1475E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr9_Lo                            = 0x1475D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Hi                           = 0x14761;
    constexpr unsigned int mmUMCCH1_PerfMonCtr10_Lo                           = 0x14760;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Hi                           = 0x14764;
    constexpr unsigned int mmUMCCH1_PerfMonCtr11_Lo                           = 0x14763;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Hi                           = 0x14767;
    constexpr unsigned int mmUMCCH1_PerfMonCtr12_Lo                           = 0x14766;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14742;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14741;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0x54344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0x54347;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0x5434A;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0x5434D;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0x54350;
    constexpr unsigned int mmUMCCH2_PerfMonCtl6                               = 0x54353;
    constexpr unsigned int mmUMCCH2_PerfMonCtl7                               = 0x54356;
    constexpr unsigned int mmUMCCH2_PerfMonCtl8                               = 0x54359;
    constexpr unsigned int mmUMCCH2_PerfMonCtl9                               = 0x5435C;
    constexpr unsigned int mmUMCCH2_PerfMonCtl10                              = 0x5435F;
    constexpr unsigned int mmUMCCH2_PerfMonCtl11                              = 0x54362;
    constexpr unsigned int mmUMCCH2_PerfMonCtl12                              = 0x54365;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0x54340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0x54346;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0x54345;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0x54349;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0x54348;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0x5434C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0x5434B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0x5434F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0x5434E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0x54352;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0x54351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Hi                            = 0x54355;
    constexpr unsigned int mmUMCCH2_PerfMonCtr6_Lo                            = 0x54354;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Hi                            = 0x54358;
    constexpr unsigned int mmUMCCH2_PerfMonCtr7_Lo                            = 0x54357;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Hi                            = 0x5435B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr8_Lo                            = 0x5435A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Hi                            = 0x5435E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr9_Lo                            = 0x5435D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Hi                           = 0x54361;
    constexpr unsigned int mmUMCCH2_PerfMonCtr10_Lo                           = 0x54360;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Hi                           = 0x54364;
    constexpr unsigned int mmUMCCH2_PerfMonCtr11_Lo                           = 0x54363;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Hi                           = 0x54367;
    constexpr unsigned int mmUMCCH2_PerfMonCtr12_Lo                           = 0x54366;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0x54342;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0x54341;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54744;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54747;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x5474A;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x5474D;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54750;
    constexpr unsigned int mmUMCCH3_PerfMonCtl6                               = 0x54753;
    constexpr unsigned int mmUMCCH3_PerfMonCtl7                               = 0x54756;
    constexpr unsigned int mmUMCCH3_PerfMonCtl8                               = 0x54759;
    constexpr unsigned int mmUMCCH3_PerfMonCtl9                               = 0x5475C;
    constexpr unsigned int mmUMCCH3_PerfMonCtl10                              = 0x5475F;
    constexpr unsigned int mmUMCCH3_PerfMonCtl11                              = 0x54762;
    constexpr unsigned int mmUMCCH3_PerfMonCtl12                              = 0x54765;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54740;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x54746;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x54745;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x54749;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x54748;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x5474C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x5474B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x5474F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x5474E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54752;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54751;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Hi                            = 0x54755;
    constexpr unsigned int mmUMCCH3_PerfMonCtr6_Lo                            = 0x54754;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Hi                            = 0x54758;
    constexpr unsigned int mmUMCCH3_PerfMonCtr7_Lo                            = 0x54757;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Hi                            = 0x5475B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr8_Lo                            = 0x5475A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Hi                            = 0x5475E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr9_Lo                            = 0x5475D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Hi                           = 0x54761;
    constexpr unsigned int mmUMCCH3_PerfMonCtr10_Lo                           = 0x54760;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Hi                           = 0x54764;
    constexpr unsigned int mmUMCCH3_PerfMonCtr11_Lo                           = 0x54763;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Hi                           = 0x54767;
    constexpr unsigned int mmUMCCH3_PerfMonCtr12_Lo                           = 0x54766;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54742;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54741;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94347;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtl6                               = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtl7                               = 0x94356;
    constexpr unsigned int mmUMCCH4_PerfMonCtl8                               = 0x94359;
    constexpr unsigned int mmUMCCH4_PerfMonCtl9                               = 0x9435C;
    constexpr unsigned int mmUMCCH4_PerfMonCtl10                              = 0x9435F;
    constexpr unsigned int mmUMCCH4_PerfMonCtl11                              = 0x94362;
    constexpr unsigned int mmUMCCH4_PerfMonCtl12                              = 0x94365;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x94346;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x94348;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Hi                            = 0x94355;
    constexpr unsigned int mmUMCCH4_PerfMonCtr6_Lo                            = 0x94354;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Hi                            = 0x94358;
    constexpr unsigned int mmUMCCH4_PerfMonCtr7_Lo                            = 0x94357;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Hi                            = 0x9435B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr8_Lo                            = 0x9435A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Hi                            = 0x9435E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr9_Lo                            = 0x9435D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Hi                           = 0x94361;
    constexpr unsigned int mmUMCCH4_PerfMonCtr10_Lo                           = 0x94360;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Hi                           = 0x94364;
    constexpr unsigned int mmUMCCH4_PerfMonCtr11_Lo                           = 0x94363;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Hi                           = 0x94367;
    constexpr unsigned int mmUMCCH4_PerfMonCtr12_Lo                           = 0x94366;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94341;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94744;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94747;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x9474A;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x9474D;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94750;
    constexpr unsigned int mmUMCCH5_PerfMonCtl6                               = 0x94753;
    constexpr unsigned int mmUMCCH5_PerfMonCtl7                               = 0x94756;
    constexpr unsigned int mmUMCCH5_PerfMonCtl8                               = 0x94759;
    constexpr unsigned int mmUMCCH5_PerfMonCtl9                               = 0x9475C;
    constexpr unsigned int mmUMCCH5_PerfMonCtl10                              = 0x9475F;
    constexpr unsigned int mmUMCCH5_PerfMonCtl11                              = 0x94762;
    constexpr unsigned int mmUMCCH5_PerfMonCtl12                              = 0x94765;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94740;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x94746;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x94745;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x94749;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x94748;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x9474C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x9474B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x9474F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x9474E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94752;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94751;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Hi                            = 0x94755;
    constexpr unsigned int mmUMCCH5_PerfMonCtr6_Lo                            = 0x94754;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Hi                            = 0x94758;
    constexpr unsigned int mmUMCCH5_PerfMonCtr7_Lo                            = 0x94757;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Hi                            = 0x9475B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr8_Lo                            = 0x9475A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Hi                            = 0x9475E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr9_Lo                            = 0x9475D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Hi                           = 0x94761;
    constexpr unsigned int mmUMCCH5_PerfMonCtr10_Lo                           = 0x94760;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Hi                           = 0x94764;
    constexpr unsigned int mmUMCCH5_PerfMonCtr11_Lo                           = 0x94763;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Hi                           = 0x94767;
    constexpr unsigned int mmUMCCH5_PerfMonCtr12_Lo                           = 0x94766;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94742;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94741;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4347;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtl6                               = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtl7                               = 0xD4356;
    constexpr unsigned int mmUMCCH6_PerfMonCtl8                               = 0xD4359;
    constexpr unsigned int mmUMCCH6_PerfMonCtl9                               = 0xD435C;
    constexpr unsigned int mmUMCCH6_PerfMonCtl10                              = 0xD435F;
    constexpr unsigned int mmUMCCH6_PerfMonCtl11                              = 0xD4362;
    constexpr unsigned int mmUMCCH6_PerfMonCtl12                              = 0xD4365;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD4346;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD4348;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Hi                            = 0xD4355;
    constexpr unsigned int mmUMCCH6_PerfMonCtr6_Lo                            = 0xD4354;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Hi                            = 0xD4358;
    constexpr unsigned int mmUMCCH6_PerfMonCtr7_Lo                            = 0xD4357;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Hi                            = 0xD435B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr8_Lo                            = 0xD435A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Hi                            = 0xD435E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr9_Lo                            = 0xD435D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Hi                           = 0xD4361;
    constexpr unsigned int mmUMCCH6_PerfMonCtr10_Lo                           = 0xD4360;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Hi                           = 0xD4364;
    constexpr unsigned int mmUMCCH6_PerfMonCtr11_Lo                           = 0xD4363;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Hi                           = 0xD4367;
    constexpr unsigned int mmUMCCH6_PerfMonCtr12_Lo                           = 0xD4366;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4341;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4744;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4747;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD474A;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD474D;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4750;
    constexpr unsigned int mmUMCCH7_PerfMonCtl6                               = 0xD4753;
    constexpr unsigned int mmUMCCH7_PerfMonCtl7                               = 0xD4756;
    constexpr unsigned int mmUMCCH7_PerfMonCtl8                               = 0xD4759;
    constexpr unsigned int mmUMCCH7_PerfMonCtl9                               = 0xD475C;
    constexpr unsigned int mmUMCCH7_PerfMonCtl10                              = 0xD475F;
    constexpr unsigned int mmUMCCH7_PerfMonCtl11                              = 0xD4762;
    constexpr unsigned int mmUMCCH7_PerfMonCtl12                              = 0xD4765;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4740;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD4746;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD4745;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD4749;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD4748;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD474C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD474B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD474F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD474E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4752;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4751;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Hi                            = 0xD4755;
    constexpr unsigned int mmUMCCH7_PerfMonCtr6_Lo                            = 0xD4754;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Hi                            = 0xD4758;
    constexpr unsigned int mmUMCCH7_PerfMonCtr7_Lo                            = 0xD4757;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Hi                            = 0xD475B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr8_Lo                            = 0xD475A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Hi                            = 0xD475E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr9_Lo                            = 0xD475D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Hi                           = 0xD4761;
    constexpr unsigned int mmUMCCH7_PerfMonCtr10_Lo                           = 0xD4760;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Hi                           = 0xD4764;
    constexpr unsigned int mmUMCCH7_PerfMonCtr11_Lo                           = 0xD4763;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Hi                           = 0xD4767;
    constexpr unsigned int mmUMCCH7_PerfMonCtr12_Lo                           = 0xD4766;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4742;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4741;
} // namespace Nv33

namespace Nv3x
{
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI                             = 0xD3C9;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO                             = 0xD3C8;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT                         = 0xDBC6;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1                        = 0xDBC7;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI                             = 0xD3CB;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO                             = 0xD3CA;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT                         = 0xDBC8;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI                             = 0xD3CD;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO                             = 0xD3CC;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT                         = 0xDBC9;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI                             = 0xD3CF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO                             = 0xD3CE;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT                         = 0xDBCA;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI                          = 0xD04A;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO                          = 0xD049;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT                      = 0xD844;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG                             = 0xDE03;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG                             = 0xDE04;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI                              = 0xD641;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO                              = 0xD640;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE                            = 0xDE02;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT                          = 0xDE00;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1                         = 0xDE01;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI                               = 0xD643;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO                               = 0xD642;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL                        = 0xDE05;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0C82;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0C83;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0C84;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0C85;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0C81;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0C80;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0C86;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0C7E;
    constexpr unsigned int mmSDMA1_PERFCNT_MISC_CNTL                          = 0xDE2F;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER0_CFG                   = 0xDE2C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER1_CFG                   = 0xDE2D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_HI                     = 0xD66D;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_LO                     = 0xD66C;
    constexpr unsigned int mmSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL              = 0xDE2E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0xD66F;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0xD66E;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0xDE30;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0xDE31;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0xD671;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0xD670;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0xDE32;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0xDE33;
} // namespace Nv3x

namespace Phx1
{
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0CE8;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0CE9;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0CEA;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0CEB;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0CEE;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0CEF;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0CEC;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CED;
} // namespace Phx1

namespace Phx2
{
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0CE8;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0CE9;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0CEA;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0CEB;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0CEE;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0CEF;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0CEC;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CED;
} // namespace Phx2

namespace Raphael
{
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi8                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi9                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi10                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi11                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi12                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi13                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi14                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi15                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo8                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo9                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo10                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo11                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo12                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo13                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo14                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo15                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi8                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi9                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi10                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi11                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi12                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi13                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi14                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi15                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo8                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo9                         = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo10                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo11                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo12                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo13                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo14                        = 0x0001;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo15                        = 0x0001;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
} // namespace Raphael

namespace Rembrandt
{
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x7511;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x7515;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x7519;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x751D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x7621;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x7623;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x7625;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x7627;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x7510;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x7514;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x7518;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x751C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x7620;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x7622;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x7624;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x7626;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x7513;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x7517;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x751B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x751F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x75E5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x75E7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x75E9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x75EB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x7512;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x7516;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x751A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x751E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x75E4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x75E6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x75E8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x75EA;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0x31DE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0x31DF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0x31E0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0x31E1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0x31E8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0x31E9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0x31EA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0x31EB;
} // namespace Rembrandt

#if CHIP_HDR_STRIX_HALO
namespace StxH
{
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x12400C81;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x12400C83;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x12400C85;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x12400C87;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x12400C89;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x12400C8B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x12400C8D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x12400C8F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x12400C80;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x12400C82;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x12400C84;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x12400C86;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x12400C88;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x12400C8A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x12400C8C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x12400C8E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x12400CC1;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x12400CC3;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x12400CC5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x12400CC7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x12400CC9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x12400CCB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x12400CCD;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x12400CCF;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x12400CC0;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x12400CC2;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x12400CC4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x12400CC6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x12400CC8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x12400CCA;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x12400CCC;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x12400CCE;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI                          = 0xD04A;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO                          = 0xD049;
    constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT                      = 0xD844;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x16343;
} // namespace StxH
#endif

} // inline namespace Chip
} // namespace Gfx9
} // namespace Pal
