/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

namespace Pal
{
namespace Gfx9
{
inline namespace Chip
{
typedef union ATC_PERFCOUNTER0_CFG                               regATC_PERFCOUNTER0_CFG;
typedef union ATC_PERFCOUNTER1_CFG                               regATC_PERFCOUNTER1_CFG;
typedef union ATC_PERFCOUNTER2_CFG                               regATC_PERFCOUNTER2_CFG;
typedef union ATC_PERFCOUNTER3_CFG                               regATC_PERFCOUNTER3_CFG;
typedef union ATC_PERFCOUNTER_HI                                 regATC_PERFCOUNTER_HI;
typedef union ATC_PERFCOUNTER_LO                                 regATC_PERFCOUNTER_LO;
typedef union ATC_PERFCOUNTER_RSLT_CNTL                          regATC_PERFCOUNTER_RSLT_CNTL;
typedef union CB_BLEND0_CONTROL                                  regCB_BLEND0_CONTROL;
typedef union CB_BLEND1_CONTROL                                  regCB_BLEND1_CONTROL;
typedef union CB_BLEND2_CONTROL                                  regCB_BLEND2_CONTROL;
typedef union CB_BLEND3_CONTROL                                  regCB_BLEND3_CONTROL;
typedef union CB_BLEND4_CONTROL                                  regCB_BLEND4_CONTROL;
typedef union CB_BLEND5_CONTROL                                  regCB_BLEND5_CONTROL;
typedef union CB_BLEND6_CONTROL                                  regCB_BLEND6_CONTROL;
typedef union CB_BLEND7_CONTROL                                  regCB_BLEND7_CONTROL;
typedef union CB_BLEND_ALPHA                                     regCB_BLEND_ALPHA;
typedef union CB_BLEND_BLUE                                      regCB_BLEND_BLUE;
typedef union CB_BLEND_GREEN                                     regCB_BLEND_GREEN;
typedef union CB_BLEND_RED                                       regCB_BLEND_RED;
typedef union CB_CACHE_EVICT_POINTS                              regCB_CACHE_EVICT_POINTS;
typedef union CB_CGTT_SCLK_CTRL                                  regCB_CGTT_SCLK_CTRL;
typedef union CB_CGTT_SCLK_CTRL1                                 regCB_CGTT_SCLK_CTRL1;
typedef union CB_COLOR0_ATTRIB                                   regCB_COLOR0_ATTRIB;
typedef union CB_COLOR0_ATTRIB2                                  regCB_COLOR0_ATTRIB2;
typedef union CB_COLOR0_ATTRIB3                                  regCB_COLOR0_ATTRIB3;
typedef union CB_COLOR0_BASE                                     regCB_COLOR0_BASE;
typedef union CB_COLOR0_BASE_EXT                                 regCB_COLOR0_BASE_EXT;
typedef union CB_COLOR0_CLEAR_WORD0                              regCB_COLOR0_CLEAR_WORD0;
typedef union CB_COLOR0_CLEAR_WORD1                              regCB_COLOR0_CLEAR_WORD1;
typedef union CB_COLOR0_CMASK                                    regCB_COLOR0_CMASK;
typedef union CB_COLOR0_CMASK_BASE_EXT                           regCB_COLOR0_CMASK_BASE_EXT;
typedef union CB_COLOR0_CMASK_SLICE                              regCB_COLOR0_CMASK_SLICE;
typedef union CB_COLOR0_DCC_BASE                                 regCB_COLOR0_DCC_BASE;
typedef union CB_COLOR0_DCC_BASE_EXT                             regCB_COLOR0_DCC_BASE_EXT;
typedef union CB_COLOR0_DCC_CONTROL                              regCB_COLOR0_DCC_CONTROL;
typedef union CB_COLOR0_FMASK                                    regCB_COLOR0_FMASK;
typedef union CB_COLOR0_FMASK_BASE_EXT                           regCB_COLOR0_FMASK_BASE_EXT;
typedef union CB_COLOR0_FMASK_SLICE                              regCB_COLOR0_FMASK_SLICE;
typedef union CB_COLOR0_INFO                                     regCB_COLOR0_INFO;
typedef union CB_COLOR0_PITCH                                    regCB_COLOR0_PITCH;
typedef union CB_COLOR0_SLICE                                    regCB_COLOR0_SLICE;
typedef union CB_COLOR0_VIEW                                     regCB_COLOR0_VIEW;
typedef union CB_COLOR1_ATTRIB                                   regCB_COLOR1_ATTRIB;
typedef union CB_COLOR1_ATTRIB2                                  regCB_COLOR1_ATTRIB2;
typedef union CB_COLOR1_ATTRIB3                                  regCB_COLOR1_ATTRIB3;
typedef union CB_COLOR1_BASE                                     regCB_COLOR1_BASE;
typedef union CB_COLOR1_BASE_EXT                                 regCB_COLOR1_BASE_EXT;
typedef union CB_COLOR1_CLEAR_WORD0                              regCB_COLOR1_CLEAR_WORD0;
typedef union CB_COLOR1_CLEAR_WORD1                              regCB_COLOR1_CLEAR_WORD1;
typedef union CB_COLOR1_CMASK                                    regCB_COLOR1_CMASK;
typedef union CB_COLOR1_CMASK_BASE_EXT                           regCB_COLOR1_CMASK_BASE_EXT;
typedef union CB_COLOR1_CMASK_SLICE                              regCB_COLOR1_CMASK_SLICE;
typedef union CB_COLOR1_DCC_BASE                                 regCB_COLOR1_DCC_BASE;
typedef union CB_COLOR1_DCC_BASE_EXT                             regCB_COLOR1_DCC_BASE_EXT;
typedef union CB_COLOR1_DCC_CONTROL                              regCB_COLOR1_DCC_CONTROL;
typedef union CB_COLOR1_FMASK                                    regCB_COLOR1_FMASK;
typedef union CB_COLOR1_FMASK_BASE_EXT                           regCB_COLOR1_FMASK_BASE_EXT;
typedef union CB_COLOR1_FMASK_SLICE                              regCB_COLOR1_FMASK_SLICE;
typedef union CB_COLOR1_INFO                                     regCB_COLOR1_INFO;
typedef union CB_COLOR1_PITCH                                    regCB_COLOR1_PITCH;
typedef union CB_COLOR1_SLICE                                    regCB_COLOR1_SLICE;
typedef union CB_COLOR1_VIEW                                     regCB_COLOR1_VIEW;
typedef union CB_COLOR2_ATTRIB                                   regCB_COLOR2_ATTRIB;
typedef union CB_COLOR2_ATTRIB2                                  regCB_COLOR2_ATTRIB2;
typedef union CB_COLOR2_ATTRIB3                                  regCB_COLOR2_ATTRIB3;
typedef union CB_COLOR2_BASE                                     regCB_COLOR2_BASE;
typedef union CB_COLOR2_BASE_EXT                                 regCB_COLOR2_BASE_EXT;
typedef union CB_COLOR2_CLEAR_WORD0                              regCB_COLOR2_CLEAR_WORD0;
typedef union CB_COLOR2_CLEAR_WORD1                              regCB_COLOR2_CLEAR_WORD1;
typedef union CB_COLOR2_CMASK                                    regCB_COLOR2_CMASK;
typedef union CB_COLOR2_CMASK_BASE_EXT                           regCB_COLOR2_CMASK_BASE_EXT;
typedef union CB_COLOR2_CMASK_SLICE                              regCB_COLOR2_CMASK_SLICE;
typedef union CB_COLOR2_DCC_BASE                                 regCB_COLOR2_DCC_BASE;
typedef union CB_COLOR2_DCC_BASE_EXT                             regCB_COLOR2_DCC_BASE_EXT;
typedef union CB_COLOR2_DCC_CONTROL                              regCB_COLOR2_DCC_CONTROL;
typedef union CB_COLOR2_FMASK                                    regCB_COLOR2_FMASK;
typedef union CB_COLOR2_FMASK_BASE_EXT                           regCB_COLOR2_FMASK_BASE_EXT;
typedef union CB_COLOR2_FMASK_SLICE                              regCB_COLOR2_FMASK_SLICE;
typedef union CB_COLOR2_INFO                                     regCB_COLOR2_INFO;
typedef union CB_COLOR2_PITCH                                    regCB_COLOR2_PITCH;
typedef union CB_COLOR2_SLICE                                    regCB_COLOR2_SLICE;
typedef union CB_COLOR2_VIEW                                     regCB_COLOR2_VIEW;
typedef union CB_COLOR3_ATTRIB                                   regCB_COLOR3_ATTRIB;
typedef union CB_COLOR3_ATTRIB2                                  regCB_COLOR3_ATTRIB2;
typedef union CB_COLOR3_ATTRIB3                                  regCB_COLOR3_ATTRIB3;
typedef union CB_COLOR3_BASE                                     regCB_COLOR3_BASE;
typedef union CB_COLOR3_BASE_EXT                                 regCB_COLOR3_BASE_EXT;
typedef union CB_COLOR3_CLEAR_WORD0                              regCB_COLOR3_CLEAR_WORD0;
typedef union CB_COLOR3_CLEAR_WORD1                              regCB_COLOR3_CLEAR_WORD1;
typedef union CB_COLOR3_CMASK                                    regCB_COLOR3_CMASK;
typedef union CB_COLOR3_CMASK_BASE_EXT                           regCB_COLOR3_CMASK_BASE_EXT;
typedef union CB_COLOR3_CMASK_SLICE                              regCB_COLOR3_CMASK_SLICE;
typedef union CB_COLOR3_DCC_BASE                                 regCB_COLOR3_DCC_BASE;
typedef union CB_COLOR3_DCC_BASE_EXT                             regCB_COLOR3_DCC_BASE_EXT;
typedef union CB_COLOR3_DCC_CONTROL                              regCB_COLOR3_DCC_CONTROL;
typedef union CB_COLOR3_FMASK                                    regCB_COLOR3_FMASK;
typedef union CB_COLOR3_FMASK_BASE_EXT                           regCB_COLOR3_FMASK_BASE_EXT;
typedef union CB_COLOR3_FMASK_SLICE                              regCB_COLOR3_FMASK_SLICE;
typedef union CB_COLOR3_INFO                                     regCB_COLOR3_INFO;
typedef union CB_COLOR3_PITCH                                    regCB_COLOR3_PITCH;
typedef union CB_COLOR3_SLICE                                    regCB_COLOR3_SLICE;
typedef union CB_COLOR3_VIEW                                     regCB_COLOR3_VIEW;
typedef union CB_COLOR4_ATTRIB                                   regCB_COLOR4_ATTRIB;
typedef union CB_COLOR4_ATTRIB2                                  regCB_COLOR4_ATTRIB2;
typedef union CB_COLOR4_ATTRIB3                                  regCB_COLOR4_ATTRIB3;
typedef union CB_COLOR4_BASE                                     regCB_COLOR4_BASE;
typedef union CB_COLOR4_BASE_EXT                                 regCB_COLOR4_BASE_EXT;
typedef union CB_COLOR4_CLEAR_WORD0                              regCB_COLOR4_CLEAR_WORD0;
typedef union CB_COLOR4_CLEAR_WORD1                              regCB_COLOR4_CLEAR_WORD1;
typedef union CB_COLOR4_CMASK                                    regCB_COLOR4_CMASK;
typedef union CB_COLOR4_CMASK_BASE_EXT                           regCB_COLOR4_CMASK_BASE_EXT;
typedef union CB_COLOR4_CMASK_SLICE                              regCB_COLOR4_CMASK_SLICE;
typedef union CB_COLOR4_DCC_BASE                                 regCB_COLOR4_DCC_BASE;
typedef union CB_COLOR4_DCC_BASE_EXT                             regCB_COLOR4_DCC_BASE_EXT;
typedef union CB_COLOR4_DCC_CONTROL                              regCB_COLOR4_DCC_CONTROL;
typedef union CB_COLOR4_FMASK                                    regCB_COLOR4_FMASK;
typedef union CB_COLOR4_FMASK_BASE_EXT                           regCB_COLOR4_FMASK_BASE_EXT;
typedef union CB_COLOR4_FMASK_SLICE                              regCB_COLOR4_FMASK_SLICE;
typedef union CB_COLOR4_INFO                                     regCB_COLOR4_INFO;
typedef union CB_COLOR4_PITCH                                    regCB_COLOR4_PITCH;
typedef union CB_COLOR4_SLICE                                    regCB_COLOR4_SLICE;
typedef union CB_COLOR4_VIEW                                     regCB_COLOR4_VIEW;
typedef union CB_COLOR5_ATTRIB                                   regCB_COLOR5_ATTRIB;
typedef union CB_COLOR5_ATTRIB2                                  regCB_COLOR5_ATTRIB2;
typedef union CB_COLOR5_ATTRIB3                                  regCB_COLOR5_ATTRIB3;
typedef union CB_COLOR5_BASE                                     regCB_COLOR5_BASE;
typedef union CB_COLOR5_BASE_EXT                                 regCB_COLOR5_BASE_EXT;
typedef union CB_COLOR5_CLEAR_WORD0                              regCB_COLOR5_CLEAR_WORD0;
typedef union CB_COLOR5_CLEAR_WORD1                              regCB_COLOR5_CLEAR_WORD1;
typedef union CB_COLOR5_CMASK                                    regCB_COLOR5_CMASK;
typedef union CB_COLOR5_CMASK_BASE_EXT                           regCB_COLOR5_CMASK_BASE_EXT;
typedef union CB_COLOR5_CMASK_SLICE                              regCB_COLOR5_CMASK_SLICE;
typedef union CB_COLOR5_DCC_BASE                                 regCB_COLOR5_DCC_BASE;
typedef union CB_COLOR5_DCC_BASE_EXT                             regCB_COLOR5_DCC_BASE_EXT;
typedef union CB_COLOR5_DCC_CONTROL                              regCB_COLOR5_DCC_CONTROL;
typedef union CB_COLOR5_FMASK                                    regCB_COLOR5_FMASK;
typedef union CB_COLOR5_FMASK_BASE_EXT                           regCB_COLOR5_FMASK_BASE_EXT;
typedef union CB_COLOR5_FMASK_SLICE                              regCB_COLOR5_FMASK_SLICE;
typedef union CB_COLOR5_INFO                                     regCB_COLOR5_INFO;
typedef union CB_COLOR5_PITCH                                    regCB_COLOR5_PITCH;
typedef union CB_COLOR5_SLICE                                    regCB_COLOR5_SLICE;
typedef union CB_COLOR5_VIEW                                     regCB_COLOR5_VIEW;
typedef union CB_COLOR6_ATTRIB                                   regCB_COLOR6_ATTRIB;
typedef union CB_COLOR6_ATTRIB2                                  regCB_COLOR6_ATTRIB2;
typedef union CB_COLOR6_ATTRIB3                                  regCB_COLOR6_ATTRIB3;
typedef union CB_COLOR6_BASE                                     regCB_COLOR6_BASE;
typedef union CB_COLOR6_BASE_EXT                                 regCB_COLOR6_BASE_EXT;
typedef union CB_COLOR6_CLEAR_WORD0                              regCB_COLOR6_CLEAR_WORD0;
typedef union CB_COLOR6_CLEAR_WORD1                              regCB_COLOR6_CLEAR_WORD1;
typedef union CB_COLOR6_CMASK                                    regCB_COLOR6_CMASK;
typedef union CB_COLOR6_CMASK_BASE_EXT                           regCB_COLOR6_CMASK_BASE_EXT;
typedef union CB_COLOR6_CMASK_SLICE                              regCB_COLOR6_CMASK_SLICE;
typedef union CB_COLOR6_DCC_BASE                                 regCB_COLOR6_DCC_BASE;
typedef union CB_COLOR6_DCC_BASE_EXT                             regCB_COLOR6_DCC_BASE_EXT;
typedef union CB_COLOR6_DCC_CONTROL                              regCB_COLOR6_DCC_CONTROL;
typedef union CB_COLOR6_FMASK                                    regCB_COLOR6_FMASK;
typedef union CB_COLOR6_FMASK_BASE_EXT                           regCB_COLOR6_FMASK_BASE_EXT;
typedef union CB_COLOR6_FMASK_SLICE                              regCB_COLOR6_FMASK_SLICE;
typedef union CB_COLOR6_INFO                                     regCB_COLOR6_INFO;
typedef union CB_COLOR6_PITCH                                    regCB_COLOR6_PITCH;
typedef union CB_COLOR6_SLICE                                    regCB_COLOR6_SLICE;
typedef union CB_COLOR6_VIEW                                     regCB_COLOR6_VIEW;
typedef union CB_COLOR7_ATTRIB                                   regCB_COLOR7_ATTRIB;
typedef union CB_COLOR7_ATTRIB2                                  regCB_COLOR7_ATTRIB2;
typedef union CB_COLOR7_ATTRIB3                                  regCB_COLOR7_ATTRIB3;
typedef union CB_COLOR7_BASE                                     regCB_COLOR7_BASE;
typedef union CB_COLOR7_BASE_EXT                                 regCB_COLOR7_BASE_EXT;
typedef union CB_COLOR7_CLEAR_WORD0                              regCB_COLOR7_CLEAR_WORD0;
typedef union CB_COLOR7_CLEAR_WORD1                              regCB_COLOR7_CLEAR_WORD1;
typedef union CB_COLOR7_CMASK                                    regCB_COLOR7_CMASK;
typedef union CB_COLOR7_CMASK_BASE_EXT                           regCB_COLOR7_CMASK_BASE_EXT;
typedef union CB_COLOR7_CMASK_SLICE                              regCB_COLOR7_CMASK_SLICE;
typedef union CB_COLOR7_DCC_BASE                                 regCB_COLOR7_DCC_BASE;
typedef union CB_COLOR7_DCC_BASE_EXT                             regCB_COLOR7_DCC_BASE_EXT;
typedef union CB_COLOR7_DCC_CONTROL                              regCB_COLOR7_DCC_CONTROL;
typedef union CB_COLOR7_FMASK                                    regCB_COLOR7_FMASK;
typedef union CB_COLOR7_FMASK_BASE_EXT                           regCB_COLOR7_FMASK_BASE_EXT;
typedef union CB_COLOR7_FMASK_SLICE                              regCB_COLOR7_FMASK_SLICE;
typedef union CB_COLOR7_INFO                                     regCB_COLOR7_INFO;
typedef union CB_COLOR7_PITCH                                    regCB_COLOR7_PITCH;
typedef union CB_COLOR7_SLICE                                    regCB_COLOR7_SLICE;
typedef union CB_COLOR7_VIEW                                     regCB_COLOR7_VIEW;
typedef union CB_COLOR_CONTROL                                   regCB_COLOR_CONTROL;
typedef union CB_COVERAGE_OUT_CONTROL                            regCB_COVERAGE_OUT_CONTROL;
typedef union CB_DCC_CONFIG                                      regCB_DCC_CONFIG;
typedef union CB_DCC_CONFIG2                                     regCB_DCC_CONFIG2;
typedef union CB_DCC_CONTROL                                     regCB_DCC_CONTROL;
typedef union CB_FDCC_CONTROL                                    regCB_FDCC_CONTROL;
typedef union CB_FGCG_SRAM_OVERRIDE                              regCB_FGCG_SRAM_OVERRIDE;
typedef union CB_HW_CONTROL                                      regCB_HW_CONTROL;
typedef union CB_HW_CONTROL_1                                    regCB_HW_CONTROL_1;
typedef union CB_HW_CONTROL_2                                    regCB_HW_CONTROL_2;
typedef union CB_HW_CONTROL_3                                    regCB_HW_CONTROL_3;
typedef union CB_HW_CONTROL_4                                    regCB_HW_CONTROL_4;
typedef union CB_HW_MEM_ARBITER_RD                               regCB_HW_MEM_ARBITER_RD;
typedef union CB_HW_MEM_ARBITER_WR                               regCB_HW_MEM_ARBITER_WR;
typedef union CB_KEY_OVERRIDE_0                                  regCB_KEY_OVERRIDE_0;
typedef union CB_KEY_OVERRIDE_1                                  regCB_KEY_OVERRIDE_1;
typedef union CB_KEY_OVERRIDE_2                                  regCB_KEY_OVERRIDE_2;
typedef union CB_KEY_OVERRIDE_3                                  regCB_KEY_OVERRIDE_3;
typedef union CB_KEY_OVERRIDE_4                                  regCB_KEY_OVERRIDE_4;
typedef union CB_KEY_OVERRIDE_5                                  regCB_KEY_OVERRIDE_5;
typedef union CB_KEY_OVERRIDE_6                                  regCB_KEY_OVERRIDE_6;
typedef union CB_KEY_OVERRIDE_7                                  regCB_KEY_OVERRIDE_7;
typedef union CB_PERFCOUNTER0_HI                                 regCB_PERFCOUNTER0_HI;
typedef union CB_PERFCOUNTER0_LO                                 regCB_PERFCOUNTER0_LO;
typedef union CB_PERFCOUNTER0_SELECT                             regCB_PERFCOUNTER0_SELECT;
typedef union CB_PERFCOUNTER0_SELECT1                            regCB_PERFCOUNTER0_SELECT1;
typedef union CB_PERFCOUNTER1_HI                                 regCB_PERFCOUNTER1_HI;
typedef union CB_PERFCOUNTER1_LO                                 regCB_PERFCOUNTER1_LO;
typedef union CB_PERFCOUNTER1_SELECT                             regCB_PERFCOUNTER1_SELECT;
typedef union CB_PERFCOUNTER2_HI                                 regCB_PERFCOUNTER2_HI;
typedef union CB_PERFCOUNTER2_LO                                 regCB_PERFCOUNTER2_LO;
typedef union CB_PERFCOUNTER2_SELECT                             regCB_PERFCOUNTER2_SELECT;
typedef union CB_PERFCOUNTER3_HI                                 regCB_PERFCOUNTER3_HI;
typedef union CB_PERFCOUNTER3_LO                                 regCB_PERFCOUNTER3_LO;
typedef union CB_PERFCOUNTER3_SELECT                             regCB_PERFCOUNTER3_SELECT;
typedef union CB_PERFCOUNTER_FILTER                              regCB_PERFCOUNTER_FILTER;
typedef union CB_RMI_BC_GL2_CACHE_CONTROL                        regCB_RMI_BC_GL2_CACHE_CONTROL;
typedef union CB_RMI_GL2_CACHE_CONTROL                           regCB_RMI_GL2_CACHE_CONTROL;
typedef union CB_SHADER_MASK                                     regCB_SHADER_MASK;
typedef union CB_STUTTER_CONTROL_CMASK_RDLAT                     regCB_STUTTER_CONTROL_CMASK_RDLAT;
typedef union CB_STUTTER_CONTROL_COLOR_RDLAT                     regCB_STUTTER_CONTROL_COLOR_RDLAT;
typedef union CB_STUTTER_CONTROL_FMASK_RDLAT                     regCB_STUTTER_CONTROL_FMASK_RDLAT;
typedef union CB_TARGET_MASK                                     regCB_TARGET_MASK;
typedef union CHA_PERFCOUNTER0_HI                                regCHA_PERFCOUNTER0_HI;
typedef union CHA_PERFCOUNTER0_LO                                regCHA_PERFCOUNTER0_LO;
typedef union CHA_PERFCOUNTER0_SELECT                            regCHA_PERFCOUNTER0_SELECT;
typedef union CHA_PERFCOUNTER0_SELECT1                           regCHA_PERFCOUNTER0_SELECT1;
typedef union CHA_PERFCOUNTER1_HI                                regCHA_PERFCOUNTER1_HI;
typedef union CHA_PERFCOUNTER1_LO                                regCHA_PERFCOUNTER1_LO;
typedef union CHA_PERFCOUNTER1_SELECT                            regCHA_PERFCOUNTER1_SELECT;
typedef union CHA_PERFCOUNTER2_HI                                regCHA_PERFCOUNTER2_HI;
typedef union CHA_PERFCOUNTER2_LO                                regCHA_PERFCOUNTER2_LO;
typedef union CHA_PERFCOUNTER2_SELECT                            regCHA_PERFCOUNTER2_SELECT;
typedef union CHA_PERFCOUNTER3_HI                                regCHA_PERFCOUNTER3_HI;
typedef union CHA_PERFCOUNTER3_LO                                regCHA_PERFCOUNTER3_LO;
typedef union CHA_PERFCOUNTER3_SELECT                            regCHA_PERFCOUNTER3_SELECT;
typedef union CHCG_PERFCOUNTER0_HI                               regCHCG_PERFCOUNTER0_HI;
typedef union CHCG_PERFCOUNTER0_LO                               regCHCG_PERFCOUNTER0_LO;
typedef union CHCG_PERFCOUNTER0_SELECT                           regCHCG_PERFCOUNTER0_SELECT;
typedef union CHCG_PERFCOUNTER0_SELECT1                          regCHCG_PERFCOUNTER0_SELECT1;
typedef union CHCG_PERFCOUNTER1_HI                               regCHCG_PERFCOUNTER1_HI;
typedef union CHCG_PERFCOUNTER1_LO                               regCHCG_PERFCOUNTER1_LO;
typedef union CHCG_PERFCOUNTER1_SELECT                           regCHCG_PERFCOUNTER1_SELECT;
typedef union CHCG_PERFCOUNTER2_HI                               regCHCG_PERFCOUNTER2_HI;
typedef union CHCG_PERFCOUNTER2_LO                               regCHCG_PERFCOUNTER2_LO;
typedef union CHCG_PERFCOUNTER2_SELECT                           regCHCG_PERFCOUNTER2_SELECT;
typedef union CHCG_PERFCOUNTER3_HI                               regCHCG_PERFCOUNTER3_HI;
typedef union CHCG_PERFCOUNTER3_LO                               regCHCG_PERFCOUNTER3_LO;
typedef union CHCG_PERFCOUNTER3_SELECT                           regCHCG_PERFCOUNTER3_SELECT;
typedef union CHC_PERFCOUNTER0_HI                                regCHC_PERFCOUNTER0_HI;
typedef union CHC_PERFCOUNTER0_LO                                regCHC_PERFCOUNTER0_LO;
typedef union CHC_PERFCOUNTER0_SELECT                            regCHC_PERFCOUNTER0_SELECT;
typedef union CHC_PERFCOUNTER0_SELECT1                           regCHC_PERFCOUNTER0_SELECT1;
typedef union CHC_PERFCOUNTER1_HI                                regCHC_PERFCOUNTER1_HI;
typedef union CHC_PERFCOUNTER1_LO                                regCHC_PERFCOUNTER1_LO;
typedef union CHC_PERFCOUNTER1_SELECT                            regCHC_PERFCOUNTER1_SELECT;
typedef union CHC_PERFCOUNTER2_HI                                regCHC_PERFCOUNTER2_HI;
typedef union CHC_PERFCOUNTER2_LO                                regCHC_PERFCOUNTER2_LO;
typedef union CHC_PERFCOUNTER2_SELECT                            regCHC_PERFCOUNTER2_SELECT;
typedef union CHC_PERFCOUNTER3_HI                                regCHC_PERFCOUNTER3_HI;
typedef union CHC_PERFCOUNTER3_LO                                regCHC_PERFCOUNTER3_LO;
typedef union CHC_PERFCOUNTER3_SELECT                            regCHC_PERFCOUNTER3_SELECT;
typedef union COHER_DEST_BASE_0                                  regCOHER_DEST_BASE_0;
typedef union COHER_DEST_BASE_1                                  regCOHER_DEST_BASE_1;
typedef union COHER_DEST_BASE_2                                  regCOHER_DEST_BASE_2;
typedef union COHER_DEST_BASE_3                                  regCOHER_DEST_BASE_3;
typedef union COHER_DEST_BASE_HI_0                               regCOHER_DEST_BASE_HI_0;
typedef union COHER_DEST_BASE_HI_1                               regCOHER_DEST_BASE_HI_1;
typedef union COHER_DEST_BASE_HI_2                               regCOHER_DEST_BASE_HI_2;
typedef union COHER_DEST_BASE_HI_3                               regCOHER_DEST_BASE_HI_3;
typedef union COMPUTE_DDID_INDEX                                 regCOMPUTE_DDID_INDEX;
typedef union COMPUTE_DESTINATION_EN_SE0                         regCOMPUTE_DESTINATION_EN_SE0;
typedef union COMPUTE_DESTINATION_EN_SE1                         regCOMPUTE_DESTINATION_EN_SE1;
typedef union COMPUTE_DESTINATION_EN_SE2                         regCOMPUTE_DESTINATION_EN_SE2;
typedef union COMPUTE_DESTINATION_EN_SE3                         regCOMPUTE_DESTINATION_EN_SE3;
typedef union COMPUTE_DIM_X                                      regCOMPUTE_DIM_X;
typedef union COMPUTE_DIM_Y                                      regCOMPUTE_DIM_Y;
typedef union COMPUTE_DIM_Z                                      regCOMPUTE_DIM_Z;
typedef union COMPUTE_DISPATCH_END                               regCOMPUTE_DISPATCH_END;
typedef union COMPUTE_DISPATCH_ID                                regCOMPUTE_DISPATCH_ID;
typedef union COMPUTE_DISPATCH_INITIATOR                         regCOMPUTE_DISPATCH_INITIATOR;
typedef union COMPUTE_DISPATCH_INTERLEAVE                        regCOMPUTE_DISPATCH_INTERLEAVE;
typedef union COMPUTE_DISPATCH_PKT_ADDR_HI                       regCOMPUTE_DISPATCH_PKT_ADDR_HI;
typedef union COMPUTE_DISPATCH_PKT_ADDR_LO                       regCOMPUTE_DISPATCH_PKT_ADDR_LO;
typedef union COMPUTE_DISPATCH_SCRATCH_BASE_HI                   regCOMPUTE_DISPATCH_SCRATCH_BASE_HI;
typedef union COMPUTE_DISPATCH_SCRATCH_BASE_LO                   regCOMPUTE_DISPATCH_SCRATCH_BASE_LO;
typedef union COMPUTE_DISPATCH_TUNNEL                            regCOMPUTE_DISPATCH_TUNNEL;
typedef union COMPUTE_MISC_RESERVED                              regCOMPUTE_MISC_RESERVED;
typedef union COMPUTE_NOWHERE                                    regCOMPUTE_NOWHERE;
typedef union COMPUTE_NUM_THREAD_X                               regCOMPUTE_NUM_THREAD_X;
typedef union COMPUTE_NUM_THREAD_Y                               regCOMPUTE_NUM_THREAD_Y;
typedef union COMPUTE_NUM_THREAD_Z                               regCOMPUTE_NUM_THREAD_Z;
typedef union COMPUTE_PERFCOUNT_ENABLE                           regCOMPUTE_PERFCOUNT_ENABLE;
typedef union COMPUTE_PGM_HI                                     regCOMPUTE_PGM_HI;
typedef union COMPUTE_PGM_LO                                     regCOMPUTE_PGM_LO;
typedef union COMPUTE_PGM_RSRC1                                  regCOMPUTE_PGM_RSRC1;
typedef union COMPUTE_PGM_RSRC2                                  regCOMPUTE_PGM_RSRC2;
typedef union COMPUTE_PGM_RSRC3                                  regCOMPUTE_PGM_RSRC3;
typedef union COMPUTE_PIPELINESTAT_ENABLE                        regCOMPUTE_PIPELINESTAT_ENABLE;
typedef union COMPUTE_PREF_PRI_ACCUM_0                           regCOMPUTE_PREF_PRI_ACCUM_0;
typedef union COMPUTE_PREF_PRI_ACCUM_1                           regCOMPUTE_PREF_PRI_ACCUM_1;
typedef union COMPUTE_PREF_PRI_ACCUM_2                           regCOMPUTE_PREF_PRI_ACCUM_2;
typedef union COMPUTE_PREF_PRI_ACCUM_3                           regCOMPUTE_PREF_PRI_ACCUM_3;
typedef union COMPUTE_RELAUNCH                                   regCOMPUTE_RELAUNCH;
typedef union COMPUTE_RELAUNCH2                                  regCOMPUTE_RELAUNCH2;
typedef union COMPUTE_REQ_CTRL                                   regCOMPUTE_REQ_CTRL;
typedef union COMPUTE_RESOURCE_LIMITS                            regCOMPUTE_RESOURCE_LIMITS;
typedef union COMPUTE_RESTART_X                                  regCOMPUTE_RESTART_X;
typedef union COMPUTE_RESTART_Y                                  regCOMPUTE_RESTART_Y;
typedef union COMPUTE_RESTART_Z                                  regCOMPUTE_RESTART_Z;
typedef union COMPUTE_SHADER_CHKSUM                              regCOMPUTE_SHADER_CHKSUM;
typedef union COMPUTE_START_X                                    regCOMPUTE_START_X;
typedef union COMPUTE_START_Y                                    regCOMPUTE_START_Y;
typedef union COMPUTE_START_Z                                    regCOMPUTE_START_Z;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE0                     regCOMPUTE_STATIC_THREAD_MGMT_SE0;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE1                     regCOMPUTE_STATIC_THREAD_MGMT_SE1;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE2                     regCOMPUTE_STATIC_THREAD_MGMT_SE2;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE3                     regCOMPUTE_STATIC_THREAD_MGMT_SE3;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE4                     regCOMPUTE_STATIC_THREAD_MGMT_SE4;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE5                     regCOMPUTE_STATIC_THREAD_MGMT_SE5;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE6                     regCOMPUTE_STATIC_THREAD_MGMT_SE6;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE7                     regCOMPUTE_STATIC_THREAD_MGMT_SE7;
typedef union COMPUTE_THREADGROUP_ID                             regCOMPUTE_THREADGROUP_ID;
typedef union COMPUTE_THREAD_TRACE_ENABLE                        regCOMPUTE_THREAD_TRACE_ENABLE;
typedef union COMPUTE_TMPRING_SIZE                               regCOMPUTE_TMPRING_SIZE;
typedef union COMPUTE_USER_ACCUM_0                               regCOMPUTE_USER_ACCUM_0;
typedef union COMPUTE_USER_ACCUM_1                               regCOMPUTE_USER_ACCUM_1;
typedef union COMPUTE_USER_ACCUM_2                               regCOMPUTE_USER_ACCUM_2;
typedef union COMPUTE_USER_ACCUM_3                               regCOMPUTE_USER_ACCUM_3;
typedef union COMPUTE_USER_DATA_0                                regCOMPUTE_USER_DATA_0;
typedef union COMPUTE_USER_DATA_1                                regCOMPUTE_USER_DATA_1;
typedef union COMPUTE_USER_DATA_2                                regCOMPUTE_USER_DATA_2;
typedef union COMPUTE_USER_DATA_3                                regCOMPUTE_USER_DATA_3;
typedef union COMPUTE_USER_DATA_4                                regCOMPUTE_USER_DATA_4;
typedef union COMPUTE_USER_DATA_5                                regCOMPUTE_USER_DATA_5;
typedef union COMPUTE_USER_DATA_6                                regCOMPUTE_USER_DATA_6;
typedef union COMPUTE_USER_DATA_7                                regCOMPUTE_USER_DATA_7;
typedef union COMPUTE_USER_DATA_8                                regCOMPUTE_USER_DATA_8;
typedef union COMPUTE_USER_DATA_9                                regCOMPUTE_USER_DATA_9;
typedef union COMPUTE_USER_DATA_10                               regCOMPUTE_USER_DATA_10;
typedef union COMPUTE_USER_DATA_11                               regCOMPUTE_USER_DATA_11;
typedef union COMPUTE_USER_DATA_12                               regCOMPUTE_USER_DATA_12;
typedef union COMPUTE_USER_DATA_13                               regCOMPUTE_USER_DATA_13;
typedef union COMPUTE_USER_DATA_14                               regCOMPUTE_USER_DATA_14;
typedef union COMPUTE_USER_DATA_15                               regCOMPUTE_USER_DATA_15;
typedef union COMPUTE_VMID                                       regCOMPUTE_VMID;
typedef union COMPUTE_WAVE_RESTORE_ADDR_HI                       regCOMPUTE_WAVE_RESTORE_ADDR_HI;
typedef union COMPUTE_WAVE_RESTORE_ADDR_LO                       regCOMPUTE_WAVE_RESTORE_ADDR_LO;
typedef union CPC_PERFCOUNTER0_HI                                regCPC_PERFCOUNTER0_HI;
typedef union CPC_PERFCOUNTER0_LO                                regCPC_PERFCOUNTER0_LO;
typedef union CPC_PERFCOUNTER0_SELECT                            regCPC_PERFCOUNTER0_SELECT;
typedef union CPC_PERFCOUNTER0_SELECT1                           regCPC_PERFCOUNTER0_SELECT1;
typedef union CPC_PERFCOUNTER1_HI                                regCPC_PERFCOUNTER1_HI;
typedef union CPC_PERFCOUNTER1_LO                                regCPC_PERFCOUNTER1_LO;
typedef union CPC_PERFCOUNTER1_SELECT                            regCPC_PERFCOUNTER1_SELECT;
typedef union CPF_PERFCOUNTER0_HI                                regCPF_PERFCOUNTER0_HI;
typedef union CPF_PERFCOUNTER0_LO                                regCPF_PERFCOUNTER0_LO;
typedef union CPF_PERFCOUNTER0_SELECT                            regCPF_PERFCOUNTER0_SELECT;
typedef union CPF_PERFCOUNTER0_SELECT1                           regCPF_PERFCOUNTER0_SELECT1;
typedef union CPF_PERFCOUNTER1_HI                                regCPF_PERFCOUNTER1_HI;
typedef union CPF_PERFCOUNTER1_LO                                regCPF_PERFCOUNTER1_LO;
typedef union CPF_PERFCOUNTER1_SELECT                            regCPF_PERFCOUNTER1_SELECT;
typedef union CPG_PERFCOUNTER0_HI                                regCPG_PERFCOUNTER0_HI;
typedef union CPG_PERFCOUNTER0_LO                                regCPG_PERFCOUNTER0_LO;
typedef union CPG_PERFCOUNTER0_SELECT                            regCPG_PERFCOUNTER0_SELECT;
typedef union CPG_PERFCOUNTER0_SELECT1                           regCPG_PERFCOUNTER0_SELECT1;
typedef union CPG_PERFCOUNTER1_HI                                regCPG_PERFCOUNTER1_HI;
typedef union CPG_PERFCOUNTER1_LO                                regCPG_PERFCOUNTER1_LO;
typedef union CPG_PERFCOUNTER1_SELECT                            regCPG_PERFCOUNTER1_SELECT;
typedef union CP_COHER_BASE                                      regCP_COHER_BASE;
typedef union CP_COHER_BASE_HI                                   regCP_COHER_BASE_HI;
typedef union CP_COHER_CNTL                                      regCP_COHER_CNTL;
typedef union CP_COHER_SIZE                                      regCP_COHER_SIZE;
typedef union CP_COHER_SIZE_HI                                   regCP_COHER_SIZE_HI;
typedef union CP_COHER_START_DELAY                               regCP_COHER_START_DELAY;
typedef union CP_COHER_STATUS                                    regCP_COHER_STATUS;
typedef union CP_ME_COHER_BASE                                   regCP_ME_COHER_BASE;
typedef union CP_ME_COHER_BASE_HI                                regCP_ME_COHER_BASE_HI;
typedef union CP_ME_COHER_CNTL                                   regCP_ME_COHER_CNTL;
typedef union CP_ME_COHER_SIZE                                   regCP_ME_COHER_SIZE;
typedef union CP_ME_COHER_SIZE_HI                                regCP_ME_COHER_SIZE_HI;
typedef union CP_ME_COHER_STATUS                                 regCP_ME_COHER_STATUS;
typedef union CP_NUM_PRIM_NEEDED_COUNT0_HI                       regCP_NUM_PRIM_NEEDED_COUNT0_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT0_LO                       regCP_NUM_PRIM_NEEDED_COUNT0_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT1_HI                       regCP_NUM_PRIM_NEEDED_COUNT1_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT1_LO                       regCP_NUM_PRIM_NEEDED_COUNT1_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT2_HI                       regCP_NUM_PRIM_NEEDED_COUNT2_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT2_LO                       regCP_NUM_PRIM_NEEDED_COUNT2_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT3_HI                       regCP_NUM_PRIM_NEEDED_COUNT3_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT3_LO                       regCP_NUM_PRIM_NEEDED_COUNT3_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT0_HI                      regCP_NUM_PRIM_WRITTEN_COUNT0_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT0_LO                      regCP_NUM_PRIM_WRITTEN_COUNT0_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT1_HI                      regCP_NUM_PRIM_WRITTEN_COUNT1_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT1_LO                      regCP_NUM_PRIM_WRITTEN_COUNT1_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT2_HI                      regCP_NUM_PRIM_WRITTEN_COUNT2_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT2_LO                      regCP_NUM_PRIM_WRITTEN_COUNT2_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT3_HI                      regCP_NUM_PRIM_WRITTEN_COUNT3_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT3_LO                      regCP_NUM_PRIM_WRITTEN_COUNT3_LO;
typedef union CP_PERFMON_CNTL                                    regCP_PERFMON_CNTL;
typedef union CP_PERFMON_CNTX_CNTL                               regCP_PERFMON_CNTX_CNTL;
typedef union CP_SC_PSINVOC_COUNT0_HI                            regCP_SC_PSINVOC_COUNT0_HI;
typedef union CP_SC_PSINVOC_COUNT0_LO                            regCP_SC_PSINVOC_COUNT0_LO;
typedef union CP_SC_PSINVOC_COUNT1_HI                            regCP_SC_PSINVOC_COUNT1_HI;
typedef union CP_SC_PSINVOC_COUNT1_LO                            regCP_SC_PSINVOC_COUNT1_LO;
typedef union CP_STRMOUT_CNTL                                    regCP_STRMOUT_CNTL;
typedef union CP_VGT_ASINVOC_COUNT_HI                            regCP_VGT_ASINVOC_COUNT_HI;
typedef union CP_VGT_ASINVOC_COUNT_LO                            regCP_VGT_ASINVOC_COUNT_LO;
typedef union CP_VGT_CSINVOC_COUNT_HI                            regCP_VGT_CSINVOC_COUNT_HI;
typedef union CP_VGT_CSINVOC_COUNT_LO                            regCP_VGT_CSINVOC_COUNT_LO;
typedef union CP_VGT_DSINVOC_COUNT_HI                            regCP_VGT_DSINVOC_COUNT_HI;
typedef union CP_VGT_DSINVOC_COUNT_LO                            regCP_VGT_DSINVOC_COUNT_LO;
typedef union CP_VGT_GSINVOC_COUNT_HI                            regCP_VGT_GSINVOC_COUNT_HI;
typedef union CP_VGT_GSINVOC_COUNT_LO                            regCP_VGT_GSINVOC_COUNT_LO;
typedef union CP_VGT_GSPRIM_COUNT_HI                             regCP_VGT_GSPRIM_COUNT_HI;
typedef union CP_VGT_GSPRIM_COUNT_LO                             regCP_VGT_GSPRIM_COUNT_LO;
typedef union CP_VGT_HSINVOC_COUNT_HI                            regCP_VGT_HSINVOC_COUNT_HI;
typedef union CP_VGT_HSINVOC_COUNT_LO                            regCP_VGT_HSINVOC_COUNT_LO;
typedef union CP_VGT_IAPRIM_COUNT_HI                             regCP_VGT_IAPRIM_COUNT_HI;
typedef union CP_VGT_IAPRIM_COUNT_LO                             regCP_VGT_IAPRIM_COUNT_LO;
typedef union CP_VGT_IAVERT_COUNT_HI                             regCP_VGT_IAVERT_COUNT_HI;
typedef union CP_VGT_IAVERT_COUNT_LO                             regCP_VGT_IAVERT_COUNT_LO;
typedef union CP_VGT_VSINVOC_COUNT_HI                            regCP_VGT_VSINVOC_COUNT_HI;
typedef union CP_VGT_VSINVOC_COUNT_LO                            regCP_VGT_VSINVOC_COUNT_LO;
typedef union DB_ALPHA_TO_MASK                                   regDB_ALPHA_TO_MASK;
typedef union DB_CGTT_CLK_CTRL_0                                 regDB_CGTT_CLK_CTRL_0;
typedef union DB_CGTT_CLK_CTRL_1                                 regDB_CGTT_CLK_CTRL_1;
typedef union DB_COUNT_CONTROL                                   regDB_COUNT_CONTROL;
typedef union DB_CREDIT_LIMIT                                    regDB_CREDIT_LIMIT;
typedef union DB_DEPTH_BOUNDS_MAX                                regDB_DEPTH_BOUNDS_MAX;
typedef union DB_DEPTH_BOUNDS_MIN                                regDB_DEPTH_BOUNDS_MIN;
typedef union DB_DEPTH_CLEAR                                     regDB_DEPTH_CLEAR;
typedef union DB_DEPTH_CONTROL                                   regDB_DEPTH_CONTROL;
typedef union DB_DEPTH_SIZE_XY                                   regDB_DEPTH_SIZE_XY;
typedef union DB_DEPTH_VIEW                                      regDB_DEPTH_VIEW;
typedef union DB_DFSM_CONFIG                                     regDB_DFSM_CONFIG;
typedef union DB_DFSM_CONTROL                                    regDB_DFSM_CONTROL;
typedef union DB_DFSM_FLUSH_AUX_EVENT                            regDB_DFSM_FLUSH_AUX_EVENT;
typedef union DB_DFSM_FLUSH_ENABLE                               regDB_DFSM_FLUSH_ENABLE;
typedef union DB_DFSM_PRIMS_IN_FLIGHT                            regDB_DFSM_PRIMS_IN_FLIGHT;
typedef union DB_DFSM_TILES_IN_FLIGHT                            regDB_DFSM_TILES_IN_FLIGHT;
typedef union DB_DFSM_WATCHDOG                                   regDB_DFSM_WATCHDOG;
typedef union DB_EQAA                                            regDB_EQAA;
typedef union DB_EQUAD_STUTTER_CONTROL                           regDB_EQUAD_STUTTER_CONTROL;
typedef union DB_ETILE_STUTTER_CONTROL                           regDB_ETILE_STUTTER_CONTROL;
typedef union DB_EXCEPTION_CONTROL                               regDB_EXCEPTION_CONTROL;
typedef union DB_FGCG_INTERFACES_CLK_CTRL                        regDB_FGCG_INTERFACES_CLK_CTRL;
typedef union DB_FGCG_SRAMS_CLK_CTRL                             regDB_FGCG_SRAMS_CLK_CTRL;
typedef union DB_FIFO_DEPTH1                                     regDB_FIFO_DEPTH1;
typedef union DB_FIFO_DEPTH2                                     regDB_FIFO_DEPTH2;
typedef union DB_FIFO_DEPTH3                                     regDB_FIFO_DEPTH3;
typedef union DB_FIFO_DEPTH4                                     regDB_FIFO_DEPTH4;
typedef union DB_FREE_CACHELINES                                 regDB_FREE_CACHELINES;
typedef union DB_HTILE_DATA_BASE                                 regDB_HTILE_DATA_BASE;
typedef union DB_HTILE_DATA_BASE_HI                              regDB_HTILE_DATA_BASE_HI;
typedef union DB_HTILE_SURFACE                                   regDB_HTILE_SURFACE;
typedef union DB_LAST_OF_BURST_CONFIG                            regDB_LAST_OF_BURST_CONFIG;
typedef union DB_LQUAD_STUTTER_CONTROL                           regDB_LQUAD_STUTTER_CONTROL;
typedef union DB_LTILE_STUTTER_CONTROL                           regDB_LTILE_STUTTER_CONTROL;
typedef union DB_MEM_ARB_WATERMARKS                              regDB_MEM_ARB_WATERMARKS;
typedef union DB_OCCLUSION_COUNT0_HI                             regDB_OCCLUSION_COUNT0_HI;
typedef union DB_OCCLUSION_COUNT0_LOW                            regDB_OCCLUSION_COUNT0_LOW;
typedef union DB_OCCLUSION_COUNT1_HI                             regDB_OCCLUSION_COUNT1_HI;
typedef union DB_OCCLUSION_COUNT1_LOW                            regDB_OCCLUSION_COUNT1_LOW;
typedef union DB_OCCLUSION_COUNT2_HI                             regDB_OCCLUSION_COUNT2_HI;
typedef union DB_OCCLUSION_COUNT2_LOW                            regDB_OCCLUSION_COUNT2_LOW;
typedef union DB_OCCLUSION_COUNT3_HI                             regDB_OCCLUSION_COUNT3_HI;
typedef union DB_OCCLUSION_COUNT3_LOW                            regDB_OCCLUSION_COUNT3_LOW;
typedef union DB_PERFCOUNTER0_HI                                 regDB_PERFCOUNTER0_HI;
typedef union DB_PERFCOUNTER0_LO                                 regDB_PERFCOUNTER0_LO;
typedef union DB_PERFCOUNTER0_SELECT                             regDB_PERFCOUNTER0_SELECT;
typedef union DB_PERFCOUNTER0_SELECT1                            regDB_PERFCOUNTER0_SELECT1;
typedef union DB_PERFCOUNTER1_HI                                 regDB_PERFCOUNTER1_HI;
typedef union DB_PERFCOUNTER1_LO                                 regDB_PERFCOUNTER1_LO;
typedef union DB_PERFCOUNTER1_SELECT                             regDB_PERFCOUNTER1_SELECT;
typedef union DB_PERFCOUNTER1_SELECT1                            regDB_PERFCOUNTER1_SELECT1;
typedef union DB_PERFCOUNTER2_HI                                 regDB_PERFCOUNTER2_HI;
typedef union DB_PERFCOUNTER2_LO                                 regDB_PERFCOUNTER2_LO;
typedef union DB_PERFCOUNTER2_SELECT                             regDB_PERFCOUNTER2_SELECT;
typedef union DB_PERFCOUNTER3_HI                                 regDB_PERFCOUNTER3_HI;
typedef union DB_PERFCOUNTER3_LO                                 regDB_PERFCOUNTER3_LO;
typedef union DB_PERFCOUNTER3_SELECT                             regDB_PERFCOUNTER3_SELECT;
typedef union DB_PRELOAD_CONTROL                                 regDB_PRELOAD_CONTROL;
typedef union DB_RENDER_CONTROL                                  regDB_RENDER_CONTROL;
typedef union DB_RENDER_OVERRIDE                                 regDB_RENDER_OVERRIDE;
typedef union DB_RENDER_OVERRIDE2                                regDB_RENDER_OVERRIDE2;
typedef union DB_RESERVED_REG_1                                  regDB_RESERVED_REG_1;
typedef union DB_RESERVED_REG_2                                  regDB_RESERVED_REG_2;
typedef union DB_RESERVED_REG_3                                  regDB_RESERVED_REG_3;
typedef union DB_RING_CONTROL                                    regDB_RING_CONTROL;
typedef union DB_RMI_BC_GL2_CACHE_CONTROL                        regDB_RMI_BC_GL2_CACHE_CONTROL;
typedef union DB_RMI_L2_CACHE_CONTROL                            regDB_RMI_L2_CACHE_CONTROL;
typedef union DB_SHADER_CONTROL                                  regDB_SHADER_CONTROL;
typedef union DB_SPI_VRS_CENTER_LOCATION                         regDB_SPI_VRS_CENTER_LOCATION;
typedef union DB_SRESULTS_COMPARE_STATE0                         regDB_SRESULTS_COMPARE_STATE0;
typedef union DB_SRESULTS_COMPARE_STATE1                         regDB_SRESULTS_COMPARE_STATE1;
typedef union DB_STENCILREFMASK                                  regDB_STENCILREFMASK;
typedef union DB_STENCILREFMASK_BF                               regDB_STENCILREFMASK_BF;
typedef union DB_STENCIL_CLEAR                                   regDB_STENCIL_CLEAR;
typedef union DB_STENCIL_CONTROL                                 regDB_STENCIL_CONTROL;
typedef union DB_STENCIL_INFO                                    regDB_STENCIL_INFO;
typedef union DB_STENCIL_READ_BASE                               regDB_STENCIL_READ_BASE;
typedef union DB_STENCIL_READ_BASE_HI                            regDB_STENCIL_READ_BASE_HI;
typedef union DB_STENCIL_WRITE_BASE                              regDB_STENCIL_WRITE_BASE;
typedef union DB_STENCIL_WRITE_BASE_HI                           regDB_STENCIL_WRITE_BASE_HI;
typedef union DB_SUBTILE_CONTROL                                 regDB_SUBTILE_CONTROL;
typedef union DB_VRS_OVERRIDE_CNTL                               regDB_VRS_OVERRIDE_CNTL;
typedef union DB_WATERMARKS                                      regDB_WATERMARKS;
typedef union DB_ZPASS_COUNT_HI                                  regDB_ZPASS_COUNT_HI;
typedef union DB_ZPASS_COUNT_LOW                                 regDB_ZPASS_COUNT_LOW;
typedef union DB_Z_INFO                                          regDB_Z_INFO;
typedef union DB_Z_READ_BASE                                     regDB_Z_READ_BASE;
typedef union DB_Z_READ_BASE_HI                                  regDB_Z_READ_BASE_HI;
typedef union DB_Z_WRITE_BASE                                    regDB_Z_WRITE_BASE;
typedef union DB_Z_WRITE_BASE_HI                                 regDB_Z_WRITE_BASE_HI;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi0                       regDF_MCD_PIE_AON_PerfMonCtlHi0;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi1                       regDF_MCD_PIE_AON_PerfMonCtlHi1;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi2                       regDF_MCD_PIE_AON_PerfMonCtlHi2;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi3                       regDF_MCD_PIE_AON_PerfMonCtlHi3;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi4                       regDF_MCD_PIE_AON_PerfMonCtlHi4;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi5                       regDF_MCD_PIE_AON_PerfMonCtlHi5;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi6                       regDF_MCD_PIE_AON_PerfMonCtlHi6;
typedef union DF_MCD_PIE_AON_PerfMonCtlHi7                       regDF_MCD_PIE_AON_PerfMonCtlHi7;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo0                       regDF_MCD_PIE_AON_PerfMonCtlLo0;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo1                       regDF_MCD_PIE_AON_PerfMonCtlLo1;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo2                       regDF_MCD_PIE_AON_PerfMonCtlLo2;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo3                       regDF_MCD_PIE_AON_PerfMonCtlLo3;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo4                       regDF_MCD_PIE_AON_PerfMonCtlLo4;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo5                       regDF_MCD_PIE_AON_PerfMonCtlLo5;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo6                       regDF_MCD_PIE_AON_PerfMonCtlLo6;
typedef union DF_MCD_PIE_AON_PerfMonCtlLo7                       regDF_MCD_PIE_AON_PerfMonCtlLo7;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi0                       regDF_MCD_PIE_AON_PerfMonCtrHi0;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi1                       regDF_MCD_PIE_AON_PerfMonCtrHi1;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi2                       regDF_MCD_PIE_AON_PerfMonCtrHi2;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi3                       regDF_MCD_PIE_AON_PerfMonCtrHi3;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi4                       regDF_MCD_PIE_AON_PerfMonCtrHi4;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi5                       regDF_MCD_PIE_AON_PerfMonCtrHi5;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi6                       regDF_MCD_PIE_AON_PerfMonCtrHi6;
typedef union DF_MCD_PIE_AON_PerfMonCtrHi7                       regDF_MCD_PIE_AON_PerfMonCtrHi7;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo0                       regDF_MCD_PIE_AON_PerfMonCtrLo0;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo1                       regDF_MCD_PIE_AON_PerfMonCtrLo1;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo2                       regDF_MCD_PIE_AON_PerfMonCtrLo2;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo3                       regDF_MCD_PIE_AON_PerfMonCtrLo3;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo4                       regDF_MCD_PIE_AON_PerfMonCtrLo4;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo5                       regDF_MCD_PIE_AON_PerfMonCtrLo5;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo6                       regDF_MCD_PIE_AON_PerfMonCtrLo6;
typedef union DF_MCD_PIE_AON_PerfMonCtrLo7                       regDF_MCD_PIE_AON_PerfMonCtrLo7;
typedef union DF_PIE_AON_PerfMonCtlHi0                           regDF_PIE_AON_PerfMonCtlHi0;
typedef union DF_PIE_AON_PerfMonCtlHi1                           regDF_PIE_AON_PerfMonCtlHi1;
typedef union DF_PIE_AON_PerfMonCtlHi2                           regDF_PIE_AON_PerfMonCtlHi2;
typedef union DF_PIE_AON_PerfMonCtlHi3                           regDF_PIE_AON_PerfMonCtlHi3;
typedef union DF_PIE_AON_PerfMonCtlHi4                           regDF_PIE_AON_PerfMonCtlHi4;
typedef union DF_PIE_AON_PerfMonCtlHi5                           regDF_PIE_AON_PerfMonCtlHi5;
typedef union DF_PIE_AON_PerfMonCtlHi6                           regDF_PIE_AON_PerfMonCtlHi6;
typedef union DF_PIE_AON_PerfMonCtlHi7                           regDF_PIE_AON_PerfMonCtlHi7;
typedef union DF_PIE_AON_PerfMonCtlHi8                           regDF_PIE_AON_PerfMonCtlHi8;
typedef union DF_PIE_AON_PerfMonCtlHi9                           regDF_PIE_AON_PerfMonCtlHi9;
typedef union DF_PIE_AON_PerfMonCtlHi10                          regDF_PIE_AON_PerfMonCtlHi10;
typedef union DF_PIE_AON_PerfMonCtlHi11                          regDF_PIE_AON_PerfMonCtlHi11;
typedef union DF_PIE_AON_PerfMonCtlHi12                          regDF_PIE_AON_PerfMonCtlHi12;
typedef union DF_PIE_AON_PerfMonCtlHi13                          regDF_PIE_AON_PerfMonCtlHi13;
typedef union DF_PIE_AON_PerfMonCtlHi14                          regDF_PIE_AON_PerfMonCtlHi14;
typedef union DF_PIE_AON_PerfMonCtlHi15                          regDF_PIE_AON_PerfMonCtlHi15;
typedef union DF_PIE_AON_PerfMonCtlLo0                           regDF_PIE_AON_PerfMonCtlLo0;
typedef union DF_PIE_AON_PerfMonCtlLo1                           regDF_PIE_AON_PerfMonCtlLo1;
typedef union DF_PIE_AON_PerfMonCtlLo2                           regDF_PIE_AON_PerfMonCtlLo2;
typedef union DF_PIE_AON_PerfMonCtlLo3                           regDF_PIE_AON_PerfMonCtlLo3;
typedef union DF_PIE_AON_PerfMonCtlLo4                           regDF_PIE_AON_PerfMonCtlLo4;
typedef union DF_PIE_AON_PerfMonCtlLo5                           regDF_PIE_AON_PerfMonCtlLo5;
typedef union DF_PIE_AON_PerfMonCtlLo6                           regDF_PIE_AON_PerfMonCtlLo6;
typedef union DF_PIE_AON_PerfMonCtlLo7                           regDF_PIE_AON_PerfMonCtlLo7;
typedef union DF_PIE_AON_PerfMonCtlLo8                           regDF_PIE_AON_PerfMonCtlLo8;
typedef union DF_PIE_AON_PerfMonCtlLo9                           regDF_PIE_AON_PerfMonCtlLo9;
typedef union DF_PIE_AON_PerfMonCtlLo10                          regDF_PIE_AON_PerfMonCtlLo10;
typedef union DF_PIE_AON_PerfMonCtlLo11                          regDF_PIE_AON_PerfMonCtlLo11;
typedef union DF_PIE_AON_PerfMonCtlLo12                          regDF_PIE_AON_PerfMonCtlLo12;
typedef union DF_PIE_AON_PerfMonCtlLo13                          regDF_PIE_AON_PerfMonCtlLo13;
typedef union DF_PIE_AON_PerfMonCtlLo14                          regDF_PIE_AON_PerfMonCtlLo14;
typedef union DF_PIE_AON_PerfMonCtlLo15                          regDF_PIE_AON_PerfMonCtlLo15;
typedef union DF_PIE_AON_PerfMonCtrHi0                           regDF_PIE_AON_PerfMonCtrHi0;
typedef union DF_PIE_AON_PerfMonCtrHi1                           regDF_PIE_AON_PerfMonCtrHi1;
typedef union DF_PIE_AON_PerfMonCtrHi2                           regDF_PIE_AON_PerfMonCtrHi2;
typedef union DF_PIE_AON_PerfMonCtrHi3                           regDF_PIE_AON_PerfMonCtrHi3;
typedef union DF_PIE_AON_PerfMonCtrHi4                           regDF_PIE_AON_PerfMonCtrHi4;
typedef union DF_PIE_AON_PerfMonCtrHi5                           regDF_PIE_AON_PerfMonCtrHi5;
typedef union DF_PIE_AON_PerfMonCtrHi6                           regDF_PIE_AON_PerfMonCtrHi6;
typedef union DF_PIE_AON_PerfMonCtrHi7                           regDF_PIE_AON_PerfMonCtrHi7;
typedef union DF_PIE_AON_PerfMonCtrHi8                           regDF_PIE_AON_PerfMonCtrHi8;
typedef union DF_PIE_AON_PerfMonCtrHi9                           regDF_PIE_AON_PerfMonCtrHi9;
typedef union DF_PIE_AON_PerfMonCtrHi10                          regDF_PIE_AON_PerfMonCtrHi10;
typedef union DF_PIE_AON_PerfMonCtrHi11                          regDF_PIE_AON_PerfMonCtrHi11;
typedef union DF_PIE_AON_PerfMonCtrHi12                          regDF_PIE_AON_PerfMonCtrHi12;
typedef union DF_PIE_AON_PerfMonCtrHi13                          regDF_PIE_AON_PerfMonCtrHi13;
typedef union DF_PIE_AON_PerfMonCtrHi14                          regDF_PIE_AON_PerfMonCtrHi14;
typedef union DF_PIE_AON_PerfMonCtrHi15                          regDF_PIE_AON_PerfMonCtrHi15;
typedef union DF_PIE_AON_PerfMonCtrLo0                           regDF_PIE_AON_PerfMonCtrLo0;
typedef union DF_PIE_AON_PerfMonCtrLo1                           regDF_PIE_AON_PerfMonCtrLo1;
typedef union DF_PIE_AON_PerfMonCtrLo2                           regDF_PIE_AON_PerfMonCtrLo2;
typedef union DF_PIE_AON_PerfMonCtrLo3                           regDF_PIE_AON_PerfMonCtrLo3;
typedef union DF_PIE_AON_PerfMonCtrLo4                           regDF_PIE_AON_PerfMonCtrLo4;
typedef union DF_PIE_AON_PerfMonCtrLo5                           regDF_PIE_AON_PerfMonCtrLo5;
typedef union DF_PIE_AON_PerfMonCtrLo6                           regDF_PIE_AON_PerfMonCtrLo6;
typedef union DF_PIE_AON_PerfMonCtrLo7                           regDF_PIE_AON_PerfMonCtrLo7;
typedef union DF_PIE_AON_PerfMonCtrLo8                           regDF_PIE_AON_PerfMonCtrLo8;
typedef union DF_PIE_AON_PerfMonCtrLo9                           regDF_PIE_AON_PerfMonCtrLo9;
typedef union DF_PIE_AON_PerfMonCtrLo10                          regDF_PIE_AON_PerfMonCtrLo10;
typedef union DF_PIE_AON_PerfMonCtrLo11                          regDF_PIE_AON_PerfMonCtrLo11;
typedef union DF_PIE_AON_PerfMonCtrLo12                          regDF_PIE_AON_PerfMonCtrLo12;
typedef union DF_PIE_AON_PerfMonCtrLo13                          regDF_PIE_AON_PerfMonCtrLo13;
typedef union DF_PIE_AON_PerfMonCtrLo14                          regDF_PIE_AON_PerfMonCtrLo14;
typedef union DF_PIE_AON_PerfMonCtrLo15                          regDF_PIE_AON_PerfMonCtrLo15;
typedef union GB_ADDR_CONFIG                                     regGB_ADDR_CONFIG;
typedef union GB_ADDR_CONFIG_READ                                regGB_ADDR_CONFIG_READ;
typedef union GCEA_PERFCOUNTER0_CFG                              regGCEA_PERFCOUNTER0_CFG;
typedef union GCEA_PERFCOUNTER1_CFG                              regGCEA_PERFCOUNTER1_CFG;
typedef union GCEA_PERFCOUNTER2_HI                               regGCEA_PERFCOUNTER2_HI;
typedef union GCEA_PERFCOUNTER2_LO                               regGCEA_PERFCOUNTER2_LO;
typedef union GCEA_PERFCOUNTER2_MODE                             regGCEA_PERFCOUNTER2_MODE;
typedef union GCEA_PERFCOUNTER2_SELECT                           regGCEA_PERFCOUNTER2_SELECT;
typedef union GCEA_PERFCOUNTER2_SELECT1                          regGCEA_PERFCOUNTER2_SELECT1;
typedef union GCEA_PERFCOUNTER_HI                                regGCEA_PERFCOUNTER_HI;
typedef union GCEA_PERFCOUNTER_LO                                regGCEA_PERFCOUNTER_LO;
typedef union GCEA_PERFCOUNTER_RSLT_CNTL                         regGCEA_PERFCOUNTER_RSLT_CNTL;
typedef union GCMC_VM_L2_PERFCOUNTER0_CFG                        regGCMC_VM_L2_PERFCOUNTER0_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER1_CFG                        regGCMC_VM_L2_PERFCOUNTER1_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER2_CFG                        regGCMC_VM_L2_PERFCOUNTER2_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER3_CFG                        regGCMC_VM_L2_PERFCOUNTER3_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER4_CFG                        regGCMC_VM_L2_PERFCOUNTER4_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER5_CFG                        regGCMC_VM_L2_PERFCOUNTER5_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER6_CFG                        regGCMC_VM_L2_PERFCOUNTER6_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER7_CFG                        regGCMC_VM_L2_PERFCOUNTER7_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER_HI                          regGCMC_VM_L2_PERFCOUNTER_HI;
typedef union GCMC_VM_L2_PERFCOUNTER_LO                          regGCMC_VM_L2_PERFCOUNTER_LO;
typedef union GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                   regGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL;
typedef union GCR_PERFCOUNTER0_HI                                regGCR_PERFCOUNTER0_HI;
typedef union GCR_PERFCOUNTER0_LO                                regGCR_PERFCOUNTER0_LO;
typedef union GCR_PERFCOUNTER0_SELECT                            regGCR_PERFCOUNTER0_SELECT;
typedef union GCR_PERFCOUNTER0_SELECT1                           regGCR_PERFCOUNTER0_SELECT1;
typedef union GCR_PERFCOUNTER1_HI                                regGCR_PERFCOUNTER1_HI;
typedef union GCR_PERFCOUNTER1_LO                                regGCR_PERFCOUNTER1_LO;
typedef union GCR_PERFCOUNTER1_SELECT                            regGCR_PERFCOUNTER1_SELECT;
typedef union GCVML2_PERFCOUNTER2_0_HI                           regGCVML2_PERFCOUNTER2_0_HI;
typedef union GCVML2_PERFCOUNTER2_0_LO                           regGCVML2_PERFCOUNTER2_0_LO;
typedef union GCVML2_PERFCOUNTER2_0_MODE                         regGCVML2_PERFCOUNTER2_0_MODE;
typedef union GCVML2_PERFCOUNTER2_0_SELECT                       regGCVML2_PERFCOUNTER2_0_SELECT;
typedef union GCVML2_PERFCOUNTER2_0_SELECT1                      regGCVML2_PERFCOUNTER2_0_SELECT1;
typedef union GCVML2_PERFCOUNTER2_1_HI                           regGCVML2_PERFCOUNTER2_1_HI;
typedef union GCVML2_PERFCOUNTER2_1_LO                           regGCVML2_PERFCOUNTER2_1_LO;
typedef union GCVML2_PERFCOUNTER2_1_MODE                         regGCVML2_PERFCOUNTER2_1_MODE;
typedef union GCVML2_PERFCOUNTER2_1_SELECT                       regGCVML2_PERFCOUNTER2_1_SELECT;
typedef union GCVML2_PERFCOUNTER2_1_SELECT1                      regGCVML2_PERFCOUNTER2_1_SELECT1;
typedef union GC_ATC_L2_PERFCOUNTER0_CFG                         regGC_ATC_L2_PERFCOUNTER0_CFG;
typedef union GC_ATC_L2_PERFCOUNTER1_CFG                         regGC_ATC_L2_PERFCOUNTER1_CFG;
typedef union GC_ATC_L2_PERFCOUNTER2_HI                          regGC_ATC_L2_PERFCOUNTER2_HI;
typedef union GC_ATC_L2_PERFCOUNTER2_LO                          regGC_ATC_L2_PERFCOUNTER2_LO;
typedef union GC_ATC_L2_PERFCOUNTER2_MODE                        regGC_ATC_L2_PERFCOUNTER2_MODE;
typedef union GC_ATC_L2_PERFCOUNTER2_SELECT                      regGC_ATC_L2_PERFCOUNTER2_SELECT;
typedef union GC_ATC_L2_PERFCOUNTER2_SELECT1                     regGC_ATC_L2_PERFCOUNTER2_SELECT1;
typedef union GC_ATC_L2_PERFCOUNTER_HI                           regGC_ATC_L2_PERFCOUNTER_HI;
typedef union GC_ATC_L2_PERFCOUNTER_LO                           regGC_ATC_L2_PERFCOUNTER_LO;
typedef union GC_ATC_L2_PERFCOUNTER_RSLT_CNTL                    regGC_ATC_L2_PERFCOUNTER_RSLT_CNTL;
typedef union GDS_PERFCOUNTER0_HI                                regGDS_PERFCOUNTER0_HI;
typedef union GDS_PERFCOUNTER0_LO                                regGDS_PERFCOUNTER0_LO;
typedef union GDS_PERFCOUNTER0_SELECT                            regGDS_PERFCOUNTER0_SELECT;
typedef union GDS_PERFCOUNTER0_SELECT1                           regGDS_PERFCOUNTER0_SELECT1;
typedef union GDS_PERFCOUNTER1_HI                                regGDS_PERFCOUNTER1_HI;
typedef union GDS_PERFCOUNTER1_LO                                regGDS_PERFCOUNTER1_LO;
typedef union GDS_PERFCOUNTER1_SELECT                            regGDS_PERFCOUNTER1_SELECT;
typedef union GDS_PERFCOUNTER1_SELECT1                           regGDS_PERFCOUNTER1_SELECT1;
typedef union GDS_PERFCOUNTER2_HI                                regGDS_PERFCOUNTER2_HI;
typedef union GDS_PERFCOUNTER2_LO                                regGDS_PERFCOUNTER2_LO;
typedef union GDS_PERFCOUNTER2_SELECT                            regGDS_PERFCOUNTER2_SELECT;
typedef union GDS_PERFCOUNTER2_SELECT1                           regGDS_PERFCOUNTER2_SELECT1;
typedef union GDS_PERFCOUNTER3_HI                                regGDS_PERFCOUNTER3_HI;
typedef union GDS_PERFCOUNTER3_LO                                regGDS_PERFCOUNTER3_LO;
typedef union GDS_PERFCOUNTER3_SELECT                            regGDS_PERFCOUNTER3_SELECT;
typedef union GDS_PERFCOUNTER3_SELECT1                           regGDS_PERFCOUNTER3_SELECT1;
typedef union GE1_PERFCOUNTER0_HI                                regGE1_PERFCOUNTER0_HI;
typedef union GE1_PERFCOUNTER0_LO                                regGE1_PERFCOUNTER0_LO;
typedef union GE1_PERFCOUNTER0_SELECT                            regGE1_PERFCOUNTER0_SELECT;
typedef union GE1_PERFCOUNTER0_SELECT1                           regGE1_PERFCOUNTER0_SELECT1;
typedef union GE1_PERFCOUNTER1_HI                                regGE1_PERFCOUNTER1_HI;
typedef union GE1_PERFCOUNTER1_LO                                regGE1_PERFCOUNTER1_LO;
typedef union GE1_PERFCOUNTER1_SELECT                            regGE1_PERFCOUNTER1_SELECT;
typedef union GE1_PERFCOUNTER1_SELECT1                           regGE1_PERFCOUNTER1_SELECT1;
typedef union GE1_PERFCOUNTER2_HI                                regGE1_PERFCOUNTER2_HI;
typedef union GE1_PERFCOUNTER2_LO                                regGE1_PERFCOUNTER2_LO;
typedef union GE1_PERFCOUNTER2_SELECT                            regGE1_PERFCOUNTER2_SELECT;
typedef union GE1_PERFCOUNTER2_SELECT1                           regGE1_PERFCOUNTER2_SELECT1;
typedef union GE1_PERFCOUNTER3_HI                                regGE1_PERFCOUNTER3_HI;
typedef union GE1_PERFCOUNTER3_LO                                regGE1_PERFCOUNTER3_LO;
typedef union GE1_PERFCOUNTER3_SELECT                            regGE1_PERFCOUNTER3_SELECT;
typedef union GE1_PERFCOUNTER3_SELECT1                           regGE1_PERFCOUNTER3_SELECT1;
typedef union GE2_DIST_PERFCOUNTER0_HI                           regGE2_DIST_PERFCOUNTER0_HI;
typedef union GE2_DIST_PERFCOUNTER0_LO                           regGE2_DIST_PERFCOUNTER0_LO;
typedef union GE2_DIST_PERFCOUNTER0_SELECT                       regGE2_DIST_PERFCOUNTER0_SELECT;
typedef union GE2_DIST_PERFCOUNTER0_SELECT1                      regGE2_DIST_PERFCOUNTER0_SELECT1;
typedef union GE2_DIST_PERFCOUNTER1_HI                           regGE2_DIST_PERFCOUNTER1_HI;
typedef union GE2_DIST_PERFCOUNTER1_LO                           regGE2_DIST_PERFCOUNTER1_LO;
typedef union GE2_DIST_PERFCOUNTER1_SELECT                       regGE2_DIST_PERFCOUNTER1_SELECT;
typedef union GE2_DIST_PERFCOUNTER1_SELECT1                      regGE2_DIST_PERFCOUNTER1_SELECT1;
typedef union GE2_DIST_PERFCOUNTER2_HI                           regGE2_DIST_PERFCOUNTER2_HI;
typedef union GE2_DIST_PERFCOUNTER2_LO                           regGE2_DIST_PERFCOUNTER2_LO;
typedef union GE2_DIST_PERFCOUNTER2_SELECT                       regGE2_DIST_PERFCOUNTER2_SELECT;
typedef union GE2_DIST_PERFCOUNTER2_SELECT1                      regGE2_DIST_PERFCOUNTER2_SELECT1;
typedef union GE2_DIST_PERFCOUNTER3_HI                           regGE2_DIST_PERFCOUNTER3_HI;
typedef union GE2_DIST_PERFCOUNTER3_LO                           regGE2_DIST_PERFCOUNTER3_LO;
typedef union GE2_DIST_PERFCOUNTER3_SELECT                       regGE2_DIST_PERFCOUNTER3_SELECT;
typedef union GE2_DIST_PERFCOUNTER3_SELECT1                      regGE2_DIST_PERFCOUNTER3_SELECT1;
typedef union GE2_SE_PERFCOUNTER0_HI                             regGE2_SE_PERFCOUNTER0_HI;
typedef union GE2_SE_PERFCOUNTER0_LO                             regGE2_SE_PERFCOUNTER0_LO;
typedef union GE2_SE_PERFCOUNTER0_SELECT                         regGE2_SE_PERFCOUNTER0_SELECT;
typedef union GE2_SE_PERFCOUNTER0_SELECT1                        regGE2_SE_PERFCOUNTER0_SELECT1;
typedef union GE2_SE_PERFCOUNTER1_HI                             regGE2_SE_PERFCOUNTER1_HI;
typedef union GE2_SE_PERFCOUNTER1_LO                             regGE2_SE_PERFCOUNTER1_LO;
typedef union GE2_SE_PERFCOUNTER1_SELECT                         regGE2_SE_PERFCOUNTER1_SELECT;
typedef union GE2_SE_PERFCOUNTER1_SELECT1                        regGE2_SE_PERFCOUNTER1_SELECT1;
typedef union GE2_SE_PERFCOUNTER2_HI                             regGE2_SE_PERFCOUNTER2_HI;
typedef union GE2_SE_PERFCOUNTER2_LO                             regGE2_SE_PERFCOUNTER2_LO;
typedef union GE2_SE_PERFCOUNTER2_SELECT                         regGE2_SE_PERFCOUNTER2_SELECT;
typedef union GE2_SE_PERFCOUNTER2_SELECT1                        regGE2_SE_PERFCOUNTER2_SELECT1;
typedef union GE2_SE_PERFCOUNTER3_HI                             regGE2_SE_PERFCOUNTER3_HI;
typedef union GE2_SE_PERFCOUNTER3_LO                             regGE2_SE_PERFCOUNTER3_LO;
typedef union GE2_SE_PERFCOUNTER3_SELECT                         regGE2_SE_PERFCOUNTER3_SELECT;
typedef union GE2_SE_PERFCOUNTER3_SELECT1                        regGE2_SE_PERFCOUNTER3_SELECT1;
typedef union GE_CNTL                                            regGE_CNTL;
typedef union GE_DMA_FIRST_INDEX                                 regGE_DMA_FIRST_INDEX;
typedef union GE_FAST_CLKS                                       regGE_FAST_CLKS;
typedef union GE_FED_STATUS                                      regGE_FED_STATUS;
typedef union GE_GS_FAST_LAUNCH_WG_DIM                           regGE_GS_FAST_LAUNCH_WG_DIM;
typedef union GE_GS_FAST_LAUNCH_WG_DIM_1                         regGE_GS_FAST_LAUNCH_WG_DIM_1;
typedef union GE_INDX_OFFSET                                     regGE_INDX_OFFSET;
typedef union GE_MAX_OUTPUT_PER_SUBGROUP                         regGE_MAX_OUTPUT_PER_SUBGROUP;
typedef union GE_MAX_VTX_INDX                                    regGE_MAX_VTX_INDX;
typedef union GE_MIN_VTX_INDX                                    regGE_MIN_VTX_INDX;
typedef union GE_MULTI_PRIM_IB_RESET_EN                          regGE_MULTI_PRIM_IB_RESET_EN;
typedef union GE_NGG_SUBGRP_CNTL                                 regGE_NGG_SUBGRP_CNTL;
typedef union GE_PA_IF_SAFE_REG                                  regGE_PA_IF_SAFE_REG;
typedef union GE_PC_ALLOC                                        regGE_PC_ALLOC;
typedef union GE_PC_CNTL                                         regGE_PC_CNTL;
typedef union GE_PERFCOUNTER0_HI                                 regGE_PERFCOUNTER0_HI;
typedef union GE_PERFCOUNTER0_LO                                 regGE_PERFCOUNTER0_LO;
typedef union GE_PERFCOUNTER0_SELECT                             regGE_PERFCOUNTER0_SELECT;
typedef union GE_PERFCOUNTER0_SELECT1                            regGE_PERFCOUNTER0_SELECT1;
typedef union GE_PERFCOUNTER1_HI                                 regGE_PERFCOUNTER1_HI;
typedef union GE_PERFCOUNTER1_LO                                 regGE_PERFCOUNTER1_LO;
typedef union GE_PERFCOUNTER1_SELECT                             regGE_PERFCOUNTER1_SELECT;
typedef union GE_PERFCOUNTER1_SELECT1                            regGE_PERFCOUNTER1_SELECT1;
typedef union GE_PERFCOUNTER2_HI                                 regGE_PERFCOUNTER2_HI;
typedef union GE_PERFCOUNTER2_LO                                 regGE_PERFCOUNTER2_LO;
typedef union GE_PERFCOUNTER2_SELECT                             regGE_PERFCOUNTER2_SELECT;
typedef union GE_PERFCOUNTER2_SELECT1                            regGE_PERFCOUNTER2_SELECT1;
typedef union GE_PERFCOUNTER3_HI                                 regGE_PERFCOUNTER3_HI;
typedef union GE_PERFCOUNTER3_LO                                 regGE_PERFCOUNTER3_LO;
typedef union GE_PERFCOUNTER3_SELECT                             regGE_PERFCOUNTER3_SELECT;
typedef union GE_PERFCOUNTER3_SELECT1                            regGE_PERFCOUNTER3_SELECT1;
typedef union GE_PERFCOUNTER4_HI                                 regGE_PERFCOUNTER4_HI;
typedef union GE_PERFCOUNTER4_LO                                 regGE_PERFCOUNTER4_LO;
typedef union GE_PERFCOUNTER4_SELECT                             regGE_PERFCOUNTER4_SELECT;
typedef union GE_PERFCOUNTER5_HI                                 regGE_PERFCOUNTER5_HI;
typedef union GE_PERFCOUNTER5_LO                                 regGE_PERFCOUNTER5_LO;
typedef union GE_PERFCOUNTER5_SELECT                             regGE_PERFCOUNTER5_SELECT;
typedef union GE_PERFCOUNTER6_HI                                 regGE_PERFCOUNTER6_HI;
typedef union GE_PERFCOUNTER6_LO                                 regGE_PERFCOUNTER6_LO;
typedef union GE_PERFCOUNTER6_SELECT                             regGE_PERFCOUNTER6_SELECT;
typedef union GE_PERFCOUNTER7_HI                                 regGE_PERFCOUNTER7_HI;
typedef union GE_PERFCOUNTER7_LO                                 regGE_PERFCOUNTER7_LO;
typedef union GE_PERFCOUNTER7_SELECT                             regGE_PERFCOUNTER7_SELECT;
typedef union GE_PERFCOUNTER8_HI                                 regGE_PERFCOUNTER8_HI;
typedef union GE_PERFCOUNTER8_LO                                 regGE_PERFCOUNTER8_LO;
typedef union GE_PERFCOUNTER8_SELECT                             regGE_PERFCOUNTER8_SELECT;
typedef union GE_PERFCOUNTER9_HI                                 regGE_PERFCOUNTER9_HI;
typedef union GE_PERFCOUNTER9_LO                                 regGE_PERFCOUNTER9_LO;
typedef union GE_PERFCOUNTER9_SELECT                             regGE_PERFCOUNTER9_SELECT;
typedef union GE_PERFCOUNTER10_HI                                regGE_PERFCOUNTER10_HI;
typedef union GE_PERFCOUNTER10_LO                                regGE_PERFCOUNTER10_LO;
typedef union GE_PERFCOUNTER10_SELECT                            regGE_PERFCOUNTER10_SELECT;
typedef union GE_PERFCOUNTER11_HI                                regGE_PERFCOUNTER11_HI;
typedef union GE_PERFCOUNTER11_LO                                regGE_PERFCOUNTER11_LO;
typedef union GE_PERFCOUNTER11_SELECT                            regGE_PERFCOUNTER11_SELECT;
typedef union GE_PRIV_CONTROL                                    regGE_PRIV_CONTROL;
typedef union GE_RATE_CNTL_1                                     regGE_RATE_CNTL_1;
typedef union GE_RATE_CNTL_2                                     regGE_RATE_CNTL_2;
typedef union GE_SPI_IF_SAFE_REG                                 regGE_SPI_IF_SAFE_REG;
typedef union GE_STATUS                                          regGE_STATUS;
typedef union GE_STEREO_CNTL                                     regGE_STEREO_CNTL;
typedef union GE_USER_VGPR1                                      regGE_USER_VGPR1;
typedef union GE_USER_VGPR2                                      regGE_USER_VGPR2;
typedef union GE_USER_VGPR3                                      regGE_USER_VGPR3;
typedef union GE_USER_VGPR_EN                                    regGE_USER_VGPR_EN;
typedef union GE_VRS_RATE                                        regGE_VRS_RATE;
typedef union GL1A_PERFCOUNTER0_HI                               regGL1A_PERFCOUNTER0_HI;
typedef union GL1A_PERFCOUNTER0_LO                               regGL1A_PERFCOUNTER0_LO;
typedef union GL1A_PERFCOUNTER0_SELECT                           regGL1A_PERFCOUNTER0_SELECT;
typedef union GL1A_PERFCOUNTER0_SELECT1                          regGL1A_PERFCOUNTER0_SELECT1;
typedef union GL1A_PERFCOUNTER1_HI                               regGL1A_PERFCOUNTER1_HI;
typedef union GL1A_PERFCOUNTER1_LO                               regGL1A_PERFCOUNTER1_LO;
typedef union GL1A_PERFCOUNTER1_SELECT                           regGL1A_PERFCOUNTER1_SELECT;
typedef union GL1A_PERFCOUNTER2_HI                               regGL1A_PERFCOUNTER2_HI;
typedef union GL1A_PERFCOUNTER2_LO                               regGL1A_PERFCOUNTER2_LO;
typedef union GL1A_PERFCOUNTER2_SELECT                           regGL1A_PERFCOUNTER2_SELECT;
typedef union GL1A_PERFCOUNTER3_HI                               regGL1A_PERFCOUNTER3_HI;
typedef union GL1A_PERFCOUNTER3_LO                               regGL1A_PERFCOUNTER3_LO;
typedef union GL1A_PERFCOUNTER3_SELECT                           regGL1A_PERFCOUNTER3_SELECT;
typedef union GL1C_PERFCOUNTER0_HI                               regGL1C_PERFCOUNTER0_HI;
typedef union GL1C_PERFCOUNTER0_LO                               regGL1C_PERFCOUNTER0_LO;
typedef union GL1C_PERFCOUNTER0_SELECT                           regGL1C_PERFCOUNTER0_SELECT;
typedef union GL1C_PERFCOUNTER0_SELECT1                          regGL1C_PERFCOUNTER0_SELECT1;
typedef union GL1C_PERFCOUNTER1_HI                               regGL1C_PERFCOUNTER1_HI;
typedef union GL1C_PERFCOUNTER1_LO                               regGL1C_PERFCOUNTER1_LO;
typedef union GL1C_PERFCOUNTER1_SELECT                           regGL1C_PERFCOUNTER1_SELECT;
typedef union GL1C_PERFCOUNTER2_HI                               regGL1C_PERFCOUNTER2_HI;
typedef union GL1C_PERFCOUNTER2_LO                               regGL1C_PERFCOUNTER2_LO;
typedef union GL1C_PERFCOUNTER2_SELECT                           regGL1C_PERFCOUNTER2_SELECT;
typedef union GL1C_PERFCOUNTER3_HI                               regGL1C_PERFCOUNTER3_HI;
typedef union GL1C_PERFCOUNTER3_LO                               regGL1C_PERFCOUNTER3_LO;
typedef union GL1C_PERFCOUNTER3_SELECT                           regGL1C_PERFCOUNTER3_SELECT;
typedef union GL2A_PERFCOUNTER0_HI                               regGL2A_PERFCOUNTER0_HI;
typedef union GL2A_PERFCOUNTER0_LO                               regGL2A_PERFCOUNTER0_LO;
typedef union GL2A_PERFCOUNTER0_SELECT                           regGL2A_PERFCOUNTER0_SELECT;
typedef union GL2A_PERFCOUNTER0_SELECT1                          regGL2A_PERFCOUNTER0_SELECT1;
typedef union GL2A_PERFCOUNTER1_HI                               regGL2A_PERFCOUNTER1_HI;
typedef union GL2A_PERFCOUNTER1_LO                               regGL2A_PERFCOUNTER1_LO;
typedef union GL2A_PERFCOUNTER1_SELECT                           regGL2A_PERFCOUNTER1_SELECT;
typedef union GL2A_PERFCOUNTER1_SELECT1                          regGL2A_PERFCOUNTER1_SELECT1;
typedef union GL2A_PERFCOUNTER2_HI                               regGL2A_PERFCOUNTER2_HI;
typedef union GL2A_PERFCOUNTER2_LO                               regGL2A_PERFCOUNTER2_LO;
typedef union GL2A_PERFCOUNTER2_SELECT                           regGL2A_PERFCOUNTER2_SELECT;
typedef union GL2A_PERFCOUNTER3_HI                               regGL2A_PERFCOUNTER3_HI;
typedef union GL2A_PERFCOUNTER3_LO                               regGL2A_PERFCOUNTER3_LO;
typedef union GL2A_PERFCOUNTER3_SELECT                           regGL2A_PERFCOUNTER3_SELECT;
typedef union GL2C_PERFCOUNTER0_HI                               regGL2C_PERFCOUNTER0_HI;
typedef union GL2C_PERFCOUNTER0_LO                               regGL2C_PERFCOUNTER0_LO;
typedef union GL2C_PERFCOUNTER0_SELECT                           regGL2C_PERFCOUNTER0_SELECT;
typedef union GL2C_PERFCOUNTER0_SELECT1                          regGL2C_PERFCOUNTER0_SELECT1;
typedef union GL2C_PERFCOUNTER1_HI                               regGL2C_PERFCOUNTER1_HI;
typedef union GL2C_PERFCOUNTER1_LO                               regGL2C_PERFCOUNTER1_LO;
typedef union GL2C_PERFCOUNTER1_SELECT                           regGL2C_PERFCOUNTER1_SELECT;
typedef union GL2C_PERFCOUNTER1_SELECT1                          regGL2C_PERFCOUNTER1_SELECT1;
typedef union GL2C_PERFCOUNTER2_HI                               regGL2C_PERFCOUNTER2_HI;
typedef union GL2C_PERFCOUNTER2_LO                               regGL2C_PERFCOUNTER2_LO;
typedef union GL2C_PERFCOUNTER2_SELECT                           regGL2C_PERFCOUNTER2_SELECT;
typedef union GL2C_PERFCOUNTER3_HI                               regGL2C_PERFCOUNTER3_HI;
typedef union GL2C_PERFCOUNTER3_LO                               regGL2C_PERFCOUNTER3_LO;
typedef union GL2C_PERFCOUNTER3_SELECT                           regGL2C_PERFCOUNTER3_SELECT;
typedef union GRBM_CHIP_REVISION                                 regGRBM_CHIP_REVISION;
typedef union GRBM_GFX_INDEX                                     regGRBM_GFX_INDEX;
typedef union GRBM_GFX_INDEX_SR_DATA                             regGRBM_GFX_INDEX_SR_DATA;
typedef union GRBM_GFX_INDEX_SR_SELECT                           regGRBM_GFX_INDEX_SR_SELECT;
typedef union GRBM_PERFCOUNTER0_HI                               regGRBM_PERFCOUNTER0_HI;
typedef union GRBM_PERFCOUNTER0_LO                               regGRBM_PERFCOUNTER0_LO;
typedef union GRBM_PERFCOUNTER0_SELECT                           regGRBM_PERFCOUNTER0_SELECT;
typedef union GRBM_PERFCOUNTER0_SELECT_HI                        regGRBM_PERFCOUNTER0_SELECT_HI;
typedef union GRBM_PERFCOUNTER1_HI                               regGRBM_PERFCOUNTER1_HI;
typedef union GRBM_PERFCOUNTER1_LO                               regGRBM_PERFCOUNTER1_LO;
typedef union GRBM_PERFCOUNTER1_SELECT                           regGRBM_PERFCOUNTER1_SELECT;
typedef union GRBM_PERFCOUNTER1_SELECT_HI                        regGRBM_PERFCOUNTER1_SELECT_HI;
typedef union GRBM_SE0_PERFCOUNTER_HI                            regGRBM_SE0_PERFCOUNTER_HI;
typedef union GRBM_SE0_PERFCOUNTER_LO                            regGRBM_SE0_PERFCOUNTER_LO;
typedef union GRBM_SE0_PERFCOUNTER_SELECT                        regGRBM_SE0_PERFCOUNTER_SELECT;
typedef union GRBM_SE1_PERFCOUNTER_HI                            regGRBM_SE1_PERFCOUNTER_HI;
typedef union GRBM_SE1_PERFCOUNTER_LO                            regGRBM_SE1_PERFCOUNTER_LO;
typedef union GRBM_SE1_PERFCOUNTER_SELECT                        regGRBM_SE1_PERFCOUNTER_SELECT;
typedef union GRBM_SE2_PERFCOUNTER_HI                            regGRBM_SE2_PERFCOUNTER_HI;
typedef union GRBM_SE2_PERFCOUNTER_LO                            regGRBM_SE2_PERFCOUNTER_LO;
typedef union GRBM_SE2_PERFCOUNTER_SELECT                        regGRBM_SE2_PERFCOUNTER_SELECT;
typedef union GRBM_SE3_PERFCOUNTER_HI                            regGRBM_SE3_PERFCOUNTER_HI;
typedef union GRBM_SE3_PERFCOUNTER_LO                            regGRBM_SE3_PERFCOUNTER_LO;
typedef union GRBM_SE3_PERFCOUNTER_SELECT                        regGRBM_SE3_PERFCOUNTER_SELECT;
typedef union GRBM_SE4_PERFCOUNTER_HI                            regGRBM_SE4_PERFCOUNTER_HI;
typedef union GRBM_SE4_PERFCOUNTER_LO                            regGRBM_SE4_PERFCOUNTER_LO;
typedef union GRBM_SE4_PERFCOUNTER_SELECT                        regGRBM_SE4_PERFCOUNTER_SELECT;
typedef union GRBM_SE5_PERFCOUNTER_HI                            regGRBM_SE5_PERFCOUNTER_HI;
typedef union GRBM_SE5_PERFCOUNTER_LO                            regGRBM_SE5_PERFCOUNTER_LO;
typedef union GRBM_SE5_PERFCOUNTER_SELECT                        regGRBM_SE5_PERFCOUNTER_SELECT;
typedef union GRBM_SE6_PERFCOUNTER_HI                            regGRBM_SE6_PERFCOUNTER_HI;
typedef union GRBM_SE6_PERFCOUNTER_LO                            regGRBM_SE6_PERFCOUNTER_LO;
typedef union GRBM_SE6_PERFCOUNTER_SELECT                        regGRBM_SE6_PERFCOUNTER_SELECT;
typedef union GUS_PERFCOUNTER0_CFG                               regGUS_PERFCOUNTER0_CFG;
typedef union GUS_PERFCOUNTER1_CFG                               regGUS_PERFCOUNTER1_CFG;
typedef union GUS_PERFCOUNTER2_HI                                regGUS_PERFCOUNTER2_HI;
typedef union GUS_PERFCOUNTER2_LO                                regGUS_PERFCOUNTER2_LO;
typedef union GUS_PERFCOUNTER2_MODE                              regGUS_PERFCOUNTER2_MODE;
typedef union GUS_PERFCOUNTER2_SELECT                            regGUS_PERFCOUNTER2_SELECT;
typedef union GUS_PERFCOUNTER2_SELECT1                           regGUS_PERFCOUNTER2_SELECT1;
typedef union GUS_PERFCOUNTER_HI                                 regGUS_PERFCOUNTER_HI;
typedef union GUS_PERFCOUNTER_LO                                 regGUS_PERFCOUNTER_LO;
typedef union GUS_PERFCOUNTER_RSLT_CNTL                          regGUS_PERFCOUNTER_RSLT_CNTL;
typedef union IA_ENHANCE                                         regIA_ENHANCE;
typedef union IA_MULTI_VGT_PARAM                                 regIA_MULTI_VGT_PARAM;
typedef union IA_MULTI_VGT_PARAM_PIPED                           regIA_MULTI_VGT_PARAM_PIPED;
typedef union IA_UTCL1_CNTL                                      regIA_UTCL1_CNTL;
typedef union IA_UTCL1_STATUS                                    regIA_UTCL1_STATUS;
typedef union IA_UTCL1_STATUS_2                                  regIA_UTCL1_STATUS_2;
typedef union MP1_SMN_FPS_CNT                                    regMP1_SMN_FPS_CNT;
typedef union PA_CL_CLIP_CNTL                                    regPA_CL_CLIP_CNTL;
typedef union PA_CL_CNTL_STATUS                                  regPA_CL_CNTL_STATUS;
typedef union PA_CL_ENHANCE                                      regPA_CL_ENHANCE;
typedef union PA_CL_GB_HORZ_CLIP_ADJ                             regPA_CL_GB_HORZ_CLIP_ADJ;
typedef union PA_CL_GB_HORZ_DISC_ADJ                             regPA_CL_GB_HORZ_DISC_ADJ;
typedef union PA_CL_GB_VERT_CLIP_ADJ                             regPA_CL_GB_VERT_CLIP_ADJ;
typedef union PA_CL_GB_VERT_DISC_ADJ                             regPA_CL_GB_VERT_DISC_ADJ;
typedef union PA_CL_NANINF_CNTL                                  regPA_CL_NANINF_CNTL;
typedef union PA_CL_NGG_CNTL                                     regPA_CL_NGG_CNTL;
typedef union PA_CL_POINT_CULL_RAD                               regPA_CL_POINT_CULL_RAD;
typedef union PA_CL_POINT_SIZE                                   regPA_CL_POINT_SIZE;
typedef union PA_CL_POINT_X_RAD                                  regPA_CL_POINT_X_RAD;
typedef union PA_CL_POINT_Y_RAD                                  regPA_CL_POINT_Y_RAD;
typedef union PA_CL_PROG_NEAR_CLIP_Z                             regPA_CL_PROG_NEAR_CLIP_Z;
typedef union PA_CL_UCP_0_W                                      regPA_CL_UCP_0_W;
typedef union PA_CL_UCP_0_X                                      regPA_CL_UCP_0_X;
typedef union PA_CL_UCP_0_Y                                      regPA_CL_UCP_0_Y;
typedef union PA_CL_UCP_0_Z                                      regPA_CL_UCP_0_Z;
typedef union PA_CL_UCP_1_W                                      regPA_CL_UCP_1_W;
typedef union PA_CL_UCP_1_X                                      regPA_CL_UCP_1_X;
typedef union PA_CL_UCP_1_Y                                      regPA_CL_UCP_1_Y;
typedef union PA_CL_UCP_1_Z                                      regPA_CL_UCP_1_Z;
typedef union PA_CL_UCP_2_W                                      regPA_CL_UCP_2_W;
typedef union PA_CL_UCP_2_X                                      regPA_CL_UCP_2_X;
typedef union PA_CL_UCP_2_Y                                      regPA_CL_UCP_2_Y;
typedef union PA_CL_UCP_2_Z                                      regPA_CL_UCP_2_Z;
typedef union PA_CL_UCP_3_W                                      regPA_CL_UCP_3_W;
typedef union PA_CL_UCP_3_X                                      regPA_CL_UCP_3_X;
typedef union PA_CL_UCP_3_Y                                      regPA_CL_UCP_3_Y;
typedef union PA_CL_UCP_3_Z                                      regPA_CL_UCP_3_Z;
typedef union PA_CL_UCP_4_W                                      regPA_CL_UCP_4_W;
typedef union PA_CL_UCP_4_X                                      regPA_CL_UCP_4_X;
typedef union PA_CL_UCP_4_Y                                      regPA_CL_UCP_4_Y;
typedef union PA_CL_UCP_4_Z                                      regPA_CL_UCP_4_Z;
typedef union PA_CL_UCP_5_W                                      regPA_CL_UCP_5_W;
typedef union PA_CL_UCP_5_X                                      regPA_CL_UCP_5_X;
typedef union PA_CL_UCP_5_Y                                      regPA_CL_UCP_5_Y;
typedef union PA_CL_UCP_5_Z                                      regPA_CL_UCP_5_Z;
typedef union PA_CL_VPORT_XOFFSET                                regPA_CL_VPORT_XOFFSET;
typedef union PA_CL_VPORT_XOFFSET_1                              regPA_CL_VPORT_XOFFSET_1;
typedef union PA_CL_VPORT_XOFFSET_2                              regPA_CL_VPORT_XOFFSET_2;
typedef union PA_CL_VPORT_XOFFSET_3                              regPA_CL_VPORT_XOFFSET_3;
typedef union PA_CL_VPORT_XOFFSET_4                              regPA_CL_VPORT_XOFFSET_4;
typedef union PA_CL_VPORT_XOFFSET_5                              regPA_CL_VPORT_XOFFSET_5;
typedef union PA_CL_VPORT_XOFFSET_6                              regPA_CL_VPORT_XOFFSET_6;
typedef union PA_CL_VPORT_XOFFSET_7                              regPA_CL_VPORT_XOFFSET_7;
typedef union PA_CL_VPORT_XOFFSET_8                              regPA_CL_VPORT_XOFFSET_8;
typedef union PA_CL_VPORT_XOFFSET_9                              regPA_CL_VPORT_XOFFSET_9;
typedef union PA_CL_VPORT_XOFFSET_10                             regPA_CL_VPORT_XOFFSET_10;
typedef union PA_CL_VPORT_XOFFSET_11                             regPA_CL_VPORT_XOFFSET_11;
typedef union PA_CL_VPORT_XOFFSET_12                             regPA_CL_VPORT_XOFFSET_12;
typedef union PA_CL_VPORT_XOFFSET_13                             regPA_CL_VPORT_XOFFSET_13;
typedef union PA_CL_VPORT_XOFFSET_14                             regPA_CL_VPORT_XOFFSET_14;
typedef union PA_CL_VPORT_XOFFSET_15                             regPA_CL_VPORT_XOFFSET_15;
typedef union PA_CL_VPORT_XSCALE                                 regPA_CL_VPORT_XSCALE;
typedef union PA_CL_VPORT_XSCALE_1                               regPA_CL_VPORT_XSCALE_1;
typedef union PA_CL_VPORT_XSCALE_2                               regPA_CL_VPORT_XSCALE_2;
typedef union PA_CL_VPORT_XSCALE_3                               regPA_CL_VPORT_XSCALE_3;
typedef union PA_CL_VPORT_XSCALE_4                               regPA_CL_VPORT_XSCALE_4;
typedef union PA_CL_VPORT_XSCALE_5                               regPA_CL_VPORT_XSCALE_5;
typedef union PA_CL_VPORT_XSCALE_6                               regPA_CL_VPORT_XSCALE_6;
typedef union PA_CL_VPORT_XSCALE_7                               regPA_CL_VPORT_XSCALE_7;
typedef union PA_CL_VPORT_XSCALE_8                               regPA_CL_VPORT_XSCALE_8;
typedef union PA_CL_VPORT_XSCALE_9                               regPA_CL_VPORT_XSCALE_9;
typedef union PA_CL_VPORT_XSCALE_10                              regPA_CL_VPORT_XSCALE_10;
typedef union PA_CL_VPORT_XSCALE_11                              regPA_CL_VPORT_XSCALE_11;
typedef union PA_CL_VPORT_XSCALE_12                              regPA_CL_VPORT_XSCALE_12;
typedef union PA_CL_VPORT_XSCALE_13                              regPA_CL_VPORT_XSCALE_13;
typedef union PA_CL_VPORT_XSCALE_14                              regPA_CL_VPORT_XSCALE_14;
typedef union PA_CL_VPORT_XSCALE_15                              regPA_CL_VPORT_XSCALE_15;
typedef union PA_CL_VPORT_YOFFSET                                regPA_CL_VPORT_YOFFSET;
typedef union PA_CL_VPORT_YOFFSET_1                              regPA_CL_VPORT_YOFFSET_1;
typedef union PA_CL_VPORT_YOFFSET_2                              regPA_CL_VPORT_YOFFSET_2;
typedef union PA_CL_VPORT_YOFFSET_3                              regPA_CL_VPORT_YOFFSET_3;
typedef union PA_CL_VPORT_YOFFSET_4                              regPA_CL_VPORT_YOFFSET_4;
typedef union PA_CL_VPORT_YOFFSET_5                              regPA_CL_VPORT_YOFFSET_5;
typedef union PA_CL_VPORT_YOFFSET_6                              regPA_CL_VPORT_YOFFSET_6;
typedef union PA_CL_VPORT_YOFFSET_7                              regPA_CL_VPORT_YOFFSET_7;
typedef union PA_CL_VPORT_YOFFSET_8                              regPA_CL_VPORT_YOFFSET_8;
typedef union PA_CL_VPORT_YOFFSET_9                              regPA_CL_VPORT_YOFFSET_9;
typedef union PA_CL_VPORT_YOFFSET_10                             regPA_CL_VPORT_YOFFSET_10;
typedef union PA_CL_VPORT_YOFFSET_11                             regPA_CL_VPORT_YOFFSET_11;
typedef union PA_CL_VPORT_YOFFSET_12                             regPA_CL_VPORT_YOFFSET_12;
typedef union PA_CL_VPORT_YOFFSET_13                             regPA_CL_VPORT_YOFFSET_13;
typedef union PA_CL_VPORT_YOFFSET_14                             regPA_CL_VPORT_YOFFSET_14;
typedef union PA_CL_VPORT_YOFFSET_15                             regPA_CL_VPORT_YOFFSET_15;
typedef union PA_CL_VPORT_YSCALE                                 regPA_CL_VPORT_YSCALE;
typedef union PA_CL_VPORT_YSCALE_1                               regPA_CL_VPORT_YSCALE_1;
typedef union PA_CL_VPORT_YSCALE_2                               regPA_CL_VPORT_YSCALE_2;
typedef union PA_CL_VPORT_YSCALE_3                               regPA_CL_VPORT_YSCALE_3;
typedef union PA_CL_VPORT_YSCALE_4                               regPA_CL_VPORT_YSCALE_4;
typedef union PA_CL_VPORT_YSCALE_5                               regPA_CL_VPORT_YSCALE_5;
typedef union PA_CL_VPORT_YSCALE_6                               regPA_CL_VPORT_YSCALE_6;
typedef union PA_CL_VPORT_YSCALE_7                               regPA_CL_VPORT_YSCALE_7;
typedef union PA_CL_VPORT_YSCALE_8                               regPA_CL_VPORT_YSCALE_8;
typedef union PA_CL_VPORT_YSCALE_9                               regPA_CL_VPORT_YSCALE_9;
typedef union PA_CL_VPORT_YSCALE_10                              regPA_CL_VPORT_YSCALE_10;
typedef union PA_CL_VPORT_YSCALE_11                              regPA_CL_VPORT_YSCALE_11;
typedef union PA_CL_VPORT_YSCALE_12                              regPA_CL_VPORT_YSCALE_12;
typedef union PA_CL_VPORT_YSCALE_13                              regPA_CL_VPORT_YSCALE_13;
typedef union PA_CL_VPORT_YSCALE_14                              regPA_CL_VPORT_YSCALE_14;
typedef union PA_CL_VPORT_YSCALE_15                              regPA_CL_VPORT_YSCALE_15;
typedef union PA_CL_VPORT_ZOFFSET                                regPA_CL_VPORT_ZOFFSET;
typedef union PA_CL_VPORT_ZOFFSET_1                              regPA_CL_VPORT_ZOFFSET_1;
typedef union PA_CL_VPORT_ZOFFSET_2                              regPA_CL_VPORT_ZOFFSET_2;
typedef union PA_CL_VPORT_ZOFFSET_3                              regPA_CL_VPORT_ZOFFSET_3;
typedef union PA_CL_VPORT_ZOFFSET_4                              regPA_CL_VPORT_ZOFFSET_4;
typedef union PA_CL_VPORT_ZOFFSET_5                              regPA_CL_VPORT_ZOFFSET_5;
typedef union PA_CL_VPORT_ZOFFSET_6                              regPA_CL_VPORT_ZOFFSET_6;
typedef union PA_CL_VPORT_ZOFFSET_7                              regPA_CL_VPORT_ZOFFSET_7;
typedef union PA_CL_VPORT_ZOFFSET_8                              regPA_CL_VPORT_ZOFFSET_8;
typedef union PA_CL_VPORT_ZOFFSET_9                              regPA_CL_VPORT_ZOFFSET_9;
typedef union PA_CL_VPORT_ZOFFSET_10                             regPA_CL_VPORT_ZOFFSET_10;
typedef union PA_CL_VPORT_ZOFFSET_11                             regPA_CL_VPORT_ZOFFSET_11;
typedef union PA_CL_VPORT_ZOFFSET_12                             regPA_CL_VPORT_ZOFFSET_12;
typedef union PA_CL_VPORT_ZOFFSET_13                             regPA_CL_VPORT_ZOFFSET_13;
typedef union PA_CL_VPORT_ZOFFSET_14                             regPA_CL_VPORT_ZOFFSET_14;
typedef union PA_CL_VPORT_ZOFFSET_15                             regPA_CL_VPORT_ZOFFSET_15;
typedef union PA_CL_VPORT_ZSCALE                                 regPA_CL_VPORT_ZSCALE;
typedef union PA_CL_VPORT_ZSCALE_1                               regPA_CL_VPORT_ZSCALE_1;
typedef union PA_CL_VPORT_ZSCALE_2                               regPA_CL_VPORT_ZSCALE_2;
typedef union PA_CL_VPORT_ZSCALE_3                               regPA_CL_VPORT_ZSCALE_3;
typedef union PA_CL_VPORT_ZSCALE_4                               regPA_CL_VPORT_ZSCALE_4;
typedef union PA_CL_VPORT_ZSCALE_5                               regPA_CL_VPORT_ZSCALE_5;
typedef union PA_CL_VPORT_ZSCALE_6                               regPA_CL_VPORT_ZSCALE_6;
typedef union PA_CL_VPORT_ZSCALE_7                               regPA_CL_VPORT_ZSCALE_7;
typedef union PA_CL_VPORT_ZSCALE_8                               regPA_CL_VPORT_ZSCALE_8;
typedef union PA_CL_VPORT_ZSCALE_9                               regPA_CL_VPORT_ZSCALE_9;
typedef union PA_CL_VPORT_ZSCALE_10                              regPA_CL_VPORT_ZSCALE_10;
typedef union PA_CL_VPORT_ZSCALE_11                              regPA_CL_VPORT_ZSCALE_11;
typedef union PA_CL_VPORT_ZSCALE_12                              regPA_CL_VPORT_ZSCALE_12;
typedef union PA_CL_VPORT_ZSCALE_13                              regPA_CL_VPORT_ZSCALE_13;
typedef union PA_CL_VPORT_ZSCALE_14                              regPA_CL_VPORT_ZSCALE_14;
typedef union PA_CL_VPORT_ZSCALE_15                              regPA_CL_VPORT_ZSCALE_15;
typedef union PA_CL_VRS_CNTL                                     regPA_CL_VRS_CNTL;
typedef union PA_CL_VS_OUT_CNTL                                  regPA_CL_VS_OUT_CNTL;
typedef union PA_CL_VTE_CNTL                                     regPA_CL_VTE_CNTL;
typedef union PA_PH_ENHANCE                                      regPA_PH_ENHANCE;
typedef union PA_PH_INTERFACE_FIFO_SIZE                          regPA_PH_INTERFACE_FIFO_SIZE;
typedef union PA_PH_PERFCOUNTER0_HI                              regPA_PH_PERFCOUNTER0_HI;
typedef union PA_PH_PERFCOUNTER0_LO                              regPA_PH_PERFCOUNTER0_LO;
typedef union PA_PH_PERFCOUNTER0_SELECT                          regPA_PH_PERFCOUNTER0_SELECT;
typedef union PA_PH_PERFCOUNTER0_SELECT1                         regPA_PH_PERFCOUNTER0_SELECT1;
typedef union PA_PH_PERFCOUNTER1_HI                              regPA_PH_PERFCOUNTER1_HI;
typedef union PA_PH_PERFCOUNTER1_LO                              regPA_PH_PERFCOUNTER1_LO;
typedef union PA_PH_PERFCOUNTER1_SELECT                          regPA_PH_PERFCOUNTER1_SELECT;
typedef union PA_PH_PERFCOUNTER1_SELECT1                         regPA_PH_PERFCOUNTER1_SELECT1;
typedef union PA_PH_PERFCOUNTER2_HI                              regPA_PH_PERFCOUNTER2_HI;
typedef union PA_PH_PERFCOUNTER2_LO                              regPA_PH_PERFCOUNTER2_LO;
typedef union PA_PH_PERFCOUNTER2_SELECT                          regPA_PH_PERFCOUNTER2_SELECT;
typedef union PA_PH_PERFCOUNTER2_SELECT1                         regPA_PH_PERFCOUNTER2_SELECT1;
typedef union PA_PH_PERFCOUNTER3_HI                              regPA_PH_PERFCOUNTER3_HI;
typedef union PA_PH_PERFCOUNTER3_LO                              regPA_PH_PERFCOUNTER3_LO;
typedef union PA_PH_PERFCOUNTER3_SELECT                          regPA_PH_PERFCOUNTER3_SELECT;
typedef union PA_PH_PERFCOUNTER3_SELECT1                         regPA_PH_PERFCOUNTER3_SELECT1;
typedef union PA_PH_PERFCOUNTER4_HI                              regPA_PH_PERFCOUNTER4_HI;
typedef union PA_PH_PERFCOUNTER4_LO                              regPA_PH_PERFCOUNTER4_LO;
typedef union PA_PH_PERFCOUNTER4_SELECT                          regPA_PH_PERFCOUNTER4_SELECT;
typedef union PA_PH_PERFCOUNTER5_HI                              regPA_PH_PERFCOUNTER5_HI;
typedef union PA_PH_PERFCOUNTER5_LO                              regPA_PH_PERFCOUNTER5_LO;
typedef union PA_PH_PERFCOUNTER5_SELECT                          regPA_PH_PERFCOUNTER5_SELECT;
typedef union PA_PH_PERFCOUNTER6_HI                              regPA_PH_PERFCOUNTER6_HI;
typedef union PA_PH_PERFCOUNTER6_LO                              regPA_PH_PERFCOUNTER6_LO;
typedef union PA_PH_PERFCOUNTER6_SELECT                          regPA_PH_PERFCOUNTER6_SELECT;
typedef union PA_PH_PERFCOUNTER7_HI                              regPA_PH_PERFCOUNTER7_HI;
typedef union PA_PH_PERFCOUNTER7_LO                              regPA_PH_PERFCOUNTER7_LO;
typedef union PA_PH_PERFCOUNTER7_SELECT                          regPA_PH_PERFCOUNTER7_SELECT;
typedef union PA_RATE_CNTL                                       regPA_RATE_CNTL;
typedef union PA_SC_AA_CONFIG                                    regPA_SC_AA_CONFIG;
typedef union PA_SC_AA_MASK_X0Y0_X1Y0                            regPA_SC_AA_MASK_X0Y0_X1Y0;
typedef union PA_SC_AA_MASK_X0Y1_X1Y1                            regPA_SC_AA_MASK_X0Y1_X1Y1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3;
typedef union PA_SC_ATM_CNTL                                     regPA_SC_ATM_CNTL;
typedef union PA_SC_BC_WAVE_BREAK                                regPA_SC_BC_WAVE_BREAK;
typedef union PA_SC_BINNER_CNTL_0                                regPA_SC_BINNER_CNTL_0;
typedef union PA_SC_BINNER_CNTL_1                                regPA_SC_BINNER_CNTL_1;
typedef union PA_SC_BINNER_CNTL_2                                regPA_SC_BINNER_CNTL_2;
typedef union PA_SC_BINNER_CNTL_OVERRIDE                         regPA_SC_BINNER_CNTL_OVERRIDE;
typedef union PA_SC_BINNER_DYNAMIC_BATCH_LIMIT                   regPA_SC_BINNER_DYNAMIC_BATCH_LIMIT;
typedef union PA_SC_BINNER_EVENT_CNTL_0                          regPA_SC_BINNER_EVENT_CNTL_0;
typedef union PA_SC_BINNER_EVENT_CNTL_1                          regPA_SC_BINNER_EVENT_CNTL_1;
typedef union PA_SC_BINNER_EVENT_CNTL_2                          regPA_SC_BINNER_EVENT_CNTL_2;
typedef union PA_SC_BINNER_EVENT_CNTL_3                          regPA_SC_BINNER_EVENT_CNTL_3;
typedef union PA_SC_BINNER_OUTPUT_TIMEOUT_CNTL                   regPA_SC_BINNER_OUTPUT_TIMEOUT_CNTL;
typedef union PA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER                regPA_SC_BINNER_OUTPUT_TIMEOUT_COUNTER;
typedef union PA_SC_BINNER_PERF_CNTL_0                           regPA_SC_BINNER_PERF_CNTL_0;
typedef union PA_SC_BINNER_PERF_CNTL_1                           regPA_SC_BINNER_PERF_CNTL_1;
typedef union PA_SC_BINNER_PERF_CNTL_2                           regPA_SC_BINNER_PERF_CNTL_2;
typedef union PA_SC_BINNER_PERF_CNTL_3                           regPA_SC_BINNER_PERF_CNTL_3;
typedef union PA_SC_BINNER_TIMEOUT_COUNTER                       regPA_SC_BINNER_TIMEOUT_COUNTER;
typedef union PA_SC_CENTROID_PRIORITY_0                          regPA_SC_CENTROID_PRIORITY_0;
typedef union PA_SC_CENTROID_PRIORITY_1                          regPA_SC_CENTROID_PRIORITY_1;
typedef union PA_SC_CLIPRECT_0_BR                                regPA_SC_CLIPRECT_0_BR;
typedef union PA_SC_CLIPRECT_0_TL                                regPA_SC_CLIPRECT_0_TL;
typedef union PA_SC_CLIPRECT_1_BR                                regPA_SC_CLIPRECT_1_BR;
typedef union PA_SC_CLIPRECT_1_TL                                regPA_SC_CLIPRECT_1_TL;
typedef union PA_SC_CLIPRECT_2_BR                                regPA_SC_CLIPRECT_2_BR;
typedef union PA_SC_CLIPRECT_2_TL                                regPA_SC_CLIPRECT_2_TL;
typedef union PA_SC_CLIPRECT_3_BR                                regPA_SC_CLIPRECT_3_BR;
typedef union PA_SC_CLIPRECT_3_TL                                regPA_SC_CLIPRECT_3_TL;
typedef union PA_SC_CLIPRECT_RULE                                regPA_SC_CLIPRECT_RULE;
typedef union PA_SC_CONSERVATIVE_RASTERIZATION_CNTL              regPA_SC_CONSERVATIVE_RASTERIZATION_CNTL;
typedef union PA_SC_DSM_CNTL                                     regPA_SC_DSM_CNTL;
typedef union PA_SC_EDGERULE                                     regPA_SC_EDGERULE;
typedef union PA_SC_ENHANCE                                      regPA_SC_ENHANCE;
typedef union PA_SC_ENHANCE_1                                    regPA_SC_ENHANCE_1;
typedef union PA_SC_ENHANCE_2                                    regPA_SC_ENHANCE_2;
typedef union PA_SC_ENHANCE_3                                    regPA_SC_ENHANCE_3;
typedef union PA_SC_ENHANCE_4                                    regPA_SC_ENHANCE_4;
typedef union PA_SC_ENHANCE_INTERNAL                             regPA_SC_ENHANCE_INTERNAL;
typedef union PA_SC_FIFO_DEPTH_CNTL                              regPA_SC_FIFO_DEPTH_CNTL;
typedef union PA_SC_FIFO_SIZE                                    regPA_SC_FIFO_SIZE;
typedef union PA_SC_FORCE_EOV_MAX_CNTS                           regPA_SC_FORCE_EOV_MAX_CNTS;
typedef union PA_SC_GENERIC_SCISSOR_BR                           regPA_SC_GENERIC_SCISSOR_BR;
typedef union PA_SC_GENERIC_SCISSOR_TL                           regPA_SC_GENERIC_SCISSOR_TL;
typedef union PA_SC_HP3D_TRAP_SCREEN_COUNT                       regPA_SC_HP3D_TRAP_SCREEN_COUNT;
typedef union PA_SC_HP3D_TRAP_SCREEN_H                           regPA_SC_HP3D_TRAP_SCREEN_H;
typedef union PA_SC_HP3D_TRAP_SCREEN_HV_EN                       regPA_SC_HP3D_TRAP_SCREEN_HV_EN;
typedef union PA_SC_HP3D_TRAP_SCREEN_HV_LOCK                     regPA_SC_HP3D_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE                  regPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_HP3D_TRAP_SCREEN_V                           regPA_SC_HP3D_TRAP_SCREEN_V;
typedef union PA_SC_IF_FIFO_SIZE                                 regPA_SC_IF_FIFO_SIZE;
typedef union PA_SC_LIGHT_SHAFT_EVENT_CONFIG_0                   regPA_SC_LIGHT_SHAFT_EVENT_CONFIG_0;
typedef union PA_SC_LIGHT_SHAFT_EVENT_CONFIG_1                   regPA_SC_LIGHT_SHAFT_EVENT_CONFIG_1;
typedef union PA_SC_LINE_CNTL                                    regPA_SC_LINE_CNTL;
typedef union PA_SC_LINE_STIPPLE                                 regPA_SC_LINE_STIPPLE;
typedef union PA_SC_LINE_STIPPLE_STATE                           regPA_SC_LINE_STIPPLE_STATE;
typedef union PA_SC_MODE_CNTL_0                                  regPA_SC_MODE_CNTL_0;
typedef union PA_SC_MODE_CNTL_1                                  regPA_SC_MODE_CNTL_1;
typedef union PA_SC_NGG_MODE_CNTL                                regPA_SC_NGG_MODE_CNTL;
typedef union PA_SC_P3D_TRAP_SCREEN_COUNT                        regPA_SC_P3D_TRAP_SCREEN_COUNT;
typedef union PA_SC_P3D_TRAP_SCREEN_H                            regPA_SC_P3D_TRAP_SCREEN_H;
typedef union PA_SC_P3D_TRAP_SCREEN_HV_EN                        regPA_SC_P3D_TRAP_SCREEN_HV_EN;
typedef union PA_SC_P3D_TRAP_SCREEN_HV_LOCK                      regPA_SC_P3D_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_P3D_TRAP_SCREEN_OCCURRENCE                   regPA_SC_P3D_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_P3D_TRAP_SCREEN_V                            regPA_SC_P3D_TRAP_SCREEN_V;
typedef union PA_SC_PACKER_WAVE_ID_CNTL                          regPA_SC_PACKER_WAVE_ID_CNTL;
typedef union PA_SC_PBB_OVERRIDE_FLAG                            regPA_SC_PBB_OVERRIDE_FLAG;
typedef union PA_SC_PERFCOUNTER0_HI                              regPA_SC_PERFCOUNTER0_HI;
typedef union PA_SC_PERFCOUNTER0_LO                              regPA_SC_PERFCOUNTER0_LO;
typedef union PA_SC_PERFCOUNTER0_SELECT                          regPA_SC_PERFCOUNTER0_SELECT;
typedef union PA_SC_PERFCOUNTER0_SELECT1                         regPA_SC_PERFCOUNTER0_SELECT1;
typedef union PA_SC_PERFCOUNTER1_HI                              regPA_SC_PERFCOUNTER1_HI;
typedef union PA_SC_PERFCOUNTER1_LO                              regPA_SC_PERFCOUNTER1_LO;
typedef union PA_SC_PERFCOUNTER1_SELECT                          regPA_SC_PERFCOUNTER1_SELECT;
typedef union PA_SC_PERFCOUNTER2_HI                              regPA_SC_PERFCOUNTER2_HI;
typedef union PA_SC_PERFCOUNTER2_LO                              regPA_SC_PERFCOUNTER2_LO;
typedef union PA_SC_PERFCOUNTER2_SELECT                          regPA_SC_PERFCOUNTER2_SELECT;
typedef union PA_SC_PERFCOUNTER3_HI                              regPA_SC_PERFCOUNTER3_HI;
typedef union PA_SC_PERFCOUNTER3_LO                              regPA_SC_PERFCOUNTER3_LO;
typedef union PA_SC_PERFCOUNTER3_SELECT                          regPA_SC_PERFCOUNTER3_SELECT;
typedef union PA_SC_PERFCOUNTER4_HI                              regPA_SC_PERFCOUNTER4_HI;
typedef union PA_SC_PERFCOUNTER4_LO                              regPA_SC_PERFCOUNTER4_LO;
typedef union PA_SC_PERFCOUNTER4_SELECT                          regPA_SC_PERFCOUNTER4_SELECT;
typedef union PA_SC_PERFCOUNTER5_HI                              regPA_SC_PERFCOUNTER5_HI;
typedef union PA_SC_PERFCOUNTER5_LO                              regPA_SC_PERFCOUNTER5_LO;
typedef union PA_SC_PERFCOUNTER5_SELECT                          regPA_SC_PERFCOUNTER5_SELECT;
typedef union PA_SC_PERFCOUNTER6_HI                              regPA_SC_PERFCOUNTER6_HI;
typedef union PA_SC_PERFCOUNTER6_LO                              regPA_SC_PERFCOUNTER6_LO;
typedef union PA_SC_PERFCOUNTER6_SELECT                          regPA_SC_PERFCOUNTER6_SELECT;
typedef union PA_SC_PERFCOUNTER7_HI                              regPA_SC_PERFCOUNTER7_HI;
typedef union PA_SC_PERFCOUNTER7_LO                              regPA_SC_PERFCOUNTER7_LO;
typedef union PA_SC_PERFCOUNTER7_SELECT                          regPA_SC_PERFCOUNTER7_SELECT;
typedef union PA_SC_PKR_WAVE_TABLE_CNTL                          regPA_SC_PKR_WAVE_TABLE_CNTL;
typedef union PA_SC_RASTER_CONFIG                                regPA_SC_RASTER_CONFIG;
typedef union PA_SC_RASTER_CONFIG_1                              regPA_SC_RASTER_CONFIG_1;
typedef union PA_SC_SCREEN_SCISSOR_BR                            regPA_SC_SCREEN_SCISSOR_BR;
typedef union PA_SC_SCREEN_SCISSOR_TL                            regPA_SC_SCREEN_SCISSOR_TL;
typedef union PA_SC_SHADER_CONTROL                               regPA_SC_SHADER_CONTROL;
typedef union PA_SC_TILE_STEERING_CREST_OVERRIDE                 regPA_SC_TILE_STEERING_CREST_OVERRIDE;
typedef union PA_SC_TILE_STEERING_OVERRIDE                       regPA_SC_TILE_STEERING_OVERRIDE;
typedef union PA_SC_TRAP_SCREEN_COUNT                            regPA_SC_TRAP_SCREEN_COUNT;
typedef union PA_SC_TRAP_SCREEN_H                                regPA_SC_TRAP_SCREEN_H;
typedef union PA_SC_TRAP_SCREEN_HV_EN                            regPA_SC_TRAP_SCREEN_HV_EN;
typedef union PA_SC_TRAP_SCREEN_HV_LOCK                          regPA_SC_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_TRAP_SCREEN_OCCURRENCE                       regPA_SC_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_TRAP_SCREEN_V                                regPA_SC_TRAP_SCREEN_V;
typedef union PA_SC_VPORT_SCISSOR_0_BR                           regPA_SC_VPORT_SCISSOR_0_BR;
typedef union PA_SC_VPORT_SCISSOR_0_TL                           regPA_SC_VPORT_SCISSOR_0_TL;
typedef union PA_SC_VPORT_SCISSOR_1_BR                           regPA_SC_VPORT_SCISSOR_1_BR;
typedef union PA_SC_VPORT_SCISSOR_1_TL                           regPA_SC_VPORT_SCISSOR_1_TL;
typedef union PA_SC_VPORT_SCISSOR_2_BR                           regPA_SC_VPORT_SCISSOR_2_BR;
typedef union PA_SC_VPORT_SCISSOR_2_TL                           regPA_SC_VPORT_SCISSOR_2_TL;
typedef union PA_SC_VPORT_SCISSOR_3_BR                           regPA_SC_VPORT_SCISSOR_3_BR;
typedef union PA_SC_VPORT_SCISSOR_3_TL                           regPA_SC_VPORT_SCISSOR_3_TL;
typedef union PA_SC_VPORT_SCISSOR_4_BR                           regPA_SC_VPORT_SCISSOR_4_BR;
typedef union PA_SC_VPORT_SCISSOR_4_TL                           regPA_SC_VPORT_SCISSOR_4_TL;
typedef union PA_SC_VPORT_SCISSOR_5_BR                           regPA_SC_VPORT_SCISSOR_5_BR;
typedef union PA_SC_VPORT_SCISSOR_5_TL                           regPA_SC_VPORT_SCISSOR_5_TL;
typedef union PA_SC_VPORT_SCISSOR_6_BR                           regPA_SC_VPORT_SCISSOR_6_BR;
typedef union PA_SC_VPORT_SCISSOR_6_TL                           regPA_SC_VPORT_SCISSOR_6_TL;
typedef union PA_SC_VPORT_SCISSOR_7_BR                           regPA_SC_VPORT_SCISSOR_7_BR;
typedef union PA_SC_VPORT_SCISSOR_7_TL                           regPA_SC_VPORT_SCISSOR_7_TL;
typedef union PA_SC_VPORT_SCISSOR_8_BR                           regPA_SC_VPORT_SCISSOR_8_BR;
typedef union PA_SC_VPORT_SCISSOR_8_TL                           regPA_SC_VPORT_SCISSOR_8_TL;
typedef union PA_SC_VPORT_SCISSOR_9_BR                           regPA_SC_VPORT_SCISSOR_9_BR;
typedef union PA_SC_VPORT_SCISSOR_9_TL                           regPA_SC_VPORT_SCISSOR_9_TL;
typedef union PA_SC_VPORT_SCISSOR_10_BR                          regPA_SC_VPORT_SCISSOR_10_BR;
typedef union PA_SC_VPORT_SCISSOR_10_TL                          regPA_SC_VPORT_SCISSOR_10_TL;
typedef union PA_SC_VPORT_SCISSOR_11_BR                          regPA_SC_VPORT_SCISSOR_11_BR;
typedef union PA_SC_VPORT_SCISSOR_11_TL                          regPA_SC_VPORT_SCISSOR_11_TL;
typedef union PA_SC_VPORT_SCISSOR_12_BR                          regPA_SC_VPORT_SCISSOR_12_BR;
typedef union PA_SC_VPORT_SCISSOR_12_TL                          regPA_SC_VPORT_SCISSOR_12_TL;
typedef union PA_SC_VPORT_SCISSOR_13_BR                          regPA_SC_VPORT_SCISSOR_13_BR;
typedef union PA_SC_VPORT_SCISSOR_13_TL                          regPA_SC_VPORT_SCISSOR_13_TL;
typedef union PA_SC_VPORT_SCISSOR_14_BR                          regPA_SC_VPORT_SCISSOR_14_BR;
typedef union PA_SC_VPORT_SCISSOR_14_TL                          regPA_SC_VPORT_SCISSOR_14_TL;
typedef union PA_SC_VPORT_SCISSOR_15_BR                          regPA_SC_VPORT_SCISSOR_15_BR;
typedef union PA_SC_VPORT_SCISSOR_15_TL                          regPA_SC_VPORT_SCISSOR_15_TL;
typedef union PA_SC_VPORT_ZMAX_0                                 regPA_SC_VPORT_ZMAX_0;
typedef union PA_SC_VPORT_ZMAX_1                                 regPA_SC_VPORT_ZMAX_1;
typedef union PA_SC_VPORT_ZMAX_2                                 regPA_SC_VPORT_ZMAX_2;
typedef union PA_SC_VPORT_ZMAX_3                                 regPA_SC_VPORT_ZMAX_3;
typedef union PA_SC_VPORT_ZMAX_4                                 regPA_SC_VPORT_ZMAX_4;
typedef union PA_SC_VPORT_ZMAX_5                                 regPA_SC_VPORT_ZMAX_5;
typedef union PA_SC_VPORT_ZMAX_6                                 regPA_SC_VPORT_ZMAX_6;
typedef union PA_SC_VPORT_ZMAX_7                                 regPA_SC_VPORT_ZMAX_7;
typedef union PA_SC_VPORT_ZMAX_8                                 regPA_SC_VPORT_ZMAX_8;
typedef union PA_SC_VPORT_ZMAX_9                                 regPA_SC_VPORT_ZMAX_9;
typedef union PA_SC_VPORT_ZMAX_10                                regPA_SC_VPORT_ZMAX_10;
typedef union PA_SC_VPORT_ZMAX_11                                regPA_SC_VPORT_ZMAX_11;
typedef union PA_SC_VPORT_ZMAX_12                                regPA_SC_VPORT_ZMAX_12;
typedef union PA_SC_VPORT_ZMAX_13                                regPA_SC_VPORT_ZMAX_13;
typedef union PA_SC_VPORT_ZMAX_14                                regPA_SC_VPORT_ZMAX_14;
typedef union PA_SC_VPORT_ZMAX_15                                regPA_SC_VPORT_ZMAX_15;
typedef union PA_SC_VPORT_ZMIN_0                                 regPA_SC_VPORT_ZMIN_0;
typedef union PA_SC_VPORT_ZMIN_1                                 regPA_SC_VPORT_ZMIN_1;
typedef union PA_SC_VPORT_ZMIN_2                                 regPA_SC_VPORT_ZMIN_2;
typedef union PA_SC_VPORT_ZMIN_3                                 regPA_SC_VPORT_ZMIN_3;
typedef union PA_SC_VPORT_ZMIN_4                                 regPA_SC_VPORT_ZMIN_4;
typedef union PA_SC_VPORT_ZMIN_5                                 regPA_SC_VPORT_ZMIN_5;
typedef union PA_SC_VPORT_ZMIN_6                                 regPA_SC_VPORT_ZMIN_6;
typedef union PA_SC_VPORT_ZMIN_7                                 regPA_SC_VPORT_ZMIN_7;
typedef union PA_SC_VPORT_ZMIN_8                                 regPA_SC_VPORT_ZMIN_8;
typedef union PA_SC_VPORT_ZMIN_9                                 regPA_SC_VPORT_ZMIN_9;
typedef union PA_SC_VPORT_ZMIN_10                                regPA_SC_VPORT_ZMIN_10;
typedef union PA_SC_VPORT_ZMIN_11                                regPA_SC_VPORT_ZMIN_11;
typedef union PA_SC_VPORT_ZMIN_12                                regPA_SC_VPORT_ZMIN_12;
typedef union PA_SC_VPORT_ZMIN_13                                regPA_SC_VPORT_ZMIN_13;
typedef union PA_SC_VPORT_ZMIN_14                                regPA_SC_VPORT_ZMIN_14;
typedef union PA_SC_VPORT_ZMIN_15                                regPA_SC_VPORT_ZMIN_15;
typedef union PA_SC_VRS_OVERRIDE_CNTL                            regPA_SC_VRS_OVERRIDE_CNTL;
typedef union PA_SC_VRS_RATE_BASE                                regPA_SC_VRS_RATE_BASE;
typedef union PA_SC_VRS_RATE_BASE_EXT                            regPA_SC_VRS_RATE_BASE_EXT;
typedef union PA_SC_VRS_RATE_CACHE_CNTL                          regPA_SC_VRS_RATE_CACHE_CNTL;
typedef union PA_SC_VRS_RATE_FEEDBACK_BASE                       regPA_SC_VRS_RATE_FEEDBACK_BASE;
typedef union PA_SC_VRS_RATE_FEEDBACK_BASE_EXT                   regPA_SC_VRS_RATE_FEEDBACK_BASE_EXT;
typedef union PA_SC_VRS_RATE_FEEDBACK_SIZE_XY                    regPA_SC_VRS_RATE_FEEDBACK_SIZE_XY;
typedef union PA_SC_VRS_RATE_SIZE_XY                             regPA_SC_VRS_RATE_SIZE_XY;
typedef union PA_SC_VRS_SURFACE_CNTL                             regPA_SC_VRS_SURFACE_CNTL;
typedef union PA_SC_VRS_SURFACE_CNTL_1                           regPA_SC_VRS_SURFACE_CNTL_1;
typedef union PA_SC_WINDOW_OFFSET                                regPA_SC_WINDOW_OFFSET;
typedef union PA_SC_WINDOW_SCISSOR_BR                            regPA_SC_WINDOW_SCISSOR_BR;
typedef union PA_SC_WINDOW_SCISSOR_TL                            regPA_SC_WINDOW_SCISSOR_TL;
typedef union PA_SIDEBAND_REQUEST_DELAYS                         regPA_SIDEBAND_REQUEST_DELAYS;
typedef union PA_STATE_STEREO_X                                  regPA_STATE_STEREO_X;
typedef union PA_STEREO_CNTL                                     regPA_STEREO_CNTL;
typedef union PA_SU_CNTL_STATUS                                  regPA_SU_CNTL_STATUS;
typedef union PA_SU_HARDWARE_SCREEN_OFFSET                       regPA_SU_HARDWARE_SCREEN_OFFSET;
typedef union PA_SU_LINE_CNTL                                    regPA_SU_LINE_CNTL;
typedef union PA_SU_LINE_STIPPLE_CNTL                            regPA_SU_LINE_STIPPLE_CNTL;
typedef union PA_SU_LINE_STIPPLE_SCALE                           regPA_SU_LINE_STIPPLE_SCALE;
typedef union PA_SU_LINE_STIPPLE_VALUE                           regPA_SU_LINE_STIPPLE_VALUE;
typedef union PA_SU_OVER_RASTERIZATION_CNTL                      regPA_SU_OVER_RASTERIZATION_CNTL;
typedef union PA_SU_PERFCOUNTER0_HI                              regPA_SU_PERFCOUNTER0_HI;
typedef union PA_SU_PERFCOUNTER0_LO                              regPA_SU_PERFCOUNTER0_LO;
typedef union PA_SU_PERFCOUNTER0_SELECT                          regPA_SU_PERFCOUNTER0_SELECT;
typedef union PA_SU_PERFCOUNTER0_SELECT1                         regPA_SU_PERFCOUNTER0_SELECT1;
typedef union PA_SU_PERFCOUNTER1_HI                              regPA_SU_PERFCOUNTER1_HI;
typedef union PA_SU_PERFCOUNTER1_LO                              regPA_SU_PERFCOUNTER1_LO;
typedef union PA_SU_PERFCOUNTER1_SELECT                          regPA_SU_PERFCOUNTER1_SELECT;
typedef union PA_SU_PERFCOUNTER1_SELECT1                         regPA_SU_PERFCOUNTER1_SELECT1;
typedef union PA_SU_PERFCOUNTER2_HI                              regPA_SU_PERFCOUNTER2_HI;
typedef union PA_SU_PERFCOUNTER2_LO                              regPA_SU_PERFCOUNTER2_LO;
typedef union PA_SU_PERFCOUNTER2_SELECT                          regPA_SU_PERFCOUNTER2_SELECT;
typedef union PA_SU_PERFCOUNTER2_SELECT1                         regPA_SU_PERFCOUNTER2_SELECT1;
typedef union PA_SU_PERFCOUNTER3_HI                              regPA_SU_PERFCOUNTER3_HI;
typedef union PA_SU_PERFCOUNTER3_LO                              regPA_SU_PERFCOUNTER3_LO;
typedef union PA_SU_PERFCOUNTER3_SELECT                          regPA_SU_PERFCOUNTER3_SELECT;
typedef union PA_SU_PERFCOUNTER3_SELECT1                         regPA_SU_PERFCOUNTER3_SELECT1;
typedef union PA_SU_POINT_MINMAX                                 regPA_SU_POINT_MINMAX;
typedef union PA_SU_POINT_SIZE                                   regPA_SU_POINT_SIZE;
typedef union PA_SU_POLY_OFFSET_BACK_OFFSET                      regPA_SU_POLY_OFFSET_BACK_OFFSET;
typedef union PA_SU_POLY_OFFSET_BACK_SCALE                       regPA_SU_POLY_OFFSET_BACK_SCALE;
typedef union PA_SU_POLY_OFFSET_CLAMP                            regPA_SU_POLY_OFFSET_CLAMP;
typedef union PA_SU_POLY_OFFSET_DB_FMT_CNTL                      regPA_SU_POLY_OFFSET_DB_FMT_CNTL;
typedef union PA_SU_POLY_OFFSET_FRONT_OFFSET                     regPA_SU_POLY_OFFSET_FRONT_OFFSET;
typedef union PA_SU_POLY_OFFSET_FRONT_SCALE                      regPA_SU_POLY_OFFSET_FRONT_SCALE;
typedef union PA_SU_PRIM_FILTER_CNTL                             regPA_SU_PRIM_FILTER_CNTL;
typedef union PA_SU_SC_MODE_CNTL                                 regPA_SU_SC_MODE_CNTL;
typedef union PA_SU_SMALL_PRIM_FILTER_CNTL                       regPA_SU_SMALL_PRIM_FILTER_CNTL;
typedef union PA_SU_VTX_CNTL                                     regPA_SU_VTX_CNTL;
typedef union PC_PERFCOUNTER0_HI                                 regPC_PERFCOUNTER0_HI;
typedef union PC_PERFCOUNTER0_LO                                 regPC_PERFCOUNTER0_LO;
typedef union PC_PERFCOUNTER0_SELECT                             regPC_PERFCOUNTER0_SELECT;
typedef union PC_PERFCOUNTER0_SELECT1                            regPC_PERFCOUNTER0_SELECT1;
typedef union PC_PERFCOUNTER1_HI                                 regPC_PERFCOUNTER1_HI;
typedef union PC_PERFCOUNTER1_LO                                 regPC_PERFCOUNTER1_LO;
typedef union PC_PERFCOUNTER1_SELECT                             regPC_PERFCOUNTER1_SELECT;
typedef union PC_PERFCOUNTER1_SELECT1                            regPC_PERFCOUNTER1_SELECT1;
typedef union PC_PERFCOUNTER2_HI                                 regPC_PERFCOUNTER2_HI;
typedef union PC_PERFCOUNTER2_LO                                 regPC_PERFCOUNTER2_LO;
typedef union PC_PERFCOUNTER2_SELECT                             regPC_PERFCOUNTER2_SELECT;
typedef union PC_PERFCOUNTER2_SELECT1                            regPC_PERFCOUNTER2_SELECT1;
typedef union PC_PERFCOUNTER3_HI                                 regPC_PERFCOUNTER3_HI;
typedef union PC_PERFCOUNTER3_LO                                 regPC_PERFCOUNTER3_LO;
typedef union PC_PERFCOUNTER3_SELECT                             regPC_PERFCOUNTER3_SELECT;
typedef union PC_PERFCOUNTER3_SELECT1                            regPC_PERFCOUNTER3_SELECT1;
typedef union PerfMonCtl1                                        regPerfMonCtl1;
typedef union PerfMonCtl2                                        regPerfMonCtl2;
typedef union PerfMonCtl3                                        regPerfMonCtl3;
typedef union PerfMonCtl4                                        regPerfMonCtl4;
typedef union PerfMonCtl5                                        regPerfMonCtl5;
typedef union PerfMonCtl6                                        regPerfMonCtl6;
typedef union PerfMonCtl7                                        regPerfMonCtl7;
typedef union PerfMonCtl8                                        regPerfMonCtl8;
typedef union PerfMonCtl9                                        regPerfMonCtl9;
typedef union PerfMonCtl10                                       regPerfMonCtl10;
typedef union PerfMonCtl11                                       regPerfMonCtl11;
typedef union PerfMonCtl12                                       regPerfMonCtl12;
typedef union PerfMonCtlClk                                      regPerfMonCtlClk;
typedef union PerfMonCtr1_Hi                                     regPerfMonCtr1_Hi;
typedef union PerfMonCtr1_Lo                                     regPerfMonCtr1_Lo;
typedef union PerfMonCtr2_Hi                                     regPerfMonCtr2_Hi;
typedef union PerfMonCtr2_Lo                                     regPerfMonCtr2_Lo;
typedef union PerfMonCtr3_Hi                                     regPerfMonCtr3_Hi;
typedef union PerfMonCtr3_Lo                                     regPerfMonCtr3_Lo;
typedef union PerfMonCtr4_Hi                                     regPerfMonCtr4_Hi;
typedef union PerfMonCtr4_Lo                                     regPerfMonCtr4_Lo;
typedef union PerfMonCtr5_Hi                                     regPerfMonCtr5_Hi;
typedef union PerfMonCtr5_Lo                                     regPerfMonCtr5_Lo;
typedef union PerfMonCtr6_Hi                                     regPerfMonCtr6_Hi;
typedef union PerfMonCtr6_Lo                                     regPerfMonCtr6_Lo;
typedef union PerfMonCtr7_Hi                                     regPerfMonCtr7_Hi;
typedef union PerfMonCtr7_Lo                                     regPerfMonCtr7_Lo;
typedef union PerfMonCtr8_Hi                                     regPerfMonCtr8_Hi;
typedef union PerfMonCtr8_Lo                                     regPerfMonCtr8_Lo;
typedef union PerfMonCtr9_Hi                                     regPerfMonCtr9_Hi;
typedef union PerfMonCtr9_Lo                                     regPerfMonCtr9_Lo;
typedef union PerfMonCtr10_Hi                                    regPerfMonCtr10_Hi;
typedef union PerfMonCtr10_Lo                                    regPerfMonCtr10_Lo;
typedef union PerfMonCtr11_Hi                                    regPerfMonCtr11_Hi;
typedef union PerfMonCtr11_Lo                                    regPerfMonCtr11_Lo;
typedef union PerfMonCtr12_Hi                                    regPerfMonCtr12_Hi;
typedef union PerfMonCtr12_Lo                                    regPerfMonCtr12_Lo;
typedef union PerfMonCtrClk_Hi                                   regPerfMonCtrClk_Hi;
typedef union PerfMonCtrClk_Lo                                   regPerfMonCtrClk_Lo;
typedef union RLC_CGTT_MGCG_OVERRIDE                             regRLC_CGTT_MGCG_OVERRIDE;
typedef union RLC_PERFCOUNTER0_HI                                regRLC_PERFCOUNTER0_HI;
typedef union RLC_PERFCOUNTER0_LO                                regRLC_PERFCOUNTER0_LO;
typedef union RLC_PERFCOUNTER0_SELECT                            regRLC_PERFCOUNTER0_SELECT;
typedef union RLC_PERFCOUNTER1_HI                                regRLC_PERFCOUNTER1_HI;
typedef union RLC_PERFCOUNTER1_LO                                regRLC_PERFCOUNTER1_LO;
typedef union RLC_PERFCOUNTER1_SELECT                            regRLC_PERFCOUNTER1_SELECT;
typedef union RLC_PERFMON_CLK_CNTL                               regRLC_PERFMON_CLK_CNTL;
typedef union RLC_PERFMON_CNTL                                   regRLC_PERFMON_CNTL;
typedef union RLC_SPM_ACCUM_CTRL                                 regRLC_SPM_ACCUM_CTRL;
typedef union RLC_SPM_ACCUM_CTRLRAM_ADDR                         regRLC_SPM_ACCUM_CTRLRAM_ADDR;
typedef union RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET                  regRLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET;
typedef union RLC_SPM_ACCUM_CTRLRAM_DATA                         regRLC_SPM_ACCUM_CTRLRAM_DATA;
typedef union RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS           regRLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS;
typedef union RLC_SPM_ACCUM_DATARAM_ADDR                         regRLC_SPM_ACCUM_DATARAM_ADDR;
typedef union RLC_SPM_ACCUM_DATARAM_DATA                         regRLC_SPM_ACCUM_DATARAM_DATA;
typedef union RLC_SPM_ACCUM_DATARAM_WRCOUNT                      regRLC_SPM_ACCUM_DATARAM_WRCOUNT;
typedef union RLC_SPM_ACCUM_MODE                                 regRLC_SPM_ACCUM_MODE;
typedef union RLC_SPM_ACCUM_SAMPLES_REQUESTED                    regRLC_SPM_ACCUM_SAMPLES_REQUESTED;
typedef union RLC_SPM_ACCUM_STATUS                               regRLC_SPM_ACCUM_STATUS;
typedef union RLC_SPM_ACCUM_SWA_DATARAM_ADDR                     regRLC_SPM_ACCUM_SWA_DATARAM_ADDR;
typedef union RLC_SPM_ACCUM_SWA_DATARAM_DATA                     regRLC_SPM_ACCUM_SWA_DATARAM_DATA;
typedef union RLC_SPM_ACCUM_THRESHOLD                            regRLC_SPM_ACCUM_THRESHOLD;
typedef union RLC_SPM_DESER_START_SKEW                           regRLC_SPM_DESER_START_SKEW;
typedef union RLC_SPM_GFXCLOCK_HIGHCOUNT                         regRLC_SPM_GFXCLOCK_HIGHCOUNT;
typedef union RLC_SPM_GFXCLOCK_LOWCOUNT                          regRLC_SPM_GFXCLOCK_LOWCOUNT;
typedef union RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR                   regRLC_SPM_GLB_SAMPLEDELAY_IND_ADDR;
typedef union RLC_SPM_GLB_SAMPLEDELAY_IND_DATA                   regRLC_SPM_GLB_SAMPLEDELAY_IND_DATA;
typedef union RLC_SPM_GLOBALS_MUXSEL_SKEW                        regRLC_SPM_GLOBALS_MUXSEL_SKEW;
typedef union RLC_SPM_GLOBALS_SAMPLE_SKEW                        regRLC_SPM_GLOBALS_SAMPLE_SKEW;
typedef union RLC_SPM_GLOBAL_DELAY_IND_ADDR                      regRLC_SPM_GLOBAL_DELAY_IND_ADDR;
typedef union RLC_SPM_GLOBAL_DELAY_IND_DATA                      regRLC_SPM_GLOBAL_DELAY_IND_DATA;
typedef union RLC_SPM_GLOBAL_MUXSEL_ADDR                         regRLC_SPM_GLOBAL_MUXSEL_ADDR;
typedef union RLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET                  regRLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET;
typedef union RLC_SPM_GLOBAL_MUXSEL_DATA                         regRLC_SPM_GLOBAL_MUXSEL_DATA;
typedef union RLC_SPM_INT_CNTL                                   regRLC_SPM_INT_CNTL;
typedef union RLC_SPM_INT_INFO_1                                 regRLC_SPM_INT_INFO_1;
typedef union RLC_SPM_INT_INFO_2                                 regRLC_SPM_INT_INFO_2;
typedef union RLC_SPM_INT_STATUS                                 regRLC_SPM_INT_STATUS;
typedef union RLC_SPM_MC_CNTL                                    regRLC_SPM_MC_CNTL;
typedef union RLC_SPM_MODE                                       regRLC_SPM_MODE;
typedef union RLC_SPM_PAUSE                                      regRLC_SPM_PAUSE;
typedef union RLC_SPM_PERFMON_CNTL                               regRLC_SPM_PERFMON_CNTL;
typedef union RLC_SPM_PERFMON_GLB_SEGMENT_SIZE                   regRLC_SPM_PERFMON_GLB_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_RING_BASE_HI                       regRLC_SPM_PERFMON_RING_BASE_HI;
typedef union RLC_SPM_PERFMON_RING_BASE_LO                       regRLC_SPM_PERFMON_RING_BASE_LO;
typedef union RLC_SPM_PERFMON_RING_SIZE                          regRLC_SPM_PERFMON_RING_SIZE;
typedef union RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE                regRLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_SEGMENT_SIZE                       regRLC_SPM_PERFMON_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE               regRLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE            regRLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_SWA_SEGMENT_SIZE                   regRLC_SPM_PERFMON_SWA_SEGMENT_SIZE;
typedef union RLC_SPM_RING_RDPTR                                 regRLC_SPM_RING_RDPTR;
typedef union RLC_SPM_RING_WRPTR                                 regRLC_SPM_RING_WRPTR;
typedef union RLC_SPM_RSPM_CMD                                   regRLC_SPM_RSPM_CMD;
typedef union RLC_SPM_RSPM_CMD_ACK                               regRLC_SPM_RSPM_CMD_ACK;
typedef union RLC_SPM_RSPM_REQ_DATA_HI                           regRLC_SPM_RSPM_REQ_DATA_HI;
typedef union RLC_SPM_RSPM_REQ_DATA_LO                           regRLC_SPM_RSPM_REQ_DATA_LO;
typedef union RLC_SPM_RSPM_REQ_OP                                regRLC_SPM_RSPM_REQ_OP;
typedef union RLC_SPM_RSPM_RET_DATA                              regRLC_SPM_RSPM_RET_DATA;
typedef union RLC_SPM_RSPM_RET_OP                                regRLC_SPM_RSPM_RET_OP;
typedef union RLC_SPM_SAMPLE_CNT                                 regRLC_SPM_SAMPLE_CNT;
typedef union RLC_SPM_SEGMENT_THRESHOLD                          regRLC_SPM_SEGMENT_THRESHOLD;
typedef union RLC_SPM_SE_DELAY_IND_ADDR                          regRLC_SPM_SE_DELAY_IND_ADDR;
typedef union RLC_SPM_SE_DELAY_IND_DATA                          regRLC_SPM_SE_DELAY_IND_DATA;
typedef union RLC_SPM_SE_MUXSEL_ADDR                             regRLC_SPM_SE_MUXSEL_ADDR;
typedef union RLC_SPM_SE_MUXSEL_ADDR_OFFSET                      regRLC_SPM_SE_MUXSEL_ADDR_OFFSET;
typedef union RLC_SPM_SE_MUXSEL_DATA                             regRLC_SPM_SE_MUXSEL_DATA;
typedef union RLC_SPM_SE_MUXSEL_SKEW                             regRLC_SPM_SE_MUXSEL_SKEW;
typedef union RLC_SPM_SE_RSPM_REQ_DATA_HI                        regRLC_SPM_SE_RSPM_REQ_DATA_HI;
typedef union RLC_SPM_SE_RSPM_REQ_DATA_LO                        regRLC_SPM_SE_RSPM_REQ_DATA_LO;
typedef union RLC_SPM_SE_RSPM_REQ_OP                             regRLC_SPM_SE_RSPM_REQ_OP;
typedef union RLC_SPM_SE_RSPM_RET_DATA                           regRLC_SPM_SE_RSPM_RET_DATA;
typedef union RLC_SPM_SE_RSPM_RET_OP                             regRLC_SPM_SE_RSPM_RET_OP;
typedef union RLC_SPM_SE_SAMPLEDELAY_IND_ADDR                    regRLC_SPM_SE_SAMPLEDELAY_IND_ADDR;
typedef union RLC_SPM_SE_SAMPLEDELAY_IND_DATA                    regRLC_SPM_SE_SAMPLEDELAY_IND_DATA;
typedef union RLC_SPM_SE_SAMPLE_SKEW                             regRLC_SPM_SE_SAMPLE_SKEW;
typedef union RLC_SPM_SPARE                                      regRLC_SPM_SPARE;
typedef union RLC_SPM_STATUS                                     regRLC_SPM_STATUS;
typedef union RLC_SPM_THREAD_TRACE_CTRL                          regRLC_SPM_THREAD_TRACE_CTRL;
typedef union RLC_SPM_UTCL1_CNTL                                 regRLC_SPM_UTCL1_CNTL;
typedef union RLC_SPM_UTCL1_ERROR_1                              regRLC_SPM_UTCL1_ERROR_1;
typedef union RLC_SPM_UTCL1_ERROR_2                              regRLC_SPM_UTCL1_ERROR_2;
typedef union RLC_SPM_VIRT_CTRL                                  regRLC_SPM_VIRT_CTRL;
typedef union RLC_SPM_VIRT_STATUS                                regRLC_SPM_VIRT_STATUS;
typedef union RMI_PERFCOUNTER0_HI                                regRMI_PERFCOUNTER0_HI;
typedef union RMI_PERFCOUNTER0_LO                                regRMI_PERFCOUNTER0_LO;
typedef union RMI_PERFCOUNTER0_SELECT                            regRMI_PERFCOUNTER0_SELECT;
typedef union RMI_PERFCOUNTER0_SELECT1                           regRMI_PERFCOUNTER0_SELECT1;
typedef union RMI_PERFCOUNTER1_HI                                regRMI_PERFCOUNTER1_HI;
typedef union RMI_PERFCOUNTER1_LO                                regRMI_PERFCOUNTER1_LO;
typedef union RMI_PERFCOUNTER1_SELECT                            regRMI_PERFCOUNTER1_SELECT;
typedef union RMI_PERFCOUNTER2_HI                                regRMI_PERFCOUNTER2_HI;
typedef union RMI_PERFCOUNTER2_LO                                regRMI_PERFCOUNTER2_LO;
typedef union RMI_PERFCOUNTER2_SELECT                            regRMI_PERFCOUNTER2_SELECT;
typedef union RMI_PERFCOUNTER2_SELECT1                           regRMI_PERFCOUNTER2_SELECT1;
typedef union RMI_PERFCOUNTER3_HI                                regRMI_PERFCOUNTER3_HI;
typedef union RMI_PERFCOUNTER3_LO                                regRMI_PERFCOUNTER3_LO;
typedef union RMI_PERFCOUNTER3_SELECT                            regRMI_PERFCOUNTER3_SELECT;
typedef union RMI_PERF_COUNTER_CNTL                              regRMI_PERF_COUNTER_CNTL;
typedef union RPB_PERFCOUNTER0_CFG                               regRPB_PERFCOUNTER0_CFG;
typedef union RPB_PERFCOUNTER1_CFG                               regRPB_PERFCOUNTER1_CFG;
typedef union RPB_PERFCOUNTER2_CFG                               regRPB_PERFCOUNTER2_CFG;
typedef union RPB_PERFCOUNTER3_CFG                               regRPB_PERFCOUNTER3_CFG;
typedef union RPB_PERFCOUNTER_HI                                 regRPB_PERFCOUNTER_HI;
typedef union RPB_PERFCOUNTER_LO                                 regRPB_PERFCOUNTER_LO;
typedef union RPB_PERFCOUNTER_RSLT_CNTL                          regRPB_PERFCOUNTER_RSLT_CNTL;
typedef union RPB_PERF_COUNTER_CNTL                              regRPB_PERF_COUNTER_CNTL;
typedef union SDMA0_PERFCNT_MISC_CNTL                            regSDMA0_PERFCNT_MISC_CNTL;
typedef union SDMA0_PERFCNT_PERFCOUNTER0_CFG                     regSDMA0_PERFCNT_PERFCOUNTER0_CFG;
typedef union SDMA0_PERFCNT_PERFCOUNTER1_CFG                     regSDMA0_PERFCNT_PERFCOUNTER1_CFG;
typedef union SDMA0_PERFCNT_PERFCOUNTER_HI                       regSDMA0_PERFCNT_PERFCOUNTER_HI;
typedef union SDMA0_PERFCNT_PERFCOUNTER_LO                       regSDMA0_PERFCNT_PERFCOUNTER_LO;
typedef union SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL                regSDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL;
typedef union SDMA0_PERFCOUNTER0_HI                              regSDMA0_PERFCOUNTER0_HI;
typedef union SDMA0_PERFCOUNTER0_LO                              regSDMA0_PERFCOUNTER0_LO;
typedef union SDMA0_PERFCOUNTER0_RESULT                          regSDMA0_PERFCOUNTER0_RESULT;
typedef union SDMA0_PERFCOUNTER0_SELECT                          regSDMA0_PERFCOUNTER0_SELECT;
typedef union SDMA0_PERFCOUNTER0_SELECT1                         regSDMA0_PERFCOUNTER0_SELECT1;
typedef union SDMA0_PERFCOUNTER1_HI                              regSDMA0_PERFCOUNTER1_HI;
typedef union SDMA0_PERFCOUNTER1_LO                              regSDMA0_PERFCOUNTER1_LO;
typedef union SDMA0_PERFCOUNTER1_RESULT                          regSDMA0_PERFCOUNTER1_RESULT;
typedef union SDMA0_PERFCOUNTER1_SELECT                          regSDMA0_PERFCOUNTER1_SELECT;
typedef union SDMA0_PERFCOUNTER1_SELECT1                         regSDMA0_PERFCOUNTER1_SELECT1;
typedef union SDMA0_PERFCOUNTER_TAG_DELAY_RANGE                  regSDMA0_PERFCOUNTER_TAG_DELAY_RANGE;
typedef union SDMA0_PERFMON_CNTL                                 regSDMA0_PERFMON_CNTL;
typedef union SDMA1_PERFCNT_MISC_CNTL                            regSDMA1_PERFCNT_MISC_CNTL;
typedef union SDMA1_PERFCNT_PERFCOUNTER0_CFG                     regSDMA1_PERFCNT_PERFCOUNTER0_CFG;
typedef union SDMA1_PERFCNT_PERFCOUNTER1_CFG                     regSDMA1_PERFCNT_PERFCOUNTER1_CFG;
typedef union SDMA1_PERFCNT_PERFCOUNTER_HI                       regSDMA1_PERFCNT_PERFCOUNTER_HI;
typedef union SDMA1_PERFCNT_PERFCOUNTER_LO                       regSDMA1_PERFCNT_PERFCOUNTER_LO;
typedef union SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL                regSDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL;
typedef union SDMA1_PERFCOUNTER0_HI                              regSDMA1_PERFCOUNTER0_HI;
typedef union SDMA1_PERFCOUNTER0_LO                              regSDMA1_PERFCOUNTER0_LO;
typedef union SDMA1_PERFCOUNTER0_RESULT                          regSDMA1_PERFCOUNTER0_RESULT;
typedef union SDMA1_PERFCOUNTER0_SELECT                          regSDMA1_PERFCOUNTER0_SELECT;
typedef union SDMA1_PERFCOUNTER0_SELECT1                         regSDMA1_PERFCOUNTER0_SELECT1;
typedef union SDMA1_PERFCOUNTER1_HI                              regSDMA1_PERFCOUNTER1_HI;
typedef union SDMA1_PERFCOUNTER1_LO                              regSDMA1_PERFCOUNTER1_LO;
typedef union SDMA1_PERFCOUNTER1_RESULT                          regSDMA1_PERFCOUNTER1_RESULT;
typedef union SDMA1_PERFCOUNTER1_SELECT                          regSDMA1_PERFCOUNTER1_SELECT;
typedef union SDMA1_PERFCOUNTER1_SELECT1                         regSDMA1_PERFCOUNTER1_SELECT1;
typedef union SDMA1_PERFCOUNTER_TAG_DELAY_RANGE                  regSDMA1_PERFCOUNTER_TAG_DELAY_RANGE;
typedef union SDMA1_PERFMON_CNTL                                 regSDMA1_PERFMON_CNTL;
typedef union SDMA2_PERFCNT_MISC_CNTL                            regSDMA2_PERFCNT_MISC_CNTL;
typedef union SDMA2_PERFCNT_PERFCOUNTER0_CFG                     regSDMA2_PERFCNT_PERFCOUNTER0_CFG;
typedef union SDMA2_PERFCNT_PERFCOUNTER1_CFG                     regSDMA2_PERFCNT_PERFCOUNTER1_CFG;
typedef union SDMA2_PERFCNT_PERFCOUNTER_HI                       regSDMA2_PERFCNT_PERFCOUNTER_HI;
typedef union SDMA2_PERFCNT_PERFCOUNTER_LO                       regSDMA2_PERFCNT_PERFCOUNTER_LO;
typedef union SDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL                regSDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL;
typedef union SDMA2_PERFCOUNTER0_HI                              regSDMA2_PERFCOUNTER0_HI;
typedef union SDMA2_PERFCOUNTER0_LO                              regSDMA2_PERFCOUNTER0_LO;
typedef union SDMA2_PERFCOUNTER0_SELECT                          regSDMA2_PERFCOUNTER0_SELECT;
typedef union SDMA2_PERFCOUNTER0_SELECT1                         regSDMA2_PERFCOUNTER0_SELECT1;
typedef union SDMA2_PERFCOUNTER1_HI                              regSDMA2_PERFCOUNTER1_HI;
typedef union SDMA2_PERFCOUNTER1_LO                              regSDMA2_PERFCOUNTER1_LO;
typedef union SDMA2_PERFCOUNTER1_SELECT                          regSDMA2_PERFCOUNTER1_SELECT;
typedef union SDMA2_PERFCOUNTER1_SELECT1                         regSDMA2_PERFCOUNTER1_SELECT1;
typedef union SDMA3_PERFCNT_MISC_CNTL                            regSDMA3_PERFCNT_MISC_CNTL;
typedef union SDMA3_PERFCNT_PERFCOUNTER0_CFG                     regSDMA3_PERFCNT_PERFCOUNTER0_CFG;
typedef union SDMA3_PERFCNT_PERFCOUNTER1_CFG                     regSDMA3_PERFCNT_PERFCOUNTER1_CFG;
typedef union SDMA3_PERFCNT_PERFCOUNTER_HI                       regSDMA3_PERFCNT_PERFCOUNTER_HI;
typedef union SDMA3_PERFCNT_PERFCOUNTER_LO                       regSDMA3_PERFCNT_PERFCOUNTER_LO;
typedef union SDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL                regSDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL;
typedef union SDMA3_PERFCOUNTER0_HI                              regSDMA3_PERFCOUNTER0_HI;
typedef union SDMA3_PERFCOUNTER0_LO                              regSDMA3_PERFCOUNTER0_LO;
typedef union SDMA3_PERFCOUNTER0_SELECT                          regSDMA3_PERFCOUNTER0_SELECT;
typedef union SDMA3_PERFCOUNTER0_SELECT1                         regSDMA3_PERFCOUNTER0_SELECT1;
typedef union SDMA3_PERFCOUNTER1_HI                              regSDMA3_PERFCOUNTER1_HI;
typedef union SDMA3_PERFCOUNTER1_LO                              regSDMA3_PERFCOUNTER1_LO;
typedef union SDMA3_PERFCOUNTER1_SELECT                          regSDMA3_PERFCOUNTER1_SELECT;
typedef union SDMA3_PERFCOUNTER1_SELECT1                         regSDMA3_PERFCOUNTER1_SELECT1;
typedef union SPI_ARB_CNTL_0                                     regSPI_ARB_CNTL_0;
typedef union SPI_ARB_CYCLES_0                                   regSPI_ARB_CYCLES_0;
typedef union SPI_ARB_CYCLES_1                                   regSPI_ARB_CYCLES_1;
typedef union SPI_ARB_PRIORITY                                   regSPI_ARB_PRIORITY;
typedef union SPI_ATTRIBUTE_RING_BASE                            regSPI_ATTRIBUTE_RING_BASE;
typedef union SPI_ATTRIBUTE_RING_SIZE                            regSPI_ATTRIBUTE_RING_SIZE;
typedef union SPI_BARYC_CNTL                                     regSPI_BARYC_CNTL;
typedef union SPI_BARYC_SSAA_CNTL                                regSPI_BARYC_SSAA_CNTL;
typedef union SPI_COMPUTE_QUEUE_RESET                            regSPI_COMPUTE_QUEUE_RESET;
typedef union SPI_COMPUTE_WF_CTX_SAVE                            regSPI_COMPUTE_WF_CTX_SAVE;
typedef union SPI_COMPUTE_WF_CTX_SAVE_STATUS                     regSPI_COMPUTE_WF_CTX_SAVE_STATUS;
typedef union SPI_CONFIG_CNTL                                    regSPI_CONFIG_CNTL;
typedef union SPI_CONFIG_CNTL_1                                  regSPI_CONFIG_CNTL_1;
typedef union SPI_CONFIG_CNTL_1_REMAP                            regSPI_CONFIG_CNTL_1_REMAP;
typedef union SPI_CONFIG_CNTL_2                                  regSPI_CONFIG_CNTL_2;
typedef union SPI_CONFIG_CNTL_2_REMAP                            regSPI_CONFIG_CNTL_2_REMAP;
typedef union SPI_CONFIG_CNTL_REMAP                              regSPI_CONFIG_CNTL_REMAP;
typedef union SPI_CONFIG_PS_CU_EN                                regSPI_CONFIG_PS_CU_EN;
typedef union SPI_CSG_PIPE_CONTROL                               regSPI_CSG_PIPE_CONTROL;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_0                          regSPI_CSQ_WF_ACTIVE_COUNT_0;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_1                          regSPI_CSQ_WF_ACTIVE_COUNT_1;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_2                          regSPI_CSQ_WF_ACTIVE_COUNT_2;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_3                          regSPI_CSQ_WF_ACTIVE_COUNT_3;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_4                          regSPI_CSQ_WF_ACTIVE_COUNT_4;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_5                          regSPI_CSQ_WF_ACTIVE_COUNT_5;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_6                          regSPI_CSQ_WF_ACTIVE_COUNT_6;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_7                          regSPI_CSQ_WF_ACTIVE_COUNT_7;
typedef union SPI_CSQ_WF_ACTIVE_STATUS                           regSPI_CSQ_WF_ACTIVE_STATUS;
typedef union SPI_CS_CRAWLER_CONFIG                              regSPI_CS_CRAWLER_CONFIG;
typedef union SPI_DSM_CNTL                                       regSPI_DSM_CNTL;
typedef union SPI_DSM_CNTL2                                      regSPI_DSM_CNTL2;
typedef union SPI_EDC_CNT                                        regSPI_EDC_CNT;
typedef union SPI_EXP_THROTTLE_CTRL                              regSPI_EXP_THROTTLE_CTRL;
typedef union SPI_FEATURE_CTRL                                   regSPI_FEATURE_CTRL;
typedef union SPI_GDS_CREDITS                                    regSPI_GDS_CREDITS;
typedef union SPI_GFX_CNTL                                       regSPI_GFX_CNTL;
typedef union SPI_GFX_CRAWLER_CONFIG                             regSPI_GFX_CRAWLER_CONFIG;
typedef union SPI_GFX_SCRATCH_BASE_HI                            regSPI_GFX_SCRATCH_BASE_HI;
typedef union SPI_GFX_SCRATCH_BASE_LO                            regSPI_GFX_SCRATCH_BASE_LO;
typedef union SPI_GS_THROTTLE_CNTL1                              regSPI_GS_THROTTLE_CNTL1;
typedef union SPI_GS_THROTTLE_CNTL2                              regSPI_GS_THROTTLE_CNTL2;
typedef union SPI_IND_DATA                                       regSPI_IND_DATA;
typedef union SPI_IND_INDEX                                      regSPI_IND_INDEX;
typedef union SPI_INTERP_CONTROL_0                               regSPI_INTERP_CONTROL_0;
typedef union SPI_LB_CTR_CTRL                                    regSPI_LB_CTR_CTRL;
typedef union SPI_LB_DATA_PERWGP_WAVE_CS                         regSPI_LB_DATA_PERWGP_WAVE_CS;
typedef union SPI_LB_DATA_PERWGP_WAVE_HSGS                       regSPI_LB_DATA_PERWGP_WAVE_HSGS;
typedef union SPI_LB_DATA_PERWGP_WAVE_PS                         regSPI_LB_DATA_PERWGP_WAVE_PS;
typedef union SPI_LB_DATA_PERWGP_WAVE_VSPS                       regSPI_LB_DATA_PERWGP_WAVE_VSPS;
typedef union SPI_LB_DATA_REG                                    regSPI_LB_DATA_REG;
typedef union SPI_LB_DATA_WAVES                                  regSPI_LB_DATA_WAVES;
typedef union SPI_LB_WGP_MASK                                    regSPI_LB_WGP_MASK;
typedef union SPI_P0_TRAP_SCREEN_GPR_MIN                         regSPI_P0_TRAP_SCREEN_GPR_MIN;
typedef union SPI_P0_TRAP_SCREEN_PSBA_HI                         regSPI_P0_TRAP_SCREEN_PSBA_HI;
typedef union SPI_P0_TRAP_SCREEN_PSBA_LO                         regSPI_P0_TRAP_SCREEN_PSBA_LO;
typedef union SPI_P0_TRAP_SCREEN_PSMA_HI                         regSPI_P0_TRAP_SCREEN_PSMA_HI;
typedef union SPI_P0_TRAP_SCREEN_PSMA_LO                         regSPI_P0_TRAP_SCREEN_PSMA_LO;
typedef union SPI_P1_TRAP_SCREEN_GPR_MIN                         regSPI_P1_TRAP_SCREEN_GPR_MIN;
typedef union SPI_P1_TRAP_SCREEN_PSBA_HI                         regSPI_P1_TRAP_SCREEN_PSBA_HI;
typedef union SPI_P1_TRAP_SCREEN_PSBA_LO                         regSPI_P1_TRAP_SCREEN_PSBA_LO;
typedef union SPI_P1_TRAP_SCREEN_PSMA_HI                         regSPI_P1_TRAP_SCREEN_PSMA_HI;
typedef union SPI_P1_TRAP_SCREEN_PSMA_LO                         regSPI_P1_TRAP_SCREEN_PSMA_LO;
typedef union SPI_PERFCOUNTER0_HI                                regSPI_PERFCOUNTER0_HI;
typedef union SPI_PERFCOUNTER0_LO                                regSPI_PERFCOUNTER0_LO;
typedef union SPI_PERFCOUNTER0_SELECT                            regSPI_PERFCOUNTER0_SELECT;
typedef union SPI_PERFCOUNTER0_SELECT1                           regSPI_PERFCOUNTER0_SELECT1;
typedef union SPI_PERFCOUNTER1_HI                                regSPI_PERFCOUNTER1_HI;
typedef union SPI_PERFCOUNTER1_LO                                regSPI_PERFCOUNTER1_LO;
typedef union SPI_PERFCOUNTER1_SELECT                            regSPI_PERFCOUNTER1_SELECT;
typedef union SPI_PERFCOUNTER1_SELECT1                           regSPI_PERFCOUNTER1_SELECT1;
typedef union SPI_PERFCOUNTER2_HI                                regSPI_PERFCOUNTER2_HI;
typedef union SPI_PERFCOUNTER2_LO                                regSPI_PERFCOUNTER2_LO;
typedef union SPI_PERFCOUNTER2_SELECT                            regSPI_PERFCOUNTER2_SELECT;
typedef union SPI_PERFCOUNTER2_SELECT1                           regSPI_PERFCOUNTER2_SELECT1;
typedef union SPI_PERFCOUNTER3_HI                                regSPI_PERFCOUNTER3_HI;
typedef union SPI_PERFCOUNTER3_LO                                regSPI_PERFCOUNTER3_LO;
typedef union SPI_PERFCOUNTER3_SELECT                            regSPI_PERFCOUNTER3_SELECT;
typedef union SPI_PERFCOUNTER3_SELECT1                           regSPI_PERFCOUNTER3_SELECT1;
typedef union SPI_PERFCOUNTER4_HI                                regSPI_PERFCOUNTER4_HI;
typedef union SPI_PERFCOUNTER4_LO                                regSPI_PERFCOUNTER4_LO;
typedef union SPI_PERFCOUNTER4_SELECT                            regSPI_PERFCOUNTER4_SELECT;
typedef union SPI_PERFCOUNTER5_HI                                regSPI_PERFCOUNTER5_HI;
typedef union SPI_PERFCOUNTER5_LO                                regSPI_PERFCOUNTER5_LO;
typedef union SPI_PERFCOUNTER5_SELECT                            regSPI_PERFCOUNTER5_SELECT;
typedef union SPI_PERFCOUNTER_BINS                               regSPI_PERFCOUNTER_BINS;
typedef union SPI_PG_ENABLE_STATIC_WGP_MASK                      regSPI_PG_ENABLE_STATIC_WGP_MASK;
typedef union SPI_PQEV_CTRL                                      regSPI_PQEV_CTRL;
typedef union SPI_PS_INPUT_ADDR                                  regSPI_PS_INPUT_ADDR;
typedef union SPI_PS_INPUT_CNTL_0                                regSPI_PS_INPUT_CNTL_0;
typedef union SPI_PS_INPUT_CNTL_1                                regSPI_PS_INPUT_CNTL_1;
typedef union SPI_PS_INPUT_CNTL_2                                regSPI_PS_INPUT_CNTL_2;
typedef union SPI_PS_INPUT_CNTL_3                                regSPI_PS_INPUT_CNTL_3;
typedef union SPI_PS_INPUT_CNTL_4                                regSPI_PS_INPUT_CNTL_4;
typedef union SPI_PS_INPUT_CNTL_5                                regSPI_PS_INPUT_CNTL_5;
typedef union SPI_PS_INPUT_CNTL_6                                regSPI_PS_INPUT_CNTL_6;
typedef union SPI_PS_INPUT_CNTL_7                                regSPI_PS_INPUT_CNTL_7;
typedef union SPI_PS_INPUT_CNTL_8                                regSPI_PS_INPUT_CNTL_8;
typedef union SPI_PS_INPUT_CNTL_9                                regSPI_PS_INPUT_CNTL_9;
typedef union SPI_PS_INPUT_CNTL_10                               regSPI_PS_INPUT_CNTL_10;
typedef union SPI_PS_INPUT_CNTL_11                               regSPI_PS_INPUT_CNTL_11;
typedef union SPI_PS_INPUT_CNTL_12                               regSPI_PS_INPUT_CNTL_12;
typedef union SPI_PS_INPUT_CNTL_13                               regSPI_PS_INPUT_CNTL_13;
typedef union SPI_PS_INPUT_CNTL_14                               regSPI_PS_INPUT_CNTL_14;
typedef union SPI_PS_INPUT_CNTL_15                               regSPI_PS_INPUT_CNTL_15;
typedef union SPI_PS_INPUT_CNTL_16                               regSPI_PS_INPUT_CNTL_16;
typedef union SPI_PS_INPUT_CNTL_17                               regSPI_PS_INPUT_CNTL_17;
typedef union SPI_PS_INPUT_CNTL_18                               regSPI_PS_INPUT_CNTL_18;
typedef union SPI_PS_INPUT_CNTL_19                               regSPI_PS_INPUT_CNTL_19;
typedef union SPI_PS_INPUT_CNTL_20                               regSPI_PS_INPUT_CNTL_20;
typedef union SPI_PS_INPUT_CNTL_21                               regSPI_PS_INPUT_CNTL_21;
typedef union SPI_PS_INPUT_CNTL_22                               regSPI_PS_INPUT_CNTL_22;
typedef union SPI_PS_INPUT_CNTL_23                               regSPI_PS_INPUT_CNTL_23;
typedef union SPI_PS_INPUT_CNTL_24                               regSPI_PS_INPUT_CNTL_24;
typedef union SPI_PS_INPUT_CNTL_25                               regSPI_PS_INPUT_CNTL_25;
typedef union SPI_PS_INPUT_CNTL_26                               regSPI_PS_INPUT_CNTL_26;
typedef union SPI_PS_INPUT_CNTL_27                               regSPI_PS_INPUT_CNTL_27;
typedef union SPI_PS_INPUT_CNTL_28                               regSPI_PS_INPUT_CNTL_28;
typedef union SPI_PS_INPUT_CNTL_29                               regSPI_PS_INPUT_CNTL_29;
typedef union SPI_PS_INPUT_CNTL_30                               regSPI_PS_INPUT_CNTL_30;
typedef union SPI_PS_INPUT_CNTL_31                               regSPI_PS_INPUT_CNTL_31;
typedef union SPI_PS_INPUT_ENA                                   regSPI_PS_INPUT_ENA;
typedef union SPI_PS_IN_CONTROL                                  regSPI_PS_IN_CONTROL;
typedef union SPI_PS_MAX_WAVE_ID                                 regSPI_PS_MAX_WAVE_ID;
typedef union SPI_RESOURCE_RESERVE_CU_0                          regSPI_RESOURCE_RESERVE_CU_0;
typedef union SPI_RESOURCE_RESERVE_CU_1                          regSPI_RESOURCE_RESERVE_CU_1;
typedef union SPI_RESOURCE_RESERVE_CU_2                          regSPI_RESOURCE_RESERVE_CU_2;
typedef union SPI_RESOURCE_RESERVE_CU_3                          regSPI_RESOURCE_RESERVE_CU_3;
typedef union SPI_RESOURCE_RESERVE_CU_4                          regSPI_RESOURCE_RESERVE_CU_4;
typedef union SPI_RESOURCE_RESERVE_CU_5                          regSPI_RESOURCE_RESERVE_CU_5;
typedef union SPI_RESOURCE_RESERVE_CU_6                          regSPI_RESOURCE_RESERVE_CU_6;
typedef union SPI_RESOURCE_RESERVE_CU_7                          regSPI_RESOURCE_RESERVE_CU_7;
typedef union SPI_RESOURCE_RESERVE_CU_8                          regSPI_RESOURCE_RESERVE_CU_8;
typedef union SPI_RESOURCE_RESERVE_CU_9                          regSPI_RESOURCE_RESERVE_CU_9;
typedef union SPI_RESOURCE_RESERVE_CU_10                         regSPI_RESOURCE_RESERVE_CU_10;
typedef union SPI_RESOURCE_RESERVE_CU_11                         regSPI_RESOURCE_RESERVE_CU_11;
typedef union SPI_RESOURCE_RESERVE_CU_12                         regSPI_RESOURCE_RESERVE_CU_12;
typedef union SPI_RESOURCE_RESERVE_CU_13                         regSPI_RESOURCE_RESERVE_CU_13;
typedef union SPI_RESOURCE_RESERVE_CU_14                         regSPI_RESOURCE_RESERVE_CU_14;
typedef union SPI_RESOURCE_RESERVE_CU_15                         regSPI_RESOURCE_RESERVE_CU_15;
typedef union SPI_RESOURCE_RESERVE_EN_CU_0                       regSPI_RESOURCE_RESERVE_EN_CU_0;
typedef union SPI_RESOURCE_RESERVE_EN_CU_1                       regSPI_RESOURCE_RESERVE_EN_CU_1;
typedef union SPI_RESOURCE_RESERVE_EN_CU_2                       regSPI_RESOURCE_RESERVE_EN_CU_2;
typedef union SPI_RESOURCE_RESERVE_EN_CU_3                       regSPI_RESOURCE_RESERVE_EN_CU_3;
typedef union SPI_RESOURCE_RESERVE_EN_CU_4                       regSPI_RESOURCE_RESERVE_EN_CU_4;
typedef union SPI_RESOURCE_RESERVE_EN_CU_5                       regSPI_RESOURCE_RESERVE_EN_CU_5;
typedef union SPI_RESOURCE_RESERVE_EN_CU_6                       regSPI_RESOURCE_RESERVE_EN_CU_6;
typedef union SPI_RESOURCE_RESERVE_EN_CU_7                       regSPI_RESOURCE_RESERVE_EN_CU_7;
typedef union SPI_RESOURCE_RESERVE_EN_CU_8                       regSPI_RESOURCE_RESERVE_EN_CU_8;
typedef union SPI_RESOURCE_RESERVE_EN_CU_9                       regSPI_RESOURCE_RESERVE_EN_CU_9;
typedef union SPI_RESOURCE_RESERVE_EN_CU_10                      regSPI_RESOURCE_RESERVE_EN_CU_10;
typedef union SPI_RESOURCE_RESERVE_EN_CU_11                      regSPI_RESOURCE_RESERVE_EN_CU_11;
typedef union SPI_RESOURCE_RESERVE_EN_CU_12                      regSPI_RESOURCE_RESERVE_EN_CU_12;
typedef union SPI_RESOURCE_RESERVE_EN_CU_13                      regSPI_RESOURCE_RESERVE_EN_CU_13;
typedef union SPI_RESOURCE_RESERVE_EN_CU_14                      regSPI_RESOURCE_RESERVE_EN_CU_14;
typedef union SPI_RESOURCE_RESERVE_EN_CU_15                      regSPI_RESOURCE_RESERVE_EN_CU_15;
typedef union SPI_SHADER_COL_FORMAT                              regSPI_SHADER_COL_FORMAT;
typedef union SPI_SHADER_GS_MESHLET_DIM                          regSPI_SHADER_GS_MESHLET_DIM;
typedef union SPI_SHADER_GS_MESHLET_EXP_ALLOC                    regSPI_SHADER_GS_MESHLET_EXP_ALLOC;
typedef union SPI_SHADER_IDX_FORMAT                              regSPI_SHADER_IDX_FORMAT;
typedef union SPI_SHADER_LATE_ALLOC_VS                           regSPI_SHADER_LATE_ALLOC_VS;
typedef union SPI_SHADER_PGM_CHKSUM_GS                           regSPI_SHADER_PGM_CHKSUM_GS;
typedef union SPI_SHADER_PGM_CHKSUM_HS                           regSPI_SHADER_PGM_CHKSUM_HS;
typedef union SPI_SHADER_PGM_CHKSUM_PS                           regSPI_SHADER_PGM_CHKSUM_PS;
typedef union SPI_SHADER_PGM_CHKSUM_VS                           regSPI_SHADER_PGM_CHKSUM_VS;
typedef union SPI_SHADER_PGM_HI_ES                               regSPI_SHADER_PGM_HI_ES;
typedef union SPI_SHADER_PGM_HI_ES_GS                            regSPI_SHADER_PGM_HI_ES_GS;
typedef union SPI_SHADER_PGM_HI_GS                               regSPI_SHADER_PGM_HI_GS;
typedef union SPI_SHADER_PGM_HI_HS                               regSPI_SHADER_PGM_HI_HS;
typedef union SPI_SHADER_PGM_HI_LS                               regSPI_SHADER_PGM_HI_LS;
typedef union SPI_SHADER_PGM_HI_LS_HS                            regSPI_SHADER_PGM_HI_LS_HS;
typedef union SPI_SHADER_PGM_HI_PS                               regSPI_SHADER_PGM_HI_PS;
typedef union SPI_SHADER_PGM_HI_VS                               regSPI_SHADER_PGM_HI_VS;
typedef union SPI_SHADER_PGM_LO_ES                               regSPI_SHADER_PGM_LO_ES;
typedef union SPI_SHADER_PGM_LO_ES_GS                            regSPI_SHADER_PGM_LO_ES_GS;
typedef union SPI_SHADER_PGM_LO_GS                               regSPI_SHADER_PGM_LO_GS;
typedef union SPI_SHADER_PGM_LO_HS                               regSPI_SHADER_PGM_LO_HS;
typedef union SPI_SHADER_PGM_LO_LS                               regSPI_SHADER_PGM_LO_LS;
typedef union SPI_SHADER_PGM_LO_LS_HS                            regSPI_SHADER_PGM_LO_LS_HS;
typedef union SPI_SHADER_PGM_LO_PS                               regSPI_SHADER_PGM_LO_PS;
typedef union SPI_SHADER_PGM_LO_VS                               regSPI_SHADER_PGM_LO_VS;
typedef union SPI_SHADER_PGM_RSRC1_ES                            regSPI_SHADER_PGM_RSRC1_ES;
typedef union SPI_SHADER_PGM_RSRC1_GS                            regSPI_SHADER_PGM_RSRC1_GS;
typedef union SPI_SHADER_PGM_RSRC1_HS                            regSPI_SHADER_PGM_RSRC1_HS;
typedef union SPI_SHADER_PGM_RSRC1_LS                            regSPI_SHADER_PGM_RSRC1_LS;
typedef union SPI_SHADER_PGM_RSRC1_PS                            regSPI_SHADER_PGM_RSRC1_PS;
typedef union SPI_SHADER_PGM_RSRC1_VS                            regSPI_SHADER_PGM_RSRC1_VS;
typedef union SPI_SHADER_PGM_RSRC2_ES                            regSPI_SHADER_PGM_RSRC2_ES;
typedef union SPI_SHADER_PGM_RSRC2_ES_GS                         regSPI_SHADER_PGM_RSRC2_ES_GS;
typedef union SPI_SHADER_PGM_RSRC2_ES_VS                         regSPI_SHADER_PGM_RSRC2_ES_VS;
typedef union SPI_SHADER_PGM_RSRC2_GS                            regSPI_SHADER_PGM_RSRC2_GS;
typedef union SPI_SHADER_PGM_RSRC2_GS_VS                         regSPI_SHADER_PGM_RSRC2_GS_VS;
typedef union SPI_SHADER_PGM_RSRC2_HS                            regSPI_SHADER_PGM_RSRC2_HS;
typedef union SPI_SHADER_PGM_RSRC2_LS                            regSPI_SHADER_PGM_RSRC2_LS;
typedef union SPI_SHADER_PGM_RSRC2_LS_ES                         regSPI_SHADER_PGM_RSRC2_LS_ES;
typedef union SPI_SHADER_PGM_RSRC2_LS_HS                         regSPI_SHADER_PGM_RSRC2_LS_HS;
typedef union SPI_SHADER_PGM_RSRC2_LS_VS                         regSPI_SHADER_PGM_RSRC2_LS_VS;
typedef union SPI_SHADER_PGM_RSRC2_PS                            regSPI_SHADER_PGM_RSRC2_PS;
typedef union SPI_SHADER_PGM_RSRC2_VS                            regSPI_SHADER_PGM_RSRC2_VS;
typedef union SPI_SHADER_PGM_RSRC3_ES                            regSPI_SHADER_PGM_RSRC3_ES;
typedef union SPI_SHADER_PGM_RSRC3_GS                            regSPI_SHADER_PGM_RSRC3_GS;
typedef union SPI_SHADER_PGM_RSRC3_HS                            regSPI_SHADER_PGM_RSRC3_HS;
typedef union SPI_SHADER_PGM_RSRC3_LS                            regSPI_SHADER_PGM_RSRC3_LS;
typedef union SPI_SHADER_PGM_RSRC3_PS                            regSPI_SHADER_PGM_RSRC3_PS;
typedef union SPI_SHADER_PGM_RSRC3_VS                            regSPI_SHADER_PGM_RSRC3_VS;
typedef union SPI_SHADER_PGM_RSRC4_GS                            regSPI_SHADER_PGM_RSRC4_GS;
typedef union SPI_SHADER_PGM_RSRC4_HS                            regSPI_SHADER_PGM_RSRC4_HS;
typedef union SPI_SHADER_PGM_RSRC4_PS                            regSPI_SHADER_PGM_RSRC4_PS;
typedef union SPI_SHADER_PGM_RSRC4_VS                            regSPI_SHADER_PGM_RSRC4_VS;
typedef union SPI_SHADER_POS_FORMAT                              regSPI_SHADER_POS_FORMAT;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_0                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_1                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_2                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_3                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_0                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_1                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_2                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_3                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_0                     regSPI_SHADER_PREF_PRI_ACCUM_PS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_1                     regSPI_SHADER_PREF_PRI_ACCUM_PS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_2                     regSPI_SHADER_PREF_PRI_ACCUM_PS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_3                     regSPI_SHADER_PREF_PRI_ACCUM_PS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_0                     regSPI_SHADER_PREF_PRI_ACCUM_VS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_1                     regSPI_SHADER_PREF_PRI_ACCUM_VS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_2                     regSPI_SHADER_PREF_PRI_ACCUM_VS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_3                     regSPI_SHADER_PREF_PRI_ACCUM_VS_3;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS                 regSPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS                 regSPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_PS                   regSPI_SHADER_PREF_PRI_CNTR_CTRL_PS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_VS                   regSPI_SHADER_PREF_PRI_CNTR_CTRL_VS;
typedef union SPI_SHADER_REQ_CTRL_ESGS                           regSPI_SHADER_REQ_CTRL_ESGS;
typedef union SPI_SHADER_REQ_CTRL_LSHS                           regSPI_SHADER_REQ_CTRL_LSHS;
typedef union SPI_SHADER_REQ_CTRL_PS                             regSPI_SHADER_REQ_CTRL_PS;
typedef union SPI_SHADER_REQ_CTRL_VS                             regSPI_SHADER_REQ_CTRL_VS;
typedef union SPI_SHADER_RSRC_LIMIT_CTRL                         regSPI_SHADER_RSRC_LIMIT_CTRL;
typedef union SPI_SHADER_USER_ACCUM_ESGS_0                       regSPI_SHADER_USER_ACCUM_ESGS_0;
typedef union SPI_SHADER_USER_ACCUM_ESGS_1                       regSPI_SHADER_USER_ACCUM_ESGS_1;
typedef union SPI_SHADER_USER_ACCUM_ESGS_2                       regSPI_SHADER_USER_ACCUM_ESGS_2;
typedef union SPI_SHADER_USER_ACCUM_ESGS_3                       regSPI_SHADER_USER_ACCUM_ESGS_3;
typedef union SPI_SHADER_USER_ACCUM_LSHS_0                       regSPI_SHADER_USER_ACCUM_LSHS_0;
typedef union SPI_SHADER_USER_ACCUM_LSHS_1                       regSPI_SHADER_USER_ACCUM_LSHS_1;
typedef union SPI_SHADER_USER_ACCUM_LSHS_2                       regSPI_SHADER_USER_ACCUM_LSHS_2;
typedef union SPI_SHADER_USER_ACCUM_LSHS_3                       regSPI_SHADER_USER_ACCUM_LSHS_3;
typedef union SPI_SHADER_USER_ACCUM_PS_0                         regSPI_SHADER_USER_ACCUM_PS_0;
typedef union SPI_SHADER_USER_ACCUM_PS_1                         regSPI_SHADER_USER_ACCUM_PS_1;
typedef union SPI_SHADER_USER_ACCUM_PS_2                         regSPI_SHADER_USER_ACCUM_PS_2;
typedef union SPI_SHADER_USER_ACCUM_PS_3                         regSPI_SHADER_USER_ACCUM_PS_3;
typedef union SPI_SHADER_USER_ACCUM_VS_0                         regSPI_SHADER_USER_ACCUM_VS_0;
typedef union SPI_SHADER_USER_ACCUM_VS_1                         regSPI_SHADER_USER_ACCUM_VS_1;
typedef union SPI_SHADER_USER_ACCUM_VS_2                         regSPI_SHADER_USER_ACCUM_VS_2;
typedef union SPI_SHADER_USER_ACCUM_VS_3                         regSPI_SHADER_USER_ACCUM_VS_3;
typedef union SPI_SHADER_USER_DATA_ADDR_HI_GS                    regSPI_SHADER_USER_DATA_ADDR_HI_GS;
typedef union SPI_SHADER_USER_DATA_ADDR_HI_HS                    regSPI_SHADER_USER_DATA_ADDR_HI_HS;
typedef union SPI_SHADER_USER_DATA_ADDR_LO_GS                    regSPI_SHADER_USER_DATA_ADDR_LO_GS;
typedef union SPI_SHADER_USER_DATA_ADDR_LO_HS                    regSPI_SHADER_USER_DATA_ADDR_LO_HS;
typedef union SPI_SHADER_USER_DATA_ES_0                          regSPI_SHADER_USER_DATA_ES_0;
typedef union SPI_SHADER_USER_DATA_ES_1                          regSPI_SHADER_USER_DATA_ES_1;
typedef union SPI_SHADER_USER_DATA_ES_2                          regSPI_SHADER_USER_DATA_ES_2;
typedef union SPI_SHADER_USER_DATA_ES_3                          regSPI_SHADER_USER_DATA_ES_3;
typedef union SPI_SHADER_USER_DATA_ES_4                          regSPI_SHADER_USER_DATA_ES_4;
typedef union SPI_SHADER_USER_DATA_ES_5                          regSPI_SHADER_USER_DATA_ES_5;
typedef union SPI_SHADER_USER_DATA_ES_6                          regSPI_SHADER_USER_DATA_ES_6;
typedef union SPI_SHADER_USER_DATA_ES_7                          regSPI_SHADER_USER_DATA_ES_7;
typedef union SPI_SHADER_USER_DATA_ES_8                          regSPI_SHADER_USER_DATA_ES_8;
typedef union SPI_SHADER_USER_DATA_ES_9                          regSPI_SHADER_USER_DATA_ES_9;
typedef union SPI_SHADER_USER_DATA_ES_10                         regSPI_SHADER_USER_DATA_ES_10;
typedef union SPI_SHADER_USER_DATA_ES_11                         regSPI_SHADER_USER_DATA_ES_11;
typedef union SPI_SHADER_USER_DATA_ES_12                         regSPI_SHADER_USER_DATA_ES_12;
typedef union SPI_SHADER_USER_DATA_ES_13                         regSPI_SHADER_USER_DATA_ES_13;
typedef union SPI_SHADER_USER_DATA_ES_14                         regSPI_SHADER_USER_DATA_ES_14;
typedef union SPI_SHADER_USER_DATA_ES_15                         regSPI_SHADER_USER_DATA_ES_15;
typedef union SPI_SHADER_USER_DATA_GS_0                          regSPI_SHADER_USER_DATA_GS_0;
typedef union SPI_SHADER_USER_DATA_GS_1                          regSPI_SHADER_USER_DATA_GS_1;
typedef union SPI_SHADER_USER_DATA_GS_2                          regSPI_SHADER_USER_DATA_GS_2;
typedef union SPI_SHADER_USER_DATA_GS_3                          regSPI_SHADER_USER_DATA_GS_3;
typedef union SPI_SHADER_USER_DATA_GS_4                          regSPI_SHADER_USER_DATA_GS_4;
typedef union SPI_SHADER_USER_DATA_GS_5                          regSPI_SHADER_USER_DATA_GS_5;
typedef union SPI_SHADER_USER_DATA_GS_6                          regSPI_SHADER_USER_DATA_GS_6;
typedef union SPI_SHADER_USER_DATA_GS_7                          regSPI_SHADER_USER_DATA_GS_7;
typedef union SPI_SHADER_USER_DATA_GS_8                          regSPI_SHADER_USER_DATA_GS_8;
typedef union SPI_SHADER_USER_DATA_GS_9                          regSPI_SHADER_USER_DATA_GS_9;
typedef union SPI_SHADER_USER_DATA_GS_10                         regSPI_SHADER_USER_DATA_GS_10;
typedef union SPI_SHADER_USER_DATA_GS_11                         regSPI_SHADER_USER_DATA_GS_11;
typedef union SPI_SHADER_USER_DATA_GS_12                         regSPI_SHADER_USER_DATA_GS_12;
typedef union SPI_SHADER_USER_DATA_GS_13                         regSPI_SHADER_USER_DATA_GS_13;
typedef union SPI_SHADER_USER_DATA_GS_14                         regSPI_SHADER_USER_DATA_GS_14;
typedef union SPI_SHADER_USER_DATA_GS_15                         regSPI_SHADER_USER_DATA_GS_15;
typedef union SPI_SHADER_USER_DATA_GS_16                         regSPI_SHADER_USER_DATA_GS_16;
typedef union SPI_SHADER_USER_DATA_GS_17                         regSPI_SHADER_USER_DATA_GS_17;
typedef union SPI_SHADER_USER_DATA_GS_18                         regSPI_SHADER_USER_DATA_GS_18;
typedef union SPI_SHADER_USER_DATA_GS_19                         regSPI_SHADER_USER_DATA_GS_19;
typedef union SPI_SHADER_USER_DATA_GS_20                         regSPI_SHADER_USER_DATA_GS_20;
typedef union SPI_SHADER_USER_DATA_GS_21                         regSPI_SHADER_USER_DATA_GS_21;
typedef union SPI_SHADER_USER_DATA_GS_22                         regSPI_SHADER_USER_DATA_GS_22;
typedef union SPI_SHADER_USER_DATA_GS_23                         regSPI_SHADER_USER_DATA_GS_23;
typedef union SPI_SHADER_USER_DATA_GS_24                         regSPI_SHADER_USER_DATA_GS_24;
typedef union SPI_SHADER_USER_DATA_GS_25                         regSPI_SHADER_USER_DATA_GS_25;
typedef union SPI_SHADER_USER_DATA_GS_26                         regSPI_SHADER_USER_DATA_GS_26;
typedef union SPI_SHADER_USER_DATA_GS_27                         regSPI_SHADER_USER_DATA_GS_27;
typedef union SPI_SHADER_USER_DATA_GS_28                         regSPI_SHADER_USER_DATA_GS_28;
typedef union SPI_SHADER_USER_DATA_GS_29                         regSPI_SHADER_USER_DATA_GS_29;
typedef union SPI_SHADER_USER_DATA_GS_30                         regSPI_SHADER_USER_DATA_GS_30;
typedef union SPI_SHADER_USER_DATA_GS_31                         regSPI_SHADER_USER_DATA_GS_31;
typedef union SPI_SHADER_USER_DATA_HS_0                          regSPI_SHADER_USER_DATA_HS_0;
typedef union SPI_SHADER_USER_DATA_HS_1                          regSPI_SHADER_USER_DATA_HS_1;
typedef union SPI_SHADER_USER_DATA_HS_2                          regSPI_SHADER_USER_DATA_HS_2;
typedef union SPI_SHADER_USER_DATA_HS_3                          regSPI_SHADER_USER_DATA_HS_3;
typedef union SPI_SHADER_USER_DATA_HS_4                          regSPI_SHADER_USER_DATA_HS_4;
typedef union SPI_SHADER_USER_DATA_HS_5                          regSPI_SHADER_USER_DATA_HS_5;
typedef union SPI_SHADER_USER_DATA_HS_6                          regSPI_SHADER_USER_DATA_HS_6;
typedef union SPI_SHADER_USER_DATA_HS_7                          regSPI_SHADER_USER_DATA_HS_7;
typedef union SPI_SHADER_USER_DATA_HS_8                          regSPI_SHADER_USER_DATA_HS_8;
typedef union SPI_SHADER_USER_DATA_HS_9                          regSPI_SHADER_USER_DATA_HS_9;
typedef union SPI_SHADER_USER_DATA_HS_10                         regSPI_SHADER_USER_DATA_HS_10;
typedef union SPI_SHADER_USER_DATA_HS_11                         regSPI_SHADER_USER_DATA_HS_11;
typedef union SPI_SHADER_USER_DATA_HS_12                         regSPI_SHADER_USER_DATA_HS_12;
typedef union SPI_SHADER_USER_DATA_HS_13                         regSPI_SHADER_USER_DATA_HS_13;
typedef union SPI_SHADER_USER_DATA_HS_14                         regSPI_SHADER_USER_DATA_HS_14;
typedef union SPI_SHADER_USER_DATA_HS_15                         regSPI_SHADER_USER_DATA_HS_15;
typedef union SPI_SHADER_USER_DATA_HS_16                         regSPI_SHADER_USER_DATA_HS_16;
typedef union SPI_SHADER_USER_DATA_HS_17                         regSPI_SHADER_USER_DATA_HS_17;
typedef union SPI_SHADER_USER_DATA_HS_18                         regSPI_SHADER_USER_DATA_HS_18;
typedef union SPI_SHADER_USER_DATA_HS_19                         regSPI_SHADER_USER_DATA_HS_19;
typedef union SPI_SHADER_USER_DATA_HS_20                         regSPI_SHADER_USER_DATA_HS_20;
typedef union SPI_SHADER_USER_DATA_HS_21                         regSPI_SHADER_USER_DATA_HS_21;
typedef union SPI_SHADER_USER_DATA_HS_22                         regSPI_SHADER_USER_DATA_HS_22;
typedef union SPI_SHADER_USER_DATA_HS_23                         regSPI_SHADER_USER_DATA_HS_23;
typedef union SPI_SHADER_USER_DATA_HS_24                         regSPI_SHADER_USER_DATA_HS_24;
typedef union SPI_SHADER_USER_DATA_HS_25                         regSPI_SHADER_USER_DATA_HS_25;
typedef union SPI_SHADER_USER_DATA_HS_26                         regSPI_SHADER_USER_DATA_HS_26;
typedef union SPI_SHADER_USER_DATA_HS_27                         regSPI_SHADER_USER_DATA_HS_27;
typedef union SPI_SHADER_USER_DATA_HS_28                         regSPI_SHADER_USER_DATA_HS_28;
typedef union SPI_SHADER_USER_DATA_HS_29                         regSPI_SHADER_USER_DATA_HS_29;
typedef union SPI_SHADER_USER_DATA_HS_30                         regSPI_SHADER_USER_DATA_HS_30;
typedef union SPI_SHADER_USER_DATA_HS_31                         regSPI_SHADER_USER_DATA_HS_31;
typedef union SPI_SHADER_USER_DATA_LS_0                          regSPI_SHADER_USER_DATA_LS_0;
typedef union SPI_SHADER_USER_DATA_LS_1                          regSPI_SHADER_USER_DATA_LS_1;
typedef union SPI_SHADER_USER_DATA_LS_2                          regSPI_SHADER_USER_DATA_LS_2;
typedef union SPI_SHADER_USER_DATA_LS_3                          regSPI_SHADER_USER_DATA_LS_3;
typedef union SPI_SHADER_USER_DATA_LS_4                          regSPI_SHADER_USER_DATA_LS_4;
typedef union SPI_SHADER_USER_DATA_LS_5                          regSPI_SHADER_USER_DATA_LS_5;
typedef union SPI_SHADER_USER_DATA_LS_6                          regSPI_SHADER_USER_DATA_LS_6;
typedef union SPI_SHADER_USER_DATA_LS_7                          regSPI_SHADER_USER_DATA_LS_7;
typedef union SPI_SHADER_USER_DATA_LS_8                          regSPI_SHADER_USER_DATA_LS_8;
typedef union SPI_SHADER_USER_DATA_LS_9                          regSPI_SHADER_USER_DATA_LS_9;
typedef union SPI_SHADER_USER_DATA_LS_10                         regSPI_SHADER_USER_DATA_LS_10;
typedef union SPI_SHADER_USER_DATA_LS_11                         regSPI_SHADER_USER_DATA_LS_11;
typedef union SPI_SHADER_USER_DATA_LS_12                         regSPI_SHADER_USER_DATA_LS_12;
typedef union SPI_SHADER_USER_DATA_LS_13                         regSPI_SHADER_USER_DATA_LS_13;
typedef union SPI_SHADER_USER_DATA_LS_14                         regSPI_SHADER_USER_DATA_LS_14;
typedef union SPI_SHADER_USER_DATA_LS_15                         regSPI_SHADER_USER_DATA_LS_15;
typedef union SPI_SHADER_USER_DATA_PS_0                          regSPI_SHADER_USER_DATA_PS_0;
typedef union SPI_SHADER_USER_DATA_PS_1                          regSPI_SHADER_USER_DATA_PS_1;
typedef union SPI_SHADER_USER_DATA_PS_2                          regSPI_SHADER_USER_DATA_PS_2;
typedef union SPI_SHADER_USER_DATA_PS_3                          regSPI_SHADER_USER_DATA_PS_3;
typedef union SPI_SHADER_USER_DATA_PS_4                          regSPI_SHADER_USER_DATA_PS_4;
typedef union SPI_SHADER_USER_DATA_PS_5                          regSPI_SHADER_USER_DATA_PS_5;
typedef union SPI_SHADER_USER_DATA_PS_6                          regSPI_SHADER_USER_DATA_PS_6;
typedef union SPI_SHADER_USER_DATA_PS_7                          regSPI_SHADER_USER_DATA_PS_7;
typedef union SPI_SHADER_USER_DATA_PS_8                          regSPI_SHADER_USER_DATA_PS_8;
typedef union SPI_SHADER_USER_DATA_PS_9                          regSPI_SHADER_USER_DATA_PS_9;
typedef union SPI_SHADER_USER_DATA_PS_10                         regSPI_SHADER_USER_DATA_PS_10;
typedef union SPI_SHADER_USER_DATA_PS_11                         regSPI_SHADER_USER_DATA_PS_11;
typedef union SPI_SHADER_USER_DATA_PS_12                         regSPI_SHADER_USER_DATA_PS_12;
typedef union SPI_SHADER_USER_DATA_PS_13                         regSPI_SHADER_USER_DATA_PS_13;
typedef union SPI_SHADER_USER_DATA_PS_14                         regSPI_SHADER_USER_DATA_PS_14;
typedef union SPI_SHADER_USER_DATA_PS_15                         regSPI_SHADER_USER_DATA_PS_15;
typedef union SPI_SHADER_USER_DATA_PS_16                         regSPI_SHADER_USER_DATA_PS_16;
typedef union SPI_SHADER_USER_DATA_PS_17                         regSPI_SHADER_USER_DATA_PS_17;
typedef union SPI_SHADER_USER_DATA_PS_18                         regSPI_SHADER_USER_DATA_PS_18;
typedef union SPI_SHADER_USER_DATA_PS_19                         regSPI_SHADER_USER_DATA_PS_19;
typedef union SPI_SHADER_USER_DATA_PS_20                         regSPI_SHADER_USER_DATA_PS_20;
typedef union SPI_SHADER_USER_DATA_PS_21                         regSPI_SHADER_USER_DATA_PS_21;
typedef union SPI_SHADER_USER_DATA_PS_22                         regSPI_SHADER_USER_DATA_PS_22;
typedef union SPI_SHADER_USER_DATA_PS_23                         regSPI_SHADER_USER_DATA_PS_23;
typedef union SPI_SHADER_USER_DATA_PS_24                         regSPI_SHADER_USER_DATA_PS_24;
typedef union SPI_SHADER_USER_DATA_PS_25                         regSPI_SHADER_USER_DATA_PS_25;
typedef union SPI_SHADER_USER_DATA_PS_26                         regSPI_SHADER_USER_DATA_PS_26;
typedef union SPI_SHADER_USER_DATA_PS_27                         regSPI_SHADER_USER_DATA_PS_27;
typedef union SPI_SHADER_USER_DATA_PS_28                         regSPI_SHADER_USER_DATA_PS_28;
typedef union SPI_SHADER_USER_DATA_PS_29                         regSPI_SHADER_USER_DATA_PS_29;
typedef union SPI_SHADER_USER_DATA_PS_30                         regSPI_SHADER_USER_DATA_PS_30;
typedef union SPI_SHADER_USER_DATA_PS_31                         regSPI_SHADER_USER_DATA_PS_31;
typedef union SPI_SHADER_USER_DATA_VS_0                          regSPI_SHADER_USER_DATA_VS_0;
typedef union SPI_SHADER_USER_DATA_VS_1                          regSPI_SHADER_USER_DATA_VS_1;
typedef union SPI_SHADER_USER_DATA_VS_2                          regSPI_SHADER_USER_DATA_VS_2;
typedef union SPI_SHADER_USER_DATA_VS_3                          regSPI_SHADER_USER_DATA_VS_3;
typedef union SPI_SHADER_USER_DATA_VS_4                          regSPI_SHADER_USER_DATA_VS_4;
typedef union SPI_SHADER_USER_DATA_VS_5                          regSPI_SHADER_USER_DATA_VS_5;
typedef union SPI_SHADER_USER_DATA_VS_6                          regSPI_SHADER_USER_DATA_VS_6;
typedef union SPI_SHADER_USER_DATA_VS_7                          regSPI_SHADER_USER_DATA_VS_7;
typedef union SPI_SHADER_USER_DATA_VS_8                          regSPI_SHADER_USER_DATA_VS_8;
typedef union SPI_SHADER_USER_DATA_VS_9                          regSPI_SHADER_USER_DATA_VS_9;
typedef union SPI_SHADER_USER_DATA_VS_10                         regSPI_SHADER_USER_DATA_VS_10;
typedef union SPI_SHADER_USER_DATA_VS_11                         regSPI_SHADER_USER_DATA_VS_11;
typedef union SPI_SHADER_USER_DATA_VS_12                         regSPI_SHADER_USER_DATA_VS_12;
typedef union SPI_SHADER_USER_DATA_VS_13                         regSPI_SHADER_USER_DATA_VS_13;
typedef union SPI_SHADER_USER_DATA_VS_14                         regSPI_SHADER_USER_DATA_VS_14;
typedef union SPI_SHADER_USER_DATA_VS_15                         regSPI_SHADER_USER_DATA_VS_15;
typedef union SPI_SHADER_USER_DATA_VS_16                         regSPI_SHADER_USER_DATA_VS_16;
typedef union SPI_SHADER_USER_DATA_VS_17                         regSPI_SHADER_USER_DATA_VS_17;
typedef union SPI_SHADER_USER_DATA_VS_18                         regSPI_SHADER_USER_DATA_VS_18;
typedef union SPI_SHADER_USER_DATA_VS_19                         regSPI_SHADER_USER_DATA_VS_19;
typedef union SPI_SHADER_USER_DATA_VS_20                         regSPI_SHADER_USER_DATA_VS_20;
typedef union SPI_SHADER_USER_DATA_VS_21                         regSPI_SHADER_USER_DATA_VS_21;
typedef union SPI_SHADER_USER_DATA_VS_22                         regSPI_SHADER_USER_DATA_VS_22;
typedef union SPI_SHADER_USER_DATA_VS_23                         regSPI_SHADER_USER_DATA_VS_23;
typedef union SPI_SHADER_USER_DATA_VS_24                         regSPI_SHADER_USER_DATA_VS_24;
typedef union SPI_SHADER_USER_DATA_VS_25                         regSPI_SHADER_USER_DATA_VS_25;
typedef union SPI_SHADER_USER_DATA_VS_26                         regSPI_SHADER_USER_DATA_VS_26;
typedef union SPI_SHADER_USER_DATA_VS_27                         regSPI_SHADER_USER_DATA_VS_27;
typedef union SPI_SHADER_USER_DATA_VS_28                         regSPI_SHADER_USER_DATA_VS_28;
typedef union SPI_SHADER_USER_DATA_VS_29                         regSPI_SHADER_USER_DATA_VS_29;
typedef union SPI_SHADER_USER_DATA_VS_30                         regSPI_SHADER_USER_DATA_VS_30;
typedef union SPI_SHADER_USER_DATA_VS_31                         regSPI_SHADER_USER_DATA_VS_31;
typedef union SPI_SHADER_Z_FORMAT                                regSPI_SHADER_Z_FORMAT;
typedef union SPI_START_PHASE                                    regSPI_START_PHASE;
typedef union SPI_SX_EXPORT_BUFFER_SIZES                         regSPI_SX_EXPORT_BUFFER_SIZES;
typedef union SPI_SX_SCOREBOARD_BUFFER_SIZES                     regSPI_SX_SCOREBOARD_BUFFER_SIZES;
typedef union SPI_SYS_COMPUTE                                    regSPI_SYS_COMPUTE;
typedef union SPI_SYS_WIF_CNTL                                   regSPI_SYS_WIF_CNTL;
typedef union SPI_TMPRING_SIZE                                   regSPI_TMPRING_SIZE;
typedef union SPI_USER_ACCUM_VMID_CNTL                           regSPI_USER_ACCUM_VMID_CNTL;
typedef union SPI_VS_OUT_CONFIG                                  regSPI_VS_OUT_CONFIG;
typedef union SPI_WAVE_LIMIT_CNTL                                regSPI_WAVE_LIMIT_CNTL;
typedef union SPI_WAVE_LIMIT_CNTL_REMAP                          regSPI_WAVE_LIMIT_CNTL_REMAP;
typedef union SPI_WCL_PIPE_PERCENT_CS0                           regSPI_WCL_PIPE_PERCENT_CS0;
typedef union SPI_WCL_PIPE_PERCENT_CS1                           regSPI_WCL_PIPE_PERCENT_CS1;
typedef union SPI_WCL_PIPE_PERCENT_CS2                           regSPI_WCL_PIPE_PERCENT_CS2;
typedef union SPI_WCL_PIPE_PERCENT_CS3                           regSPI_WCL_PIPE_PERCENT_CS3;
typedef union SPI_WCL_PIPE_PERCENT_CS4                           regSPI_WCL_PIPE_PERCENT_CS4;
typedef union SPI_WCL_PIPE_PERCENT_CS5                           regSPI_WCL_PIPE_PERCENT_CS5;
typedef union SPI_WCL_PIPE_PERCENT_CS6                           regSPI_WCL_PIPE_PERCENT_CS6;
typedef union SPI_WCL_PIPE_PERCENT_CS7                           regSPI_WCL_PIPE_PERCENT_CS7;
typedef union SPI_WCL_PIPE_PERCENT_GFX                           regSPI_WCL_PIPE_PERCENT_GFX;
typedef union SPI_WCL_PIPE_PERCENT_HP3D                          regSPI_WCL_PIPE_PERCENT_HP3D;
typedef union SPI_WF_ACTIVE_COUNT_GFX                            regSPI_WF_ACTIVE_COUNT_GFX;
typedef union SPI_WF_ACTIVE_COUNT_HPG                            regSPI_WF_ACTIVE_COUNT_HPG;
typedef union SPI_WF_LIFETIME_CNTL                               regSPI_WF_LIFETIME_CNTL;
typedef union SPI_WF_LIFETIME_LIMIT_0                            regSPI_WF_LIFETIME_LIMIT_0;
typedef union SPI_WF_LIFETIME_LIMIT_1                            regSPI_WF_LIFETIME_LIMIT_1;
typedef union SPI_WF_LIFETIME_LIMIT_2                            regSPI_WF_LIFETIME_LIMIT_2;
typedef union SPI_WF_LIFETIME_LIMIT_3                            regSPI_WF_LIFETIME_LIMIT_3;
typedef union SPI_WF_LIFETIME_LIMIT_4                            regSPI_WF_LIFETIME_LIMIT_4;
typedef union SPI_WF_LIFETIME_LIMIT_5                            regSPI_WF_LIFETIME_LIMIT_5;
typedef union SPI_WF_LIFETIME_LIMIT_6                            regSPI_WF_LIFETIME_LIMIT_6;
typedef union SPI_WF_LIFETIME_LIMIT_7                            regSPI_WF_LIFETIME_LIMIT_7;
typedef union SPI_WF_LIFETIME_LIMIT_8                            regSPI_WF_LIFETIME_LIMIT_8;
typedef union SPI_WF_LIFETIME_LIMIT_9                            regSPI_WF_LIFETIME_LIMIT_9;
typedef union SPI_WF_LIFETIME_STATUS_0                           regSPI_WF_LIFETIME_STATUS_0;
typedef union SPI_WF_LIFETIME_STATUS_1                           regSPI_WF_LIFETIME_STATUS_1;
typedef union SPI_WF_LIFETIME_STATUS_2                           regSPI_WF_LIFETIME_STATUS_2;
typedef union SPI_WF_LIFETIME_STATUS_3                           regSPI_WF_LIFETIME_STATUS_3;
typedef union SPI_WF_LIFETIME_STATUS_4                           regSPI_WF_LIFETIME_STATUS_4;
typedef union SPI_WF_LIFETIME_STATUS_5                           regSPI_WF_LIFETIME_STATUS_5;
typedef union SPI_WF_LIFETIME_STATUS_6                           regSPI_WF_LIFETIME_STATUS_6;
typedef union SPI_WF_LIFETIME_STATUS_7                           regSPI_WF_LIFETIME_STATUS_7;
typedef union SPI_WF_LIFETIME_STATUS_8                           regSPI_WF_LIFETIME_STATUS_8;
typedef union SPI_WF_LIFETIME_STATUS_9                           regSPI_WF_LIFETIME_STATUS_9;
typedef union SPI_WF_LIFETIME_STATUS_10                          regSPI_WF_LIFETIME_STATUS_10;
typedef union SPI_WF_LIFETIME_STATUS_11                          regSPI_WF_LIFETIME_STATUS_11;
typedef union SPI_WF_LIFETIME_STATUS_12                          regSPI_WF_LIFETIME_STATUS_12;
typedef union SPI_WF_LIFETIME_STATUS_13                          regSPI_WF_LIFETIME_STATUS_13;
typedef union SPI_WF_LIFETIME_STATUS_14                          regSPI_WF_LIFETIME_STATUS_14;
typedef union SPI_WF_LIFETIME_STATUS_15                          regSPI_WF_LIFETIME_STATUS_15;
typedef union SPI_WF_LIFETIME_STATUS_16                          regSPI_WF_LIFETIME_STATUS_16;
typedef union SPI_WF_LIFETIME_STATUS_17                          regSPI_WF_LIFETIME_STATUS_17;
typedef union SPI_WF_LIFETIME_STATUS_18                          regSPI_WF_LIFETIME_STATUS_18;
typedef union SPI_WF_LIFETIME_STATUS_19                          regSPI_WF_LIFETIME_STATUS_19;
typedef union SPI_WF_LIFETIME_STATUS_20                          regSPI_WF_LIFETIME_STATUS_20;
typedef union SPI_WF_LIFETIME_STATUS_21                          regSPI_WF_LIFETIME_STATUS_21;
typedef union SQG_CONFIG                                         regSQG_CONFIG;
typedef union SQG_GL1H_STATUS                                    regSQG_GL1H_STATUS;
typedef union SQG_PERFCOUNTER0_HI                                regSQG_PERFCOUNTER0_HI;
typedef union SQG_PERFCOUNTER0_LO                                regSQG_PERFCOUNTER0_LO;
typedef union SQG_PERFCOUNTER0_SELECT                            regSQG_PERFCOUNTER0_SELECT;
typedef union SQG_PERFCOUNTER1_HI                                regSQG_PERFCOUNTER1_HI;
typedef union SQG_PERFCOUNTER1_LO                                regSQG_PERFCOUNTER1_LO;
typedef union SQG_PERFCOUNTER1_SELECT                            regSQG_PERFCOUNTER1_SELECT;
typedef union SQG_PERFCOUNTER2_HI                                regSQG_PERFCOUNTER2_HI;
typedef union SQG_PERFCOUNTER2_LO                                regSQG_PERFCOUNTER2_LO;
typedef union SQG_PERFCOUNTER2_SELECT                            regSQG_PERFCOUNTER2_SELECT;
typedef union SQG_PERFCOUNTER3_HI                                regSQG_PERFCOUNTER3_HI;
typedef union SQG_PERFCOUNTER3_LO                                regSQG_PERFCOUNTER3_LO;
typedef union SQG_PERFCOUNTER3_SELECT                            regSQG_PERFCOUNTER3_SELECT;
typedef union SQG_PERFCOUNTER4_HI                                regSQG_PERFCOUNTER4_HI;
typedef union SQG_PERFCOUNTER4_LO                                regSQG_PERFCOUNTER4_LO;
typedef union SQG_PERFCOUNTER4_SELECT                            regSQG_PERFCOUNTER4_SELECT;
typedef union SQG_PERFCOUNTER5_HI                                regSQG_PERFCOUNTER5_HI;
typedef union SQG_PERFCOUNTER5_LO                                regSQG_PERFCOUNTER5_LO;
typedef union SQG_PERFCOUNTER5_SELECT                            regSQG_PERFCOUNTER5_SELECT;
typedef union SQG_PERFCOUNTER6_HI                                regSQG_PERFCOUNTER6_HI;
typedef union SQG_PERFCOUNTER6_LO                                regSQG_PERFCOUNTER6_LO;
typedef union SQG_PERFCOUNTER6_SELECT                            regSQG_PERFCOUNTER6_SELECT;
typedef union SQG_PERFCOUNTER7_HI                                regSQG_PERFCOUNTER7_HI;
typedef union SQG_PERFCOUNTER7_LO                                regSQG_PERFCOUNTER7_LO;
typedef union SQG_PERFCOUNTER7_SELECT                            regSQG_PERFCOUNTER7_SELECT;
typedef union SQG_PERFCOUNTER_CTRL                               regSQG_PERFCOUNTER_CTRL;
typedef union SQG_PERFCOUNTER_CTRL2                              regSQG_PERFCOUNTER_CTRL2;
typedef union SQG_PERF_SAMPLE_FINISH                             regSQG_PERF_SAMPLE_FINISH;
typedef union SQG_STATUS                                         regSQG_STATUS;
typedef union SQG_UTCL0_CNTL1                                    regSQG_UTCL0_CNTL1;
typedef union SQG_UTCL0_CNTL2                                    regSQG_UTCL0_CNTL2;
typedef union SQG_UTCL0_STATUS                                   regSQG_UTCL0_STATUS;
typedef union SQ_ALU_CLK_CTRL                                    regSQ_ALU_CLK_CTRL;
typedef union SQ_ARB_CONFIG                                      regSQ_ARB_CONFIG;
typedef union SQ_CLK_CTRL                                        regSQ_CLK_CTRL;
typedef union SQ_CMD                                             regSQ_CMD;
typedef union SQ_CONFIG                                          regSQ_CONFIG;
typedef union SQ_DSM_CNTL                                        regSQ_DSM_CNTL;
typedef union SQ_DSM_CNTL2                                       regSQ_DSM_CNTL2;
typedef union SQ_EDC_CNT                                         regSQ_EDC_CNT;
typedef union SQ_EDC_FUE_CNTL                                    regSQ_EDC_FUE_CNTL;
typedef union SQ_FIFO_SIZES                                      regSQ_FIFO_SIZES;
typedef union SQ_IND_DATA                                        regSQ_IND_DATA;
typedef union SQ_IND_INDEX                                       regSQ_IND_INDEX;
typedef union SQ_INTERRUPT_AUTO_MASK                             regSQ_INTERRUPT_AUTO_MASK;
typedef union SQ_INTERRUPT_MSG_CTRL                              regSQ_INTERRUPT_MSG_CTRL;
typedef union SQ_LB_CTR_CTRL                                     regSQ_LB_CTR_CTRL;
typedef union SQ_LB_CTR_SEL0                                     regSQ_LB_CTR_SEL0;
typedef union SQ_LB_CTR_SEL1                                     regSQ_LB_CTR_SEL1;
typedef union SQ_LB_DATA0                                        regSQ_LB_DATA0;
typedef union SQ_LB_DATA1                                        regSQ_LB_DATA1;
typedef union SQ_LB_DATA2                                        regSQ_LB_DATA2;
typedef union SQ_LB_DATA3                                        regSQ_LB_DATA3;
typedef union SQ_LDS_CLK_CTRL                                    regSQ_LDS_CLK_CTRL;
typedef union SQ_PERFCOUNTER0_HI                                 regSQ_PERFCOUNTER0_HI;
typedef union SQ_PERFCOUNTER0_LO                                 regSQ_PERFCOUNTER0_LO;
typedef union SQ_PERFCOUNTER0_SELECT                             regSQ_PERFCOUNTER0_SELECT;
typedef union SQ_PERFCOUNTER1_HI                                 regSQ_PERFCOUNTER1_HI;
typedef union SQ_PERFCOUNTER1_LO                                 regSQ_PERFCOUNTER1_LO;
typedef union SQ_PERFCOUNTER1_SELECT                             regSQ_PERFCOUNTER1_SELECT;
typedef union SQ_PERFCOUNTER2_HI                                 regSQ_PERFCOUNTER2_HI;
typedef union SQ_PERFCOUNTER2_LO                                 regSQ_PERFCOUNTER2_LO;
typedef union SQ_PERFCOUNTER2_SELECT                             regSQ_PERFCOUNTER2_SELECT;
typedef union SQ_PERFCOUNTER3_HI                                 regSQ_PERFCOUNTER3_HI;
typedef union SQ_PERFCOUNTER3_LO                                 regSQ_PERFCOUNTER3_LO;
typedef union SQ_PERFCOUNTER3_SELECT                             regSQ_PERFCOUNTER3_SELECT;
typedef union SQ_PERFCOUNTER4_HI                                 regSQ_PERFCOUNTER4_HI;
typedef union SQ_PERFCOUNTER4_LO                                 regSQ_PERFCOUNTER4_LO;
typedef union SQ_PERFCOUNTER4_SELECT                             regSQ_PERFCOUNTER4_SELECT;
typedef union SQ_PERFCOUNTER5_HI                                 regSQ_PERFCOUNTER5_HI;
typedef union SQ_PERFCOUNTER5_LO                                 regSQ_PERFCOUNTER5_LO;
typedef union SQ_PERFCOUNTER5_SELECT                             regSQ_PERFCOUNTER5_SELECT;
typedef union SQ_PERFCOUNTER6_HI                                 regSQ_PERFCOUNTER6_HI;
typedef union SQ_PERFCOUNTER6_LO                                 regSQ_PERFCOUNTER6_LO;
typedef union SQ_PERFCOUNTER6_SELECT                             regSQ_PERFCOUNTER6_SELECT;
typedef union SQ_PERFCOUNTER7_HI                                 regSQ_PERFCOUNTER7_HI;
typedef union SQ_PERFCOUNTER7_LO                                 regSQ_PERFCOUNTER7_LO;
typedef union SQ_PERFCOUNTER7_SELECT                             regSQ_PERFCOUNTER7_SELECT;
typedef union SQ_PERFCOUNTER8_HI                                 regSQ_PERFCOUNTER8_HI;
typedef union SQ_PERFCOUNTER8_LO                                 regSQ_PERFCOUNTER8_LO;
typedef union SQ_PERFCOUNTER8_SELECT                             regSQ_PERFCOUNTER8_SELECT;
typedef union SQ_PERFCOUNTER9_HI                                 regSQ_PERFCOUNTER9_HI;
typedef union SQ_PERFCOUNTER9_LO                                 regSQ_PERFCOUNTER9_LO;
typedef union SQ_PERFCOUNTER9_SELECT                             regSQ_PERFCOUNTER9_SELECT;
typedef union SQ_PERFCOUNTER10_HI                                regSQ_PERFCOUNTER10_HI;
typedef union SQ_PERFCOUNTER10_LO                                regSQ_PERFCOUNTER10_LO;
typedef union SQ_PERFCOUNTER10_SELECT                            regSQ_PERFCOUNTER10_SELECT;
typedef union SQ_PERFCOUNTER11_HI                                regSQ_PERFCOUNTER11_HI;
typedef union SQ_PERFCOUNTER11_LO                                regSQ_PERFCOUNTER11_LO;
typedef union SQ_PERFCOUNTER11_SELECT                            regSQ_PERFCOUNTER11_SELECT;
typedef union SQ_PERFCOUNTER12_HI                                regSQ_PERFCOUNTER12_HI;
typedef union SQ_PERFCOUNTER12_LO                                regSQ_PERFCOUNTER12_LO;
typedef union SQ_PERFCOUNTER12_SELECT                            regSQ_PERFCOUNTER12_SELECT;
typedef union SQ_PERFCOUNTER13_HI                                regSQ_PERFCOUNTER13_HI;
typedef union SQ_PERFCOUNTER13_LO                                regSQ_PERFCOUNTER13_LO;
typedef union SQ_PERFCOUNTER13_SELECT                            regSQ_PERFCOUNTER13_SELECT;
typedef union SQ_PERFCOUNTER14_HI                                regSQ_PERFCOUNTER14_HI;
typedef union SQ_PERFCOUNTER14_LO                                regSQ_PERFCOUNTER14_LO;
typedef union SQ_PERFCOUNTER14_SELECT                            regSQ_PERFCOUNTER14_SELECT;
typedef union SQ_PERFCOUNTER15_HI                                regSQ_PERFCOUNTER15_HI;
typedef union SQ_PERFCOUNTER15_LO                                regSQ_PERFCOUNTER15_LO;
typedef union SQ_PERFCOUNTER15_SELECT                            regSQ_PERFCOUNTER15_SELECT;
typedef union SQ_PERFCOUNTER_CTRL                                regSQ_PERFCOUNTER_CTRL;
typedef union SQ_PERFCOUNTER_CTRL2                               regSQ_PERFCOUNTER_CTRL2;
typedef union SQ_PERF_SNAPSHOT_CTRL                              regSQ_PERF_SNAPSHOT_CTRL;
typedef union SQ_PERF_SNAPSHOT_DATA                              regSQ_PERF_SNAPSHOT_DATA;
typedef union SQ_PERF_SNAPSHOT_PC_HI                             regSQ_PERF_SNAPSHOT_PC_HI;
typedef union SQ_PERF_SNAPSHOT_PC_LO                             regSQ_PERF_SNAPSHOT_PC_LO;
typedef union SQ_RANDOM_WAVE_PRI                                 regSQ_RANDOM_WAVE_PRI;
typedef union SQ_RUNTIME_CONFIG                                  regSQ_RUNTIME_CONFIG;
typedef union SQ_SHADER_TBA_HI                                   regSQ_SHADER_TBA_HI;
typedef union SQ_SHADER_TBA_LO                                   regSQ_SHADER_TBA_LO;
typedef union SQ_SHADER_TMA_HI                                   regSQ_SHADER_TMA_HI;
typedef union SQ_SHADER_TMA_LO                                   regSQ_SHADER_TMA_LO;
typedef union SQ_TEX_CLK_CTRL                                    regSQ_TEX_CLK_CTRL;
typedef union SQ_THREAD_TRACE_BUF0_BASE                          regSQ_THREAD_TRACE_BUF0_BASE;
typedef union SQ_THREAD_TRACE_BUF0_SIZE                          regSQ_THREAD_TRACE_BUF0_SIZE;
typedef union SQ_THREAD_TRACE_BUF1_BASE                          regSQ_THREAD_TRACE_BUF1_BASE;
typedef union SQ_THREAD_TRACE_BUF1_SIZE                          regSQ_THREAD_TRACE_BUF1_SIZE;
typedef union SQ_THREAD_TRACE_CTRL                               regSQ_THREAD_TRACE_CTRL;
typedef union SQ_THREAD_TRACE_DROPPED_CNTR                       regSQ_THREAD_TRACE_DROPPED_CNTR;
typedef union SQ_THREAD_TRACE_GFX_DRAW_CNTR                      regSQ_THREAD_TRACE_GFX_DRAW_CNTR;
typedef union SQ_THREAD_TRACE_GFX_MARKER_CNTR                    regSQ_THREAD_TRACE_GFX_MARKER_CNTR;
typedef union SQ_THREAD_TRACE_HP3D_DRAW_CNTR                     regSQ_THREAD_TRACE_HP3D_DRAW_CNTR;
typedef union SQ_THREAD_TRACE_HP3D_MARKER_CNTR                   regSQ_THREAD_TRACE_HP3D_MARKER_CNTR;
typedef union SQ_THREAD_TRACE_MASK                               regSQ_THREAD_TRACE_MASK;
typedef union SQ_THREAD_TRACE_STATUS                             regSQ_THREAD_TRACE_STATUS;
typedef union SQ_THREAD_TRACE_STATUS2                            regSQ_THREAD_TRACE_STATUS2;
typedef union SQ_THREAD_TRACE_TOKEN_MASK                         regSQ_THREAD_TRACE_TOKEN_MASK;
typedef union SQ_THREAD_TRACE_USERDATA_0                         regSQ_THREAD_TRACE_USERDATA_0;
typedef union SQ_THREAD_TRACE_USERDATA_1                         regSQ_THREAD_TRACE_USERDATA_1;
typedef union SQ_THREAD_TRACE_USERDATA_2                         regSQ_THREAD_TRACE_USERDATA_2;
typedef union SQ_THREAD_TRACE_USERDATA_3                         regSQ_THREAD_TRACE_USERDATA_3;
typedef union SQ_THREAD_TRACE_USERDATA_4                         regSQ_THREAD_TRACE_USERDATA_4;
typedef union SQ_THREAD_TRACE_USERDATA_5                         regSQ_THREAD_TRACE_USERDATA_5;
typedef union SQ_THREAD_TRACE_USERDATA_6                         regSQ_THREAD_TRACE_USERDATA_6;
typedef union SQ_THREAD_TRACE_USERDATA_7                         regSQ_THREAD_TRACE_USERDATA_7;
typedef union SQ_THREAD_TRACE_WPTR                               regSQ_THREAD_TRACE_WPTR;
typedef union SQ_TIME_HI                                         regSQ_TIME_HI;
typedef union SQ_TIME_LO                                         regSQ_TIME_LO;
typedef union SQ_WATCH0_ADDR_H                                   regSQ_WATCH0_ADDR_H;
typedef union SQ_WATCH0_ADDR_L                                   regSQ_WATCH0_ADDR_L;
typedef union SQ_WATCH0_CNTL                                     regSQ_WATCH0_CNTL;
typedef union SQ_WATCH1_ADDR_H                                   regSQ_WATCH1_ADDR_H;
typedef union SQ_WATCH1_ADDR_L                                   regSQ_WATCH1_ADDR_L;
typedef union SQ_WATCH1_CNTL                                     regSQ_WATCH1_CNTL;
typedef union SQ_WATCH2_ADDR_H                                   regSQ_WATCH2_ADDR_H;
typedef union SQ_WATCH2_ADDR_L                                   regSQ_WATCH2_ADDR_L;
typedef union SQ_WATCH2_CNTL                                     regSQ_WATCH2_CNTL;
typedef union SQ_WATCH3_ADDR_H                                   regSQ_WATCH3_ADDR_H;
typedef union SQ_WATCH3_ADDR_L                                   regSQ_WATCH3_ADDR_L;
typedef union SQ_WATCH3_CNTL                                     regSQ_WATCH3_CNTL;
typedef union SQ_WREXEC_EXEC_HI                                  regSQ_WREXEC_EXEC_HI;
typedef union SQ_WREXEC_EXEC_LO                                  regSQ_WREXEC_EXEC_LO;
typedef union SX_BLEND_OPT_CONTROL                               regSX_BLEND_OPT_CONTROL;
typedef union SX_BLEND_OPT_EPSILON                               regSX_BLEND_OPT_EPSILON;
typedef union SX_MRT0_BLEND_OPT                                  regSX_MRT0_BLEND_OPT;
typedef union SX_MRT1_BLEND_OPT                                  regSX_MRT1_BLEND_OPT;
typedef union SX_MRT2_BLEND_OPT                                  regSX_MRT2_BLEND_OPT;
typedef union SX_MRT3_BLEND_OPT                                  regSX_MRT3_BLEND_OPT;
typedef union SX_MRT4_BLEND_OPT                                  regSX_MRT4_BLEND_OPT;
typedef union SX_MRT5_BLEND_OPT                                  regSX_MRT5_BLEND_OPT;
typedef union SX_MRT6_BLEND_OPT                                  regSX_MRT6_BLEND_OPT;
typedef union SX_MRT7_BLEND_OPT                                  regSX_MRT7_BLEND_OPT;
typedef union SX_PERFCOUNTER0_HI                                 regSX_PERFCOUNTER0_HI;
typedef union SX_PERFCOUNTER0_LO                                 regSX_PERFCOUNTER0_LO;
typedef union SX_PERFCOUNTER0_SELECT                             regSX_PERFCOUNTER0_SELECT;
typedef union SX_PERFCOUNTER0_SELECT1                            regSX_PERFCOUNTER0_SELECT1;
typedef union SX_PERFCOUNTER1_HI                                 regSX_PERFCOUNTER1_HI;
typedef union SX_PERFCOUNTER1_LO                                 regSX_PERFCOUNTER1_LO;
typedef union SX_PERFCOUNTER1_SELECT                             regSX_PERFCOUNTER1_SELECT;
typedef union SX_PERFCOUNTER1_SELECT1                            regSX_PERFCOUNTER1_SELECT1;
typedef union SX_PERFCOUNTER2_HI                                 regSX_PERFCOUNTER2_HI;
typedef union SX_PERFCOUNTER2_LO                                 regSX_PERFCOUNTER2_LO;
typedef union SX_PERFCOUNTER2_SELECT                             regSX_PERFCOUNTER2_SELECT;
typedef union SX_PERFCOUNTER3_HI                                 regSX_PERFCOUNTER3_HI;
typedef union SX_PERFCOUNTER3_LO                                 regSX_PERFCOUNTER3_LO;
typedef union SX_PERFCOUNTER3_SELECT                             regSX_PERFCOUNTER3_SELECT;
typedef union SX_PS_DOWNCONVERT                                  regSX_PS_DOWNCONVERT;
typedef union SX_PS_DOWNCONVERT_CONTROL                          regSX_PS_DOWNCONVERT_CONTROL;
typedef union TA_BC_BASE_ADDR                                    regTA_BC_BASE_ADDR;
typedef union TA_BC_BASE_ADDR_HI                                 regTA_BC_BASE_ADDR_HI;
typedef union TA_CGTT_CTRL                                       regTA_CGTT_CTRL;
typedef union TA_CNTL                                            regTA_CNTL;
typedef union TA_CNTL2                                           regTA_CNTL2;
typedef union TA_CNTL_AUX                                        regTA_CNTL_AUX;
typedef union TA_CS_BC_BASE_ADDR                                 regTA_CS_BC_BASE_ADDR;
typedef union TA_CS_BC_BASE_ADDR_HI                              regTA_CS_BC_BASE_ADDR_HI;
typedef union TA_PERFCOUNTER0_HI                                 regTA_PERFCOUNTER0_HI;
typedef union TA_PERFCOUNTER0_LO                                 regTA_PERFCOUNTER0_LO;
typedef union TA_PERFCOUNTER0_SELECT                             regTA_PERFCOUNTER0_SELECT;
typedef union TA_PERFCOUNTER0_SELECT1                            regTA_PERFCOUNTER0_SELECT1;
typedef union TA_PERFCOUNTER1_HI                                 regTA_PERFCOUNTER1_HI;
typedef union TA_PERFCOUNTER1_LO                                 regTA_PERFCOUNTER1_LO;
typedef union TA_PERFCOUNTER1_SELECT                             regTA_PERFCOUNTER1_SELECT;
typedef union TA_POWER_CNTL                                      regTA_POWER_CNTL;
typedef union TA_RESERVED_010C                                   regTA_RESERVED_010C;
typedef union TA_SCRATCH                                         regTA_SCRATCH;
typedef union TA_STATUS                                          regTA_STATUS;
typedef union TCP_PERFCOUNTER0_HI                                regTCP_PERFCOUNTER0_HI;
typedef union TCP_PERFCOUNTER0_LO                                regTCP_PERFCOUNTER0_LO;
typedef union TCP_PERFCOUNTER0_SELECT                            regTCP_PERFCOUNTER0_SELECT;
typedef union TCP_PERFCOUNTER0_SELECT1                           regTCP_PERFCOUNTER0_SELECT1;
typedef union TCP_PERFCOUNTER1_HI                                regTCP_PERFCOUNTER1_HI;
typedef union TCP_PERFCOUNTER1_LO                                regTCP_PERFCOUNTER1_LO;
typedef union TCP_PERFCOUNTER1_SELECT                            regTCP_PERFCOUNTER1_SELECT;
typedef union TCP_PERFCOUNTER1_SELECT1                           regTCP_PERFCOUNTER1_SELECT1;
typedef union TCP_PERFCOUNTER2_HI                                regTCP_PERFCOUNTER2_HI;
typedef union TCP_PERFCOUNTER2_LO                                regTCP_PERFCOUNTER2_LO;
typedef union TCP_PERFCOUNTER2_SELECT                            regTCP_PERFCOUNTER2_SELECT;
typedef union TCP_PERFCOUNTER3_HI                                regTCP_PERFCOUNTER3_HI;
typedef union TCP_PERFCOUNTER3_LO                                regTCP_PERFCOUNTER3_LO;
typedef union TCP_PERFCOUNTER3_SELECT                            regTCP_PERFCOUNTER3_SELECT;
typedef union TCP_PERFCOUNTER_FILTER                             regTCP_PERFCOUNTER_FILTER;
typedef union TCP_PERFCOUNTER_FILTER2                            regTCP_PERFCOUNTER_FILTER2;
typedef union TCP_PERFCOUNTER_FILTER_EN                          regTCP_PERFCOUNTER_FILTER_EN;
typedef union TD_PERFCOUNTER0_HI                                 regTD_PERFCOUNTER0_HI;
typedef union TD_PERFCOUNTER0_LO                                 regTD_PERFCOUNTER0_LO;
typedef union TD_PERFCOUNTER0_SELECT                             regTD_PERFCOUNTER0_SELECT;
typedef union TD_PERFCOUNTER0_SELECT1                            regTD_PERFCOUNTER0_SELECT1;
typedef union TD_PERFCOUNTER1_HI                                 regTD_PERFCOUNTER1_HI;
typedef union TD_PERFCOUNTER1_LO                                 regTD_PERFCOUNTER1_LO;
typedef union TD_PERFCOUNTER1_SELECT                             regTD_PERFCOUNTER1_SELECT;
typedef union UMCCH0_PerfMonCtl1                                 regUMCCH0_PerfMonCtl1;
typedef union UMCCH0_PerfMonCtl2                                 regUMCCH0_PerfMonCtl2;
typedef union UMCCH0_PerfMonCtl3                                 regUMCCH0_PerfMonCtl3;
typedef union UMCCH0_PerfMonCtl4                                 regUMCCH0_PerfMonCtl4;
typedef union UMCCH0_PerfMonCtl5                                 regUMCCH0_PerfMonCtl5;
typedef union UMCCH0_PerfMonCtlClk                               regUMCCH0_PerfMonCtlClk;
typedef union UMCCH0_PerfMonCtr1_Hi                              regUMCCH0_PerfMonCtr1_Hi;
typedef union UMCCH0_PerfMonCtr1_Lo                              regUMCCH0_PerfMonCtr1_Lo;
typedef union UMCCH0_PerfMonCtr2_Hi                              regUMCCH0_PerfMonCtr2_Hi;
typedef union UMCCH0_PerfMonCtr2_Lo                              regUMCCH0_PerfMonCtr2_Lo;
typedef union UMCCH0_PerfMonCtr3_Hi                              regUMCCH0_PerfMonCtr3_Hi;
typedef union UMCCH0_PerfMonCtr3_Lo                              regUMCCH0_PerfMonCtr3_Lo;
typedef union UMCCH0_PerfMonCtr4_Hi                              regUMCCH0_PerfMonCtr4_Hi;
typedef union UMCCH0_PerfMonCtr4_Lo                              regUMCCH0_PerfMonCtr4_Lo;
typedef union UMCCH0_PerfMonCtr5_Hi                              regUMCCH0_PerfMonCtr5_Hi;
typedef union UMCCH0_PerfMonCtr5_Lo                              regUMCCH0_PerfMonCtr5_Lo;
typedef union UMCCH0_PerfMonCtrClk_Hi                            regUMCCH0_PerfMonCtrClk_Hi;
typedef union UMCCH0_PerfMonCtrClk_Lo                            regUMCCH0_PerfMonCtrClk_Lo;
typedef union UMCCH1_PerfMonCtl1                                 regUMCCH1_PerfMonCtl1;
typedef union UMCCH1_PerfMonCtl2                                 regUMCCH1_PerfMonCtl2;
typedef union UMCCH1_PerfMonCtl3                                 regUMCCH1_PerfMonCtl3;
typedef union UMCCH1_PerfMonCtl4                                 regUMCCH1_PerfMonCtl4;
typedef union UMCCH1_PerfMonCtl5                                 regUMCCH1_PerfMonCtl5;
typedef union UMCCH1_PerfMonCtlClk                               regUMCCH1_PerfMonCtlClk;
typedef union UMCCH1_PerfMonCtr1_Hi                              regUMCCH1_PerfMonCtr1_Hi;
typedef union UMCCH1_PerfMonCtr1_Lo                              regUMCCH1_PerfMonCtr1_Lo;
typedef union UMCCH1_PerfMonCtr2_Hi                              regUMCCH1_PerfMonCtr2_Hi;
typedef union UMCCH1_PerfMonCtr2_Lo                              regUMCCH1_PerfMonCtr2_Lo;
typedef union UMCCH1_PerfMonCtr3_Hi                              regUMCCH1_PerfMonCtr3_Hi;
typedef union UMCCH1_PerfMonCtr3_Lo                              regUMCCH1_PerfMonCtr3_Lo;
typedef union UMCCH1_PerfMonCtr4_Hi                              regUMCCH1_PerfMonCtr4_Hi;
typedef union UMCCH1_PerfMonCtr4_Lo                              regUMCCH1_PerfMonCtr4_Lo;
typedef union UMCCH1_PerfMonCtr5_Hi                              regUMCCH1_PerfMonCtr5_Hi;
typedef union UMCCH1_PerfMonCtr5_Lo                              regUMCCH1_PerfMonCtr5_Lo;
typedef union UMCCH1_PerfMonCtrClk_Hi                            regUMCCH1_PerfMonCtrClk_Hi;
typedef union UMCCH1_PerfMonCtrClk_Lo                            regUMCCH1_PerfMonCtrClk_Lo;
typedef union UMCCH2_PerfMonCtl1                                 regUMCCH2_PerfMonCtl1;
typedef union UMCCH2_PerfMonCtl2                                 regUMCCH2_PerfMonCtl2;
typedef union UMCCH2_PerfMonCtl3                                 regUMCCH2_PerfMonCtl3;
typedef union UMCCH2_PerfMonCtl4                                 regUMCCH2_PerfMonCtl4;
typedef union UMCCH2_PerfMonCtl5                                 regUMCCH2_PerfMonCtl5;
typedef union UMCCH2_PerfMonCtlClk                               regUMCCH2_PerfMonCtlClk;
typedef union UMCCH2_PerfMonCtr1_Hi                              regUMCCH2_PerfMonCtr1_Hi;
typedef union UMCCH2_PerfMonCtr1_Lo                              regUMCCH2_PerfMonCtr1_Lo;
typedef union UMCCH2_PerfMonCtr2_Hi                              regUMCCH2_PerfMonCtr2_Hi;
typedef union UMCCH2_PerfMonCtr2_Lo                              regUMCCH2_PerfMonCtr2_Lo;
typedef union UMCCH2_PerfMonCtr3_Hi                              regUMCCH2_PerfMonCtr3_Hi;
typedef union UMCCH2_PerfMonCtr3_Lo                              regUMCCH2_PerfMonCtr3_Lo;
typedef union UMCCH2_PerfMonCtr4_Hi                              regUMCCH2_PerfMonCtr4_Hi;
typedef union UMCCH2_PerfMonCtr4_Lo                              regUMCCH2_PerfMonCtr4_Lo;
typedef union UMCCH2_PerfMonCtr5_Hi                              regUMCCH2_PerfMonCtr5_Hi;
typedef union UMCCH2_PerfMonCtr5_Lo                              regUMCCH2_PerfMonCtr5_Lo;
typedef union UMCCH2_PerfMonCtrClk_Hi                            regUMCCH2_PerfMonCtrClk_Hi;
typedef union UMCCH2_PerfMonCtrClk_Lo                            regUMCCH2_PerfMonCtrClk_Lo;
typedef union UMCCH3_PerfMonCtl1                                 regUMCCH3_PerfMonCtl1;
typedef union UMCCH3_PerfMonCtl2                                 regUMCCH3_PerfMonCtl2;
typedef union UMCCH3_PerfMonCtl3                                 regUMCCH3_PerfMonCtl3;
typedef union UMCCH3_PerfMonCtl4                                 regUMCCH3_PerfMonCtl4;
typedef union UMCCH3_PerfMonCtl5                                 regUMCCH3_PerfMonCtl5;
typedef union UMCCH3_PerfMonCtlClk                               regUMCCH3_PerfMonCtlClk;
typedef union UMCCH3_PerfMonCtr1_Hi                              regUMCCH3_PerfMonCtr1_Hi;
typedef union UMCCH3_PerfMonCtr1_Lo                              regUMCCH3_PerfMonCtr1_Lo;
typedef union UMCCH3_PerfMonCtr2_Hi                              regUMCCH3_PerfMonCtr2_Hi;
typedef union UMCCH3_PerfMonCtr2_Lo                              regUMCCH3_PerfMonCtr2_Lo;
typedef union UMCCH3_PerfMonCtr3_Hi                              regUMCCH3_PerfMonCtr3_Hi;
typedef union UMCCH3_PerfMonCtr3_Lo                              regUMCCH3_PerfMonCtr3_Lo;
typedef union UMCCH3_PerfMonCtr4_Hi                              regUMCCH3_PerfMonCtr4_Hi;
typedef union UMCCH3_PerfMonCtr4_Lo                              regUMCCH3_PerfMonCtr4_Lo;
typedef union UMCCH3_PerfMonCtr5_Hi                              regUMCCH3_PerfMonCtr5_Hi;
typedef union UMCCH3_PerfMonCtr5_Lo                              regUMCCH3_PerfMonCtr5_Lo;
typedef union UMCCH3_PerfMonCtrClk_Hi                            regUMCCH3_PerfMonCtrClk_Hi;
typedef union UMCCH3_PerfMonCtrClk_Lo                            regUMCCH3_PerfMonCtrClk_Lo;
typedef union UMCCH4_PerfMonCtl1                                 regUMCCH4_PerfMonCtl1;
typedef union UMCCH4_PerfMonCtl2                                 regUMCCH4_PerfMonCtl2;
typedef union UMCCH4_PerfMonCtl3                                 regUMCCH4_PerfMonCtl3;
typedef union UMCCH4_PerfMonCtl4                                 regUMCCH4_PerfMonCtl4;
typedef union UMCCH4_PerfMonCtl5                                 regUMCCH4_PerfMonCtl5;
typedef union UMCCH4_PerfMonCtlClk                               regUMCCH4_PerfMonCtlClk;
typedef union UMCCH4_PerfMonCtr1_Hi                              regUMCCH4_PerfMonCtr1_Hi;
typedef union UMCCH4_PerfMonCtr1_Lo                              regUMCCH4_PerfMonCtr1_Lo;
typedef union UMCCH4_PerfMonCtr2_Hi                              regUMCCH4_PerfMonCtr2_Hi;
typedef union UMCCH4_PerfMonCtr2_Lo                              regUMCCH4_PerfMonCtr2_Lo;
typedef union UMCCH4_PerfMonCtr3_Hi                              regUMCCH4_PerfMonCtr3_Hi;
typedef union UMCCH4_PerfMonCtr3_Lo                              regUMCCH4_PerfMonCtr3_Lo;
typedef union UMCCH4_PerfMonCtr4_Hi                              regUMCCH4_PerfMonCtr4_Hi;
typedef union UMCCH4_PerfMonCtr4_Lo                              regUMCCH4_PerfMonCtr4_Lo;
typedef union UMCCH4_PerfMonCtr5_Hi                              regUMCCH4_PerfMonCtr5_Hi;
typedef union UMCCH4_PerfMonCtr5_Lo                              regUMCCH4_PerfMonCtr5_Lo;
typedef union UMCCH4_PerfMonCtrClk_Hi                            regUMCCH4_PerfMonCtrClk_Hi;
typedef union UMCCH4_PerfMonCtrClk_Lo                            regUMCCH4_PerfMonCtrClk_Lo;
typedef union UMCCH5_PerfMonCtl1                                 regUMCCH5_PerfMonCtl1;
typedef union UMCCH5_PerfMonCtl2                                 regUMCCH5_PerfMonCtl2;
typedef union UMCCH5_PerfMonCtl3                                 regUMCCH5_PerfMonCtl3;
typedef union UMCCH5_PerfMonCtl4                                 regUMCCH5_PerfMonCtl4;
typedef union UMCCH5_PerfMonCtl5                                 regUMCCH5_PerfMonCtl5;
typedef union UMCCH5_PerfMonCtlClk                               regUMCCH5_PerfMonCtlClk;
typedef union UMCCH5_PerfMonCtr1_Hi                              regUMCCH5_PerfMonCtr1_Hi;
typedef union UMCCH5_PerfMonCtr1_Lo                              regUMCCH5_PerfMonCtr1_Lo;
typedef union UMCCH5_PerfMonCtr2_Hi                              regUMCCH5_PerfMonCtr2_Hi;
typedef union UMCCH5_PerfMonCtr2_Lo                              regUMCCH5_PerfMonCtr2_Lo;
typedef union UMCCH5_PerfMonCtr3_Hi                              regUMCCH5_PerfMonCtr3_Hi;
typedef union UMCCH5_PerfMonCtr3_Lo                              regUMCCH5_PerfMonCtr3_Lo;
typedef union UMCCH5_PerfMonCtr4_Hi                              regUMCCH5_PerfMonCtr4_Hi;
typedef union UMCCH5_PerfMonCtr4_Lo                              regUMCCH5_PerfMonCtr4_Lo;
typedef union UMCCH5_PerfMonCtr5_Hi                              regUMCCH5_PerfMonCtr5_Hi;
typedef union UMCCH5_PerfMonCtr5_Lo                              regUMCCH5_PerfMonCtr5_Lo;
typedef union UMCCH5_PerfMonCtrClk_Hi                            regUMCCH5_PerfMonCtrClk_Hi;
typedef union UMCCH5_PerfMonCtrClk_Lo                            regUMCCH5_PerfMonCtrClk_Lo;
typedef union UMCCH6_PerfMonCtl1                                 regUMCCH6_PerfMonCtl1;
typedef union UMCCH6_PerfMonCtl2                                 regUMCCH6_PerfMonCtl2;
typedef union UMCCH6_PerfMonCtl3                                 regUMCCH6_PerfMonCtl3;
typedef union UMCCH6_PerfMonCtl4                                 regUMCCH6_PerfMonCtl4;
typedef union UMCCH6_PerfMonCtl5                                 regUMCCH6_PerfMonCtl5;
typedef union UMCCH6_PerfMonCtlClk                               regUMCCH6_PerfMonCtlClk;
typedef union UMCCH6_PerfMonCtr1_Hi                              regUMCCH6_PerfMonCtr1_Hi;
typedef union UMCCH6_PerfMonCtr1_Lo                              regUMCCH6_PerfMonCtr1_Lo;
typedef union UMCCH6_PerfMonCtr2_Hi                              regUMCCH6_PerfMonCtr2_Hi;
typedef union UMCCH6_PerfMonCtr2_Lo                              regUMCCH6_PerfMonCtr2_Lo;
typedef union UMCCH6_PerfMonCtr3_Hi                              regUMCCH6_PerfMonCtr3_Hi;
typedef union UMCCH6_PerfMonCtr3_Lo                              regUMCCH6_PerfMonCtr3_Lo;
typedef union UMCCH6_PerfMonCtr4_Hi                              regUMCCH6_PerfMonCtr4_Hi;
typedef union UMCCH6_PerfMonCtr4_Lo                              regUMCCH6_PerfMonCtr4_Lo;
typedef union UMCCH6_PerfMonCtr5_Hi                              regUMCCH6_PerfMonCtr5_Hi;
typedef union UMCCH6_PerfMonCtr5_Lo                              regUMCCH6_PerfMonCtr5_Lo;
typedef union UMCCH6_PerfMonCtrClk_Hi                            regUMCCH6_PerfMonCtrClk_Hi;
typedef union UMCCH6_PerfMonCtrClk_Lo                            regUMCCH6_PerfMonCtrClk_Lo;
typedef union UMCCH7_PerfMonCtl1                                 regUMCCH7_PerfMonCtl1;
typedef union UMCCH7_PerfMonCtl2                                 regUMCCH7_PerfMonCtl2;
typedef union UMCCH7_PerfMonCtl3                                 regUMCCH7_PerfMonCtl3;
typedef union UMCCH7_PerfMonCtl4                                 regUMCCH7_PerfMonCtl4;
typedef union UMCCH7_PerfMonCtl5                                 regUMCCH7_PerfMonCtl5;
typedef union UMCCH7_PerfMonCtlClk                               regUMCCH7_PerfMonCtlClk;
typedef union UMCCH7_PerfMonCtr1_Hi                              regUMCCH7_PerfMonCtr1_Hi;
typedef union UMCCH7_PerfMonCtr1_Lo                              regUMCCH7_PerfMonCtr1_Lo;
typedef union UMCCH7_PerfMonCtr2_Hi                              regUMCCH7_PerfMonCtr2_Hi;
typedef union UMCCH7_PerfMonCtr2_Lo                              regUMCCH7_PerfMonCtr2_Lo;
typedef union UMCCH7_PerfMonCtr3_Hi                              regUMCCH7_PerfMonCtr3_Hi;
typedef union UMCCH7_PerfMonCtr3_Lo                              regUMCCH7_PerfMonCtr3_Lo;
typedef union UMCCH7_PerfMonCtr4_Hi                              regUMCCH7_PerfMonCtr4_Hi;
typedef union UMCCH7_PerfMonCtr4_Lo                              regUMCCH7_PerfMonCtr4_Lo;
typedef union UMCCH7_PerfMonCtr5_Hi                              regUMCCH7_PerfMonCtr5_Hi;
typedef union UMCCH7_PerfMonCtr5_Lo                              regUMCCH7_PerfMonCtr5_Lo;
typedef union UMCCH7_PerfMonCtrClk_Hi                            regUMCCH7_PerfMonCtrClk_Hi;
typedef union UMCCH7_PerfMonCtrClk_Lo                            regUMCCH7_PerfMonCtrClk_Lo;
typedef union UMCCH8_PerfMonCtl1                                 regUMCCH8_PerfMonCtl1;
typedef union UMCCH8_PerfMonCtl2                                 regUMCCH8_PerfMonCtl2;
typedef union UMCCH8_PerfMonCtl3                                 regUMCCH8_PerfMonCtl3;
typedef union UMCCH8_PerfMonCtl4                                 regUMCCH8_PerfMonCtl4;
typedef union UMCCH8_PerfMonCtl5                                 regUMCCH8_PerfMonCtl5;
typedef union UMCCH8_PerfMonCtlClk                               regUMCCH8_PerfMonCtlClk;
typedef union UMCCH8_PerfMonCtr1_Hi                              regUMCCH8_PerfMonCtr1_Hi;
typedef union UMCCH8_PerfMonCtr1_Lo                              regUMCCH8_PerfMonCtr1_Lo;
typedef union UMCCH8_PerfMonCtr2_Hi                              regUMCCH8_PerfMonCtr2_Hi;
typedef union UMCCH8_PerfMonCtr2_Lo                              regUMCCH8_PerfMonCtr2_Lo;
typedef union UMCCH8_PerfMonCtr3_Hi                              regUMCCH8_PerfMonCtr3_Hi;
typedef union UMCCH8_PerfMonCtr3_Lo                              regUMCCH8_PerfMonCtr3_Lo;
typedef union UMCCH8_PerfMonCtr4_Hi                              regUMCCH8_PerfMonCtr4_Hi;
typedef union UMCCH8_PerfMonCtr4_Lo                              regUMCCH8_PerfMonCtr4_Lo;
typedef union UMCCH8_PerfMonCtr5_Hi                              regUMCCH8_PerfMonCtr5_Hi;
typedef union UMCCH8_PerfMonCtr5_Lo                              regUMCCH8_PerfMonCtr5_Lo;
typedef union UMCCH8_PerfMonCtrClk_Hi                            regUMCCH8_PerfMonCtrClk_Hi;
typedef union UMCCH8_PerfMonCtrClk_Lo                            regUMCCH8_PerfMonCtrClk_Lo;
typedef union UMCCH9_PerfMonCtl1                                 regUMCCH9_PerfMonCtl1;
typedef union UMCCH9_PerfMonCtl2                                 regUMCCH9_PerfMonCtl2;
typedef union UMCCH9_PerfMonCtl3                                 regUMCCH9_PerfMonCtl3;
typedef union UMCCH9_PerfMonCtl4                                 regUMCCH9_PerfMonCtl4;
typedef union UMCCH9_PerfMonCtl5                                 regUMCCH9_PerfMonCtl5;
typedef union UMCCH9_PerfMonCtlClk                               regUMCCH9_PerfMonCtlClk;
typedef union UMCCH9_PerfMonCtr1_Hi                              regUMCCH9_PerfMonCtr1_Hi;
typedef union UMCCH9_PerfMonCtr1_Lo                              regUMCCH9_PerfMonCtr1_Lo;
typedef union UMCCH9_PerfMonCtr2_Hi                              regUMCCH9_PerfMonCtr2_Hi;
typedef union UMCCH9_PerfMonCtr2_Lo                              regUMCCH9_PerfMonCtr2_Lo;
typedef union UMCCH9_PerfMonCtr3_Hi                              regUMCCH9_PerfMonCtr3_Hi;
typedef union UMCCH9_PerfMonCtr3_Lo                              regUMCCH9_PerfMonCtr3_Lo;
typedef union UMCCH9_PerfMonCtr4_Hi                              regUMCCH9_PerfMonCtr4_Hi;
typedef union UMCCH9_PerfMonCtr4_Lo                              regUMCCH9_PerfMonCtr4_Lo;
typedef union UMCCH9_PerfMonCtr5_Hi                              regUMCCH9_PerfMonCtr5_Hi;
typedef union UMCCH9_PerfMonCtr5_Lo                              regUMCCH9_PerfMonCtr5_Lo;
typedef union UMCCH9_PerfMonCtrClk_Hi                            regUMCCH9_PerfMonCtrClk_Hi;
typedef union UMCCH9_PerfMonCtrClk_Lo                            regUMCCH9_PerfMonCtrClk_Lo;
typedef union UMCCH10_PerfMonCtl1                                regUMCCH10_PerfMonCtl1;
typedef union UMCCH10_PerfMonCtl2                                regUMCCH10_PerfMonCtl2;
typedef union UMCCH10_PerfMonCtl3                                regUMCCH10_PerfMonCtl3;
typedef union UMCCH10_PerfMonCtl4                                regUMCCH10_PerfMonCtl4;
typedef union UMCCH10_PerfMonCtl5                                regUMCCH10_PerfMonCtl5;
typedef union UMCCH10_PerfMonCtlClk                              regUMCCH10_PerfMonCtlClk;
typedef union UMCCH10_PerfMonCtr1_Hi                             regUMCCH10_PerfMonCtr1_Hi;
typedef union UMCCH10_PerfMonCtr1_Lo                             regUMCCH10_PerfMonCtr1_Lo;
typedef union UMCCH10_PerfMonCtr2_Hi                             regUMCCH10_PerfMonCtr2_Hi;
typedef union UMCCH10_PerfMonCtr2_Lo                             regUMCCH10_PerfMonCtr2_Lo;
typedef union UMCCH10_PerfMonCtr3_Hi                             regUMCCH10_PerfMonCtr3_Hi;
typedef union UMCCH10_PerfMonCtr3_Lo                             regUMCCH10_PerfMonCtr3_Lo;
typedef union UMCCH10_PerfMonCtr4_Hi                             regUMCCH10_PerfMonCtr4_Hi;
typedef union UMCCH10_PerfMonCtr4_Lo                             regUMCCH10_PerfMonCtr4_Lo;
typedef union UMCCH10_PerfMonCtr5_Hi                             regUMCCH10_PerfMonCtr5_Hi;
typedef union UMCCH10_PerfMonCtr5_Lo                             regUMCCH10_PerfMonCtr5_Lo;
typedef union UMCCH10_PerfMonCtrClk_Hi                           regUMCCH10_PerfMonCtrClk_Hi;
typedef union UMCCH10_PerfMonCtrClk_Lo                           regUMCCH10_PerfMonCtrClk_Lo;
typedef union UMCCH11_PerfMonCtl1                                regUMCCH11_PerfMonCtl1;
typedef union UMCCH11_PerfMonCtl2                                regUMCCH11_PerfMonCtl2;
typedef union UMCCH11_PerfMonCtl3                                regUMCCH11_PerfMonCtl3;
typedef union UMCCH11_PerfMonCtl4                                regUMCCH11_PerfMonCtl4;
typedef union UMCCH11_PerfMonCtl5                                regUMCCH11_PerfMonCtl5;
typedef union UMCCH11_PerfMonCtlClk                              regUMCCH11_PerfMonCtlClk;
typedef union UMCCH11_PerfMonCtr1_Hi                             regUMCCH11_PerfMonCtr1_Hi;
typedef union UMCCH11_PerfMonCtr1_Lo                             regUMCCH11_PerfMonCtr1_Lo;
typedef union UMCCH11_PerfMonCtr2_Hi                             regUMCCH11_PerfMonCtr2_Hi;
typedef union UMCCH11_PerfMonCtr2_Lo                             regUMCCH11_PerfMonCtr2_Lo;
typedef union UMCCH11_PerfMonCtr3_Hi                             regUMCCH11_PerfMonCtr3_Hi;
typedef union UMCCH11_PerfMonCtr3_Lo                             regUMCCH11_PerfMonCtr3_Lo;
typedef union UMCCH11_PerfMonCtr4_Hi                             regUMCCH11_PerfMonCtr4_Hi;
typedef union UMCCH11_PerfMonCtr4_Lo                             regUMCCH11_PerfMonCtr4_Lo;
typedef union UMCCH11_PerfMonCtr5_Hi                             regUMCCH11_PerfMonCtr5_Hi;
typedef union UMCCH11_PerfMonCtr5_Lo                             regUMCCH11_PerfMonCtr5_Lo;
typedef union UMCCH11_PerfMonCtrClk_Hi                           regUMCCH11_PerfMonCtrClk_Hi;
typedef union UMCCH11_PerfMonCtrClk_Lo                           regUMCCH11_PerfMonCtrClk_Lo;
typedef union UMCCH12_PerfMonCtl1                                regUMCCH12_PerfMonCtl1;
typedef union UMCCH12_PerfMonCtl2                                regUMCCH12_PerfMonCtl2;
typedef union UMCCH12_PerfMonCtl3                                regUMCCH12_PerfMonCtl3;
typedef union UMCCH12_PerfMonCtl4                                regUMCCH12_PerfMonCtl4;
typedef union UMCCH12_PerfMonCtl5                                regUMCCH12_PerfMonCtl5;
typedef union UMCCH12_PerfMonCtlClk                              regUMCCH12_PerfMonCtlClk;
typedef union UMCCH12_PerfMonCtr1_Hi                             regUMCCH12_PerfMonCtr1_Hi;
typedef union UMCCH12_PerfMonCtr1_Lo                             regUMCCH12_PerfMonCtr1_Lo;
typedef union UMCCH12_PerfMonCtr2_Hi                             regUMCCH12_PerfMonCtr2_Hi;
typedef union UMCCH12_PerfMonCtr2_Lo                             regUMCCH12_PerfMonCtr2_Lo;
typedef union UMCCH12_PerfMonCtr3_Hi                             regUMCCH12_PerfMonCtr3_Hi;
typedef union UMCCH12_PerfMonCtr3_Lo                             regUMCCH12_PerfMonCtr3_Lo;
typedef union UMCCH12_PerfMonCtr4_Hi                             regUMCCH12_PerfMonCtr4_Hi;
typedef union UMCCH12_PerfMonCtr4_Lo                             regUMCCH12_PerfMonCtr4_Lo;
typedef union UMCCH12_PerfMonCtr5_Hi                             regUMCCH12_PerfMonCtr5_Hi;
typedef union UMCCH12_PerfMonCtr5_Lo                             regUMCCH12_PerfMonCtr5_Lo;
typedef union UMCCH12_PerfMonCtrClk_Hi                           regUMCCH12_PerfMonCtrClk_Hi;
typedef union UMCCH12_PerfMonCtrClk_Lo                           regUMCCH12_PerfMonCtrClk_Lo;
typedef union UMCCH13_PerfMonCtl1                                regUMCCH13_PerfMonCtl1;
typedef union UMCCH13_PerfMonCtl2                                regUMCCH13_PerfMonCtl2;
typedef union UMCCH13_PerfMonCtl3                                regUMCCH13_PerfMonCtl3;
typedef union UMCCH13_PerfMonCtl4                                regUMCCH13_PerfMonCtl4;
typedef union UMCCH13_PerfMonCtl5                                regUMCCH13_PerfMonCtl5;
typedef union UMCCH13_PerfMonCtlClk                              regUMCCH13_PerfMonCtlClk;
typedef union UMCCH13_PerfMonCtr1_Hi                             regUMCCH13_PerfMonCtr1_Hi;
typedef union UMCCH13_PerfMonCtr1_Lo                             regUMCCH13_PerfMonCtr1_Lo;
typedef union UMCCH13_PerfMonCtr2_Hi                             regUMCCH13_PerfMonCtr2_Hi;
typedef union UMCCH13_PerfMonCtr2_Lo                             regUMCCH13_PerfMonCtr2_Lo;
typedef union UMCCH13_PerfMonCtr3_Hi                             regUMCCH13_PerfMonCtr3_Hi;
typedef union UMCCH13_PerfMonCtr3_Lo                             regUMCCH13_PerfMonCtr3_Lo;
typedef union UMCCH13_PerfMonCtr4_Hi                             regUMCCH13_PerfMonCtr4_Hi;
typedef union UMCCH13_PerfMonCtr4_Lo                             regUMCCH13_PerfMonCtr4_Lo;
typedef union UMCCH13_PerfMonCtr5_Hi                             regUMCCH13_PerfMonCtr5_Hi;
typedef union UMCCH13_PerfMonCtr5_Lo                             regUMCCH13_PerfMonCtr5_Lo;
typedef union UMCCH13_PerfMonCtrClk_Hi                           regUMCCH13_PerfMonCtrClk_Hi;
typedef union UMCCH13_PerfMonCtrClk_Lo                           regUMCCH13_PerfMonCtrClk_Lo;
typedef union UMCCH14_PerfMonCtl1                                regUMCCH14_PerfMonCtl1;
typedef union UMCCH14_PerfMonCtl2                                regUMCCH14_PerfMonCtl2;
typedef union UMCCH14_PerfMonCtl3                                regUMCCH14_PerfMonCtl3;
typedef union UMCCH14_PerfMonCtl4                                regUMCCH14_PerfMonCtl4;
typedef union UMCCH14_PerfMonCtl5                                regUMCCH14_PerfMonCtl5;
typedef union UMCCH14_PerfMonCtlClk                              regUMCCH14_PerfMonCtlClk;
typedef union UMCCH14_PerfMonCtr1_Hi                             regUMCCH14_PerfMonCtr1_Hi;
typedef union UMCCH14_PerfMonCtr1_Lo                             regUMCCH14_PerfMonCtr1_Lo;
typedef union UMCCH14_PerfMonCtr2_Hi                             regUMCCH14_PerfMonCtr2_Hi;
typedef union UMCCH14_PerfMonCtr2_Lo                             regUMCCH14_PerfMonCtr2_Lo;
typedef union UMCCH14_PerfMonCtr3_Hi                             regUMCCH14_PerfMonCtr3_Hi;
typedef union UMCCH14_PerfMonCtr3_Lo                             regUMCCH14_PerfMonCtr3_Lo;
typedef union UMCCH14_PerfMonCtr4_Hi                             regUMCCH14_PerfMonCtr4_Hi;
typedef union UMCCH14_PerfMonCtr4_Lo                             regUMCCH14_PerfMonCtr4_Lo;
typedef union UMCCH14_PerfMonCtr5_Hi                             regUMCCH14_PerfMonCtr5_Hi;
typedef union UMCCH14_PerfMonCtr5_Lo                             regUMCCH14_PerfMonCtr5_Lo;
typedef union UMCCH14_PerfMonCtrClk_Hi                           regUMCCH14_PerfMonCtrClk_Hi;
typedef union UMCCH14_PerfMonCtrClk_Lo                           regUMCCH14_PerfMonCtrClk_Lo;
typedef union UMCCH15_PerfMonCtl1                                regUMCCH15_PerfMonCtl1;
typedef union UMCCH15_PerfMonCtl2                                regUMCCH15_PerfMonCtl2;
typedef union UMCCH15_PerfMonCtl3                                regUMCCH15_PerfMonCtl3;
typedef union UMCCH15_PerfMonCtl4                                regUMCCH15_PerfMonCtl4;
typedef union UMCCH15_PerfMonCtl5                                regUMCCH15_PerfMonCtl5;
typedef union UMCCH15_PerfMonCtlClk                              regUMCCH15_PerfMonCtlClk;
typedef union UMCCH15_PerfMonCtr1_Hi                             regUMCCH15_PerfMonCtr1_Hi;
typedef union UMCCH15_PerfMonCtr1_Lo                             regUMCCH15_PerfMonCtr1_Lo;
typedef union UMCCH15_PerfMonCtr2_Hi                             regUMCCH15_PerfMonCtr2_Hi;
typedef union UMCCH15_PerfMonCtr2_Lo                             regUMCCH15_PerfMonCtr2_Lo;
typedef union UMCCH15_PerfMonCtr3_Hi                             regUMCCH15_PerfMonCtr3_Hi;
typedef union UMCCH15_PerfMonCtr3_Lo                             regUMCCH15_PerfMonCtr3_Lo;
typedef union UMCCH15_PerfMonCtr4_Hi                             regUMCCH15_PerfMonCtr4_Hi;
typedef union UMCCH15_PerfMonCtr4_Lo                             regUMCCH15_PerfMonCtr4_Lo;
typedef union UMCCH15_PerfMonCtr5_Hi                             regUMCCH15_PerfMonCtr5_Hi;
typedef union UMCCH15_PerfMonCtr5_Lo                             regUMCCH15_PerfMonCtr5_Lo;
typedef union UMCCH15_PerfMonCtrClk_Hi                           regUMCCH15_PerfMonCtrClk_Hi;
typedef union UMCCH15_PerfMonCtrClk_Lo                           regUMCCH15_PerfMonCtrClk_Lo;
typedef union UTCL1_PERFCOUNTER0_HI                              regUTCL1_PERFCOUNTER0_HI;
typedef union UTCL1_PERFCOUNTER0_LO                              regUTCL1_PERFCOUNTER0_LO;
typedef union UTCL1_PERFCOUNTER0_SELECT                          regUTCL1_PERFCOUNTER0_SELECT;
typedef union UTCL1_PERFCOUNTER1_HI                              regUTCL1_PERFCOUNTER1_HI;
typedef union UTCL1_PERFCOUNTER1_LO                              regUTCL1_PERFCOUNTER1_LO;
typedef union UTCL1_PERFCOUNTER1_SELECT                          regUTCL1_PERFCOUNTER1_SELECT;
typedef union UTCL1_PERFCOUNTER2_HI                              regUTCL1_PERFCOUNTER2_HI;
typedef union UTCL1_PERFCOUNTER2_LO                              regUTCL1_PERFCOUNTER2_LO;
typedef union UTCL1_PERFCOUNTER2_SELECT                          regUTCL1_PERFCOUNTER2_SELECT;
typedef union UTCL1_PERFCOUNTER3_HI                              regUTCL1_PERFCOUNTER3_HI;
typedef union UTCL1_PERFCOUNTER3_LO                              regUTCL1_PERFCOUNTER3_LO;
typedef union UTCL1_PERFCOUNTER3_SELECT                          regUTCL1_PERFCOUNTER3_SELECT;
typedef union VGT_CACHE_INVALIDATION                             regVGT_CACHE_INVALIDATION;
typedef union VGT_CNTL_STATUS                                    regVGT_CNTL_STATUS;
typedef union VGT_DISPATCH_DRAW_INDEX                            regVGT_DISPATCH_DRAW_INDEX;
typedef union VGT_DMA_BASE                                       regVGT_DMA_BASE;
typedef union VGT_DMA_BASE_HI                                    regVGT_DMA_BASE_HI;
typedef union VGT_DMA_CONTROL                                    regVGT_DMA_CONTROL;
typedef union VGT_DMA_DATA_FIFO_DEPTH                            regVGT_DMA_DATA_FIFO_DEPTH;
typedef union VGT_DMA_EVENT_INITIATOR                            regVGT_DMA_EVENT_INITIATOR;
typedef union VGT_DMA_INDEX_TYPE                                 regVGT_DMA_INDEX_TYPE;
typedef union VGT_DMA_LS_HS_CONFIG                               regVGT_DMA_LS_HS_CONFIG;
typedef union VGT_DMA_MAX_SIZE                                   regVGT_DMA_MAX_SIZE;
typedef union VGT_DMA_NUM_INSTANCES                              regVGT_DMA_NUM_INSTANCES;
typedef union VGT_DMA_PRIMITIVE_TYPE                             regVGT_DMA_PRIMITIVE_TYPE;
typedef union VGT_DMA_REQ_FIFO_DEPTH                             regVGT_DMA_REQ_FIFO_DEPTH;
typedef union VGT_DMA_SIZE                                       regVGT_DMA_SIZE;
typedef union VGT_DRAW_INITIATOR                                 regVGT_DRAW_INITIATOR;
typedef union VGT_DRAW_INIT_FIFO_DEPTH                           regVGT_DRAW_INIT_FIFO_DEPTH;
typedef union VGT_DRAW_PAYLOAD_CNTL                              regVGT_DRAW_PAYLOAD_CNTL;
typedef union VGT_ENHANCE                                        regVGT_ENHANCE;
typedef union VGT_ESGS_RING_ITEMSIZE                             regVGT_ESGS_RING_ITEMSIZE;
typedef union VGT_ESGS_RING_SIZE                                 regVGT_ESGS_RING_SIZE;
typedef union VGT_ESGS_RING_SIZE_UMD                             regVGT_ESGS_RING_SIZE_UMD;
typedef union VGT_ES_PER_GS                                      regVGT_ES_PER_GS;
typedef union VGT_EVENT_ADDRESS_REG                              regVGT_EVENT_ADDRESS_REG;
typedef union VGT_EVENT_INITIATOR                                regVGT_EVENT_INITIATOR;
typedef union VGT_FIFO_DEPTHS                                    regVGT_FIFO_DEPTHS;
typedef union VGT_GROUP_DECR                                     regVGT_GROUP_DECR;
typedef union VGT_GROUP_FIRST_DECR                               regVGT_GROUP_FIRST_DECR;
typedef union VGT_GROUP_PRIM_TYPE                                regVGT_GROUP_PRIM_TYPE;
typedef union VGT_GROUP_VECT_0_CNTL                              regVGT_GROUP_VECT_0_CNTL;
typedef union VGT_GROUP_VECT_0_FMT_CNTL                          regVGT_GROUP_VECT_0_FMT_CNTL;
typedef union VGT_GROUP_VECT_1_CNTL                              regVGT_GROUP_VECT_1_CNTL;
typedef union VGT_GROUP_VECT_1_FMT_CNTL                          regVGT_GROUP_VECT_1_FMT_CNTL;
typedef union VGT_GSVS_RING_ITEMSIZE                             regVGT_GSVS_RING_ITEMSIZE;
typedef union VGT_GSVS_RING_OFFSET_1                             regVGT_GSVS_RING_OFFSET_1;
typedef union VGT_GSVS_RING_OFFSET_2                             regVGT_GSVS_RING_OFFSET_2;
typedef union VGT_GSVS_RING_OFFSET_3                             regVGT_GSVS_RING_OFFSET_3;
typedef union VGT_GSVS_RING_SIZE                                 regVGT_GSVS_RING_SIZE;
typedef union VGT_GSVS_RING_SIZE_UMD                             regVGT_GSVS_RING_SIZE_UMD;
typedef union VGT_GS_INSTANCE_CNT                                regVGT_GS_INSTANCE_CNT;
typedef union VGT_GS_MAX_VERT_OUT                                regVGT_GS_MAX_VERT_OUT;
typedef union VGT_GS_MAX_WAVE_ID                                 regVGT_GS_MAX_WAVE_ID;
typedef union VGT_GS_MODE                                        regVGT_GS_MODE;
typedef union VGT_GS_ONCHIP_CNTL                                 regVGT_GS_ONCHIP_CNTL;
typedef union VGT_GS_OUT_PRIM_TYPE                               regVGT_GS_OUT_PRIM_TYPE;
typedef union VGT_GS_PER_ES                                      regVGT_GS_PER_ES;
typedef union VGT_GS_PER_VS                                      regVGT_GS_PER_VS;
typedef union VGT_GS_VERTEX_REUSE                                regVGT_GS_VERTEX_REUSE;
typedef union VGT_GS_VERT_ITEMSIZE                               regVGT_GS_VERT_ITEMSIZE;
typedef union VGT_GS_VERT_ITEMSIZE_1                             regVGT_GS_VERT_ITEMSIZE_1;
typedef union VGT_GS_VERT_ITEMSIZE_2                             regVGT_GS_VERT_ITEMSIZE_2;
typedef union VGT_GS_VERT_ITEMSIZE_3                             regVGT_GS_VERT_ITEMSIZE_3;
typedef union VGT_HOS_CNTL                                       regVGT_HOS_CNTL;
typedef union VGT_HOS_MAX_TESS_LEVEL                             regVGT_HOS_MAX_TESS_LEVEL;
typedef union VGT_HOS_MIN_TESS_LEVEL                             regVGT_HOS_MIN_TESS_LEVEL;
typedef union VGT_HOS_REUSE_DEPTH                                regVGT_HOS_REUSE_DEPTH;
typedef union VGT_HS_OFFCHIP_PARAM                               regVGT_HS_OFFCHIP_PARAM;
typedef union VGT_HS_OFFCHIP_PARAM_UMD                           regVGT_HS_OFFCHIP_PARAM_UMD;
typedef union VGT_IMMED_DATA                                     regVGT_IMMED_DATA;
typedef union VGT_INDEX_TYPE                                     regVGT_INDEX_TYPE;
typedef union VGT_INDX_OFFSET                                    regVGT_INDX_OFFSET;
typedef union VGT_INSTANCE_BASE_ID                               regVGT_INSTANCE_BASE_ID;
typedef union VGT_INSTANCE_STEP_RATE_0                           regVGT_INSTANCE_STEP_RATE_0;
typedef union VGT_INSTANCE_STEP_RATE_1                           regVGT_INSTANCE_STEP_RATE_1;
typedef union VGT_LAST_COPY_STATE                                regVGT_LAST_COPY_STATE;
typedef union VGT_LS_HS_CONFIG                                   regVGT_LS_HS_CONFIG;
typedef union VGT_MAX_VTX_INDX                                   regVGT_MAX_VTX_INDX;
typedef union VGT_MC_LAT_CNTL                                    regVGT_MC_LAT_CNTL;
typedef union VGT_MIN_VTX_INDX                                   regVGT_MIN_VTX_INDX;
typedef union VGT_MULTI_PRIM_IB_RESET_EN                         regVGT_MULTI_PRIM_IB_RESET_EN;
typedef union VGT_MULTI_PRIM_IB_RESET_INDX                       regVGT_MULTI_PRIM_IB_RESET_INDX;
typedef union VGT_NUM_INDICES                                    regVGT_NUM_INDICES;
typedef union VGT_NUM_INSTANCES                                  regVGT_NUM_INSTANCES;
typedef union VGT_OUTPUT_PATH_CNTL                               regVGT_OUTPUT_PATH_CNTL;
typedef union VGT_OUT_DEALLOC_CNTL                               regVGT_OUT_DEALLOC_CNTL;
typedef union VGT_PRIMITIVEID_EN                                 regVGT_PRIMITIVEID_EN;
typedef union VGT_PRIMITIVEID_RESET                              regVGT_PRIMITIVEID_RESET;
typedef union VGT_PRIMITIVE_TYPE                                 regVGT_PRIMITIVE_TYPE;
typedef union VGT_REUSE_OFF                                      regVGT_REUSE_OFF;
typedef union VGT_SHADER_STAGES_EN                               regVGT_SHADER_STAGES_EN;
typedef union VGT_STRMOUT_BUFFER_CONFIG                          regVGT_STRMOUT_BUFFER_CONFIG;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_0                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_0;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_1                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_1;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_2                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_2;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_3                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_3;
typedef union VGT_STRMOUT_BUFFER_OFFSET_0                        regVGT_STRMOUT_BUFFER_OFFSET_0;
typedef union VGT_STRMOUT_BUFFER_OFFSET_1                        regVGT_STRMOUT_BUFFER_OFFSET_1;
typedef union VGT_STRMOUT_BUFFER_OFFSET_2                        regVGT_STRMOUT_BUFFER_OFFSET_2;
typedef union VGT_STRMOUT_BUFFER_OFFSET_3                        regVGT_STRMOUT_BUFFER_OFFSET_3;
typedef union VGT_STRMOUT_BUFFER_SIZE_0                          regVGT_STRMOUT_BUFFER_SIZE_0;
typedef union VGT_STRMOUT_BUFFER_SIZE_1                          regVGT_STRMOUT_BUFFER_SIZE_1;
typedef union VGT_STRMOUT_BUFFER_SIZE_2                          regVGT_STRMOUT_BUFFER_SIZE_2;
typedef union VGT_STRMOUT_BUFFER_SIZE_3                          regVGT_STRMOUT_BUFFER_SIZE_3;
typedef union VGT_STRMOUT_CONFIG                                 regVGT_STRMOUT_CONFIG;
typedef union VGT_STRMOUT_DELAY                                  regVGT_STRMOUT_DELAY;
typedef union VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE         regVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE;
typedef union VGT_STRMOUT_DRAW_OPAQUE_OFFSET                     regVGT_STRMOUT_DRAW_OPAQUE_OFFSET;
typedef union VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE              regVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE;
typedef union VGT_STRMOUT_VTX_STRIDE_0                           regVGT_STRMOUT_VTX_STRIDE_0;
typedef union VGT_STRMOUT_VTX_STRIDE_1                           regVGT_STRMOUT_VTX_STRIDE_1;
typedef union VGT_STRMOUT_VTX_STRIDE_2                           regVGT_STRMOUT_VTX_STRIDE_2;
typedef union VGT_STRMOUT_VTX_STRIDE_3                           regVGT_STRMOUT_VTX_STRIDE_3;
typedef union VGT_SYS_CONFIG                                     regVGT_SYS_CONFIG;
typedef union VGT_TESS_DISTRIBUTION                              regVGT_TESS_DISTRIBUTION;
typedef union VGT_TF_MEMORY_BASE                                 regVGT_TF_MEMORY_BASE;
typedef union VGT_TF_MEMORY_BASE_HI                              regVGT_TF_MEMORY_BASE_HI;
typedef union VGT_TF_MEMORY_BASE_HI_UMD                          regVGT_TF_MEMORY_BASE_HI_UMD;
typedef union VGT_TF_MEMORY_BASE_UMD                             regVGT_TF_MEMORY_BASE_UMD;
typedef union VGT_TF_PARAM                                       regVGT_TF_PARAM;
typedef union VGT_TF_RING_SIZE                                   regVGT_TF_RING_SIZE;
typedef union VGT_TF_RING_SIZE_UMD                               regVGT_TF_RING_SIZE_UMD;
typedef union VGT_VERTEX_REUSE_BLOCK_CNTL                        regVGT_VERTEX_REUSE_BLOCK_CNTL;
typedef union VGT_VS_MAX_WAVE_ID                                 regVGT_VS_MAX_WAVE_ID;
typedef union VGT_VTX_CNT_EN                                     regVGT_VTX_CNT_EN;
typedef union VGT_VTX_VECT_EJECT_REG                             regVGT_VTX_VECT_EJECT_REG;
typedef union WD_BUF_RESOURCE_1                                  regWD_BUF_RESOURCE_1;
typedef union WD_BUF_RESOURCE_2                                  regWD_BUF_RESOURCE_2;
typedef union WD_CNTL_SB_BUF_BASE                                regWD_CNTL_SB_BUF_BASE;
typedef union WD_CNTL_SB_BUF_BASE_HI                             regWD_CNTL_SB_BUF_BASE_HI;
typedef union WD_CNTL_STATUS                                     regWD_CNTL_STATUS;
typedef union WD_ENHANCE                                         regWD_ENHANCE;
typedef union WD_INDEX_BUF_BASE                                  regWD_INDEX_BUF_BASE;
typedef union WD_INDEX_BUF_BASE_HI                               regWD_INDEX_BUF_BASE_HI;
typedef union WD_POS_BUF_BASE                                    regWD_POS_BUF_BASE;
typedef union WD_POS_BUF_BASE_HI                                 regWD_POS_BUF_BASE_HI;
typedef union WD_QOS                                             regWD_QOS;
typedef union WD_UTCL1_CNTL                                      regWD_UTCL1_CNTL;
typedef union WD_UTCL1_STATUS                                    regWD_UTCL1_STATUS;
} // inline namespace Chip
} // namespace Gfx9
} // namespace Pal
